﻿#ifndef LIBRETRO_CORE_OPTIONS_INTL_H__
#define LIBRETRO_CORE_OPTIONS_INTL_H__

#if defined(_MSC_VER) && (_MSC_VER >= 1500 && _MSC_VER < 1900)
/* https://support.microsoft.com/en-us/kb/980263 */
#pragma execution_character_set("utf-8")
#pragma warning(disable:4566)
#endif

#include <libretro.h>

#include "libretro_options.h"

/*
 ********************************
 * VERSION: 1.3
 ********************************
 *
 * - 1.3: Move translations to libretro_core_options_intl.h
 *        - libretro_core_options_intl.h includes BOM and utf-8
 *          fix for MSVC 2010-2013
 *        - Added HAVE_NO_LANGEXTRA flag to disable translations
 *          on platforms/compilers without BOM support
 * - 1.2: Use core options v1 interface when
 *        RETRO_ENVIRONMENT_GET_CORE_OPTIONS_VERSION is >= 1
 *        (previously required RETRO_ENVIRONMENT_GET_CORE_OPTIONS_VERSION == 1)
 * - 1.1: Support generation of core options v0 retro_core_option_value
 *        arrays containing options with a single value
 * - 1.0: First commit
*/

#ifdef __cplusplus
extern "C" {
#endif

/*
 ********************************
 * Core Option Definitions
 ********************************
*/
/* RETRO_LANGUAGE_AR */

#define CATEGORY_VIDEO_LABEL_AR "فيديو"
#define CATEGORY_VIDEO_INFO_0_AR NULL
#define CATEGORY_OSD_LABEL_AR "إشعارات على الشاشة"
#define CATEGORY_OSD_INFO_0_AR NULL
#define CATEGORY_INPUT_LABEL_AR "الإدخال"
#define CATEGORY_INPUT_INFO_0_AR NULL
#define CATEGORY_MEMCARDS_LABEL_AR "بطاقة الذاكرة"
#define CATEGORY_MEMCARDS_INFO_0_AR NULL
#define CATEGORY_PGXP_LABEL_AR NULL
#define CATEGORY_PGXP_INFO_0_AR NULL
#define CATEGORY_HACKS_LABEL_AR NULL
#define CATEGORY_HACKS_INFO_0_AR NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_AR NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_AR NULL
#define OPTION_VAL_1X_NATIVE_AR "1x (أصلي)"
#define OPTION_VAL_2X_AR NULL
#define OPTION_VAL_4X_AR NULL
#define OPTION_VAL_8X_AR NULL
#define OPTION_VAL_16X_AR NULL
#define BEETLE_OPT_DEPTH_LABEL_AR NULL
#define BEETLE_OPT_DEPTH_INFO_0_AR NULL
#define OPTION_VAL_16BPP_NATIVE_AR NULL
#define OPTION_VAL_32BPP_AR NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_AR NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_AR NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_AR NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_AR NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_AR NULL
#define BEETLE_OPT_FILTER_LABEL_AR NULL
#define BEETLE_OPT_FILTER_INFO_0_AR NULL
#define OPTION_VAL_NEAREST_AR "أقرب"
#define OPTION_VAL_SABR_AR NULL
#define OPTION_VAL_XBR_AR NULL
#define OPTION_VAL_BILINEAR_AR "ثنائي"
#define OPTION_VAL_3_POINT_AR NULL
#define OPTION_VAL_JINC2_AR NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_AR NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_AR NULL
#define OPTION_VAL_OPAQUE_AR NULL
#define OPTION_VAL_ALL_AR NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_AR NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_AR NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_AR NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_AR NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_AR NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_AR NULL
#define BEETLE_OPT_MSAA_LABEL_AR NULL
#define BEETLE_OPT_MSAA_INFO_0_AR NULL
#define OPTION_VAL_1X_AR NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_AR NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_AR NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_AR NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_AR NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_AR NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_AR NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_AR NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_AR NULL
#define BEETLE_OPT_WIREFRAME_LABEL_AR NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_AR NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_AR NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_AR NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_AR NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_AR NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_AR NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_AR NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_AR NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_AR NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_AR NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_AR NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_AR NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_AR NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_AR NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_AR NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_AR NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_AR NULL
#define OPTION_VAL_LIGHTGUN_AR NULL
#define OPTION_VAL_TOUCHSCREEN_AR NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_AR NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_AR NULL
#define OPTION_VAL_CROSS_AR NULL
#define OPTION_VAL_DOT_AR NULL
#define OPTION_VAL_OFF_AR NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_AR NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_AR NULL
#define OPTION_VAL_RED_AR "أحمر"
#define OPTION_VAL_BLUE_AR "أزرق"
#define OPTION_VAL_GREEN_AR "أخضر"
#define OPTION_VAL_ORANGE_AR NULL
#define OPTION_VAL_YELLOW_AR "أصفر"
#define OPTION_VAL_CYAN_AR NULL
#define OPTION_VAL_PINK_AR NULL
#define OPTION_VAL_PURPLE_AR NULL
#define OPTION_VAL_BLACK_AR NULL
#define OPTION_VAL_WHITE_AR NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_AR NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_AR NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_AR NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_AR NULL
#define OPTION_VAL_5_AR NULL
#define OPTION_VAL_10_AR NULL
#define OPTION_VAL_15_AR NULL
#define OPTION_VAL_20_AR NULL
#define OPTION_VAL_25_AR NULL
#define OPTION_VAL_30_AR NULL
#define OPTION_VAL_35_AR NULL
#define OPTION_VAL_40_AR NULL
#define OPTION_VAL_45_AR NULL
#define OPTION_VAL_50_AR NULL
#define OPTION_VAL_55_AR NULL
#define OPTION_VAL_60_AR NULL
#define OPTION_VAL_65_AR NULL
#define OPTION_VAL_70_AR NULL
#define OPTION_VAL_75_AR NULL
#define OPTION_VAL_80_AR NULL
#define OPTION_VAL_85_AR NULL
#define OPTION_VAL_90_AR NULL
#define OPTION_VAL_95_AR NULL
#define OPTION_VAL_100_AR NULL
#define OPTION_VAL_105_AR NULL
#define OPTION_VAL_110_AR NULL
#define OPTION_VAL_115_AR NULL
#define OPTION_VAL_120_AR NULL
#define OPTION_VAL_125_AR NULL
#define OPTION_VAL_130_AR NULL
#define OPTION_VAL_135_AR NULL
#define OPTION_VAL_140_AR NULL
#define OPTION_VAL_145_AR NULL
#define OPTION_VAL_150_AR NULL
#define OPTION_VAL_155_AR NULL
#define OPTION_VAL_160_AR NULL
#define OPTION_VAL_165_AR NULL
#define OPTION_VAL_170_AR NULL
#define OPTION_VAL_175_AR NULL
#define OPTION_VAL_180_AR NULL
#define OPTION_VAL_185_AR NULL
#define OPTION_VAL_190_AR NULL
#define OPTION_VAL_195_AR NULL
#define OPTION_VAL_200_AR NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_AR NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_AR NULL
#define OPTION_VAL_LINEAR_AR "خطي"
#define OPTION_VAL_QUADRATIC_AR NULL
#define OPTION_VAL_CUBIC_AR NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_AR NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_AR NULL
#define OPTION_VAL_0_AR NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_AR NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_AR NULL
#define OPTION_VAL_LIBRETRO_AR NULL
#define OPTION_VAL_MEDNAFEN_AR NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_AR NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_AR NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_AR NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_AR NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_AR NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_AR NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_AR NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_AR NULL
#define OPTION_VAL_1_AR NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_AR NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_AR NULL
#define OPTION_VAL_MEMORY_ONLY_AR NULL
#define OPTION_VAL_MEMORY_CPU_AR NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_AR NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_AR NULL
#define OPTION_VAL_0PX_AR NULL
#define OPTION_VAL_1PX_AR NULL
#define OPTION_VAL_2PX_AR NULL
#define OPTION_VAL_3PX_AR NULL
#define OPTION_VAL_4PX_AR NULL
#define OPTION_VAL_5PX_AR NULL
#define OPTION_VAL_6PX_AR NULL
#define OPTION_VAL_7PX_AR NULL
#define OPTION_VAL_8PX_AR NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_AR NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_AR NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_AR NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_AR NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_AR NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_AR NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_AR NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_AR NULL
#define OPTION_VAL_DEFAULT_AR NULL
#define OPTION_VAL_AGGRESSIVE_AR NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_AR NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_AR NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_AR NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_AR NULL
#define OPTION_VAL_16_9_AR NULL
#define OPTION_VAL_16_10_AR NULL
#define OPTION_VAL_18_9_AR NULL
#define OPTION_VAL_19_9_AR NULL
#define OPTION_VAL_20_9_AR NULL
#define OPTION_VAL_21_9_AR NULL
#define OPTION_VAL_32_9_AR NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_AR NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_AR NULL
#define OPTION_VAL_100_NATIVE_AR NULL
#define OPTION_VAL_210_AR NULL
#define OPTION_VAL_220_AR NULL
#define OPTION_VAL_230_AR NULL
#define OPTION_VAL_240_AR NULL
#define OPTION_VAL_250_AR NULL
#define OPTION_VAL_260_AR NULL
#define OPTION_VAL_270_AR NULL
#define OPTION_VAL_280_AR NULL
#define OPTION_VAL_290_AR NULL
#define OPTION_VAL_300_AR NULL
#define OPTION_VAL_310_AR NULL
#define OPTION_VAL_320_AR NULL
#define OPTION_VAL_330_AR NULL
#define OPTION_VAL_340_AR NULL
#define OPTION_VAL_350_AR NULL
#define OPTION_VAL_360_AR NULL
#define OPTION_VAL_370_AR NULL
#define OPTION_VAL_380_AR NULL
#define OPTION_VAL_390_AR NULL
#define OPTION_VAL_400_AR NULL
#define OPTION_VAL_410_AR NULL
#define OPTION_VAL_420_AR NULL
#define OPTION_VAL_430_AR NULL
#define OPTION_VAL_440_AR NULL
#define OPTION_VAL_450_AR NULL
#define OPTION_VAL_460_AR NULL
#define OPTION_VAL_470_AR NULL
#define OPTION_VAL_480_AR NULL
#define OPTION_VAL_490_AR NULL
#define OPTION_VAL_500_AR NULL
#define OPTION_VAL_510_AR NULL
#define OPTION_VAL_520_AR NULL
#define OPTION_VAL_530_AR NULL
#define OPTION_VAL_540_AR NULL
#define OPTION_VAL_550_AR NULL
#define OPTION_VAL_560_AR NULL
#define OPTION_VAL_570_AR NULL
#define OPTION_VAL_580_AR NULL
#define OPTION_VAL_590_AR NULL
#define OPTION_VAL_600_AR NULL
#define OPTION_VAL_610_AR NULL
#define OPTION_VAL_620_AR NULL
#define OPTION_VAL_630_AR NULL
#define OPTION_VAL_640_AR NULL
#define OPTION_VAL_650_AR NULL
#define OPTION_VAL_660_AR NULL
#define OPTION_VAL_670_AR NULL
#define OPTION_VAL_680_AR NULL
#define OPTION_VAL_690_AR NULL
#define OPTION_VAL_700_AR NULL
#define OPTION_VAL_710_AR NULL
#define OPTION_VAL_720_AR NULL
#define OPTION_VAL_730_AR NULL
#define OPTION_VAL_740_AR NULL
#define OPTION_VAL_750_AR NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_AR NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_AR NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_AR NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_AR NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_AR NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_AR NULL
#define OPTION_VAL_PSXONPSP_AR NULL
#define OPTION_VAL_PS1_ROM_AR NULL
#define BEETLE_OPT_RENDERER_LABEL_AR NULL
#define BEETLE_OPT_RENDERER_INFO_0_AR NULL
#define OPTION_VAL_HARDWARE_AR NULL
#define OPTION_VAL_HARDWARE_GL_AR NULL
#define OPTION_VAL_HARDWARE_VK_AR NULL
#define OPTION_VAL_SOFTWARE_AR NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_AR NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_AR NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_AR NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_AR NULL
#define OPTION_VAL_DISABLED_AR NULL
#define OPTION_VAL_EXECUTE_AR NULL
#define OPTION_VAL_EXECUTE_ONE_AR NULL
#define OPTION_VAL_RUN_INTERPRETER_AR NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_AR NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_AR NULL
#define OPTION_VAL_FULL_AR NULL
#define OPTION_VAL_DMA_AR NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_AR NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_AR NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_AR NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_AR NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_AR NULL
#define OPTION_VAL_FORCE_INTERLACED_AR NULL
#define OPTION_VAL_AUTO_TOGGLE_AR NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_AR NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_AR NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_AR NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_AR NULL
#define OPTION_VAL_DISABLED_O53_AR "لاشيء"
#define OPTION_VAL_STATIC_AR NULL
#define OPTION_VAL_SMART_AR NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_AR NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_AR NULL
#define OPTION_VAL_9PX_AR NULL
#define OPTION_VAL_10PX_AR NULL
#define OPTION_VAL_11PX_AR NULL
#define OPTION_VAL_12PX_AR NULL
#define OPTION_VAL_13PX_AR NULL
#define OPTION_VAL_14PX_AR NULL
#define OPTION_VAL_15PX_AR NULL
#define OPTION_VAL_16PX_AR NULL
#define OPTION_VAL_17PX_AR NULL
#define OPTION_VAL_18PX_AR NULL
#define OPTION_VAL_19PX_AR NULL
#define OPTION_VAL_20PX_AR NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_AR NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_AR NULL
#define OPTION_VAL_12PX_O55_AR NULL
#define OPTION_VAL_11PX_O55_AR NULL
#define OPTION_VAL_10PX_O55_AR NULL
#define OPTION_VAL_9PX_O55_AR NULL
#define OPTION_VAL_8PX_O55_AR NULL
#define OPTION_VAL_7PX_O55_AR NULL
#define OPTION_VAL_6PX_O55_AR NULL
#define OPTION_VAL_5PX_O55_AR NULL
#define OPTION_VAL_4PX_O55_AR NULL
#define OPTION_VAL_3PX_O55_AR NULL
#define OPTION_VAL_2PX_O55_AR NULL
#define OPTION_VAL_1PX_O55_AR NULL
#define OPTION_VAL_DISABLED_O55_AR NULL
#define OPTION_VAL_1PX_O55_0_AR NULL
#define OPTION_VAL_2PX_O55_0_AR NULL
#define OPTION_VAL_3PX_O55_0_AR NULL
#define OPTION_VAL_4PX_O55_0_AR NULL
#define OPTION_VAL_5PX_O55_0_AR NULL
#define OPTION_VAL_6PX_O55_0_AR NULL
#define OPTION_VAL_7PX_O55_0_AR NULL
#define OPTION_VAL_8PX_O55_0_AR NULL
#define OPTION_VAL_9PX_O55_0_AR NULL
#define OPTION_VAL_10PX_O55_0_AR NULL
#define OPTION_VAL_11PX_O55_0_AR NULL
#define OPTION_VAL_12PX_O55_0_AR NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_AR NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_AR NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_AR NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_AR NULL
#define OPTION_VAL_32X_AR NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_AR NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_AR NULL
#define OPTION_VAL_CORRECTED_AR NULL
#define OPTION_VAL_UNCORRECTED_AR NULL
#define OPTION_VAL_4_3_AR NULL
#define OPTION_VAL_NTSC_AR NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_AR NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_AR NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_AR NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_AR NULL
#define OPTION_VAL_239_AR NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_AR NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_AR NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_AR NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_AR NULL
#define OPTION_VAL_287_AR NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_AR NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_AR NULL
#define OPTION_VAL_SYNC_AR NULL
#define OPTION_VAL_ASYNC_AR NULL
#define OPTION_VAL_PRECACHE_AR NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_AR NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_AR NULL
#define OPTION_VAL_2X_NATIVE_AR NULL
#define OPTION_VAL_6X_AR NULL
#define OPTION_VAL_10X_AR NULL
#define OPTION_VAL_12X_AR NULL
#define OPTION_VAL_14X_AR NULL

struct retro_core_option_v2_category option_cats_ar[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_AR,
      CATEGORY_VIDEO_INFO_0_AR
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_AR,
      CATEGORY_OSD_INFO_0_AR
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_AR,
      CATEGORY_INPUT_INFO_0_AR
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_AR,
      CATEGORY_MEMCARDS_INFO_0_AR
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_AR,
      CATEGORY_PGXP_INFO_0_AR
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_AR,
      CATEGORY_HACKS_INFO_0_AR
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_ar[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_AR,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_AR,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_AR },
         { "2x",         OPTION_VAL_2X_AR },
         { "4x",         OPTION_VAL_4X_AR },
         { "8x",         OPTION_VAL_8X_AR },
         { "16x",        OPTION_VAL_16X_AR },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_AR,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_AR,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_AR },
         { "32bpp",         OPTION_VAL_32BPP_AR },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_AR,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_AR,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_AR },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_AR },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_AR,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_AR,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_AR,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_AR,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_AR },
         { "SABR",     OPTION_VAL_SABR_AR },
         { "xBR",      OPTION_VAL_XBR_AR },
         { "bilinear", OPTION_VAL_BILINEAR_AR },
         { "3-point",  OPTION_VAL_3_POINT_AR },
         { "JINC2",    OPTION_VAL_JINC2_AR },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_AR,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_AR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_AR },
         { "all", OPTION_VAL_ALL_AR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_AR,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_AR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_AR },
         { "all", OPTION_VAL_ALL_AR },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_AR,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_AR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_AR,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_AR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_AR,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_AR,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_AR },
         { "2x",  OPTION_VAL_2X_AR },
         { "4x",  OPTION_VAL_4X_AR },
         { "8x",  OPTION_VAL_8X_AR },
         { "16x", OPTION_VAL_16X_AR },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_AR,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_AR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_AR,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_AR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_AR,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_AR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_AR,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_AR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_AR,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_AR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_AR,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_AR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_AR,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_AR,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_AR,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_AR,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_AR,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_AR,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_AR,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_AR,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_AR,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_AR,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_AR,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_AR,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_AR,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_AR,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_AR },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_AR },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_AR,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_AR,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_AR },
         { "dot",   OPTION_VAL_DOT_AR },
         { "off",   OPTION_VAL_OFF_AR },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_AR,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_AR,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_AR },
         { "blue", OPTION_VAL_BLUE_AR },
         { "green", OPTION_VAL_GREEN_AR },
         { "orange", OPTION_VAL_ORANGE_AR },
         { "yellow", OPTION_VAL_YELLOW_AR },
         { "cyan", OPTION_VAL_CYAN_AR },
         { "pink", OPTION_VAL_PINK_AR },
         { "purple", OPTION_VAL_PURPLE_AR },
         { "black", OPTION_VAL_BLACK_AR },
         { "white", OPTION_VAL_WHITE_AR },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_AR,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_AR,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_AR },
         { "red", OPTION_VAL_RED_AR },
         { "green", OPTION_VAL_GREEN_AR },
         { "orange", OPTION_VAL_ORANGE_AR },
         { "yellow", OPTION_VAL_YELLOW_AR },
         { "cyan", OPTION_VAL_CYAN_AR },
         { "pink", OPTION_VAL_PINK_AR },
         { "purple", OPTION_VAL_PURPLE_AR },
         { "black", OPTION_VAL_BLACK_AR },
         { "white", OPTION_VAL_WHITE_AR },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_AR,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_AR,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_AR },
         { "10%",  OPTION_VAL_10_AR },
         { "15%",  OPTION_VAL_15_AR },
         { "20%",  OPTION_VAL_20_AR },
         { "25%",  OPTION_VAL_25_AR },
         { "30%",  OPTION_VAL_30_AR },
         { "35%",  OPTION_VAL_35_AR },
         { "40%",  OPTION_VAL_40_AR },
         { "45%",  OPTION_VAL_45_AR },
         { "50%",  OPTION_VAL_50_AR },
         { "55%",  OPTION_VAL_55_AR },
         { "60%",  OPTION_VAL_60_AR },
         { "65%",  OPTION_VAL_65_AR },
         { "70%",  OPTION_VAL_70_AR },
         { "75%",  OPTION_VAL_75_AR },
         { "80%",  OPTION_VAL_80_AR },
         { "85%",  OPTION_VAL_85_AR },
         { "90%",  OPTION_VAL_90_AR },
         { "95%",  OPTION_VAL_95_AR },
         { "100%", OPTION_VAL_100_AR },
         { "105%", OPTION_VAL_105_AR },
         { "110%", OPTION_VAL_110_AR },
         { "115%", OPTION_VAL_115_AR },
         { "120%", OPTION_VAL_120_AR },
         { "125%", OPTION_VAL_125_AR },
         { "130%", OPTION_VAL_130_AR },
         { "135%", OPTION_VAL_135_AR },
         { "140%", OPTION_VAL_140_AR },
         { "145%", OPTION_VAL_145_AR },
         { "150%", OPTION_VAL_150_AR },
         { "155%", OPTION_VAL_155_AR },
         { "160%", OPTION_VAL_160_AR },
         { "165%", OPTION_VAL_165_AR },
         { "170%", OPTION_VAL_170_AR },
         { "175%", OPTION_VAL_175_AR },
         { "180%", OPTION_VAL_180_AR },
         { "185%", OPTION_VAL_185_AR },
         { "190%", OPTION_VAL_190_AR },
         { "195%", OPTION_VAL_195_AR },
         { "200%", OPTION_VAL_200_AR },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_AR,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_AR,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_AR },
         { "quadratic", OPTION_VAL_QUADRATIC_AR },
         { "cubic",     OPTION_VAL_CUBIC_AR },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_AR,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_AR,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_AR },
         { "5%",  OPTION_VAL_5_AR },
         { "10%", OPTION_VAL_10_AR },
         { "15%", OPTION_VAL_15_AR },
         { "20%", OPTION_VAL_20_AR },
         { "25%", OPTION_VAL_25_AR },
         { "30%", OPTION_VAL_30_AR },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_AR,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_AR,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_AR },
         { "mednafen", OPTION_VAL_MEDNAFEN_AR },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_AR,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_AR,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_AR,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_AR,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_AR,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_AR,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_AR,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_AR,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_AR },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_AR,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_AR,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_AR },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_AR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_AR,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_AR,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_AR },
         { "1px", OPTION_VAL_1PX_AR },
         { "2px", OPTION_VAL_2PX_AR },
         { "3px", OPTION_VAL_3PX_AR },
         { "4px", OPTION_VAL_4PX_AR },
         { "5px", OPTION_VAL_5PX_AR },
         { "6px", OPTION_VAL_6PX_AR },
         { "7px", OPTION_VAL_7PX_AR },
         { "8px", OPTION_VAL_8PX_AR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_AR,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_AR,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_AR,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_AR,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_AR,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_AR,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_AR,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_AR,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_AR },
         { "aggressive", OPTION_VAL_AGGRESSIVE_AR },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_AR,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_AR,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_AR,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_AR,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_AR },
         { "16:10", OPTION_VAL_16_10_AR },
         { "18:9",  OPTION_VAL_18_9_AR },
         { "19:9",  OPTION_VAL_19_9_AR },
         { "20:9",  OPTION_VAL_20_9_AR },
         { "21:9",  OPTION_VAL_21_9_AR }, // 64:27
         { "32:9",  OPTION_VAL_32_9_AR },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_AR,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_AR,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_AR },
         { "60%",           OPTION_VAL_60_AR },
         { "70%",           OPTION_VAL_70_AR },
         { "80%",           OPTION_VAL_80_AR },
         { "90%",           OPTION_VAL_90_AR },
         { "100%(native)", OPTION_VAL_100_NATIVE_AR },
         { "110%",          OPTION_VAL_110_AR },
         { "120%",          OPTION_VAL_120_AR },
         { "130%",          OPTION_VAL_130_AR },
         { "140%",          OPTION_VAL_140_AR },
         { "150%",          OPTION_VAL_150_AR },
         { "160%",          OPTION_VAL_160_AR },
         { "170%",          OPTION_VAL_170_AR },
         { "180%",          OPTION_VAL_180_AR },
         { "190%",          OPTION_VAL_190_AR },
         { "200%",          OPTION_VAL_200_AR },
         { "210%",          OPTION_VAL_210_AR },
         { "220%",          OPTION_VAL_220_AR },
         { "230%",          OPTION_VAL_230_AR },
         { "240%",          OPTION_VAL_240_AR },
         { "250%",          OPTION_VAL_250_AR },
         { "260%",          OPTION_VAL_260_AR },
         { "270%",          OPTION_VAL_270_AR },
         { "280%",          OPTION_VAL_280_AR },
         { "290%",          OPTION_VAL_290_AR },
         { "300%",          OPTION_VAL_300_AR },
         { "310%",          OPTION_VAL_310_AR },
         { "320%",          OPTION_VAL_320_AR },
         { "330%",          OPTION_VAL_330_AR },
         { "340%",          OPTION_VAL_340_AR },
         { "350%",          OPTION_VAL_350_AR },
         { "360%",          OPTION_VAL_360_AR },
         { "370%",          OPTION_VAL_370_AR },
         { "380%",          OPTION_VAL_380_AR },
         { "390%",          OPTION_VAL_390_AR },
         { "400%",          OPTION_VAL_400_AR },
         { "410%",          OPTION_VAL_410_AR },
         { "420%",          OPTION_VAL_420_AR },
         { "430%",          OPTION_VAL_430_AR },
         { "440%",          OPTION_VAL_440_AR },
         { "450%",          OPTION_VAL_450_AR },
         { "460%",          OPTION_VAL_460_AR },
         { "470%",          OPTION_VAL_470_AR },
         { "480%",          OPTION_VAL_480_AR },
         { "490%",          OPTION_VAL_490_AR },
         { "500%",          OPTION_VAL_500_AR },
         { "510%",          OPTION_VAL_510_AR },
         { "520%",          OPTION_VAL_520_AR },
         { "530%",          OPTION_VAL_530_AR },
         { "540%",          OPTION_VAL_540_AR },
         { "550%",          OPTION_VAL_550_AR },
         { "560%",          OPTION_VAL_560_AR },
         { "570%",          OPTION_VAL_570_AR },
         { "580%",          OPTION_VAL_580_AR },
         { "590%",          OPTION_VAL_590_AR },
         { "600%",          OPTION_VAL_600_AR },
         { "610%",          OPTION_VAL_610_AR },
         { "620%",          OPTION_VAL_620_AR },
         { "630%",          OPTION_VAL_630_AR },
         { "640%",          OPTION_VAL_640_AR },
         { "650%",          OPTION_VAL_650_AR },
         { "660%",          OPTION_VAL_660_AR },
         { "670%",          OPTION_VAL_670_AR },
         { "680%",          OPTION_VAL_680_AR },
         { "690%",          OPTION_VAL_690_AR },
         { "700%",          OPTION_VAL_700_AR },
         { "710%",          OPTION_VAL_710_AR },
         { "720%",          OPTION_VAL_720_AR },
         { "730%",          OPTION_VAL_730_AR },
         { "740%",          OPTION_VAL_740_AR },
         { "750%",          OPTION_VAL_750_AR },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_AR,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_AR,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_AR,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_AR,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_AR,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_AR,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_AR },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_AR },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_AR,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_AR,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_AR },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_AR },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_AR },
#endif
         { "software",    OPTION_VAL_SOFTWARE_AR },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_AR,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_AR,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_AR,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_AR,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_AR },
         { "execute",  OPTION_VAL_EXECUTE_AR },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_AR },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_AR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_AR,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_AR,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_AR },
         { "dma",  OPTION_VAL_DMA_AR },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_AR,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_AR,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_AR,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_AR,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_AR },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_AR },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_AR },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_AR,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_AR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_AR,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_AR,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_AR },
         { "static",  OPTION_VAL_STATIC_AR },
         { "smart", OPTION_VAL_SMART_AR },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_AR,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_AR,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_AR },
         { "2px",      OPTION_VAL_2PX_AR },
         { "3px",      OPTION_VAL_3PX_AR },
         { "4px",      OPTION_VAL_4PX_AR },
         { "5px",      OPTION_VAL_5PX_AR },
         { "6px",      OPTION_VAL_6PX_AR },
         { "7px",      OPTION_VAL_7PX_AR },
         { "8px",      OPTION_VAL_8PX_AR },
         { "9px",      OPTION_VAL_9PX_AR },
         { "10px",     OPTION_VAL_10PX_AR },
         { "11px",     OPTION_VAL_11PX_AR },
         { "12px",     OPTION_VAL_12PX_AR },
         { "13px",     OPTION_VAL_13PX_AR },
         { "14px",     OPTION_VAL_14PX_AR },
         { "15px",     OPTION_VAL_15PX_AR },
         { "16px",     OPTION_VAL_16PX_AR },
         { "17px",     OPTION_VAL_17PX_AR },
         { "18px",     OPTION_VAL_18PX_AR },
         { "19px",     OPTION_VAL_19PX_AR },
         { "20px",     OPTION_VAL_20PX_AR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_AR,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_AR,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_AR },
         { "-11px",    OPTION_VAL_11PX_O55_AR },
         { "-10px",    OPTION_VAL_10PX_O55_AR },
         { "-9px",     OPTION_VAL_9PX_O55_AR },
         { "-8px",     OPTION_VAL_8PX_O55_AR },
         { "-7px",     OPTION_VAL_7PX_O55_AR },
         { "-6px",     OPTION_VAL_6PX_O55_AR },
         { "-5px",     OPTION_VAL_5PX_O55_AR },
         { "-4px",     OPTION_VAL_4PX_O55_AR },
         { "-3px",     OPTION_VAL_3PX_O55_AR },
         { "-2px",     OPTION_VAL_2PX_O55_AR },
         { "-1px",     OPTION_VAL_1PX_O55_AR },
         { "disabled", OPTION_VAL_DISABLED_O55_AR },
         { "+1px",     OPTION_VAL_1PX_O55_0_AR },
         { "+2px",     OPTION_VAL_2PX_O55_0_AR },
         { "+3px",     OPTION_VAL_3PX_O55_0_AR },
         { "+4px",     OPTION_VAL_4PX_O55_0_AR },
         { "+5px",     OPTION_VAL_5PX_O55_0_AR },
         { "+6px",     OPTION_VAL_6PX_O55_0_AR },
         { "+7px",     OPTION_VAL_7PX_O55_0_AR },
         { "+8px",     OPTION_VAL_8PX_O55_0_AR },
         { "+9px",     OPTION_VAL_9PX_O55_0_AR },
         { "+10px",    OPTION_VAL_10PX_O55_0_AR },
         { "+11px",    OPTION_VAL_11PX_O55_0_AR },
         { "+12px",    OPTION_VAL_12PX_O55_0_AR },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_AR,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_AR,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_AR },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_AR,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_AR,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_AR },
         { "2x",         OPTION_VAL_2X_AR },
         { "4x",         OPTION_VAL_4X_AR },
         { "8x",         OPTION_VAL_8X_AR },
         { "16x",        OPTION_VAL_16X_AR },
         { "32x",        OPTION_VAL_32X_AR },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_AR,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_AR,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_AR },
         { "uncorrected", OPTION_VAL_UNCORRECTED_AR },
         { "4:3",  OPTION_VAL_4_3_AR },
         { "ntsc", OPTION_VAL_NTSC_AR },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_AR,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_AR,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_AR,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_AR,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_AR },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_AR,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_AR,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_AR,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_AR,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_AR },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_AR,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_AR,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_AR },
         { "async",    OPTION_VAL_ASYNC_AR },
         { "precache", OPTION_VAL_PRECACHE_AR },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_AR,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_AR,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_AR },
         { "4x",          OPTION_VAL_4X_AR },
         { "6x",          OPTION_VAL_6X_AR },
         { "8x",          OPTION_VAL_8X_AR },
         { "10x",         OPTION_VAL_10X_AR },
         { "12x",         OPTION_VAL_12X_AR },
         { "14x",         OPTION_VAL_14X_AR },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_ar = {
   option_cats_ar,
   option_defs_ar
};

/* RETRO_LANGUAGE_AST */

#define CATEGORY_VIDEO_LABEL_AST "Videu"
#define CATEGORY_VIDEO_INFO_0_AST NULL
#define CATEGORY_OSD_LABEL_AST "Avisos na pantalla"
#define CATEGORY_OSD_INFO_0_AST NULL
#define CATEGORY_INPUT_LABEL_AST "Entrada"
#define CATEGORY_INPUT_INFO_0_AST NULL
#define CATEGORY_MEMCARDS_LABEL_AST "Tarxeta de memoria"
#define CATEGORY_MEMCARDS_INFO_0_AST NULL
#define CATEGORY_PGXP_LABEL_AST NULL
#define CATEGORY_PGXP_INFO_0_AST NULL
#define CATEGORY_HACKS_LABEL_AST NULL
#define CATEGORY_HACKS_INFO_0_AST NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_AST NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_AST NULL
#define OPTION_VAL_1X_NATIVE_AST NULL
#define OPTION_VAL_2X_AST "x2"
#define OPTION_VAL_4X_AST "x4"
#define OPTION_VAL_8X_AST "x8"
#define OPTION_VAL_16X_AST NULL
#define BEETLE_OPT_DEPTH_LABEL_AST NULL
#define BEETLE_OPT_DEPTH_INFO_0_AST NULL
#define OPTION_VAL_16BPP_NATIVE_AST NULL
#define OPTION_VAL_32BPP_AST NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_AST NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_AST NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_AST "Resolución interna"
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_AST NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_AST NULL
#define BEETLE_OPT_FILTER_LABEL_AST NULL
#define BEETLE_OPT_FILTER_INFO_0_AST NULL
#define OPTION_VAL_NEAREST_AST NULL
#define OPTION_VAL_SABR_AST NULL
#define OPTION_VAL_XBR_AST NULL
#define OPTION_VAL_BILINEAR_AST "Billinial"
#define OPTION_VAL_3_POINT_AST NULL
#define OPTION_VAL_JINC2_AST NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_AST NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_AST NULL
#define OPTION_VAL_OPAQUE_AST NULL
#define OPTION_VAL_ALL_AST NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_AST NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_AST NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_AST NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_AST NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_AST NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_AST NULL
#define BEETLE_OPT_MSAA_LABEL_AST NULL
#define BEETLE_OPT_MSAA_INFO_0_AST NULL
#define OPTION_VAL_1X_AST "x1"
#define BEETLE_OPT_MDEC_YUV_LABEL_AST NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_AST NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_AST NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_AST NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_AST NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_AST NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_AST NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_AST NULL
#define BEETLE_OPT_WIREFRAME_LABEL_AST NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_AST NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_AST NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_AST NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_AST NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_AST NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_AST NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_AST NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_AST NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_AST NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_AST NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_AST NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_AST NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_AST NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_AST NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_AST NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_AST NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_AST NULL
#define OPTION_VAL_LIGHTGUN_AST NULL
#define OPTION_VAL_TOUCHSCREEN_AST "Pantalla táctil"
#define BEETLE_OPT_GUN_CURSOR_LABEL_AST NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_AST NULL
#define OPTION_VAL_CROSS_AST NULL
#define OPTION_VAL_DOT_AST NULL
#define OPTION_VAL_OFF_AST NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_AST NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_AST NULL
#define OPTION_VAL_RED_AST "Coloráu"
#define OPTION_VAL_BLUE_AST "Azul"
#define OPTION_VAL_GREEN_AST "Verde"
#define OPTION_VAL_ORANGE_AST "Naranxa"
#define OPTION_VAL_YELLOW_AST "Mariellu"
#define OPTION_VAL_CYAN_AST "Cianu"
#define OPTION_VAL_PINK_AST "Rosa"
#define OPTION_VAL_PURPLE_AST "Moráu"
#define OPTION_VAL_BLACK_AST "Prietu"
#define OPTION_VAL_WHITE_AST "Blancu"
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_AST NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_AST NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_AST "Sensibilidá del mur"
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_AST NULL
#define OPTION_VAL_5_AST NULL
#define OPTION_VAL_10_AST NULL
#define OPTION_VAL_15_AST NULL
#define OPTION_VAL_20_AST NULL
#define OPTION_VAL_25_AST NULL
#define OPTION_VAL_30_AST NULL
#define OPTION_VAL_35_AST NULL
#define OPTION_VAL_40_AST NULL
#define OPTION_VAL_45_AST NULL
#define OPTION_VAL_50_AST NULL
#define OPTION_VAL_55_AST NULL
#define OPTION_VAL_60_AST NULL
#define OPTION_VAL_65_AST NULL
#define OPTION_VAL_70_AST NULL
#define OPTION_VAL_75_AST NULL
#define OPTION_VAL_80_AST NULL
#define OPTION_VAL_85_AST NULL
#define OPTION_VAL_90_AST NULL
#define OPTION_VAL_95_AST NULL
#define OPTION_VAL_100_AST "100% (Por defeutu)"
#define OPTION_VAL_105_AST NULL
#define OPTION_VAL_110_AST NULL
#define OPTION_VAL_115_AST NULL
#define OPTION_VAL_120_AST NULL
#define OPTION_VAL_125_AST NULL
#define OPTION_VAL_130_AST NULL
#define OPTION_VAL_135_AST NULL
#define OPTION_VAL_140_AST NULL
#define OPTION_VAL_145_AST NULL
#define OPTION_VAL_150_AST NULL
#define OPTION_VAL_155_AST NULL
#define OPTION_VAL_160_AST NULL
#define OPTION_VAL_165_AST NULL
#define OPTION_VAL_170_AST NULL
#define OPTION_VAL_175_AST NULL
#define OPTION_VAL_180_AST NULL
#define OPTION_VAL_185_AST NULL
#define OPTION_VAL_190_AST NULL
#define OPTION_VAL_195_AST NULL
#define OPTION_VAL_200_AST NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_AST NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_AST NULL
#define OPTION_VAL_LINEAR_AST NULL
#define OPTION_VAL_QUADRATIC_AST NULL
#define OPTION_VAL_CUBIC_AST NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_AST NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_AST NULL
#define OPTION_VAL_0_AST NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_AST NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_AST NULL
#define OPTION_VAL_LIBRETRO_AST NULL
#define OPTION_VAL_MEDNAFEN_AST NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_AST NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_AST NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_AST NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_AST NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_AST NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_AST NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_AST NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_AST NULL
#define OPTION_VAL_1_AST NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_AST NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_AST NULL
#define OPTION_VAL_MEMORY_ONLY_AST NULL
#define OPTION_VAL_MEMORY_CPU_AST NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_AST NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_AST NULL
#define OPTION_VAL_0PX_AST NULL
#define OPTION_VAL_1PX_AST NULL
#define OPTION_VAL_2PX_AST NULL
#define OPTION_VAL_3PX_AST NULL
#define OPTION_VAL_4PX_AST NULL
#define OPTION_VAL_5PX_AST NULL
#define OPTION_VAL_6PX_AST NULL
#define OPTION_VAL_7PX_AST NULL
#define OPTION_VAL_8PX_AST NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_AST NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_AST NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_AST NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_AST NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_AST NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_AST NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_AST NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_AST NULL
#define OPTION_VAL_DEFAULT_AST NULL
#define OPTION_VAL_AGGRESSIVE_AST NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_AST NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_AST NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_AST NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_AST NULL
#define OPTION_VAL_16_9_AST NULL
#define OPTION_VAL_16_10_AST NULL
#define OPTION_VAL_18_9_AST NULL
#define OPTION_VAL_19_9_AST NULL
#define OPTION_VAL_20_9_AST NULL
#define OPTION_VAL_21_9_AST NULL
#define OPTION_VAL_32_9_AST NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_AST NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_AST NULL
#define OPTION_VAL_100_NATIVE_AST NULL
#define OPTION_VAL_210_AST NULL
#define OPTION_VAL_220_AST NULL
#define OPTION_VAL_230_AST NULL
#define OPTION_VAL_240_AST NULL
#define OPTION_VAL_250_AST NULL
#define OPTION_VAL_260_AST NULL
#define OPTION_VAL_270_AST NULL
#define OPTION_VAL_280_AST NULL
#define OPTION_VAL_290_AST NULL
#define OPTION_VAL_300_AST NULL
#define OPTION_VAL_310_AST NULL
#define OPTION_VAL_320_AST NULL
#define OPTION_VAL_330_AST NULL
#define OPTION_VAL_340_AST NULL
#define OPTION_VAL_350_AST NULL
#define OPTION_VAL_360_AST NULL
#define OPTION_VAL_370_AST NULL
#define OPTION_VAL_380_AST NULL
#define OPTION_VAL_390_AST NULL
#define OPTION_VAL_400_AST NULL
#define OPTION_VAL_410_AST NULL
#define OPTION_VAL_420_AST NULL
#define OPTION_VAL_430_AST NULL
#define OPTION_VAL_440_AST NULL
#define OPTION_VAL_450_AST NULL
#define OPTION_VAL_460_AST NULL
#define OPTION_VAL_470_AST NULL
#define OPTION_VAL_480_AST NULL
#define OPTION_VAL_490_AST NULL
#define OPTION_VAL_500_AST NULL
#define OPTION_VAL_510_AST NULL
#define OPTION_VAL_520_AST NULL
#define OPTION_VAL_530_AST NULL
#define OPTION_VAL_540_AST NULL
#define OPTION_VAL_550_AST NULL
#define OPTION_VAL_560_AST NULL
#define OPTION_VAL_570_AST NULL
#define OPTION_VAL_580_AST NULL
#define OPTION_VAL_590_AST NULL
#define OPTION_VAL_600_AST NULL
#define OPTION_VAL_610_AST NULL
#define OPTION_VAL_620_AST NULL
#define OPTION_VAL_630_AST NULL
#define OPTION_VAL_640_AST NULL
#define OPTION_VAL_650_AST NULL
#define OPTION_VAL_660_AST NULL
#define OPTION_VAL_670_AST NULL
#define OPTION_VAL_680_AST NULL
#define OPTION_VAL_690_AST NULL
#define OPTION_VAL_700_AST NULL
#define OPTION_VAL_710_AST NULL
#define OPTION_VAL_720_AST NULL
#define OPTION_VAL_730_AST NULL
#define OPTION_VAL_740_AST NULL
#define OPTION_VAL_750_AST NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_AST NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_AST NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_AST NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_AST NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_AST NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_AST NULL
#define OPTION_VAL_PSXONPSP_AST NULL
#define OPTION_VAL_PS1_ROM_AST NULL
#define BEETLE_OPT_RENDERER_LABEL_AST NULL
#define BEETLE_OPT_RENDERER_INFO_0_AST NULL
#define OPTION_VAL_HARDWARE_AST NULL
#define OPTION_VAL_HARDWARE_GL_AST NULL
#define OPTION_VAL_HARDWARE_VK_AST NULL
#define OPTION_VAL_SOFTWARE_AST NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_AST NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_AST NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_AST NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_AST NULL
#define OPTION_VAL_DISABLED_AST NULL
#define OPTION_VAL_EXECUTE_AST NULL
#define OPTION_VAL_EXECUTE_ONE_AST NULL
#define OPTION_VAL_RUN_INTERPRETER_AST NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_AST NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_AST NULL
#define OPTION_VAL_FULL_AST NULL
#define OPTION_VAL_DMA_AST NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_AST NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_AST NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_AST NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_AST NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_AST NULL
#define OPTION_VAL_FORCE_INTERLACED_AST NULL
#define OPTION_VAL_AUTO_TOGGLE_AST NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_AST NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_AST NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_AST NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_AST NULL
#define OPTION_VAL_DISABLED_O53_AST NULL
#define OPTION_VAL_STATIC_AST NULL
#define OPTION_VAL_SMART_AST NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_AST NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_AST NULL
#define OPTION_VAL_9PX_AST NULL
#define OPTION_VAL_10PX_AST NULL
#define OPTION_VAL_11PX_AST NULL
#define OPTION_VAL_12PX_AST NULL
#define OPTION_VAL_13PX_AST NULL
#define OPTION_VAL_14PX_AST NULL
#define OPTION_VAL_15PX_AST NULL
#define OPTION_VAL_16PX_AST NULL
#define OPTION_VAL_17PX_AST NULL
#define OPTION_VAL_18PX_AST NULL
#define OPTION_VAL_19PX_AST NULL
#define OPTION_VAL_20PX_AST NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_AST NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_AST NULL
#define OPTION_VAL_12PX_O55_AST NULL
#define OPTION_VAL_11PX_O55_AST NULL
#define OPTION_VAL_10PX_O55_AST NULL
#define OPTION_VAL_9PX_O55_AST NULL
#define OPTION_VAL_8PX_O55_AST NULL
#define OPTION_VAL_7PX_O55_AST NULL
#define OPTION_VAL_6PX_O55_AST NULL
#define OPTION_VAL_5PX_O55_AST NULL
#define OPTION_VAL_4PX_O55_AST NULL
#define OPTION_VAL_3PX_O55_AST NULL
#define OPTION_VAL_2PX_O55_AST NULL
#define OPTION_VAL_1PX_O55_AST NULL
#define OPTION_VAL_DISABLED_O55_AST "0 (Por defeutu)"
#define OPTION_VAL_1PX_O55_0_AST NULL
#define OPTION_VAL_2PX_O55_0_AST NULL
#define OPTION_VAL_3PX_O55_0_AST NULL
#define OPTION_VAL_4PX_O55_0_AST NULL
#define OPTION_VAL_5PX_O55_0_AST NULL
#define OPTION_VAL_6PX_O55_0_AST NULL
#define OPTION_VAL_7PX_O55_0_AST NULL
#define OPTION_VAL_8PX_O55_0_AST NULL
#define OPTION_VAL_9PX_O55_0_AST NULL
#define OPTION_VAL_10PX_O55_0_AST NULL
#define OPTION_VAL_11PX_O55_0_AST NULL
#define OPTION_VAL_12PX_O55_0_AST NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_AST NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_AST NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_AST NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_AST NULL
#define OPTION_VAL_32X_AST NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_AST "Proporción d'aspeutu del nucleu"
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_AST NULL
#define OPTION_VAL_CORRECTED_AST NULL
#define OPTION_VAL_UNCORRECTED_AST NULL
#define OPTION_VAL_4_3_AST NULL
#define OPTION_VAL_NTSC_AST NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_AST NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_AST NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_AST NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_AST NULL
#define OPTION_VAL_239_AST "239 (Por defeutu)"
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_AST NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_AST NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_AST NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_AST NULL
#define OPTION_VAL_287_AST "287 (Por defeutu)"
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_AST NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_AST NULL
#define OPTION_VAL_SYNC_AST NULL
#define OPTION_VAL_ASYNC_AST NULL
#define OPTION_VAL_PRECACHE_AST NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_AST NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_AST NULL
#define OPTION_VAL_2X_NATIVE_AST NULL
#define OPTION_VAL_6X_AST NULL
#define OPTION_VAL_10X_AST NULL
#define OPTION_VAL_12X_AST NULL
#define OPTION_VAL_14X_AST NULL

struct retro_core_option_v2_category option_cats_ast[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_AST,
      CATEGORY_VIDEO_INFO_0_AST
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_AST,
      CATEGORY_OSD_INFO_0_AST
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_AST,
      CATEGORY_INPUT_INFO_0_AST
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_AST,
      CATEGORY_MEMCARDS_INFO_0_AST
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_AST,
      CATEGORY_PGXP_INFO_0_AST
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_AST,
      CATEGORY_HACKS_INFO_0_AST
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_ast[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_AST,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_AST,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_AST },
         { "2x",         OPTION_VAL_2X_AST },
         { "4x",         OPTION_VAL_4X_AST },
         { "8x",         OPTION_VAL_8X_AST },
         { "16x",        OPTION_VAL_16X_AST },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_AST,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_AST,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_AST },
         { "32bpp",         OPTION_VAL_32BPP_AST },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_AST,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_AST,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_AST },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_AST },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_AST,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_AST,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_AST,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_AST,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_AST },
         { "SABR",     OPTION_VAL_SABR_AST },
         { "xBR",      OPTION_VAL_XBR_AST },
         { "bilinear", OPTION_VAL_BILINEAR_AST },
         { "3-point",  OPTION_VAL_3_POINT_AST },
         { "JINC2",    OPTION_VAL_JINC2_AST },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_AST,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_AST,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_AST },
         { "all", OPTION_VAL_ALL_AST },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_AST,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_AST,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_AST },
         { "all", OPTION_VAL_ALL_AST },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_AST,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_AST,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_AST,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_AST,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_AST,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_AST,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_AST },
         { "2x",  OPTION_VAL_2X_AST },
         { "4x",  OPTION_VAL_4X_AST },
         { "8x",  OPTION_VAL_8X_AST },
         { "16x", OPTION_VAL_16X_AST },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_AST,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_AST,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_AST,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_AST,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_AST,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_AST,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_AST,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_AST,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_AST,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_AST,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_AST,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_AST,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_AST,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_AST,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_AST,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_AST,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_AST,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_AST,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_AST,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_AST,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_AST,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_AST,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_AST,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_AST,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_AST,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_AST,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_AST },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_AST },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_AST,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_AST,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_AST },
         { "dot",   OPTION_VAL_DOT_AST },
         { "off",   OPTION_VAL_OFF_AST },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_AST,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_AST,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_AST },
         { "blue", OPTION_VAL_BLUE_AST },
         { "green", OPTION_VAL_GREEN_AST },
         { "orange", OPTION_VAL_ORANGE_AST },
         { "yellow", OPTION_VAL_YELLOW_AST },
         { "cyan", OPTION_VAL_CYAN_AST },
         { "pink", OPTION_VAL_PINK_AST },
         { "purple", OPTION_VAL_PURPLE_AST },
         { "black", OPTION_VAL_BLACK_AST },
         { "white", OPTION_VAL_WHITE_AST },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_AST,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_AST,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_AST },
         { "red", OPTION_VAL_RED_AST },
         { "green", OPTION_VAL_GREEN_AST },
         { "orange", OPTION_VAL_ORANGE_AST },
         { "yellow", OPTION_VAL_YELLOW_AST },
         { "cyan", OPTION_VAL_CYAN_AST },
         { "pink", OPTION_VAL_PINK_AST },
         { "purple", OPTION_VAL_PURPLE_AST },
         { "black", OPTION_VAL_BLACK_AST },
         { "white", OPTION_VAL_WHITE_AST },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_AST,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_AST,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_AST },
         { "10%",  OPTION_VAL_10_AST },
         { "15%",  OPTION_VAL_15_AST },
         { "20%",  OPTION_VAL_20_AST },
         { "25%",  OPTION_VAL_25_AST },
         { "30%",  OPTION_VAL_30_AST },
         { "35%",  OPTION_VAL_35_AST },
         { "40%",  OPTION_VAL_40_AST },
         { "45%",  OPTION_VAL_45_AST },
         { "50%",  OPTION_VAL_50_AST },
         { "55%",  OPTION_VAL_55_AST },
         { "60%",  OPTION_VAL_60_AST },
         { "65%",  OPTION_VAL_65_AST },
         { "70%",  OPTION_VAL_70_AST },
         { "75%",  OPTION_VAL_75_AST },
         { "80%",  OPTION_VAL_80_AST },
         { "85%",  OPTION_VAL_85_AST },
         { "90%",  OPTION_VAL_90_AST },
         { "95%",  OPTION_VAL_95_AST },
         { "100%", OPTION_VAL_100_AST },
         { "105%", OPTION_VAL_105_AST },
         { "110%", OPTION_VAL_110_AST },
         { "115%", OPTION_VAL_115_AST },
         { "120%", OPTION_VAL_120_AST },
         { "125%", OPTION_VAL_125_AST },
         { "130%", OPTION_VAL_130_AST },
         { "135%", OPTION_VAL_135_AST },
         { "140%", OPTION_VAL_140_AST },
         { "145%", OPTION_VAL_145_AST },
         { "150%", OPTION_VAL_150_AST },
         { "155%", OPTION_VAL_155_AST },
         { "160%", OPTION_VAL_160_AST },
         { "165%", OPTION_VAL_165_AST },
         { "170%", OPTION_VAL_170_AST },
         { "175%", OPTION_VAL_175_AST },
         { "180%", OPTION_VAL_180_AST },
         { "185%", OPTION_VAL_185_AST },
         { "190%", OPTION_VAL_190_AST },
         { "195%", OPTION_VAL_195_AST },
         { "200%", OPTION_VAL_200_AST },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_AST,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_AST,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_AST },
         { "quadratic", OPTION_VAL_QUADRATIC_AST },
         { "cubic",     OPTION_VAL_CUBIC_AST },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_AST,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_AST,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_AST },
         { "5%",  OPTION_VAL_5_AST },
         { "10%", OPTION_VAL_10_AST },
         { "15%", OPTION_VAL_15_AST },
         { "20%", OPTION_VAL_20_AST },
         { "25%", OPTION_VAL_25_AST },
         { "30%", OPTION_VAL_30_AST },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_AST,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_AST,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_AST },
         { "mednafen", OPTION_VAL_MEDNAFEN_AST },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_AST,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_AST,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_AST,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_AST,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_AST,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_AST,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_AST,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_AST,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_AST },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_AST,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_AST,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_AST },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_AST },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_AST,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_AST,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_AST },
         { "1px", OPTION_VAL_1PX_AST },
         { "2px", OPTION_VAL_2PX_AST },
         { "3px", OPTION_VAL_3PX_AST },
         { "4px", OPTION_VAL_4PX_AST },
         { "5px", OPTION_VAL_5PX_AST },
         { "6px", OPTION_VAL_6PX_AST },
         { "7px", OPTION_VAL_7PX_AST },
         { "8px", OPTION_VAL_8PX_AST },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_AST,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_AST,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_AST,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_AST,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_AST,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_AST,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_AST,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_AST,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_AST },
         { "aggressive", OPTION_VAL_AGGRESSIVE_AST },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_AST,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_AST,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_AST,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_AST,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_AST },
         { "16:10", OPTION_VAL_16_10_AST },
         { "18:9",  OPTION_VAL_18_9_AST },
         { "19:9",  OPTION_VAL_19_9_AST },
         { "20:9",  OPTION_VAL_20_9_AST },
         { "21:9",  OPTION_VAL_21_9_AST }, // 64:27
         { "32:9",  OPTION_VAL_32_9_AST },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_AST,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_AST,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_AST },
         { "60%",           OPTION_VAL_60_AST },
         { "70%",           OPTION_VAL_70_AST },
         { "80%",           OPTION_VAL_80_AST },
         { "90%",           OPTION_VAL_90_AST },
         { "100%(native)", OPTION_VAL_100_NATIVE_AST },
         { "110%",          OPTION_VAL_110_AST },
         { "120%",          OPTION_VAL_120_AST },
         { "130%",          OPTION_VAL_130_AST },
         { "140%",          OPTION_VAL_140_AST },
         { "150%",          OPTION_VAL_150_AST },
         { "160%",          OPTION_VAL_160_AST },
         { "170%",          OPTION_VAL_170_AST },
         { "180%",          OPTION_VAL_180_AST },
         { "190%",          OPTION_VAL_190_AST },
         { "200%",          OPTION_VAL_200_AST },
         { "210%",          OPTION_VAL_210_AST },
         { "220%",          OPTION_VAL_220_AST },
         { "230%",          OPTION_VAL_230_AST },
         { "240%",          OPTION_VAL_240_AST },
         { "250%",          OPTION_VAL_250_AST },
         { "260%",          OPTION_VAL_260_AST },
         { "270%",          OPTION_VAL_270_AST },
         { "280%",          OPTION_VAL_280_AST },
         { "290%",          OPTION_VAL_290_AST },
         { "300%",          OPTION_VAL_300_AST },
         { "310%",          OPTION_VAL_310_AST },
         { "320%",          OPTION_VAL_320_AST },
         { "330%",          OPTION_VAL_330_AST },
         { "340%",          OPTION_VAL_340_AST },
         { "350%",          OPTION_VAL_350_AST },
         { "360%",          OPTION_VAL_360_AST },
         { "370%",          OPTION_VAL_370_AST },
         { "380%",          OPTION_VAL_380_AST },
         { "390%",          OPTION_VAL_390_AST },
         { "400%",          OPTION_VAL_400_AST },
         { "410%",          OPTION_VAL_410_AST },
         { "420%",          OPTION_VAL_420_AST },
         { "430%",          OPTION_VAL_430_AST },
         { "440%",          OPTION_VAL_440_AST },
         { "450%",          OPTION_VAL_450_AST },
         { "460%",          OPTION_VAL_460_AST },
         { "470%",          OPTION_VAL_470_AST },
         { "480%",          OPTION_VAL_480_AST },
         { "490%",          OPTION_VAL_490_AST },
         { "500%",          OPTION_VAL_500_AST },
         { "510%",          OPTION_VAL_510_AST },
         { "520%",          OPTION_VAL_520_AST },
         { "530%",          OPTION_VAL_530_AST },
         { "540%",          OPTION_VAL_540_AST },
         { "550%",          OPTION_VAL_550_AST },
         { "560%",          OPTION_VAL_560_AST },
         { "570%",          OPTION_VAL_570_AST },
         { "580%",          OPTION_VAL_580_AST },
         { "590%",          OPTION_VAL_590_AST },
         { "600%",          OPTION_VAL_600_AST },
         { "610%",          OPTION_VAL_610_AST },
         { "620%",          OPTION_VAL_620_AST },
         { "630%",          OPTION_VAL_630_AST },
         { "640%",          OPTION_VAL_640_AST },
         { "650%",          OPTION_VAL_650_AST },
         { "660%",          OPTION_VAL_660_AST },
         { "670%",          OPTION_VAL_670_AST },
         { "680%",          OPTION_VAL_680_AST },
         { "690%",          OPTION_VAL_690_AST },
         { "700%",          OPTION_VAL_700_AST },
         { "710%",          OPTION_VAL_710_AST },
         { "720%",          OPTION_VAL_720_AST },
         { "730%",          OPTION_VAL_730_AST },
         { "740%",          OPTION_VAL_740_AST },
         { "750%",          OPTION_VAL_750_AST },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_AST,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_AST,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_AST,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_AST,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_AST,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_AST,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_AST },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_AST },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_AST,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_AST,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_AST },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_AST },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_AST },
#endif
         { "software",    OPTION_VAL_SOFTWARE_AST },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_AST,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_AST,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_AST,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_AST,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_AST },
         { "execute",  OPTION_VAL_EXECUTE_AST },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_AST },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_AST },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_AST,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_AST,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_AST },
         { "dma",  OPTION_VAL_DMA_AST },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_AST,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_AST,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_AST,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_AST,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_AST },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_AST },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_AST },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_AST,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_AST,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_AST,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_AST,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_AST },
         { "static",  OPTION_VAL_STATIC_AST },
         { "smart", OPTION_VAL_SMART_AST },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_AST,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_AST,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_AST },
         { "2px",      OPTION_VAL_2PX_AST },
         { "3px",      OPTION_VAL_3PX_AST },
         { "4px",      OPTION_VAL_4PX_AST },
         { "5px",      OPTION_VAL_5PX_AST },
         { "6px",      OPTION_VAL_6PX_AST },
         { "7px",      OPTION_VAL_7PX_AST },
         { "8px",      OPTION_VAL_8PX_AST },
         { "9px",      OPTION_VAL_9PX_AST },
         { "10px",     OPTION_VAL_10PX_AST },
         { "11px",     OPTION_VAL_11PX_AST },
         { "12px",     OPTION_VAL_12PX_AST },
         { "13px",     OPTION_VAL_13PX_AST },
         { "14px",     OPTION_VAL_14PX_AST },
         { "15px",     OPTION_VAL_15PX_AST },
         { "16px",     OPTION_VAL_16PX_AST },
         { "17px",     OPTION_VAL_17PX_AST },
         { "18px",     OPTION_VAL_18PX_AST },
         { "19px",     OPTION_VAL_19PX_AST },
         { "20px",     OPTION_VAL_20PX_AST },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_AST,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_AST,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_AST },
         { "-11px",    OPTION_VAL_11PX_O55_AST },
         { "-10px",    OPTION_VAL_10PX_O55_AST },
         { "-9px",     OPTION_VAL_9PX_O55_AST },
         { "-8px",     OPTION_VAL_8PX_O55_AST },
         { "-7px",     OPTION_VAL_7PX_O55_AST },
         { "-6px",     OPTION_VAL_6PX_O55_AST },
         { "-5px",     OPTION_VAL_5PX_O55_AST },
         { "-4px",     OPTION_VAL_4PX_O55_AST },
         { "-3px",     OPTION_VAL_3PX_O55_AST },
         { "-2px",     OPTION_VAL_2PX_O55_AST },
         { "-1px",     OPTION_VAL_1PX_O55_AST },
         { "disabled", OPTION_VAL_DISABLED_O55_AST },
         { "+1px",     OPTION_VAL_1PX_O55_0_AST },
         { "+2px",     OPTION_VAL_2PX_O55_0_AST },
         { "+3px",     OPTION_VAL_3PX_O55_0_AST },
         { "+4px",     OPTION_VAL_4PX_O55_0_AST },
         { "+5px",     OPTION_VAL_5PX_O55_0_AST },
         { "+6px",     OPTION_VAL_6PX_O55_0_AST },
         { "+7px",     OPTION_VAL_7PX_O55_0_AST },
         { "+8px",     OPTION_VAL_8PX_O55_0_AST },
         { "+9px",     OPTION_VAL_9PX_O55_0_AST },
         { "+10px",    OPTION_VAL_10PX_O55_0_AST },
         { "+11px",    OPTION_VAL_11PX_O55_0_AST },
         { "+12px",    OPTION_VAL_12PX_O55_0_AST },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_AST,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_AST,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_AST },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_AST,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_AST,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_AST },
         { "2x",         OPTION_VAL_2X_AST },
         { "4x",         OPTION_VAL_4X_AST },
         { "8x",         OPTION_VAL_8X_AST },
         { "16x",        OPTION_VAL_16X_AST },
         { "32x",        OPTION_VAL_32X_AST },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_AST,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_AST,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_AST },
         { "uncorrected", OPTION_VAL_UNCORRECTED_AST },
         { "4:3",  OPTION_VAL_4_3_AST },
         { "ntsc", OPTION_VAL_NTSC_AST },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_AST,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_AST,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_AST,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_AST,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_AST },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_AST,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_AST,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_AST,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_AST,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_AST },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_AST,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_AST,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_AST },
         { "async",    OPTION_VAL_ASYNC_AST },
         { "precache", OPTION_VAL_PRECACHE_AST },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_AST,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_AST,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_AST },
         { "4x",          OPTION_VAL_4X_AST },
         { "6x",          OPTION_VAL_6X_AST },
         { "8x",          OPTION_VAL_8X_AST },
         { "10x",         OPTION_VAL_10X_AST },
         { "12x",         OPTION_VAL_12X_AST },
         { "14x",         OPTION_VAL_14X_AST },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_ast = {
   option_cats_ast,
   option_defs_ast
};

/* RETRO_LANGUAGE_CA */

#define CATEGORY_VIDEO_LABEL_CA "Vídeo"
#define CATEGORY_VIDEO_INFO_0_CA NULL
#define CATEGORY_OSD_LABEL_CA NULL
#define CATEGORY_OSD_INFO_0_CA NULL
#define CATEGORY_INPUT_LABEL_CA "Dispositius de joc"
#define CATEGORY_INPUT_INFO_0_CA NULL
#define CATEGORY_MEMCARDS_LABEL_CA NULL
#define CATEGORY_MEMCARDS_INFO_0_CA NULL
#define CATEGORY_PGXP_LABEL_CA NULL
#define CATEGORY_PGXP_INFO_0_CA NULL
#define CATEGORY_HACKS_LABEL_CA NULL
#define CATEGORY_HACKS_INFO_0_CA NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_CA NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_CA NULL
#define OPTION_VAL_1X_NATIVE_CA NULL
#define OPTION_VAL_2X_CA NULL
#define OPTION_VAL_4X_CA NULL
#define OPTION_VAL_8X_CA NULL
#define OPTION_VAL_16X_CA NULL
#define BEETLE_OPT_DEPTH_LABEL_CA NULL
#define BEETLE_OPT_DEPTH_INFO_0_CA NULL
#define OPTION_VAL_16BPP_NATIVE_CA NULL
#define OPTION_VAL_32BPP_CA NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_CA NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_CA NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_CA "Resolució Interna"
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_CA NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_CA NULL
#define BEETLE_OPT_FILTER_LABEL_CA NULL
#define BEETLE_OPT_FILTER_INFO_0_CA NULL
#define OPTION_VAL_NEAREST_CA NULL
#define OPTION_VAL_SABR_CA NULL
#define OPTION_VAL_XBR_CA NULL
#define OPTION_VAL_BILINEAR_CA NULL
#define OPTION_VAL_3_POINT_CA NULL
#define OPTION_VAL_JINC2_CA NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_CA NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_CA NULL
#define OPTION_VAL_OPAQUE_CA NULL
#define OPTION_VAL_ALL_CA NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_CA NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_CA NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_CA NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_CA NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_CA NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_CA NULL
#define BEETLE_OPT_MSAA_LABEL_CA NULL
#define BEETLE_OPT_MSAA_INFO_0_CA NULL
#define OPTION_VAL_1X_CA NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_CA NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_CA NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_CA NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_CA NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_CA NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_CA NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_CA NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_CA NULL
#define BEETLE_OPT_WIREFRAME_LABEL_CA NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_CA NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_CA NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_CA NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_CA NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_CA NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_CA NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_CA NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_CA NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_CA NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_CA NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_CA NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_CA NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_CA NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_CA NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_CA NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_CA NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_CA NULL
#define OPTION_VAL_LIGHTGUN_CA NULL
#define OPTION_VAL_TOUCHSCREEN_CA NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_CA NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_CA NULL
#define OPTION_VAL_CROSS_CA NULL
#define OPTION_VAL_DOT_CA NULL
#define OPTION_VAL_OFF_CA NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_CA NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_CA NULL
#define OPTION_VAL_RED_CA NULL
#define OPTION_VAL_BLUE_CA NULL
#define OPTION_VAL_GREEN_CA NULL
#define OPTION_VAL_ORANGE_CA NULL
#define OPTION_VAL_YELLOW_CA NULL
#define OPTION_VAL_CYAN_CA NULL
#define OPTION_VAL_PINK_CA NULL
#define OPTION_VAL_PURPLE_CA NULL
#define OPTION_VAL_BLACK_CA NULL
#define OPTION_VAL_WHITE_CA NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_CA NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_CA NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_CA NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_CA NULL
#define OPTION_VAL_5_CA NULL
#define OPTION_VAL_10_CA NULL
#define OPTION_VAL_15_CA NULL
#define OPTION_VAL_20_CA NULL
#define OPTION_VAL_25_CA NULL
#define OPTION_VAL_30_CA NULL
#define OPTION_VAL_35_CA NULL
#define OPTION_VAL_40_CA NULL
#define OPTION_VAL_45_CA NULL
#define OPTION_VAL_50_CA NULL
#define OPTION_VAL_55_CA NULL
#define OPTION_VAL_60_CA NULL
#define OPTION_VAL_65_CA NULL
#define OPTION_VAL_70_CA NULL
#define OPTION_VAL_75_CA NULL
#define OPTION_VAL_80_CA NULL
#define OPTION_VAL_85_CA NULL
#define OPTION_VAL_90_CA NULL
#define OPTION_VAL_95_CA NULL
#define OPTION_VAL_100_CA NULL
#define OPTION_VAL_105_CA NULL
#define OPTION_VAL_110_CA NULL
#define OPTION_VAL_115_CA NULL
#define OPTION_VAL_120_CA NULL
#define OPTION_VAL_125_CA NULL
#define OPTION_VAL_130_CA NULL
#define OPTION_VAL_135_CA NULL
#define OPTION_VAL_140_CA NULL
#define OPTION_VAL_145_CA NULL
#define OPTION_VAL_150_CA NULL
#define OPTION_VAL_155_CA NULL
#define OPTION_VAL_160_CA NULL
#define OPTION_VAL_165_CA NULL
#define OPTION_VAL_170_CA NULL
#define OPTION_VAL_175_CA NULL
#define OPTION_VAL_180_CA NULL
#define OPTION_VAL_185_CA NULL
#define OPTION_VAL_190_CA NULL
#define OPTION_VAL_195_CA NULL
#define OPTION_VAL_200_CA NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_CA NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_CA NULL
#define OPTION_VAL_LINEAR_CA NULL
#define OPTION_VAL_QUADRATIC_CA NULL
#define OPTION_VAL_CUBIC_CA NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_CA NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_CA NULL
#define OPTION_VAL_0_CA NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_CA NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_CA NULL
#define OPTION_VAL_LIBRETRO_CA NULL
#define OPTION_VAL_MEDNAFEN_CA NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_CA NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_CA NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_CA NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_CA NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_CA NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_CA NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_CA NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_CA NULL
#define OPTION_VAL_1_CA NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_CA NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_CA NULL
#define OPTION_VAL_MEMORY_ONLY_CA NULL
#define OPTION_VAL_MEMORY_CPU_CA NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_CA NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_CA NULL
#define OPTION_VAL_0PX_CA NULL
#define OPTION_VAL_1PX_CA NULL
#define OPTION_VAL_2PX_CA NULL
#define OPTION_VAL_3PX_CA NULL
#define OPTION_VAL_4PX_CA NULL
#define OPTION_VAL_5PX_CA NULL
#define OPTION_VAL_6PX_CA NULL
#define OPTION_VAL_7PX_CA NULL
#define OPTION_VAL_8PX_CA NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_CA NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_CA NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_CA NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_CA NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_CA NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_CA NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_CA NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_CA NULL
#define OPTION_VAL_DEFAULT_CA NULL
#define OPTION_VAL_AGGRESSIVE_CA NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_CA NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_CA NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_CA NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_CA NULL
#define OPTION_VAL_16_9_CA NULL
#define OPTION_VAL_16_10_CA NULL
#define OPTION_VAL_18_9_CA NULL
#define OPTION_VAL_19_9_CA NULL
#define OPTION_VAL_20_9_CA NULL
#define OPTION_VAL_21_9_CA NULL
#define OPTION_VAL_32_9_CA NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_CA NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_CA NULL
#define OPTION_VAL_100_NATIVE_CA NULL
#define OPTION_VAL_210_CA NULL
#define OPTION_VAL_220_CA NULL
#define OPTION_VAL_230_CA NULL
#define OPTION_VAL_240_CA NULL
#define OPTION_VAL_250_CA NULL
#define OPTION_VAL_260_CA NULL
#define OPTION_VAL_270_CA NULL
#define OPTION_VAL_280_CA NULL
#define OPTION_VAL_290_CA NULL
#define OPTION_VAL_300_CA NULL
#define OPTION_VAL_310_CA NULL
#define OPTION_VAL_320_CA NULL
#define OPTION_VAL_330_CA NULL
#define OPTION_VAL_340_CA NULL
#define OPTION_VAL_350_CA NULL
#define OPTION_VAL_360_CA NULL
#define OPTION_VAL_370_CA NULL
#define OPTION_VAL_380_CA NULL
#define OPTION_VAL_390_CA NULL
#define OPTION_VAL_400_CA NULL
#define OPTION_VAL_410_CA NULL
#define OPTION_VAL_420_CA NULL
#define OPTION_VAL_430_CA NULL
#define OPTION_VAL_440_CA NULL
#define OPTION_VAL_450_CA NULL
#define OPTION_VAL_460_CA NULL
#define OPTION_VAL_470_CA NULL
#define OPTION_VAL_480_CA NULL
#define OPTION_VAL_490_CA NULL
#define OPTION_VAL_500_CA NULL
#define OPTION_VAL_510_CA NULL
#define OPTION_VAL_520_CA NULL
#define OPTION_VAL_530_CA NULL
#define OPTION_VAL_540_CA NULL
#define OPTION_VAL_550_CA NULL
#define OPTION_VAL_560_CA NULL
#define OPTION_VAL_570_CA NULL
#define OPTION_VAL_580_CA NULL
#define OPTION_VAL_590_CA NULL
#define OPTION_VAL_600_CA NULL
#define OPTION_VAL_610_CA NULL
#define OPTION_VAL_620_CA NULL
#define OPTION_VAL_630_CA NULL
#define OPTION_VAL_640_CA NULL
#define OPTION_VAL_650_CA NULL
#define OPTION_VAL_660_CA NULL
#define OPTION_VAL_670_CA NULL
#define OPTION_VAL_680_CA NULL
#define OPTION_VAL_690_CA NULL
#define OPTION_VAL_700_CA NULL
#define OPTION_VAL_710_CA NULL
#define OPTION_VAL_720_CA NULL
#define OPTION_VAL_730_CA NULL
#define OPTION_VAL_740_CA NULL
#define OPTION_VAL_750_CA NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_CA NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_CA NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_CA NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_CA NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_CA NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_CA NULL
#define OPTION_VAL_PSXONPSP_CA NULL
#define OPTION_VAL_PS1_ROM_CA NULL
#define BEETLE_OPT_RENDERER_LABEL_CA NULL
#define BEETLE_OPT_RENDERER_INFO_0_CA NULL
#define OPTION_VAL_HARDWARE_CA NULL
#define OPTION_VAL_HARDWARE_GL_CA NULL
#define OPTION_VAL_HARDWARE_VK_CA NULL
#define OPTION_VAL_SOFTWARE_CA NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_CA NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_CA NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_CA NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_CA NULL
#define OPTION_VAL_DISABLED_CA NULL
#define OPTION_VAL_EXECUTE_CA NULL
#define OPTION_VAL_EXECUTE_ONE_CA NULL
#define OPTION_VAL_RUN_INTERPRETER_CA NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_CA NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_CA NULL
#define OPTION_VAL_FULL_CA NULL
#define OPTION_VAL_DMA_CA NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_CA NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_CA NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_CA NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_CA NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_CA NULL
#define OPTION_VAL_FORCE_INTERLACED_CA NULL
#define OPTION_VAL_AUTO_TOGGLE_CA NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_CA NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_CA NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_CA NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_CA NULL
#define OPTION_VAL_DISABLED_O53_CA NULL
#define OPTION_VAL_STATIC_CA NULL
#define OPTION_VAL_SMART_CA NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_CA NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_CA NULL
#define OPTION_VAL_9PX_CA NULL
#define OPTION_VAL_10PX_CA NULL
#define OPTION_VAL_11PX_CA NULL
#define OPTION_VAL_12PX_CA NULL
#define OPTION_VAL_13PX_CA NULL
#define OPTION_VAL_14PX_CA NULL
#define OPTION_VAL_15PX_CA NULL
#define OPTION_VAL_16PX_CA NULL
#define OPTION_VAL_17PX_CA NULL
#define OPTION_VAL_18PX_CA NULL
#define OPTION_VAL_19PX_CA NULL
#define OPTION_VAL_20PX_CA NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_CA NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_CA NULL
#define OPTION_VAL_12PX_O55_CA NULL
#define OPTION_VAL_11PX_O55_CA NULL
#define OPTION_VAL_10PX_O55_CA NULL
#define OPTION_VAL_9PX_O55_CA NULL
#define OPTION_VAL_8PX_O55_CA NULL
#define OPTION_VAL_7PX_O55_CA NULL
#define OPTION_VAL_6PX_O55_CA NULL
#define OPTION_VAL_5PX_O55_CA NULL
#define OPTION_VAL_4PX_O55_CA NULL
#define OPTION_VAL_3PX_O55_CA NULL
#define OPTION_VAL_2PX_O55_CA NULL
#define OPTION_VAL_1PX_O55_CA NULL
#define OPTION_VAL_DISABLED_O55_CA NULL
#define OPTION_VAL_1PX_O55_0_CA NULL
#define OPTION_VAL_2PX_O55_0_CA NULL
#define OPTION_VAL_3PX_O55_0_CA NULL
#define OPTION_VAL_4PX_O55_0_CA NULL
#define OPTION_VAL_5PX_O55_0_CA NULL
#define OPTION_VAL_6PX_O55_0_CA NULL
#define OPTION_VAL_7PX_O55_0_CA NULL
#define OPTION_VAL_8PX_O55_0_CA NULL
#define OPTION_VAL_9PX_O55_0_CA NULL
#define OPTION_VAL_10PX_O55_0_CA NULL
#define OPTION_VAL_11PX_O55_0_CA NULL
#define OPTION_VAL_12PX_O55_0_CA NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_CA NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_CA NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_CA NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_CA NULL
#define OPTION_VAL_32X_CA NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_CA NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_CA NULL
#define OPTION_VAL_CORRECTED_CA NULL
#define OPTION_VAL_UNCORRECTED_CA NULL
#define OPTION_VAL_4_3_CA NULL
#define OPTION_VAL_NTSC_CA NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_CA NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_CA NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_CA NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_CA NULL
#define OPTION_VAL_239_CA NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_CA NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_CA NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_CA NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_CA NULL
#define OPTION_VAL_287_CA NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_CA NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_CA NULL
#define OPTION_VAL_SYNC_CA NULL
#define OPTION_VAL_ASYNC_CA NULL
#define OPTION_VAL_PRECACHE_CA NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_CA NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_CA NULL
#define OPTION_VAL_2X_NATIVE_CA NULL
#define OPTION_VAL_6X_CA NULL
#define OPTION_VAL_10X_CA NULL
#define OPTION_VAL_12X_CA NULL
#define OPTION_VAL_14X_CA NULL

struct retro_core_option_v2_category option_cats_ca[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_CA,
      CATEGORY_VIDEO_INFO_0_CA
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_CA,
      CATEGORY_OSD_INFO_0_CA
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_CA,
      CATEGORY_INPUT_INFO_0_CA
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_CA,
      CATEGORY_MEMCARDS_INFO_0_CA
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_CA,
      CATEGORY_PGXP_INFO_0_CA
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_CA,
      CATEGORY_HACKS_INFO_0_CA
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_ca[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_CA,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_CA,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_CA },
         { "2x",         OPTION_VAL_2X_CA },
         { "4x",         OPTION_VAL_4X_CA },
         { "8x",         OPTION_VAL_8X_CA },
         { "16x",        OPTION_VAL_16X_CA },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_CA,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_CA,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_CA },
         { "32bpp",         OPTION_VAL_32BPP_CA },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_CA,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_CA,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_CA },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_CA },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_CA,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_CA,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_CA,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_CA,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_CA },
         { "SABR",     OPTION_VAL_SABR_CA },
         { "xBR",      OPTION_VAL_XBR_CA },
         { "bilinear", OPTION_VAL_BILINEAR_CA },
         { "3-point",  OPTION_VAL_3_POINT_CA },
         { "JINC2",    OPTION_VAL_JINC2_CA },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_CA,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_CA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_CA },
         { "all", OPTION_VAL_ALL_CA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_CA,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_CA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_CA },
         { "all", OPTION_VAL_ALL_CA },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_CA,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_CA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_CA,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_CA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_CA,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_CA,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_CA },
         { "2x",  OPTION_VAL_2X_CA },
         { "4x",  OPTION_VAL_4X_CA },
         { "8x",  OPTION_VAL_8X_CA },
         { "16x", OPTION_VAL_16X_CA },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_CA,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_CA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_CA,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_CA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_CA,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_CA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_CA,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_CA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_CA,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_CA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_CA,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_CA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_CA,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_CA,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_CA,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_CA,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_CA,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_CA,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_CA,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_CA,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_CA,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_CA,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_CA,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_CA,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_CA,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_CA,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_CA },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_CA },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_CA,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_CA,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_CA },
         { "dot",   OPTION_VAL_DOT_CA },
         { "off",   OPTION_VAL_OFF_CA },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_CA,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_CA,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_CA },
         { "blue", OPTION_VAL_BLUE_CA },
         { "green", OPTION_VAL_GREEN_CA },
         { "orange", OPTION_VAL_ORANGE_CA },
         { "yellow", OPTION_VAL_YELLOW_CA },
         { "cyan", OPTION_VAL_CYAN_CA },
         { "pink", OPTION_VAL_PINK_CA },
         { "purple", OPTION_VAL_PURPLE_CA },
         { "black", OPTION_VAL_BLACK_CA },
         { "white", OPTION_VAL_WHITE_CA },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_CA,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_CA,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_CA },
         { "red", OPTION_VAL_RED_CA },
         { "green", OPTION_VAL_GREEN_CA },
         { "orange", OPTION_VAL_ORANGE_CA },
         { "yellow", OPTION_VAL_YELLOW_CA },
         { "cyan", OPTION_VAL_CYAN_CA },
         { "pink", OPTION_VAL_PINK_CA },
         { "purple", OPTION_VAL_PURPLE_CA },
         { "black", OPTION_VAL_BLACK_CA },
         { "white", OPTION_VAL_WHITE_CA },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_CA,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_CA,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_CA },
         { "10%",  OPTION_VAL_10_CA },
         { "15%",  OPTION_VAL_15_CA },
         { "20%",  OPTION_VAL_20_CA },
         { "25%",  OPTION_VAL_25_CA },
         { "30%",  OPTION_VAL_30_CA },
         { "35%",  OPTION_VAL_35_CA },
         { "40%",  OPTION_VAL_40_CA },
         { "45%",  OPTION_VAL_45_CA },
         { "50%",  OPTION_VAL_50_CA },
         { "55%",  OPTION_VAL_55_CA },
         { "60%",  OPTION_VAL_60_CA },
         { "65%",  OPTION_VAL_65_CA },
         { "70%",  OPTION_VAL_70_CA },
         { "75%",  OPTION_VAL_75_CA },
         { "80%",  OPTION_VAL_80_CA },
         { "85%",  OPTION_VAL_85_CA },
         { "90%",  OPTION_VAL_90_CA },
         { "95%",  OPTION_VAL_95_CA },
         { "100%", OPTION_VAL_100_CA },
         { "105%", OPTION_VAL_105_CA },
         { "110%", OPTION_VAL_110_CA },
         { "115%", OPTION_VAL_115_CA },
         { "120%", OPTION_VAL_120_CA },
         { "125%", OPTION_VAL_125_CA },
         { "130%", OPTION_VAL_130_CA },
         { "135%", OPTION_VAL_135_CA },
         { "140%", OPTION_VAL_140_CA },
         { "145%", OPTION_VAL_145_CA },
         { "150%", OPTION_VAL_150_CA },
         { "155%", OPTION_VAL_155_CA },
         { "160%", OPTION_VAL_160_CA },
         { "165%", OPTION_VAL_165_CA },
         { "170%", OPTION_VAL_170_CA },
         { "175%", OPTION_VAL_175_CA },
         { "180%", OPTION_VAL_180_CA },
         { "185%", OPTION_VAL_185_CA },
         { "190%", OPTION_VAL_190_CA },
         { "195%", OPTION_VAL_195_CA },
         { "200%", OPTION_VAL_200_CA },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_CA,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_CA,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_CA },
         { "quadratic", OPTION_VAL_QUADRATIC_CA },
         { "cubic",     OPTION_VAL_CUBIC_CA },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_CA,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_CA,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_CA },
         { "5%",  OPTION_VAL_5_CA },
         { "10%", OPTION_VAL_10_CA },
         { "15%", OPTION_VAL_15_CA },
         { "20%", OPTION_VAL_20_CA },
         { "25%", OPTION_VAL_25_CA },
         { "30%", OPTION_VAL_30_CA },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_CA,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_CA,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_CA },
         { "mednafen", OPTION_VAL_MEDNAFEN_CA },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_CA,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_CA,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_CA,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_CA,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_CA,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_CA,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_CA,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_CA,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_CA },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_CA,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_CA,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_CA },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_CA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_CA,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_CA,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_CA },
         { "1px", OPTION_VAL_1PX_CA },
         { "2px", OPTION_VAL_2PX_CA },
         { "3px", OPTION_VAL_3PX_CA },
         { "4px", OPTION_VAL_4PX_CA },
         { "5px", OPTION_VAL_5PX_CA },
         { "6px", OPTION_VAL_6PX_CA },
         { "7px", OPTION_VAL_7PX_CA },
         { "8px", OPTION_VAL_8PX_CA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_CA,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_CA,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_CA,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_CA,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_CA,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_CA,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_CA,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_CA,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_CA },
         { "aggressive", OPTION_VAL_AGGRESSIVE_CA },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_CA,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_CA,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_CA,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_CA,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_CA },
         { "16:10", OPTION_VAL_16_10_CA },
         { "18:9",  OPTION_VAL_18_9_CA },
         { "19:9",  OPTION_VAL_19_9_CA },
         { "20:9",  OPTION_VAL_20_9_CA },
         { "21:9",  OPTION_VAL_21_9_CA }, // 64:27
         { "32:9",  OPTION_VAL_32_9_CA },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_CA,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_CA,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_CA },
         { "60%",           OPTION_VAL_60_CA },
         { "70%",           OPTION_VAL_70_CA },
         { "80%",           OPTION_VAL_80_CA },
         { "90%",           OPTION_VAL_90_CA },
         { "100%(native)", OPTION_VAL_100_NATIVE_CA },
         { "110%",          OPTION_VAL_110_CA },
         { "120%",          OPTION_VAL_120_CA },
         { "130%",          OPTION_VAL_130_CA },
         { "140%",          OPTION_VAL_140_CA },
         { "150%",          OPTION_VAL_150_CA },
         { "160%",          OPTION_VAL_160_CA },
         { "170%",          OPTION_VAL_170_CA },
         { "180%",          OPTION_VAL_180_CA },
         { "190%",          OPTION_VAL_190_CA },
         { "200%",          OPTION_VAL_200_CA },
         { "210%",          OPTION_VAL_210_CA },
         { "220%",          OPTION_VAL_220_CA },
         { "230%",          OPTION_VAL_230_CA },
         { "240%",          OPTION_VAL_240_CA },
         { "250%",          OPTION_VAL_250_CA },
         { "260%",          OPTION_VAL_260_CA },
         { "270%",          OPTION_VAL_270_CA },
         { "280%",          OPTION_VAL_280_CA },
         { "290%",          OPTION_VAL_290_CA },
         { "300%",          OPTION_VAL_300_CA },
         { "310%",          OPTION_VAL_310_CA },
         { "320%",          OPTION_VAL_320_CA },
         { "330%",          OPTION_VAL_330_CA },
         { "340%",          OPTION_VAL_340_CA },
         { "350%",          OPTION_VAL_350_CA },
         { "360%",          OPTION_VAL_360_CA },
         { "370%",          OPTION_VAL_370_CA },
         { "380%",          OPTION_VAL_380_CA },
         { "390%",          OPTION_VAL_390_CA },
         { "400%",          OPTION_VAL_400_CA },
         { "410%",          OPTION_VAL_410_CA },
         { "420%",          OPTION_VAL_420_CA },
         { "430%",          OPTION_VAL_430_CA },
         { "440%",          OPTION_VAL_440_CA },
         { "450%",          OPTION_VAL_450_CA },
         { "460%",          OPTION_VAL_460_CA },
         { "470%",          OPTION_VAL_470_CA },
         { "480%",          OPTION_VAL_480_CA },
         { "490%",          OPTION_VAL_490_CA },
         { "500%",          OPTION_VAL_500_CA },
         { "510%",          OPTION_VAL_510_CA },
         { "520%",          OPTION_VAL_520_CA },
         { "530%",          OPTION_VAL_530_CA },
         { "540%",          OPTION_VAL_540_CA },
         { "550%",          OPTION_VAL_550_CA },
         { "560%",          OPTION_VAL_560_CA },
         { "570%",          OPTION_VAL_570_CA },
         { "580%",          OPTION_VAL_580_CA },
         { "590%",          OPTION_VAL_590_CA },
         { "600%",          OPTION_VAL_600_CA },
         { "610%",          OPTION_VAL_610_CA },
         { "620%",          OPTION_VAL_620_CA },
         { "630%",          OPTION_VAL_630_CA },
         { "640%",          OPTION_VAL_640_CA },
         { "650%",          OPTION_VAL_650_CA },
         { "660%",          OPTION_VAL_660_CA },
         { "670%",          OPTION_VAL_670_CA },
         { "680%",          OPTION_VAL_680_CA },
         { "690%",          OPTION_VAL_690_CA },
         { "700%",          OPTION_VAL_700_CA },
         { "710%",          OPTION_VAL_710_CA },
         { "720%",          OPTION_VAL_720_CA },
         { "730%",          OPTION_VAL_730_CA },
         { "740%",          OPTION_VAL_740_CA },
         { "750%",          OPTION_VAL_750_CA },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_CA,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_CA,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_CA,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_CA,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_CA,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_CA,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_CA },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_CA },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_CA,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_CA,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_CA },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_CA },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_CA },
#endif
         { "software",    OPTION_VAL_SOFTWARE_CA },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_CA,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_CA,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_CA,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_CA,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_CA },
         { "execute",  OPTION_VAL_EXECUTE_CA },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_CA },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_CA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_CA,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_CA,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_CA },
         { "dma",  OPTION_VAL_DMA_CA },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_CA,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_CA,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_CA,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_CA,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_CA },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_CA },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_CA },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_CA,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_CA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_CA,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_CA,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_CA },
         { "static",  OPTION_VAL_STATIC_CA },
         { "smart", OPTION_VAL_SMART_CA },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_CA,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_CA,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_CA },
         { "2px",      OPTION_VAL_2PX_CA },
         { "3px",      OPTION_VAL_3PX_CA },
         { "4px",      OPTION_VAL_4PX_CA },
         { "5px",      OPTION_VAL_5PX_CA },
         { "6px",      OPTION_VAL_6PX_CA },
         { "7px",      OPTION_VAL_7PX_CA },
         { "8px",      OPTION_VAL_8PX_CA },
         { "9px",      OPTION_VAL_9PX_CA },
         { "10px",     OPTION_VAL_10PX_CA },
         { "11px",     OPTION_VAL_11PX_CA },
         { "12px",     OPTION_VAL_12PX_CA },
         { "13px",     OPTION_VAL_13PX_CA },
         { "14px",     OPTION_VAL_14PX_CA },
         { "15px",     OPTION_VAL_15PX_CA },
         { "16px",     OPTION_VAL_16PX_CA },
         { "17px",     OPTION_VAL_17PX_CA },
         { "18px",     OPTION_VAL_18PX_CA },
         { "19px",     OPTION_VAL_19PX_CA },
         { "20px",     OPTION_VAL_20PX_CA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_CA,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_CA,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_CA },
         { "-11px",    OPTION_VAL_11PX_O55_CA },
         { "-10px",    OPTION_VAL_10PX_O55_CA },
         { "-9px",     OPTION_VAL_9PX_O55_CA },
         { "-8px",     OPTION_VAL_8PX_O55_CA },
         { "-7px",     OPTION_VAL_7PX_O55_CA },
         { "-6px",     OPTION_VAL_6PX_O55_CA },
         { "-5px",     OPTION_VAL_5PX_O55_CA },
         { "-4px",     OPTION_VAL_4PX_O55_CA },
         { "-3px",     OPTION_VAL_3PX_O55_CA },
         { "-2px",     OPTION_VAL_2PX_O55_CA },
         { "-1px",     OPTION_VAL_1PX_O55_CA },
         { "disabled", OPTION_VAL_DISABLED_O55_CA },
         { "+1px",     OPTION_VAL_1PX_O55_0_CA },
         { "+2px",     OPTION_VAL_2PX_O55_0_CA },
         { "+3px",     OPTION_VAL_3PX_O55_0_CA },
         { "+4px",     OPTION_VAL_4PX_O55_0_CA },
         { "+5px",     OPTION_VAL_5PX_O55_0_CA },
         { "+6px",     OPTION_VAL_6PX_O55_0_CA },
         { "+7px",     OPTION_VAL_7PX_O55_0_CA },
         { "+8px",     OPTION_VAL_8PX_O55_0_CA },
         { "+9px",     OPTION_VAL_9PX_O55_0_CA },
         { "+10px",    OPTION_VAL_10PX_O55_0_CA },
         { "+11px",    OPTION_VAL_11PX_O55_0_CA },
         { "+12px",    OPTION_VAL_12PX_O55_0_CA },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_CA,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_CA,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_CA },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_CA,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_CA,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_CA },
         { "2x",         OPTION_VAL_2X_CA },
         { "4x",         OPTION_VAL_4X_CA },
         { "8x",         OPTION_VAL_8X_CA },
         { "16x",        OPTION_VAL_16X_CA },
         { "32x",        OPTION_VAL_32X_CA },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_CA,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_CA,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_CA },
         { "uncorrected", OPTION_VAL_UNCORRECTED_CA },
         { "4:3",  OPTION_VAL_4_3_CA },
         { "ntsc", OPTION_VAL_NTSC_CA },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_CA,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_CA,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_CA,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_CA,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_CA },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_CA,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_CA,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_CA,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_CA,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_CA },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_CA,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_CA,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_CA },
         { "async",    OPTION_VAL_ASYNC_CA },
         { "precache", OPTION_VAL_PRECACHE_CA },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_CA,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_CA,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_CA },
         { "4x",          OPTION_VAL_4X_CA },
         { "6x",          OPTION_VAL_6X_CA },
         { "8x",          OPTION_VAL_8X_CA },
         { "10x",         OPTION_VAL_10X_CA },
         { "12x",         OPTION_VAL_12X_CA },
         { "14x",         OPTION_VAL_14X_CA },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_ca = {
   option_cats_ca,
   option_defs_ca
};

/* RETRO_LANGUAGE_CHS */

#define CATEGORY_VIDEO_LABEL_CHS "视频"
#define CATEGORY_VIDEO_INFO_0_CHS "更改长宽比、显示裁剪、视频过滤和帧跳过设置。"
#define CATEGORY_OSD_LABEL_CHS "屏幕通知"
#define CATEGORY_OSD_INFO_0_CHS NULL
#define CATEGORY_INPUT_LABEL_CHS "输入"
#define CATEGORY_INPUT_INFO_0_CHS NULL
#define CATEGORY_MEMCARDS_LABEL_CHS "内存卡"
#define CATEGORY_MEMCARDS_INFO_0_CHS NULL
#define CATEGORY_PGXP_LABEL_CHS "PGXP (几何变换管道)"
#define CATEGORY_PGXP_INFO_0_CHS "这些选项控制增强，可以改进图形与原始控制台相比。PGXP可以消除弹形图和 Z-战斗问题。"
#define CATEGORY_HACKS_LABEL_CHS "模拟修改"
#define CATEGORY_HACKS_INFO_0_CHS NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_CHS "内部GPU分辨率"
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_CHS NULL
#define OPTION_VAL_1X_NATIVE_CHS "1x (原始)"
#define OPTION_VAL_2X_CHS "2 倍"
#define OPTION_VAL_4X_CHS "4 倍"
#define OPTION_VAL_8X_CHS "8 倍"
#define OPTION_VAL_16X_CHS "16 倍"
#define BEETLE_OPT_DEPTH_LABEL_CHS "内部色深度"
#define BEETLE_OPT_DEPTH_INFO_0_CHS NULL
#define OPTION_VAL_16BPP_NATIVE_CHS "16位像素(原始)"
#define OPTION_VAL_32BPP_CHS "32位像素"
#define BEETLE_OPT_DITHER_MODE_LABEL_CHS "抖动模式"
#define BEETLE_OPT_DITHER_MODE_INFO_0_CHS NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_CHS "内部分辨率"
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_CHS "纹理紫外线偏移"
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_CHS NULL
#define BEETLE_OPT_FILTER_LABEL_CHS "纹理过滤"
#define BEETLE_OPT_FILTER_INFO_0_CHS NULL
#define OPTION_VAL_NEAREST_CHS "最近的"
#define OPTION_VAL_SABR_CHS NULL
#define OPTION_VAL_XBR_CHS NULL
#define OPTION_VAL_BILINEAR_CHS "双线性"
#define OPTION_VAL_3_POINT_CHS "3 点"
#define OPTION_VAL_JINC2_CHS NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_CHS "从过滤中排除素材"
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_CHS NULL
#define OPTION_VAL_OPAQUE_CHS "仅不透明度"
#define OPTION_VAL_ALL_CHS "不透明和半透明度"
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_CHS "排除筛选中的 2D 多边形"
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_CHS "不要将纹理过滤器应用到2D多边形。检测到2D多边形带有激发性，可能会有眼镜。 与自适应平滑或其他后处理过滤器一起使用以获取最佳效果。"
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_CHS "自适应平滑化"
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_CHS NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_CHS "超大(从样本到原生分辨率)"
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_CHS NULL
#define BEETLE_OPT_MSAA_LABEL_CHS "多重采样抗锯齿轮模式"
#define BEETLE_OPT_MSAA_INFO_0_CHS NULL
#define OPTION_VAL_1X_CHS NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_CHS NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_CHS NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_CHS NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_CHS NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_CHS NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_CHS NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_CHS NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_CHS NULL
#define BEETLE_OPT_WIREFRAME_LABEL_CHS NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_CHS NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_CHS NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_CHS NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_CHS NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_CHS NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_CHS NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_CHS NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_CHS NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_CHS NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_CHS NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_CHS NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_CHS NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_CHS NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_CHS NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_CHS NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_CHS NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_CHS NULL
#define OPTION_VAL_LIGHTGUN_CHS NULL
#define OPTION_VAL_TOUCHSCREEN_CHS NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_CHS NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_CHS NULL
#define OPTION_VAL_CROSS_CHS "叉"
#define OPTION_VAL_DOT_CHS "点"
#define OPTION_VAL_OFF_CHS "无光标"
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_CHS NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_CHS NULL
#define OPTION_VAL_RED_CHS "红色"
#define OPTION_VAL_BLUE_CHS "蓝色"
#define OPTION_VAL_GREEN_CHS "绿色"
#define OPTION_VAL_ORANGE_CHS "奥朗日"
#define OPTION_VAL_YELLOW_CHS "黄色"
#define OPTION_VAL_CYAN_CHS "青色"
#define OPTION_VAL_PINK_CHS "粉"
#define OPTION_VAL_PURPLE_CHS "紫色"
#define OPTION_VAL_BLACK_CHS "浓体 (Black)"
#define OPTION_VAL_WHITE_CHS "白色"
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_CHS NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_CHS NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_CHS "鼠标灵敏度"
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_CHS NULL
#define OPTION_VAL_5_CHS NULL
#define OPTION_VAL_10_CHS NULL
#define OPTION_VAL_15_CHS NULL
#define OPTION_VAL_20_CHS NULL
#define OPTION_VAL_25_CHS NULL
#define OPTION_VAL_30_CHS NULL
#define OPTION_VAL_35_CHS NULL
#define OPTION_VAL_40_CHS NULL
#define OPTION_VAL_45_CHS NULL
#define OPTION_VAL_50_CHS NULL
#define OPTION_VAL_55_CHS NULL
#define OPTION_VAL_60_CHS NULL
#define OPTION_VAL_65_CHS NULL
#define OPTION_VAL_70_CHS NULL
#define OPTION_VAL_75_CHS NULL
#define OPTION_VAL_80_CHS NULL
#define OPTION_VAL_85_CHS NULL
#define OPTION_VAL_90_CHS NULL
#define OPTION_VAL_95_CHS NULL
#define OPTION_VAL_100_CHS NULL
#define OPTION_VAL_105_CHS NULL
#define OPTION_VAL_110_CHS NULL
#define OPTION_VAL_115_CHS NULL
#define OPTION_VAL_120_CHS NULL
#define OPTION_VAL_125_CHS NULL
#define OPTION_VAL_130_CHS NULL
#define OPTION_VAL_135_CHS NULL
#define OPTION_VAL_140_CHS NULL
#define OPTION_VAL_145_CHS NULL
#define OPTION_VAL_150_CHS NULL
#define OPTION_VAL_155_CHS NULL
#define OPTION_VAL_160_CHS NULL
#define OPTION_VAL_165_CHS NULL
#define OPTION_VAL_170_CHS NULL
#define OPTION_VAL_175_CHS NULL
#define OPTION_VAL_180_CHS NULL
#define OPTION_VAL_185_CHS NULL
#define OPTION_VAL_190_CHS NULL
#define OPTION_VAL_195_CHS NULL
#define OPTION_VAL_200_CHS NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_CHS NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_CHS NULL
#define OPTION_VAL_LINEAR_CHS "线性"
#define OPTION_VAL_QUADRATIC_CHS "平方"
#define OPTION_VAL_CUBIC_CHS "立方"
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_CHS NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_CHS NULL
#define OPTION_VAL_0_CHS NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_CHS "内存卡 0 操作(需要重启)"
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_CHS "选择用于内存卡0的保存数据格式。“Mednafen”可以用于兼容独立版Mednafen。 当和 Beetle PSX使用时，Libretro (.srm) 和 Mednafen (.mcr) 保存具有内部相同的格式，可以通过重命名相互转换。"
#define OPTION_VAL_LIBRETRO_CHS NULL
#define OPTION_VAL_MEDNAFEN_CHS NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_CHS "启用内存卡 1 (需要重启)"
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_CHS NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_CHS "共享内存卡(需要重启)"
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_CHS "如果启用，所有游戏都将保存并从相同的内存卡文件中加载。 当禁用时，将为已加载的每个内容生成单独的内存卡文件。 注意：如果“内存卡0方法”设置为“Libret”，只有正确的内存卡会受到影响。"
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_CHS "内存卡左边索引"
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_CHS NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_CHS NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_CHS NULL
#define OPTION_VAL_1_CHS NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_CHS NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_CHS NULL
#define OPTION_VAL_MEMORY_ONLY_CHS NULL
#define OPTION_VAL_MEMORY_CPU_CHS NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_CHS NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_CHS NULL
#define OPTION_VAL_0PX_CHS NULL
#define OPTION_VAL_1PX_CHS NULL
#define OPTION_VAL_2PX_CHS NULL
#define OPTION_VAL_3PX_CHS NULL
#define OPTION_VAL_4PX_CHS NULL
#define OPTION_VAL_5PX_CHS NULL
#define OPTION_VAL_6PX_CHS NULL
#define OPTION_VAL_7PX_CHS NULL
#define OPTION_VAL_8PX_CHS NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_CHS NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_CHS NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_CHS NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_CHS NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_CHS NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_CHS NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_CHS NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_CHS NULL
#define OPTION_VAL_DEFAULT_CHS "默认"
#define OPTION_VAL_AGGRESSIVE_CHS "激进"
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_CHS NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_CHS NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_CHS NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_CHS NULL
#define OPTION_VAL_16_9_CHS NULL
#define OPTION_VAL_16_10_CHS NULL
#define OPTION_VAL_18_9_CHS NULL
#define OPTION_VAL_19_9_CHS NULL
#define OPTION_VAL_20_9_CHS NULL
#define OPTION_VAL_21_9_CHS NULL
#define OPTION_VAL_32_9_CHS NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_CHS NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_CHS NULL
#define OPTION_VAL_100_NATIVE_CHS NULL
#define OPTION_VAL_210_CHS NULL
#define OPTION_VAL_220_CHS NULL
#define OPTION_VAL_230_CHS NULL
#define OPTION_VAL_240_CHS NULL
#define OPTION_VAL_250_CHS NULL
#define OPTION_VAL_260_CHS NULL
#define OPTION_VAL_270_CHS NULL
#define OPTION_VAL_280_CHS NULL
#define OPTION_VAL_290_CHS NULL
#define OPTION_VAL_300_CHS NULL
#define OPTION_VAL_310_CHS NULL
#define OPTION_VAL_320_CHS NULL
#define OPTION_VAL_330_CHS NULL
#define OPTION_VAL_340_CHS NULL
#define OPTION_VAL_350_CHS NULL
#define OPTION_VAL_360_CHS NULL
#define OPTION_VAL_370_CHS NULL
#define OPTION_VAL_380_CHS NULL
#define OPTION_VAL_390_CHS NULL
#define OPTION_VAL_400_CHS NULL
#define OPTION_VAL_410_CHS NULL
#define OPTION_VAL_420_CHS NULL
#define OPTION_VAL_430_CHS NULL
#define OPTION_VAL_440_CHS NULL
#define OPTION_VAL_450_CHS NULL
#define OPTION_VAL_460_CHS NULL
#define OPTION_VAL_470_CHS NULL
#define OPTION_VAL_480_CHS NULL
#define OPTION_VAL_490_CHS NULL
#define OPTION_VAL_500_CHS NULL
#define OPTION_VAL_510_CHS NULL
#define OPTION_VAL_520_CHS NULL
#define OPTION_VAL_530_CHS NULL
#define OPTION_VAL_540_CHS NULL
#define OPTION_VAL_550_CHS NULL
#define OPTION_VAL_560_CHS NULL
#define OPTION_VAL_570_CHS NULL
#define OPTION_VAL_580_CHS NULL
#define OPTION_VAL_590_CHS NULL
#define OPTION_VAL_600_CHS NULL
#define OPTION_VAL_610_CHS NULL
#define OPTION_VAL_620_CHS NULL
#define OPTION_VAL_630_CHS NULL
#define OPTION_VAL_640_CHS NULL
#define OPTION_VAL_650_CHS NULL
#define OPTION_VAL_660_CHS NULL
#define OPTION_VAL_670_CHS NULL
#define OPTION_VAL_680_CHS NULL
#define OPTION_VAL_690_CHS NULL
#define OPTION_VAL_700_CHS NULL
#define OPTION_VAL_710_CHS NULL
#define OPTION_VAL_720_CHS NULL
#define OPTION_VAL_730_CHS NULL
#define OPTION_VAL_740_CHS NULL
#define OPTION_VAL_750_CHS NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_CHS NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_CHS NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_CHS NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_CHS NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_CHS NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_CHS NULL
#define OPTION_VAL_PSXONPSP_CHS NULL
#define OPTION_VAL_PS1_ROM_CHS NULL
#define BEETLE_OPT_RENDERER_LABEL_CHS NULL
#define BEETLE_OPT_RENDERER_INFO_0_CHS NULL
#define OPTION_VAL_HARDWARE_CHS NULL
#define OPTION_VAL_HARDWARE_GL_CHS NULL
#define OPTION_VAL_HARDWARE_VK_CHS NULL
#define OPTION_VAL_SOFTWARE_CHS "软件"
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_CHS NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_CHS NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_CHS NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_CHS NULL
#define OPTION_VAL_DISABLED_CHS NULL
#define OPTION_VAL_EXECUTE_CHS NULL
#define OPTION_VAL_EXECUTE_ONE_CHS NULL
#define OPTION_VAL_RUN_INTERPRETER_CHS NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_CHS NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_CHS NULL
#define OPTION_VAL_FULL_CHS "全双工"
#define OPTION_VAL_DMA_CHS NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_CHS NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_CHS NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_CHS NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_CHS NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_CHS NULL
#define OPTION_VAL_FORCE_INTERLACED_CHS NULL
#define OPTION_VAL_AUTO_TOGGLE_CHS NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_CHS NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_CHS NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_CHS NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_CHS NULL
#define OPTION_VAL_DISABLED_O53_CHS "无"
#define OPTION_VAL_STATIC_CHS "静态"
#define OPTION_VAL_SMART_CHS NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_CHS NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_CHS NULL
#define OPTION_VAL_9PX_CHS NULL
#define OPTION_VAL_10PX_CHS NULL
#define OPTION_VAL_11PX_CHS NULL
#define OPTION_VAL_12PX_CHS NULL
#define OPTION_VAL_13PX_CHS NULL
#define OPTION_VAL_14PX_CHS NULL
#define OPTION_VAL_15PX_CHS NULL
#define OPTION_VAL_16PX_CHS NULL
#define OPTION_VAL_17PX_CHS NULL
#define OPTION_VAL_18PX_CHS NULL
#define OPTION_VAL_19PX_CHS NULL
#define OPTION_VAL_20PX_CHS NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_CHS NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_CHS NULL
#define OPTION_VAL_12PX_O55_CHS NULL
#define OPTION_VAL_11PX_O55_CHS NULL
#define OPTION_VAL_10PX_O55_CHS NULL
#define OPTION_VAL_9PX_O55_CHS NULL
#define OPTION_VAL_8PX_O55_CHS NULL
#define OPTION_VAL_7PX_O55_CHS NULL
#define OPTION_VAL_6PX_O55_CHS NULL
#define OPTION_VAL_5PX_O55_CHS NULL
#define OPTION_VAL_4PX_O55_CHS NULL
#define OPTION_VAL_3PX_O55_CHS NULL
#define OPTION_VAL_2PX_O55_CHS NULL
#define OPTION_VAL_1PX_O55_CHS NULL
#define OPTION_VAL_DISABLED_O55_CHS "0 (默认)"
#define OPTION_VAL_1PX_O55_0_CHS NULL
#define OPTION_VAL_2PX_O55_0_CHS NULL
#define OPTION_VAL_3PX_O55_0_CHS NULL
#define OPTION_VAL_4PX_O55_0_CHS NULL
#define OPTION_VAL_5PX_O55_0_CHS NULL
#define OPTION_VAL_6PX_O55_0_CHS NULL
#define OPTION_VAL_7PX_O55_0_CHS NULL
#define OPTION_VAL_8PX_O55_0_CHS NULL
#define OPTION_VAL_9PX_O55_0_CHS NULL
#define OPTION_VAL_10PX_O55_0_CHS NULL
#define OPTION_VAL_11PX_O55_0_CHS NULL
#define OPTION_VAL_12PX_O55_0_CHS NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_CHS NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_CHS NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_CHS NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_CHS NULL
#define OPTION_VAL_32X_CHS NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_CHS NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_CHS NULL
#define OPTION_VAL_CORRECTED_CHS NULL
#define OPTION_VAL_UNCORRECTED_CHS NULL
#define OPTION_VAL_4_3_CHS NULL
#define OPTION_VAL_NTSC_CHS NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_CHS NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_CHS NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_CHS NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_CHS NULL
#define OPTION_VAL_239_CHS "239 (默认)"
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_CHS NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_CHS NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_CHS NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_CHS NULL
#define OPTION_VAL_287_CHS "287 (默认)"
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_CHS NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_CHS NULL
#define OPTION_VAL_SYNC_CHS NULL
#define OPTION_VAL_ASYNC_CHS NULL
#define OPTION_VAL_PRECACHE_CHS NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_CHS NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_CHS NULL
#define OPTION_VAL_2X_NATIVE_CHS NULL
#define OPTION_VAL_6X_CHS NULL
#define OPTION_VAL_10X_CHS NULL
#define OPTION_VAL_12X_CHS NULL
#define OPTION_VAL_14X_CHS NULL

struct retro_core_option_v2_category option_cats_chs[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_CHS,
      CATEGORY_VIDEO_INFO_0_CHS
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_CHS,
      CATEGORY_OSD_INFO_0_CHS
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_CHS,
      CATEGORY_INPUT_INFO_0_CHS
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_CHS,
      CATEGORY_MEMCARDS_INFO_0_CHS
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_CHS,
      CATEGORY_PGXP_INFO_0_CHS
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_CHS,
      CATEGORY_HACKS_INFO_0_CHS
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_chs[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_CHS,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_CHS,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_CHS },
         { "2x",         OPTION_VAL_2X_CHS },
         { "4x",         OPTION_VAL_4X_CHS },
         { "8x",         OPTION_VAL_8X_CHS },
         { "16x",        OPTION_VAL_16X_CHS },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_CHS,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_CHS,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_CHS },
         { "32bpp",         OPTION_VAL_32BPP_CHS },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_CHS,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_CHS,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_CHS },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_CHS },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_CHS,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_CHS,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_CHS,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_CHS,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_CHS },
         { "SABR",     OPTION_VAL_SABR_CHS },
         { "xBR",      OPTION_VAL_XBR_CHS },
         { "bilinear", OPTION_VAL_BILINEAR_CHS },
         { "3-point",  OPTION_VAL_3_POINT_CHS },
         { "JINC2",    OPTION_VAL_JINC2_CHS },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_CHS,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_CHS,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_CHS },
         { "all", OPTION_VAL_ALL_CHS },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_CHS,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_CHS,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_CHS },
         { "all", OPTION_VAL_ALL_CHS },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_CHS,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_CHS,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_CHS,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_CHS,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_CHS,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_CHS,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_CHS },
         { "2x",  OPTION_VAL_2X_CHS },
         { "4x",  OPTION_VAL_4X_CHS },
         { "8x",  OPTION_VAL_8X_CHS },
         { "16x", OPTION_VAL_16X_CHS },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_CHS,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_CHS,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_CHS,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_CHS,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_CHS,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_CHS,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_CHS,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_CHS,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_CHS,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_CHS,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_CHS,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_CHS,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_CHS,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_CHS,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_CHS,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_CHS,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_CHS,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_CHS,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_CHS,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_CHS,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_CHS,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_CHS,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_CHS,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_CHS,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_CHS,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_CHS,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_CHS },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_CHS },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_CHS,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_CHS,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_CHS },
         { "dot",   OPTION_VAL_DOT_CHS },
         { "off",   OPTION_VAL_OFF_CHS },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_CHS,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_CHS,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_CHS },
         { "blue", OPTION_VAL_BLUE_CHS },
         { "green", OPTION_VAL_GREEN_CHS },
         { "orange", OPTION_VAL_ORANGE_CHS },
         { "yellow", OPTION_VAL_YELLOW_CHS },
         { "cyan", OPTION_VAL_CYAN_CHS },
         { "pink", OPTION_VAL_PINK_CHS },
         { "purple", OPTION_VAL_PURPLE_CHS },
         { "black", OPTION_VAL_BLACK_CHS },
         { "white", OPTION_VAL_WHITE_CHS },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_CHS,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_CHS,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_CHS },
         { "red", OPTION_VAL_RED_CHS },
         { "green", OPTION_VAL_GREEN_CHS },
         { "orange", OPTION_VAL_ORANGE_CHS },
         { "yellow", OPTION_VAL_YELLOW_CHS },
         { "cyan", OPTION_VAL_CYAN_CHS },
         { "pink", OPTION_VAL_PINK_CHS },
         { "purple", OPTION_VAL_PURPLE_CHS },
         { "black", OPTION_VAL_BLACK_CHS },
         { "white", OPTION_VAL_WHITE_CHS },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_CHS,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_CHS,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_CHS },
         { "10%",  OPTION_VAL_10_CHS },
         { "15%",  OPTION_VAL_15_CHS },
         { "20%",  OPTION_VAL_20_CHS },
         { "25%",  OPTION_VAL_25_CHS },
         { "30%",  OPTION_VAL_30_CHS },
         { "35%",  OPTION_VAL_35_CHS },
         { "40%",  OPTION_VAL_40_CHS },
         { "45%",  OPTION_VAL_45_CHS },
         { "50%",  OPTION_VAL_50_CHS },
         { "55%",  OPTION_VAL_55_CHS },
         { "60%",  OPTION_VAL_60_CHS },
         { "65%",  OPTION_VAL_65_CHS },
         { "70%",  OPTION_VAL_70_CHS },
         { "75%",  OPTION_VAL_75_CHS },
         { "80%",  OPTION_VAL_80_CHS },
         { "85%",  OPTION_VAL_85_CHS },
         { "90%",  OPTION_VAL_90_CHS },
         { "95%",  OPTION_VAL_95_CHS },
         { "100%", OPTION_VAL_100_CHS },
         { "105%", OPTION_VAL_105_CHS },
         { "110%", OPTION_VAL_110_CHS },
         { "115%", OPTION_VAL_115_CHS },
         { "120%", OPTION_VAL_120_CHS },
         { "125%", OPTION_VAL_125_CHS },
         { "130%", OPTION_VAL_130_CHS },
         { "135%", OPTION_VAL_135_CHS },
         { "140%", OPTION_VAL_140_CHS },
         { "145%", OPTION_VAL_145_CHS },
         { "150%", OPTION_VAL_150_CHS },
         { "155%", OPTION_VAL_155_CHS },
         { "160%", OPTION_VAL_160_CHS },
         { "165%", OPTION_VAL_165_CHS },
         { "170%", OPTION_VAL_170_CHS },
         { "175%", OPTION_VAL_175_CHS },
         { "180%", OPTION_VAL_180_CHS },
         { "185%", OPTION_VAL_185_CHS },
         { "190%", OPTION_VAL_190_CHS },
         { "195%", OPTION_VAL_195_CHS },
         { "200%", OPTION_VAL_200_CHS },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_CHS,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_CHS,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_CHS },
         { "quadratic", OPTION_VAL_QUADRATIC_CHS },
         { "cubic",     OPTION_VAL_CUBIC_CHS },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_CHS,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_CHS,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_CHS },
         { "5%",  OPTION_VAL_5_CHS },
         { "10%", OPTION_VAL_10_CHS },
         { "15%", OPTION_VAL_15_CHS },
         { "20%", OPTION_VAL_20_CHS },
         { "25%", OPTION_VAL_25_CHS },
         { "30%", OPTION_VAL_30_CHS },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_CHS,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_CHS,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_CHS },
         { "mednafen", OPTION_VAL_MEDNAFEN_CHS },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_CHS,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_CHS,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_CHS,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_CHS,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_CHS,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_CHS,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_CHS,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_CHS,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_CHS },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_CHS,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_CHS,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_CHS },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_CHS },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_CHS,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_CHS,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_CHS },
         { "1px", OPTION_VAL_1PX_CHS },
         { "2px", OPTION_VAL_2PX_CHS },
         { "3px", OPTION_VAL_3PX_CHS },
         { "4px", OPTION_VAL_4PX_CHS },
         { "5px", OPTION_VAL_5PX_CHS },
         { "6px", OPTION_VAL_6PX_CHS },
         { "7px", OPTION_VAL_7PX_CHS },
         { "8px", OPTION_VAL_8PX_CHS },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_CHS,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_CHS,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_CHS,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_CHS,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_CHS,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_CHS,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_CHS,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_CHS,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_CHS },
         { "aggressive", OPTION_VAL_AGGRESSIVE_CHS },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_CHS,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_CHS,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_CHS,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_CHS,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_CHS },
         { "16:10", OPTION_VAL_16_10_CHS },
         { "18:9",  OPTION_VAL_18_9_CHS },
         { "19:9",  OPTION_VAL_19_9_CHS },
         { "20:9",  OPTION_VAL_20_9_CHS },
         { "21:9",  OPTION_VAL_21_9_CHS }, // 64:27
         { "32:9",  OPTION_VAL_32_9_CHS },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_CHS,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_CHS,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_CHS },
         { "60%",           OPTION_VAL_60_CHS },
         { "70%",           OPTION_VAL_70_CHS },
         { "80%",           OPTION_VAL_80_CHS },
         { "90%",           OPTION_VAL_90_CHS },
         { "100%(native)", OPTION_VAL_100_NATIVE_CHS },
         { "110%",          OPTION_VAL_110_CHS },
         { "120%",          OPTION_VAL_120_CHS },
         { "130%",          OPTION_VAL_130_CHS },
         { "140%",          OPTION_VAL_140_CHS },
         { "150%",          OPTION_VAL_150_CHS },
         { "160%",          OPTION_VAL_160_CHS },
         { "170%",          OPTION_VAL_170_CHS },
         { "180%",          OPTION_VAL_180_CHS },
         { "190%",          OPTION_VAL_190_CHS },
         { "200%",          OPTION_VAL_200_CHS },
         { "210%",          OPTION_VAL_210_CHS },
         { "220%",          OPTION_VAL_220_CHS },
         { "230%",          OPTION_VAL_230_CHS },
         { "240%",          OPTION_VAL_240_CHS },
         { "250%",          OPTION_VAL_250_CHS },
         { "260%",          OPTION_VAL_260_CHS },
         { "270%",          OPTION_VAL_270_CHS },
         { "280%",          OPTION_VAL_280_CHS },
         { "290%",          OPTION_VAL_290_CHS },
         { "300%",          OPTION_VAL_300_CHS },
         { "310%",          OPTION_VAL_310_CHS },
         { "320%",          OPTION_VAL_320_CHS },
         { "330%",          OPTION_VAL_330_CHS },
         { "340%",          OPTION_VAL_340_CHS },
         { "350%",          OPTION_VAL_350_CHS },
         { "360%",          OPTION_VAL_360_CHS },
         { "370%",          OPTION_VAL_370_CHS },
         { "380%",          OPTION_VAL_380_CHS },
         { "390%",          OPTION_VAL_390_CHS },
         { "400%",          OPTION_VAL_400_CHS },
         { "410%",          OPTION_VAL_410_CHS },
         { "420%",          OPTION_VAL_420_CHS },
         { "430%",          OPTION_VAL_430_CHS },
         { "440%",          OPTION_VAL_440_CHS },
         { "450%",          OPTION_VAL_450_CHS },
         { "460%",          OPTION_VAL_460_CHS },
         { "470%",          OPTION_VAL_470_CHS },
         { "480%",          OPTION_VAL_480_CHS },
         { "490%",          OPTION_VAL_490_CHS },
         { "500%",          OPTION_VAL_500_CHS },
         { "510%",          OPTION_VAL_510_CHS },
         { "520%",          OPTION_VAL_520_CHS },
         { "530%",          OPTION_VAL_530_CHS },
         { "540%",          OPTION_VAL_540_CHS },
         { "550%",          OPTION_VAL_550_CHS },
         { "560%",          OPTION_VAL_560_CHS },
         { "570%",          OPTION_VAL_570_CHS },
         { "580%",          OPTION_VAL_580_CHS },
         { "590%",          OPTION_VAL_590_CHS },
         { "600%",          OPTION_VAL_600_CHS },
         { "610%",          OPTION_VAL_610_CHS },
         { "620%",          OPTION_VAL_620_CHS },
         { "630%",          OPTION_VAL_630_CHS },
         { "640%",          OPTION_VAL_640_CHS },
         { "650%",          OPTION_VAL_650_CHS },
         { "660%",          OPTION_VAL_660_CHS },
         { "670%",          OPTION_VAL_670_CHS },
         { "680%",          OPTION_VAL_680_CHS },
         { "690%",          OPTION_VAL_690_CHS },
         { "700%",          OPTION_VAL_700_CHS },
         { "710%",          OPTION_VAL_710_CHS },
         { "720%",          OPTION_VAL_720_CHS },
         { "730%",          OPTION_VAL_730_CHS },
         { "740%",          OPTION_VAL_740_CHS },
         { "750%",          OPTION_VAL_750_CHS },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_CHS,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_CHS,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_CHS,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_CHS,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_CHS,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_CHS,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_CHS },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_CHS },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_CHS,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_CHS },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_CHS },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_CHS },
#endif
         { "software",    OPTION_VAL_SOFTWARE_CHS },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_CHS,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_CHS,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_CHS,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_CHS },
         { "execute",  OPTION_VAL_EXECUTE_CHS },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_CHS },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_CHS },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_CHS,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_CHS },
         { "dma",  OPTION_VAL_DMA_CHS },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_CHS,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_CHS,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_CHS },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_CHS },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_CHS },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_CHS,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_CHS,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_CHS,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_CHS,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_CHS },
         { "static",  OPTION_VAL_STATIC_CHS },
         { "smart", OPTION_VAL_SMART_CHS },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_CHS,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_CHS,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_CHS },
         { "2px",      OPTION_VAL_2PX_CHS },
         { "3px",      OPTION_VAL_3PX_CHS },
         { "4px",      OPTION_VAL_4PX_CHS },
         { "5px",      OPTION_VAL_5PX_CHS },
         { "6px",      OPTION_VAL_6PX_CHS },
         { "7px",      OPTION_VAL_7PX_CHS },
         { "8px",      OPTION_VAL_8PX_CHS },
         { "9px",      OPTION_VAL_9PX_CHS },
         { "10px",     OPTION_VAL_10PX_CHS },
         { "11px",     OPTION_VAL_11PX_CHS },
         { "12px",     OPTION_VAL_12PX_CHS },
         { "13px",     OPTION_VAL_13PX_CHS },
         { "14px",     OPTION_VAL_14PX_CHS },
         { "15px",     OPTION_VAL_15PX_CHS },
         { "16px",     OPTION_VAL_16PX_CHS },
         { "17px",     OPTION_VAL_17PX_CHS },
         { "18px",     OPTION_VAL_18PX_CHS },
         { "19px",     OPTION_VAL_19PX_CHS },
         { "20px",     OPTION_VAL_20PX_CHS },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_CHS,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_CHS,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_CHS },
         { "-11px",    OPTION_VAL_11PX_O55_CHS },
         { "-10px",    OPTION_VAL_10PX_O55_CHS },
         { "-9px",     OPTION_VAL_9PX_O55_CHS },
         { "-8px",     OPTION_VAL_8PX_O55_CHS },
         { "-7px",     OPTION_VAL_7PX_O55_CHS },
         { "-6px",     OPTION_VAL_6PX_O55_CHS },
         { "-5px",     OPTION_VAL_5PX_O55_CHS },
         { "-4px",     OPTION_VAL_4PX_O55_CHS },
         { "-3px",     OPTION_VAL_3PX_O55_CHS },
         { "-2px",     OPTION_VAL_2PX_O55_CHS },
         { "-1px",     OPTION_VAL_1PX_O55_CHS },
         { "disabled", OPTION_VAL_DISABLED_O55_CHS },
         { "+1px",     OPTION_VAL_1PX_O55_0_CHS },
         { "+2px",     OPTION_VAL_2PX_O55_0_CHS },
         { "+3px",     OPTION_VAL_3PX_O55_0_CHS },
         { "+4px",     OPTION_VAL_4PX_O55_0_CHS },
         { "+5px",     OPTION_VAL_5PX_O55_0_CHS },
         { "+6px",     OPTION_VAL_6PX_O55_0_CHS },
         { "+7px",     OPTION_VAL_7PX_O55_0_CHS },
         { "+8px",     OPTION_VAL_8PX_O55_0_CHS },
         { "+9px",     OPTION_VAL_9PX_O55_0_CHS },
         { "+10px",    OPTION_VAL_10PX_O55_0_CHS },
         { "+11px",    OPTION_VAL_11PX_O55_0_CHS },
         { "+12px",    OPTION_VAL_12PX_O55_0_CHS },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_CHS,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_CHS,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_CHS },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_CHS,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_CHS,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_CHS },
         { "2x",         OPTION_VAL_2X_CHS },
         { "4x",         OPTION_VAL_4X_CHS },
         { "8x",         OPTION_VAL_8X_CHS },
         { "16x",        OPTION_VAL_16X_CHS },
         { "32x",        OPTION_VAL_32X_CHS },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_CHS,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_CHS,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_CHS },
         { "uncorrected", OPTION_VAL_UNCORRECTED_CHS },
         { "4:3",  OPTION_VAL_4_3_CHS },
         { "ntsc", OPTION_VAL_NTSC_CHS },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_CHS,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_CHS,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_CHS,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_CHS,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_CHS },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_CHS,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_CHS,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_CHS,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_CHS,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_CHS },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_CHS,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_CHS },
         { "async",    OPTION_VAL_ASYNC_CHS },
         { "precache", OPTION_VAL_PRECACHE_CHS },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_CHS,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_CHS },
         { "4x",          OPTION_VAL_4X_CHS },
         { "6x",          OPTION_VAL_6X_CHS },
         { "8x",          OPTION_VAL_8X_CHS },
         { "10x",         OPTION_VAL_10X_CHS },
         { "12x",         OPTION_VAL_12X_CHS },
         { "14x",         OPTION_VAL_14X_CHS },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_chs = {
   option_cats_chs,
   option_defs_chs
};

/* RETRO_LANGUAGE_CHT */

#define CATEGORY_VIDEO_LABEL_CHT "視訊"
#define CATEGORY_VIDEO_INFO_0_CHT "變更長寬比，影像裁切，影像濾鏡以及跳幀設定"
#define CATEGORY_OSD_LABEL_CHT "營幕通知"
#define CATEGORY_OSD_INFO_0_CHT "變更畫面上顯示的通知"
#define CATEGORY_INPUT_LABEL_CHT "輸入"
#define CATEGORY_INPUT_INFO_0_CHT "變更光線槍，滑鼠以及neGcon手把設定"
#define CATEGORY_MEMCARDS_LABEL_CHT "記憶卡"
#define CATEGORY_MEMCARDS_INFO_0_CHT "變更系統所使用的虛擬記憶卡相關設定"
#define CATEGORY_PGXP_LABEL_CHT NULL
#define CATEGORY_PGXP_INFO_0_CHT NULL
#define CATEGORY_HACKS_LABEL_CHT NULL
#define CATEGORY_HACKS_INFO_0_CHT NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_CHT NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_CHT NULL
#define OPTION_VAL_1X_NATIVE_CHT "1x (原生)"
#define OPTION_VAL_2X_CHT NULL
#define OPTION_VAL_4X_CHT NULL
#define OPTION_VAL_8X_CHT NULL
#define OPTION_VAL_16X_CHT NULL
#define BEETLE_OPT_DEPTH_LABEL_CHT "內部色深"
#define BEETLE_OPT_DEPTH_INFO_0_CHT NULL
#define OPTION_VAL_16BPP_NATIVE_CHT "16 bpp (原生)"
#define OPTION_VAL_32BPP_CHT NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_CHT NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_CHT NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_CHT NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_CHT NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_CHT NULL
#define BEETLE_OPT_FILTER_LABEL_CHT "材質過濾"
#define BEETLE_OPT_FILTER_INFO_0_CHT "選擇材質過濾方法。'最接近'模擬原始硬體。'雙線性'以及'3-Point'為平滑過濾，他會透過模糊畫面來減少像素感。'SABR'，'xBR'以及'JINC2'為升級濾鏡，透過更高的效能需求來提升材質還原度/清晰度。只支援硬體渲染。"
#define OPTION_VAL_NEAREST_CHT "最接近"
#define OPTION_VAL_SABR_CHT NULL
#define OPTION_VAL_XBR_CHT NULL
#define OPTION_VAL_BILINEAR_CHT "雙線性插值"
#define OPTION_VAL_3_POINT_CHT NULL
#define OPTION_VAL_JINC2_CHT NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_CHT NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_CHT NULL
#define OPTION_VAL_OPAQUE_CHT "僅限不透明"
#define OPTION_VAL_ALL_CHT "不透明與半透明"
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_CHT NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_CHT "請勿在2D多邊形使用材質過濾。2D多邊形使用啟發法來偵測並可能造成小故障。搭配適應平滑法或其他後期處理濾鏡來達到最佳效果。"
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_CHT NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_CHT NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_CHT "超級取樣 (降採樣至原生解析度)"
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_CHT NULL
#define BEETLE_OPT_MSAA_LABEL_CHT "多重取樣反鋸齒"
#define BEETLE_OPT_MSAA_INFO_0_CHT "選擇渲染內容的MSAA等級。改善3D物件的視覺效果。只支援Vulkan渲染器。"
#define OPTION_VAL_1X_CHT NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_CHT NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_CHT NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_CHT NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_CHT NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_CHT NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_CHT NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_CHT NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_CHT NULL
#define BEETLE_OPT_WIREFRAME_LABEL_CHT NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_CHT NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_CHT NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_CHT NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_CHT NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_CHT NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_CHT NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_CHT NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_CHT NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_CHT NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_CHT NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_CHT NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_CHT NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_CHT NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_CHT NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_CHT NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_CHT NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_CHT NULL
#define OPTION_VAL_LIGHTGUN_CHT "光線槍"
#define OPTION_VAL_TOUCHSCREEN_CHT "觸控螢幕"
#define BEETLE_OPT_GUN_CURSOR_LABEL_CHT NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_CHT NULL
#define OPTION_VAL_CROSS_CHT NULL
#define OPTION_VAL_DOT_CHT NULL
#define OPTION_VAL_OFF_CHT NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_CHT NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_CHT NULL
#define OPTION_VAL_RED_CHT "紅色"
#define OPTION_VAL_BLUE_CHT "藍色"
#define OPTION_VAL_GREEN_CHT "綠色"
#define OPTION_VAL_ORANGE_CHT NULL
#define OPTION_VAL_YELLOW_CHT "黃色"
#define OPTION_VAL_CYAN_CHT NULL
#define OPTION_VAL_PINK_CHT NULL
#define OPTION_VAL_PURPLE_CHT NULL
#define OPTION_VAL_BLACK_CHT NULL
#define OPTION_VAL_WHITE_CHT NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_CHT NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_CHT NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_CHT NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_CHT NULL
#define OPTION_VAL_5_CHT NULL
#define OPTION_VAL_10_CHT NULL
#define OPTION_VAL_15_CHT NULL
#define OPTION_VAL_20_CHT NULL
#define OPTION_VAL_25_CHT NULL
#define OPTION_VAL_30_CHT NULL
#define OPTION_VAL_35_CHT NULL
#define OPTION_VAL_40_CHT NULL
#define OPTION_VAL_45_CHT NULL
#define OPTION_VAL_50_CHT NULL
#define OPTION_VAL_55_CHT NULL
#define OPTION_VAL_60_CHT NULL
#define OPTION_VAL_65_CHT NULL
#define OPTION_VAL_70_CHT NULL
#define OPTION_VAL_75_CHT NULL
#define OPTION_VAL_80_CHT NULL
#define OPTION_VAL_85_CHT NULL
#define OPTION_VAL_90_CHT NULL
#define OPTION_VAL_95_CHT NULL
#define OPTION_VAL_100_CHT NULL
#define OPTION_VAL_105_CHT NULL
#define OPTION_VAL_110_CHT NULL
#define OPTION_VAL_115_CHT NULL
#define OPTION_VAL_120_CHT NULL
#define OPTION_VAL_125_CHT NULL
#define OPTION_VAL_130_CHT NULL
#define OPTION_VAL_135_CHT NULL
#define OPTION_VAL_140_CHT NULL
#define OPTION_VAL_145_CHT NULL
#define OPTION_VAL_150_CHT NULL
#define OPTION_VAL_155_CHT NULL
#define OPTION_VAL_160_CHT NULL
#define OPTION_VAL_165_CHT NULL
#define OPTION_VAL_170_CHT NULL
#define OPTION_VAL_175_CHT NULL
#define OPTION_VAL_180_CHT NULL
#define OPTION_VAL_185_CHT NULL
#define OPTION_VAL_190_CHT NULL
#define OPTION_VAL_195_CHT NULL
#define OPTION_VAL_200_CHT NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_CHT NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_CHT NULL
#define OPTION_VAL_LINEAR_CHT "線性"
#define OPTION_VAL_QUADRATIC_CHT NULL
#define OPTION_VAL_CUBIC_CHT NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_CHT NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_CHT NULL
#define OPTION_VAL_0_CHT NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_CHT NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_CHT NULL
#define OPTION_VAL_LIBRETRO_CHT NULL
#define OPTION_VAL_MEDNAFEN_CHT NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_CHT NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_CHT NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_CHT NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_CHT NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_CHT NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_CHT NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_CHT NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_CHT NULL
#define OPTION_VAL_1_CHT NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_CHT NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_CHT NULL
#define OPTION_VAL_MEMORY_ONLY_CHT NULL
#define OPTION_VAL_MEMORY_CPU_CHT NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_CHT NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_CHT NULL
#define OPTION_VAL_0PX_CHT NULL
#define OPTION_VAL_1PX_CHT NULL
#define OPTION_VAL_2PX_CHT NULL
#define OPTION_VAL_3PX_CHT NULL
#define OPTION_VAL_4PX_CHT NULL
#define OPTION_VAL_5PX_CHT NULL
#define OPTION_VAL_6PX_CHT NULL
#define OPTION_VAL_7PX_CHT NULL
#define OPTION_VAL_8PX_CHT NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_CHT NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_CHT NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_CHT NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_CHT NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_CHT NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_CHT NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_CHT NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_CHT NULL
#define OPTION_VAL_DEFAULT_CHT NULL
#define OPTION_VAL_AGGRESSIVE_CHT NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_CHT NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_CHT NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_CHT NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_CHT NULL
#define OPTION_VAL_16_9_CHT NULL
#define OPTION_VAL_16_10_CHT NULL
#define OPTION_VAL_18_9_CHT NULL
#define OPTION_VAL_19_9_CHT NULL
#define OPTION_VAL_20_9_CHT NULL
#define OPTION_VAL_21_9_CHT NULL
#define OPTION_VAL_32_9_CHT NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_CHT NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_CHT NULL
#define OPTION_VAL_100_NATIVE_CHT NULL
#define OPTION_VAL_210_CHT NULL
#define OPTION_VAL_220_CHT NULL
#define OPTION_VAL_230_CHT NULL
#define OPTION_VAL_240_CHT NULL
#define OPTION_VAL_250_CHT NULL
#define OPTION_VAL_260_CHT NULL
#define OPTION_VAL_270_CHT NULL
#define OPTION_VAL_280_CHT NULL
#define OPTION_VAL_290_CHT NULL
#define OPTION_VAL_300_CHT NULL
#define OPTION_VAL_310_CHT NULL
#define OPTION_VAL_320_CHT NULL
#define OPTION_VAL_330_CHT NULL
#define OPTION_VAL_340_CHT NULL
#define OPTION_VAL_350_CHT NULL
#define OPTION_VAL_360_CHT NULL
#define OPTION_VAL_370_CHT NULL
#define OPTION_VAL_380_CHT NULL
#define OPTION_VAL_390_CHT NULL
#define OPTION_VAL_400_CHT NULL
#define OPTION_VAL_410_CHT NULL
#define OPTION_VAL_420_CHT NULL
#define OPTION_VAL_430_CHT NULL
#define OPTION_VAL_440_CHT NULL
#define OPTION_VAL_450_CHT NULL
#define OPTION_VAL_460_CHT NULL
#define OPTION_VAL_470_CHT NULL
#define OPTION_VAL_480_CHT NULL
#define OPTION_VAL_490_CHT NULL
#define OPTION_VAL_500_CHT NULL
#define OPTION_VAL_510_CHT NULL
#define OPTION_VAL_520_CHT NULL
#define OPTION_VAL_530_CHT NULL
#define OPTION_VAL_540_CHT NULL
#define OPTION_VAL_550_CHT NULL
#define OPTION_VAL_560_CHT NULL
#define OPTION_VAL_570_CHT NULL
#define OPTION_VAL_580_CHT NULL
#define OPTION_VAL_590_CHT NULL
#define OPTION_VAL_600_CHT NULL
#define OPTION_VAL_610_CHT NULL
#define OPTION_VAL_620_CHT NULL
#define OPTION_VAL_630_CHT NULL
#define OPTION_VAL_640_CHT NULL
#define OPTION_VAL_650_CHT NULL
#define OPTION_VAL_660_CHT NULL
#define OPTION_VAL_670_CHT NULL
#define OPTION_VAL_680_CHT NULL
#define OPTION_VAL_690_CHT NULL
#define OPTION_VAL_700_CHT NULL
#define OPTION_VAL_710_CHT NULL
#define OPTION_VAL_720_CHT NULL
#define OPTION_VAL_730_CHT NULL
#define OPTION_VAL_740_CHT NULL
#define OPTION_VAL_750_CHT NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_CHT NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_CHT NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_CHT NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_CHT NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_CHT NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_CHT NULL
#define OPTION_VAL_PSXONPSP_CHT NULL
#define OPTION_VAL_PS1_ROM_CHT NULL
#define BEETLE_OPT_RENDERER_LABEL_CHT NULL
#define BEETLE_OPT_RENDERER_INFO_0_CHT NULL
#define OPTION_VAL_HARDWARE_CHT NULL
#define OPTION_VAL_HARDWARE_GL_CHT NULL
#define OPTION_VAL_HARDWARE_VK_CHT NULL
#define OPTION_VAL_SOFTWARE_CHT NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_CHT NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_CHT NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_CHT NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_CHT NULL
#define OPTION_VAL_DISABLED_CHT NULL
#define OPTION_VAL_EXECUTE_CHT NULL
#define OPTION_VAL_EXECUTE_ONE_CHT NULL
#define OPTION_VAL_RUN_INTERPRETER_CHT NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_CHT NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_CHT NULL
#define OPTION_VAL_FULL_CHT NULL
#define OPTION_VAL_DMA_CHT NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_CHT NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_CHT NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_CHT NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_CHT NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_CHT NULL
#define OPTION_VAL_FORCE_INTERLACED_CHT NULL
#define OPTION_VAL_AUTO_TOGGLE_CHT NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_CHT NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_CHT NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_CHT NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_CHT NULL
#define OPTION_VAL_DISABLED_O53_CHT "無"
#define OPTION_VAL_STATIC_CHT NULL
#define OPTION_VAL_SMART_CHT NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_CHT NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_CHT NULL
#define OPTION_VAL_9PX_CHT NULL
#define OPTION_VAL_10PX_CHT NULL
#define OPTION_VAL_11PX_CHT NULL
#define OPTION_VAL_12PX_CHT NULL
#define OPTION_VAL_13PX_CHT NULL
#define OPTION_VAL_14PX_CHT NULL
#define OPTION_VAL_15PX_CHT NULL
#define OPTION_VAL_16PX_CHT NULL
#define OPTION_VAL_17PX_CHT NULL
#define OPTION_VAL_18PX_CHT NULL
#define OPTION_VAL_19PX_CHT NULL
#define OPTION_VAL_20PX_CHT NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_CHT NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_CHT NULL
#define OPTION_VAL_12PX_O55_CHT NULL
#define OPTION_VAL_11PX_O55_CHT NULL
#define OPTION_VAL_10PX_O55_CHT NULL
#define OPTION_VAL_9PX_O55_CHT NULL
#define OPTION_VAL_8PX_O55_CHT NULL
#define OPTION_VAL_7PX_O55_CHT NULL
#define OPTION_VAL_6PX_O55_CHT NULL
#define OPTION_VAL_5PX_O55_CHT NULL
#define OPTION_VAL_4PX_O55_CHT NULL
#define OPTION_VAL_3PX_O55_CHT NULL
#define OPTION_VAL_2PX_O55_CHT NULL
#define OPTION_VAL_1PX_O55_CHT NULL
#define OPTION_VAL_DISABLED_O55_CHT NULL
#define OPTION_VAL_1PX_O55_0_CHT NULL
#define OPTION_VAL_2PX_O55_0_CHT NULL
#define OPTION_VAL_3PX_O55_0_CHT NULL
#define OPTION_VAL_4PX_O55_0_CHT NULL
#define OPTION_VAL_5PX_O55_0_CHT NULL
#define OPTION_VAL_6PX_O55_0_CHT NULL
#define OPTION_VAL_7PX_O55_0_CHT NULL
#define OPTION_VAL_8PX_O55_0_CHT NULL
#define OPTION_VAL_9PX_O55_0_CHT NULL
#define OPTION_VAL_10PX_O55_0_CHT NULL
#define OPTION_VAL_11PX_O55_0_CHT NULL
#define OPTION_VAL_12PX_O55_0_CHT NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_CHT NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_CHT NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_CHT NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_CHT NULL
#define OPTION_VAL_32X_CHT NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_CHT NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_CHT NULL
#define OPTION_VAL_CORRECTED_CHT NULL
#define OPTION_VAL_UNCORRECTED_CHT NULL
#define OPTION_VAL_4_3_CHT NULL
#define OPTION_VAL_NTSC_CHT NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_CHT NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_CHT NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_CHT NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_CHT NULL
#define OPTION_VAL_239_CHT NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_CHT NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_CHT NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_CHT NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_CHT NULL
#define OPTION_VAL_287_CHT NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_CHT NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_CHT NULL
#define OPTION_VAL_SYNC_CHT NULL
#define OPTION_VAL_ASYNC_CHT NULL
#define OPTION_VAL_PRECACHE_CHT NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_CHT NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_CHT NULL
#define OPTION_VAL_2X_NATIVE_CHT NULL
#define OPTION_VAL_6X_CHT NULL
#define OPTION_VAL_10X_CHT NULL
#define OPTION_VAL_12X_CHT NULL
#define OPTION_VAL_14X_CHT NULL

struct retro_core_option_v2_category option_cats_cht[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_CHT,
      CATEGORY_VIDEO_INFO_0_CHT
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_CHT,
      CATEGORY_OSD_INFO_0_CHT
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_CHT,
      CATEGORY_INPUT_INFO_0_CHT
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_CHT,
      CATEGORY_MEMCARDS_INFO_0_CHT
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_CHT,
      CATEGORY_PGXP_INFO_0_CHT
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_CHT,
      CATEGORY_HACKS_INFO_0_CHT
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_cht[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_CHT,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_CHT,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_CHT },
         { "2x",         OPTION_VAL_2X_CHT },
         { "4x",         OPTION_VAL_4X_CHT },
         { "8x",         OPTION_VAL_8X_CHT },
         { "16x",        OPTION_VAL_16X_CHT },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_CHT,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_CHT,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_CHT },
         { "32bpp",         OPTION_VAL_32BPP_CHT },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_CHT,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_CHT,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_CHT },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_CHT },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_CHT,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_CHT,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_CHT,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_CHT,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_CHT },
         { "SABR",     OPTION_VAL_SABR_CHT },
         { "xBR",      OPTION_VAL_XBR_CHT },
         { "bilinear", OPTION_VAL_BILINEAR_CHT },
         { "3-point",  OPTION_VAL_3_POINT_CHT },
         { "JINC2",    OPTION_VAL_JINC2_CHT },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_CHT,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_CHT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_CHT },
         { "all", OPTION_VAL_ALL_CHT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_CHT,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_CHT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_CHT },
         { "all", OPTION_VAL_ALL_CHT },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_CHT,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_CHT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_CHT,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_CHT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_CHT,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_CHT,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_CHT },
         { "2x",  OPTION_VAL_2X_CHT },
         { "4x",  OPTION_VAL_4X_CHT },
         { "8x",  OPTION_VAL_8X_CHT },
         { "16x", OPTION_VAL_16X_CHT },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_CHT,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_CHT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_CHT,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_CHT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_CHT,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_CHT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_CHT,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_CHT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_CHT,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_CHT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_CHT,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_CHT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_CHT,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_CHT,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_CHT,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_CHT,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_CHT,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_CHT,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_CHT,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_CHT,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_CHT,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_CHT,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_CHT,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_CHT,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_CHT,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_CHT,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_CHT },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_CHT },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_CHT,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_CHT,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_CHT },
         { "dot",   OPTION_VAL_DOT_CHT },
         { "off",   OPTION_VAL_OFF_CHT },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_CHT,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_CHT,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_CHT },
         { "blue", OPTION_VAL_BLUE_CHT },
         { "green", OPTION_VAL_GREEN_CHT },
         { "orange", OPTION_VAL_ORANGE_CHT },
         { "yellow", OPTION_VAL_YELLOW_CHT },
         { "cyan", OPTION_VAL_CYAN_CHT },
         { "pink", OPTION_VAL_PINK_CHT },
         { "purple", OPTION_VAL_PURPLE_CHT },
         { "black", OPTION_VAL_BLACK_CHT },
         { "white", OPTION_VAL_WHITE_CHT },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_CHT,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_CHT,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_CHT },
         { "red", OPTION_VAL_RED_CHT },
         { "green", OPTION_VAL_GREEN_CHT },
         { "orange", OPTION_VAL_ORANGE_CHT },
         { "yellow", OPTION_VAL_YELLOW_CHT },
         { "cyan", OPTION_VAL_CYAN_CHT },
         { "pink", OPTION_VAL_PINK_CHT },
         { "purple", OPTION_VAL_PURPLE_CHT },
         { "black", OPTION_VAL_BLACK_CHT },
         { "white", OPTION_VAL_WHITE_CHT },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_CHT,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_CHT,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_CHT },
         { "10%",  OPTION_VAL_10_CHT },
         { "15%",  OPTION_VAL_15_CHT },
         { "20%",  OPTION_VAL_20_CHT },
         { "25%",  OPTION_VAL_25_CHT },
         { "30%",  OPTION_VAL_30_CHT },
         { "35%",  OPTION_VAL_35_CHT },
         { "40%",  OPTION_VAL_40_CHT },
         { "45%",  OPTION_VAL_45_CHT },
         { "50%",  OPTION_VAL_50_CHT },
         { "55%",  OPTION_VAL_55_CHT },
         { "60%",  OPTION_VAL_60_CHT },
         { "65%",  OPTION_VAL_65_CHT },
         { "70%",  OPTION_VAL_70_CHT },
         { "75%",  OPTION_VAL_75_CHT },
         { "80%",  OPTION_VAL_80_CHT },
         { "85%",  OPTION_VAL_85_CHT },
         { "90%",  OPTION_VAL_90_CHT },
         { "95%",  OPTION_VAL_95_CHT },
         { "100%", OPTION_VAL_100_CHT },
         { "105%", OPTION_VAL_105_CHT },
         { "110%", OPTION_VAL_110_CHT },
         { "115%", OPTION_VAL_115_CHT },
         { "120%", OPTION_VAL_120_CHT },
         { "125%", OPTION_VAL_125_CHT },
         { "130%", OPTION_VAL_130_CHT },
         { "135%", OPTION_VAL_135_CHT },
         { "140%", OPTION_VAL_140_CHT },
         { "145%", OPTION_VAL_145_CHT },
         { "150%", OPTION_VAL_150_CHT },
         { "155%", OPTION_VAL_155_CHT },
         { "160%", OPTION_VAL_160_CHT },
         { "165%", OPTION_VAL_165_CHT },
         { "170%", OPTION_VAL_170_CHT },
         { "175%", OPTION_VAL_175_CHT },
         { "180%", OPTION_VAL_180_CHT },
         { "185%", OPTION_VAL_185_CHT },
         { "190%", OPTION_VAL_190_CHT },
         { "195%", OPTION_VAL_195_CHT },
         { "200%", OPTION_VAL_200_CHT },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_CHT,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_CHT,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_CHT },
         { "quadratic", OPTION_VAL_QUADRATIC_CHT },
         { "cubic",     OPTION_VAL_CUBIC_CHT },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_CHT,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_CHT,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_CHT },
         { "5%",  OPTION_VAL_5_CHT },
         { "10%", OPTION_VAL_10_CHT },
         { "15%", OPTION_VAL_15_CHT },
         { "20%", OPTION_VAL_20_CHT },
         { "25%", OPTION_VAL_25_CHT },
         { "30%", OPTION_VAL_30_CHT },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_CHT,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_CHT,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_CHT },
         { "mednafen", OPTION_VAL_MEDNAFEN_CHT },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_CHT,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_CHT,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_CHT,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_CHT,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_CHT,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_CHT,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_CHT,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_CHT,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_CHT },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_CHT,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_CHT,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_CHT },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_CHT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_CHT,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_CHT,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_CHT },
         { "1px", OPTION_VAL_1PX_CHT },
         { "2px", OPTION_VAL_2PX_CHT },
         { "3px", OPTION_VAL_3PX_CHT },
         { "4px", OPTION_VAL_4PX_CHT },
         { "5px", OPTION_VAL_5PX_CHT },
         { "6px", OPTION_VAL_6PX_CHT },
         { "7px", OPTION_VAL_7PX_CHT },
         { "8px", OPTION_VAL_8PX_CHT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_CHT,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_CHT,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_CHT,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_CHT,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_CHT,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_CHT,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_CHT,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_CHT,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_CHT },
         { "aggressive", OPTION_VAL_AGGRESSIVE_CHT },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_CHT,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_CHT,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_CHT,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_CHT,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_CHT },
         { "16:10", OPTION_VAL_16_10_CHT },
         { "18:9",  OPTION_VAL_18_9_CHT },
         { "19:9",  OPTION_VAL_19_9_CHT },
         { "20:9",  OPTION_VAL_20_9_CHT },
         { "21:9",  OPTION_VAL_21_9_CHT }, // 64:27
         { "32:9",  OPTION_VAL_32_9_CHT },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_CHT,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_CHT,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_CHT },
         { "60%",           OPTION_VAL_60_CHT },
         { "70%",           OPTION_VAL_70_CHT },
         { "80%",           OPTION_VAL_80_CHT },
         { "90%",           OPTION_VAL_90_CHT },
         { "100%(native)", OPTION_VAL_100_NATIVE_CHT },
         { "110%",          OPTION_VAL_110_CHT },
         { "120%",          OPTION_VAL_120_CHT },
         { "130%",          OPTION_VAL_130_CHT },
         { "140%",          OPTION_VAL_140_CHT },
         { "150%",          OPTION_VAL_150_CHT },
         { "160%",          OPTION_VAL_160_CHT },
         { "170%",          OPTION_VAL_170_CHT },
         { "180%",          OPTION_VAL_180_CHT },
         { "190%",          OPTION_VAL_190_CHT },
         { "200%",          OPTION_VAL_200_CHT },
         { "210%",          OPTION_VAL_210_CHT },
         { "220%",          OPTION_VAL_220_CHT },
         { "230%",          OPTION_VAL_230_CHT },
         { "240%",          OPTION_VAL_240_CHT },
         { "250%",          OPTION_VAL_250_CHT },
         { "260%",          OPTION_VAL_260_CHT },
         { "270%",          OPTION_VAL_270_CHT },
         { "280%",          OPTION_VAL_280_CHT },
         { "290%",          OPTION_VAL_290_CHT },
         { "300%",          OPTION_VAL_300_CHT },
         { "310%",          OPTION_VAL_310_CHT },
         { "320%",          OPTION_VAL_320_CHT },
         { "330%",          OPTION_VAL_330_CHT },
         { "340%",          OPTION_VAL_340_CHT },
         { "350%",          OPTION_VAL_350_CHT },
         { "360%",          OPTION_VAL_360_CHT },
         { "370%",          OPTION_VAL_370_CHT },
         { "380%",          OPTION_VAL_380_CHT },
         { "390%",          OPTION_VAL_390_CHT },
         { "400%",          OPTION_VAL_400_CHT },
         { "410%",          OPTION_VAL_410_CHT },
         { "420%",          OPTION_VAL_420_CHT },
         { "430%",          OPTION_VAL_430_CHT },
         { "440%",          OPTION_VAL_440_CHT },
         { "450%",          OPTION_VAL_450_CHT },
         { "460%",          OPTION_VAL_460_CHT },
         { "470%",          OPTION_VAL_470_CHT },
         { "480%",          OPTION_VAL_480_CHT },
         { "490%",          OPTION_VAL_490_CHT },
         { "500%",          OPTION_VAL_500_CHT },
         { "510%",          OPTION_VAL_510_CHT },
         { "520%",          OPTION_VAL_520_CHT },
         { "530%",          OPTION_VAL_530_CHT },
         { "540%",          OPTION_VAL_540_CHT },
         { "550%",          OPTION_VAL_550_CHT },
         { "560%",          OPTION_VAL_560_CHT },
         { "570%",          OPTION_VAL_570_CHT },
         { "580%",          OPTION_VAL_580_CHT },
         { "590%",          OPTION_VAL_590_CHT },
         { "600%",          OPTION_VAL_600_CHT },
         { "610%",          OPTION_VAL_610_CHT },
         { "620%",          OPTION_VAL_620_CHT },
         { "630%",          OPTION_VAL_630_CHT },
         { "640%",          OPTION_VAL_640_CHT },
         { "650%",          OPTION_VAL_650_CHT },
         { "660%",          OPTION_VAL_660_CHT },
         { "670%",          OPTION_VAL_670_CHT },
         { "680%",          OPTION_VAL_680_CHT },
         { "690%",          OPTION_VAL_690_CHT },
         { "700%",          OPTION_VAL_700_CHT },
         { "710%",          OPTION_VAL_710_CHT },
         { "720%",          OPTION_VAL_720_CHT },
         { "730%",          OPTION_VAL_730_CHT },
         { "740%",          OPTION_VAL_740_CHT },
         { "750%",          OPTION_VAL_750_CHT },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_CHT,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_CHT,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_CHT,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_CHT,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_CHT,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_CHT,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_CHT },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_CHT },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_CHT,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_CHT },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_CHT },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_CHT },
#endif
         { "software",    OPTION_VAL_SOFTWARE_CHT },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_CHT,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_CHT,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_CHT,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_CHT },
         { "execute",  OPTION_VAL_EXECUTE_CHT },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_CHT },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_CHT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_CHT,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_CHT },
         { "dma",  OPTION_VAL_DMA_CHT },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_CHT,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_CHT,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_CHT },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_CHT },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_CHT },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_CHT,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_CHT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_CHT,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_CHT,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_CHT },
         { "static",  OPTION_VAL_STATIC_CHT },
         { "smart", OPTION_VAL_SMART_CHT },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_CHT,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_CHT,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_CHT },
         { "2px",      OPTION_VAL_2PX_CHT },
         { "3px",      OPTION_VAL_3PX_CHT },
         { "4px",      OPTION_VAL_4PX_CHT },
         { "5px",      OPTION_VAL_5PX_CHT },
         { "6px",      OPTION_VAL_6PX_CHT },
         { "7px",      OPTION_VAL_7PX_CHT },
         { "8px",      OPTION_VAL_8PX_CHT },
         { "9px",      OPTION_VAL_9PX_CHT },
         { "10px",     OPTION_VAL_10PX_CHT },
         { "11px",     OPTION_VAL_11PX_CHT },
         { "12px",     OPTION_VAL_12PX_CHT },
         { "13px",     OPTION_VAL_13PX_CHT },
         { "14px",     OPTION_VAL_14PX_CHT },
         { "15px",     OPTION_VAL_15PX_CHT },
         { "16px",     OPTION_VAL_16PX_CHT },
         { "17px",     OPTION_VAL_17PX_CHT },
         { "18px",     OPTION_VAL_18PX_CHT },
         { "19px",     OPTION_VAL_19PX_CHT },
         { "20px",     OPTION_VAL_20PX_CHT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_CHT,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_CHT,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_CHT },
         { "-11px",    OPTION_VAL_11PX_O55_CHT },
         { "-10px",    OPTION_VAL_10PX_O55_CHT },
         { "-9px",     OPTION_VAL_9PX_O55_CHT },
         { "-8px",     OPTION_VAL_8PX_O55_CHT },
         { "-7px",     OPTION_VAL_7PX_O55_CHT },
         { "-6px",     OPTION_VAL_6PX_O55_CHT },
         { "-5px",     OPTION_VAL_5PX_O55_CHT },
         { "-4px",     OPTION_VAL_4PX_O55_CHT },
         { "-3px",     OPTION_VAL_3PX_O55_CHT },
         { "-2px",     OPTION_VAL_2PX_O55_CHT },
         { "-1px",     OPTION_VAL_1PX_O55_CHT },
         { "disabled", OPTION_VAL_DISABLED_O55_CHT },
         { "+1px",     OPTION_VAL_1PX_O55_0_CHT },
         { "+2px",     OPTION_VAL_2PX_O55_0_CHT },
         { "+3px",     OPTION_VAL_3PX_O55_0_CHT },
         { "+4px",     OPTION_VAL_4PX_O55_0_CHT },
         { "+5px",     OPTION_VAL_5PX_O55_0_CHT },
         { "+6px",     OPTION_VAL_6PX_O55_0_CHT },
         { "+7px",     OPTION_VAL_7PX_O55_0_CHT },
         { "+8px",     OPTION_VAL_8PX_O55_0_CHT },
         { "+9px",     OPTION_VAL_9PX_O55_0_CHT },
         { "+10px",    OPTION_VAL_10PX_O55_0_CHT },
         { "+11px",    OPTION_VAL_11PX_O55_0_CHT },
         { "+12px",    OPTION_VAL_12PX_O55_0_CHT },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_CHT,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_CHT,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_CHT },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_CHT,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_CHT,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_CHT },
         { "2x",         OPTION_VAL_2X_CHT },
         { "4x",         OPTION_VAL_4X_CHT },
         { "8x",         OPTION_VAL_8X_CHT },
         { "16x",        OPTION_VAL_16X_CHT },
         { "32x",        OPTION_VAL_32X_CHT },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_CHT,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_CHT,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_CHT },
         { "uncorrected", OPTION_VAL_UNCORRECTED_CHT },
         { "4:3",  OPTION_VAL_4_3_CHT },
         { "ntsc", OPTION_VAL_NTSC_CHT },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_CHT,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_CHT,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_CHT,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_CHT,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_CHT },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_CHT,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_CHT,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_CHT,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_CHT,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_CHT },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_CHT,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_CHT },
         { "async",    OPTION_VAL_ASYNC_CHT },
         { "precache", OPTION_VAL_PRECACHE_CHT },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_CHT,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_CHT },
         { "4x",          OPTION_VAL_4X_CHT },
         { "6x",          OPTION_VAL_6X_CHT },
         { "8x",          OPTION_VAL_8X_CHT },
         { "10x",         OPTION_VAL_10X_CHT },
         { "12x",         OPTION_VAL_12X_CHT },
         { "14x",         OPTION_VAL_14X_CHT },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_cht = {
   option_cats_cht,
   option_defs_cht
};

/* RETRO_LANGUAGE_CS */

#define CATEGORY_VIDEO_LABEL_CS NULL
#define CATEGORY_VIDEO_INFO_0_CS NULL
#define CATEGORY_OSD_LABEL_CS NULL
#define CATEGORY_OSD_INFO_0_CS NULL
#define CATEGORY_INPUT_LABEL_CS "Vstup"
#define CATEGORY_INPUT_INFO_0_CS NULL
#define CATEGORY_MEMCARDS_LABEL_CS NULL
#define CATEGORY_MEMCARDS_INFO_0_CS NULL
#define CATEGORY_PGXP_LABEL_CS NULL
#define CATEGORY_PGXP_INFO_0_CS NULL
#define CATEGORY_HACKS_LABEL_CS NULL
#define CATEGORY_HACKS_INFO_0_CS NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_CS NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_CS NULL
#define OPTION_VAL_1X_NATIVE_CS NULL
#define OPTION_VAL_2X_CS NULL
#define OPTION_VAL_4X_CS NULL
#define OPTION_VAL_8X_CS NULL
#define OPTION_VAL_16X_CS NULL
#define BEETLE_OPT_DEPTH_LABEL_CS NULL
#define BEETLE_OPT_DEPTH_INFO_0_CS NULL
#define OPTION_VAL_16BPP_NATIVE_CS NULL
#define OPTION_VAL_32BPP_CS NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_CS NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_CS NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_CS NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_CS NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_CS NULL
#define BEETLE_OPT_FILTER_LABEL_CS NULL
#define BEETLE_OPT_FILTER_INFO_0_CS NULL
#define OPTION_VAL_NEAREST_CS NULL
#define OPTION_VAL_SABR_CS NULL
#define OPTION_VAL_XBR_CS NULL
#define OPTION_VAL_BILINEAR_CS NULL
#define OPTION_VAL_3_POINT_CS NULL
#define OPTION_VAL_JINC2_CS NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_CS NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_CS NULL
#define OPTION_VAL_OPAQUE_CS NULL
#define OPTION_VAL_ALL_CS NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_CS NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_CS NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_CS NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_CS NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_CS NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_CS NULL
#define BEETLE_OPT_MSAA_LABEL_CS NULL
#define BEETLE_OPT_MSAA_INFO_0_CS NULL
#define OPTION_VAL_1X_CS NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_CS NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_CS NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_CS NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_CS NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_CS NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_CS NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_CS NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_CS NULL
#define BEETLE_OPT_WIREFRAME_LABEL_CS NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_CS NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_CS NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_CS NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_CS NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_CS NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_CS NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_CS NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_CS NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_CS NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_CS NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_CS NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_CS NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_CS NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_CS NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_CS NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_CS NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_CS NULL
#define OPTION_VAL_LIGHTGUN_CS NULL
#define OPTION_VAL_TOUCHSCREEN_CS NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_CS NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_CS NULL
#define OPTION_VAL_CROSS_CS NULL
#define OPTION_VAL_DOT_CS NULL
#define OPTION_VAL_OFF_CS NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_CS NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_CS NULL
#define OPTION_VAL_RED_CS NULL
#define OPTION_VAL_BLUE_CS NULL
#define OPTION_VAL_GREEN_CS NULL
#define OPTION_VAL_ORANGE_CS NULL
#define OPTION_VAL_YELLOW_CS NULL
#define OPTION_VAL_CYAN_CS NULL
#define OPTION_VAL_PINK_CS NULL
#define OPTION_VAL_PURPLE_CS NULL
#define OPTION_VAL_BLACK_CS NULL
#define OPTION_VAL_WHITE_CS NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_CS NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_CS NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_CS NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_CS NULL
#define OPTION_VAL_5_CS NULL
#define OPTION_VAL_10_CS NULL
#define OPTION_VAL_15_CS NULL
#define OPTION_VAL_20_CS NULL
#define OPTION_VAL_25_CS NULL
#define OPTION_VAL_30_CS NULL
#define OPTION_VAL_35_CS NULL
#define OPTION_VAL_40_CS NULL
#define OPTION_VAL_45_CS NULL
#define OPTION_VAL_50_CS NULL
#define OPTION_VAL_55_CS NULL
#define OPTION_VAL_60_CS NULL
#define OPTION_VAL_65_CS NULL
#define OPTION_VAL_70_CS NULL
#define OPTION_VAL_75_CS NULL
#define OPTION_VAL_80_CS NULL
#define OPTION_VAL_85_CS NULL
#define OPTION_VAL_90_CS NULL
#define OPTION_VAL_95_CS NULL
#define OPTION_VAL_100_CS NULL
#define OPTION_VAL_105_CS NULL
#define OPTION_VAL_110_CS NULL
#define OPTION_VAL_115_CS NULL
#define OPTION_VAL_120_CS NULL
#define OPTION_VAL_125_CS NULL
#define OPTION_VAL_130_CS NULL
#define OPTION_VAL_135_CS NULL
#define OPTION_VAL_140_CS NULL
#define OPTION_VAL_145_CS NULL
#define OPTION_VAL_150_CS NULL
#define OPTION_VAL_155_CS NULL
#define OPTION_VAL_160_CS NULL
#define OPTION_VAL_165_CS NULL
#define OPTION_VAL_170_CS NULL
#define OPTION_VAL_175_CS NULL
#define OPTION_VAL_180_CS NULL
#define OPTION_VAL_185_CS NULL
#define OPTION_VAL_190_CS NULL
#define OPTION_VAL_195_CS NULL
#define OPTION_VAL_200_CS NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_CS NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_CS NULL
#define OPTION_VAL_LINEAR_CS NULL
#define OPTION_VAL_QUADRATIC_CS NULL
#define OPTION_VAL_CUBIC_CS NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_CS NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_CS NULL
#define OPTION_VAL_0_CS NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_CS NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_CS NULL
#define OPTION_VAL_LIBRETRO_CS NULL
#define OPTION_VAL_MEDNAFEN_CS NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_CS NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_CS NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_CS NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_CS NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_CS NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_CS NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_CS NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_CS NULL
#define OPTION_VAL_1_CS NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_CS NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_CS NULL
#define OPTION_VAL_MEMORY_ONLY_CS NULL
#define OPTION_VAL_MEMORY_CPU_CS NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_CS NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_CS NULL
#define OPTION_VAL_0PX_CS NULL
#define OPTION_VAL_1PX_CS NULL
#define OPTION_VAL_2PX_CS NULL
#define OPTION_VAL_3PX_CS NULL
#define OPTION_VAL_4PX_CS NULL
#define OPTION_VAL_5PX_CS NULL
#define OPTION_VAL_6PX_CS NULL
#define OPTION_VAL_7PX_CS NULL
#define OPTION_VAL_8PX_CS NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_CS NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_CS NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_CS NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_CS NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_CS NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_CS NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_CS NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_CS NULL
#define OPTION_VAL_DEFAULT_CS NULL
#define OPTION_VAL_AGGRESSIVE_CS NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_CS NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_CS NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_CS NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_CS NULL
#define OPTION_VAL_16_9_CS NULL
#define OPTION_VAL_16_10_CS NULL
#define OPTION_VAL_18_9_CS NULL
#define OPTION_VAL_19_9_CS NULL
#define OPTION_VAL_20_9_CS NULL
#define OPTION_VAL_21_9_CS NULL
#define OPTION_VAL_32_9_CS NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_CS NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_CS NULL
#define OPTION_VAL_100_NATIVE_CS NULL
#define OPTION_VAL_210_CS NULL
#define OPTION_VAL_220_CS NULL
#define OPTION_VAL_230_CS NULL
#define OPTION_VAL_240_CS NULL
#define OPTION_VAL_250_CS NULL
#define OPTION_VAL_260_CS NULL
#define OPTION_VAL_270_CS NULL
#define OPTION_VAL_280_CS NULL
#define OPTION_VAL_290_CS NULL
#define OPTION_VAL_300_CS NULL
#define OPTION_VAL_310_CS NULL
#define OPTION_VAL_320_CS NULL
#define OPTION_VAL_330_CS NULL
#define OPTION_VAL_340_CS NULL
#define OPTION_VAL_350_CS NULL
#define OPTION_VAL_360_CS NULL
#define OPTION_VAL_370_CS NULL
#define OPTION_VAL_380_CS NULL
#define OPTION_VAL_390_CS NULL
#define OPTION_VAL_400_CS NULL
#define OPTION_VAL_410_CS NULL
#define OPTION_VAL_420_CS NULL
#define OPTION_VAL_430_CS NULL
#define OPTION_VAL_440_CS NULL
#define OPTION_VAL_450_CS NULL
#define OPTION_VAL_460_CS NULL
#define OPTION_VAL_470_CS NULL
#define OPTION_VAL_480_CS NULL
#define OPTION_VAL_490_CS NULL
#define OPTION_VAL_500_CS NULL
#define OPTION_VAL_510_CS NULL
#define OPTION_VAL_520_CS NULL
#define OPTION_VAL_530_CS NULL
#define OPTION_VAL_540_CS NULL
#define OPTION_VAL_550_CS NULL
#define OPTION_VAL_560_CS NULL
#define OPTION_VAL_570_CS NULL
#define OPTION_VAL_580_CS NULL
#define OPTION_VAL_590_CS NULL
#define OPTION_VAL_600_CS NULL
#define OPTION_VAL_610_CS NULL
#define OPTION_VAL_620_CS NULL
#define OPTION_VAL_630_CS NULL
#define OPTION_VAL_640_CS NULL
#define OPTION_VAL_650_CS NULL
#define OPTION_VAL_660_CS NULL
#define OPTION_VAL_670_CS NULL
#define OPTION_VAL_680_CS NULL
#define OPTION_VAL_690_CS NULL
#define OPTION_VAL_700_CS NULL
#define OPTION_VAL_710_CS NULL
#define OPTION_VAL_720_CS NULL
#define OPTION_VAL_730_CS NULL
#define OPTION_VAL_740_CS NULL
#define OPTION_VAL_750_CS NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_CS NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_CS NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_CS NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_CS NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_CS NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_CS NULL
#define OPTION_VAL_PSXONPSP_CS NULL
#define OPTION_VAL_PS1_ROM_CS NULL
#define BEETLE_OPT_RENDERER_LABEL_CS NULL
#define BEETLE_OPT_RENDERER_INFO_0_CS NULL
#define OPTION_VAL_HARDWARE_CS NULL
#define OPTION_VAL_HARDWARE_GL_CS NULL
#define OPTION_VAL_HARDWARE_VK_CS NULL
#define OPTION_VAL_SOFTWARE_CS NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_CS NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_CS NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_CS NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_CS NULL
#define OPTION_VAL_DISABLED_CS NULL
#define OPTION_VAL_EXECUTE_CS NULL
#define OPTION_VAL_EXECUTE_ONE_CS NULL
#define OPTION_VAL_RUN_INTERPRETER_CS NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_CS NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_CS NULL
#define OPTION_VAL_FULL_CS NULL
#define OPTION_VAL_DMA_CS NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_CS NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_CS NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_CS NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_CS NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_CS NULL
#define OPTION_VAL_FORCE_INTERLACED_CS NULL
#define OPTION_VAL_AUTO_TOGGLE_CS NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_CS NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_CS NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_CS NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_CS NULL
#define OPTION_VAL_DISABLED_O53_CS NULL
#define OPTION_VAL_STATIC_CS NULL
#define OPTION_VAL_SMART_CS NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_CS NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_CS NULL
#define OPTION_VAL_9PX_CS NULL
#define OPTION_VAL_10PX_CS NULL
#define OPTION_VAL_11PX_CS NULL
#define OPTION_VAL_12PX_CS NULL
#define OPTION_VAL_13PX_CS NULL
#define OPTION_VAL_14PX_CS NULL
#define OPTION_VAL_15PX_CS NULL
#define OPTION_VAL_16PX_CS NULL
#define OPTION_VAL_17PX_CS NULL
#define OPTION_VAL_18PX_CS NULL
#define OPTION_VAL_19PX_CS NULL
#define OPTION_VAL_20PX_CS NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_CS NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_CS NULL
#define OPTION_VAL_12PX_O55_CS NULL
#define OPTION_VAL_11PX_O55_CS NULL
#define OPTION_VAL_10PX_O55_CS NULL
#define OPTION_VAL_9PX_O55_CS NULL
#define OPTION_VAL_8PX_O55_CS NULL
#define OPTION_VAL_7PX_O55_CS NULL
#define OPTION_VAL_6PX_O55_CS NULL
#define OPTION_VAL_5PX_O55_CS NULL
#define OPTION_VAL_4PX_O55_CS NULL
#define OPTION_VAL_3PX_O55_CS NULL
#define OPTION_VAL_2PX_O55_CS NULL
#define OPTION_VAL_1PX_O55_CS NULL
#define OPTION_VAL_DISABLED_O55_CS NULL
#define OPTION_VAL_1PX_O55_0_CS NULL
#define OPTION_VAL_2PX_O55_0_CS NULL
#define OPTION_VAL_3PX_O55_0_CS NULL
#define OPTION_VAL_4PX_O55_0_CS NULL
#define OPTION_VAL_5PX_O55_0_CS NULL
#define OPTION_VAL_6PX_O55_0_CS NULL
#define OPTION_VAL_7PX_O55_0_CS NULL
#define OPTION_VAL_8PX_O55_0_CS NULL
#define OPTION_VAL_9PX_O55_0_CS NULL
#define OPTION_VAL_10PX_O55_0_CS NULL
#define OPTION_VAL_11PX_O55_0_CS NULL
#define OPTION_VAL_12PX_O55_0_CS NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_CS NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_CS NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_CS NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_CS NULL
#define OPTION_VAL_32X_CS NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_CS NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_CS NULL
#define OPTION_VAL_CORRECTED_CS NULL
#define OPTION_VAL_UNCORRECTED_CS NULL
#define OPTION_VAL_4_3_CS NULL
#define OPTION_VAL_NTSC_CS NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_CS NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_CS NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_CS NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_CS NULL
#define OPTION_VAL_239_CS NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_CS NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_CS NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_CS NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_CS NULL
#define OPTION_VAL_287_CS NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_CS NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_CS NULL
#define OPTION_VAL_SYNC_CS NULL
#define OPTION_VAL_ASYNC_CS NULL
#define OPTION_VAL_PRECACHE_CS NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_CS NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_CS NULL
#define OPTION_VAL_2X_NATIVE_CS NULL
#define OPTION_VAL_6X_CS NULL
#define OPTION_VAL_10X_CS NULL
#define OPTION_VAL_12X_CS NULL
#define OPTION_VAL_14X_CS NULL

struct retro_core_option_v2_category option_cats_cs[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_CS,
      CATEGORY_VIDEO_INFO_0_CS
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_CS,
      CATEGORY_OSD_INFO_0_CS
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_CS,
      CATEGORY_INPUT_INFO_0_CS
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_CS,
      CATEGORY_MEMCARDS_INFO_0_CS
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_CS,
      CATEGORY_PGXP_INFO_0_CS
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_CS,
      CATEGORY_HACKS_INFO_0_CS
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_cs[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_CS,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_CS,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_CS },
         { "2x",         OPTION_VAL_2X_CS },
         { "4x",         OPTION_VAL_4X_CS },
         { "8x",         OPTION_VAL_8X_CS },
         { "16x",        OPTION_VAL_16X_CS },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_CS,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_CS,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_CS },
         { "32bpp",         OPTION_VAL_32BPP_CS },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_CS,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_CS,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_CS },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_CS },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_CS,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_CS,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_CS,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_CS,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_CS },
         { "SABR",     OPTION_VAL_SABR_CS },
         { "xBR",      OPTION_VAL_XBR_CS },
         { "bilinear", OPTION_VAL_BILINEAR_CS },
         { "3-point",  OPTION_VAL_3_POINT_CS },
         { "JINC2",    OPTION_VAL_JINC2_CS },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_CS,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_CS,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_CS },
         { "all", OPTION_VAL_ALL_CS },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_CS,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_CS,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_CS },
         { "all", OPTION_VAL_ALL_CS },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_CS,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_CS,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_CS,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_CS,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_CS,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_CS,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_CS },
         { "2x",  OPTION_VAL_2X_CS },
         { "4x",  OPTION_VAL_4X_CS },
         { "8x",  OPTION_VAL_8X_CS },
         { "16x", OPTION_VAL_16X_CS },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_CS,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_CS,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_CS,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_CS,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_CS,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_CS,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_CS,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_CS,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_CS,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_CS,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_CS,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_CS,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_CS,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_CS,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_CS,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_CS,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_CS,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_CS,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_CS,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_CS,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_CS,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_CS,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_CS,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_CS,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_CS,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_CS,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_CS },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_CS },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_CS,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_CS,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_CS },
         { "dot",   OPTION_VAL_DOT_CS },
         { "off",   OPTION_VAL_OFF_CS },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_CS,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_CS,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_CS },
         { "blue", OPTION_VAL_BLUE_CS },
         { "green", OPTION_VAL_GREEN_CS },
         { "orange", OPTION_VAL_ORANGE_CS },
         { "yellow", OPTION_VAL_YELLOW_CS },
         { "cyan", OPTION_VAL_CYAN_CS },
         { "pink", OPTION_VAL_PINK_CS },
         { "purple", OPTION_VAL_PURPLE_CS },
         { "black", OPTION_VAL_BLACK_CS },
         { "white", OPTION_VAL_WHITE_CS },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_CS,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_CS,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_CS },
         { "red", OPTION_VAL_RED_CS },
         { "green", OPTION_VAL_GREEN_CS },
         { "orange", OPTION_VAL_ORANGE_CS },
         { "yellow", OPTION_VAL_YELLOW_CS },
         { "cyan", OPTION_VAL_CYAN_CS },
         { "pink", OPTION_VAL_PINK_CS },
         { "purple", OPTION_VAL_PURPLE_CS },
         { "black", OPTION_VAL_BLACK_CS },
         { "white", OPTION_VAL_WHITE_CS },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_CS,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_CS,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_CS },
         { "10%",  OPTION_VAL_10_CS },
         { "15%",  OPTION_VAL_15_CS },
         { "20%",  OPTION_VAL_20_CS },
         { "25%",  OPTION_VAL_25_CS },
         { "30%",  OPTION_VAL_30_CS },
         { "35%",  OPTION_VAL_35_CS },
         { "40%",  OPTION_VAL_40_CS },
         { "45%",  OPTION_VAL_45_CS },
         { "50%",  OPTION_VAL_50_CS },
         { "55%",  OPTION_VAL_55_CS },
         { "60%",  OPTION_VAL_60_CS },
         { "65%",  OPTION_VAL_65_CS },
         { "70%",  OPTION_VAL_70_CS },
         { "75%",  OPTION_VAL_75_CS },
         { "80%",  OPTION_VAL_80_CS },
         { "85%",  OPTION_VAL_85_CS },
         { "90%",  OPTION_VAL_90_CS },
         { "95%",  OPTION_VAL_95_CS },
         { "100%", OPTION_VAL_100_CS },
         { "105%", OPTION_VAL_105_CS },
         { "110%", OPTION_VAL_110_CS },
         { "115%", OPTION_VAL_115_CS },
         { "120%", OPTION_VAL_120_CS },
         { "125%", OPTION_VAL_125_CS },
         { "130%", OPTION_VAL_130_CS },
         { "135%", OPTION_VAL_135_CS },
         { "140%", OPTION_VAL_140_CS },
         { "145%", OPTION_VAL_145_CS },
         { "150%", OPTION_VAL_150_CS },
         { "155%", OPTION_VAL_155_CS },
         { "160%", OPTION_VAL_160_CS },
         { "165%", OPTION_VAL_165_CS },
         { "170%", OPTION_VAL_170_CS },
         { "175%", OPTION_VAL_175_CS },
         { "180%", OPTION_VAL_180_CS },
         { "185%", OPTION_VAL_185_CS },
         { "190%", OPTION_VAL_190_CS },
         { "195%", OPTION_VAL_195_CS },
         { "200%", OPTION_VAL_200_CS },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_CS,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_CS,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_CS },
         { "quadratic", OPTION_VAL_QUADRATIC_CS },
         { "cubic",     OPTION_VAL_CUBIC_CS },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_CS,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_CS,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_CS },
         { "5%",  OPTION_VAL_5_CS },
         { "10%", OPTION_VAL_10_CS },
         { "15%", OPTION_VAL_15_CS },
         { "20%", OPTION_VAL_20_CS },
         { "25%", OPTION_VAL_25_CS },
         { "30%", OPTION_VAL_30_CS },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_CS,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_CS,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_CS },
         { "mednafen", OPTION_VAL_MEDNAFEN_CS },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_CS,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_CS,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_CS,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_CS,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_CS,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_CS,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_CS,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_CS,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_CS },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_CS,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_CS,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_CS },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_CS },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_CS,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_CS,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_CS },
         { "1px", OPTION_VAL_1PX_CS },
         { "2px", OPTION_VAL_2PX_CS },
         { "3px", OPTION_VAL_3PX_CS },
         { "4px", OPTION_VAL_4PX_CS },
         { "5px", OPTION_VAL_5PX_CS },
         { "6px", OPTION_VAL_6PX_CS },
         { "7px", OPTION_VAL_7PX_CS },
         { "8px", OPTION_VAL_8PX_CS },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_CS,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_CS,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_CS,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_CS,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_CS,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_CS,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_CS,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_CS,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_CS },
         { "aggressive", OPTION_VAL_AGGRESSIVE_CS },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_CS,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_CS,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_CS,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_CS,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_CS },
         { "16:10", OPTION_VAL_16_10_CS },
         { "18:9",  OPTION_VAL_18_9_CS },
         { "19:9",  OPTION_VAL_19_9_CS },
         { "20:9",  OPTION_VAL_20_9_CS },
         { "21:9",  OPTION_VAL_21_9_CS }, // 64:27
         { "32:9",  OPTION_VAL_32_9_CS },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_CS,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_CS,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_CS },
         { "60%",           OPTION_VAL_60_CS },
         { "70%",           OPTION_VAL_70_CS },
         { "80%",           OPTION_VAL_80_CS },
         { "90%",           OPTION_VAL_90_CS },
         { "100%(native)", OPTION_VAL_100_NATIVE_CS },
         { "110%",          OPTION_VAL_110_CS },
         { "120%",          OPTION_VAL_120_CS },
         { "130%",          OPTION_VAL_130_CS },
         { "140%",          OPTION_VAL_140_CS },
         { "150%",          OPTION_VAL_150_CS },
         { "160%",          OPTION_VAL_160_CS },
         { "170%",          OPTION_VAL_170_CS },
         { "180%",          OPTION_VAL_180_CS },
         { "190%",          OPTION_VAL_190_CS },
         { "200%",          OPTION_VAL_200_CS },
         { "210%",          OPTION_VAL_210_CS },
         { "220%",          OPTION_VAL_220_CS },
         { "230%",          OPTION_VAL_230_CS },
         { "240%",          OPTION_VAL_240_CS },
         { "250%",          OPTION_VAL_250_CS },
         { "260%",          OPTION_VAL_260_CS },
         { "270%",          OPTION_VAL_270_CS },
         { "280%",          OPTION_VAL_280_CS },
         { "290%",          OPTION_VAL_290_CS },
         { "300%",          OPTION_VAL_300_CS },
         { "310%",          OPTION_VAL_310_CS },
         { "320%",          OPTION_VAL_320_CS },
         { "330%",          OPTION_VAL_330_CS },
         { "340%",          OPTION_VAL_340_CS },
         { "350%",          OPTION_VAL_350_CS },
         { "360%",          OPTION_VAL_360_CS },
         { "370%",          OPTION_VAL_370_CS },
         { "380%",          OPTION_VAL_380_CS },
         { "390%",          OPTION_VAL_390_CS },
         { "400%",          OPTION_VAL_400_CS },
         { "410%",          OPTION_VAL_410_CS },
         { "420%",          OPTION_VAL_420_CS },
         { "430%",          OPTION_VAL_430_CS },
         { "440%",          OPTION_VAL_440_CS },
         { "450%",          OPTION_VAL_450_CS },
         { "460%",          OPTION_VAL_460_CS },
         { "470%",          OPTION_VAL_470_CS },
         { "480%",          OPTION_VAL_480_CS },
         { "490%",          OPTION_VAL_490_CS },
         { "500%",          OPTION_VAL_500_CS },
         { "510%",          OPTION_VAL_510_CS },
         { "520%",          OPTION_VAL_520_CS },
         { "530%",          OPTION_VAL_530_CS },
         { "540%",          OPTION_VAL_540_CS },
         { "550%",          OPTION_VAL_550_CS },
         { "560%",          OPTION_VAL_560_CS },
         { "570%",          OPTION_VAL_570_CS },
         { "580%",          OPTION_VAL_580_CS },
         { "590%",          OPTION_VAL_590_CS },
         { "600%",          OPTION_VAL_600_CS },
         { "610%",          OPTION_VAL_610_CS },
         { "620%",          OPTION_VAL_620_CS },
         { "630%",          OPTION_VAL_630_CS },
         { "640%",          OPTION_VAL_640_CS },
         { "650%",          OPTION_VAL_650_CS },
         { "660%",          OPTION_VAL_660_CS },
         { "670%",          OPTION_VAL_670_CS },
         { "680%",          OPTION_VAL_680_CS },
         { "690%",          OPTION_VAL_690_CS },
         { "700%",          OPTION_VAL_700_CS },
         { "710%",          OPTION_VAL_710_CS },
         { "720%",          OPTION_VAL_720_CS },
         { "730%",          OPTION_VAL_730_CS },
         { "740%",          OPTION_VAL_740_CS },
         { "750%",          OPTION_VAL_750_CS },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_CS,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_CS,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_CS,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_CS,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_CS,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_CS,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_CS },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_CS },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_CS,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_CS,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_CS },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_CS },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_CS },
#endif
         { "software",    OPTION_VAL_SOFTWARE_CS },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_CS,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_CS,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_CS,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_CS,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_CS },
         { "execute",  OPTION_VAL_EXECUTE_CS },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_CS },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_CS },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_CS,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_CS,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_CS },
         { "dma",  OPTION_VAL_DMA_CS },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_CS,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_CS,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_CS,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_CS,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_CS },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_CS },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_CS },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_CS,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_CS,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_CS,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_CS,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_CS },
         { "static",  OPTION_VAL_STATIC_CS },
         { "smart", OPTION_VAL_SMART_CS },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_CS,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_CS,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_CS },
         { "2px",      OPTION_VAL_2PX_CS },
         { "3px",      OPTION_VAL_3PX_CS },
         { "4px",      OPTION_VAL_4PX_CS },
         { "5px",      OPTION_VAL_5PX_CS },
         { "6px",      OPTION_VAL_6PX_CS },
         { "7px",      OPTION_VAL_7PX_CS },
         { "8px",      OPTION_VAL_8PX_CS },
         { "9px",      OPTION_VAL_9PX_CS },
         { "10px",     OPTION_VAL_10PX_CS },
         { "11px",     OPTION_VAL_11PX_CS },
         { "12px",     OPTION_VAL_12PX_CS },
         { "13px",     OPTION_VAL_13PX_CS },
         { "14px",     OPTION_VAL_14PX_CS },
         { "15px",     OPTION_VAL_15PX_CS },
         { "16px",     OPTION_VAL_16PX_CS },
         { "17px",     OPTION_VAL_17PX_CS },
         { "18px",     OPTION_VAL_18PX_CS },
         { "19px",     OPTION_VAL_19PX_CS },
         { "20px",     OPTION_VAL_20PX_CS },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_CS,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_CS,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_CS },
         { "-11px",    OPTION_VAL_11PX_O55_CS },
         { "-10px",    OPTION_VAL_10PX_O55_CS },
         { "-9px",     OPTION_VAL_9PX_O55_CS },
         { "-8px",     OPTION_VAL_8PX_O55_CS },
         { "-7px",     OPTION_VAL_7PX_O55_CS },
         { "-6px",     OPTION_VAL_6PX_O55_CS },
         { "-5px",     OPTION_VAL_5PX_O55_CS },
         { "-4px",     OPTION_VAL_4PX_O55_CS },
         { "-3px",     OPTION_VAL_3PX_O55_CS },
         { "-2px",     OPTION_VAL_2PX_O55_CS },
         { "-1px",     OPTION_VAL_1PX_O55_CS },
         { "disabled", OPTION_VAL_DISABLED_O55_CS },
         { "+1px",     OPTION_VAL_1PX_O55_0_CS },
         { "+2px",     OPTION_VAL_2PX_O55_0_CS },
         { "+3px",     OPTION_VAL_3PX_O55_0_CS },
         { "+4px",     OPTION_VAL_4PX_O55_0_CS },
         { "+5px",     OPTION_VAL_5PX_O55_0_CS },
         { "+6px",     OPTION_VAL_6PX_O55_0_CS },
         { "+7px",     OPTION_VAL_7PX_O55_0_CS },
         { "+8px",     OPTION_VAL_8PX_O55_0_CS },
         { "+9px",     OPTION_VAL_9PX_O55_0_CS },
         { "+10px",    OPTION_VAL_10PX_O55_0_CS },
         { "+11px",    OPTION_VAL_11PX_O55_0_CS },
         { "+12px",    OPTION_VAL_12PX_O55_0_CS },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_CS,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_CS,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_CS },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_CS,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_CS,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_CS },
         { "2x",         OPTION_VAL_2X_CS },
         { "4x",         OPTION_VAL_4X_CS },
         { "8x",         OPTION_VAL_8X_CS },
         { "16x",        OPTION_VAL_16X_CS },
         { "32x",        OPTION_VAL_32X_CS },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_CS,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_CS,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_CS },
         { "uncorrected", OPTION_VAL_UNCORRECTED_CS },
         { "4:3",  OPTION_VAL_4_3_CS },
         { "ntsc", OPTION_VAL_NTSC_CS },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_CS,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_CS,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_CS,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_CS,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_CS },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_CS,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_CS,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_CS,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_CS,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_CS },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_CS,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_CS,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_CS },
         { "async",    OPTION_VAL_ASYNC_CS },
         { "precache", OPTION_VAL_PRECACHE_CS },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_CS,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_CS,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_CS },
         { "4x",          OPTION_VAL_4X_CS },
         { "6x",          OPTION_VAL_6X_CS },
         { "8x",          OPTION_VAL_8X_CS },
         { "10x",         OPTION_VAL_10X_CS },
         { "12x",         OPTION_VAL_12X_CS },
         { "14x",         OPTION_VAL_14X_CS },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_cs = {
   option_cats_cs,
   option_defs_cs
};

/* RETRO_LANGUAGE_CY */

#define CATEGORY_VIDEO_LABEL_CY NULL
#define CATEGORY_VIDEO_INFO_0_CY NULL
#define CATEGORY_OSD_LABEL_CY NULL
#define CATEGORY_OSD_INFO_0_CY NULL
#define CATEGORY_INPUT_LABEL_CY "Mewnbwn"
#define CATEGORY_INPUT_INFO_0_CY NULL
#define CATEGORY_MEMCARDS_LABEL_CY NULL
#define CATEGORY_MEMCARDS_INFO_0_CY NULL
#define CATEGORY_PGXP_LABEL_CY NULL
#define CATEGORY_PGXP_INFO_0_CY NULL
#define CATEGORY_HACKS_LABEL_CY NULL
#define CATEGORY_HACKS_INFO_0_CY NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_CY NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_CY NULL
#define OPTION_VAL_1X_NATIVE_CY NULL
#define OPTION_VAL_2X_CY NULL
#define OPTION_VAL_4X_CY NULL
#define OPTION_VAL_8X_CY NULL
#define OPTION_VAL_16X_CY NULL
#define BEETLE_OPT_DEPTH_LABEL_CY NULL
#define BEETLE_OPT_DEPTH_INFO_0_CY NULL
#define OPTION_VAL_16BPP_NATIVE_CY NULL
#define OPTION_VAL_32BPP_CY NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_CY NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_CY NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_CY NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_CY NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_CY NULL
#define BEETLE_OPT_FILTER_LABEL_CY NULL
#define BEETLE_OPT_FILTER_INFO_0_CY NULL
#define OPTION_VAL_NEAREST_CY NULL
#define OPTION_VAL_SABR_CY NULL
#define OPTION_VAL_XBR_CY NULL
#define OPTION_VAL_BILINEAR_CY NULL
#define OPTION_VAL_3_POINT_CY NULL
#define OPTION_VAL_JINC2_CY NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_CY NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_CY NULL
#define OPTION_VAL_OPAQUE_CY NULL
#define OPTION_VAL_ALL_CY NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_CY NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_CY NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_CY NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_CY NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_CY NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_CY NULL
#define BEETLE_OPT_MSAA_LABEL_CY NULL
#define BEETLE_OPT_MSAA_INFO_0_CY NULL
#define OPTION_VAL_1X_CY NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_CY NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_CY NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_CY NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_CY NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_CY NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_CY NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_CY NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_CY NULL
#define BEETLE_OPT_WIREFRAME_LABEL_CY NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_CY NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_CY NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_CY NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_CY NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_CY NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_CY NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_CY NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_CY NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_CY NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_CY NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_CY NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_CY NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_CY NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_CY NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_CY NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_CY NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_CY NULL
#define OPTION_VAL_LIGHTGUN_CY NULL
#define OPTION_VAL_TOUCHSCREEN_CY NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_CY NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_CY NULL
#define OPTION_VAL_CROSS_CY NULL
#define OPTION_VAL_DOT_CY NULL
#define OPTION_VAL_OFF_CY NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_CY NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_CY NULL
#define OPTION_VAL_RED_CY "Coch"
#define OPTION_VAL_BLUE_CY NULL
#define OPTION_VAL_GREEN_CY NULL
#define OPTION_VAL_ORANGE_CY NULL
#define OPTION_VAL_YELLOW_CY NULL
#define OPTION_VAL_CYAN_CY NULL
#define OPTION_VAL_PINK_CY NULL
#define OPTION_VAL_PURPLE_CY NULL
#define OPTION_VAL_BLACK_CY NULL
#define OPTION_VAL_WHITE_CY NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_CY NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_CY NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_CY NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_CY NULL
#define OPTION_VAL_5_CY NULL
#define OPTION_VAL_10_CY NULL
#define OPTION_VAL_15_CY NULL
#define OPTION_VAL_20_CY NULL
#define OPTION_VAL_25_CY NULL
#define OPTION_VAL_30_CY NULL
#define OPTION_VAL_35_CY NULL
#define OPTION_VAL_40_CY NULL
#define OPTION_VAL_45_CY NULL
#define OPTION_VAL_50_CY NULL
#define OPTION_VAL_55_CY NULL
#define OPTION_VAL_60_CY NULL
#define OPTION_VAL_65_CY NULL
#define OPTION_VAL_70_CY NULL
#define OPTION_VAL_75_CY NULL
#define OPTION_VAL_80_CY NULL
#define OPTION_VAL_85_CY NULL
#define OPTION_VAL_90_CY NULL
#define OPTION_VAL_95_CY NULL
#define OPTION_VAL_100_CY NULL
#define OPTION_VAL_105_CY NULL
#define OPTION_VAL_110_CY NULL
#define OPTION_VAL_115_CY NULL
#define OPTION_VAL_120_CY NULL
#define OPTION_VAL_125_CY NULL
#define OPTION_VAL_130_CY NULL
#define OPTION_VAL_135_CY NULL
#define OPTION_VAL_140_CY NULL
#define OPTION_VAL_145_CY NULL
#define OPTION_VAL_150_CY NULL
#define OPTION_VAL_155_CY NULL
#define OPTION_VAL_160_CY NULL
#define OPTION_VAL_165_CY NULL
#define OPTION_VAL_170_CY NULL
#define OPTION_VAL_175_CY NULL
#define OPTION_VAL_180_CY NULL
#define OPTION_VAL_185_CY NULL
#define OPTION_VAL_190_CY NULL
#define OPTION_VAL_195_CY NULL
#define OPTION_VAL_200_CY NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_CY NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_CY NULL
#define OPTION_VAL_LINEAR_CY NULL
#define OPTION_VAL_QUADRATIC_CY NULL
#define OPTION_VAL_CUBIC_CY NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_CY NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_CY NULL
#define OPTION_VAL_0_CY NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_CY NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_CY NULL
#define OPTION_VAL_LIBRETRO_CY NULL
#define OPTION_VAL_MEDNAFEN_CY NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_CY NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_CY NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_CY NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_CY NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_CY NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_CY NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_CY NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_CY NULL
#define OPTION_VAL_1_CY NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_CY NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_CY NULL
#define OPTION_VAL_MEMORY_ONLY_CY NULL
#define OPTION_VAL_MEMORY_CPU_CY NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_CY NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_CY NULL
#define OPTION_VAL_0PX_CY NULL
#define OPTION_VAL_1PX_CY NULL
#define OPTION_VAL_2PX_CY NULL
#define OPTION_VAL_3PX_CY NULL
#define OPTION_VAL_4PX_CY NULL
#define OPTION_VAL_5PX_CY NULL
#define OPTION_VAL_6PX_CY NULL
#define OPTION_VAL_7PX_CY NULL
#define OPTION_VAL_8PX_CY NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_CY NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_CY NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_CY NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_CY NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_CY NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_CY NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_CY NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_CY NULL
#define OPTION_VAL_DEFAULT_CY NULL
#define OPTION_VAL_AGGRESSIVE_CY NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_CY NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_CY NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_CY NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_CY NULL
#define OPTION_VAL_16_9_CY NULL
#define OPTION_VAL_16_10_CY NULL
#define OPTION_VAL_18_9_CY NULL
#define OPTION_VAL_19_9_CY NULL
#define OPTION_VAL_20_9_CY NULL
#define OPTION_VAL_21_9_CY NULL
#define OPTION_VAL_32_9_CY NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_CY NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_CY NULL
#define OPTION_VAL_100_NATIVE_CY NULL
#define OPTION_VAL_210_CY NULL
#define OPTION_VAL_220_CY NULL
#define OPTION_VAL_230_CY NULL
#define OPTION_VAL_240_CY NULL
#define OPTION_VAL_250_CY NULL
#define OPTION_VAL_260_CY NULL
#define OPTION_VAL_270_CY NULL
#define OPTION_VAL_280_CY NULL
#define OPTION_VAL_290_CY NULL
#define OPTION_VAL_300_CY NULL
#define OPTION_VAL_310_CY NULL
#define OPTION_VAL_320_CY NULL
#define OPTION_VAL_330_CY NULL
#define OPTION_VAL_340_CY NULL
#define OPTION_VAL_350_CY NULL
#define OPTION_VAL_360_CY NULL
#define OPTION_VAL_370_CY NULL
#define OPTION_VAL_380_CY NULL
#define OPTION_VAL_390_CY NULL
#define OPTION_VAL_400_CY NULL
#define OPTION_VAL_410_CY NULL
#define OPTION_VAL_420_CY NULL
#define OPTION_VAL_430_CY NULL
#define OPTION_VAL_440_CY NULL
#define OPTION_VAL_450_CY NULL
#define OPTION_VAL_460_CY NULL
#define OPTION_VAL_470_CY NULL
#define OPTION_VAL_480_CY NULL
#define OPTION_VAL_490_CY NULL
#define OPTION_VAL_500_CY NULL
#define OPTION_VAL_510_CY NULL
#define OPTION_VAL_520_CY NULL
#define OPTION_VAL_530_CY NULL
#define OPTION_VAL_540_CY NULL
#define OPTION_VAL_550_CY NULL
#define OPTION_VAL_560_CY NULL
#define OPTION_VAL_570_CY NULL
#define OPTION_VAL_580_CY NULL
#define OPTION_VAL_590_CY NULL
#define OPTION_VAL_600_CY NULL
#define OPTION_VAL_610_CY NULL
#define OPTION_VAL_620_CY NULL
#define OPTION_VAL_630_CY NULL
#define OPTION_VAL_640_CY NULL
#define OPTION_VAL_650_CY NULL
#define OPTION_VAL_660_CY NULL
#define OPTION_VAL_670_CY NULL
#define OPTION_VAL_680_CY NULL
#define OPTION_VAL_690_CY NULL
#define OPTION_VAL_700_CY NULL
#define OPTION_VAL_710_CY NULL
#define OPTION_VAL_720_CY NULL
#define OPTION_VAL_730_CY NULL
#define OPTION_VAL_740_CY NULL
#define OPTION_VAL_750_CY NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_CY NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_CY NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_CY NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_CY NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_CY NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_CY NULL
#define OPTION_VAL_PSXONPSP_CY NULL
#define OPTION_VAL_PS1_ROM_CY NULL
#define BEETLE_OPT_RENDERER_LABEL_CY NULL
#define BEETLE_OPT_RENDERER_INFO_0_CY NULL
#define OPTION_VAL_HARDWARE_CY NULL
#define OPTION_VAL_HARDWARE_GL_CY NULL
#define OPTION_VAL_HARDWARE_VK_CY NULL
#define OPTION_VAL_SOFTWARE_CY NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_CY NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_CY NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_CY NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_CY NULL
#define OPTION_VAL_DISABLED_CY NULL
#define OPTION_VAL_EXECUTE_CY NULL
#define OPTION_VAL_EXECUTE_ONE_CY NULL
#define OPTION_VAL_RUN_INTERPRETER_CY NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_CY NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_CY NULL
#define OPTION_VAL_FULL_CY NULL
#define OPTION_VAL_DMA_CY NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_CY NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_CY NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_CY NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_CY NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_CY NULL
#define OPTION_VAL_FORCE_INTERLACED_CY NULL
#define OPTION_VAL_AUTO_TOGGLE_CY NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_CY NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_CY NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_CY NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_CY NULL
#define OPTION_VAL_DISABLED_O53_CY "Dim"
#define OPTION_VAL_STATIC_CY NULL
#define OPTION_VAL_SMART_CY NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_CY NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_CY NULL
#define OPTION_VAL_9PX_CY NULL
#define OPTION_VAL_10PX_CY NULL
#define OPTION_VAL_11PX_CY NULL
#define OPTION_VAL_12PX_CY NULL
#define OPTION_VAL_13PX_CY NULL
#define OPTION_VAL_14PX_CY NULL
#define OPTION_VAL_15PX_CY NULL
#define OPTION_VAL_16PX_CY NULL
#define OPTION_VAL_17PX_CY NULL
#define OPTION_VAL_18PX_CY NULL
#define OPTION_VAL_19PX_CY NULL
#define OPTION_VAL_20PX_CY NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_CY NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_CY NULL
#define OPTION_VAL_12PX_O55_CY NULL
#define OPTION_VAL_11PX_O55_CY NULL
#define OPTION_VAL_10PX_O55_CY NULL
#define OPTION_VAL_9PX_O55_CY NULL
#define OPTION_VAL_8PX_O55_CY NULL
#define OPTION_VAL_7PX_O55_CY NULL
#define OPTION_VAL_6PX_O55_CY NULL
#define OPTION_VAL_5PX_O55_CY NULL
#define OPTION_VAL_4PX_O55_CY NULL
#define OPTION_VAL_3PX_O55_CY NULL
#define OPTION_VAL_2PX_O55_CY NULL
#define OPTION_VAL_1PX_O55_CY NULL
#define OPTION_VAL_DISABLED_O55_CY NULL
#define OPTION_VAL_1PX_O55_0_CY NULL
#define OPTION_VAL_2PX_O55_0_CY NULL
#define OPTION_VAL_3PX_O55_0_CY NULL
#define OPTION_VAL_4PX_O55_0_CY NULL
#define OPTION_VAL_5PX_O55_0_CY NULL
#define OPTION_VAL_6PX_O55_0_CY NULL
#define OPTION_VAL_7PX_O55_0_CY NULL
#define OPTION_VAL_8PX_O55_0_CY NULL
#define OPTION_VAL_9PX_O55_0_CY NULL
#define OPTION_VAL_10PX_O55_0_CY NULL
#define OPTION_VAL_11PX_O55_0_CY NULL
#define OPTION_VAL_12PX_O55_0_CY NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_CY NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_CY NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_CY NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_CY NULL
#define OPTION_VAL_32X_CY NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_CY NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_CY NULL
#define OPTION_VAL_CORRECTED_CY NULL
#define OPTION_VAL_UNCORRECTED_CY NULL
#define OPTION_VAL_4_3_CY NULL
#define OPTION_VAL_NTSC_CY NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_CY NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_CY NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_CY NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_CY NULL
#define OPTION_VAL_239_CY NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_CY NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_CY NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_CY NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_CY NULL
#define OPTION_VAL_287_CY NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_CY NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_CY NULL
#define OPTION_VAL_SYNC_CY NULL
#define OPTION_VAL_ASYNC_CY NULL
#define OPTION_VAL_PRECACHE_CY NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_CY NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_CY NULL
#define OPTION_VAL_2X_NATIVE_CY NULL
#define OPTION_VAL_6X_CY NULL
#define OPTION_VAL_10X_CY NULL
#define OPTION_VAL_12X_CY NULL
#define OPTION_VAL_14X_CY NULL

struct retro_core_option_v2_category option_cats_cy[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_CY,
      CATEGORY_VIDEO_INFO_0_CY
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_CY,
      CATEGORY_OSD_INFO_0_CY
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_CY,
      CATEGORY_INPUT_INFO_0_CY
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_CY,
      CATEGORY_MEMCARDS_INFO_0_CY
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_CY,
      CATEGORY_PGXP_INFO_0_CY
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_CY,
      CATEGORY_HACKS_INFO_0_CY
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_cy[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_CY,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_CY,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_CY },
         { "2x",         OPTION_VAL_2X_CY },
         { "4x",         OPTION_VAL_4X_CY },
         { "8x",         OPTION_VAL_8X_CY },
         { "16x",        OPTION_VAL_16X_CY },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_CY,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_CY,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_CY },
         { "32bpp",         OPTION_VAL_32BPP_CY },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_CY,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_CY,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_CY },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_CY },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_CY,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_CY,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_CY,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_CY,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_CY },
         { "SABR",     OPTION_VAL_SABR_CY },
         { "xBR",      OPTION_VAL_XBR_CY },
         { "bilinear", OPTION_VAL_BILINEAR_CY },
         { "3-point",  OPTION_VAL_3_POINT_CY },
         { "JINC2",    OPTION_VAL_JINC2_CY },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_CY,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_CY,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_CY },
         { "all", OPTION_VAL_ALL_CY },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_CY,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_CY,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_CY },
         { "all", OPTION_VAL_ALL_CY },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_CY,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_CY,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_CY,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_CY,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_CY,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_CY,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_CY },
         { "2x",  OPTION_VAL_2X_CY },
         { "4x",  OPTION_VAL_4X_CY },
         { "8x",  OPTION_VAL_8X_CY },
         { "16x", OPTION_VAL_16X_CY },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_CY,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_CY,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_CY,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_CY,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_CY,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_CY,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_CY,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_CY,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_CY,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_CY,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_CY,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_CY,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_CY,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_CY,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_CY,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_CY,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_CY,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_CY,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_CY,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_CY,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_CY,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_CY,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_CY,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_CY,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_CY,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_CY,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_CY },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_CY },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_CY,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_CY,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_CY },
         { "dot",   OPTION_VAL_DOT_CY },
         { "off",   OPTION_VAL_OFF_CY },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_CY,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_CY,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_CY },
         { "blue", OPTION_VAL_BLUE_CY },
         { "green", OPTION_VAL_GREEN_CY },
         { "orange", OPTION_VAL_ORANGE_CY },
         { "yellow", OPTION_VAL_YELLOW_CY },
         { "cyan", OPTION_VAL_CYAN_CY },
         { "pink", OPTION_VAL_PINK_CY },
         { "purple", OPTION_VAL_PURPLE_CY },
         { "black", OPTION_VAL_BLACK_CY },
         { "white", OPTION_VAL_WHITE_CY },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_CY,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_CY,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_CY },
         { "red", OPTION_VAL_RED_CY },
         { "green", OPTION_VAL_GREEN_CY },
         { "orange", OPTION_VAL_ORANGE_CY },
         { "yellow", OPTION_VAL_YELLOW_CY },
         { "cyan", OPTION_VAL_CYAN_CY },
         { "pink", OPTION_VAL_PINK_CY },
         { "purple", OPTION_VAL_PURPLE_CY },
         { "black", OPTION_VAL_BLACK_CY },
         { "white", OPTION_VAL_WHITE_CY },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_CY,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_CY,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_CY },
         { "10%",  OPTION_VAL_10_CY },
         { "15%",  OPTION_VAL_15_CY },
         { "20%",  OPTION_VAL_20_CY },
         { "25%",  OPTION_VAL_25_CY },
         { "30%",  OPTION_VAL_30_CY },
         { "35%",  OPTION_VAL_35_CY },
         { "40%",  OPTION_VAL_40_CY },
         { "45%",  OPTION_VAL_45_CY },
         { "50%",  OPTION_VAL_50_CY },
         { "55%",  OPTION_VAL_55_CY },
         { "60%",  OPTION_VAL_60_CY },
         { "65%",  OPTION_VAL_65_CY },
         { "70%",  OPTION_VAL_70_CY },
         { "75%",  OPTION_VAL_75_CY },
         { "80%",  OPTION_VAL_80_CY },
         { "85%",  OPTION_VAL_85_CY },
         { "90%",  OPTION_VAL_90_CY },
         { "95%",  OPTION_VAL_95_CY },
         { "100%", OPTION_VAL_100_CY },
         { "105%", OPTION_VAL_105_CY },
         { "110%", OPTION_VAL_110_CY },
         { "115%", OPTION_VAL_115_CY },
         { "120%", OPTION_VAL_120_CY },
         { "125%", OPTION_VAL_125_CY },
         { "130%", OPTION_VAL_130_CY },
         { "135%", OPTION_VAL_135_CY },
         { "140%", OPTION_VAL_140_CY },
         { "145%", OPTION_VAL_145_CY },
         { "150%", OPTION_VAL_150_CY },
         { "155%", OPTION_VAL_155_CY },
         { "160%", OPTION_VAL_160_CY },
         { "165%", OPTION_VAL_165_CY },
         { "170%", OPTION_VAL_170_CY },
         { "175%", OPTION_VAL_175_CY },
         { "180%", OPTION_VAL_180_CY },
         { "185%", OPTION_VAL_185_CY },
         { "190%", OPTION_VAL_190_CY },
         { "195%", OPTION_VAL_195_CY },
         { "200%", OPTION_VAL_200_CY },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_CY,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_CY,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_CY },
         { "quadratic", OPTION_VAL_QUADRATIC_CY },
         { "cubic",     OPTION_VAL_CUBIC_CY },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_CY,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_CY,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_CY },
         { "5%",  OPTION_VAL_5_CY },
         { "10%", OPTION_VAL_10_CY },
         { "15%", OPTION_VAL_15_CY },
         { "20%", OPTION_VAL_20_CY },
         { "25%", OPTION_VAL_25_CY },
         { "30%", OPTION_VAL_30_CY },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_CY,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_CY,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_CY },
         { "mednafen", OPTION_VAL_MEDNAFEN_CY },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_CY,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_CY,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_CY,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_CY,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_CY,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_CY,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_CY,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_CY,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_CY },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_CY,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_CY,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_CY },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_CY },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_CY,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_CY,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_CY },
         { "1px", OPTION_VAL_1PX_CY },
         { "2px", OPTION_VAL_2PX_CY },
         { "3px", OPTION_VAL_3PX_CY },
         { "4px", OPTION_VAL_4PX_CY },
         { "5px", OPTION_VAL_5PX_CY },
         { "6px", OPTION_VAL_6PX_CY },
         { "7px", OPTION_VAL_7PX_CY },
         { "8px", OPTION_VAL_8PX_CY },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_CY,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_CY,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_CY,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_CY,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_CY,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_CY,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_CY,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_CY,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_CY },
         { "aggressive", OPTION_VAL_AGGRESSIVE_CY },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_CY,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_CY,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_CY,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_CY,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_CY },
         { "16:10", OPTION_VAL_16_10_CY },
         { "18:9",  OPTION_VAL_18_9_CY },
         { "19:9",  OPTION_VAL_19_9_CY },
         { "20:9",  OPTION_VAL_20_9_CY },
         { "21:9",  OPTION_VAL_21_9_CY }, // 64:27
         { "32:9",  OPTION_VAL_32_9_CY },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_CY,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_CY,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_CY },
         { "60%",           OPTION_VAL_60_CY },
         { "70%",           OPTION_VAL_70_CY },
         { "80%",           OPTION_VAL_80_CY },
         { "90%",           OPTION_VAL_90_CY },
         { "100%(native)", OPTION_VAL_100_NATIVE_CY },
         { "110%",          OPTION_VAL_110_CY },
         { "120%",          OPTION_VAL_120_CY },
         { "130%",          OPTION_VAL_130_CY },
         { "140%",          OPTION_VAL_140_CY },
         { "150%",          OPTION_VAL_150_CY },
         { "160%",          OPTION_VAL_160_CY },
         { "170%",          OPTION_VAL_170_CY },
         { "180%",          OPTION_VAL_180_CY },
         { "190%",          OPTION_VAL_190_CY },
         { "200%",          OPTION_VAL_200_CY },
         { "210%",          OPTION_VAL_210_CY },
         { "220%",          OPTION_VAL_220_CY },
         { "230%",          OPTION_VAL_230_CY },
         { "240%",          OPTION_VAL_240_CY },
         { "250%",          OPTION_VAL_250_CY },
         { "260%",          OPTION_VAL_260_CY },
         { "270%",          OPTION_VAL_270_CY },
         { "280%",          OPTION_VAL_280_CY },
         { "290%",          OPTION_VAL_290_CY },
         { "300%",          OPTION_VAL_300_CY },
         { "310%",          OPTION_VAL_310_CY },
         { "320%",          OPTION_VAL_320_CY },
         { "330%",          OPTION_VAL_330_CY },
         { "340%",          OPTION_VAL_340_CY },
         { "350%",          OPTION_VAL_350_CY },
         { "360%",          OPTION_VAL_360_CY },
         { "370%",          OPTION_VAL_370_CY },
         { "380%",          OPTION_VAL_380_CY },
         { "390%",          OPTION_VAL_390_CY },
         { "400%",          OPTION_VAL_400_CY },
         { "410%",          OPTION_VAL_410_CY },
         { "420%",          OPTION_VAL_420_CY },
         { "430%",          OPTION_VAL_430_CY },
         { "440%",          OPTION_VAL_440_CY },
         { "450%",          OPTION_VAL_450_CY },
         { "460%",          OPTION_VAL_460_CY },
         { "470%",          OPTION_VAL_470_CY },
         { "480%",          OPTION_VAL_480_CY },
         { "490%",          OPTION_VAL_490_CY },
         { "500%",          OPTION_VAL_500_CY },
         { "510%",          OPTION_VAL_510_CY },
         { "520%",          OPTION_VAL_520_CY },
         { "530%",          OPTION_VAL_530_CY },
         { "540%",          OPTION_VAL_540_CY },
         { "550%",          OPTION_VAL_550_CY },
         { "560%",          OPTION_VAL_560_CY },
         { "570%",          OPTION_VAL_570_CY },
         { "580%",          OPTION_VAL_580_CY },
         { "590%",          OPTION_VAL_590_CY },
         { "600%",          OPTION_VAL_600_CY },
         { "610%",          OPTION_VAL_610_CY },
         { "620%",          OPTION_VAL_620_CY },
         { "630%",          OPTION_VAL_630_CY },
         { "640%",          OPTION_VAL_640_CY },
         { "650%",          OPTION_VAL_650_CY },
         { "660%",          OPTION_VAL_660_CY },
         { "670%",          OPTION_VAL_670_CY },
         { "680%",          OPTION_VAL_680_CY },
         { "690%",          OPTION_VAL_690_CY },
         { "700%",          OPTION_VAL_700_CY },
         { "710%",          OPTION_VAL_710_CY },
         { "720%",          OPTION_VAL_720_CY },
         { "730%",          OPTION_VAL_730_CY },
         { "740%",          OPTION_VAL_740_CY },
         { "750%",          OPTION_VAL_750_CY },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_CY,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_CY,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_CY,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_CY,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_CY,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_CY,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_CY },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_CY },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_CY,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_CY,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_CY },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_CY },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_CY },
#endif
         { "software",    OPTION_VAL_SOFTWARE_CY },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_CY,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_CY,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_CY,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_CY,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_CY },
         { "execute",  OPTION_VAL_EXECUTE_CY },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_CY },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_CY },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_CY,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_CY,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_CY },
         { "dma",  OPTION_VAL_DMA_CY },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_CY,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_CY,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_CY,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_CY,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_CY },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_CY },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_CY },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_CY,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_CY,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_CY,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_CY,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_CY },
         { "static",  OPTION_VAL_STATIC_CY },
         { "smart", OPTION_VAL_SMART_CY },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_CY,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_CY,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_CY },
         { "2px",      OPTION_VAL_2PX_CY },
         { "3px",      OPTION_VAL_3PX_CY },
         { "4px",      OPTION_VAL_4PX_CY },
         { "5px",      OPTION_VAL_5PX_CY },
         { "6px",      OPTION_VAL_6PX_CY },
         { "7px",      OPTION_VAL_7PX_CY },
         { "8px",      OPTION_VAL_8PX_CY },
         { "9px",      OPTION_VAL_9PX_CY },
         { "10px",     OPTION_VAL_10PX_CY },
         { "11px",     OPTION_VAL_11PX_CY },
         { "12px",     OPTION_VAL_12PX_CY },
         { "13px",     OPTION_VAL_13PX_CY },
         { "14px",     OPTION_VAL_14PX_CY },
         { "15px",     OPTION_VAL_15PX_CY },
         { "16px",     OPTION_VAL_16PX_CY },
         { "17px",     OPTION_VAL_17PX_CY },
         { "18px",     OPTION_VAL_18PX_CY },
         { "19px",     OPTION_VAL_19PX_CY },
         { "20px",     OPTION_VAL_20PX_CY },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_CY,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_CY,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_CY },
         { "-11px",    OPTION_VAL_11PX_O55_CY },
         { "-10px",    OPTION_VAL_10PX_O55_CY },
         { "-9px",     OPTION_VAL_9PX_O55_CY },
         { "-8px",     OPTION_VAL_8PX_O55_CY },
         { "-7px",     OPTION_VAL_7PX_O55_CY },
         { "-6px",     OPTION_VAL_6PX_O55_CY },
         { "-5px",     OPTION_VAL_5PX_O55_CY },
         { "-4px",     OPTION_VAL_4PX_O55_CY },
         { "-3px",     OPTION_VAL_3PX_O55_CY },
         { "-2px",     OPTION_VAL_2PX_O55_CY },
         { "-1px",     OPTION_VAL_1PX_O55_CY },
         { "disabled", OPTION_VAL_DISABLED_O55_CY },
         { "+1px",     OPTION_VAL_1PX_O55_0_CY },
         { "+2px",     OPTION_VAL_2PX_O55_0_CY },
         { "+3px",     OPTION_VAL_3PX_O55_0_CY },
         { "+4px",     OPTION_VAL_4PX_O55_0_CY },
         { "+5px",     OPTION_VAL_5PX_O55_0_CY },
         { "+6px",     OPTION_VAL_6PX_O55_0_CY },
         { "+7px",     OPTION_VAL_7PX_O55_0_CY },
         { "+8px",     OPTION_VAL_8PX_O55_0_CY },
         { "+9px",     OPTION_VAL_9PX_O55_0_CY },
         { "+10px",    OPTION_VAL_10PX_O55_0_CY },
         { "+11px",    OPTION_VAL_11PX_O55_0_CY },
         { "+12px",    OPTION_VAL_12PX_O55_0_CY },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_CY,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_CY,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_CY },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_CY,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_CY,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_CY },
         { "2x",         OPTION_VAL_2X_CY },
         { "4x",         OPTION_VAL_4X_CY },
         { "8x",         OPTION_VAL_8X_CY },
         { "16x",        OPTION_VAL_16X_CY },
         { "32x",        OPTION_VAL_32X_CY },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_CY,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_CY,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_CY },
         { "uncorrected", OPTION_VAL_UNCORRECTED_CY },
         { "4:3",  OPTION_VAL_4_3_CY },
         { "ntsc", OPTION_VAL_NTSC_CY },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_CY,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_CY,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_CY,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_CY,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_CY },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_CY,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_CY,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_CY,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_CY,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_CY },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_CY,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_CY,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_CY },
         { "async",    OPTION_VAL_ASYNC_CY },
         { "precache", OPTION_VAL_PRECACHE_CY },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_CY,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_CY,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_CY },
         { "4x",          OPTION_VAL_4X_CY },
         { "6x",          OPTION_VAL_6X_CY },
         { "8x",          OPTION_VAL_8X_CY },
         { "10x",         OPTION_VAL_10X_CY },
         { "12x",         OPTION_VAL_12X_CY },
         { "14x",         OPTION_VAL_14X_CY },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_cy = {
   option_cats_cy,
   option_defs_cy
};

/* RETRO_LANGUAGE_DA */

#define CATEGORY_VIDEO_LABEL_DA NULL
#define CATEGORY_VIDEO_INFO_0_DA NULL
#define CATEGORY_OSD_LABEL_DA NULL
#define CATEGORY_OSD_INFO_0_DA NULL
#define CATEGORY_INPUT_LABEL_DA NULL
#define CATEGORY_INPUT_INFO_0_DA NULL
#define CATEGORY_MEMCARDS_LABEL_DA NULL
#define CATEGORY_MEMCARDS_INFO_0_DA NULL
#define CATEGORY_PGXP_LABEL_DA NULL
#define CATEGORY_PGXP_INFO_0_DA NULL
#define CATEGORY_HACKS_LABEL_DA NULL
#define CATEGORY_HACKS_INFO_0_DA NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_DA NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_DA NULL
#define OPTION_VAL_1X_NATIVE_DA NULL
#define OPTION_VAL_2X_DA NULL
#define OPTION_VAL_4X_DA NULL
#define OPTION_VAL_8X_DA NULL
#define OPTION_VAL_16X_DA NULL
#define BEETLE_OPT_DEPTH_LABEL_DA NULL
#define BEETLE_OPT_DEPTH_INFO_0_DA NULL
#define OPTION_VAL_16BPP_NATIVE_DA NULL
#define OPTION_VAL_32BPP_DA NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_DA NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_DA NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_DA NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_DA NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_DA NULL
#define BEETLE_OPT_FILTER_LABEL_DA NULL
#define BEETLE_OPT_FILTER_INFO_0_DA NULL
#define OPTION_VAL_NEAREST_DA NULL
#define OPTION_VAL_SABR_DA NULL
#define OPTION_VAL_XBR_DA NULL
#define OPTION_VAL_BILINEAR_DA NULL
#define OPTION_VAL_3_POINT_DA NULL
#define OPTION_VAL_JINC2_DA NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_DA NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_DA NULL
#define OPTION_VAL_OPAQUE_DA NULL
#define OPTION_VAL_ALL_DA NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_DA NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_DA NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_DA NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_DA NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_DA NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_DA NULL
#define BEETLE_OPT_MSAA_LABEL_DA NULL
#define BEETLE_OPT_MSAA_INFO_0_DA NULL
#define OPTION_VAL_1X_DA NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_DA NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_DA NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_DA NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_DA NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_DA NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_DA NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_DA NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_DA NULL
#define BEETLE_OPT_WIREFRAME_LABEL_DA NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_DA NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_DA NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_DA NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_DA NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_DA NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_DA NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_DA NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_DA NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_DA NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_DA NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_DA NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_DA NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_DA NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_DA NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_DA NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_DA NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_DA NULL
#define OPTION_VAL_LIGHTGUN_DA NULL
#define OPTION_VAL_TOUCHSCREEN_DA NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_DA NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_DA NULL
#define OPTION_VAL_CROSS_DA NULL
#define OPTION_VAL_DOT_DA NULL
#define OPTION_VAL_OFF_DA NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_DA NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_DA NULL
#define OPTION_VAL_RED_DA NULL
#define OPTION_VAL_BLUE_DA NULL
#define OPTION_VAL_GREEN_DA NULL
#define OPTION_VAL_ORANGE_DA NULL
#define OPTION_VAL_YELLOW_DA NULL
#define OPTION_VAL_CYAN_DA NULL
#define OPTION_VAL_PINK_DA NULL
#define OPTION_VAL_PURPLE_DA NULL
#define OPTION_VAL_BLACK_DA NULL
#define OPTION_VAL_WHITE_DA NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_DA NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_DA NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_DA NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_DA NULL
#define OPTION_VAL_5_DA NULL
#define OPTION_VAL_10_DA NULL
#define OPTION_VAL_15_DA NULL
#define OPTION_VAL_20_DA NULL
#define OPTION_VAL_25_DA NULL
#define OPTION_VAL_30_DA NULL
#define OPTION_VAL_35_DA NULL
#define OPTION_VAL_40_DA NULL
#define OPTION_VAL_45_DA NULL
#define OPTION_VAL_50_DA NULL
#define OPTION_VAL_55_DA NULL
#define OPTION_VAL_60_DA NULL
#define OPTION_VAL_65_DA NULL
#define OPTION_VAL_70_DA NULL
#define OPTION_VAL_75_DA NULL
#define OPTION_VAL_80_DA NULL
#define OPTION_VAL_85_DA NULL
#define OPTION_VAL_90_DA NULL
#define OPTION_VAL_95_DA NULL
#define OPTION_VAL_100_DA NULL
#define OPTION_VAL_105_DA NULL
#define OPTION_VAL_110_DA NULL
#define OPTION_VAL_115_DA NULL
#define OPTION_VAL_120_DA NULL
#define OPTION_VAL_125_DA NULL
#define OPTION_VAL_130_DA NULL
#define OPTION_VAL_135_DA NULL
#define OPTION_VAL_140_DA NULL
#define OPTION_VAL_145_DA NULL
#define OPTION_VAL_150_DA NULL
#define OPTION_VAL_155_DA NULL
#define OPTION_VAL_160_DA NULL
#define OPTION_VAL_165_DA NULL
#define OPTION_VAL_170_DA NULL
#define OPTION_VAL_175_DA NULL
#define OPTION_VAL_180_DA NULL
#define OPTION_VAL_185_DA NULL
#define OPTION_VAL_190_DA NULL
#define OPTION_VAL_195_DA NULL
#define OPTION_VAL_200_DA NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_DA NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_DA NULL
#define OPTION_VAL_LINEAR_DA NULL
#define OPTION_VAL_QUADRATIC_DA NULL
#define OPTION_VAL_CUBIC_DA NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_DA NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_DA NULL
#define OPTION_VAL_0_DA NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_DA NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_DA NULL
#define OPTION_VAL_LIBRETRO_DA NULL
#define OPTION_VAL_MEDNAFEN_DA NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_DA NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_DA NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_DA NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_DA NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_DA NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_DA NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_DA NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_DA NULL
#define OPTION_VAL_1_DA NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_DA NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_DA NULL
#define OPTION_VAL_MEMORY_ONLY_DA NULL
#define OPTION_VAL_MEMORY_CPU_DA NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_DA NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_DA NULL
#define OPTION_VAL_0PX_DA NULL
#define OPTION_VAL_1PX_DA NULL
#define OPTION_VAL_2PX_DA NULL
#define OPTION_VAL_3PX_DA NULL
#define OPTION_VAL_4PX_DA NULL
#define OPTION_VAL_5PX_DA NULL
#define OPTION_VAL_6PX_DA NULL
#define OPTION_VAL_7PX_DA NULL
#define OPTION_VAL_8PX_DA NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_DA NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_DA NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_DA NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_DA NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_DA NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_DA NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_DA NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_DA NULL
#define OPTION_VAL_DEFAULT_DA NULL
#define OPTION_VAL_AGGRESSIVE_DA NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_DA NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_DA NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_DA NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_DA NULL
#define OPTION_VAL_16_9_DA NULL
#define OPTION_VAL_16_10_DA NULL
#define OPTION_VAL_18_9_DA NULL
#define OPTION_VAL_19_9_DA NULL
#define OPTION_VAL_20_9_DA NULL
#define OPTION_VAL_21_9_DA NULL
#define OPTION_VAL_32_9_DA NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_DA NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_DA NULL
#define OPTION_VAL_100_NATIVE_DA NULL
#define OPTION_VAL_210_DA NULL
#define OPTION_VAL_220_DA NULL
#define OPTION_VAL_230_DA NULL
#define OPTION_VAL_240_DA NULL
#define OPTION_VAL_250_DA NULL
#define OPTION_VAL_260_DA NULL
#define OPTION_VAL_270_DA NULL
#define OPTION_VAL_280_DA NULL
#define OPTION_VAL_290_DA NULL
#define OPTION_VAL_300_DA NULL
#define OPTION_VAL_310_DA NULL
#define OPTION_VAL_320_DA NULL
#define OPTION_VAL_330_DA NULL
#define OPTION_VAL_340_DA NULL
#define OPTION_VAL_350_DA NULL
#define OPTION_VAL_360_DA NULL
#define OPTION_VAL_370_DA NULL
#define OPTION_VAL_380_DA NULL
#define OPTION_VAL_390_DA NULL
#define OPTION_VAL_400_DA NULL
#define OPTION_VAL_410_DA NULL
#define OPTION_VAL_420_DA NULL
#define OPTION_VAL_430_DA NULL
#define OPTION_VAL_440_DA NULL
#define OPTION_VAL_450_DA NULL
#define OPTION_VAL_460_DA NULL
#define OPTION_VAL_470_DA NULL
#define OPTION_VAL_480_DA NULL
#define OPTION_VAL_490_DA NULL
#define OPTION_VAL_500_DA NULL
#define OPTION_VAL_510_DA NULL
#define OPTION_VAL_520_DA NULL
#define OPTION_VAL_530_DA NULL
#define OPTION_VAL_540_DA NULL
#define OPTION_VAL_550_DA NULL
#define OPTION_VAL_560_DA NULL
#define OPTION_VAL_570_DA NULL
#define OPTION_VAL_580_DA NULL
#define OPTION_VAL_590_DA NULL
#define OPTION_VAL_600_DA NULL
#define OPTION_VAL_610_DA NULL
#define OPTION_VAL_620_DA NULL
#define OPTION_VAL_630_DA NULL
#define OPTION_VAL_640_DA NULL
#define OPTION_VAL_650_DA NULL
#define OPTION_VAL_660_DA NULL
#define OPTION_VAL_670_DA NULL
#define OPTION_VAL_680_DA NULL
#define OPTION_VAL_690_DA NULL
#define OPTION_VAL_700_DA NULL
#define OPTION_VAL_710_DA NULL
#define OPTION_VAL_720_DA NULL
#define OPTION_VAL_730_DA NULL
#define OPTION_VAL_740_DA NULL
#define OPTION_VAL_750_DA NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_DA NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_DA NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_DA NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_DA NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_DA NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_DA NULL
#define OPTION_VAL_PSXONPSP_DA NULL
#define OPTION_VAL_PS1_ROM_DA NULL
#define BEETLE_OPT_RENDERER_LABEL_DA NULL
#define BEETLE_OPT_RENDERER_INFO_0_DA NULL
#define OPTION_VAL_HARDWARE_DA NULL
#define OPTION_VAL_HARDWARE_GL_DA NULL
#define OPTION_VAL_HARDWARE_VK_DA NULL
#define OPTION_VAL_SOFTWARE_DA NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_DA NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_DA NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_DA NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_DA NULL
#define OPTION_VAL_DISABLED_DA NULL
#define OPTION_VAL_EXECUTE_DA NULL
#define OPTION_VAL_EXECUTE_ONE_DA NULL
#define OPTION_VAL_RUN_INTERPRETER_DA NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_DA NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_DA NULL
#define OPTION_VAL_FULL_DA NULL
#define OPTION_VAL_DMA_DA NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_DA NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_DA NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_DA NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_DA NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_DA NULL
#define OPTION_VAL_FORCE_INTERLACED_DA NULL
#define OPTION_VAL_AUTO_TOGGLE_DA NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_DA NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_DA NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_DA NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_DA NULL
#define OPTION_VAL_DISABLED_O53_DA NULL
#define OPTION_VAL_STATIC_DA NULL
#define OPTION_VAL_SMART_DA NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_DA NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_DA NULL
#define OPTION_VAL_9PX_DA NULL
#define OPTION_VAL_10PX_DA NULL
#define OPTION_VAL_11PX_DA NULL
#define OPTION_VAL_12PX_DA NULL
#define OPTION_VAL_13PX_DA NULL
#define OPTION_VAL_14PX_DA NULL
#define OPTION_VAL_15PX_DA NULL
#define OPTION_VAL_16PX_DA NULL
#define OPTION_VAL_17PX_DA NULL
#define OPTION_VAL_18PX_DA NULL
#define OPTION_VAL_19PX_DA NULL
#define OPTION_VAL_20PX_DA NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_DA NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_DA NULL
#define OPTION_VAL_12PX_O55_DA NULL
#define OPTION_VAL_11PX_O55_DA NULL
#define OPTION_VAL_10PX_O55_DA NULL
#define OPTION_VAL_9PX_O55_DA NULL
#define OPTION_VAL_8PX_O55_DA NULL
#define OPTION_VAL_7PX_O55_DA NULL
#define OPTION_VAL_6PX_O55_DA NULL
#define OPTION_VAL_5PX_O55_DA NULL
#define OPTION_VAL_4PX_O55_DA NULL
#define OPTION_VAL_3PX_O55_DA NULL
#define OPTION_VAL_2PX_O55_DA NULL
#define OPTION_VAL_1PX_O55_DA NULL
#define OPTION_VAL_DISABLED_O55_DA NULL
#define OPTION_VAL_1PX_O55_0_DA NULL
#define OPTION_VAL_2PX_O55_0_DA NULL
#define OPTION_VAL_3PX_O55_0_DA NULL
#define OPTION_VAL_4PX_O55_0_DA NULL
#define OPTION_VAL_5PX_O55_0_DA NULL
#define OPTION_VAL_6PX_O55_0_DA NULL
#define OPTION_VAL_7PX_O55_0_DA NULL
#define OPTION_VAL_8PX_O55_0_DA NULL
#define OPTION_VAL_9PX_O55_0_DA NULL
#define OPTION_VAL_10PX_O55_0_DA NULL
#define OPTION_VAL_11PX_O55_0_DA NULL
#define OPTION_VAL_12PX_O55_0_DA NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_DA NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_DA NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_DA NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_DA NULL
#define OPTION_VAL_32X_DA NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_DA NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_DA NULL
#define OPTION_VAL_CORRECTED_DA NULL
#define OPTION_VAL_UNCORRECTED_DA NULL
#define OPTION_VAL_4_3_DA NULL
#define OPTION_VAL_NTSC_DA NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_DA NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_DA NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_DA NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_DA NULL
#define OPTION_VAL_239_DA NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_DA NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_DA NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_DA NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_DA NULL
#define OPTION_VAL_287_DA NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_DA NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_DA NULL
#define OPTION_VAL_SYNC_DA NULL
#define OPTION_VAL_ASYNC_DA NULL
#define OPTION_VAL_PRECACHE_DA NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_DA NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_DA NULL
#define OPTION_VAL_2X_NATIVE_DA NULL
#define OPTION_VAL_6X_DA NULL
#define OPTION_VAL_10X_DA NULL
#define OPTION_VAL_12X_DA NULL
#define OPTION_VAL_14X_DA NULL

struct retro_core_option_v2_category option_cats_da[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_DA,
      CATEGORY_VIDEO_INFO_0_DA
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_DA,
      CATEGORY_OSD_INFO_0_DA
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_DA,
      CATEGORY_INPUT_INFO_0_DA
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_DA,
      CATEGORY_MEMCARDS_INFO_0_DA
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_DA,
      CATEGORY_PGXP_INFO_0_DA
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_DA,
      CATEGORY_HACKS_INFO_0_DA
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_da[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_DA,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_DA,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_DA },
         { "2x",         OPTION_VAL_2X_DA },
         { "4x",         OPTION_VAL_4X_DA },
         { "8x",         OPTION_VAL_8X_DA },
         { "16x",        OPTION_VAL_16X_DA },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_DA,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_DA,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_DA },
         { "32bpp",         OPTION_VAL_32BPP_DA },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_DA,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_DA,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_DA },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_DA },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_DA,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_DA,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_DA,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_DA,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_DA },
         { "SABR",     OPTION_VAL_SABR_DA },
         { "xBR",      OPTION_VAL_XBR_DA },
         { "bilinear", OPTION_VAL_BILINEAR_DA },
         { "3-point",  OPTION_VAL_3_POINT_DA },
         { "JINC2",    OPTION_VAL_JINC2_DA },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_DA,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_DA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_DA },
         { "all", OPTION_VAL_ALL_DA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_DA,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_DA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_DA },
         { "all", OPTION_VAL_ALL_DA },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_DA,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_DA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_DA,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_DA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_DA,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_DA,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_DA },
         { "2x",  OPTION_VAL_2X_DA },
         { "4x",  OPTION_VAL_4X_DA },
         { "8x",  OPTION_VAL_8X_DA },
         { "16x", OPTION_VAL_16X_DA },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_DA,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_DA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_DA,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_DA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_DA,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_DA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_DA,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_DA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_DA,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_DA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_DA,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_DA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_DA,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_DA,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_DA,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_DA,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_DA,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_DA,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_DA,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_DA,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_DA,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_DA,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_DA,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_DA,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_DA,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_DA,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_DA },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_DA },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_DA,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_DA,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_DA },
         { "dot",   OPTION_VAL_DOT_DA },
         { "off",   OPTION_VAL_OFF_DA },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_DA,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_DA,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_DA },
         { "blue", OPTION_VAL_BLUE_DA },
         { "green", OPTION_VAL_GREEN_DA },
         { "orange", OPTION_VAL_ORANGE_DA },
         { "yellow", OPTION_VAL_YELLOW_DA },
         { "cyan", OPTION_VAL_CYAN_DA },
         { "pink", OPTION_VAL_PINK_DA },
         { "purple", OPTION_VAL_PURPLE_DA },
         { "black", OPTION_VAL_BLACK_DA },
         { "white", OPTION_VAL_WHITE_DA },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_DA,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_DA,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_DA },
         { "red", OPTION_VAL_RED_DA },
         { "green", OPTION_VAL_GREEN_DA },
         { "orange", OPTION_VAL_ORANGE_DA },
         { "yellow", OPTION_VAL_YELLOW_DA },
         { "cyan", OPTION_VAL_CYAN_DA },
         { "pink", OPTION_VAL_PINK_DA },
         { "purple", OPTION_VAL_PURPLE_DA },
         { "black", OPTION_VAL_BLACK_DA },
         { "white", OPTION_VAL_WHITE_DA },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_DA,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_DA,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_DA },
         { "10%",  OPTION_VAL_10_DA },
         { "15%",  OPTION_VAL_15_DA },
         { "20%",  OPTION_VAL_20_DA },
         { "25%",  OPTION_VAL_25_DA },
         { "30%",  OPTION_VAL_30_DA },
         { "35%",  OPTION_VAL_35_DA },
         { "40%",  OPTION_VAL_40_DA },
         { "45%",  OPTION_VAL_45_DA },
         { "50%",  OPTION_VAL_50_DA },
         { "55%",  OPTION_VAL_55_DA },
         { "60%",  OPTION_VAL_60_DA },
         { "65%",  OPTION_VAL_65_DA },
         { "70%",  OPTION_VAL_70_DA },
         { "75%",  OPTION_VAL_75_DA },
         { "80%",  OPTION_VAL_80_DA },
         { "85%",  OPTION_VAL_85_DA },
         { "90%",  OPTION_VAL_90_DA },
         { "95%",  OPTION_VAL_95_DA },
         { "100%", OPTION_VAL_100_DA },
         { "105%", OPTION_VAL_105_DA },
         { "110%", OPTION_VAL_110_DA },
         { "115%", OPTION_VAL_115_DA },
         { "120%", OPTION_VAL_120_DA },
         { "125%", OPTION_VAL_125_DA },
         { "130%", OPTION_VAL_130_DA },
         { "135%", OPTION_VAL_135_DA },
         { "140%", OPTION_VAL_140_DA },
         { "145%", OPTION_VAL_145_DA },
         { "150%", OPTION_VAL_150_DA },
         { "155%", OPTION_VAL_155_DA },
         { "160%", OPTION_VAL_160_DA },
         { "165%", OPTION_VAL_165_DA },
         { "170%", OPTION_VAL_170_DA },
         { "175%", OPTION_VAL_175_DA },
         { "180%", OPTION_VAL_180_DA },
         { "185%", OPTION_VAL_185_DA },
         { "190%", OPTION_VAL_190_DA },
         { "195%", OPTION_VAL_195_DA },
         { "200%", OPTION_VAL_200_DA },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_DA,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_DA,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_DA },
         { "quadratic", OPTION_VAL_QUADRATIC_DA },
         { "cubic",     OPTION_VAL_CUBIC_DA },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_DA,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_DA,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_DA },
         { "5%",  OPTION_VAL_5_DA },
         { "10%", OPTION_VAL_10_DA },
         { "15%", OPTION_VAL_15_DA },
         { "20%", OPTION_VAL_20_DA },
         { "25%", OPTION_VAL_25_DA },
         { "30%", OPTION_VAL_30_DA },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_DA,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_DA,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_DA },
         { "mednafen", OPTION_VAL_MEDNAFEN_DA },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_DA,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_DA,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_DA,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_DA,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_DA,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_DA,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_DA,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_DA,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_DA },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_DA,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_DA,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_DA },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_DA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_DA,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_DA,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_DA },
         { "1px", OPTION_VAL_1PX_DA },
         { "2px", OPTION_VAL_2PX_DA },
         { "3px", OPTION_VAL_3PX_DA },
         { "4px", OPTION_VAL_4PX_DA },
         { "5px", OPTION_VAL_5PX_DA },
         { "6px", OPTION_VAL_6PX_DA },
         { "7px", OPTION_VAL_7PX_DA },
         { "8px", OPTION_VAL_8PX_DA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_DA,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_DA,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_DA,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_DA,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_DA,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_DA,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_DA,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_DA,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_DA },
         { "aggressive", OPTION_VAL_AGGRESSIVE_DA },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_DA,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_DA,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_DA,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_DA,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_DA },
         { "16:10", OPTION_VAL_16_10_DA },
         { "18:9",  OPTION_VAL_18_9_DA },
         { "19:9",  OPTION_VAL_19_9_DA },
         { "20:9",  OPTION_VAL_20_9_DA },
         { "21:9",  OPTION_VAL_21_9_DA }, // 64:27
         { "32:9",  OPTION_VAL_32_9_DA },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_DA,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_DA,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_DA },
         { "60%",           OPTION_VAL_60_DA },
         { "70%",           OPTION_VAL_70_DA },
         { "80%",           OPTION_VAL_80_DA },
         { "90%",           OPTION_VAL_90_DA },
         { "100%(native)", OPTION_VAL_100_NATIVE_DA },
         { "110%",          OPTION_VAL_110_DA },
         { "120%",          OPTION_VAL_120_DA },
         { "130%",          OPTION_VAL_130_DA },
         { "140%",          OPTION_VAL_140_DA },
         { "150%",          OPTION_VAL_150_DA },
         { "160%",          OPTION_VAL_160_DA },
         { "170%",          OPTION_VAL_170_DA },
         { "180%",          OPTION_VAL_180_DA },
         { "190%",          OPTION_VAL_190_DA },
         { "200%",          OPTION_VAL_200_DA },
         { "210%",          OPTION_VAL_210_DA },
         { "220%",          OPTION_VAL_220_DA },
         { "230%",          OPTION_VAL_230_DA },
         { "240%",          OPTION_VAL_240_DA },
         { "250%",          OPTION_VAL_250_DA },
         { "260%",          OPTION_VAL_260_DA },
         { "270%",          OPTION_VAL_270_DA },
         { "280%",          OPTION_VAL_280_DA },
         { "290%",          OPTION_VAL_290_DA },
         { "300%",          OPTION_VAL_300_DA },
         { "310%",          OPTION_VAL_310_DA },
         { "320%",          OPTION_VAL_320_DA },
         { "330%",          OPTION_VAL_330_DA },
         { "340%",          OPTION_VAL_340_DA },
         { "350%",          OPTION_VAL_350_DA },
         { "360%",          OPTION_VAL_360_DA },
         { "370%",          OPTION_VAL_370_DA },
         { "380%",          OPTION_VAL_380_DA },
         { "390%",          OPTION_VAL_390_DA },
         { "400%",          OPTION_VAL_400_DA },
         { "410%",          OPTION_VAL_410_DA },
         { "420%",          OPTION_VAL_420_DA },
         { "430%",          OPTION_VAL_430_DA },
         { "440%",          OPTION_VAL_440_DA },
         { "450%",          OPTION_VAL_450_DA },
         { "460%",          OPTION_VAL_460_DA },
         { "470%",          OPTION_VAL_470_DA },
         { "480%",          OPTION_VAL_480_DA },
         { "490%",          OPTION_VAL_490_DA },
         { "500%",          OPTION_VAL_500_DA },
         { "510%",          OPTION_VAL_510_DA },
         { "520%",          OPTION_VAL_520_DA },
         { "530%",          OPTION_VAL_530_DA },
         { "540%",          OPTION_VAL_540_DA },
         { "550%",          OPTION_VAL_550_DA },
         { "560%",          OPTION_VAL_560_DA },
         { "570%",          OPTION_VAL_570_DA },
         { "580%",          OPTION_VAL_580_DA },
         { "590%",          OPTION_VAL_590_DA },
         { "600%",          OPTION_VAL_600_DA },
         { "610%",          OPTION_VAL_610_DA },
         { "620%",          OPTION_VAL_620_DA },
         { "630%",          OPTION_VAL_630_DA },
         { "640%",          OPTION_VAL_640_DA },
         { "650%",          OPTION_VAL_650_DA },
         { "660%",          OPTION_VAL_660_DA },
         { "670%",          OPTION_VAL_670_DA },
         { "680%",          OPTION_VAL_680_DA },
         { "690%",          OPTION_VAL_690_DA },
         { "700%",          OPTION_VAL_700_DA },
         { "710%",          OPTION_VAL_710_DA },
         { "720%",          OPTION_VAL_720_DA },
         { "730%",          OPTION_VAL_730_DA },
         { "740%",          OPTION_VAL_740_DA },
         { "750%",          OPTION_VAL_750_DA },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_DA,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_DA,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_DA,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_DA,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_DA,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_DA,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_DA },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_DA },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_DA,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_DA,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_DA },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_DA },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_DA },
#endif
         { "software",    OPTION_VAL_SOFTWARE_DA },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_DA,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_DA,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_DA,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_DA,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_DA },
         { "execute",  OPTION_VAL_EXECUTE_DA },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_DA },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_DA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_DA,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_DA,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_DA },
         { "dma",  OPTION_VAL_DMA_DA },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_DA,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_DA,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_DA,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_DA,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_DA },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_DA },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_DA },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_DA,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_DA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_DA,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_DA,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_DA },
         { "static",  OPTION_VAL_STATIC_DA },
         { "smart", OPTION_VAL_SMART_DA },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_DA,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_DA,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_DA },
         { "2px",      OPTION_VAL_2PX_DA },
         { "3px",      OPTION_VAL_3PX_DA },
         { "4px",      OPTION_VAL_4PX_DA },
         { "5px",      OPTION_VAL_5PX_DA },
         { "6px",      OPTION_VAL_6PX_DA },
         { "7px",      OPTION_VAL_7PX_DA },
         { "8px",      OPTION_VAL_8PX_DA },
         { "9px",      OPTION_VAL_9PX_DA },
         { "10px",     OPTION_VAL_10PX_DA },
         { "11px",     OPTION_VAL_11PX_DA },
         { "12px",     OPTION_VAL_12PX_DA },
         { "13px",     OPTION_VAL_13PX_DA },
         { "14px",     OPTION_VAL_14PX_DA },
         { "15px",     OPTION_VAL_15PX_DA },
         { "16px",     OPTION_VAL_16PX_DA },
         { "17px",     OPTION_VAL_17PX_DA },
         { "18px",     OPTION_VAL_18PX_DA },
         { "19px",     OPTION_VAL_19PX_DA },
         { "20px",     OPTION_VAL_20PX_DA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_DA,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_DA,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_DA },
         { "-11px",    OPTION_VAL_11PX_O55_DA },
         { "-10px",    OPTION_VAL_10PX_O55_DA },
         { "-9px",     OPTION_VAL_9PX_O55_DA },
         { "-8px",     OPTION_VAL_8PX_O55_DA },
         { "-7px",     OPTION_VAL_7PX_O55_DA },
         { "-6px",     OPTION_VAL_6PX_O55_DA },
         { "-5px",     OPTION_VAL_5PX_O55_DA },
         { "-4px",     OPTION_VAL_4PX_O55_DA },
         { "-3px",     OPTION_VAL_3PX_O55_DA },
         { "-2px",     OPTION_VAL_2PX_O55_DA },
         { "-1px",     OPTION_VAL_1PX_O55_DA },
         { "disabled", OPTION_VAL_DISABLED_O55_DA },
         { "+1px",     OPTION_VAL_1PX_O55_0_DA },
         { "+2px",     OPTION_VAL_2PX_O55_0_DA },
         { "+3px",     OPTION_VAL_3PX_O55_0_DA },
         { "+4px",     OPTION_VAL_4PX_O55_0_DA },
         { "+5px",     OPTION_VAL_5PX_O55_0_DA },
         { "+6px",     OPTION_VAL_6PX_O55_0_DA },
         { "+7px",     OPTION_VAL_7PX_O55_0_DA },
         { "+8px",     OPTION_VAL_8PX_O55_0_DA },
         { "+9px",     OPTION_VAL_9PX_O55_0_DA },
         { "+10px",    OPTION_VAL_10PX_O55_0_DA },
         { "+11px",    OPTION_VAL_11PX_O55_0_DA },
         { "+12px",    OPTION_VAL_12PX_O55_0_DA },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_DA,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_DA,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_DA },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_DA,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_DA,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_DA },
         { "2x",         OPTION_VAL_2X_DA },
         { "4x",         OPTION_VAL_4X_DA },
         { "8x",         OPTION_VAL_8X_DA },
         { "16x",        OPTION_VAL_16X_DA },
         { "32x",        OPTION_VAL_32X_DA },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_DA,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_DA,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_DA },
         { "uncorrected", OPTION_VAL_UNCORRECTED_DA },
         { "4:3",  OPTION_VAL_4_3_DA },
         { "ntsc", OPTION_VAL_NTSC_DA },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_DA,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_DA,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_DA,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_DA,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_DA },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_DA,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_DA,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_DA,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_DA,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_DA },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_DA,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_DA,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_DA },
         { "async",    OPTION_VAL_ASYNC_DA },
         { "precache", OPTION_VAL_PRECACHE_DA },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_DA,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_DA,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_DA },
         { "4x",          OPTION_VAL_4X_DA },
         { "6x",          OPTION_VAL_6X_DA },
         { "8x",          OPTION_VAL_8X_DA },
         { "10x",         OPTION_VAL_10X_DA },
         { "12x",         OPTION_VAL_12X_DA },
         { "14x",         OPTION_VAL_14X_DA },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_da = {
   option_cats_da,
   option_defs_da
};

/* RETRO_LANGUAGE_DE */

#define CATEGORY_VIDEO_LABEL_DE NULL
#define CATEGORY_VIDEO_INFO_0_DE NULL
#define CATEGORY_OSD_LABEL_DE "Bildschirm-Benachrichtigungen"
#define CATEGORY_OSD_INFO_0_DE NULL
#define CATEGORY_INPUT_LABEL_DE "Eingabe"
#define CATEGORY_INPUT_INFO_0_DE NULL
#define CATEGORY_MEMCARDS_LABEL_DE NULL
#define CATEGORY_MEMCARDS_INFO_0_DE NULL
#define CATEGORY_PGXP_LABEL_DE NULL
#define CATEGORY_PGXP_INFO_0_DE "Diese Optionen steuern Erweiterungen, die die Grafik im Vergleich zur Originalkonsole verbessern können. PGXP kann verzerrte Texturen und Z-Fighting-Probleme beseitigen."
#define CATEGORY_HACKS_LABEL_DE "Emulations Hacks"
#define CATEGORY_HACKS_INFO_0_DE NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_DE "Interne GPU-Auflösung"
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_DE NULL
#define OPTION_VAL_1X_NATIVE_DE "1x (Nativ)"
#define OPTION_VAL_2X_DE NULL
#define OPTION_VAL_4X_DE NULL
#define OPTION_VAL_8X_DE NULL
#define OPTION_VAL_16X_DE NULL
#define BEETLE_OPT_DEPTH_LABEL_DE "Interne Farbtiefe"
#define BEETLE_OPT_DEPTH_INFO_0_DE NULL
#define OPTION_VAL_16BPP_NATIVE_DE "16 bpp (Nativ)"
#define OPTION_VAL_32BPP_DE NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_DE "Dithering-Muster"
#define BEETLE_OPT_DITHER_MODE_INFO_0_DE NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_DE "Interne Auflösung"
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_DE "Texturen-UV-Versatz"
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_DE NULL
#define BEETLE_OPT_FILTER_LABEL_DE "Texturfilterung"
#define BEETLE_OPT_FILTER_INFO_0_DE NULL
#define OPTION_VAL_NEAREST_DE "Nächste"
#define OPTION_VAL_SABR_DE NULL
#define OPTION_VAL_XBR_DE NULL
#define OPTION_VAL_BILINEAR_DE NULL
#define OPTION_VAL_3_POINT_DE "3-Punkt"
#define OPTION_VAL_JINC2_DE NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_DE "Sprites von der Filterung ausschließen"
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_DE NULL
#define OPTION_VAL_OPAQUE_DE NULL
#define OPTION_VAL_ALL_DE NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_DE NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_DE NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_DE "Adaptive Glättung"
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_DE NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_DE NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_DE NULL
#define BEETLE_OPT_MSAA_LABEL_DE NULL
#define BEETLE_OPT_MSAA_INFO_0_DE NULL
#define OPTION_VAL_1X_DE "1 x"
#define BEETLE_OPT_MDEC_YUV_LABEL_DE NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_DE NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_DE NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_DE NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_DE NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_DE NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_DE NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_DE NULL
#define BEETLE_OPT_WIREFRAME_LABEL_DE NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_DE NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_DE NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_DE NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_DE NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_DE NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_DE "Anzeige volles VRAM (Debug)"
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_DE NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_DE NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_DE NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_DE NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_DE NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_DE NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_DE NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_DE NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_DE NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_DE NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_DE NULL
#define OPTION_VAL_LIGHTGUN_DE NULL
#define OPTION_VAL_TOUCHSCREEN_DE NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_DE NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_DE NULL
#define OPTION_VAL_CROSS_DE "Kreuz"
#define OPTION_VAL_DOT_DE "Punkt"
#define OPTION_VAL_OFF_DE NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_DE NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_DE NULL
#define OPTION_VAL_RED_DE "Rot"
#define OPTION_VAL_BLUE_DE "Blau"
#define OPTION_VAL_GREEN_DE "Grün"
#define OPTION_VAL_ORANGE_DE NULL
#define OPTION_VAL_YELLOW_DE "Gelb"
#define OPTION_VAL_CYAN_DE NULL
#define OPTION_VAL_PINK_DE NULL
#define OPTION_VAL_PURPLE_DE "Lila"
#define OPTION_VAL_BLACK_DE "Schwarz"
#define OPTION_VAL_WHITE_DE "Weiß"
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_DE NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_DE NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_DE "Mausempfindlichkeit"
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_DE NULL
#define OPTION_VAL_5_DE "5 %"
#define OPTION_VAL_10_DE "10 %"
#define OPTION_VAL_15_DE "15 %"
#define OPTION_VAL_20_DE "20 %"
#define OPTION_VAL_25_DE "25 %"
#define OPTION_VAL_30_DE "30 %"
#define OPTION_VAL_35_DE "35 %"
#define OPTION_VAL_40_DE "40 %"
#define OPTION_VAL_45_DE "45 %"
#define OPTION_VAL_50_DE "50 %"
#define OPTION_VAL_55_DE "55 %"
#define OPTION_VAL_60_DE "60 %"
#define OPTION_VAL_65_DE "65 %"
#define OPTION_VAL_70_DE "70 %"
#define OPTION_VAL_75_DE "75 %"
#define OPTION_VAL_80_DE "80 %"
#define OPTION_VAL_85_DE "85 %"
#define OPTION_VAL_90_DE "90 %"
#define OPTION_VAL_95_DE "95 %"
#define OPTION_VAL_100_DE NULL
#define OPTION_VAL_105_DE "105 %"
#define OPTION_VAL_110_DE "110 %"
#define OPTION_VAL_115_DE "115 %"
#define OPTION_VAL_120_DE "120 %"
#define OPTION_VAL_125_DE "125 %"
#define OPTION_VAL_130_DE "130 %"
#define OPTION_VAL_135_DE "135 %"
#define OPTION_VAL_140_DE "140 %"
#define OPTION_VAL_145_DE "145 %"
#define OPTION_VAL_150_DE "150 %"
#define OPTION_VAL_155_DE "155 %"
#define OPTION_VAL_160_DE "160 %"
#define OPTION_VAL_165_DE "165 %"
#define OPTION_VAL_170_DE "170 %"
#define OPTION_VAL_175_DE "175 %"
#define OPTION_VAL_180_DE "180 %"
#define OPTION_VAL_185_DE "185 %"
#define OPTION_VAL_190_DE "190 %"
#define OPTION_VAL_195_DE "195 %"
#define OPTION_VAL_200_DE "200 %"
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_DE NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_DE NULL
#define OPTION_VAL_LINEAR_DE NULL
#define OPTION_VAL_QUADRATIC_DE NULL
#define OPTION_VAL_CUBIC_DE NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_DE NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_DE NULL
#define OPTION_VAL_0_DE "0 %"
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_DE NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_DE NULL
#define OPTION_VAL_LIBRETRO_DE NULL
#define OPTION_VAL_MEDNAFEN_DE NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_DE NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_DE NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_DE NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_DE NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_DE NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_DE NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_DE NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_DE NULL
#define OPTION_VAL_1_DE NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_DE NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_DE NULL
#define OPTION_VAL_MEMORY_ONLY_DE "Nur Speicher"
#define OPTION_VAL_MEMORY_CPU_DE NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_DE NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_DE NULL
#define OPTION_VAL_0PX_DE NULL
#define OPTION_VAL_1PX_DE NULL
#define OPTION_VAL_2PX_DE NULL
#define OPTION_VAL_3PX_DE NULL
#define OPTION_VAL_4PX_DE NULL
#define OPTION_VAL_5PX_DE NULL
#define OPTION_VAL_6PX_DE NULL
#define OPTION_VAL_7PX_DE NULL
#define OPTION_VAL_8PX_DE NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_DE NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_DE NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_DE NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_DE NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_DE NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_DE NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_DE NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_DE NULL
#define OPTION_VAL_DEFAULT_DE "Standard"
#define OPTION_VAL_AGGRESSIVE_DE "Aggressiv"
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_DE NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_DE NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_DE NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_DE NULL
#define OPTION_VAL_16_9_DE NULL
#define OPTION_VAL_16_10_DE NULL
#define OPTION_VAL_18_9_DE NULL
#define OPTION_VAL_19_9_DE NULL
#define OPTION_VAL_20_9_DE NULL
#define OPTION_VAL_21_9_DE NULL
#define OPTION_VAL_32_9_DE NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_DE "CPU-Frequenzskalierung (Übertaktung)"
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_DE NULL
#define OPTION_VAL_100_NATIVE_DE "100 % (Nativ)"
#define OPTION_VAL_210_DE "210 %"
#define OPTION_VAL_220_DE "220 %"
#define OPTION_VAL_230_DE "230 %"
#define OPTION_VAL_240_DE "240 %"
#define OPTION_VAL_250_DE "250 %"
#define OPTION_VAL_260_DE "260 %"
#define OPTION_VAL_270_DE "270 %"
#define OPTION_VAL_280_DE "280 %"
#define OPTION_VAL_290_DE "290 %"
#define OPTION_VAL_300_DE "300 %"
#define OPTION_VAL_310_DE "310 %"
#define OPTION_VAL_320_DE "320 %"
#define OPTION_VAL_330_DE "330 %"
#define OPTION_VAL_340_DE "340 %"
#define OPTION_VAL_350_DE "350 %"
#define OPTION_VAL_360_DE "360 %"
#define OPTION_VAL_370_DE "370 %"
#define OPTION_VAL_380_DE "380 %"
#define OPTION_VAL_390_DE "390 %"
#define OPTION_VAL_400_DE "400 %"
#define OPTION_VAL_410_DE "410 %"
#define OPTION_VAL_420_DE "420 %"
#define OPTION_VAL_430_DE "430 %"
#define OPTION_VAL_440_DE "440 %"
#define OPTION_VAL_450_DE "450 %"
#define OPTION_VAL_460_DE "460 %"
#define OPTION_VAL_470_DE "470 %"
#define OPTION_VAL_480_DE "480 %"
#define OPTION_VAL_490_DE "490 %"
#define OPTION_VAL_500_DE "500 %"
#define OPTION_VAL_510_DE NULL
#define OPTION_VAL_520_DE NULL
#define OPTION_VAL_530_DE NULL
#define OPTION_VAL_540_DE NULL
#define OPTION_VAL_550_DE NULL
#define OPTION_VAL_560_DE NULL
#define OPTION_VAL_570_DE "570 %"
#define OPTION_VAL_580_DE "580 %"
#define OPTION_VAL_590_DE "590 %"
#define OPTION_VAL_600_DE "600 %"
#define OPTION_VAL_610_DE "610 %"
#define OPTION_VAL_620_DE "620 %"
#define OPTION_VAL_630_DE "630 %"
#define OPTION_VAL_640_DE "640 %"
#define OPTION_VAL_650_DE "650 %"
#define OPTION_VAL_660_DE "660 %"
#define OPTION_VAL_670_DE "670 %"
#define OPTION_VAL_680_DE "680 %"
#define OPTION_VAL_690_DE "690 %"
#define OPTION_VAL_700_DE "700 %"
#define OPTION_VAL_710_DE "710 %"
#define OPTION_VAL_720_DE "720 %"
#define OPTION_VAL_730_DE "730 %"
#define OPTION_VAL_740_DE "740 %"
#define OPTION_VAL_750_DE "750 %"
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_DE NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_DE NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_DE "BIOS überspringen"
#define BEETLE_OPT_SKIP_BIOS_INFO_0_DE NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_DE NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_DE NULL
#define OPTION_VAL_PSXONPSP_DE NULL
#define OPTION_VAL_PS1_ROM_DE NULL
#define BEETLE_OPT_RENDERER_LABEL_DE NULL
#define BEETLE_OPT_RENDERER_INFO_0_DE NULL
#define OPTION_VAL_HARDWARE_DE "Hardware (Automatisch)"
#define OPTION_VAL_HARDWARE_GL_DE NULL
#define OPTION_VAL_HARDWARE_VK_DE NULL
#define OPTION_VAL_SOFTWARE_DE NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_DE NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_DE NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_DE NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_DE NULL
#define OPTION_VAL_DISABLED_DE NULL
#define OPTION_VAL_EXECUTE_DE NULL
#define OPTION_VAL_EXECUTE_ONE_DE NULL
#define OPTION_VAL_RUN_INTERPRETER_DE NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_DE NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_DE NULL
#define OPTION_VAL_FULL_DE NULL
#define OPTION_VAL_DMA_DE NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_DE NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_DE NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_DE NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_DE NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_DE NULL
#define OPTION_VAL_FORCE_INTERLACED_DE NULL
#define OPTION_VAL_AUTO_TOGGLE_DE NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_DE NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_DE NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_DE "Overscan zuschneiden"
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_DE NULL
#define OPTION_VAL_DISABLED_O53_DE "Keine"
#define OPTION_VAL_STATIC_DE NULL
#define OPTION_VAL_SMART_DE NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_DE NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_DE NULL
#define OPTION_VAL_9PX_DE NULL
#define OPTION_VAL_10PX_DE NULL
#define OPTION_VAL_11PX_DE NULL
#define OPTION_VAL_12PX_DE NULL
#define OPTION_VAL_13PX_DE NULL
#define OPTION_VAL_14PX_DE NULL
#define OPTION_VAL_15PX_DE NULL
#define OPTION_VAL_16PX_DE NULL
#define OPTION_VAL_17PX_DE NULL
#define OPTION_VAL_18PX_DE NULL
#define OPTION_VAL_19PX_DE NULL
#define OPTION_VAL_20PX_DE NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_DE NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_DE NULL
#define OPTION_VAL_12PX_O55_DE NULL
#define OPTION_VAL_11PX_O55_DE NULL
#define OPTION_VAL_10PX_O55_DE NULL
#define OPTION_VAL_9PX_O55_DE NULL
#define OPTION_VAL_8PX_O55_DE NULL
#define OPTION_VAL_7PX_O55_DE NULL
#define OPTION_VAL_6PX_O55_DE NULL
#define OPTION_VAL_5PX_O55_DE NULL
#define OPTION_VAL_4PX_O55_DE NULL
#define OPTION_VAL_3PX_O55_DE NULL
#define OPTION_VAL_2PX_O55_DE NULL
#define OPTION_VAL_1PX_O55_DE NULL
#define OPTION_VAL_DISABLED_O55_DE "0 (Standard)"
#define OPTION_VAL_1PX_O55_0_DE NULL
#define OPTION_VAL_2PX_O55_0_DE NULL
#define OPTION_VAL_3PX_O55_0_DE NULL
#define OPTION_VAL_4PX_O55_0_DE NULL
#define OPTION_VAL_5PX_O55_0_DE NULL
#define OPTION_VAL_6PX_O55_0_DE NULL
#define OPTION_VAL_7PX_O55_0_DE NULL
#define OPTION_VAL_8PX_O55_0_DE NULL
#define OPTION_VAL_9PX_O55_0_DE NULL
#define OPTION_VAL_10PX_O55_0_DE NULL
#define OPTION_VAL_11PX_O55_0_DE NULL
#define OPTION_VAL_12PX_O55_0_DE NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_DE "Horizontaler Bildversatz (GPU-Zyklen)"
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_DE NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_DE NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_DE NULL
#define OPTION_VAL_32X_DE NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_DE NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_DE NULL
#define OPTION_VAL_CORRECTED_DE "Korrigiert"
#define OPTION_VAL_UNCORRECTED_DE "Unkorrigiert"
#define OPTION_VAL_4_3_DE "4:3 erzwingen"
#define OPTION_VAL_NTSC_DE "NTSC erzwingen"
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_DE NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_DE NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_DE NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_DE NULL
#define OPTION_VAL_239_DE "239 (Standard)"
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_DE NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_DE NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_DE NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_DE NULL
#define OPTION_VAL_287_DE "287 (Standard)"
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_DE NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_DE NULL
#define OPTION_VAL_SYNC_DE "Synchron"
#define OPTION_VAL_ASYNC_DE "Asynchron"
#define OPTION_VAL_PRECACHE_DE NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_DE "CD-Ladegeschwindigkeit"
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_DE NULL
#define OPTION_VAL_2X_NATIVE_DE "2x (Nativ)"
#define OPTION_VAL_6X_DE "6 x"
#define OPTION_VAL_10X_DE NULL
#define OPTION_VAL_12X_DE NULL
#define OPTION_VAL_14X_DE NULL

struct retro_core_option_v2_category option_cats_de[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_DE,
      CATEGORY_VIDEO_INFO_0_DE
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_DE,
      CATEGORY_OSD_INFO_0_DE
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_DE,
      CATEGORY_INPUT_INFO_0_DE
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_DE,
      CATEGORY_MEMCARDS_INFO_0_DE
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_DE,
      CATEGORY_PGXP_INFO_0_DE
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_DE,
      CATEGORY_HACKS_INFO_0_DE
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_de[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_DE,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_DE,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_DE },
         { "2x",         OPTION_VAL_2X_DE },
         { "4x",         OPTION_VAL_4X_DE },
         { "8x",         OPTION_VAL_8X_DE },
         { "16x",        OPTION_VAL_16X_DE },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_DE,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_DE,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_DE },
         { "32bpp",         OPTION_VAL_32BPP_DE },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_DE,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_DE,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_DE },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_DE },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_DE,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_DE,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_DE,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_DE,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_DE },
         { "SABR",     OPTION_VAL_SABR_DE },
         { "xBR",      OPTION_VAL_XBR_DE },
         { "bilinear", OPTION_VAL_BILINEAR_DE },
         { "3-point",  OPTION_VAL_3_POINT_DE },
         { "JINC2",    OPTION_VAL_JINC2_DE },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_DE,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_DE,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_DE },
         { "all", OPTION_VAL_ALL_DE },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_DE,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_DE,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_DE },
         { "all", OPTION_VAL_ALL_DE },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_DE,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_DE,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_DE,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_DE,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_DE,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_DE,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_DE },
         { "2x",  OPTION_VAL_2X_DE },
         { "4x",  OPTION_VAL_4X_DE },
         { "8x",  OPTION_VAL_8X_DE },
         { "16x", OPTION_VAL_16X_DE },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_DE,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_DE,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_DE,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_DE,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_DE,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_DE,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_DE,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_DE,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_DE,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_DE,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_DE,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_DE,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_DE,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_DE,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_DE,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_DE,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_DE,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_DE,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_DE,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_DE,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_DE,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_DE,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_DE,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_DE,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_DE,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_DE,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_DE },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_DE },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_DE,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_DE,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_DE },
         { "dot",   OPTION_VAL_DOT_DE },
         { "off",   OPTION_VAL_OFF_DE },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_DE,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_DE,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_DE },
         { "blue", OPTION_VAL_BLUE_DE },
         { "green", OPTION_VAL_GREEN_DE },
         { "orange", OPTION_VAL_ORANGE_DE },
         { "yellow", OPTION_VAL_YELLOW_DE },
         { "cyan", OPTION_VAL_CYAN_DE },
         { "pink", OPTION_VAL_PINK_DE },
         { "purple", OPTION_VAL_PURPLE_DE },
         { "black", OPTION_VAL_BLACK_DE },
         { "white", OPTION_VAL_WHITE_DE },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_DE,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_DE,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_DE },
         { "red", OPTION_VAL_RED_DE },
         { "green", OPTION_VAL_GREEN_DE },
         { "orange", OPTION_VAL_ORANGE_DE },
         { "yellow", OPTION_VAL_YELLOW_DE },
         { "cyan", OPTION_VAL_CYAN_DE },
         { "pink", OPTION_VAL_PINK_DE },
         { "purple", OPTION_VAL_PURPLE_DE },
         { "black", OPTION_VAL_BLACK_DE },
         { "white", OPTION_VAL_WHITE_DE },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_DE,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_DE,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_DE },
         { "10%",  OPTION_VAL_10_DE },
         { "15%",  OPTION_VAL_15_DE },
         { "20%",  OPTION_VAL_20_DE },
         { "25%",  OPTION_VAL_25_DE },
         { "30%",  OPTION_VAL_30_DE },
         { "35%",  OPTION_VAL_35_DE },
         { "40%",  OPTION_VAL_40_DE },
         { "45%",  OPTION_VAL_45_DE },
         { "50%",  OPTION_VAL_50_DE },
         { "55%",  OPTION_VAL_55_DE },
         { "60%",  OPTION_VAL_60_DE },
         { "65%",  OPTION_VAL_65_DE },
         { "70%",  OPTION_VAL_70_DE },
         { "75%",  OPTION_VAL_75_DE },
         { "80%",  OPTION_VAL_80_DE },
         { "85%",  OPTION_VAL_85_DE },
         { "90%",  OPTION_VAL_90_DE },
         { "95%",  OPTION_VAL_95_DE },
         { "100%", OPTION_VAL_100_DE },
         { "105%", OPTION_VAL_105_DE },
         { "110%", OPTION_VAL_110_DE },
         { "115%", OPTION_VAL_115_DE },
         { "120%", OPTION_VAL_120_DE },
         { "125%", OPTION_VAL_125_DE },
         { "130%", OPTION_VAL_130_DE },
         { "135%", OPTION_VAL_135_DE },
         { "140%", OPTION_VAL_140_DE },
         { "145%", OPTION_VAL_145_DE },
         { "150%", OPTION_VAL_150_DE },
         { "155%", OPTION_VAL_155_DE },
         { "160%", OPTION_VAL_160_DE },
         { "165%", OPTION_VAL_165_DE },
         { "170%", OPTION_VAL_170_DE },
         { "175%", OPTION_VAL_175_DE },
         { "180%", OPTION_VAL_180_DE },
         { "185%", OPTION_VAL_185_DE },
         { "190%", OPTION_VAL_190_DE },
         { "195%", OPTION_VAL_195_DE },
         { "200%", OPTION_VAL_200_DE },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_DE,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_DE,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_DE },
         { "quadratic", OPTION_VAL_QUADRATIC_DE },
         { "cubic",     OPTION_VAL_CUBIC_DE },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_DE,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_DE,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_DE },
         { "5%",  OPTION_VAL_5_DE },
         { "10%", OPTION_VAL_10_DE },
         { "15%", OPTION_VAL_15_DE },
         { "20%", OPTION_VAL_20_DE },
         { "25%", OPTION_VAL_25_DE },
         { "30%", OPTION_VAL_30_DE },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_DE,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_DE,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_DE },
         { "mednafen", OPTION_VAL_MEDNAFEN_DE },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_DE,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_DE,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_DE,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_DE,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_DE,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_DE,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_DE,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_DE,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_DE },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_DE,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_DE,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_DE },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_DE },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_DE,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_DE,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_DE },
         { "1px", OPTION_VAL_1PX_DE },
         { "2px", OPTION_VAL_2PX_DE },
         { "3px", OPTION_VAL_3PX_DE },
         { "4px", OPTION_VAL_4PX_DE },
         { "5px", OPTION_VAL_5PX_DE },
         { "6px", OPTION_VAL_6PX_DE },
         { "7px", OPTION_VAL_7PX_DE },
         { "8px", OPTION_VAL_8PX_DE },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_DE,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_DE,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_DE,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_DE,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_DE,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_DE,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_DE,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_DE,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_DE },
         { "aggressive", OPTION_VAL_AGGRESSIVE_DE },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_DE,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_DE,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_DE,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_DE,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_DE },
         { "16:10", OPTION_VAL_16_10_DE },
         { "18:9",  OPTION_VAL_18_9_DE },
         { "19:9",  OPTION_VAL_19_9_DE },
         { "20:9",  OPTION_VAL_20_9_DE },
         { "21:9",  OPTION_VAL_21_9_DE }, // 64:27
         { "32:9",  OPTION_VAL_32_9_DE },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_DE,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_DE,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_DE },
         { "60%",           OPTION_VAL_60_DE },
         { "70%",           OPTION_VAL_70_DE },
         { "80%",           OPTION_VAL_80_DE },
         { "90%",           OPTION_VAL_90_DE },
         { "100%(native)", OPTION_VAL_100_NATIVE_DE },
         { "110%",          OPTION_VAL_110_DE },
         { "120%",          OPTION_VAL_120_DE },
         { "130%",          OPTION_VAL_130_DE },
         { "140%",          OPTION_VAL_140_DE },
         { "150%",          OPTION_VAL_150_DE },
         { "160%",          OPTION_VAL_160_DE },
         { "170%",          OPTION_VAL_170_DE },
         { "180%",          OPTION_VAL_180_DE },
         { "190%",          OPTION_VAL_190_DE },
         { "200%",          OPTION_VAL_200_DE },
         { "210%",          OPTION_VAL_210_DE },
         { "220%",          OPTION_VAL_220_DE },
         { "230%",          OPTION_VAL_230_DE },
         { "240%",          OPTION_VAL_240_DE },
         { "250%",          OPTION_VAL_250_DE },
         { "260%",          OPTION_VAL_260_DE },
         { "270%",          OPTION_VAL_270_DE },
         { "280%",          OPTION_VAL_280_DE },
         { "290%",          OPTION_VAL_290_DE },
         { "300%",          OPTION_VAL_300_DE },
         { "310%",          OPTION_VAL_310_DE },
         { "320%",          OPTION_VAL_320_DE },
         { "330%",          OPTION_VAL_330_DE },
         { "340%",          OPTION_VAL_340_DE },
         { "350%",          OPTION_VAL_350_DE },
         { "360%",          OPTION_VAL_360_DE },
         { "370%",          OPTION_VAL_370_DE },
         { "380%",          OPTION_VAL_380_DE },
         { "390%",          OPTION_VAL_390_DE },
         { "400%",          OPTION_VAL_400_DE },
         { "410%",          OPTION_VAL_410_DE },
         { "420%",          OPTION_VAL_420_DE },
         { "430%",          OPTION_VAL_430_DE },
         { "440%",          OPTION_VAL_440_DE },
         { "450%",          OPTION_VAL_450_DE },
         { "460%",          OPTION_VAL_460_DE },
         { "470%",          OPTION_VAL_470_DE },
         { "480%",          OPTION_VAL_480_DE },
         { "490%",          OPTION_VAL_490_DE },
         { "500%",          OPTION_VAL_500_DE },
         { "510%",          OPTION_VAL_510_DE },
         { "520%",          OPTION_VAL_520_DE },
         { "530%",          OPTION_VAL_530_DE },
         { "540%",          OPTION_VAL_540_DE },
         { "550%",          OPTION_VAL_550_DE },
         { "560%",          OPTION_VAL_560_DE },
         { "570%",          OPTION_VAL_570_DE },
         { "580%",          OPTION_VAL_580_DE },
         { "590%",          OPTION_VAL_590_DE },
         { "600%",          OPTION_VAL_600_DE },
         { "610%",          OPTION_VAL_610_DE },
         { "620%",          OPTION_VAL_620_DE },
         { "630%",          OPTION_VAL_630_DE },
         { "640%",          OPTION_VAL_640_DE },
         { "650%",          OPTION_VAL_650_DE },
         { "660%",          OPTION_VAL_660_DE },
         { "670%",          OPTION_VAL_670_DE },
         { "680%",          OPTION_VAL_680_DE },
         { "690%",          OPTION_VAL_690_DE },
         { "700%",          OPTION_VAL_700_DE },
         { "710%",          OPTION_VAL_710_DE },
         { "720%",          OPTION_VAL_720_DE },
         { "730%",          OPTION_VAL_730_DE },
         { "740%",          OPTION_VAL_740_DE },
         { "750%",          OPTION_VAL_750_DE },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_DE,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_DE,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_DE,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_DE,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_DE,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_DE,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_DE },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_DE },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_DE,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_DE,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_DE },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_DE },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_DE },
#endif
         { "software",    OPTION_VAL_SOFTWARE_DE },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_DE,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_DE,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_DE,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_DE,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_DE },
         { "execute",  OPTION_VAL_EXECUTE_DE },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_DE },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_DE },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_DE,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_DE,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_DE },
         { "dma",  OPTION_VAL_DMA_DE },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_DE,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_DE,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_DE,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_DE,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_DE },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_DE },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_DE },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_DE,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_DE,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_DE,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_DE,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_DE },
         { "static",  OPTION_VAL_STATIC_DE },
         { "smart", OPTION_VAL_SMART_DE },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_DE,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_DE,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_DE },
         { "2px",      OPTION_VAL_2PX_DE },
         { "3px",      OPTION_VAL_3PX_DE },
         { "4px",      OPTION_VAL_4PX_DE },
         { "5px",      OPTION_VAL_5PX_DE },
         { "6px",      OPTION_VAL_6PX_DE },
         { "7px",      OPTION_VAL_7PX_DE },
         { "8px",      OPTION_VAL_8PX_DE },
         { "9px",      OPTION_VAL_9PX_DE },
         { "10px",     OPTION_VAL_10PX_DE },
         { "11px",     OPTION_VAL_11PX_DE },
         { "12px",     OPTION_VAL_12PX_DE },
         { "13px",     OPTION_VAL_13PX_DE },
         { "14px",     OPTION_VAL_14PX_DE },
         { "15px",     OPTION_VAL_15PX_DE },
         { "16px",     OPTION_VAL_16PX_DE },
         { "17px",     OPTION_VAL_17PX_DE },
         { "18px",     OPTION_VAL_18PX_DE },
         { "19px",     OPTION_VAL_19PX_DE },
         { "20px",     OPTION_VAL_20PX_DE },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_DE,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_DE,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_DE },
         { "-11px",    OPTION_VAL_11PX_O55_DE },
         { "-10px",    OPTION_VAL_10PX_O55_DE },
         { "-9px",     OPTION_VAL_9PX_O55_DE },
         { "-8px",     OPTION_VAL_8PX_O55_DE },
         { "-7px",     OPTION_VAL_7PX_O55_DE },
         { "-6px",     OPTION_VAL_6PX_O55_DE },
         { "-5px",     OPTION_VAL_5PX_O55_DE },
         { "-4px",     OPTION_VAL_4PX_O55_DE },
         { "-3px",     OPTION_VAL_3PX_O55_DE },
         { "-2px",     OPTION_VAL_2PX_O55_DE },
         { "-1px",     OPTION_VAL_1PX_O55_DE },
         { "disabled", OPTION_VAL_DISABLED_O55_DE },
         { "+1px",     OPTION_VAL_1PX_O55_0_DE },
         { "+2px",     OPTION_VAL_2PX_O55_0_DE },
         { "+3px",     OPTION_VAL_3PX_O55_0_DE },
         { "+4px",     OPTION_VAL_4PX_O55_0_DE },
         { "+5px",     OPTION_VAL_5PX_O55_0_DE },
         { "+6px",     OPTION_VAL_6PX_O55_0_DE },
         { "+7px",     OPTION_VAL_7PX_O55_0_DE },
         { "+8px",     OPTION_VAL_8PX_O55_0_DE },
         { "+9px",     OPTION_VAL_9PX_O55_0_DE },
         { "+10px",    OPTION_VAL_10PX_O55_0_DE },
         { "+11px",    OPTION_VAL_11PX_O55_0_DE },
         { "+12px",    OPTION_VAL_12PX_O55_0_DE },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_DE,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_DE,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_DE },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_DE,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_DE,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_DE },
         { "2x",         OPTION_VAL_2X_DE },
         { "4x",         OPTION_VAL_4X_DE },
         { "8x",         OPTION_VAL_8X_DE },
         { "16x",        OPTION_VAL_16X_DE },
         { "32x",        OPTION_VAL_32X_DE },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_DE,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_DE,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_DE },
         { "uncorrected", OPTION_VAL_UNCORRECTED_DE },
         { "4:3",  OPTION_VAL_4_3_DE },
         { "ntsc", OPTION_VAL_NTSC_DE },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_DE,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_DE,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_DE,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_DE,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_DE },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_DE,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_DE,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_DE,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_DE,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_DE },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_DE,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_DE,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_DE },
         { "async",    OPTION_VAL_ASYNC_DE },
         { "precache", OPTION_VAL_PRECACHE_DE },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_DE,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_DE,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_DE },
         { "4x",          OPTION_VAL_4X_DE },
         { "6x",          OPTION_VAL_6X_DE },
         { "8x",          OPTION_VAL_8X_DE },
         { "10x",         OPTION_VAL_10X_DE },
         { "12x",         OPTION_VAL_12X_DE },
         { "14x",         OPTION_VAL_14X_DE },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_de = {
   option_cats_de,
   option_defs_de
};

/* RETRO_LANGUAGE_EL */

#define CATEGORY_VIDEO_LABEL_EL "Οδηγός Βίντεο"
#define CATEGORY_VIDEO_INFO_0_EL NULL
#define CATEGORY_OSD_LABEL_EL "Ειδοποιήσεις Οθόνης Απεικόνισης"
#define CATEGORY_OSD_INFO_0_EL NULL
#define CATEGORY_INPUT_LABEL_EL "Οδηγός Εισαγωγής"
#define CATEGORY_INPUT_INFO_0_EL NULL
#define CATEGORY_MEMCARDS_LABEL_EL NULL
#define CATEGORY_MEMCARDS_INFO_0_EL NULL
#define CATEGORY_PGXP_LABEL_EL NULL
#define CATEGORY_PGXP_INFO_0_EL NULL
#define CATEGORY_HACKS_LABEL_EL NULL
#define CATEGORY_HACKS_INFO_0_EL NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_EL NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_EL NULL
#define OPTION_VAL_1X_NATIVE_EL NULL
#define OPTION_VAL_2X_EL NULL
#define OPTION_VAL_4X_EL NULL
#define OPTION_VAL_8X_EL NULL
#define OPTION_VAL_16X_EL NULL
#define BEETLE_OPT_DEPTH_LABEL_EL NULL
#define BEETLE_OPT_DEPTH_INFO_0_EL NULL
#define OPTION_VAL_16BPP_NATIVE_EL NULL
#define OPTION_VAL_32BPP_EL NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_EL NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_EL NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_EL NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_EL NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_EL NULL
#define BEETLE_OPT_FILTER_LABEL_EL NULL
#define BEETLE_OPT_FILTER_INFO_0_EL NULL
#define OPTION_VAL_NEAREST_EL "Κοντινότερο"
#define OPTION_VAL_SABR_EL NULL
#define OPTION_VAL_XBR_EL NULL
#define OPTION_VAL_BILINEAR_EL NULL
#define OPTION_VAL_3_POINT_EL NULL
#define OPTION_VAL_JINC2_EL NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_EL NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_EL NULL
#define OPTION_VAL_OPAQUE_EL NULL
#define OPTION_VAL_ALL_EL NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_EL NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_EL NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_EL NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_EL NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_EL NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_EL NULL
#define BEETLE_OPT_MSAA_LABEL_EL NULL
#define BEETLE_OPT_MSAA_INFO_0_EL NULL
#define OPTION_VAL_1X_EL NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_EL NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_EL NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_EL NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_EL NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_EL NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_EL NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_EL NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_EL NULL
#define BEETLE_OPT_WIREFRAME_LABEL_EL NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_EL NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_EL NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_EL NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_EL NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_EL NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_EL NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_EL NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_EL NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_EL NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_EL NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_EL NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_EL NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_EL NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_EL NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_EL NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_EL NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_EL NULL
#define OPTION_VAL_LIGHTGUN_EL NULL
#define OPTION_VAL_TOUCHSCREEN_EL NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_EL NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_EL NULL
#define OPTION_VAL_CROSS_EL NULL
#define OPTION_VAL_DOT_EL NULL
#define OPTION_VAL_OFF_EL NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_EL NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_EL NULL
#define OPTION_VAL_RED_EL "Κόκκινο"
#define OPTION_VAL_BLUE_EL "Μπλε"
#define OPTION_VAL_GREEN_EL "Πράσινο"
#define OPTION_VAL_ORANGE_EL NULL
#define OPTION_VAL_YELLOW_EL "Κίτρινο"
#define OPTION_VAL_CYAN_EL NULL
#define OPTION_VAL_PINK_EL NULL
#define OPTION_VAL_PURPLE_EL NULL
#define OPTION_VAL_BLACK_EL NULL
#define OPTION_VAL_WHITE_EL NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_EL NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_EL NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_EL "Ευαισθησία Ποντικιού"
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_EL NULL
#define OPTION_VAL_5_EL NULL
#define OPTION_VAL_10_EL NULL
#define OPTION_VAL_15_EL NULL
#define OPTION_VAL_20_EL NULL
#define OPTION_VAL_25_EL NULL
#define OPTION_VAL_30_EL NULL
#define OPTION_VAL_35_EL NULL
#define OPTION_VAL_40_EL NULL
#define OPTION_VAL_45_EL NULL
#define OPTION_VAL_50_EL NULL
#define OPTION_VAL_55_EL NULL
#define OPTION_VAL_60_EL NULL
#define OPTION_VAL_65_EL NULL
#define OPTION_VAL_70_EL NULL
#define OPTION_VAL_75_EL NULL
#define OPTION_VAL_80_EL "το 80%"
#define OPTION_VAL_85_EL NULL
#define OPTION_VAL_90_EL NULL
#define OPTION_VAL_95_EL NULL
#define OPTION_VAL_100_EL NULL
#define OPTION_VAL_105_EL NULL
#define OPTION_VAL_110_EL NULL
#define OPTION_VAL_115_EL NULL
#define OPTION_VAL_120_EL NULL
#define OPTION_VAL_125_EL NULL
#define OPTION_VAL_130_EL NULL
#define OPTION_VAL_135_EL NULL
#define OPTION_VAL_140_EL NULL
#define OPTION_VAL_145_EL NULL
#define OPTION_VAL_150_EL NULL
#define OPTION_VAL_155_EL NULL
#define OPTION_VAL_160_EL NULL
#define OPTION_VAL_165_EL NULL
#define OPTION_VAL_170_EL NULL
#define OPTION_VAL_175_EL NULL
#define OPTION_VAL_180_EL NULL
#define OPTION_VAL_185_EL NULL
#define OPTION_VAL_190_EL NULL
#define OPTION_VAL_195_EL NULL
#define OPTION_VAL_200_EL NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_EL NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_EL NULL
#define OPTION_VAL_LINEAR_EL "Γραμμικός"
#define OPTION_VAL_QUADRATIC_EL NULL
#define OPTION_VAL_CUBIC_EL NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_EL NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_EL NULL
#define OPTION_VAL_0_EL NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_EL NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_EL NULL
#define OPTION_VAL_LIBRETRO_EL NULL
#define OPTION_VAL_MEDNAFEN_EL NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_EL NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_EL NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_EL NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_EL NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_EL NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_EL NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_EL NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_EL NULL
#define OPTION_VAL_1_EL NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_EL NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_EL NULL
#define OPTION_VAL_MEMORY_ONLY_EL NULL
#define OPTION_VAL_MEMORY_CPU_EL NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_EL NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_EL NULL
#define OPTION_VAL_0PX_EL NULL
#define OPTION_VAL_1PX_EL NULL
#define OPTION_VAL_2PX_EL NULL
#define OPTION_VAL_3PX_EL NULL
#define OPTION_VAL_4PX_EL NULL
#define OPTION_VAL_5PX_EL NULL
#define OPTION_VAL_6PX_EL NULL
#define OPTION_VAL_7PX_EL NULL
#define OPTION_VAL_8PX_EL NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_EL NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_EL NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_EL NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_EL NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_EL NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_EL NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_EL NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_EL NULL
#define OPTION_VAL_DEFAULT_EL "Προκαθορισμένο"
#define OPTION_VAL_AGGRESSIVE_EL NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_EL NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_EL NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_EL NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_EL NULL
#define OPTION_VAL_16_9_EL NULL
#define OPTION_VAL_16_10_EL NULL
#define OPTION_VAL_18_9_EL NULL
#define OPTION_VAL_19_9_EL NULL
#define OPTION_VAL_20_9_EL NULL
#define OPTION_VAL_21_9_EL NULL
#define OPTION_VAL_32_9_EL NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_EL NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_EL NULL
#define OPTION_VAL_100_NATIVE_EL NULL
#define OPTION_VAL_210_EL NULL
#define OPTION_VAL_220_EL NULL
#define OPTION_VAL_230_EL NULL
#define OPTION_VAL_240_EL NULL
#define OPTION_VAL_250_EL NULL
#define OPTION_VAL_260_EL NULL
#define OPTION_VAL_270_EL NULL
#define OPTION_VAL_280_EL NULL
#define OPTION_VAL_290_EL NULL
#define OPTION_VAL_300_EL NULL
#define OPTION_VAL_310_EL NULL
#define OPTION_VAL_320_EL NULL
#define OPTION_VAL_330_EL NULL
#define OPTION_VAL_340_EL NULL
#define OPTION_VAL_350_EL NULL
#define OPTION_VAL_360_EL NULL
#define OPTION_VAL_370_EL NULL
#define OPTION_VAL_380_EL NULL
#define OPTION_VAL_390_EL NULL
#define OPTION_VAL_400_EL NULL
#define OPTION_VAL_410_EL NULL
#define OPTION_VAL_420_EL NULL
#define OPTION_VAL_430_EL NULL
#define OPTION_VAL_440_EL NULL
#define OPTION_VAL_450_EL NULL
#define OPTION_VAL_460_EL NULL
#define OPTION_VAL_470_EL NULL
#define OPTION_VAL_480_EL NULL
#define OPTION_VAL_490_EL NULL
#define OPTION_VAL_500_EL NULL
#define OPTION_VAL_510_EL NULL
#define OPTION_VAL_520_EL NULL
#define OPTION_VAL_530_EL NULL
#define OPTION_VAL_540_EL NULL
#define OPTION_VAL_550_EL NULL
#define OPTION_VAL_560_EL NULL
#define OPTION_VAL_570_EL NULL
#define OPTION_VAL_580_EL NULL
#define OPTION_VAL_590_EL NULL
#define OPTION_VAL_600_EL NULL
#define OPTION_VAL_610_EL NULL
#define OPTION_VAL_620_EL NULL
#define OPTION_VAL_630_EL NULL
#define OPTION_VAL_640_EL NULL
#define OPTION_VAL_650_EL NULL
#define OPTION_VAL_660_EL NULL
#define OPTION_VAL_670_EL NULL
#define OPTION_VAL_680_EL NULL
#define OPTION_VAL_690_EL NULL
#define OPTION_VAL_700_EL NULL
#define OPTION_VAL_710_EL NULL
#define OPTION_VAL_720_EL NULL
#define OPTION_VAL_730_EL NULL
#define OPTION_VAL_740_EL NULL
#define OPTION_VAL_750_EL NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_EL NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_EL NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_EL NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_EL NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_EL NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_EL NULL
#define OPTION_VAL_PSXONPSP_EL NULL
#define OPTION_VAL_PS1_ROM_EL NULL
#define BEETLE_OPT_RENDERER_LABEL_EL NULL
#define BEETLE_OPT_RENDERER_INFO_0_EL NULL
#define OPTION_VAL_HARDWARE_EL NULL
#define OPTION_VAL_HARDWARE_GL_EL NULL
#define OPTION_VAL_HARDWARE_VK_EL NULL
#define OPTION_VAL_SOFTWARE_EL NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_EL NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_EL NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_EL NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_EL NULL
#define OPTION_VAL_DISABLED_EL NULL
#define OPTION_VAL_EXECUTE_EL NULL
#define OPTION_VAL_EXECUTE_ONE_EL NULL
#define OPTION_VAL_RUN_INTERPRETER_EL NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_EL NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_EL NULL
#define OPTION_VAL_FULL_EL NULL
#define OPTION_VAL_DMA_EL NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_EL NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_EL NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_EL NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_EL NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_EL NULL
#define OPTION_VAL_FORCE_INTERLACED_EL NULL
#define OPTION_VAL_AUTO_TOGGLE_EL NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_EL NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_EL NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_EL NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_EL NULL
#define OPTION_VAL_DISABLED_O53_EL "Κανείς"
#define OPTION_VAL_STATIC_EL NULL
#define OPTION_VAL_SMART_EL NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_EL NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_EL NULL
#define OPTION_VAL_9PX_EL NULL
#define OPTION_VAL_10PX_EL NULL
#define OPTION_VAL_11PX_EL NULL
#define OPTION_VAL_12PX_EL NULL
#define OPTION_VAL_13PX_EL NULL
#define OPTION_VAL_14PX_EL NULL
#define OPTION_VAL_15PX_EL NULL
#define OPTION_VAL_16PX_EL NULL
#define OPTION_VAL_17PX_EL NULL
#define OPTION_VAL_18PX_EL NULL
#define OPTION_VAL_19PX_EL NULL
#define OPTION_VAL_20PX_EL NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_EL NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_EL NULL
#define OPTION_VAL_12PX_O55_EL NULL
#define OPTION_VAL_11PX_O55_EL NULL
#define OPTION_VAL_10PX_O55_EL NULL
#define OPTION_VAL_9PX_O55_EL NULL
#define OPTION_VAL_8PX_O55_EL NULL
#define OPTION_VAL_7PX_O55_EL NULL
#define OPTION_VAL_6PX_O55_EL NULL
#define OPTION_VAL_5PX_O55_EL NULL
#define OPTION_VAL_4PX_O55_EL NULL
#define OPTION_VAL_3PX_O55_EL NULL
#define OPTION_VAL_2PX_O55_EL NULL
#define OPTION_VAL_1PX_O55_EL NULL
#define OPTION_VAL_DISABLED_O55_EL "0 (Προεπιλογή)"
#define OPTION_VAL_1PX_O55_0_EL NULL
#define OPTION_VAL_2PX_O55_0_EL NULL
#define OPTION_VAL_3PX_O55_0_EL NULL
#define OPTION_VAL_4PX_O55_0_EL NULL
#define OPTION_VAL_5PX_O55_0_EL NULL
#define OPTION_VAL_6PX_O55_0_EL NULL
#define OPTION_VAL_7PX_O55_0_EL NULL
#define OPTION_VAL_8PX_O55_0_EL NULL
#define OPTION_VAL_9PX_O55_0_EL NULL
#define OPTION_VAL_10PX_O55_0_EL NULL
#define OPTION_VAL_11PX_O55_0_EL NULL
#define OPTION_VAL_12PX_O55_0_EL NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_EL NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_EL NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_EL NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_EL NULL
#define OPTION_VAL_32X_EL NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_EL NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_EL NULL
#define OPTION_VAL_CORRECTED_EL NULL
#define OPTION_VAL_UNCORRECTED_EL NULL
#define OPTION_VAL_4_3_EL NULL
#define OPTION_VAL_NTSC_EL NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_EL NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_EL NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_EL NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_EL NULL
#define OPTION_VAL_239_EL "239 (Προεπιλογή)"
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_EL NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_EL NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_EL NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_EL NULL
#define OPTION_VAL_287_EL "287 (Προεπιλογή)"
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_EL NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_EL NULL
#define OPTION_VAL_SYNC_EL NULL
#define OPTION_VAL_ASYNC_EL NULL
#define OPTION_VAL_PRECACHE_EL NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_EL NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_EL NULL
#define OPTION_VAL_2X_NATIVE_EL NULL
#define OPTION_VAL_6X_EL NULL
#define OPTION_VAL_10X_EL NULL
#define OPTION_VAL_12X_EL NULL
#define OPTION_VAL_14X_EL NULL

struct retro_core_option_v2_category option_cats_el[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_EL,
      CATEGORY_VIDEO_INFO_0_EL
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_EL,
      CATEGORY_OSD_INFO_0_EL
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_EL,
      CATEGORY_INPUT_INFO_0_EL
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_EL,
      CATEGORY_MEMCARDS_INFO_0_EL
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_EL,
      CATEGORY_PGXP_INFO_0_EL
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_EL,
      CATEGORY_HACKS_INFO_0_EL
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_el[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_EL,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_EL,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_EL },
         { "2x",         OPTION_VAL_2X_EL },
         { "4x",         OPTION_VAL_4X_EL },
         { "8x",         OPTION_VAL_8X_EL },
         { "16x",        OPTION_VAL_16X_EL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_EL,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_EL,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_EL },
         { "32bpp",         OPTION_VAL_32BPP_EL },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_EL,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_EL,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_EL },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_EL },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_EL,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_EL,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_EL,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_EL,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_EL },
         { "SABR",     OPTION_VAL_SABR_EL },
         { "xBR",      OPTION_VAL_XBR_EL },
         { "bilinear", OPTION_VAL_BILINEAR_EL },
         { "3-point",  OPTION_VAL_3_POINT_EL },
         { "JINC2",    OPTION_VAL_JINC2_EL },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_EL,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_EL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_EL },
         { "all", OPTION_VAL_ALL_EL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_EL,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_EL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_EL },
         { "all", OPTION_VAL_ALL_EL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_EL,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_EL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_EL,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_EL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_EL,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_EL,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_EL },
         { "2x",  OPTION_VAL_2X_EL },
         { "4x",  OPTION_VAL_4X_EL },
         { "8x",  OPTION_VAL_8X_EL },
         { "16x", OPTION_VAL_16X_EL },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_EL,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_EL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_EL,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_EL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_EL,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_EL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_EL,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_EL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_EL,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_EL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_EL,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_EL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_EL,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_EL,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_EL,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_EL,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_EL,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_EL,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_EL,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_EL,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_EL,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_EL,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_EL,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_EL,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_EL,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_EL,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_EL },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_EL },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_EL,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_EL,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_EL },
         { "dot",   OPTION_VAL_DOT_EL },
         { "off",   OPTION_VAL_OFF_EL },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_EL,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_EL,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_EL },
         { "blue", OPTION_VAL_BLUE_EL },
         { "green", OPTION_VAL_GREEN_EL },
         { "orange", OPTION_VAL_ORANGE_EL },
         { "yellow", OPTION_VAL_YELLOW_EL },
         { "cyan", OPTION_VAL_CYAN_EL },
         { "pink", OPTION_VAL_PINK_EL },
         { "purple", OPTION_VAL_PURPLE_EL },
         { "black", OPTION_VAL_BLACK_EL },
         { "white", OPTION_VAL_WHITE_EL },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_EL,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_EL,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_EL },
         { "red", OPTION_VAL_RED_EL },
         { "green", OPTION_VAL_GREEN_EL },
         { "orange", OPTION_VAL_ORANGE_EL },
         { "yellow", OPTION_VAL_YELLOW_EL },
         { "cyan", OPTION_VAL_CYAN_EL },
         { "pink", OPTION_VAL_PINK_EL },
         { "purple", OPTION_VAL_PURPLE_EL },
         { "black", OPTION_VAL_BLACK_EL },
         { "white", OPTION_VAL_WHITE_EL },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_EL,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_EL,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_EL },
         { "10%",  OPTION_VAL_10_EL },
         { "15%",  OPTION_VAL_15_EL },
         { "20%",  OPTION_VAL_20_EL },
         { "25%",  OPTION_VAL_25_EL },
         { "30%",  OPTION_VAL_30_EL },
         { "35%",  OPTION_VAL_35_EL },
         { "40%",  OPTION_VAL_40_EL },
         { "45%",  OPTION_VAL_45_EL },
         { "50%",  OPTION_VAL_50_EL },
         { "55%",  OPTION_VAL_55_EL },
         { "60%",  OPTION_VAL_60_EL },
         { "65%",  OPTION_VAL_65_EL },
         { "70%",  OPTION_VAL_70_EL },
         { "75%",  OPTION_VAL_75_EL },
         { "80%",  OPTION_VAL_80_EL },
         { "85%",  OPTION_VAL_85_EL },
         { "90%",  OPTION_VAL_90_EL },
         { "95%",  OPTION_VAL_95_EL },
         { "100%", OPTION_VAL_100_EL },
         { "105%", OPTION_VAL_105_EL },
         { "110%", OPTION_VAL_110_EL },
         { "115%", OPTION_VAL_115_EL },
         { "120%", OPTION_VAL_120_EL },
         { "125%", OPTION_VAL_125_EL },
         { "130%", OPTION_VAL_130_EL },
         { "135%", OPTION_VAL_135_EL },
         { "140%", OPTION_VAL_140_EL },
         { "145%", OPTION_VAL_145_EL },
         { "150%", OPTION_VAL_150_EL },
         { "155%", OPTION_VAL_155_EL },
         { "160%", OPTION_VAL_160_EL },
         { "165%", OPTION_VAL_165_EL },
         { "170%", OPTION_VAL_170_EL },
         { "175%", OPTION_VAL_175_EL },
         { "180%", OPTION_VAL_180_EL },
         { "185%", OPTION_VAL_185_EL },
         { "190%", OPTION_VAL_190_EL },
         { "195%", OPTION_VAL_195_EL },
         { "200%", OPTION_VAL_200_EL },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_EL,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_EL,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_EL },
         { "quadratic", OPTION_VAL_QUADRATIC_EL },
         { "cubic",     OPTION_VAL_CUBIC_EL },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_EL,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_EL,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_EL },
         { "5%",  OPTION_VAL_5_EL },
         { "10%", OPTION_VAL_10_EL },
         { "15%", OPTION_VAL_15_EL },
         { "20%", OPTION_VAL_20_EL },
         { "25%", OPTION_VAL_25_EL },
         { "30%", OPTION_VAL_30_EL },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_EL,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_EL,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_EL },
         { "mednafen", OPTION_VAL_MEDNAFEN_EL },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_EL,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_EL,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_EL,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_EL,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_EL,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_EL,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_EL,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_EL,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_EL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_EL,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_EL,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_EL },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_EL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_EL,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_EL,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_EL },
         { "1px", OPTION_VAL_1PX_EL },
         { "2px", OPTION_VAL_2PX_EL },
         { "3px", OPTION_VAL_3PX_EL },
         { "4px", OPTION_VAL_4PX_EL },
         { "5px", OPTION_VAL_5PX_EL },
         { "6px", OPTION_VAL_6PX_EL },
         { "7px", OPTION_VAL_7PX_EL },
         { "8px", OPTION_VAL_8PX_EL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_EL,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_EL,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_EL,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_EL,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_EL,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_EL,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_EL,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_EL,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_EL },
         { "aggressive", OPTION_VAL_AGGRESSIVE_EL },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_EL,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_EL,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_EL,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_EL,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_EL },
         { "16:10", OPTION_VAL_16_10_EL },
         { "18:9",  OPTION_VAL_18_9_EL },
         { "19:9",  OPTION_VAL_19_9_EL },
         { "20:9",  OPTION_VAL_20_9_EL },
         { "21:9",  OPTION_VAL_21_9_EL }, // 64:27
         { "32:9",  OPTION_VAL_32_9_EL },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_EL,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_EL,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_EL },
         { "60%",           OPTION_VAL_60_EL },
         { "70%",           OPTION_VAL_70_EL },
         { "80%",           OPTION_VAL_80_EL },
         { "90%",           OPTION_VAL_90_EL },
         { "100%(native)", OPTION_VAL_100_NATIVE_EL },
         { "110%",          OPTION_VAL_110_EL },
         { "120%",          OPTION_VAL_120_EL },
         { "130%",          OPTION_VAL_130_EL },
         { "140%",          OPTION_VAL_140_EL },
         { "150%",          OPTION_VAL_150_EL },
         { "160%",          OPTION_VAL_160_EL },
         { "170%",          OPTION_VAL_170_EL },
         { "180%",          OPTION_VAL_180_EL },
         { "190%",          OPTION_VAL_190_EL },
         { "200%",          OPTION_VAL_200_EL },
         { "210%",          OPTION_VAL_210_EL },
         { "220%",          OPTION_VAL_220_EL },
         { "230%",          OPTION_VAL_230_EL },
         { "240%",          OPTION_VAL_240_EL },
         { "250%",          OPTION_VAL_250_EL },
         { "260%",          OPTION_VAL_260_EL },
         { "270%",          OPTION_VAL_270_EL },
         { "280%",          OPTION_VAL_280_EL },
         { "290%",          OPTION_VAL_290_EL },
         { "300%",          OPTION_VAL_300_EL },
         { "310%",          OPTION_VAL_310_EL },
         { "320%",          OPTION_VAL_320_EL },
         { "330%",          OPTION_VAL_330_EL },
         { "340%",          OPTION_VAL_340_EL },
         { "350%",          OPTION_VAL_350_EL },
         { "360%",          OPTION_VAL_360_EL },
         { "370%",          OPTION_VAL_370_EL },
         { "380%",          OPTION_VAL_380_EL },
         { "390%",          OPTION_VAL_390_EL },
         { "400%",          OPTION_VAL_400_EL },
         { "410%",          OPTION_VAL_410_EL },
         { "420%",          OPTION_VAL_420_EL },
         { "430%",          OPTION_VAL_430_EL },
         { "440%",          OPTION_VAL_440_EL },
         { "450%",          OPTION_VAL_450_EL },
         { "460%",          OPTION_VAL_460_EL },
         { "470%",          OPTION_VAL_470_EL },
         { "480%",          OPTION_VAL_480_EL },
         { "490%",          OPTION_VAL_490_EL },
         { "500%",          OPTION_VAL_500_EL },
         { "510%",          OPTION_VAL_510_EL },
         { "520%",          OPTION_VAL_520_EL },
         { "530%",          OPTION_VAL_530_EL },
         { "540%",          OPTION_VAL_540_EL },
         { "550%",          OPTION_VAL_550_EL },
         { "560%",          OPTION_VAL_560_EL },
         { "570%",          OPTION_VAL_570_EL },
         { "580%",          OPTION_VAL_580_EL },
         { "590%",          OPTION_VAL_590_EL },
         { "600%",          OPTION_VAL_600_EL },
         { "610%",          OPTION_VAL_610_EL },
         { "620%",          OPTION_VAL_620_EL },
         { "630%",          OPTION_VAL_630_EL },
         { "640%",          OPTION_VAL_640_EL },
         { "650%",          OPTION_VAL_650_EL },
         { "660%",          OPTION_VAL_660_EL },
         { "670%",          OPTION_VAL_670_EL },
         { "680%",          OPTION_VAL_680_EL },
         { "690%",          OPTION_VAL_690_EL },
         { "700%",          OPTION_VAL_700_EL },
         { "710%",          OPTION_VAL_710_EL },
         { "720%",          OPTION_VAL_720_EL },
         { "730%",          OPTION_VAL_730_EL },
         { "740%",          OPTION_VAL_740_EL },
         { "750%",          OPTION_VAL_750_EL },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_EL,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_EL,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_EL,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_EL,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_EL,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_EL,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_EL },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_EL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_EL,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_EL,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_EL },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_EL },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_EL },
#endif
         { "software",    OPTION_VAL_SOFTWARE_EL },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_EL,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_EL,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_EL,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_EL,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_EL },
         { "execute",  OPTION_VAL_EXECUTE_EL },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_EL },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_EL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_EL,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_EL,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_EL },
         { "dma",  OPTION_VAL_DMA_EL },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_EL,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_EL,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_EL,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_EL,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_EL },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_EL },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_EL },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_EL,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_EL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_EL,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_EL,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_EL },
         { "static",  OPTION_VAL_STATIC_EL },
         { "smart", OPTION_VAL_SMART_EL },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_EL,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_EL,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_EL },
         { "2px",      OPTION_VAL_2PX_EL },
         { "3px",      OPTION_VAL_3PX_EL },
         { "4px",      OPTION_VAL_4PX_EL },
         { "5px",      OPTION_VAL_5PX_EL },
         { "6px",      OPTION_VAL_6PX_EL },
         { "7px",      OPTION_VAL_7PX_EL },
         { "8px",      OPTION_VAL_8PX_EL },
         { "9px",      OPTION_VAL_9PX_EL },
         { "10px",     OPTION_VAL_10PX_EL },
         { "11px",     OPTION_VAL_11PX_EL },
         { "12px",     OPTION_VAL_12PX_EL },
         { "13px",     OPTION_VAL_13PX_EL },
         { "14px",     OPTION_VAL_14PX_EL },
         { "15px",     OPTION_VAL_15PX_EL },
         { "16px",     OPTION_VAL_16PX_EL },
         { "17px",     OPTION_VAL_17PX_EL },
         { "18px",     OPTION_VAL_18PX_EL },
         { "19px",     OPTION_VAL_19PX_EL },
         { "20px",     OPTION_VAL_20PX_EL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_EL,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_EL,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_EL },
         { "-11px",    OPTION_VAL_11PX_O55_EL },
         { "-10px",    OPTION_VAL_10PX_O55_EL },
         { "-9px",     OPTION_VAL_9PX_O55_EL },
         { "-8px",     OPTION_VAL_8PX_O55_EL },
         { "-7px",     OPTION_VAL_7PX_O55_EL },
         { "-6px",     OPTION_VAL_6PX_O55_EL },
         { "-5px",     OPTION_VAL_5PX_O55_EL },
         { "-4px",     OPTION_VAL_4PX_O55_EL },
         { "-3px",     OPTION_VAL_3PX_O55_EL },
         { "-2px",     OPTION_VAL_2PX_O55_EL },
         { "-1px",     OPTION_VAL_1PX_O55_EL },
         { "disabled", OPTION_VAL_DISABLED_O55_EL },
         { "+1px",     OPTION_VAL_1PX_O55_0_EL },
         { "+2px",     OPTION_VAL_2PX_O55_0_EL },
         { "+3px",     OPTION_VAL_3PX_O55_0_EL },
         { "+4px",     OPTION_VAL_4PX_O55_0_EL },
         { "+5px",     OPTION_VAL_5PX_O55_0_EL },
         { "+6px",     OPTION_VAL_6PX_O55_0_EL },
         { "+7px",     OPTION_VAL_7PX_O55_0_EL },
         { "+8px",     OPTION_VAL_8PX_O55_0_EL },
         { "+9px",     OPTION_VAL_9PX_O55_0_EL },
         { "+10px",    OPTION_VAL_10PX_O55_0_EL },
         { "+11px",    OPTION_VAL_11PX_O55_0_EL },
         { "+12px",    OPTION_VAL_12PX_O55_0_EL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_EL,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_EL,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_EL },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_EL,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_EL,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_EL },
         { "2x",         OPTION_VAL_2X_EL },
         { "4x",         OPTION_VAL_4X_EL },
         { "8x",         OPTION_VAL_8X_EL },
         { "16x",        OPTION_VAL_16X_EL },
         { "32x",        OPTION_VAL_32X_EL },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_EL,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_EL,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_EL },
         { "uncorrected", OPTION_VAL_UNCORRECTED_EL },
         { "4:3",  OPTION_VAL_4_3_EL },
         { "ntsc", OPTION_VAL_NTSC_EL },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_EL,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_EL,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_EL,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_EL,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_EL },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_EL,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_EL,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_EL,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_EL,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_EL },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_EL,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_EL,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_EL },
         { "async",    OPTION_VAL_ASYNC_EL },
         { "precache", OPTION_VAL_PRECACHE_EL },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_EL,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_EL,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_EL },
         { "4x",          OPTION_VAL_4X_EL },
         { "6x",          OPTION_VAL_6X_EL },
         { "8x",          OPTION_VAL_8X_EL },
         { "10x",         OPTION_VAL_10X_EL },
         { "12x",         OPTION_VAL_12X_EL },
         { "14x",         OPTION_VAL_14X_EL },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_el = {
   option_cats_el,
   option_defs_el
};

/* RETRO_LANGUAGE_EO */

#define CATEGORY_VIDEO_LABEL_EO "Video Driver"
#define CATEGORY_VIDEO_INFO_0_EO NULL
#define CATEGORY_OSD_LABEL_EO "Enable Onscreen Notifications"
#define CATEGORY_OSD_INFO_0_EO NULL
#define CATEGORY_INPUT_LABEL_EO "Input Driver"
#define CATEGORY_INPUT_INFO_0_EO NULL
#define CATEGORY_MEMCARDS_LABEL_EO NULL
#define CATEGORY_MEMCARDS_INFO_0_EO NULL
#define CATEGORY_PGXP_LABEL_EO NULL
#define CATEGORY_PGXP_INFO_0_EO NULL
#define CATEGORY_HACKS_LABEL_EO NULL
#define CATEGORY_HACKS_INFO_0_EO NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_EO NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_EO NULL
#define OPTION_VAL_1X_NATIVE_EO NULL
#define OPTION_VAL_2X_EO NULL
#define OPTION_VAL_4X_EO NULL
#define OPTION_VAL_8X_EO NULL
#define OPTION_VAL_16X_EO NULL
#define BEETLE_OPT_DEPTH_LABEL_EO NULL
#define BEETLE_OPT_DEPTH_INFO_0_EO NULL
#define OPTION_VAL_16BPP_NATIVE_EO NULL
#define OPTION_VAL_32BPP_EO NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_EO NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_EO NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_EO "Interna Rezolucio"
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_EO NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_EO NULL
#define BEETLE_OPT_FILTER_LABEL_EO NULL
#define BEETLE_OPT_FILTER_INFO_0_EO NULL
#define OPTION_VAL_NEAREST_EO NULL
#define OPTION_VAL_SABR_EO NULL
#define OPTION_VAL_XBR_EO NULL
#define OPTION_VAL_BILINEAR_EO NULL
#define OPTION_VAL_3_POINT_EO NULL
#define OPTION_VAL_JINC2_EO NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_EO NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_EO NULL
#define OPTION_VAL_OPAQUE_EO NULL
#define OPTION_VAL_ALL_EO NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_EO NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_EO NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_EO NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_EO NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_EO NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_EO NULL
#define BEETLE_OPT_MSAA_LABEL_EO NULL
#define BEETLE_OPT_MSAA_INFO_0_EO NULL
#define OPTION_VAL_1X_EO NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_EO NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_EO NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_EO NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_EO NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_EO NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_EO NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_EO NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_EO NULL
#define BEETLE_OPT_WIREFRAME_LABEL_EO NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_EO NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_EO NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_EO NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_EO NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_EO NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_EO NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_EO NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_EO NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_EO NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_EO NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_EO NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_EO NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_EO NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_EO NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_EO NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_EO NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_EO NULL
#define OPTION_VAL_LIGHTGUN_EO NULL
#define OPTION_VAL_TOUCHSCREEN_EO NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_EO NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_EO NULL
#define OPTION_VAL_CROSS_EO NULL
#define OPTION_VAL_DOT_EO NULL
#define OPTION_VAL_OFF_EO NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_EO NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_EO NULL
#define OPTION_VAL_RED_EO NULL
#define OPTION_VAL_BLUE_EO NULL
#define OPTION_VAL_GREEN_EO NULL
#define OPTION_VAL_ORANGE_EO NULL
#define OPTION_VAL_YELLOW_EO NULL
#define OPTION_VAL_CYAN_EO NULL
#define OPTION_VAL_PINK_EO NULL
#define OPTION_VAL_PURPLE_EO NULL
#define OPTION_VAL_BLACK_EO NULL
#define OPTION_VAL_WHITE_EO NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_EO NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_EO NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_EO NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_EO NULL
#define OPTION_VAL_5_EO NULL
#define OPTION_VAL_10_EO NULL
#define OPTION_VAL_15_EO NULL
#define OPTION_VAL_20_EO NULL
#define OPTION_VAL_25_EO NULL
#define OPTION_VAL_30_EO NULL
#define OPTION_VAL_35_EO NULL
#define OPTION_VAL_40_EO NULL
#define OPTION_VAL_45_EO NULL
#define OPTION_VAL_50_EO NULL
#define OPTION_VAL_55_EO NULL
#define OPTION_VAL_60_EO NULL
#define OPTION_VAL_65_EO NULL
#define OPTION_VAL_70_EO NULL
#define OPTION_VAL_75_EO NULL
#define OPTION_VAL_80_EO NULL
#define OPTION_VAL_85_EO NULL
#define OPTION_VAL_90_EO NULL
#define OPTION_VAL_95_EO NULL
#define OPTION_VAL_100_EO NULL
#define OPTION_VAL_105_EO NULL
#define OPTION_VAL_110_EO NULL
#define OPTION_VAL_115_EO NULL
#define OPTION_VAL_120_EO NULL
#define OPTION_VAL_125_EO NULL
#define OPTION_VAL_130_EO NULL
#define OPTION_VAL_135_EO NULL
#define OPTION_VAL_140_EO NULL
#define OPTION_VAL_145_EO NULL
#define OPTION_VAL_150_EO NULL
#define OPTION_VAL_155_EO NULL
#define OPTION_VAL_160_EO NULL
#define OPTION_VAL_165_EO NULL
#define OPTION_VAL_170_EO NULL
#define OPTION_VAL_175_EO NULL
#define OPTION_VAL_180_EO NULL
#define OPTION_VAL_185_EO NULL
#define OPTION_VAL_190_EO NULL
#define OPTION_VAL_195_EO NULL
#define OPTION_VAL_200_EO NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_EO NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_EO NULL
#define OPTION_VAL_LINEAR_EO NULL
#define OPTION_VAL_QUADRATIC_EO NULL
#define OPTION_VAL_CUBIC_EO NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_EO NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_EO NULL
#define OPTION_VAL_0_EO NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_EO NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_EO NULL
#define OPTION_VAL_LIBRETRO_EO NULL
#define OPTION_VAL_MEDNAFEN_EO NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_EO NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_EO NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_EO NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_EO NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_EO NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_EO NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_EO NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_EO NULL
#define OPTION_VAL_1_EO NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_EO NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_EO NULL
#define OPTION_VAL_MEMORY_ONLY_EO NULL
#define OPTION_VAL_MEMORY_CPU_EO NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_EO NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_EO NULL
#define OPTION_VAL_0PX_EO NULL
#define OPTION_VAL_1PX_EO NULL
#define OPTION_VAL_2PX_EO NULL
#define OPTION_VAL_3PX_EO NULL
#define OPTION_VAL_4PX_EO NULL
#define OPTION_VAL_5PX_EO NULL
#define OPTION_VAL_6PX_EO NULL
#define OPTION_VAL_7PX_EO NULL
#define OPTION_VAL_8PX_EO NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_EO NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_EO NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_EO NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_EO NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_EO NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_EO NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_EO NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_EO NULL
#define OPTION_VAL_DEFAULT_EO NULL
#define OPTION_VAL_AGGRESSIVE_EO NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_EO NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_EO NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_EO NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_EO NULL
#define OPTION_VAL_16_9_EO NULL
#define OPTION_VAL_16_10_EO NULL
#define OPTION_VAL_18_9_EO NULL
#define OPTION_VAL_19_9_EO NULL
#define OPTION_VAL_20_9_EO NULL
#define OPTION_VAL_21_9_EO NULL
#define OPTION_VAL_32_9_EO NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_EO NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_EO NULL
#define OPTION_VAL_100_NATIVE_EO NULL
#define OPTION_VAL_210_EO NULL
#define OPTION_VAL_220_EO NULL
#define OPTION_VAL_230_EO NULL
#define OPTION_VAL_240_EO NULL
#define OPTION_VAL_250_EO NULL
#define OPTION_VAL_260_EO NULL
#define OPTION_VAL_270_EO NULL
#define OPTION_VAL_280_EO NULL
#define OPTION_VAL_290_EO NULL
#define OPTION_VAL_300_EO NULL
#define OPTION_VAL_310_EO NULL
#define OPTION_VAL_320_EO NULL
#define OPTION_VAL_330_EO NULL
#define OPTION_VAL_340_EO NULL
#define OPTION_VAL_350_EO NULL
#define OPTION_VAL_360_EO NULL
#define OPTION_VAL_370_EO NULL
#define OPTION_VAL_380_EO NULL
#define OPTION_VAL_390_EO NULL
#define OPTION_VAL_400_EO NULL
#define OPTION_VAL_410_EO NULL
#define OPTION_VAL_420_EO NULL
#define OPTION_VAL_430_EO NULL
#define OPTION_VAL_440_EO NULL
#define OPTION_VAL_450_EO NULL
#define OPTION_VAL_460_EO NULL
#define OPTION_VAL_470_EO NULL
#define OPTION_VAL_480_EO NULL
#define OPTION_VAL_490_EO NULL
#define OPTION_VAL_500_EO NULL
#define OPTION_VAL_510_EO NULL
#define OPTION_VAL_520_EO NULL
#define OPTION_VAL_530_EO NULL
#define OPTION_VAL_540_EO NULL
#define OPTION_VAL_550_EO NULL
#define OPTION_VAL_560_EO NULL
#define OPTION_VAL_570_EO NULL
#define OPTION_VAL_580_EO NULL
#define OPTION_VAL_590_EO NULL
#define OPTION_VAL_600_EO NULL
#define OPTION_VAL_610_EO NULL
#define OPTION_VAL_620_EO NULL
#define OPTION_VAL_630_EO NULL
#define OPTION_VAL_640_EO NULL
#define OPTION_VAL_650_EO NULL
#define OPTION_VAL_660_EO NULL
#define OPTION_VAL_670_EO NULL
#define OPTION_VAL_680_EO NULL
#define OPTION_VAL_690_EO NULL
#define OPTION_VAL_700_EO NULL
#define OPTION_VAL_710_EO NULL
#define OPTION_VAL_720_EO NULL
#define OPTION_VAL_730_EO NULL
#define OPTION_VAL_740_EO NULL
#define OPTION_VAL_750_EO NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_EO NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_EO NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_EO NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_EO NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_EO NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_EO NULL
#define OPTION_VAL_PSXONPSP_EO NULL
#define OPTION_VAL_PS1_ROM_EO NULL
#define BEETLE_OPT_RENDERER_LABEL_EO NULL
#define BEETLE_OPT_RENDERER_INFO_0_EO NULL
#define OPTION_VAL_HARDWARE_EO NULL
#define OPTION_VAL_HARDWARE_GL_EO NULL
#define OPTION_VAL_HARDWARE_VK_EO NULL
#define OPTION_VAL_SOFTWARE_EO NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_EO NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_EO NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_EO NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_EO NULL
#define OPTION_VAL_DISABLED_EO NULL
#define OPTION_VAL_EXECUTE_EO NULL
#define OPTION_VAL_EXECUTE_ONE_EO NULL
#define OPTION_VAL_RUN_INTERPRETER_EO NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_EO NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_EO NULL
#define OPTION_VAL_FULL_EO NULL
#define OPTION_VAL_DMA_EO NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_EO NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_EO NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_EO NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_EO NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_EO NULL
#define OPTION_VAL_FORCE_INTERLACED_EO NULL
#define OPTION_VAL_AUTO_TOGGLE_EO NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_EO NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_EO NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_EO NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_EO NULL
#define OPTION_VAL_DISABLED_O53_EO NULL
#define OPTION_VAL_STATIC_EO NULL
#define OPTION_VAL_SMART_EO NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_EO NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_EO NULL
#define OPTION_VAL_9PX_EO NULL
#define OPTION_VAL_10PX_EO NULL
#define OPTION_VAL_11PX_EO NULL
#define OPTION_VAL_12PX_EO NULL
#define OPTION_VAL_13PX_EO NULL
#define OPTION_VAL_14PX_EO NULL
#define OPTION_VAL_15PX_EO NULL
#define OPTION_VAL_16PX_EO NULL
#define OPTION_VAL_17PX_EO NULL
#define OPTION_VAL_18PX_EO NULL
#define OPTION_VAL_19PX_EO NULL
#define OPTION_VAL_20PX_EO NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_EO NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_EO NULL
#define OPTION_VAL_12PX_O55_EO NULL
#define OPTION_VAL_11PX_O55_EO NULL
#define OPTION_VAL_10PX_O55_EO NULL
#define OPTION_VAL_9PX_O55_EO NULL
#define OPTION_VAL_8PX_O55_EO NULL
#define OPTION_VAL_7PX_O55_EO NULL
#define OPTION_VAL_6PX_O55_EO NULL
#define OPTION_VAL_5PX_O55_EO NULL
#define OPTION_VAL_4PX_O55_EO NULL
#define OPTION_VAL_3PX_O55_EO NULL
#define OPTION_VAL_2PX_O55_EO NULL
#define OPTION_VAL_1PX_O55_EO NULL
#define OPTION_VAL_DISABLED_O55_EO NULL
#define OPTION_VAL_1PX_O55_0_EO NULL
#define OPTION_VAL_2PX_O55_0_EO NULL
#define OPTION_VAL_3PX_O55_0_EO NULL
#define OPTION_VAL_4PX_O55_0_EO NULL
#define OPTION_VAL_5PX_O55_0_EO NULL
#define OPTION_VAL_6PX_O55_0_EO NULL
#define OPTION_VAL_7PX_O55_0_EO NULL
#define OPTION_VAL_8PX_O55_0_EO NULL
#define OPTION_VAL_9PX_O55_0_EO NULL
#define OPTION_VAL_10PX_O55_0_EO NULL
#define OPTION_VAL_11PX_O55_0_EO NULL
#define OPTION_VAL_12PX_O55_0_EO NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_EO NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_EO NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_EO NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_EO NULL
#define OPTION_VAL_32X_EO NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_EO NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_EO NULL
#define OPTION_VAL_CORRECTED_EO NULL
#define OPTION_VAL_UNCORRECTED_EO NULL
#define OPTION_VAL_4_3_EO NULL
#define OPTION_VAL_NTSC_EO NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_EO NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_EO NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_EO NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_EO NULL
#define OPTION_VAL_239_EO NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_EO NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_EO NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_EO NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_EO NULL
#define OPTION_VAL_287_EO NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_EO NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_EO NULL
#define OPTION_VAL_SYNC_EO NULL
#define OPTION_VAL_ASYNC_EO NULL
#define OPTION_VAL_PRECACHE_EO NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_EO NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_EO NULL
#define OPTION_VAL_2X_NATIVE_EO NULL
#define OPTION_VAL_6X_EO NULL
#define OPTION_VAL_10X_EO NULL
#define OPTION_VAL_12X_EO NULL
#define OPTION_VAL_14X_EO NULL

struct retro_core_option_v2_category option_cats_eo[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_EO,
      CATEGORY_VIDEO_INFO_0_EO
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_EO,
      CATEGORY_OSD_INFO_0_EO
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_EO,
      CATEGORY_INPUT_INFO_0_EO
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_EO,
      CATEGORY_MEMCARDS_INFO_0_EO
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_EO,
      CATEGORY_PGXP_INFO_0_EO
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_EO,
      CATEGORY_HACKS_INFO_0_EO
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_eo[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_EO,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_EO,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_EO },
         { "2x",         OPTION_VAL_2X_EO },
         { "4x",         OPTION_VAL_4X_EO },
         { "8x",         OPTION_VAL_8X_EO },
         { "16x",        OPTION_VAL_16X_EO },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_EO,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_EO,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_EO },
         { "32bpp",         OPTION_VAL_32BPP_EO },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_EO,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_EO,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_EO },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_EO },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_EO,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_EO,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_EO,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_EO,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_EO },
         { "SABR",     OPTION_VAL_SABR_EO },
         { "xBR",      OPTION_VAL_XBR_EO },
         { "bilinear", OPTION_VAL_BILINEAR_EO },
         { "3-point",  OPTION_VAL_3_POINT_EO },
         { "JINC2",    OPTION_VAL_JINC2_EO },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_EO,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_EO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_EO },
         { "all", OPTION_VAL_ALL_EO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_EO,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_EO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_EO },
         { "all", OPTION_VAL_ALL_EO },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_EO,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_EO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_EO,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_EO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_EO,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_EO,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_EO },
         { "2x",  OPTION_VAL_2X_EO },
         { "4x",  OPTION_VAL_4X_EO },
         { "8x",  OPTION_VAL_8X_EO },
         { "16x", OPTION_VAL_16X_EO },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_EO,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_EO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_EO,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_EO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_EO,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_EO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_EO,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_EO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_EO,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_EO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_EO,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_EO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_EO,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_EO,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_EO,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_EO,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_EO,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_EO,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_EO,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_EO,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_EO,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_EO,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_EO,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_EO,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_EO,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_EO,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_EO },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_EO },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_EO,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_EO,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_EO },
         { "dot",   OPTION_VAL_DOT_EO },
         { "off",   OPTION_VAL_OFF_EO },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_EO,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_EO,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_EO },
         { "blue", OPTION_VAL_BLUE_EO },
         { "green", OPTION_VAL_GREEN_EO },
         { "orange", OPTION_VAL_ORANGE_EO },
         { "yellow", OPTION_VAL_YELLOW_EO },
         { "cyan", OPTION_VAL_CYAN_EO },
         { "pink", OPTION_VAL_PINK_EO },
         { "purple", OPTION_VAL_PURPLE_EO },
         { "black", OPTION_VAL_BLACK_EO },
         { "white", OPTION_VAL_WHITE_EO },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_EO,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_EO,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_EO },
         { "red", OPTION_VAL_RED_EO },
         { "green", OPTION_VAL_GREEN_EO },
         { "orange", OPTION_VAL_ORANGE_EO },
         { "yellow", OPTION_VAL_YELLOW_EO },
         { "cyan", OPTION_VAL_CYAN_EO },
         { "pink", OPTION_VAL_PINK_EO },
         { "purple", OPTION_VAL_PURPLE_EO },
         { "black", OPTION_VAL_BLACK_EO },
         { "white", OPTION_VAL_WHITE_EO },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_EO,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_EO,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_EO },
         { "10%",  OPTION_VAL_10_EO },
         { "15%",  OPTION_VAL_15_EO },
         { "20%",  OPTION_VAL_20_EO },
         { "25%",  OPTION_VAL_25_EO },
         { "30%",  OPTION_VAL_30_EO },
         { "35%",  OPTION_VAL_35_EO },
         { "40%",  OPTION_VAL_40_EO },
         { "45%",  OPTION_VAL_45_EO },
         { "50%",  OPTION_VAL_50_EO },
         { "55%",  OPTION_VAL_55_EO },
         { "60%",  OPTION_VAL_60_EO },
         { "65%",  OPTION_VAL_65_EO },
         { "70%",  OPTION_VAL_70_EO },
         { "75%",  OPTION_VAL_75_EO },
         { "80%",  OPTION_VAL_80_EO },
         { "85%",  OPTION_VAL_85_EO },
         { "90%",  OPTION_VAL_90_EO },
         { "95%",  OPTION_VAL_95_EO },
         { "100%", OPTION_VAL_100_EO },
         { "105%", OPTION_VAL_105_EO },
         { "110%", OPTION_VAL_110_EO },
         { "115%", OPTION_VAL_115_EO },
         { "120%", OPTION_VAL_120_EO },
         { "125%", OPTION_VAL_125_EO },
         { "130%", OPTION_VAL_130_EO },
         { "135%", OPTION_VAL_135_EO },
         { "140%", OPTION_VAL_140_EO },
         { "145%", OPTION_VAL_145_EO },
         { "150%", OPTION_VAL_150_EO },
         { "155%", OPTION_VAL_155_EO },
         { "160%", OPTION_VAL_160_EO },
         { "165%", OPTION_VAL_165_EO },
         { "170%", OPTION_VAL_170_EO },
         { "175%", OPTION_VAL_175_EO },
         { "180%", OPTION_VAL_180_EO },
         { "185%", OPTION_VAL_185_EO },
         { "190%", OPTION_VAL_190_EO },
         { "195%", OPTION_VAL_195_EO },
         { "200%", OPTION_VAL_200_EO },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_EO,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_EO,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_EO },
         { "quadratic", OPTION_VAL_QUADRATIC_EO },
         { "cubic",     OPTION_VAL_CUBIC_EO },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_EO,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_EO,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_EO },
         { "5%",  OPTION_VAL_5_EO },
         { "10%", OPTION_VAL_10_EO },
         { "15%", OPTION_VAL_15_EO },
         { "20%", OPTION_VAL_20_EO },
         { "25%", OPTION_VAL_25_EO },
         { "30%", OPTION_VAL_30_EO },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_EO,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_EO,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_EO },
         { "mednafen", OPTION_VAL_MEDNAFEN_EO },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_EO,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_EO,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_EO,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_EO,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_EO,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_EO,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_EO,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_EO,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_EO },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_EO,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_EO,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_EO },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_EO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_EO,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_EO,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_EO },
         { "1px", OPTION_VAL_1PX_EO },
         { "2px", OPTION_VAL_2PX_EO },
         { "3px", OPTION_VAL_3PX_EO },
         { "4px", OPTION_VAL_4PX_EO },
         { "5px", OPTION_VAL_5PX_EO },
         { "6px", OPTION_VAL_6PX_EO },
         { "7px", OPTION_VAL_7PX_EO },
         { "8px", OPTION_VAL_8PX_EO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_EO,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_EO,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_EO,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_EO,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_EO,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_EO,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_EO,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_EO,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_EO },
         { "aggressive", OPTION_VAL_AGGRESSIVE_EO },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_EO,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_EO,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_EO,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_EO,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_EO },
         { "16:10", OPTION_VAL_16_10_EO },
         { "18:9",  OPTION_VAL_18_9_EO },
         { "19:9",  OPTION_VAL_19_9_EO },
         { "20:9",  OPTION_VAL_20_9_EO },
         { "21:9",  OPTION_VAL_21_9_EO }, // 64:27
         { "32:9",  OPTION_VAL_32_9_EO },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_EO,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_EO,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_EO },
         { "60%",           OPTION_VAL_60_EO },
         { "70%",           OPTION_VAL_70_EO },
         { "80%",           OPTION_VAL_80_EO },
         { "90%",           OPTION_VAL_90_EO },
         { "100%(native)", OPTION_VAL_100_NATIVE_EO },
         { "110%",          OPTION_VAL_110_EO },
         { "120%",          OPTION_VAL_120_EO },
         { "130%",          OPTION_VAL_130_EO },
         { "140%",          OPTION_VAL_140_EO },
         { "150%",          OPTION_VAL_150_EO },
         { "160%",          OPTION_VAL_160_EO },
         { "170%",          OPTION_VAL_170_EO },
         { "180%",          OPTION_VAL_180_EO },
         { "190%",          OPTION_VAL_190_EO },
         { "200%",          OPTION_VAL_200_EO },
         { "210%",          OPTION_VAL_210_EO },
         { "220%",          OPTION_VAL_220_EO },
         { "230%",          OPTION_VAL_230_EO },
         { "240%",          OPTION_VAL_240_EO },
         { "250%",          OPTION_VAL_250_EO },
         { "260%",          OPTION_VAL_260_EO },
         { "270%",          OPTION_VAL_270_EO },
         { "280%",          OPTION_VAL_280_EO },
         { "290%",          OPTION_VAL_290_EO },
         { "300%",          OPTION_VAL_300_EO },
         { "310%",          OPTION_VAL_310_EO },
         { "320%",          OPTION_VAL_320_EO },
         { "330%",          OPTION_VAL_330_EO },
         { "340%",          OPTION_VAL_340_EO },
         { "350%",          OPTION_VAL_350_EO },
         { "360%",          OPTION_VAL_360_EO },
         { "370%",          OPTION_VAL_370_EO },
         { "380%",          OPTION_VAL_380_EO },
         { "390%",          OPTION_VAL_390_EO },
         { "400%",          OPTION_VAL_400_EO },
         { "410%",          OPTION_VAL_410_EO },
         { "420%",          OPTION_VAL_420_EO },
         { "430%",          OPTION_VAL_430_EO },
         { "440%",          OPTION_VAL_440_EO },
         { "450%",          OPTION_VAL_450_EO },
         { "460%",          OPTION_VAL_460_EO },
         { "470%",          OPTION_VAL_470_EO },
         { "480%",          OPTION_VAL_480_EO },
         { "490%",          OPTION_VAL_490_EO },
         { "500%",          OPTION_VAL_500_EO },
         { "510%",          OPTION_VAL_510_EO },
         { "520%",          OPTION_VAL_520_EO },
         { "530%",          OPTION_VAL_530_EO },
         { "540%",          OPTION_VAL_540_EO },
         { "550%",          OPTION_VAL_550_EO },
         { "560%",          OPTION_VAL_560_EO },
         { "570%",          OPTION_VAL_570_EO },
         { "580%",          OPTION_VAL_580_EO },
         { "590%",          OPTION_VAL_590_EO },
         { "600%",          OPTION_VAL_600_EO },
         { "610%",          OPTION_VAL_610_EO },
         { "620%",          OPTION_VAL_620_EO },
         { "630%",          OPTION_VAL_630_EO },
         { "640%",          OPTION_VAL_640_EO },
         { "650%",          OPTION_VAL_650_EO },
         { "660%",          OPTION_VAL_660_EO },
         { "670%",          OPTION_VAL_670_EO },
         { "680%",          OPTION_VAL_680_EO },
         { "690%",          OPTION_VAL_690_EO },
         { "700%",          OPTION_VAL_700_EO },
         { "710%",          OPTION_VAL_710_EO },
         { "720%",          OPTION_VAL_720_EO },
         { "730%",          OPTION_VAL_730_EO },
         { "740%",          OPTION_VAL_740_EO },
         { "750%",          OPTION_VAL_750_EO },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_EO,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_EO,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_EO,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_EO,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_EO,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_EO,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_EO },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_EO },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_EO,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_EO,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_EO },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_EO },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_EO },
#endif
         { "software",    OPTION_VAL_SOFTWARE_EO },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_EO,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_EO,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_EO,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_EO,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_EO },
         { "execute",  OPTION_VAL_EXECUTE_EO },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_EO },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_EO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_EO,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_EO,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_EO },
         { "dma",  OPTION_VAL_DMA_EO },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_EO,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_EO,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_EO,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_EO,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_EO },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_EO },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_EO },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_EO,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_EO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_EO,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_EO,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_EO },
         { "static",  OPTION_VAL_STATIC_EO },
         { "smart", OPTION_VAL_SMART_EO },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_EO,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_EO,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_EO },
         { "2px",      OPTION_VAL_2PX_EO },
         { "3px",      OPTION_VAL_3PX_EO },
         { "4px",      OPTION_VAL_4PX_EO },
         { "5px",      OPTION_VAL_5PX_EO },
         { "6px",      OPTION_VAL_6PX_EO },
         { "7px",      OPTION_VAL_7PX_EO },
         { "8px",      OPTION_VAL_8PX_EO },
         { "9px",      OPTION_VAL_9PX_EO },
         { "10px",     OPTION_VAL_10PX_EO },
         { "11px",     OPTION_VAL_11PX_EO },
         { "12px",     OPTION_VAL_12PX_EO },
         { "13px",     OPTION_VAL_13PX_EO },
         { "14px",     OPTION_VAL_14PX_EO },
         { "15px",     OPTION_VAL_15PX_EO },
         { "16px",     OPTION_VAL_16PX_EO },
         { "17px",     OPTION_VAL_17PX_EO },
         { "18px",     OPTION_VAL_18PX_EO },
         { "19px",     OPTION_VAL_19PX_EO },
         { "20px",     OPTION_VAL_20PX_EO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_EO,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_EO,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_EO },
         { "-11px",    OPTION_VAL_11PX_O55_EO },
         { "-10px",    OPTION_VAL_10PX_O55_EO },
         { "-9px",     OPTION_VAL_9PX_O55_EO },
         { "-8px",     OPTION_VAL_8PX_O55_EO },
         { "-7px",     OPTION_VAL_7PX_O55_EO },
         { "-6px",     OPTION_VAL_6PX_O55_EO },
         { "-5px",     OPTION_VAL_5PX_O55_EO },
         { "-4px",     OPTION_VAL_4PX_O55_EO },
         { "-3px",     OPTION_VAL_3PX_O55_EO },
         { "-2px",     OPTION_VAL_2PX_O55_EO },
         { "-1px",     OPTION_VAL_1PX_O55_EO },
         { "disabled", OPTION_VAL_DISABLED_O55_EO },
         { "+1px",     OPTION_VAL_1PX_O55_0_EO },
         { "+2px",     OPTION_VAL_2PX_O55_0_EO },
         { "+3px",     OPTION_VAL_3PX_O55_0_EO },
         { "+4px",     OPTION_VAL_4PX_O55_0_EO },
         { "+5px",     OPTION_VAL_5PX_O55_0_EO },
         { "+6px",     OPTION_VAL_6PX_O55_0_EO },
         { "+7px",     OPTION_VAL_7PX_O55_0_EO },
         { "+8px",     OPTION_VAL_8PX_O55_0_EO },
         { "+9px",     OPTION_VAL_9PX_O55_0_EO },
         { "+10px",    OPTION_VAL_10PX_O55_0_EO },
         { "+11px",    OPTION_VAL_11PX_O55_0_EO },
         { "+12px",    OPTION_VAL_12PX_O55_0_EO },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_EO,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_EO,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_EO },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_EO,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_EO,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_EO },
         { "2x",         OPTION_VAL_2X_EO },
         { "4x",         OPTION_VAL_4X_EO },
         { "8x",         OPTION_VAL_8X_EO },
         { "16x",        OPTION_VAL_16X_EO },
         { "32x",        OPTION_VAL_32X_EO },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_EO,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_EO,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_EO },
         { "uncorrected", OPTION_VAL_UNCORRECTED_EO },
         { "4:3",  OPTION_VAL_4_3_EO },
         { "ntsc", OPTION_VAL_NTSC_EO },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_EO,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_EO,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_EO,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_EO,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_EO },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_EO,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_EO,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_EO,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_EO,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_EO },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_EO,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_EO,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_EO },
         { "async",    OPTION_VAL_ASYNC_EO },
         { "precache", OPTION_VAL_PRECACHE_EO },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_EO,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_EO,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_EO },
         { "4x",          OPTION_VAL_4X_EO },
         { "6x",          OPTION_VAL_6X_EO },
         { "8x",          OPTION_VAL_8X_EO },
         { "10x",         OPTION_VAL_10X_EO },
         { "12x",         OPTION_VAL_12X_EO },
         { "14x",         OPTION_VAL_14X_EO },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_eo = {
   option_cats_eo,
   option_defs_eo
};

/* RETRO_LANGUAGE_ES */

#define CATEGORY_VIDEO_LABEL_ES "Vídeo"
#define CATEGORY_VIDEO_INFO_0_ES "Cambia las opciones de relación de aspecto, recorte de imagen, filtros de vídeo y omisión de fotogramas."
#define CATEGORY_OSD_LABEL_ES "Notificaciones en pantalla"
#define CATEGORY_OSD_INFO_0_ES "Cambia las notificaciones que se mostrarán en pantalla."
#define CATEGORY_INPUT_LABEL_ES "Entrada"
#define CATEGORY_INPUT_INFO_0_ES "Cambia los ajustes de las pistolas de luz, el ratón y el neGcon."
#define CATEGORY_MEMCARDS_LABEL_ES "Memory Cards"
#define CATEGORY_MEMCARDS_INFO_0_ES "Cambia la configuración de las Memory Card virtuales que utilizará el sistema."
#define CATEGORY_PGXP_LABEL_ES "PGXP (Proceso de transformación precisa de geometría)"
#define CATEGORY_PGXP_INFO_0_ES "Estas opciones permiten mejorar los gráficos por encima de lo que puede mostrar la consola real, eliminando las distorsiones de texturas y el «Z-fighting» (distorsión entre polígonos)."
#define CATEGORY_HACKS_LABEL_ES "Arreglos de emulación"
#define CATEGORY_HACKS_INFO_0_ES "Cambia las opciones de velocidad del procesador y de precisión de la emulación que afectan al rendimiento a bajo nivel y a la compatibilidad."
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_ES "Resolución interna de la GPU"
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_ES "Selecciona el multiplicador de la resolución interna. Toda resolución superior a «1x (Nativa)» mejorará la fidelidad de los modelos 3D a costa de aumentar los requisitos de rendimiento. Los elementos 2D no suelen verse afectados."
#define OPTION_VAL_1X_NATIVE_ES "1x (nativa)"
#define OPTION_VAL_2X_ES NULL
#define OPTION_VAL_4X_ES NULL
#define OPTION_VAL_8X_ES NULL
#define OPTION_VAL_16X_ES NULL
#define BEETLE_OPT_DEPTH_LABEL_ES "Profundidad interna de colores"
#define BEETLE_OPT_DEPTH_INFO_0_ES "Selecciona la profundidad interna de colores. Una mayor profundidad puede reducir el efecto de bandas de color sin tener que recurrir al efecto de tramado. 16 bpp simula el hardware original, pero puede generar bandas de color si la opción de tramado no está activada. Se recomienda desactivar la opción «Tramado» al seleccionar 32 bpp en esta opción."
#define OPTION_VAL_16BPP_NATIVE_ES "16 bpp (nativa)"
#define OPTION_VAL_32BPP_ES NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_ES "Tramado"
#define BEETLE_OPT_DITHER_MODE_INFO_0_ES "Selecciona la configuración del tramado. «1x (Nativo)» simula el tramado nativo a baja resolución que utilizaba el hardware original para suavizar los defectos de bandas de color visibles en la profundidad de colores nativa. «Resolución interna» cambia la escala del tramado a la resolución interna configurada para producir un resultado más limpio. Se recomienda desactivar esta opción al utilizar una profundidad de colores de 32 bpp. Nota: Activar esta opción en Vulkan desactivará la reducción de colores a la profundidad nativa y activará una profundidad interna superior."
#define OPTION_VAL_INTERNAL_RESOLUTION_ES "Resolución interna"
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_ES "Compensación de UV de texturas"
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_ES "Muestrea las texturas de los polígonos 3D con una compensación para resoluciones superiores a la nativa. Reduce los salientes en las texturas, pero puede producir fallos gráficos accidentales."
#define BEETLE_OPT_FILTER_LABEL_ES "Filtrado de texturas"
#define BEETLE_OPT_FILTER_INFO_0_ES "Selecciona el método de filtrado de texturas. «Más cercano» simula el hardware original. «Bilineal» y «De tres puntos» son filtros de suavizado que reducen la pixelación difuminando la imagen. «SABR», «xBR» y «JINC2» son filtros de escalado que podrían mejorar la fidelidad/definición de las texturas a costa de aumentar los requisitos de rendimiento. Solo funciona con los renderizadores por hardware."
#define OPTION_VAL_NEAREST_ES "Más cercano"
#define OPTION_VAL_SABR_ES NULL
#define OPTION_VAL_XBR_ES NULL
#define OPTION_VAL_BILINEAR_ES "Bilineal"
#define OPTION_VAL_3_POINT_ES "De tres puntos"
#define OPTION_VAL_JINC2_ES NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_ES "No filtrar sprites"
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_ES "No aplicará el filtrado de texturas a los sprites. Evita los bordes en varios juegos con fondos renderizados en 2D. Se recomienda activar también la opción de Suavizado adaptativo u otro efecto de posprocesado para conseguir el mejor efecto."
#define OPTION_VAL_OPAQUE_ES "Solo sprites opacos"
#define OPTION_VAL_ALL_ES "Sprites opacos y semitransparentes"
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_ES "No filtrar polígonos 2D"
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_ES "No aplicará el filtrado de texturas a los polígonos en 2D. Estos son detectados mediante un proceso heurístico, por lo que puede haber fallos visuales. Se recomienda activar también la opción «Suavizado adaptativo» u otro efecto de posprocesado para conseguir el mejor efecto."
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_ES "Suavizado adaptativo"
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_ES "Suaviza los gráficos y elementos de interfaz en 2D sin difuminar los objetos renderizados en 3D. Solo funciona con el renderizador Vulkan."
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_ES "Supermuestreo (reducción a resolución nativa)"
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_ES "Reduce el contenido renderizado de una resolución interna superior a la nativa. Al combinar este efecto con multiplicadores para aumentar la resolución interna, los juegos pueden mostrarse con objetos 3D con bordes suavizados en la resolución nativa. Genera los mejores resultados en aquellos títulos que combinan elementos 2D y 3D (p. ej.: personajes 3D sobre fondos prerenderizados) y acompañado de shaders de simulación de CRT. Solo funciona con el renderizador Vulkan. Nota: Se recomienda desactivar el tramado al utilizar esta opción."
#define BEETLE_OPT_MSAA_LABEL_ES "Suavizado de bordes MSAA"
#define BEETLE_OPT_MSAA_INFO_0_ES "Ajusta el MSAA que se aplicará al contenido renderizado. Mejora el aspecto de los objetos 3D. Solo funciona con el renderizador Vulkan."
#define OPTION_VAL_1X_ES NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_ES "Filtro cromático YUV para MDEC"
#define BEETLE_OPT_MDEC_YUV_INFO_0_ES "Mejora la calidad de la reproducción de secuencias FMV reduciendo los artefactos de los «macrobloques» (cuadrados y bordes de sierra). Solo funciona con el renderizador Vulkan."
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_ES "Rastreo de texturas"
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_ES "Necesario para el volcado y sustitución de texturas. Probablemente provocará que la mayoría de juegos se queden colgados."
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_ES "Volcar texturas"
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_ES "Vuelca las texturas que se utilicen a <cd>-texture-dump/"
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_ES "Sustituir texturas"
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_ES "Sustituye las texturas con las versiones en alta definición que se encuentren en <cd>-texture-replacements/"
#define BEETLE_OPT_WIREFRAME_LABEL_ES "Modo de mallas (depuración)"
#define BEETLE_OPT_WIREFRAME_INFO_0_ES "Renderiza solo las mallas de los objetos 3D, sin mostrar sus texturas o sombreado. Solo funciona con el renderizador por hardware de OpenGL. Nota: Esta opción solo se utiliza para depuración y debería mantenerse desactivada por norma general."
#define BEETLE_OPT_FRAME_DUPING_LABEL_ES "Duplicado de fotogramas (mayor velocidad)"
#define BEETLE_OPT_FRAME_DUPING_INFO_0_ES "Al activar esta opción (y si es compatible con el front-end de libretro), aumenta levemente el rendimiento al indicar al front-end que repita el fotograma anterior si el núcleo no muestra nada nuevo."
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_ES "Mostrar FPS internos"
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_ES "Muestra la velocidad de fotogramas interna con la que el sistema PlayStation emulado renderiza el contenido. Nota: Es necesario activar las notificaciones en pantalla en el front-end libretro."
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_ES "Mostrar la VRAM completa (depuración)"
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_ES "Visualiza toda la VRAM emulada. Solo funciona con los renderizadores por hardware de OpenGL y Vulkan. Nota: Esta opción solo se utiliza para depuración y debería mantenerse desactivada por norma general."
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_ES "Autocalibrar controles analógicos"
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_ES "Cuando el dispositivo de entrada esté configurado como DualShock, mando analógico, joystick analógico o neGcon, esta opción permitirá calibrar de forma dinámica las entradas analógicas. Se controlarán en tiempo real los valores de entrada máximos registrados para escalar las coordenadas analógicas que se transmitan al emulador. Esto sirve para juegos como Mega Man Legends 2, que esperan unos valores superiores a los que pueden transmitir los mandos modernos. Se recomienda que los sticks analógicos sean girados en toda su extensión nada más cargar un contenido para que el algoritmo de calibración funcione lo mejor posible."
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_ES "Conmutador de modo analógico del DualShock"
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_ES "Cuando el tipo de dispositivo de entrada sea DualShock, esta opción permite que el DualShock emulado pueda alternar entre los modos digital y analógico, como hace el hardware original. Al desactivar esta opción el DualShock quedará fijado en el modo analógico y al activarla el DualShock podrá cambiar entre los modos digital y analógico manteniendo pulsada la combinación START+SELECT+L1+L2+R1+R2."
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_ES "Puerto 1: activar Multitap"
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_ES "Activa el sistema de Multitap en el puerto 1."
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_ES "Puerto 2: activar Multitap"
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_ES "Activa el sistema de Multitap en el puerto 2."
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_ES "Modo de entrada de pistolas de luz"
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_ES "Selecciona si se debe usar una entrada de ratón o de pantalla táctil cuando el tipo de dispositivo esté configurado como «Guncon/G-Con 45» o «Justifier»."
#define OPTION_VAL_LIGHTGUN_ES "Pistola de luz"
#define OPTION_VAL_TOUCHSCREEN_ES "Pantalla táctil"
#define BEETLE_OPT_GUN_CURSOR_LABEL_ES "Cursor del arma"
#define BEETLE_OPT_GUN_CURSOR_INFO_0_ES "Selecciona el cursor que aparecerá en pantalla al usar los tipos de dispositivo de entrada «Guncon/G-Con 45» o «Justifier». Al desactivar esta opción se ocultará el punto de mira."
#define OPTION_VAL_CROSS_ES "Cruz"
#define OPTION_VAL_DOT_ES "Punto"
#define OPTION_VAL_OFF_ES "Sin cursor"
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_ES "Puerto 1: color de la mira de la pistola"
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_ES "Selecciona el color del punto de mira de la pistola de luz conectada en el puerto 1."
#define OPTION_VAL_RED_ES "Rojo"
#define OPTION_VAL_BLUE_ES "Azul"
#define OPTION_VAL_GREEN_ES "Verde"
#define OPTION_VAL_ORANGE_ES "Naranja"
#define OPTION_VAL_YELLOW_ES "Amarillo"
#define OPTION_VAL_CYAN_ES "Cian"
#define OPTION_VAL_PINK_ES "Rosa"
#define OPTION_VAL_PURPLE_ES "Violeta"
#define OPTION_VAL_BLACK_ES "Negro"
#define OPTION_VAL_WHITE_ES "Blanco"
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_ES "Puerto 2: color de la mira de la pistola"
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_ES "Selecciona el color del punto de mira de la pistola de luz conectada en el puerto 2."
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_ES "Sensibilidad del ratón"
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_ES "Ajusta la respuesta del dispositivo de entrada «Mouse (ratón)»."
#define OPTION_VAL_5_ES "5 %"
#define OPTION_VAL_10_ES "10 %"
#define OPTION_VAL_15_ES "15 %"
#define OPTION_VAL_20_ES "20 %"
#define OPTION_VAL_25_ES "25 %"
#define OPTION_VAL_30_ES "30 %"
#define OPTION_VAL_35_ES "35 %"
#define OPTION_VAL_40_ES "40 %"
#define OPTION_VAL_45_ES "45 %"
#define OPTION_VAL_50_ES "50 %"
#define OPTION_VAL_55_ES "55 %"
#define OPTION_VAL_60_ES "60 %"
#define OPTION_VAL_65_ES "65 %"
#define OPTION_VAL_70_ES "70 %"
#define OPTION_VAL_75_ES "75 %"
#define OPTION_VAL_80_ES "80 %"
#define OPTION_VAL_85_ES "85 %"
#define OPTION_VAL_90_ES "90 %"
#define OPTION_VAL_95_ES "95 %"
#define OPTION_VAL_100_ES "100 % (por defecto)"
#define OPTION_VAL_105_ES "105 %"
#define OPTION_VAL_110_ES "110 %"
#define OPTION_VAL_115_ES "115 %"
#define OPTION_VAL_120_ES "120 %"
#define OPTION_VAL_125_ES "125 %"
#define OPTION_VAL_130_ES "130 %"
#define OPTION_VAL_135_ES "135 %"
#define OPTION_VAL_140_ES "140 %"
#define OPTION_VAL_145_ES "145 %"
#define OPTION_VAL_150_ES "150 %"
#define OPTION_VAL_155_ES "155 %"
#define OPTION_VAL_160_ES "160 %"
#define OPTION_VAL_165_ES "165 %"
#define OPTION_VAL_170_ES "170 %"
#define OPTION_VAL_175_ES "175 %"
#define OPTION_VAL_180_ES "180 %"
#define OPTION_VAL_185_ES "185 %"
#define OPTION_VAL_190_ES "190 %"
#define OPTION_VAL_195_ES "195 %"
#define OPTION_VAL_200_ES "200 %"
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_ES "Respuesta al torcer el neGcon"
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_ES "Selecciona el tipo de respuesta del stick analógico izquierdo del RetroPad al simular la acción de torcer un dispositivo de entrada neGcon emulado. El desplazamiento del stick analógico puede ser asignado a la rotación del neGcon de forma lineal, cuadrática o cúbica. «Cuadrática» da una mayor precisión que «Lineal» en movimientos más sutiles. «Cúbica» aumenta más la precisión de los movimientos más sutiles, pero exagera los más largos. Nota: solo se recomienda usar «Lineal» con periféricos tipo volante de carreras. Los mandos convencionales gestionan la entrada analógica de una forma muy distinta al mecanismo de rotación del neGcon de tal forma que la asignación lineal sobreamplifica los movimientos sutiles, lo que afecta al control preciso. En la mayoría de casos, la opción «Cuadrática» produce la mejor aproximación posible al hardware real."
#define OPTION_VAL_LINEAR_ES "Lineal"
#define OPTION_VAL_QUADRATIC_ES "Cuadrática"
#define OPTION_VAL_CUBIC_ES "Cúbica"
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_ES "Zona muerta al torcer el neGcon"
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_ES "Ajusta la zona muerta del stick analógico izquierdo del RetroPad al simular la acción de torcer un dispositivo de entrada neGcon emulado. Sirve para evitar que el mando registre movimientos no realizados. Nota: la mayoría de juegos compatibles con neGcon incluyen opciones dentro del juego para ajustar un valor de zona muerta al torcerlo. Este valor debe configurarse como cero o neutral en todo momento para que no haya una pérdida de precisión. Cualquier ajuste que sea necesario solo debe aplicarse mediante esta opción del núcleo, sobre todo si «Respuesta al torcer el neGcon» está configurada como «Cuadrática» o «Cúbica»."
#define OPTION_VAL_0_ES "0 %"
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_ES "Método de la Memory Card 0 (es necesario reiniciar)"
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_ES "Selecciona el formato de datos guardados que se utilizará en la Memory Card 0. «Mednafen» puede mejorar la compatibilidad con la versión independiente de Mednafen. Al utilizar los archivos guardados con Beetle PSX, los archivos de libretro (.srm) y Mednafen (.mcr) son idénticos internamente, así que pueden intercambiarse entre sí modificando sus nombres."
#define OPTION_VAL_LIBRETRO_ES NULL
#define OPTION_VAL_MEDNAFEN_ES NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_ES "Activar Memory Card 1 (es necesario reiniciar)"
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_ES "Emula una segunda Memory Card en la ranura 1. Al desactivar esta opción, los juegos solo podrán acceder a la Memory Card de la ranura 0. Nota: algunos juegos necesitan que esta opción esté desactivada para funcionar correctamente (p. ej.: Codename Tenka). Nota: la Memory Card 1 utiliza el formato de guardado Mednafen (.mcr)."
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_ES "Memory Card compartidas (es necesario reiniciar)"
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_ES "Al activar esta opción, todos los juegos utilizarán los mismos archivos de Memory Card para guardar y cargar partidas. Al desactivarla se utilizarán archivos de Memory Card independientes por cada elemento del contenido cargado. Nota: si la opción «Método de la Memory Card 0» está configurada como «Libretro», esta opción solo afectará a la Memory Card de la ranura 1."
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_ES "Índice de la Memory Card izquierda"
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_ES "Cambia la Memory Card que está cargada en la ranura izquierda. Esta opción solo funcionará si la opción «Método de la Memory Card 0» está configurada como «Mednafen». La Memory Card predeterminada es el índice 0."
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_ES "Índice de la Memory Card derecha"
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_ES "Cambia la Memory Card que está cargada en la ranura derecha. Esta opción solo funcionará si la opción «Activar Memory Card 1» está activada. La Memory Card predeterminada es el índice 1."
#define OPTION_VAL_1_ES "1 (por defecto)"
#define BEETLE_OPT_PGXP_MODE_LABEL_ES "Modo de operación del PGXP"
#define BEETLE_OPT_PGXP_MODE_INFO_0_ES "Renderiza los objetos 3D con una precisión subpíxel, utilizando coordenadas de vértices de coma fija para minimizar la distorsión y temblores en objetos 3D que tenía el hardware original. «Solo en memoria» apenas da problemas de compatibilidad y se recomienda su uso general. «Memoria + CPU (inestable)» puede reducir aún más los temblores, pero tiene unos requisitos de rendimiento elevados y puede provocar fallos en la geometría."
#define OPTION_VAL_MEMORY_ONLY_ES "Solo en memoria"
#define OPTION_VAL_MEMORY_CPU_ES "Memoria + CPU (inestable)"
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_ES "Tolerancia a la geometría 2D del PGXP"
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_ES "Oculta los errores más evidentes de las operaciones del PGXP: este valor especifica la tolerancia con la que se conservarán los valores del PGXP en aquellas geometrías que no dispongan de la información de profundidad necesaria."
#define OPTION_VAL_0PX_ES "0 px"
#define OPTION_VAL_1PX_ES "1 px"
#define OPTION_VAL_2PX_ES "2 px"
#define OPTION_VAL_3PX_ES "3 px"
#define OPTION_VAL_4PX_ES "4 px"
#define OPTION_VAL_5PX_ES "5 px"
#define OPTION_VAL_6PX_ES "6 px"
#define OPTION_VAL_7PX_ES "7 px"
#define OPTION_VAL_8PX_ES "8 px"
#define BEETLE_OPT_PGXP_NCLIP_LABEL_ES "Selección de primitivos del PGXP"
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_ES "Utiliza la implementación de NCLIP del PGXP. Mejora el aspecto visual tapando los agujeros de aquellas geometrías que tengan coordenadas PGXP. Provoca cuelgues en ciertos juegos y circunstancias."
#define BEETLE_OPT_PGXP_VERTEX_LABEL_ES "Caché de vértices del PGXP"
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_ES "Cachea las posiciones de vértices mejoradas por el PGXP sean cacheadas para reutilizarlas al dibujar polígonos. Puede mejorar la alineación de los objetos y reducir los bordes, pero los falsos positivos a la hora de recurrir a la caché pueden producir defectos visuales. Actualmente se recomienda desactivar esta opción. Solo se aplicará cuando se active el modo de operación del PGXP. Solo funciona con los renderizadores por hardware."
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_ES "Texturizado fiel a la perspectiva del PGXP"
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_ES "Sustituye el mapeado de texturas afín nativo de PSX con un mapeado de texturas fiel a la perspectiva. Elimina las distorsiones posicionales y la deformación de texturas, produciendo texturas correctamente alineadas. Solo se aplicará cuando se active el modo de operación del PGXP. Solo funciona con los renderizadores por hardware."
#define BEETLE_OPT_LINE_RENDER_LABEL_ES "Arreglo para el efecto «Line-to-Quad»"
#define BEETLE_OPT_LINE_RENDER_INFO_0_ES "Selecciona el método de ejecución del hack para convertir líneas a rectángulos. Ciertos juegos (Doom, Hexen, Soul Blade, etcétera) dibujan líneas horizontales estirando triángulos de un píxel de altura a lo largo de la pantalla, que luego son rasterizados como una hilera de píxeles en el hardware original. Este hack detecta esos triángulos y los convierte en rectángulos según sea necesario, permitiendo que se muestren correctamente en los renderizadores por hardware y en resoluciones internas superiores a la nativa. La opción «Agresivo» es necesaria en ciertos títulos (p. ej.: Dark Forces, Duke Nukem) pero puede producir defectos visuales en otros. En caso de duda, seleccionar «Predeterminado»."
#define OPTION_VAL_DEFAULT_ES "Predeterminado"
#define OPTION_VAL_AGGRESSIVE_ES "Agresivo"
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_ES "Modificación para pantallas panorámicas"
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_ES "Renderiza los contenidos 3D en formato anamórfico y hace que el framebuffer emulado tenga una relación de aspecto panorámica. Produce los mejores resultados con juegos hechos completamente en 3D. Los elementos 2D se estirarán horizontalmente y podrían dejar de estar alineados."
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_ES "Relación de aspecto de la modificación para pantallas panorámicas"
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_ES "Selecciona la relación de aspecto usada por la modificación para pantallas panorámicas."
#define OPTION_VAL_16_9_ES NULL
#define OPTION_VAL_16_10_ES NULL
#define OPTION_VAL_18_9_ES NULL
#define OPTION_VAL_19_9_ES NULL
#define OPTION_VAL_20_9_ES NULL
#define OPTION_VAL_21_9_ES NULL
#define OPTION_VAL_32_9_ES NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_ES "Escalado de frecuencia de la CPU (velocidad)"
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_ES "Aumenta (o disminuye) la velocidad del reloj emulado de la CPU de PSX. Una velocidad superior puede eliminar las ralentizaciones y mejorar la velocidad de fotogramas en ciertos juegos a costa de aumentar los requisitos de rendimiento. Ten en cuenta que ciertos juegos incluyen un limitador de fotogramas interno y no ganarán beneficio alguno al aumentar la velocidad. Puede provocar que ciertos efectos vayan más rápido de lo normal en ciertos juegos."
#define OPTION_VAL_100_NATIVE_ES "100% (nativo)"
#define OPTION_VAL_210_ES "210 %"
#define OPTION_VAL_220_ES "220 %"
#define OPTION_VAL_230_ES "230 %"
#define OPTION_VAL_240_ES "240 %"
#define OPTION_VAL_250_ES "250 %"
#define OPTION_VAL_260_ES "260 %"
#define OPTION_VAL_270_ES "270 %"
#define OPTION_VAL_280_ES "280 %"
#define OPTION_VAL_290_ES "290 %"
#define OPTION_VAL_300_ES "300 %"
#define OPTION_VAL_310_ES "310 %"
#define OPTION_VAL_320_ES "320 %"
#define OPTION_VAL_330_ES "330 %"
#define OPTION_VAL_340_ES "340 %"
#define OPTION_VAL_350_ES "350 %"
#define OPTION_VAL_360_ES "360 %"
#define OPTION_VAL_370_ES "370 %"
#define OPTION_VAL_380_ES "380 %"
#define OPTION_VAL_390_ES "390 %"
#define OPTION_VAL_400_ES "400 %"
#define OPTION_VAL_410_ES "410 %"
#define OPTION_VAL_420_ES "420 %"
#define OPTION_VAL_430_ES "430 %"
#define OPTION_VAL_440_ES "440 %"
#define OPTION_VAL_450_ES "450 %"
#define OPTION_VAL_460_ES "460 %"
#define OPTION_VAL_470_ES "470 %"
#define OPTION_VAL_480_ES "480 %"
#define OPTION_VAL_490_ES "490 %"
#define OPTION_VAL_500_ES "500 %"
#define OPTION_VAL_510_ES "510 %"
#define OPTION_VAL_520_ES "520 %"
#define OPTION_VAL_530_ES "530 %"
#define OPTION_VAL_540_ES "540 %"
#define OPTION_VAL_550_ES "550 %"
#define OPTION_VAL_560_ES "560 %"
#define OPTION_VAL_570_ES "570 %"
#define OPTION_VAL_580_ES "580 %"
#define OPTION_VAL_590_ES "590 %"
#define OPTION_VAL_600_ES "600 %"
#define OPTION_VAL_610_ES "610 %"
#define OPTION_VAL_620_ES "620 %"
#define OPTION_VAL_630_ES "630 %"
#define OPTION_VAL_640_ES "640 %"
#define OPTION_VAL_650_ES "650 %"
#define OPTION_VAL_660_ES "660 %"
#define OPTION_VAL_670_ES "670 %"
#define OPTION_VAL_680_ES "680 %"
#define OPTION_VAL_690_ES "690 %"
#define OPTION_VAL_700_ES "700 %"
#define OPTION_VAL_710_ES "710 %"
#define OPTION_VAL_720_ES "720 %"
#define OPTION_VAL_730_ES "730 %"
#define OPTION_VAL_740_ES "740 %"
#define OPTION_VAL_750_ES "750 %"
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_ES "Acelerar el procesador GTE"
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_ES "Frena todas las operaciones emuladas del GTE (el coprocesador de la CPU para gráficos 3D) a una latencia constante de un ciclo. Aquellos juegos que utilicen en gran medida el GTE podrían mejorar su velocidad de fotogramas y la estabilidad en la duración de los mismos."
#define BEETLE_OPT_SKIP_BIOS_LABEL_ES "Omitir BIOS"
#define BEETLE_OPT_SKIP_BIOS_INFO_0_ES "Omite la animación de arranque de la BIOS de PlayStation que suele aparecer al cargar un contenido. Nota: Esta opción puede generar problemas de compatibilidad en varios juegos (juegos PAL con protección anticopia, Saga Frontier, etc.)."
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_ES "Omitir la BIOS (es necesario reiniciar)"
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_ES "Reemplaza la BIOS correspondiente a la región del contenido con una de región libre (si está disponible)."
#define OPTION_VAL_PSXONPSP_ES "BIOS de PS1 usada en PSP"
#define OPTION_VAL_PS1_ROM_ES "BIOS de PS1 usada en PS3"
#define BEETLE_OPT_RENDERER_LABEL_ES "Renderizador (es necesario reiniciar)"
#define BEETLE_OPT_RENDERER_INFO_0_ES "El renderizador por software es el más preciso, pero sus requisitos son muy elevados si se ejecuta a una resolución interna superior a la de la GPU. Los renderizadores por hardware son menos precisos, pero tienen un mejor rendimiento al usar resoluciones internas superiores y permiten varias mejoras gráficas. «Hardware (Automático)» seleccionará automáticamente el renderizador Vulkan u OpenGL según el controlador de vídeo actual del front-end de libretro. Si el controlador no es compatible con Vulkan o con OpenGL 3.3, se utilizará el renderizador por software como reserva del núcleo."
#define OPTION_VAL_HARDWARE_ES "Hardware (automático)"
#define OPTION_VAL_HARDWARE_GL_ES NULL
#define OPTION_VAL_HARDWARE_VK_ES NULL
#define OPTION_VAL_SOFTWARE_ES NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_ES "Framebuffer por software"
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_ES "Permite emular con precisión los efectos del framebuffer (p. ej.: desenfoque de movimiento, la espiral de batallas de FF7) al utilizar los renderizadores por hardware ejecutando una copia del renderizador por software a resolución nativa en un segundo plano. Al desactivar esta opción se omitirán estas operaciones (OpenGL) o se renderizarán en la GPU (Vulkan). Desactivar esta opción puede mejorar el rendimiento a costa de generar errores gráficos graves. En caso de duda, deja esta opción activada."
#define BEETLE_OPT_CPU_DYNAREC_LABEL_ES "Dynarec de CPU"
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_ES "Recompila de forma dinámica las instrucciones de la CPU a instrucciones nativas. Es más rápido que el intérprete, pero los intervalos de la CPU son menos precisos y puede provocar fallos."
#define OPTION_VAL_DISABLED_ES "Desactivada (intérprete Beetle)"
#define OPTION_VAL_EXECUTE_ES "Máximo rendimiento"
#define OPTION_VAL_EXECUTE_ONE_ES "Con control de los intervalos entre ciclos"
#define OPTION_VAL_RUN_INTERPRETER_ES "Intérprete lightrec"
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_ES "Invalidación de código del dynarec"
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_ES "Algunos juegos necesitan una invalidación completa y otros solo necesitan invalidar la DMA."
#define OPTION_VAL_FULL_ES "Completa"
#define OPTION_VAL_DMA_ES "Solo DMA (algo más rápida)"
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_ES "Ciclos de eventos de DMA/GPU del dynarec"
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_ES "Indica el número máximo de ciclos ejecutados por la CPU antes de comprobar la DMA o la GPU. Un valor superior será más rápido. Tiene menos repercusión en el intérprete Beetle que en el dynarec."
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_ES "Barrido de señal según núcleo"
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_ES "Ajusta el barrido de señal que indicará el núcleo al front-end. «Cambiar automáticamente» permite que el núcleo cambie entre los barridos progresivo y entrelazado, pero pueden provocar reinicios en los controladores de vídeo y audio del front-end."
#define OPTION_VAL_FORCE_PROGRESSIVE_ES "Tasa progresiva"
#define OPTION_VAL_FORCE_INTERLACED_ES "Forzar barrido entrelazado"
#define OPTION_VAL_AUTO_TOGGLE_ES "Cambiar automáticamente"
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_ES "Anular sincronía de vídeo PAL (europea)"
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_ES "Debido a la diferencia entre estándares, los juegos PAL suelen parecer más lentos que sus versiones NTSC, tanto estadounidenses como japonesas. Esta opción puede anular la velocidad de vídeo PAL para intentar ejecutar dichos juegos con la velocidad de fotogramas NTSC. Esta opción no produce efecto alguno en contenidos NTSC."
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_ES "Recortar sobrebarrido horizontal"
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_ES "«Ninguno» conserva los bordes (columnas negras a ambos lados en el caso de imágenes NTSC, bordes por los cuatro costados en imágenes PAL) para simular las barras negras que produce el hardware real de PSX en una señal de vídeo analógica. «Estático» se limita a eliminar los bordes horizontales, mientras que «Dinámico» elimina todos los bordes."
#define OPTION_VAL_DISABLED_O53_ES "Ninguno"
#define OPTION_VAL_STATIC_ES "Estático"
#define OPTION_VAL_SMART_ES "Dinámico (por defecto)"
#define BEETLE_OPT_IMAGE_CROP_LABEL_ES "Recorte adicional"
#define BEETLE_OPT_IMAGE_CROP_INFO_0_ES "Al activar la opción «Recortar sobrebarrido horizontal», esta opción permite reducir el ancho de la imagen recortada usando un valor concreto en píxeles. Solo funciona con el renderizador por software."
#define OPTION_VAL_9PX_ES "9 px"
#define OPTION_VAL_10PX_ES "10 px"
#define OPTION_VAL_11PX_ES "11 px"
#define OPTION_VAL_12PX_ES "12 px"
#define OPTION_VAL_13PX_ES "13 px"
#define OPTION_VAL_14PX_ES "14 px"
#define OPTION_VAL_15PX_ES "15 px"
#define OPTION_VAL_16PX_ES "16 px"
#define OPTION_VAL_17PX_ES "17 px"
#define OPTION_VAL_18PX_ES "18 px"
#define OPTION_VAL_19PX_ES "19 px"
#define OPTION_VAL_20PX_ES "20 px"
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_ES "Desplazar imagen recortada"
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_ES "Al activar la opción «Recortar sobrebarrido horizontal», esta opción permite desplazar horizontalmente la imagen recortada hacia la derecha (valores positivos) o hacia la izquierda (valores negativos) usando un valor concreto en píxeles. Utilizar para corregir problemas de alineación. Solo funciona con el renderizador por software."
#define OPTION_VAL_12PX_O55_ES "-12 px"
#define OPTION_VAL_11PX_O55_ES "-11 px"
#define OPTION_VAL_10PX_O55_ES "-10 px"
#define OPTION_VAL_9PX_O55_ES "-9 px"
#define OPTION_VAL_8PX_O55_ES "-8 px"
#define OPTION_VAL_7PX_O55_ES "-7 px"
#define OPTION_VAL_6PX_O55_ES "-6 px"
#define OPTION_VAL_5PX_O55_ES "-5 px"
#define OPTION_VAL_4PX_O55_ES "-4 px"
#define OPTION_VAL_3PX_O55_ES "-3 px"
#define OPTION_VAL_2PX_O55_ES "-2 px"
#define OPTION_VAL_1PX_O55_ES "-1 px"
#define OPTION_VAL_DISABLED_O55_ES "0 (por defecto)"
#define OPTION_VAL_1PX_O55_0_ES "+1 px"
#define OPTION_VAL_2PX_O55_0_ES "+2 px"
#define OPTION_VAL_3PX_O55_0_ES "+3 px"
#define OPTION_VAL_4PX_O55_0_ES "+4 px"
#define OPTION_VAL_5PX_O55_0_ES "+5 px"
#define OPTION_VAL_6PX_O55_0_ES "+6 px"
#define OPTION_VAL_7PX_O55_0_ES "+7 px"
#define OPTION_VAL_8PX_O55_0_ES "+8 px"
#define OPTION_VAL_9PX_O55_0_ES "+9 px"
#define OPTION_VAL_10PX_O55_0_ES "+10 px"
#define OPTION_VAL_11PX_O55_0_ES "+11 px"
#define OPTION_VAL_12PX_O55_0_ES "+12 px"
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_ES "Desplazar imagen horizontal (ciclos de GPU)"
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_ES "Especifica el número de ciclos de GPU con los que desplazar la imagen. Los valores positivos mueven la imagen hacia la derecha y los negativos hacia la izquierda. Solo funciona con los renderizadores por hardware."
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_ES "Acelerar el rasterizador de la GPU"
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_ES "Aumenta la velocidad del rasterizador 2D incluido en la GPU emulada de PSX. No mejora el renderizado 3D y su efecto suele ser limitado."
#define OPTION_VAL_32X_ES NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_ES "Relación de aspecto del núcleo"
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_ES "Selecciona la relación de aspecto del núcleo. Este ajuste será ignorado si se activan las opciones «Modificación para pantallas panorámicas» o «Mostrar la VRAM completa»."
#define OPTION_VAL_CORRECTED_ES "Corregida"
#define OPTION_VAL_UNCORRECTED_ES "Sin corregir"
#define OPTION_VAL_4_3_ES "Forzar 4:3"
#define OPTION_VAL_NTSC_ES "Forzar NTSC"
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_ES "Línea de barrido inicial en formato NTSC"
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_ES "Selecciona la primera línea de barrido que se mostrará al ejecutar contenidos NTSC. Un valor superior a cero reducirá la altura de las imágenes generadas recortando los píxeles de la parte superior. Puede servir para evitar el efecto «letterboxing»."
#define BEETLE_OPT_LAST_SCANLINE_LABEL_ES "Línea de barrido final en formato NTSC"
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_ES "Selecciona la última línea de barrido que se mostrará al ejecutar contenidos NTSC. Un valor inferior a 239 reducirá la altura de las imágenes generadas recortando los píxeles de la parte inferior. Puede servir para evitar el efecto «letterboxing»."
#define OPTION_VAL_239_ES "239 (por defecto)"
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_ES "Línea de barrido inicial en formato PAL"
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_ES "Selecciona la primera línea de barrido que se mostrará al ejecutar contenidos PAL. Un valor superior a cero reducirá la altura de las imágenes generadas recortando los píxeles de la parte superior. Puede servir para evitar el efecto «letterboxing»."
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_ES "Línea de barrido final en formato PAL"
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_ES "Selecciona la última línea de barrido que se mostrará al ejecutar contenidos PAL. Un valor inferior a 287 reducirá la altura de las imágenes generadas recortando los píxeles de la parte inferior. Puede servir para evitar el efecto «letterboxing»."
#define OPTION_VAL_287_ES "287 (por defecto)"
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_ES "Método de acceso al CD (es necesario reiniciar)"
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_ES "Selecciona el método utilizado para leer datos de las imágenes de disco del contenido. «Sincrónico» simula el hardware original, «Asincrónico» puede reducir los tirones en aquellos dispositivos que tengan un almacenamiento lento y «Precacheado» carga la imagen de disco entera en memoria al ejecutar el contenido, lo que puede mejorar los tiempos de carga del juego a costa de retrasar el arranque inicial. «Precacheado» puede producir problemas en sistemas con poca RAM."
#define OPTION_VAL_SYNC_ES "Sincrónico"
#define OPTION_VAL_ASYNC_ES "Asincrónico"
#define OPTION_VAL_PRECACHE_ES "Precacheado"
#define BEETLE_OPT_CD_FASTLOAD_LABEL_ES "Velocidad de lectura del CD"
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_ES "Selecciona el multiplicador de velocidad de acceso al disco. Un valor superior a «2x (nativa)» puede reducir en gran medida los tiempos de carga de los juegos, pero produciendo errores de sincronía. Algunos juegos podrían no funcionar correctamente si este valor es superior a cierta cifra."
#define OPTION_VAL_2X_NATIVE_ES "2x (nativa)"
#define OPTION_VAL_6X_ES NULL
#define OPTION_VAL_10X_ES NULL
#define OPTION_VAL_12X_ES NULL
#define OPTION_VAL_14X_ES NULL

struct retro_core_option_v2_category option_cats_es[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_ES,
      CATEGORY_VIDEO_INFO_0_ES
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_ES,
      CATEGORY_OSD_INFO_0_ES
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_ES,
      CATEGORY_INPUT_INFO_0_ES
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_ES,
      CATEGORY_MEMCARDS_INFO_0_ES
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_ES,
      CATEGORY_PGXP_INFO_0_ES
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_ES,
      CATEGORY_HACKS_INFO_0_ES
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_es[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_ES,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_ES,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_ES },
         { "2x",         OPTION_VAL_2X_ES },
         { "4x",         OPTION_VAL_4X_ES },
         { "8x",         OPTION_VAL_8X_ES },
         { "16x",        OPTION_VAL_16X_ES },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_ES,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_ES,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_ES },
         { "32bpp",         OPTION_VAL_32BPP_ES },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_ES,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_ES,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_ES },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_ES },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_ES,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_ES,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_ES,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_ES,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_ES },
         { "SABR",     OPTION_VAL_SABR_ES },
         { "xBR",      OPTION_VAL_XBR_ES },
         { "bilinear", OPTION_VAL_BILINEAR_ES },
         { "3-point",  OPTION_VAL_3_POINT_ES },
         { "JINC2",    OPTION_VAL_JINC2_ES },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_ES,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_ES,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_ES },
         { "all", OPTION_VAL_ALL_ES },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_ES,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_ES,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_ES },
         { "all", OPTION_VAL_ALL_ES },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_ES,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_ES,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_ES,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_ES,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_ES,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_ES,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_ES },
         { "2x",  OPTION_VAL_2X_ES },
         { "4x",  OPTION_VAL_4X_ES },
         { "8x",  OPTION_VAL_8X_ES },
         { "16x", OPTION_VAL_16X_ES },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_ES,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_ES,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_ES,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_ES,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_ES,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_ES,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_ES,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_ES,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_ES,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_ES,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_ES,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_ES,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_ES,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_ES,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_ES,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_ES,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_ES,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_ES,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_ES,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_ES,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_ES,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_ES,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_ES,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_ES,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_ES,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_ES,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_ES },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_ES },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_ES,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_ES,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_ES },
         { "dot",   OPTION_VAL_DOT_ES },
         { "off",   OPTION_VAL_OFF_ES },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_ES,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_ES,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_ES },
         { "blue", OPTION_VAL_BLUE_ES },
         { "green", OPTION_VAL_GREEN_ES },
         { "orange", OPTION_VAL_ORANGE_ES },
         { "yellow", OPTION_VAL_YELLOW_ES },
         { "cyan", OPTION_VAL_CYAN_ES },
         { "pink", OPTION_VAL_PINK_ES },
         { "purple", OPTION_VAL_PURPLE_ES },
         { "black", OPTION_VAL_BLACK_ES },
         { "white", OPTION_VAL_WHITE_ES },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_ES,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_ES,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_ES },
         { "red", OPTION_VAL_RED_ES },
         { "green", OPTION_VAL_GREEN_ES },
         { "orange", OPTION_VAL_ORANGE_ES },
         { "yellow", OPTION_VAL_YELLOW_ES },
         { "cyan", OPTION_VAL_CYAN_ES },
         { "pink", OPTION_VAL_PINK_ES },
         { "purple", OPTION_VAL_PURPLE_ES },
         { "black", OPTION_VAL_BLACK_ES },
         { "white", OPTION_VAL_WHITE_ES },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_ES,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_ES,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_ES },
         { "10%",  OPTION_VAL_10_ES },
         { "15%",  OPTION_VAL_15_ES },
         { "20%",  OPTION_VAL_20_ES },
         { "25%",  OPTION_VAL_25_ES },
         { "30%",  OPTION_VAL_30_ES },
         { "35%",  OPTION_VAL_35_ES },
         { "40%",  OPTION_VAL_40_ES },
         { "45%",  OPTION_VAL_45_ES },
         { "50%",  OPTION_VAL_50_ES },
         { "55%",  OPTION_VAL_55_ES },
         { "60%",  OPTION_VAL_60_ES },
         { "65%",  OPTION_VAL_65_ES },
         { "70%",  OPTION_VAL_70_ES },
         { "75%",  OPTION_VAL_75_ES },
         { "80%",  OPTION_VAL_80_ES },
         { "85%",  OPTION_VAL_85_ES },
         { "90%",  OPTION_VAL_90_ES },
         { "95%",  OPTION_VAL_95_ES },
         { "100%", OPTION_VAL_100_ES },
         { "105%", OPTION_VAL_105_ES },
         { "110%", OPTION_VAL_110_ES },
         { "115%", OPTION_VAL_115_ES },
         { "120%", OPTION_VAL_120_ES },
         { "125%", OPTION_VAL_125_ES },
         { "130%", OPTION_VAL_130_ES },
         { "135%", OPTION_VAL_135_ES },
         { "140%", OPTION_VAL_140_ES },
         { "145%", OPTION_VAL_145_ES },
         { "150%", OPTION_VAL_150_ES },
         { "155%", OPTION_VAL_155_ES },
         { "160%", OPTION_VAL_160_ES },
         { "165%", OPTION_VAL_165_ES },
         { "170%", OPTION_VAL_170_ES },
         { "175%", OPTION_VAL_175_ES },
         { "180%", OPTION_VAL_180_ES },
         { "185%", OPTION_VAL_185_ES },
         { "190%", OPTION_VAL_190_ES },
         { "195%", OPTION_VAL_195_ES },
         { "200%", OPTION_VAL_200_ES },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_ES,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_ES,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_ES },
         { "quadratic", OPTION_VAL_QUADRATIC_ES },
         { "cubic",     OPTION_VAL_CUBIC_ES },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_ES,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_ES,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_ES },
         { "5%",  OPTION_VAL_5_ES },
         { "10%", OPTION_VAL_10_ES },
         { "15%", OPTION_VAL_15_ES },
         { "20%", OPTION_VAL_20_ES },
         { "25%", OPTION_VAL_25_ES },
         { "30%", OPTION_VAL_30_ES },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_ES,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_ES,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_ES },
         { "mednafen", OPTION_VAL_MEDNAFEN_ES },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_ES,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_ES,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_ES,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_ES,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_ES,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_ES,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_ES,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_ES,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_ES },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_ES,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_ES,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_ES },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_ES },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_ES,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_ES,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_ES },
         { "1px", OPTION_VAL_1PX_ES },
         { "2px", OPTION_VAL_2PX_ES },
         { "3px", OPTION_VAL_3PX_ES },
         { "4px", OPTION_VAL_4PX_ES },
         { "5px", OPTION_VAL_5PX_ES },
         { "6px", OPTION_VAL_6PX_ES },
         { "7px", OPTION_VAL_7PX_ES },
         { "8px", OPTION_VAL_8PX_ES },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_ES,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_ES,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_ES,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_ES,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_ES,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_ES,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_ES,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_ES,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_ES },
         { "aggressive", OPTION_VAL_AGGRESSIVE_ES },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_ES,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_ES,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_ES,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_ES,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_ES },
         { "16:10", OPTION_VAL_16_10_ES },
         { "18:9",  OPTION_VAL_18_9_ES },
         { "19:9",  OPTION_VAL_19_9_ES },
         { "20:9",  OPTION_VAL_20_9_ES },
         { "21:9",  OPTION_VAL_21_9_ES }, // 64:27
         { "32:9",  OPTION_VAL_32_9_ES },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_ES,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_ES,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_ES },
         { "60%",           OPTION_VAL_60_ES },
         { "70%",           OPTION_VAL_70_ES },
         { "80%",           OPTION_VAL_80_ES },
         { "90%",           OPTION_VAL_90_ES },
         { "100%(native)", OPTION_VAL_100_NATIVE_ES },
         { "110%",          OPTION_VAL_110_ES },
         { "120%",          OPTION_VAL_120_ES },
         { "130%",          OPTION_VAL_130_ES },
         { "140%",          OPTION_VAL_140_ES },
         { "150%",          OPTION_VAL_150_ES },
         { "160%",          OPTION_VAL_160_ES },
         { "170%",          OPTION_VAL_170_ES },
         { "180%",          OPTION_VAL_180_ES },
         { "190%",          OPTION_VAL_190_ES },
         { "200%",          OPTION_VAL_200_ES },
         { "210%",          OPTION_VAL_210_ES },
         { "220%",          OPTION_VAL_220_ES },
         { "230%",          OPTION_VAL_230_ES },
         { "240%",          OPTION_VAL_240_ES },
         { "250%",          OPTION_VAL_250_ES },
         { "260%",          OPTION_VAL_260_ES },
         { "270%",          OPTION_VAL_270_ES },
         { "280%",          OPTION_VAL_280_ES },
         { "290%",          OPTION_VAL_290_ES },
         { "300%",          OPTION_VAL_300_ES },
         { "310%",          OPTION_VAL_310_ES },
         { "320%",          OPTION_VAL_320_ES },
         { "330%",          OPTION_VAL_330_ES },
         { "340%",          OPTION_VAL_340_ES },
         { "350%",          OPTION_VAL_350_ES },
         { "360%",          OPTION_VAL_360_ES },
         { "370%",          OPTION_VAL_370_ES },
         { "380%",          OPTION_VAL_380_ES },
         { "390%",          OPTION_VAL_390_ES },
         { "400%",          OPTION_VAL_400_ES },
         { "410%",          OPTION_VAL_410_ES },
         { "420%",          OPTION_VAL_420_ES },
         { "430%",          OPTION_VAL_430_ES },
         { "440%",          OPTION_VAL_440_ES },
         { "450%",          OPTION_VAL_450_ES },
         { "460%",          OPTION_VAL_460_ES },
         { "470%",          OPTION_VAL_470_ES },
         { "480%",          OPTION_VAL_480_ES },
         { "490%",          OPTION_VAL_490_ES },
         { "500%",          OPTION_VAL_500_ES },
         { "510%",          OPTION_VAL_510_ES },
         { "520%",          OPTION_VAL_520_ES },
         { "530%",          OPTION_VAL_530_ES },
         { "540%",          OPTION_VAL_540_ES },
         { "550%",          OPTION_VAL_550_ES },
         { "560%",          OPTION_VAL_560_ES },
         { "570%",          OPTION_VAL_570_ES },
         { "580%",          OPTION_VAL_580_ES },
         { "590%",          OPTION_VAL_590_ES },
         { "600%",          OPTION_VAL_600_ES },
         { "610%",          OPTION_VAL_610_ES },
         { "620%",          OPTION_VAL_620_ES },
         { "630%",          OPTION_VAL_630_ES },
         { "640%",          OPTION_VAL_640_ES },
         { "650%",          OPTION_VAL_650_ES },
         { "660%",          OPTION_VAL_660_ES },
         { "670%",          OPTION_VAL_670_ES },
         { "680%",          OPTION_VAL_680_ES },
         { "690%",          OPTION_VAL_690_ES },
         { "700%",          OPTION_VAL_700_ES },
         { "710%",          OPTION_VAL_710_ES },
         { "720%",          OPTION_VAL_720_ES },
         { "730%",          OPTION_VAL_730_ES },
         { "740%",          OPTION_VAL_740_ES },
         { "750%",          OPTION_VAL_750_ES },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_ES,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_ES,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_ES,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_ES,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_ES,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_ES,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_ES },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_ES },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_ES,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_ES,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_ES },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_ES },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_ES },
#endif
         { "software",    OPTION_VAL_SOFTWARE_ES },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_ES,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_ES,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_ES,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_ES,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_ES },
         { "execute",  OPTION_VAL_EXECUTE_ES },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_ES },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_ES },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_ES,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_ES,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_ES },
         { "dma",  OPTION_VAL_DMA_ES },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_ES,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_ES,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_ES,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_ES,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_ES },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_ES },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_ES },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_ES,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_ES,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_ES,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_ES,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_ES },
         { "static",  OPTION_VAL_STATIC_ES },
         { "smart", OPTION_VAL_SMART_ES },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_ES,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_ES,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_ES },
         { "2px",      OPTION_VAL_2PX_ES },
         { "3px",      OPTION_VAL_3PX_ES },
         { "4px",      OPTION_VAL_4PX_ES },
         { "5px",      OPTION_VAL_5PX_ES },
         { "6px",      OPTION_VAL_6PX_ES },
         { "7px",      OPTION_VAL_7PX_ES },
         { "8px",      OPTION_VAL_8PX_ES },
         { "9px",      OPTION_VAL_9PX_ES },
         { "10px",     OPTION_VAL_10PX_ES },
         { "11px",     OPTION_VAL_11PX_ES },
         { "12px",     OPTION_VAL_12PX_ES },
         { "13px",     OPTION_VAL_13PX_ES },
         { "14px",     OPTION_VAL_14PX_ES },
         { "15px",     OPTION_VAL_15PX_ES },
         { "16px",     OPTION_VAL_16PX_ES },
         { "17px",     OPTION_VAL_17PX_ES },
         { "18px",     OPTION_VAL_18PX_ES },
         { "19px",     OPTION_VAL_19PX_ES },
         { "20px",     OPTION_VAL_20PX_ES },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_ES,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_ES,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_ES },
         { "-11px",    OPTION_VAL_11PX_O55_ES },
         { "-10px",    OPTION_VAL_10PX_O55_ES },
         { "-9px",     OPTION_VAL_9PX_O55_ES },
         { "-8px",     OPTION_VAL_8PX_O55_ES },
         { "-7px",     OPTION_VAL_7PX_O55_ES },
         { "-6px",     OPTION_VAL_6PX_O55_ES },
         { "-5px",     OPTION_VAL_5PX_O55_ES },
         { "-4px",     OPTION_VAL_4PX_O55_ES },
         { "-3px",     OPTION_VAL_3PX_O55_ES },
         { "-2px",     OPTION_VAL_2PX_O55_ES },
         { "-1px",     OPTION_VAL_1PX_O55_ES },
         { "disabled", OPTION_VAL_DISABLED_O55_ES },
         { "+1px",     OPTION_VAL_1PX_O55_0_ES },
         { "+2px",     OPTION_VAL_2PX_O55_0_ES },
         { "+3px",     OPTION_VAL_3PX_O55_0_ES },
         { "+4px",     OPTION_VAL_4PX_O55_0_ES },
         { "+5px",     OPTION_VAL_5PX_O55_0_ES },
         { "+6px",     OPTION_VAL_6PX_O55_0_ES },
         { "+7px",     OPTION_VAL_7PX_O55_0_ES },
         { "+8px",     OPTION_VAL_8PX_O55_0_ES },
         { "+9px",     OPTION_VAL_9PX_O55_0_ES },
         { "+10px",    OPTION_VAL_10PX_O55_0_ES },
         { "+11px",    OPTION_VAL_11PX_O55_0_ES },
         { "+12px",    OPTION_VAL_12PX_O55_0_ES },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_ES,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_ES,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_ES },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_ES,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_ES,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_ES },
         { "2x",         OPTION_VAL_2X_ES },
         { "4x",         OPTION_VAL_4X_ES },
         { "8x",         OPTION_VAL_8X_ES },
         { "16x",        OPTION_VAL_16X_ES },
         { "32x",        OPTION_VAL_32X_ES },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_ES,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_ES,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_ES },
         { "uncorrected", OPTION_VAL_UNCORRECTED_ES },
         { "4:3",  OPTION_VAL_4_3_ES },
         { "ntsc", OPTION_VAL_NTSC_ES },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_ES,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_ES,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_ES,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_ES,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_ES },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_ES,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_ES,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_ES,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_ES,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_ES },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_ES,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_ES,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_ES },
         { "async",    OPTION_VAL_ASYNC_ES },
         { "precache", OPTION_VAL_PRECACHE_ES },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_ES,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_ES,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_ES },
         { "4x",          OPTION_VAL_4X_ES },
         { "6x",          OPTION_VAL_6X_ES },
         { "8x",          OPTION_VAL_8X_ES },
         { "10x",         OPTION_VAL_10X_ES },
         { "12x",         OPTION_VAL_12X_ES },
         { "14x",         OPTION_VAL_14X_ES },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_es = {
   option_cats_es,
   option_defs_es
};

/* RETRO_LANGUAGE_FA */

#define CATEGORY_VIDEO_LABEL_FA "ویدیو"
#define CATEGORY_VIDEO_INFO_0_FA NULL
#define CATEGORY_OSD_LABEL_FA NULL
#define CATEGORY_OSD_INFO_0_FA NULL
#define CATEGORY_INPUT_LABEL_FA "داده"
#define CATEGORY_INPUT_INFO_0_FA NULL
#define CATEGORY_MEMCARDS_LABEL_FA NULL
#define CATEGORY_MEMCARDS_INFO_0_FA NULL
#define CATEGORY_PGXP_LABEL_FA NULL
#define CATEGORY_PGXP_INFO_0_FA NULL
#define CATEGORY_HACKS_LABEL_FA NULL
#define CATEGORY_HACKS_INFO_0_FA NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_FA NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_FA NULL
#define OPTION_VAL_1X_NATIVE_FA NULL
#define OPTION_VAL_2X_FA NULL
#define OPTION_VAL_4X_FA NULL
#define OPTION_VAL_8X_FA NULL
#define OPTION_VAL_16X_FA NULL
#define BEETLE_OPT_DEPTH_LABEL_FA NULL
#define BEETLE_OPT_DEPTH_INFO_0_FA NULL
#define OPTION_VAL_16BPP_NATIVE_FA NULL
#define OPTION_VAL_32BPP_FA NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_FA NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_FA NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_FA NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_FA NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_FA NULL
#define BEETLE_OPT_FILTER_LABEL_FA NULL
#define BEETLE_OPT_FILTER_INFO_0_FA NULL
#define OPTION_VAL_NEAREST_FA NULL
#define OPTION_VAL_SABR_FA NULL
#define OPTION_VAL_XBR_FA NULL
#define OPTION_VAL_BILINEAR_FA NULL
#define OPTION_VAL_3_POINT_FA NULL
#define OPTION_VAL_JINC2_FA NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_FA NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_FA NULL
#define OPTION_VAL_OPAQUE_FA NULL
#define OPTION_VAL_ALL_FA NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_FA NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_FA NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_FA NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_FA NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_FA NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_FA NULL
#define BEETLE_OPT_MSAA_LABEL_FA NULL
#define BEETLE_OPT_MSAA_INFO_0_FA NULL
#define OPTION_VAL_1X_FA NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_FA NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_FA NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_FA NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_FA NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_FA NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_FA NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_FA NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_FA NULL
#define BEETLE_OPT_WIREFRAME_LABEL_FA NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_FA NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_FA NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_FA NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_FA NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_FA NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_FA NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_FA NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_FA NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_FA NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_FA NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_FA NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_FA NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_FA NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_FA NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_FA NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_FA NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_FA NULL
#define OPTION_VAL_LIGHTGUN_FA NULL
#define OPTION_VAL_TOUCHSCREEN_FA NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_FA NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_FA NULL
#define OPTION_VAL_CROSS_FA NULL
#define OPTION_VAL_DOT_FA NULL
#define OPTION_VAL_OFF_FA NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_FA NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_FA NULL
#define OPTION_VAL_RED_FA NULL
#define OPTION_VAL_BLUE_FA NULL
#define OPTION_VAL_GREEN_FA NULL
#define OPTION_VAL_ORANGE_FA NULL
#define OPTION_VAL_YELLOW_FA NULL
#define OPTION_VAL_CYAN_FA NULL
#define OPTION_VAL_PINK_FA NULL
#define OPTION_VAL_PURPLE_FA NULL
#define OPTION_VAL_BLACK_FA NULL
#define OPTION_VAL_WHITE_FA NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_FA NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_FA NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_FA NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_FA NULL
#define OPTION_VAL_5_FA NULL
#define OPTION_VAL_10_FA NULL
#define OPTION_VAL_15_FA NULL
#define OPTION_VAL_20_FA NULL
#define OPTION_VAL_25_FA NULL
#define OPTION_VAL_30_FA NULL
#define OPTION_VAL_35_FA NULL
#define OPTION_VAL_40_FA NULL
#define OPTION_VAL_45_FA NULL
#define OPTION_VAL_50_FA NULL
#define OPTION_VAL_55_FA NULL
#define OPTION_VAL_60_FA NULL
#define OPTION_VAL_65_FA NULL
#define OPTION_VAL_70_FA NULL
#define OPTION_VAL_75_FA NULL
#define OPTION_VAL_80_FA NULL
#define OPTION_VAL_85_FA NULL
#define OPTION_VAL_90_FA NULL
#define OPTION_VAL_95_FA NULL
#define OPTION_VAL_100_FA NULL
#define OPTION_VAL_105_FA NULL
#define OPTION_VAL_110_FA NULL
#define OPTION_VAL_115_FA NULL
#define OPTION_VAL_120_FA NULL
#define OPTION_VAL_125_FA NULL
#define OPTION_VAL_130_FA NULL
#define OPTION_VAL_135_FA NULL
#define OPTION_VAL_140_FA NULL
#define OPTION_VAL_145_FA NULL
#define OPTION_VAL_150_FA NULL
#define OPTION_VAL_155_FA NULL
#define OPTION_VAL_160_FA NULL
#define OPTION_VAL_165_FA NULL
#define OPTION_VAL_170_FA NULL
#define OPTION_VAL_175_FA NULL
#define OPTION_VAL_180_FA NULL
#define OPTION_VAL_185_FA NULL
#define OPTION_VAL_190_FA NULL
#define OPTION_VAL_195_FA NULL
#define OPTION_VAL_200_FA NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_FA NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_FA NULL
#define OPTION_VAL_LINEAR_FA NULL
#define OPTION_VAL_QUADRATIC_FA NULL
#define OPTION_VAL_CUBIC_FA NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_FA NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_FA NULL
#define OPTION_VAL_0_FA NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_FA NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_FA NULL
#define OPTION_VAL_LIBRETRO_FA NULL
#define OPTION_VAL_MEDNAFEN_FA NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_FA NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_FA NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_FA NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_FA NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_FA NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_FA NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_FA NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_FA NULL
#define OPTION_VAL_1_FA NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_FA NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_FA NULL
#define OPTION_VAL_MEMORY_ONLY_FA NULL
#define OPTION_VAL_MEMORY_CPU_FA NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_FA NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_FA NULL
#define OPTION_VAL_0PX_FA NULL
#define OPTION_VAL_1PX_FA NULL
#define OPTION_VAL_2PX_FA NULL
#define OPTION_VAL_3PX_FA NULL
#define OPTION_VAL_4PX_FA NULL
#define OPTION_VAL_5PX_FA NULL
#define OPTION_VAL_6PX_FA NULL
#define OPTION_VAL_7PX_FA NULL
#define OPTION_VAL_8PX_FA NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_FA NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_FA NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_FA NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_FA NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_FA NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_FA NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_FA NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_FA NULL
#define OPTION_VAL_DEFAULT_FA NULL
#define OPTION_VAL_AGGRESSIVE_FA NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_FA NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_FA NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_FA NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_FA NULL
#define OPTION_VAL_16_9_FA NULL
#define OPTION_VAL_16_10_FA NULL
#define OPTION_VAL_18_9_FA NULL
#define OPTION_VAL_19_9_FA NULL
#define OPTION_VAL_20_9_FA NULL
#define OPTION_VAL_21_9_FA NULL
#define OPTION_VAL_32_9_FA NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_FA NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_FA NULL
#define OPTION_VAL_100_NATIVE_FA NULL
#define OPTION_VAL_210_FA NULL
#define OPTION_VAL_220_FA NULL
#define OPTION_VAL_230_FA NULL
#define OPTION_VAL_240_FA NULL
#define OPTION_VAL_250_FA NULL
#define OPTION_VAL_260_FA NULL
#define OPTION_VAL_270_FA NULL
#define OPTION_VAL_280_FA NULL
#define OPTION_VAL_290_FA NULL
#define OPTION_VAL_300_FA NULL
#define OPTION_VAL_310_FA NULL
#define OPTION_VAL_320_FA NULL
#define OPTION_VAL_330_FA NULL
#define OPTION_VAL_340_FA NULL
#define OPTION_VAL_350_FA NULL
#define OPTION_VAL_360_FA NULL
#define OPTION_VAL_370_FA NULL
#define OPTION_VAL_380_FA NULL
#define OPTION_VAL_390_FA NULL
#define OPTION_VAL_400_FA NULL
#define OPTION_VAL_410_FA NULL
#define OPTION_VAL_420_FA NULL
#define OPTION_VAL_430_FA NULL
#define OPTION_VAL_440_FA NULL
#define OPTION_VAL_450_FA NULL
#define OPTION_VAL_460_FA NULL
#define OPTION_VAL_470_FA NULL
#define OPTION_VAL_480_FA NULL
#define OPTION_VAL_490_FA NULL
#define OPTION_VAL_500_FA NULL
#define OPTION_VAL_510_FA NULL
#define OPTION_VAL_520_FA NULL
#define OPTION_VAL_530_FA NULL
#define OPTION_VAL_540_FA NULL
#define OPTION_VAL_550_FA NULL
#define OPTION_VAL_560_FA NULL
#define OPTION_VAL_570_FA NULL
#define OPTION_VAL_580_FA NULL
#define OPTION_VAL_590_FA NULL
#define OPTION_VAL_600_FA NULL
#define OPTION_VAL_610_FA NULL
#define OPTION_VAL_620_FA NULL
#define OPTION_VAL_630_FA NULL
#define OPTION_VAL_640_FA NULL
#define OPTION_VAL_650_FA NULL
#define OPTION_VAL_660_FA NULL
#define OPTION_VAL_670_FA NULL
#define OPTION_VAL_680_FA NULL
#define OPTION_VAL_690_FA NULL
#define OPTION_VAL_700_FA NULL
#define OPTION_VAL_710_FA NULL
#define OPTION_VAL_720_FA NULL
#define OPTION_VAL_730_FA NULL
#define OPTION_VAL_740_FA NULL
#define OPTION_VAL_750_FA NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_FA NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_FA NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_FA NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_FA NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_FA NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_FA NULL
#define OPTION_VAL_PSXONPSP_FA NULL
#define OPTION_VAL_PS1_ROM_FA NULL
#define BEETLE_OPT_RENDERER_LABEL_FA NULL
#define BEETLE_OPT_RENDERER_INFO_0_FA NULL
#define OPTION_VAL_HARDWARE_FA NULL
#define OPTION_VAL_HARDWARE_GL_FA NULL
#define OPTION_VAL_HARDWARE_VK_FA NULL
#define OPTION_VAL_SOFTWARE_FA NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_FA NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_FA NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_FA NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_FA NULL
#define OPTION_VAL_DISABLED_FA NULL
#define OPTION_VAL_EXECUTE_FA NULL
#define OPTION_VAL_EXECUTE_ONE_FA NULL
#define OPTION_VAL_RUN_INTERPRETER_FA NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_FA NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_FA NULL
#define OPTION_VAL_FULL_FA NULL
#define OPTION_VAL_DMA_FA NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_FA NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_FA NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_FA NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_FA NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_FA NULL
#define OPTION_VAL_FORCE_INTERLACED_FA NULL
#define OPTION_VAL_AUTO_TOGGLE_FA NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_FA NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_FA NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_FA NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_FA NULL
#define OPTION_VAL_DISABLED_O53_FA NULL
#define OPTION_VAL_STATIC_FA NULL
#define OPTION_VAL_SMART_FA NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_FA NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_FA NULL
#define OPTION_VAL_9PX_FA NULL
#define OPTION_VAL_10PX_FA NULL
#define OPTION_VAL_11PX_FA NULL
#define OPTION_VAL_12PX_FA NULL
#define OPTION_VAL_13PX_FA NULL
#define OPTION_VAL_14PX_FA NULL
#define OPTION_VAL_15PX_FA NULL
#define OPTION_VAL_16PX_FA NULL
#define OPTION_VAL_17PX_FA NULL
#define OPTION_VAL_18PX_FA NULL
#define OPTION_VAL_19PX_FA NULL
#define OPTION_VAL_20PX_FA NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_FA NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_FA NULL
#define OPTION_VAL_12PX_O55_FA NULL
#define OPTION_VAL_11PX_O55_FA NULL
#define OPTION_VAL_10PX_O55_FA NULL
#define OPTION_VAL_9PX_O55_FA NULL
#define OPTION_VAL_8PX_O55_FA NULL
#define OPTION_VAL_7PX_O55_FA NULL
#define OPTION_VAL_6PX_O55_FA NULL
#define OPTION_VAL_5PX_O55_FA NULL
#define OPTION_VAL_4PX_O55_FA NULL
#define OPTION_VAL_3PX_O55_FA NULL
#define OPTION_VAL_2PX_O55_FA NULL
#define OPTION_VAL_1PX_O55_FA NULL
#define OPTION_VAL_DISABLED_O55_FA NULL
#define OPTION_VAL_1PX_O55_0_FA NULL
#define OPTION_VAL_2PX_O55_0_FA NULL
#define OPTION_VAL_3PX_O55_0_FA NULL
#define OPTION_VAL_4PX_O55_0_FA NULL
#define OPTION_VAL_5PX_O55_0_FA NULL
#define OPTION_VAL_6PX_O55_0_FA NULL
#define OPTION_VAL_7PX_O55_0_FA NULL
#define OPTION_VAL_8PX_O55_0_FA NULL
#define OPTION_VAL_9PX_O55_0_FA NULL
#define OPTION_VAL_10PX_O55_0_FA NULL
#define OPTION_VAL_11PX_O55_0_FA NULL
#define OPTION_VAL_12PX_O55_0_FA NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_FA NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_FA NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_FA NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_FA NULL
#define OPTION_VAL_32X_FA NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_FA NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_FA NULL
#define OPTION_VAL_CORRECTED_FA NULL
#define OPTION_VAL_UNCORRECTED_FA NULL
#define OPTION_VAL_4_3_FA NULL
#define OPTION_VAL_NTSC_FA NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_FA NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_FA NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_FA NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_FA NULL
#define OPTION_VAL_239_FA NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_FA NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_FA NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_FA NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_FA NULL
#define OPTION_VAL_287_FA NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_FA NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_FA NULL
#define OPTION_VAL_SYNC_FA NULL
#define OPTION_VAL_ASYNC_FA NULL
#define OPTION_VAL_PRECACHE_FA NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_FA NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_FA NULL
#define OPTION_VAL_2X_NATIVE_FA NULL
#define OPTION_VAL_6X_FA NULL
#define OPTION_VAL_10X_FA NULL
#define OPTION_VAL_12X_FA NULL
#define OPTION_VAL_14X_FA NULL

struct retro_core_option_v2_category option_cats_fa[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_FA,
      CATEGORY_VIDEO_INFO_0_FA
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_FA,
      CATEGORY_OSD_INFO_0_FA
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_FA,
      CATEGORY_INPUT_INFO_0_FA
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_FA,
      CATEGORY_MEMCARDS_INFO_0_FA
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_FA,
      CATEGORY_PGXP_INFO_0_FA
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_FA,
      CATEGORY_HACKS_INFO_0_FA
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_fa[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_FA,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_FA,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_FA },
         { "2x",         OPTION_VAL_2X_FA },
         { "4x",         OPTION_VAL_4X_FA },
         { "8x",         OPTION_VAL_8X_FA },
         { "16x",        OPTION_VAL_16X_FA },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_FA,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_FA,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_FA },
         { "32bpp",         OPTION_VAL_32BPP_FA },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_FA,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_FA,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_FA },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_FA },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_FA,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_FA,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_FA,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_FA,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_FA },
         { "SABR",     OPTION_VAL_SABR_FA },
         { "xBR",      OPTION_VAL_XBR_FA },
         { "bilinear", OPTION_VAL_BILINEAR_FA },
         { "3-point",  OPTION_VAL_3_POINT_FA },
         { "JINC2",    OPTION_VAL_JINC2_FA },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_FA,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_FA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_FA },
         { "all", OPTION_VAL_ALL_FA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_FA,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_FA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_FA },
         { "all", OPTION_VAL_ALL_FA },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_FA,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_FA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_FA,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_FA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_FA,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_FA,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_FA },
         { "2x",  OPTION_VAL_2X_FA },
         { "4x",  OPTION_VAL_4X_FA },
         { "8x",  OPTION_VAL_8X_FA },
         { "16x", OPTION_VAL_16X_FA },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_FA,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_FA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_FA,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_FA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_FA,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_FA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_FA,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_FA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_FA,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_FA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_FA,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_FA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_FA,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_FA,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_FA,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_FA,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_FA,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_FA,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_FA,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_FA,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_FA,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_FA,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_FA,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_FA,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_FA,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_FA,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_FA },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_FA },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_FA,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_FA,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_FA },
         { "dot",   OPTION_VAL_DOT_FA },
         { "off",   OPTION_VAL_OFF_FA },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_FA,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_FA,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_FA },
         { "blue", OPTION_VAL_BLUE_FA },
         { "green", OPTION_VAL_GREEN_FA },
         { "orange", OPTION_VAL_ORANGE_FA },
         { "yellow", OPTION_VAL_YELLOW_FA },
         { "cyan", OPTION_VAL_CYAN_FA },
         { "pink", OPTION_VAL_PINK_FA },
         { "purple", OPTION_VAL_PURPLE_FA },
         { "black", OPTION_VAL_BLACK_FA },
         { "white", OPTION_VAL_WHITE_FA },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_FA,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_FA,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_FA },
         { "red", OPTION_VAL_RED_FA },
         { "green", OPTION_VAL_GREEN_FA },
         { "orange", OPTION_VAL_ORANGE_FA },
         { "yellow", OPTION_VAL_YELLOW_FA },
         { "cyan", OPTION_VAL_CYAN_FA },
         { "pink", OPTION_VAL_PINK_FA },
         { "purple", OPTION_VAL_PURPLE_FA },
         { "black", OPTION_VAL_BLACK_FA },
         { "white", OPTION_VAL_WHITE_FA },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_FA,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_FA,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_FA },
         { "10%",  OPTION_VAL_10_FA },
         { "15%",  OPTION_VAL_15_FA },
         { "20%",  OPTION_VAL_20_FA },
         { "25%",  OPTION_VAL_25_FA },
         { "30%",  OPTION_VAL_30_FA },
         { "35%",  OPTION_VAL_35_FA },
         { "40%",  OPTION_VAL_40_FA },
         { "45%",  OPTION_VAL_45_FA },
         { "50%",  OPTION_VAL_50_FA },
         { "55%",  OPTION_VAL_55_FA },
         { "60%",  OPTION_VAL_60_FA },
         { "65%",  OPTION_VAL_65_FA },
         { "70%",  OPTION_VAL_70_FA },
         { "75%",  OPTION_VAL_75_FA },
         { "80%",  OPTION_VAL_80_FA },
         { "85%",  OPTION_VAL_85_FA },
         { "90%",  OPTION_VAL_90_FA },
         { "95%",  OPTION_VAL_95_FA },
         { "100%", OPTION_VAL_100_FA },
         { "105%", OPTION_VAL_105_FA },
         { "110%", OPTION_VAL_110_FA },
         { "115%", OPTION_VAL_115_FA },
         { "120%", OPTION_VAL_120_FA },
         { "125%", OPTION_VAL_125_FA },
         { "130%", OPTION_VAL_130_FA },
         { "135%", OPTION_VAL_135_FA },
         { "140%", OPTION_VAL_140_FA },
         { "145%", OPTION_VAL_145_FA },
         { "150%", OPTION_VAL_150_FA },
         { "155%", OPTION_VAL_155_FA },
         { "160%", OPTION_VAL_160_FA },
         { "165%", OPTION_VAL_165_FA },
         { "170%", OPTION_VAL_170_FA },
         { "175%", OPTION_VAL_175_FA },
         { "180%", OPTION_VAL_180_FA },
         { "185%", OPTION_VAL_185_FA },
         { "190%", OPTION_VAL_190_FA },
         { "195%", OPTION_VAL_195_FA },
         { "200%", OPTION_VAL_200_FA },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_FA,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_FA,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_FA },
         { "quadratic", OPTION_VAL_QUADRATIC_FA },
         { "cubic",     OPTION_VAL_CUBIC_FA },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_FA,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_FA,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_FA },
         { "5%",  OPTION_VAL_5_FA },
         { "10%", OPTION_VAL_10_FA },
         { "15%", OPTION_VAL_15_FA },
         { "20%", OPTION_VAL_20_FA },
         { "25%", OPTION_VAL_25_FA },
         { "30%", OPTION_VAL_30_FA },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_FA,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_FA,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_FA },
         { "mednafen", OPTION_VAL_MEDNAFEN_FA },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_FA,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_FA,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_FA,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_FA,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_FA,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_FA,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_FA,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_FA,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_FA },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_FA,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_FA,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_FA },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_FA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_FA,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_FA,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_FA },
         { "1px", OPTION_VAL_1PX_FA },
         { "2px", OPTION_VAL_2PX_FA },
         { "3px", OPTION_VAL_3PX_FA },
         { "4px", OPTION_VAL_4PX_FA },
         { "5px", OPTION_VAL_5PX_FA },
         { "6px", OPTION_VAL_6PX_FA },
         { "7px", OPTION_VAL_7PX_FA },
         { "8px", OPTION_VAL_8PX_FA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_FA,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_FA,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_FA,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_FA,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_FA,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_FA,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_FA,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_FA,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_FA },
         { "aggressive", OPTION_VAL_AGGRESSIVE_FA },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_FA,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_FA,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_FA,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_FA,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_FA },
         { "16:10", OPTION_VAL_16_10_FA },
         { "18:9",  OPTION_VAL_18_9_FA },
         { "19:9",  OPTION_VAL_19_9_FA },
         { "20:9",  OPTION_VAL_20_9_FA },
         { "21:9",  OPTION_VAL_21_9_FA }, // 64:27
         { "32:9",  OPTION_VAL_32_9_FA },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_FA,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_FA,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_FA },
         { "60%",           OPTION_VAL_60_FA },
         { "70%",           OPTION_VAL_70_FA },
         { "80%",           OPTION_VAL_80_FA },
         { "90%",           OPTION_VAL_90_FA },
         { "100%(native)", OPTION_VAL_100_NATIVE_FA },
         { "110%",          OPTION_VAL_110_FA },
         { "120%",          OPTION_VAL_120_FA },
         { "130%",          OPTION_VAL_130_FA },
         { "140%",          OPTION_VAL_140_FA },
         { "150%",          OPTION_VAL_150_FA },
         { "160%",          OPTION_VAL_160_FA },
         { "170%",          OPTION_VAL_170_FA },
         { "180%",          OPTION_VAL_180_FA },
         { "190%",          OPTION_VAL_190_FA },
         { "200%",          OPTION_VAL_200_FA },
         { "210%",          OPTION_VAL_210_FA },
         { "220%",          OPTION_VAL_220_FA },
         { "230%",          OPTION_VAL_230_FA },
         { "240%",          OPTION_VAL_240_FA },
         { "250%",          OPTION_VAL_250_FA },
         { "260%",          OPTION_VAL_260_FA },
         { "270%",          OPTION_VAL_270_FA },
         { "280%",          OPTION_VAL_280_FA },
         { "290%",          OPTION_VAL_290_FA },
         { "300%",          OPTION_VAL_300_FA },
         { "310%",          OPTION_VAL_310_FA },
         { "320%",          OPTION_VAL_320_FA },
         { "330%",          OPTION_VAL_330_FA },
         { "340%",          OPTION_VAL_340_FA },
         { "350%",          OPTION_VAL_350_FA },
         { "360%",          OPTION_VAL_360_FA },
         { "370%",          OPTION_VAL_370_FA },
         { "380%",          OPTION_VAL_380_FA },
         { "390%",          OPTION_VAL_390_FA },
         { "400%",          OPTION_VAL_400_FA },
         { "410%",          OPTION_VAL_410_FA },
         { "420%",          OPTION_VAL_420_FA },
         { "430%",          OPTION_VAL_430_FA },
         { "440%",          OPTION_VAL_440_FA },
         { "450%",          OPTION_VAL_450_FA },
         { "460%",          OPTION_VAL_460_FA },
         { "470%",          OPTION_VAL_470_FA },
         { "480%",          OPTION_VAL_480_FA },
         { "490%",          OPTION_VAL_490_FA },
         { "500%",          OPTION_VAL_500_FA },
         { "510%",          OPTION_VAL_510_FA },
         { "520%",          OPTION_VAL_520_FA },
         { "530%",          OPTION_VAL_530_FA },
         { "540%",          OPTION_VAL_540_FA },
         { "550%",          OPTION_VAL_550_FA },
         { "560%",          OPTION_VAL_560_FA },
         { "570%",          OPTION_VAL_570_FA },
         { "580%",          OPTION_VAL_580_FA },
         { "590%",          OPTION_VAL_590_FA },
         { "600%",          OPTION_VAL_600_FA },
         { "610%",          OPTION_VAL_610_FA },
         { "620%",          OPTION_VAL_620_FA },
         { "630%",          OPTION_VAL_630_FA },
         { "640%",          OPTION_VAL_640_FA },
         { "650%",          OPTION_VAL_650_FA },
         { "660%",          OPTION_VAL_660_FA },
         { "670%",          OPTION_VAL_670_FA },
         { "680%",          OPTION_VAL_680_FA },
         { "690%",          OPTION_VAL_690_FA },
         { "700%",          OPTION_VAL_700_FA },
         { "710%",          OPTION_VAL_710_FA },
         { "720%",          OPTION_VAL_720_FA },
         { "730%",          OPTION_VAL_730_FA },
         { "740%",          OPTION_VAL_740_FA },
         { "750%",          OPTION_VAL_750_FA },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_FA,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_FA,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_FA,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_FA,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_FA,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_FA,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_FA },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_FA },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_FA,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_FA,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_FA },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_FA },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_FA },
#endif
         { "software",    OPTION_VAL_SOFTWARE_FA },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_FA,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_FA,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_FA,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_FA,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_FA },
         { "execute",  OPTION_VAL_EXECUTE_FA },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_FA },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_FA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_FA,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_FA,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_FA },
         { "dma",  OPTION_VAL_DMA_FA },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_FA,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_FA,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_FA,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_FA,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_FA },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_FA },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_FA },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_FA,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_FA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_FA,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_FA,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_FA },
         { "static",  OPTION_VAL_STATIC_FA },
         { "smart", OPTION_VAL_SMART_FA },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_FA,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_FA,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_FA },
         { "2px",      OPTION_VAL_2PX_FA },
         { "3px",      OPTION_VAL_3PX_FA },
         { "4px",      OPTION_VAL_4PX_FA },
         { "5px",      OPTION_VAL_5PX_FA },
         { "6px",      OPTION_VAL_6PX_FA },
         { "7px",      OPTION_VAL_7PX_FA },
         { "8px",      OPTION_VAL_8PX_FA },
         { "9px",      OPTION_VAL_9PX_FA },
         { "10px",     OPTION_VAL_10PX_FA },
         { "11px",     OPTION_VAL_11PX_FA },
         { "12px",     OPTION_VAL_12PX_FA },
         { "13px",     OPTION_VAL_13PX_FA },
         { "14px",     OPTION_VAL_14PX_FA },
         { "15px",     OPTION_VAL_15PX_FA },
         { "16px",     OPTION_VAL_16PX_FA },
         { "17px",     OPTION_VAL_17PX_FA },
         { "18px",     OPTION_VAL_18PX_FA },
         { "19px",     OPTION_VAL_19PX_FA },
         { "20px",     OPTION_VAL_20PX_FA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_FA,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_FA,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_FA },
         { "-11px",    OPTION_VAL_11PX_O55_FA },
         { "-10px",    OPTION_VAL_10PX_O55_FA },
         { "-9px",     OPTION_VAL_9PX_O55_FA },
         { "-8px",     OPTION_VAL_8PX_O55_FA },
         { "-7px",     OPTION_VAL_7PX_O55_FA },
         { "-6px",     OPTION_VAL_6PX_O55_FA },
         { "-5px",     OPTION_VAL_5PX_O55_FA },
         { "-4px",     OPTION_VAL_4PX_O55_FA },
         { "-3px",     OPTION_VAL_3PX_O55_FA },
         { "-2px",     OPTION_VAL_2PX_O55_FA },
         { "-1px",     OPTION_VAL_1PX_O55_FA },
         { "disabled", OPTION_VAL_DISABLED_O55_FA },
         { "+1px",     OPTION_VAL_1PX_O55_0_FA },
         { "+2px",     OPTION_VAL_2PX_O55_0_FA },
         { "+3px",     OPTION_VAL_3PX_O55_0_FA },
         { "+4px",     OPTION_VAL_4PX_O55_0_FA },
         { "+5px",     OPTION_VAL_5PX_O55_0_FA },
         { "+6px",     OPTION_VAL_6PX_O55_0_FA },
         { "+7px",     OPTION_VAL_7PX_O55_0_FA },
         { "+8px",     OPTION_VAL_8PX_O55_0_FA },
         { "+9px",     OPTION_VAL_9PX_O55_0_FA },
         { "+10px",    OPTION_VAL_10PX_O55_0_FA },
         { "+11px",    OPTION_VAL_11PX_O55_0_FA },
         { "+12px",    OPTION_VAL_12PX_O55_0_FA },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_FA,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_FA,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_FA },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_FA,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_FA,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_FA },
         { "2x",         OPTION_VAL_2X_FA },
         { "4x",         OPTION_VAL_4X_FA },
         { "8x",         OPTION_VAL_8X_FA },
         { "16x",        OPTION_VAL_16X_FA },
         { "32x",        OPTION_VAL_32X_FA },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_FA,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_FA,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_FA },
         { "uncorrected", OPTION_VAL_UNCORRECTED_FA },
         { "4:3",  OPTION_VAL_4_3_FA },
         { "ntsc", OPTION_VAL_NTSC_FA },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_FA,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_FA,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_FA,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_FA,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_FA },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_FA,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_FA,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_FA,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_FA,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_FA },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_FA,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_FA,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_FA },
         { "async",    OPTION_VAL_ASYNC_FA },
         { "precache", OPTION_VAL_PRECACHE_FA },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_FA,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_FA,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_FA },
         { "4x",          OPTION_VAL_4X_FA },
         { "6x",          OPTION_VAL_6X_FA },
         { "8x",          OPTION_VAL_8X_FA },
         { "10x",         OPTION_VAL_10X_FA },
         { "12x",         OPTION_VAL_12X_FA },
         { "14x",         OPTION_VAL_14X_FA },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_fa = {
   option_cats_fa,
   option_defs_fa
};

/* RETRO_LANGUAGE_FI */

#define CATEGORY_VIDEO_LABEL_FI NULL
#define CATEGORY_VIDEO_INFO_0_FI "Muuta kuvasuhdetta, näytön rajausta, videosuodatusta ja kuvanohitusasetuksia."
#define CATEGORY_OSD_LABEL_FI "Näyttöilmoitukset"
#define CATEGORY_OSD_INFO_0_FI NULL
#define CATEGORY_INPUT_LABEL_FI "Syöte"
#define CATEGORY_INPUT_INFO_0_FI NULL
#define CATEGORY_MEMCARDS_LABEL_FI "Muistikortti"
#define CATEGORY_MEMCARDS_INFO_0_FI NULL
#define CATEGORY_PGXP_LABEL_FI NULL
#define CATEGORY_PGXP_INFO_0_FI NULL
#define CATEGORY_HACKS_LABEL_FI NULL
#define CATEGORY_HACKS_INFO_0_FI "Muuta prosessorin ylikellotus- ja emulointitarkkuusasetuksia, jotka vaikuttavat matalan tason suorituskykyyn ja yhteensopivuuteen."
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_FI NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_FI NULL
#define OPTION_VAL_1X_NATIVE_FI "1x (Natiivi)"
#define OPTION_VAL_2X_FI NULL
#define OPTION_VAL_4X_FI NULL
#define OPTION_VAL_8X_FI NULL
#define OPTION_VAL_16X_FI NULL
#define BEETLE_OPT_DEPTH_LABEL_FI "Sisäinen värisyvyys"
#define BEETLE_OPT_DEPTH_INFO_0_FI NULL
#define OPTION_VAL_16BPP_NATIVE_FI "16 bpp (Natiivi)"
#define OPTION_VAL_32BPP_FI NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_FI NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_FI NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_FI "Sisäinen resoluutio"
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_FI NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_FI NULL
#define BEETLE_OPT_FILTER_LABEL_FI "Tekstuurisuodatus"
#define BEETLE_OPT_FILTER_INFO_0_FI NULL
#define OPTION_VAL_NEAREST_FI "Lähin"
#define OPTION_VAL_SABR_FI NULL
#define OPTION_VAL_XBR_FI NULL
#define OPTION_VAL_BILINEAR_FI "Bilineaarinen"
#define OPTION_VAL_3_POINT_FI NULL
#define OPTION_VAL_JINC2_FI NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_FI NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_FI NULL
#define OPTION_VAL_OPAQUE_FI NULL
#define OPTION_VAL_ALL_FI NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_FI NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_FI NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_FI "Mukautuva pehmennys"
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_FI NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_FI NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_FI NULL
#define BEETLE_OPT_MSAA_LABEL_FI NULL
#define BEETLE_OPT_MSAA_INFO_0_FI NULL
#define OPTION_VAL_1X_FI NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_FI NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_FI NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_FI NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_FI NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_FI NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_FI NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_FI NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_FI NULL
#define BEETLE_OPT_WIREFRAME_LABEL_FI NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_FI NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_FI NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_FI NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_FI "Näytä sisäinen FPS"
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_FI NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_FI NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_FI NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_FI NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_FI NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_FI NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_FI NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_FI NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_FI NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_FI NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_FI NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_FI NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_FI NULL
#define OPTION_VAL_LIGHTGUN_FI "Valoase"
#define OPTION_VAL_TOUCHSCREEN_FI "Kosketusnäyttö"
#define BEETLE_OPT_GUN_CURSOR_LABEL_FI "Aseen tähtäin"
#define BEETLE_OPT_GUN_CURSOR_INFO_0_FI NULL
#define OPTION_VAL_CROSS_FI "Risti"
#define OPTION_VAL_DOT_FI "Piste"
#define OPTION_VAL_OFF_FI NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_FI NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_FI NULL
#define OPTION_VAL_RED_FI "Punainen"
#define OPTION_VAL_BLUE_FI "Sininen"
#define OPTION_VAL_GREEN_FI "Vihreä"
#define OPTION_VAL_ORANGE_FI "Oranssi"
#define OPTION_VAL_YELLOW_FI "Keltainen"
#define OPTION_VAL_CYAN_FI "Syaani"
#define OPTION_VAL_PINK_FI "Vaaleanpunainen"
#define OPTION_VAL_PURPLE_FI "Violetti"
#define OPTION_VAL_BLACK_FI "Musta"
#define OPTION_VAL_WHITE_FI "Valkoinen"
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_FI NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_FI NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_FI "Hiiren herkkyys"
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_FI NULL
#define OPTION_VAL_5_FI "5 %"
#define OPTION_VAL_10_FI "10 %"
#define OPTION_VAL_15_FI "15 %"
#define OPTION_VAL_20_FI "20 %"
#define OPTION_VAL_25_FI "25 %"
#define OPTION_VAL_30_FI "30 %"
#define OPTION_VAL_35_FI "35 %"
#define OPTION_VAL_40_FI "40 %"
#define OPTION_VAL_45_FI "45 %"
#define OPTION_VAL_50_FI "50 %"
#define OPTION_VAL_55_FI "55 %"
#define OPTION_VAL_60_FI "60 %"
#define OPTION_VAL_65_FI "65 %"
#define OPTION_VAL_70_FI "70 %"
#define OPTION_VAL_75_FI "75 %"
#define OPTION_VAL_80_FI "80 %"
#define OPTION_VAL_85_FI "85 %"
#define OPTION_VAL_90_FI "90 %"
#define OPTION_VAL_95_FI "95 %"
#define OPTION_VAL_100_FI "100 % (Oletus)"
#define OPTION_VAL_105_FI "105 %"
#define OPTION_VAL_110_FI "110 %"
#define OPTION_VAL_115_FI "115 %"
#define OPTION_VAL_120_FI "120 %"
#define OPTION_VAL_125_FI "125 %"
#define OPTION_VAL_130_FI "130 %"
#define OPTION_VAL_135_FI "135 %"
#define OPTION_VAL_140_FI "140 %"
#define OPTION_VAL_145_FI "145 %"
#define OPTION_VAL_150_FI "150 %"
#define OPTION_VAL_155_FI "155 %"
#define OPTION_VAL_160_FI "160 %"
#define OPTION_VAL_165_FI "165 %"
#define OPTION_VAL_170_FI "170 %"
#define OPTION_VAL_175_FI "175 %"
#define OPTION_VAL_180_FI "180 %"
#define OPTION_VAL_185_FI "185 %"
#define OPTION_VAL_190_FI "190 %"
#define OPTION_VAL_195_FI "195 %"
#define OPTION_VAL_200_FI "200 %"
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_FI NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_FI NULL
#define OPTION_VAL_LINEAR_FI "Lineaarinen"
#define OPTION_VAL_QUADRATIC_FI NULL
#define OPTION_VAL_CUBIC_FI NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_FI NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_FI NULL
#define OPTION_VAL_0_FI "0 %"
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_FI NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_FI NULL
#define OPTION_VAL_LIBRETRO_FI NULL
#define OPTION_VAL_MEDNAFEN_FI NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_FI NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_FI NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_FI "Jaetut muistikortit (Uudelleenkäynnistys vaaditaan)"
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_FI NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_FI NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_FI NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_FI NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_FI NULL
#define OPTION_VAL_1_FI "1 (Oletus)"
#define BEETLE_OPT_PGXP_MODE_LABEL_FI NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_FI NULL
#define OPTION_VAL_MEMORY_ONLY_FI NULL
#define OPTION_VAL_MEMORY_CPU_FI NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_FI NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_FI NULL
#define OPTION_VAL_0PX_FI NULL
#define OPTION_VAL_1PX_FI NULL
#define OPTION_VAL_2PX_FI NULL
#define OPTION_VAL_3PX_FI NULL
#define OPTION_VAL_4PX_FI NULL
#define OPTION_VAL_5PX_FI NULL
#define OPTION_VAL_6PX_FI NULL
#define OPTION_VAL_7PX_FI NULL
#define OPTION_VAL_8PX_FI NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_FI NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_FI NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_FI NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_FI NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_FI NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_FI NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_FI NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_FI NULL
#define OPTION_VAL_DEFAULT_FI "Oletus"
#define OPTION_VAL_AGGRESSIVE_FI NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_FI NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_FI NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_FI NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_FI NULL
#define OPTION_VAL_16_9_FI NULL
#define OPTION_VAL_16_10_FI NULL
#define OPTION_VAL_18_9_FI NULL
#define OPTION_VAL_19_9_FI NULL
#define OPTION_VAL_20_9_FI NULL
#define OPTION_VAL_21_9_FI NULL
#define OPTION_VAL_32_9_FI NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_FI NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_FI NULL
#define OPTION_VAL_100_NATIVE_FI "100 % (Natiivi)"
#define OPTION_VAL_210_FI "210 %"
#define OPTION_VAL_220_FI "220 %"
#define OPTION_VAL_230_FI "230 %"
#define OPTION_VAL_240_FI "240 %"
#define OPTION_VAL_250_FI "250 %"
#define OPTION_VAL_260_FI "260 %"
#define OPTION_VAL_270_FI "270 %"
#define OPTION_VAL_280_FI "280 %"
#define OPTION_VAL_290_FI "290 %"
#define OPTION_VAL_300_FI "300 %"
#define OPTION_VAL_310_FI "310 %"
#define OPTION_VAL_320_FI "320 %"
#define OPTION_VAL_330_FI "330 %"
#define OPTION_VAL_340_FI "340 %"
#define OPTION_VAL_350_FI "350 %"
#define OPTION_VAL_360_FI "360 %"
#define OPTION_VAL_370_FI "370 %"
#define OPTION_VAL_380_FI "380 %"
#define OPTION_VAL_390_FI "390 %"
#define OPTION_VAL_400_FI "400 %"
#define OPTION_VAL_410_FI "410 %"
#define OPTION_VAL_420_FI "420 %"
#define OPTION_VAL_430_FI "430 %"
#define OPTION_VAL_440_FI "440 %"
#define OPTION_VAL_450_FI "450 %"
#define OPTION_VAL_460_FI "460 %"
#define OPTION_VAL_470_FI "470 %"
#define OPTION_VAL_480_FI "480 %"
#define OPTION_VAL_490_FI "490 %"
#define OPTION_VAL_500_FI "500 %"
#define OPTION_VAL_510_FI "510 %"
#define OPTION_VAL_520_FI "520 %"
#define OPTION_VAL_530_FI "530 %"
#define OPTION_VAL_540_FI "540 %"
#define OPTION_VAL_550_FI "550 %"
#define OPTION_VAL_560_FI "560 %"
#define OPTION_VAL_570_FI "570 %"
#define OPTION_VAL_580_FI "580 %"
#define OPTION_VAL_590_FI "590 %"
#define OPTION_VAL_600_FI "600 %"
#define OPTION_VAL_610_FI "610 %"
#define OPTION_VAL_620_FI "620 %"
#define OPTION_VAL_630_FI "630 %"
#define OPTION_VAL_640_FI "640 %"
#define OPTION_VAL_650_FI "650 %"
#define OPTION_VAL_660_FI "660 %"
#define OPTION_VAL_670_FI "670 %"
#define OPTION_VAL_680_FI "680 %"
#define OPTION_VAL_690_FI "690 %"
#define OPTION_VAL_700_FI "700 %"
#define OPTION_VAL_710_FI "710 %"
#define OPTION_VAL_720_FI "720 %"
#define OPTION_VAL_730_FI "730 %"
#define OPTION_VAL_740_FI "740 %"
#define OPTION_VAL_750_FI "750 %"
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_FI NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_FI NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_FI "Ohita BIOS"
#define BEETLE_OPT_SKIP_BIOS_INFO_0_FI NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_FI NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_FI NULL
#define OPTION_VAL_PSXONPSP_FI NULL
#define OPTION_VAL_PS1_ROM_FI NULL
#define BEETLE_OPT_RENDERER_LABEL_FI NULL
#define BEETLE_OPT_RENDERER_INFO_0_FI NULL
#define OPTION_VAL_HARDWARE_FI NULL
#define OPTION_VAL_HARDWARE_GL_FI "Laitteisto (OpenGL)"
#define OPTION_VAL_HARDWARE_VK_FI "Laitteisto (Vulkan)"
#define OPTION_VAL_SOFTWARE_FI "Ohjelmisto"
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_FI NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_FI NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_FI NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_FI NULL
#define OPTION_VAL_DISABLED_FI NULL
#define OPTION_VAL_EXECUTE_FI NULL
#define OPTION_VAL_EXECUTE_ONE_FI NULL
#define OPTION_VAL_RUN_INTERPRETER_FI NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_FI NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_FI NULL
#define OPTION_VAL_FULL_FI NULL
#define OPTION_VAL_DMA_FI NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_FI NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_FI NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_FI NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_FI NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_FI NULL
#define OPTION_VAL_FORCE_INTERLACED_FI NULL
#define OPTION_VAL_AUTO_TOGGLE_FI NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_FI NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_FI NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_FI NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_FI NULL
#define OPTION_VAL_DISABLED_O53_FI "Ei mitään"
#define OPTION_VAL_STATIC_FI NULL
#define OPTION_VAL_SMART_FI "Dynaaminen (Oletus)"
#define BEETLE_OPT_IMAGE_CROP_LABEL_FI NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_FI NULL
#define OPTION_VAL_9PX_FI NULL
#define OPTION_VAL_10PX_FI NULL
#define OPTION_VAL_11PX_FI NULL
#define OPTION_VAL_12PX_FI NULL
#define OPTION_VAL_13PX_FI NULL
#define OPTION_VAL_14PX_FI NULL
#define OPTION_VAL_15PX_FI NULL
#define OPTION_VAL_16PX_FI NULL
#define OPTION_VAL_17PX_FI NULL
#define OPTION_VAL_18PX_FI NULL
#define OPTION_VAL_19PX_FI NULL
#define OPTION_VAL_20PX_FI NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_FI NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_FI NULL
#define OPTION_VAL_12PX_O55_FI NULL
#define OPTION_VAL_11PX_O55_FI NULL
#define OPTION_VAL_10PX_O55_FI NULL
#define OPTION_VAL_9PX_O55_FI NULL
#define OPTION_VAL_8PX_O55_FI NULL
#define OPTION_VAL_7PX_O55_FI NULL
#define OPTION_VAL_6PX_O55_FI NULL
#define OPTION_VAL_5PX_O55_FI NULL
#define OPTION_VAL_4PX_O55_FI NULL
#define OPTION_VAL_3PX_O55_FI NULL
#define OPTION_VAL_2PX_O55_FI NULL
#define OPTION_VAL_1PX_O55_FI NULL
#define OPTION_VAL_DISABLED_O55_FI "0 (Oletus)"
#define OPTION_VAL_1PX_O55_0_FI NULL
#define OPTION_VAL_2PX_O55_0_FI NULL
#define OPTION_VAL_3PX_O55_0_FI NULL
#define OPTION_VAL_4PX_O55_0_FI NULL
#define OPTION_VAL_5PX_O55_0_FI NULL
#define OPTION_VAL_6PX_O55_0_FI NULL
#define OPTION_VAL_7PX_O55_0_FI NULL
#define OPTION_VAL_8PX_O55_0_FI NULL
#define OPTION_VAL_9PX_O55_0_FI NULL
#define OPTION_VAL_10PX_O55_0_FI NULL
#define OPTION_VAL_11PX_O55_0_FI NULL
#define OPTION_VAL_12PX_O55_0_FI NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_FI NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_FI NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_FI NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_FI NULL
#define OPTION_VAL_32X_FI NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_FI "Ytimen kuvasuhde"
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_FI NULL
#define OPTION_VAL_CORRECTED_FI NULL
#define OPTION_VAL_UNCORRECTED_FI NULL
#define OPTION_VAL_4_3_FI "Pakota 4:3"
#define OPTION_VAL_NTSC_FI "Pakota NTSC"
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_FI NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_FI NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_FI NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_FI NULL
#define OPTION_VAL_239_FI "239 (Oletus)"
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_FI NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_FI NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_FI NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_FI NULL
#define OPTION_VAL_287_FI "287 (Oletus)"
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_FI NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_FI NULL
#define OPTION_VAL_SYNC_FI "Synkroninen"
#define OPTION_VAL_ASYNC_FI "Asynkroninen"
#define OPTION_VAL_PRECACHE_FI NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_FI "CD:n latausnopeus"
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_FI NULL
#define OPTION_VAL_2X_NATIVE_FI "2x (Natiivi)"
#define OPTION_VAL_6X_FI NULL
#define OPTION_VAL_10X_FI NULL
#define OPTION_VAL_12X_FI NULL
#define OPTION_VAL_14X_FI NULL

struct retro_core_option_v2_category option_cats_fi[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_FI,
      CATEGORY_VIDEO_INFO_0_FI
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_FI,
      CATEGORY_OSD_INFO_0_FI
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_FI,
      CATEGORY_INPUT_INFO_0_FI
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_FI,
      CATEGORY_MEMCARDS_INFO_0_FI
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_FI,
      CATEGORY_PGXP_INFO_0_FI
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_FI,
      CATEGORY_HACKS_INFO_0_FI
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_fi[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_FI,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_FI,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_FI },
         { "2x",         OPTION_VAL_2X_FI },
         { "4x",         OPTION_VAL_4X_FI },
         { "8x",         OPTION_VAL_8X_FI },
         { "16x",        OPTION_VAL_16X_FI },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_FI,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_FI,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_FI },
         { "32bpp",         OPTION_VAL_32BPP_FI },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_FI,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_FI,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_FI },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_FI },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_FI,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_FI,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_FI,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_FI,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_FI },
         { "SABR",     OPTION_VAL_SABR_FI },
         { "xBR",      OPTION_VAL_XBR_FI },
         { "bilinear", OPTION_VAL_BILINEAR_FI },
         { "3-point",  OPTION_VAL_3_POINT_FI },
         { "JINC2",    OPTION_VAL_JINC2_FI },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_FI,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_FI,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_FI },
         { "all", OPTION_VAL_ALL_FI },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_FI,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_FI,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_FI },
         { "all", OPTION_VAL_ALL_FI },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_FI,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_FI,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_FI,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_FI,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_FI,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_FI,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_FI },
         { "2x",  OPTION_VAL_2X_FI },
         { "4x",  OPTION_VAL_4X_FI },
         { "8x",  OPTION_VAL_8X_FI },
         { "16x", OPTION_VAL_16X_FI },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_FI,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_FI,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_FI,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_FI,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_FI,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_FI,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_FI,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_FI,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_FI,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_FI,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_FI,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_FI,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_FI,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_FI,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_FI,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_FI,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_FI,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_FI,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_FI,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_FI,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_FI,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_FI,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_FI,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_FI,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_FI,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_FI,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_FI },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_FI },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_FI,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_FI,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_FI },
         { "dot",   OPTION_VAL_DOT_FI },
         { "off",   OPTION_VAL_OFF_FI },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_FI,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_FI,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_FI },
         { "blue", OPTION_VAL_BLUE_FI },
         { "green", OPTION_VAL_GREEN_FI },
         { "orange", OPTION_VAL_ORANGE_FI },
         { "yellow", OPTION_VAL_YELLOW_FI },
         { "cyan", OPTION_VAL_CYAN_FI },
         { "pink", OPTION_VAL_PINK_FI },
         { "purple", OPTION_VAL_PURPLE_FI },
         { "black", OPTION_VAL_BLACK_FI },
         { "white", OPTION_VAL_WHITE_FI },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_FI,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_FI,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_FI },
         { "red", OPTION_VAL_RED_FI },
         { "green", OPTION_VAL_GREEN_FI },
         { "orange", OPTION_VAL_ORANGE_FI },
         { "yellow", OPTION_VAL_YELLOW_FI },
         { "cyan", OPTION_VAL_CYAN_FI },
         { "pink", OPTION_VAL_PINK_FI },
         { "purple", OPTION_VAL_PURPLE_FI },
         { "black", OPTION_VAL_BLACK_FI },
         { "white", OPTION_VAL_WHITE_FI },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_FI,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_FI,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_FI },
         { "10%",  OPTION_VAL_10_FI },
         { "15%",  OPTION_VAL_15_FI },
         { "20%",  OPTION_VAL_20_FI },
         { "25%",  OPTION_VAL_25_FI },
         { "30%",  OPTION_VAL_30_FI },
         { "35%",  OPTION_VAL_35_FI },
         { "40%",  OPTION_VAL_40_FI },
         { "45%",  OPTION_VAL_45_FI },
         { "50%",  OPTION_VAL_50_FI },
         { "55%",  OPTION_VAL_55_FI },
         { "60%",  OPTION_VAL_60_FI },
         { "65%",  OPTION_VAL_65_FI },
         { "70%",  OPTION_VAL_70_FI },
         { "75%",  OPTION_VAL_75_FI },
         { "80%",  OPTION_VAL_80_FI },
         { "85%",  OPTION_VAL_85_FI },
         { "90%",  OPTION_VAL_90_FI },
         { "95%",  OPTION_VAL_95_FI },
         { "100%", OPTION_VAL_100_FI },
         { "105%", OPTION_VAL_105_FI },
         { "110%", OPTION_VAL_110_FI },
         { "115%", OPTION_VAL_115_FI },
         { "120%", OPTION_VAL_120_FI },
         { "125%", OPTION_VAL_125_FI },
         { "130%", OPTION_VAL_130_FI },
         { "135%", OPTION_VAL_135_FI },
         { "140%", OPTION_VAL_140_FI },
         { "145%", OPTION_VAL_145_FI },
         { "150%", OPTION_VAL_150_FI },
         { "155%", OPTION_VAL_155_FI },
         { "160%", OPTION_VAL_160_FI },
         { "165%", OPTION_VAL_165_FI },
         { "170%", OPTION_VAL_170_FI },
         { "175%", OPTION_VAL_175_FI },
         { "180%", OPTION_VAL_180_FI },
         { "185%", OPTION_VAL_185_FI },
         { "190%", OPTION_VAL_190_FI },
         { "195%", OPTION_VAL_195_FI },
         { "200%", OPTION_VAL_200_FI },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_FI,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_FI,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_FI },
         { "quadratic", OPTION_VAL_QUADRATIC_FI },
         { "cubic",     OPTION_VAL_CUBIC_FI },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_FI,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_FI,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_FI },
         { "5%",  OPTION_VAL_5_FI },
         { "10%", OPTION_VAL_10_FI },
         { "15%", OPTION_VAL_15_FI },
         { "20%", OPTION_VAL_20_FI },
         { "25%", OPTION_VAL_25_FI },
         { "30%", OPTION_VAL_30_FI },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_FI,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_FI,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_FI },
         { "mednafen", OPTION_VAL_MEDNAFEN_FI },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_FI,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_FI,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_FI,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_FI,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_FI,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_FI,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_FI,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_FI,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_FI },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_FI,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_FI,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_FI },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_FI },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_FI,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_FI,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_FI },
         { "1px", OPTION_VAL_1PX_FI },
         { "2px", OPTION_VAL_2PX_FI },
         { "3px", OPTION_VAL_3PX_FI },
         { "4px", OPTION_VAL_4PX_FI },
         { "5px", OPTION_VAL_5PX_FI },
         { "6px", OPTION_VAL_6PX_FI },
         { "7px", OPTION_VAL_7PX_FI },
         { "8px", OPTION_VAL_8PX_FI },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_FI,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_FI,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_FI,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_FI,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_FI,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_FI,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_FI,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_FI,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_FI },
         { "aggressive", OPTION_VAL_AGGRESSIVE_FI },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_FI,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_FI,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_FI,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_FI,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_FI },
         { "16:10", OPTION_VAL_16_10_FI },
         { "18:9",  OPTION_VAL_18_9_FI },
         { "19:9",  OPTION_VAL_19_9_FI },
         { "20:9",  OPTION_VAL_20_9_FI },
         { "21:9",  OPTION_VAL_21_9_FI }, // 64:27
         { "32:9",  OPTION_VAL_32_9_FI },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_FI,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_FI,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_FI },
         { "60%",           OPTION_VAL_60_FI },
         { "70%",           OPTION_VAL_70_FI },
         { "80%",           OPTION_VAL_80_FI },
         { "90%",           OPTION_VAL_90_FI },
         { "100%(native)", OPTION_VAL_100_NATIVE_FI },
         { "110%",          OPTION_VAL_110_FI },
         { "120%",          OPTION_VAL_120_FI },
         { "130%",          OPTION_VAL_130_FI },
         { "140%",          OPTION_VAL_140_FI },
         { "150%",          OPTION_VAL_150_FI },
         { "160%",          OPTION_VAL_160_FI },
         { "170%",          OPTION_VAL_170_FI },
         { "180%",          OPTION_VAL_180_FI },
         { "190%",          OPTION_VAL_190_FI },
         { "200%",          OPTION_VAL_200_FI },
         { "210%",          OPTION_VAL_210_FI },
         { "220%",          OPTION_VAL_220_FI },
         { "230%",          OPTION_VAL_230_FI },
         { "240%",          OPTION_VAL_240_FI },
         { "250%",          OPTION_VAL_250_FI },
         { "260%",          OPTION_VAL_260_FI },
         { "270%",          OPTION_VAL_270_FI },
         { "280%",          OPTION_VAL_280_FI },
         { "290%",          OPTION_VAL_290_FI },
         { "300%",          OPTION_VAL_300_FI },
         { "310%",          OPTION_VAL_310_FI },
         { "320%",          OPTION_VAL_320_FI },
         { "330%",          OPTION_VAL_330_FI },
         { "340%",          OPTION_VAL_340_FI },
         { "350%",          OPTION_VAL_350_FI },
         { "360%",          OPTION_VAL_360_FI },
         { "370%",          OPTION_VAL_370_FI },
         { "380%",          OPTION_VAL_380_FI },
         { "390%",          OPTION_VAL_390_FI },
         { "400%",          OPTION_VAL_400_FI },
         { "410%",          OPTION_VAL_410_FI },
         { "420%",          OPTION_VAL_420_FI },
         { "430%",          OPTION_VAL_430_FI },
         { "440%",          OPTION_VAL_440_FI },
         { "450%",          OPTION_VAL_450_FI },
         { "460%",          OPTION_VAL_460_FI },
         { "470%",          OPTION_VAL_470_FI },
         { "480%",          OPTION_VAL_480_FI },
         { "490%",          OPTION_VAL_490_FI },
         { "500%",          OPTION_VAL_500_FI },
         { "510%",          OPTION_VAL_510_FI },
         { "520%",          OPTION_VAL_520_FI },
         { "530%",          OPTION_VAL_530_FI },
         { "540%",          OPTION_VAL_540_FI },
         { "550%",          OPTION_VAL_550_FI },
         { "560%",          OPTION_VAL_560_FI },
         { "570%",          OPTION_VAL_570_FI },
         { "580%",          OPTION_VAL_580_FI },
         { "590%",          OPTION_VAL_590_FI },
         { "600%",          OPTION_VAL_600_FI },
         { "610%",          OPTION_VAL_610_FI },
         { "620%",          OPTION_VAL_620_FI },
         { "630%",          OPTION_VAL_630_FI },
         { "640%",          OPTION_VAL_640_FI },
         { "650%",          OPTION_VAL_650_FI },
         { "660%",          OPTION_VAL_660_FI },
         { "670%",          OPTION_VAL_670_FI },
         { "680%",          OPTION_VAL_680_FI },
         { "690%",          OPTION_VAL_690_FI },
         { "700%",          OPTION_VAL_700_FI },
         { "710%",          OPTION_VAL_710_FI },
         { "720%",          OPTION_VAL_720_FI },
         { "730%",          OPTION_VAL_730_FI },
         { "740%",          OPTION_VAL_740_FI },
         { "750%",          OPTION_VAL_750_FI },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_FI,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_FI,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_FI,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_FI,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_FI,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_FI,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_FI },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_FI },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_FI,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_FI,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_FI },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_FI },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_FI },
#endif
         { "software",    OPTION_VAL_SOFTWARE_FI },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_FI,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_FI,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_FI,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_FI,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_FI },
         { "execute",  OPTION_VAL_EXECUTE_FI },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_FI },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_FI },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_FI,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_FI,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_FI },
         { "dma",  OPTION_VAL_DMA_FI },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_FI,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_FI,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_FI,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_FI,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_FI },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_FI },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_FI },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_FI,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_FI,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_FI,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_FI,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_FI },
         { "static",  OPTION_VAL_STATIC_FI },
         { "smart", OPTION_VAL_SMART_FI },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_FI,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_FI,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_FI },
         { "2px",      OPTION_VAL_2PX_FI },
         { "3px",      OPTION_VAL_3PX_FI },
         { "4px",      OPTION_VAL_4PX_FI },
         { "5px",      OPTION_VAL_5PX_FI },
         { "6px",      OPTION_VAL_6PX_FI },
         { "7px",      OPTION_VAL_7PX_FI },
         { "8px",      OPTION_VAL_8PX_FI },
         { "9px",      OPTION_VAL_9PX_FI },
         { "10px",     OPTION_VAL_10PX_FI },
         { "11px",     OPTION_VAL_11PX_FI },
         { "12px",     OPTION_VAL_12PX_FI },
         { "13px",     OPTION_VAL_13PX_FI },
         { "14px",     OPTION_VAL_14PX_FI },
         { "15px",     OPTION_VAL_15PX_FI },
         { "16px",     OPTION_VAL_16PX_FI },
         { "17px",     OPTION_VAL_17PX_FI },
         { "18px",     OPTION_VAL_18PX_FI },
         { "19px",     OPTION_VAL_19PX_FI },
         { "20px",     OPTION_VAL_20PX_FI },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_FI,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_FI,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_FI },
         { "-11px",    OPTION_VAL_11PX_O55_FI },
         { "-10px",    OPTION_VAL_10PX_O55_FI },
         { "-9px",     OPTION_VAL_9PX_O55_FI },
         { "-8px",     OPTION_VAL_8PX_O55_FI },
         { "-7px",     OPTION_VAL_7PX_O55_FI },
         { "-6px",     OPTION_VAL_6PX_O55_FI },
         { "-5px",     OPTION_VAL_5PX_O55_FI },
         { "-4px",     OPTION_VAL_4PX_O55_FI },
         { "-3px",     OPTION_VAL_3PX_O55_FI },
         { "-2px",     OPTION_VAL_2PX_O55_FI },
         { "-1px",     OPTION_VAL_1PX_O55_FI },
         { "disabled", OPTION_VAL_DISABLED_O55_FI },
         { "+1px",     OPTION_VAL_1PX_O55_0_FI },
         { "+2px",     OPTION_VAL_2PX_O55_0_FI },
         { "+3px",     OPTION_VAL_3PX_O55_0_FI },
         { "+4px",     OPTION_VAL_4PX_O55_0_FI },
         { "+5px",     OPTION_VAL_5PX_O55_0_FI },
         { "+6px",     OPTION_VAL_6PX_O55_0_FI },
         { "+7px",     OPTION_VAL_7PX_O55_0_FI },
         { "+8px",     OPTION_VAL_8PX_O55_0_FI },
         { "+9px",     OPTION_VAL_9PX_O55_0_FI },
         { "+10px",    OPTION_VAL_10PX_O55_0_FI },
         { "+11px",    OPTION_VAL_11PX_O55_0_FI },
         { "+12px",    OPTION_VAL_12PX_O55_0_FI },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_FI,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_FI,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_FI },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_FI,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_FI,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_FI },
         { "2x",         OPTION_VAL_2X_FI },
         { "4x",         OPTION_VAL_4X_FI },
         { "8x",         OPTION_VAL_8X_FI },
         { "16x",        OPTION_VAL_16X_FI },
         { "32x",        OPTION_VAL_32X_FI },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_FI,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_FI,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_FI },
         { "uncorrected", OPTION_VAL_UNCORRECTED_FI },
         { "4:3",  OPTION_VAL_4_3_FI },
         { "ntsc", OPTION_VAL_NTSC_FI },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_FI,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_FI,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_FI,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_FI,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_FI },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_FI,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_FI,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_FI,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_FI,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_FI },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_FI,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_FI,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_FI },
         { "async",    OPTION_VAL_ASYNC_FI },
         { "precache", OPTION_VAL_PRECACHE_FI },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_FI,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_FI,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_FI },
         { "4x",          OPTION_VAL_4X_FI },
         { "6x",          OPTION_VAL_6X_FI },
         { "8x",          OPTION_VAL_8X_FI },
         { "10x",         OPTION_VAL_10X_FI },
         { "12x",         OPTION_VAL_12X_FI },
         { "14x",         OPTION_VAL_14X_FI },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_fi = {
   option_cats_fi,
   option_defs_fi
};

/* RETRO_LANGUAGE_FR */

#define CATEGORY_VIDEO_LABEL_FR "Vidéo"
#define CATEGORY_VIDEO_INFO_0_FR "Modifier les réglages du rapport d'aspect, du recadrage de l'affichage, du filtre vidéo et du saut d'images."
#define CATEGORY_OSD_LABEL_FR "Notifications à l'écran"
#define CATEGORY_OSD_INFO_0_FR "Modifier les notifications affichées à l'écran."
#define CATEGORY_INPUT_LABEL_FR "Entrées"
#define CATEGORY_INPUT_INFO_0_FR "Modifier les réglages du pistolet, de la souris et du neGcon."
#define CATEGORY_MEMCARDS_LABEL_FR "Memory Card (sauvegarde)"
#define CATEGORY_MEMCARDS_INFO_0_FR "Modifier les réglages relatifs aux Memory Card virtuelles utilisées par le système."
#define CATEGORY_PGXP_LABEL_FR "PGXP (Pipeline de transformation géométrique précise)"
#define CATEGORY_PGXP_INFO_0_FR "Ces options contrôlent des améliorations qui peuvent améliorer les graphismes par rapport à la console originale. PGXP peut se débarrasser des déformations de textures et des problèmes de Z-fighting (chevauchement de textures)."
#define CATEGORY_HACKS_LABEL_FR "Hacks d'émulation"
#define CATEGORY_HACKS_INFO_0_FR "Modifier les réglages d'overclocking du processeur et de la précision d'émulation qui affectent les performances de bas niveau et la compatibilité."
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_FR "Résolution du processeur graphique interne"
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_FR "Sélectionner le multiplicateur de résolution interne. Les résolutions supérieures à 'x1 (native)' améliorent la fidélité des modèles 3D au détriment des exigences de performance accrues. Les éléments 2D ne sont généralement pas affectés par ce réglage."
#define OPTION_VAL_1X_NATIVE_FR "x1 (native)"
#define OPTION_VAL_2X_FR "x2"
#define OPTION_VAL_4X_FR "x4"
#define OPTION_VAL_8X_FR "x8"
#define OPTION_VAL_16X_FR "x16"
#define BEETLE_OPT_DEPTH_LABEL_FR "Profondeur de couleurs interne"
#define BEETLE_OPT_DEPTH_INFO_0_FR "Sélectionner la profondeur de couleurs interne. Une profondeur de couleurs plus élevée peut réduire les effets de bande de couleurs sans utiliser de tramage. 16 bpp émule le matériel original mais peut avoir un bandage visible si le tramage n'est pas activé. Il est recommandé de désactiver 'Motif de tramage (dithering)' lorsque cette option est réglée sur 32 bpp."
#define OPTION_VAL_16BPP_NATIVE_FR "16 bpp (native)"
#define OPTION_VAL_32BPP_FR NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_FR "Motif de tramage (dithering)"
#define BEETLE_OPT_DITHER_MODE_INFO_0_FR "Sélectionner la configuration du motif de tramage (dithering). 'x1 (native)' émule le tramage natif de basse résolution utilisé par le matériel original pour lisser les artefacts de bandes de couleurs visibles à la profondeur de couleurs native. La 'Résolution interne' met à l'échelle la granularité du tramage sur la résolution interne configurée pour des résultats plus propres. Devrait être désactivé lors de l'exécution à une profondeur de couleurs sur 32 bpp. Remarque : Avec Vulkan, activer ceci forcera l'échantillonnage à la profondeur de couleur native, tandis que la désactivation activera automatiquement la sortie à une plus grande profondeur de couleurs."
#define OPTION_VAL_INTERNAL_RESOLUTION_FR "Résolution interne"
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_FR "Décalage UV de la texture"
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_FR "Échantillonner les textures des polygones 3D avec un décalage pour les résolutions internes supérieures à x1. Réduit les discontinuités de textures mais peut causer des bugs graphiques involontaires."
#define BEETLE_OPT_FILTER_LABEL_FR "Filtrage des textures"
#define BEETLE_OPT_FILTER_INFO_0_FR "Sélectionner la méthode de filtrage des textures. 'Au plus proche' émule le matériel original. 'Bilinéaire' et 'À 3 points' sont des filtres de lissage, qui réduisent la pixelisation via le flou. Les filtres 'SABR', 'xBR' et 'JINC2' sont des filtres d'agrandissement qui peuvent améliorer la fidélité/netteté des textures au détriment des exigences de performances accrues. Uniquement pris en charge par les moteurs de rendu matériels."
#define OPTION_VAL_NEAREST_FR "Au plus proche"
#define OPTION_VAL_SABR_FR NULL
#define OPTION_VAL_XBR_FR NULL
#define OPTION_VAL_BILINEAR_FR "Bilinéaire"
#define OPTION_VAL_3_POINT_FR "À 3 points"
#define OPTION_VAL_JINC2_FR NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_FR "Exclure les sprites du filtrage"
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_FR "Ne pas appliquer le filtrage de textures aux sprites. Empêche les discontinuités dans divers jeux avec des fonds rendus sur des sprites 2D. Utiliser avec le lissage adaptatif ou un autre filtre de post-traitement pour un meilleur effet."
#define OPTION_VAL_OPAQUE_FR "Opaque uniquement"
#define OPTION_VAL_ALL_FR "Opaque et semi-transparent"
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_FR "Exclure les polygones 2D du filtrage"
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_FR "Ne pas appliquer le filtrage de textures aux polygones 2D. Les polygones 2D sont détectés avec une heuristique et il peut y avoir des bugs. Utiliser avec le lissage adaptatif ou un autre filtre de post-traitement pour un meilleur effet."
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_FR "Lissage adaptatif"
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_FR "Lisser les images 2D et les éléments de l'interface utilisateur sans flouter les objets rendus en 3D. Uniquement pris en charge par le moteur de rendu Vulkan."
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_FR "Super échantillonnage (sous-échantillonnage à la résolution native)"
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_FR "Sous-échantillonne le rendu depuis la résolution interne supérieure à l'échelle de la résolution native. La combinaison de ceci avec des multiplicateurs de résolution interne plus élevés permet d'afficher des jeux avec des objets 3D anti-crénelés en basse résolution native. Produit les meilleurs résultats lorsqu'elle est appliquée à des titres mélangeant des éléments 2D et 3D (par ex. les personnages en 3D sur des arrière-plans pré-rendus), et fonctionne bien en conjonction avec les shaders CRT. Uniquement pris en charge par le moteur de rendu Vulkan. Remarque : désactiver 'Motif de tramage' est recommandé lorsque cette option est activée."
#define BEETLE_OPT_MSAA_LABEL_FR "Anti-crénelage multi-échantillonné"
#define BEETLE_OPT_MSAA_INFO_0_FR "Sélectionner le niveau de MSAA pour le rendu. Améliore l'apparence des objets 3D. Uniquement pris en charge par le moteur de rendu Vulkan."
#define OPTION_VAL_1X_FR "x1"
#define BEETLE_OPT_MDEC_YUV_LABEL_FR "Filtre MDEC YUV chroma"
#define BEETLE_OPT_MDEC_YUV_INFO_0_FR "Améliore la qualité de la lecture des vidéos (FMV) en réduisant les artefacts de 'macroblocs' (carrés/bords dentelés). Uniquement pris en charge par le moteur de rendu Vulkan."
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_FR "Suivre les textures"
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_FR "Pré-requis pour l'importation et le remplacement de textures. Plantera probablement dans la plupart des jeux."
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_FR "Importer les textures"
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_FR "Importer les textures utilisées vers <cd>-texture-dump/"
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_FR "Remplacer les textures"
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_FR "Remplacer les textures par des versions HD depuis <cd>-texture-replacements/"
#define BEETLE_OPT_WIREFRAME_LABEL_FR "Mode fil de fer (débuggage)"
#define BEETLE_OPT_WIREFRAME_INFO_0_FR "Rendre les modèles 3D sous forme de contours sans textures ni ombres. Uniquement pris en charge par le moteur de rendu matériel OpenGL. Remarque : Cette option est utile à des fins de débuggage, et devrait normalement être désactivée."
#define BEETLE_OPT_FRAME_DUPING_LABEL_FR "Duplication d'images (accélération)"
#define BEETLE_OPT_FRAME_DUPING_INFO_0_FR "Lorsque cette option est activée et prise en charge par l'interface de libretro, cela fournit une petite augmentation des performances en appelant l'interface à répéter l'image précédente si le cœur n'a rien de nouveau à afficher."
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_FR "Afficher les i/s internes"
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_FR "Affiche la fréquence d'images interne à laquelle le système PlayStation émulé rend du contenu. Remarque : Nécessite que les notifications à l'écran soient activées dans l'interface de libretro."
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_FR "Afficher la VRAM complète (débuggage)"
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_FR "Visualiser entièrement la VRAM de la console émulée. Uniquement pris en charge par les moteurs de rendu matériels OpenGL et Vulkan. Remarque : Ceci est à des fins de débuggage, et devrait normalement être désactivé."
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_FR "Auto-étalonnage analogique"
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_FR "Lorsque le périphérique d'entrée est réglé sur DualShock, Manette analogique, Joystick analogique ou neGcon, cette option active l'étalonnage dynamique des entrées analogiques. Les valeurs maximales enregistrées sont surveillées en temps réel et utilisées pour mettre à l'échelle les coordonnées analogiques passées à l'émulateur. Cela devrait être utilisé pour des jeux tels que Mega Man Legends 2 qui s'attendent à des valeurs plus grandes que ce que les manettes modernes fournissent. Pour de meilleurs résultats, les sticks analogiques devraient être tournés dans toute la mesure du possible pour régler l'algorithme de calibration chaque fois que du contenu est chargé."
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_FR "Activer le mode analogique DualShock"
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_FR "Lorsque le type de périphérique d'entrée est DualShock, cette option permet au DualShock émulé d'être basculé entre le mode NUMÉRIQUE et le mode ANALOGIQUE comme le matériel original. Lorsqu'elle est désactivée, le DualShock est verrouillé en mode ANALOGIQUE et lorsqu'elle est activée, le DualShock peut être basculé entre le mode NUMÉRIQUE et le mode ANALOGIQUE en maintenant appuyé START+SELECT+L1+L2+R1+R2."
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_FR "Port 1 : Activer le multitap"
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_FR "Activer la fonctionnalité multitap sur le port 1."
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_FR "Port 2 : Activer le multitap"
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_FR "Activer la fonctionnalité multitap sur le port 2."
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_FR "Mode d'entrée du pistolet"
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_FR "Sélectionner s'il faut utiliser une entrée 'Pistolet' contrôlée par la souris ou un 'Écran tactile' lorsque le type de périphérique est réglé sur 'Guncon/G-Con 45' ou 'Justifier'."
#define OPTION_VAL_LIGHTGUN_FR "Pistolet"
#define OPTION_VAL_TOUCHSCREEN_FR "Écran tactile"
#define BEETLE_OPT_GUN_CURSOR_LABEL_FR "Viseur du pistolet"
#define BEETLE_OPT_GUN_CURSOR_INFO_0_FR "Sélectionner le curseur du pistolet à afficher à l'écran lors de l'utilisation des types de périphériques d'entrée 'Guncon/G-Con 45' et 'Justifier'. Lorsque cette option est désactivée, les viseurs sont toujours masqués."
#define OPTION_VAL_CROSS_FR "Croix"
#define OPTION_VAL_DOT_FR "Point"
#define OPTION_VAL_OFF_FR "Pas de viseur"
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_FR "Port 1 : Couleur de viseur du pistolet"
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_FR "Sélectionner la couleur de viseur du pistolet pour le port 1."
#define OPTION_VAL_RED_FR "Rouge"
#define OPTION_VAL_BLUE_FR "Bleue"
#define OPTION_VAL_GREEN_FR "Verte"
#define OPTION_VAL_ORANGE_FR NULL
#define OPTION_VAL_YELLOW_FR "Jaune"
#define OPTION_VAL_CYAN_FR NULL
#define OPTION_VAL_PINK_FR "Rose"
#define OPTION_VAL_PURPLE_FR "Violette"
#define OPTION_VAL_BLACK_FR "Noire"
#define OPTION_VAL_WHITE_FR "Blanche"
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_FR "Port 2 : Couleur de viseur du pistolet"
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_FR "Sélectionner la couleur de viseur du pistolet pour le port 2."
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_FR "Sensibilité de la souris"
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_FR "Sélectionner la réactivité du type de périphérique d'entrée 'Souris'."
#define OPTION_VAL_5_FR NULL
#define OPTION_VAL_10_FR NULL
#define OPTION_VAL_15_FR NULL
#define OPTION_VAL_20_FR NULL
#define OPTION_VAL_25_FR NULL
#define OPTION_VAL_30_FR NULL
#define OPTION_VAL_35_FR NULL
#define OPTION_VAL_40_FR NULL
#define OPTION_VAL_45_FR NULL
#define OPTION_VAL_50_FR NULL
#define OPTION_VAL_55_FR NULL
#define OPTION_VAL_60_FR NULL
#define OPTION_VAL_65_FR NULL
#define OPTION_VAL_70_FR NULL
#define OPTION_VAL_75_FR NULL
#define OPTION_VAL_80_FR NULL
#define OPTION_VAL_85_FR NULL
#define OPTION_VAL_90_FR NULL
#define OPTION_VAL_95_FR NULL
#define OPTION_VAL_100_FR "100% (par défaut)"
#define OPTION_VAL_105_FR NULL
#define OPTION_VAL_110_FR NULL
#define OPTION_VAL_115_FR NULL
#define OPTION_VAL_120_FR NULL
#define OPTION_VAL_125_FR NULL
#define OPTION_VAL_130_FR NULL
#define OPTION_VAL_135_FR NULL
#define OPTION_VAL_140_FR NULL
#define OPTION_VAL_145_FR NULL
#define OPTION_VAL_150_FR NULL
#define OPTION_VAL_155_FR NULL
#define OPTION_VAL_160_FR NULL
#define OPTION_VAL_165_FR NULL
#define OPTION_VAL_170_FR NULL
#define OPTION_VAL_175_FR NULL
#define OPTION_VAL_180_FR NULL
#define OPTION_VAL_185_FR NULL
#define OPTION_VAL_190_FR NULL
#define OPTION_VAL_195_FR NULL
#define OPTION_VAL_200_FR NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_FR "Réponse de torsion du neGcon"
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_FR "Sélectionner le type de réponse du stick analogique de gauche de la RetroManette lors de la simulation de l'action de 'torsion' des périphériques d'entrée 'neGcon' émulés. Le déplacement des sticks analogiques peut être mappé à un angle de rotation neGcon linéaire, quadratique ou cubique. 'Quadratique' permet une plus grande précision que 'Linéaire' lors de petits déplacements. 'Cubique' augmente davantage la précision des petits déplacements, mais 'exagère' les mouvements plus grands. Remarque : 'Linéaire' n'est recommandé que lorsque vous utilisez des périphériques de volants de course. Les manettes conventionnelles implémentent l'entrée analogique d'une manière fondamentalement différente du mécanisme de 'torsion' du neGcon, de telle sorte que le mappage linéaire amplifie trop les petits mouvements, entravant le contrôle précis. Dans la plupart des cas, 'Quadratique' fournit l'approximation la plus proche du matériel réel."
#define OPTION_VAL_LINEAR_FR "Linéaire"
#define OPTION_VAL_QUADRATIC_FR "Quadratique"
#define OPTION_VAL_CUBIC_FR "Cubique"
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_FR "Deadzone de torsion du negCon"
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_FR "Sélectionner la deadzone du stick analogique gauche de la RetroManette lors de la simulation de l'action 'torsion' des périphériques d'entrée 'neGcon' émulés. Utilisé pour éliminer la dérive de la manette. Remarque : la plupart des titres compatibles avec le neGcon fournissent des options en jeu pour définir une valeur de deadzone de la 'torsion'. Pour éviter la perte de précision, la deadzone réglée en jeu devrait *toujours* être réglée à zéro. Tous les ajustements requis devraient *uniquement* être appliqués via cette option de coeur. Ceci est particulièrement important lorsque la valeur de 'Réponse de torsion du neGcon' est définie sur 'Quadratique' ou 'Cubique'."
#define OPTION_VAL_0_FR NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_FR "Méthode de la Memory Card 0 (Redémarrage requis)"
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_FR "Choisir le format des données de sauvegarde utilisé pour la carte mémoire 0. 'Mednafen' peut être utilisé pour la compatibilité avec la version autonome de Mednafen. Lors de l'utilisation avec Beetle PSX, Libretro (.srm) et Mednafen (.mcr) les sauvegardes ont des formats internes identiques et peuvent être converties les unes vers les autres via le renommage."
#define OPTION_VAL_LIBRETRO_FR NULL
#define OPTION_VAL_MEDNAFEN_FR NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_FR "Activer la Memory Card 1 (Redémarrage requis)"
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_FR "Émuler une deuxième carte mémoire dans l'emplacement 1. Lorsque cette option est désactivée, les jeux ne peuvent accéder à la carte mémoire que dans l'emplacement 0. Remarque : certains jeux nécessitent que cette option soit désactivée pour un fonctionnement correct (par exemple, Codename Tenka). Remarque : la Memory Card 1 utilise le format de sauvegarde Mednafen (.mcr)."
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_FR "Memory Cards partagées (Redémarrage requis)"
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_FR "Lorsque cette option est activée, tous les jeux vont sauvegarder et charger à partir des mêmes fichiers de carte mémoire. Lorsqu'elle est désactivée, des fichiers de carte mémoire séparés seront générés pour chaque élément de contenu chargé. Remarque : si la 'Méthode de la Memory Card 0' est définie sur 'Libretro', seule la carte mémoire de droite sera affectée."
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_FR "Index de la Memory Card de gauche"
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_FR "Modifier la carte mémoire actuellement chargée dans l'emplacement de gauche. Cette option ne fonctionnera que si la Méthode de la Memory Card 0 est définie sur Mednafen. La carte par défaut est à l'index 0."
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_FR "Index de la Memory Card de droite"
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_FR "Modifier la carte mémoire actuellement chargée dans l'emplacement de droite. Cette option ne fonctionnera que si la Memory Card 1 est activée. La carte par défaut est à l'index 1."
#define OPTION_VAL_1_FR "1 (par défaut)"
#define BEETLE_OPT_PGXP_MODE_LABEL_FR "Mode d'opération de PGXP"
#define BEETLE_OPT_PGXP_MODE_INFO_0_FR "Permet aux objets 3D d'être rendus avec une précision aux sous-pixels, minimisant la distorsion et les variations des objets 3D vues sur le matériel d'origine en raison de l'utilisation de coordonnées de vertex sur un point fixe. Le mode 'Mémoire uniquement' a un minimum de problèmes de compatibilité et est recommandé pour une utilisation générale. Le mode 'Mémoire + processeur (buggé)' peut réduire encore plus les variations, mais il a des exigences de performances élevées et peut causer diverses erreurs de géométrie."
#define OPTION_VAL_MEMORY_ONLY_FR "Mémoire uniquement"
#define OPTION_VAL_MEMORY_CPU_FR "Mémoire + processeur (buggé)"
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_FR "Tolérance à la géométrie 2D de PGXP"
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_FR "Masquer les erreurs les plus flagrantes dans les opérations de PGXP : la valeur spécifie la tolérance avec laquelle les valeurs de PGXP seront conservées en cas de géométries sans informations de profondeur appropriées."
#define OPTION_VAL_0PX_FR NULL
#define OPTION_VAL_1PX_FR NULL
#define OPTION_VAL_2PX_FR NULL
#define OPTION_VAL_3PX_FR NULL
#define OPTION_VAL_4PX_FR NULL
#define OPTION_VAL_5PX_FR NULL
#define OPTION_VAL_6PX_FR NULL
#define OPTION_VAL_7PX_FR NULL
#define OPTION_VAL_8PX_FR NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_FR "Élimination primitive des faces cachées PGXP"
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_FR "Utiliser l'implémentation NCLIP de PGXP. Améliore l'apparence en réduisant les trous dans les géométries avec les coordonnées de PGXP. Connu pour causer des bloquages de certains jeux dans diverses circonstances."
#define BEETLE_OPT_PGXP_VERTEX_LABEL_FR "Cache des vertex de PGXP"
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_FR "Mettre en cache la position des vertex améliorée par PGXP pour une réutilisation entre les rendus de polygones. Peut potentiellement améliorer l'alignement des objets et réduire les discontinuités visibles lors du rendu des textures, mais les faux positifs lors des requêtes du cache peuvent produire des bugs graphiques. Il est actuellement recommandé de laisser cette option désactivée. Cette option n'est appliquée que lorsque le Mode d'opération de PGXP est activé. Uniquement pris en charge par les moteurs de rendu matériels."
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_FR "Textures correctes en perspective de PGXP"
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_FR "Remplacer le mappage de textures affiné natif de la PSX par le mappage de texture correct pour la perspective. Élimine la distorsion et la déformation dépendant de la position des textures, ce qui entraîne un alignement correct des textures. Cette option n'est appliquée que lorsque le Mode d'opération de PGXP est activé. Uniquement pris en charge par les moteurs de rendu matériels."
#define BEETLE_OPT_LINE_RENDER_LABEL_FR "Hack des lignes en quadrilatères"
#define BEETLE_OPT_LINE_RENDER_INFO_0_FR "Choisir la méthode du hack des lignes en quadrilatères. Certains jeux (comme Doom, Hexen, Soul Blade, etc. par exemple) rendent des lignes horizontales en étirant des triangles d'une hauteur d'un pixel sur l'écran, qui sont rastérisés comme une rangée de pixels sur le matériel original. Ce hack détecte ces petits triangles et les convertit en quadrilatères si nécessaire, leur permettant d'être affichés correctement sur les moteurs de rendu matériels et à des résolutions internes agrandies. 'Agressif' est requis pour certains titres (Dark Forces et Duke Nukem par exemple) mais peut autrement introduire des bugs graphiques. Laisser sur 'Par défaut' en cas d'incertitude."
#define OPTION_VAL_DEFAULT_FR "Par défaut"
#define OPTION_VAL_AGGRESSIVE_FR "Agressif"
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_FR "Hack de mode écran large"
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_FR "Rendre le contenu 3D de manière anamorphique et afficher le tampon d'image émulé à un rapport d'aspect d'écran large. Produit de meilleurs résultats avec des jeux entièrement en 3D. Les éléments 2D seront étirés horizontalement et peuvent être mal alignés."
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_FR "Rapport d'aspect du hack de mode écran large"
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_FR "Sélectionner le rapport d'aspect à utiliser pour le hack de mode écran large."
#define OPTION_VAL_16_9_FR NULL
#define OPTION_VAL_16_10_FR NULL
#define OPTION_VAL_18_9_FR NULL
#define OPTION_VAL_19_9_FR NULL
#define OPTION_VAL_20_9_FR NULL
#define OPTION_VAL_21_9_FR NULL
#define OPTION_VAL_32_9_FR NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_FR "Échelle de la fréquence du processeur (overclock)"
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_FR "Overclocker (ou underclocker) le processeur émulé de la PSX. L'overclocking peut éliminer le ralentissement et améliorer la cadence d'images dans certains jeux au détriment des exigences de performances accrues. Notez que certains jeux ont un limiteur de fréquence d'images interne et peuvent ne pas bénéficier de l'overclocking. Peut causer l'animation plus rapide que prévu de certains effets dans certains titres lors de l'overclocking."
#define OPTION_VAL_100_NATIVE_FR "100% (native)"
#define OPTION_VAL_210_FR NULL
#define OPTION_VAL_220_FR NULL
#define OPTION_VAL_230_FR NULL
#define OPTION_VAL_240_FR NULL
#define OPTION_VAL_250_FR NULL
#define OPTION_VAL_260_FR NULL
#define OPTION_VAL_270_FR NULL
#define OPTION_VAL_280_FR NULL
#define OPTION_VAL_290_FR NULL
#define OPTION_VAL_300_FR NULL
#define OPTION_VAL_310_FR NULL
#define OPTION_VAL_320_FR NULL
#define OPTION_VAL_330_FR NULL
#define OPTION_VAL_340_FR NULL
#define OPTION_VAL_350_FR NULL
#define OPTION_VAL_360_FR NULL
#define OPTION_VAL_370_FR NULL
#define OPTION_VAL_380_FR NULL
#define OPTION_VAL_390_FR NULL
#define OPTION_VAL_400_FR NULL
#define OPTION_VAL_410_FR NULL
#define OPTION_VAL_420_FR NULL
#define OPTION_VAL_430_FR NULL
#define OPTION_VAL_440_FR NULL
#define OPTION_VAL_450_FR NULL
#define OPTION_VAL_460_FR NULL
#define OPTION_VAL_470_FR NULL
#define OPTION_VAL_480_FR NULL
#define OPTION_VAL_490_FR NULL
#define OPTION_VAL_500_FR NULL
#define OPTION_VAL_510_FR NULL
#define OPTION_VAL_520_FR NULL
#define OPTION_VAL_530_FR NULL
#define OPTION_VAL_540_FR NULL
#define OPTION_VAL_550_FR NULL
#define OPTION_VAL_560_FR NULL
#define OPTION_VAL_570_FR NULL
#define OPTION_VAL_580_FR NULL
#define OPTION_VAL_590_FR NULL
#define OPTION_VAL_600_FR NULL
#define OPTION_VAL_610_FR NULL
#define OPTION_VAL_620_FR NULL
#define OPTION_VAL_630_FR NULL
#define OPTION_VAL_640_FR NULL
#define OPTION_VAL_650_FR NULL
#define OPTION_VAL_660_FR NULL
#define OPTION_VAL_670_FR NULL
#define OPTION_VAL_680_FR NULL
#define OPTION_VAL_690_FR NULL
#define OPTION_VAL_700_FR NULL
#define OPTION_VAL_710_FR NULL
#define OPTION_VAL_720_FR NULL
#define OPTION_VAL_730_FR NULL
#define OPTION_VAL_740_FR NULL
#define OPTION_VAL_750_FR NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_FR "Overclocker le GTE"
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_FR "Réduire toutes les opérations du GTE émulé (coprocesseur du CPU pour les graphismes 3D) à une latence constante d'un cycle. Pour les jeux qui font un usage intensif du GTE, cela peut grandement améliorer la fréquence d'images et la stabilité du temps d'images."
#define BEETLE_OPT_SKIP_BIOS_LABEL_FR "Ignorer le BIOS"
#define BEETLE_OPT_SKIP_BIOS_INFO_0_FR "Ignorer l'animation de démarrage du BIOS PlayStation normalement affichée lors du chargement de contenu. Remarque : l'activation de cette option pose des problèmes de compatibilité avec un certain nombre de jeux (jeux protégés contre la copie PAL, Saga Frontier, etc.)."
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_FR "Remplacer le BIOS (Redémarrage requis)"
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_FR "Remplacer le BIOS spécifique à la région standard par un BIOS dézoné s'il est trouvé."
#define OPTION_VAL_PSXONPSP_FR "BIOS PS1 de la PSP"
#define OPTION_VAL_PS1_ROM_FR "BIOS PS1 de la PS3"
#define BEETLE_OPT_RENDERER_LABEL_FR "Moteur de rendu (Redémarrage requis)"
#define BEETLE_OPT_RENDERER_INFO_0_FR "Le moteur de rendu logiciel est le plus précis mais a des exigences en performances élevées lorsqu'il fonctionne avec des résolutions de carte graphique interne accrues. Les moteurs de rendu matériels, bien que moins précis, améliorent les performances par rapport au rendu logiciel à des résolutions internes accrues et permettent diverses améliorations graphiques. 'Matériel (auto)' sélectionne automatiquement le moteur de rendu Vulkan ou OpenGL, selon le pilote vidéo de l'interface libretro actuel. Si le pilote vidéo fourni n'est pas compatible avec Vulkan ou OpenGL 3.3, alors le cœur se repliera sur le moteur de rendu logiciel."
#define OPTION_VAL_HARDWARE_FR "Matériel (auto)"
#define OPTION_VAL_HARDWARE_GL_FR "Matériel (OpenGL)"
#define OPTION_VAL_HARDWARE_VK_FR "Matériel (Vulkan)"
#define OPTION_VAL_SOFTWARE_FR "Logiciel"
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_FR "Tampon d'images logiciel"
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_FR "Activer l'émulation précise des effets de tampon d'image (flou de mouvement, tourbillon de combat dans FF7 par exemple) lors de l'utilisation des moteurs de rendu matériels en exécutant une copie du rendu logiciel à la résolution native en arrière-plan. Si cette option est désactivée, ces opérations sont omises (OpenGL) ou rendues par le processeur graphique (Vulkan). La désactivation peut améliorer les performances mais peut causer des erreurs graphiques graves. Laisser activé si vous n'êtes pas sûr."
#define BEETLE_OPT_CPU_DYNAREC_LABEL_FR "Dynarec du processeur"
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_FR "Recompiler dynamiquement les instructions du processeur en mode natif. Bien plus rapide que l'interpréteur, mais la cadence du processeur est moins précise et peut avoir des bugs."
#define OPTION_VAL_DISABLED_FR "Désactivé (interpréteur Beetle)"
#define OPTION_VAL_EXECUTE_FR "Performances maximales"
#define OPTION_VAL_EXECUTE_ONE_FR "Contrôle du temps de cycle"
#define OPTION_VAL_RUN_INTERPRETER_FR "Interpréteur Lightrec"
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_FR "Invalidation du code Dynarec"
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_FR "Certains jeux requièrent une invalidation 'Complète', certains requièrent 'DMA uniquement'."
#define OPTION_VAL_FULL_FR "Complète"
#define OPTION_VAL_DMA_FR "DMA uniquement (légèrement plus rapide)"
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_FR "Cycles d'événements Dynarec DMA/processeur graphique"
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_FR "Cycles maximum exécutés par le processeur avant la vérification d'une mise à jour du processeur graphique ou du DMA, un nombre plus élevé sera plus rapide, a beaucoup moins d'impact sur l'interpréteur Beetle que sur le Dynarec."
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_FR "Cadence des i/s communiquée par le cœur"
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_FR "Sélectionner la cadence des images par seconde que le coeur va communiquer à l'interface. Le basculement automatique permettra au cœur de basculer entre communiquer les débits progressifs et entrelacés, mais peut causer des réinitialisations de pilotes vidéo/audio pour l'interface."
#define OPTION_VAL_FORCE_PROGRESSIVE_FR "Débit progressif"
#define OPTION_VAL_FORCE_INTERLACED_FR "Forcer le débit entrelacé"
#define OPTION_VAL_AUTO_TOGGLE_FR "Autoriser le basculement automatique"
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_FR "Substitution de la cadence vidéo PAL (européenne)"
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_FR "En raison de normes différentes, les jeux PAL semblent souvent ralentis par rapport aux versions américaines ou japonaises à la norme NTSC. Cette option peut être utilisée pour remplacer les timings PAL afin d'essayer d'exécuter ces jeux avec le débit d'image NTSC. Cette option n'a aucun effet lors de l'exécution de contenu NTSC."
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_FR "Recadrage du surbalayage"
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_FR "'Aucun' conserve le remplissage (les piliers de chaque côté de l'image pour NTSC, de tous les côtés pour PAL) pour émuler les mêmes barres noires générées en sortie vidéo analogique par du matériel PSX réel. 'Statique' supprime seulement le remplissage horizontal, 'Dynamique' supprime tout remplissage."
#define OPTION_VAL_DISABLED_O53_FR "Aucun"
#define OPTION_VAL_STATIC_FR "Statique"
#define OPTION_VAL_SMART_FR "Dynamique (par défaut)"
#define BEETLE_OPT_IMAGE_CROP_LABEL_FR "Recadrage supplémentaire"
#define BEETLE_OPT_IMAGE_CROP_INFO_0_FR "Lorsque le 'Recadrage du surbalayage horizontal' est activé, cette option réduit la largeur de l'image recadrée par le nombre spécifié de pixels."
#define OPTION_VAL_9PX_FR NULL
#define OPTION_VAL_10PX_FR NULL
#define OPTION_VAL_11PX_FR NULL
#define OPTION_VAL_12PX_FR NULL
#define OPTION_VAL_13PX_FR NULL
#define OPTION_VAL_14PX_FR NULL
#define OPTION_VAL_15PX_FR NULL
#define OPTION_VAL_16PX_FR NULL
#define OPTION_VAL_17PX_FR NULL
#define OPTION_VAL_18PX_FR NULL
#define OPTION_VAL_19PX_FR NULL
#define OPTION_VAL_20PX_FR NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_FR "Décalage de l'image recadrée"
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_FR "Lorsque le 'Recadrage du surbalayage horizontal' est activé, cela permet à l'image recadrée résultante d'être décalée horizontalement à droite (valeur positive) ou à gauche (valeur négative) par le nombre de pixels spécifié. Peut être utilisé pour corriger des problèmes d'alignement. Uniquement pris en charge par le moteur de rendu logiciel."
#define OPTION_VAL_12PX_O55_FR NULL
#define OPTION_VAL_11PX_O55_FR NULL
#define OPTION_VAL_10PX_O55_FR NULL
#define OPTION_VAL_9PX_O55_FR NULL
#define OPTION_VAL_8PX_O55_FR NULL
#define OPTION_VAL_7PX_O55_FR NULL
#define OPTION_VAL_6PX_O55_FR NULL
#define OPTION_VAL_5PX_O55_FR NULL
#define OPTION_VAL_4PX_O55_FR NULL
#define OPTION_VAL_3PX_O55_FR NULL
#define OPTION_VAL_2PX_O55_FR NULL
#define OPTION_VAL_1PX_O55_FR NULL
#define OPTION_VAL_DISABLED_O55_FR "0 (par défaut)"
#define OPTION_VAL_1PX_O55_0_FR NULL
#define OPTION_VAL_2PX_O55_0_FR NULL
#define OPTION_VAL_3PX_O55_0_FR NULL
#define OPTION_VAL_4PX_O55_0_FR NULL
#define OPTION_VAL_5PX_O55_0_FR NULL
#define OPTION_VAL_6PX_O55_0_FR NULL
#define OPTION_VAL_7PX_O55_0_FR NULL
#define OPTION_VAL_8PX_O55_0_FR NULL
#define OPTION_VAL_9PX_O55_0_FR NULL
#define OPTION_VAL_10PX_O55_0_FR NULL
#define OPTION_VAL_11PX_O55_0_FR NULL
#define OPTION_VAL_12PX_O55_0_FR NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_FR "Décalage horizontal de l'image (cycles du processeur graphique)"
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_FR "Sélectionner le nombre de cycles du processeur graphique par lesquels décaler l'image. Les valeurs positives déplacent l'image vers la droite, les valeurs négatives déplacent l'image vers la gauche. Uniquement pris en charge par les moteurs de rendu matériels."
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_FR "Overclocking du rastériseur processeur graphique"
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_FR "Active l'overclocking du rastériseur 2D contenu dans le processeur graphique de la PSX émulée. N'améliore pas le rendu 3D, et en général n'a que peu d'effet."
#define OPTION_VAL_32X_FR "x32"
#define BEETLE_OPT_ASPECT_RATIO_LABEL_FR "Rapport d'aspect du cœur"
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_FR "Sélectionner le rapport d'aspect fourni par le cœur. Ce réglage est ignoré lorsque les options Hack mode écran large ou Afficher la VRAM complète sont activées."
#define OPTION_VAL_CORRECTED_FR "Corrigé"
#define OPTION_VAL_UNCORRECTED_FR "Non corrigé"
#define OPTION_VAL_4_3_FR "Forcer 4:3"
#define OPTION_VAL_NTSC_FR "Forcer NTSC"
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_FR "Ligne de balayage initiale - NTSC"
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_FR "Sélectionner la première ligne de balayage affichée lors de l'exécution de contenu NTSC. Les valeurs supérieures à zéro réduiront la hauteur des images en sortie en recadrant les pixels à partir du bord le plus haut. Peut être utilisé pour contrecarrer l'effet de letterboxing."
#define BEETLE_OPT_LAST_SCANLINE_LABEL_FR "Dernière ligne de balayage - NTSC"
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_FR "Sélectionner la dernière ligne de balayage affichée lors de l'exécution de contenu NTSC. Les valeurs inférieures à 239 réduiront la hauteur des images en sortie en recadrant les pixels à partir du bord le plus bas. Peut être utilisé pour contrecarrer l'effet de letterboxing."
#define OPTION_VAL_239_FR "239 (par défaut)"
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_FR "Ligne de balayage initiale - PAL"
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_FR "Sélectionner la première ligne de balayage affichée lors de l'exécution de contenu PAL. Les valeurs supérieures à zéro réduiront la hauteur des images en sortie en recadrant les pixels à partir du bord le plus haut. Peut être utilisé pour contrecarrer l'effet de letterboxing."
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_FR "Dernière ligne de balayage - PAL"
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_FR "Sélectionner la dernière ligne de balayage affichée lors de l'exécution de contenu PAL. Les valeurs inférieures à 287 réduiront la hauteur des images en sortie en recadrant les pixels à partir du bord le plus bas. Peut être utilisé pour contrecarrer l'effet de letterboxing."
#define OPTION_VAL_287_FR "287 (par défaut)"
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_FR "Méthode d'accès au CD (Redémarrage requis)"
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_FR "Sélectionner la méthode utilisée pour lire les données à partir des images disque de contenu. 'Synchrone' imite le matériel original. 'Asynchrone' peut réduire les saccades sur les appareils avec un stockage lent. 'Pré-cachée' charge la totalité de l'image disque en mémoire lors du lancement de contenu, ce qui peut améliorer les temps de chargement en jeu au prix d'un délai initial au démarrage. 'Pré-cachée' peut causer des problèmes sur les systèmes avec peu de mémoire vive (RAM), et se repliera sur 'Synchrone' pour les médias physiques."
#define OPTION_VAL_SYNC_FR "Synchrone"
#define OPTION_VAL_ASYNC_FR "Asynchrone"
#define OPTION_VAL_PRECACHE_FR "Pré-cachée"
#define BEETLE_OPT_CD_FASTLOAD_LABEL_FR "Vitesse de chargement du CD"
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_FR "Sélectionner le multiplicateur de vitesse d'accès au disque. Les valeurs supérieures à 'x2 (native)' peuvent considérablement réduire le temps de chargement en jeu, mais peuvent introduire des erreurs de timing. Certains jeux peuvent ne pas fonctionner correctement au-dessus d'une certaine valeur."
#define OPTION_VAL_2X_NATIVE_FR "x2 (native)"
#define OPTION_VAL_6X_FR "x6"
#define OPTION_VAL_10X_FR "x10"
#define OPTION_VAL_12X_FR "x12"
#define OPTION_VAL_14X_FR "x14"

struct retro_core_option_v2_category option_cats_fr[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_FR,
      CATEGORY_VIDEO_INFO_0_FR
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_FR,
      CATEGORY_OSD_INFO_0_FR
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_FR,
      CATEGORY_INPUT_INFO_0_FR
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_FR,
      CATEGORY_MEMCARDS_INFO_0_FR
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_FR,
      CATEGORY_PGXP_INFO_0_FR
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_FR,
      CATEGORY_HACKS_INFO_0_FR
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_fr[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_FR,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_FR,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_FR },
         { "2x",         OPTION_VAL_2X_FR },
         { "4x",         OPTION_VAL_4X_FR },
         { "8x",         OPTION_VAL_8X_FR },
         { "16x",        OPTION_VAL_16X_FR },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_FR,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_FR,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_FR },
         { "32bpp",         OPTION_VAL_32BPP_FR },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_FR,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_FR,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_FR },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_FR },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_FR,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_FR,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_FR,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_FR,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_FR },
         { "SABR",     OPTION_VAL_SABR_FR },
         { "xBR",      OPTION_VAL_XBR_FR },
         { "bilinear", OPTION_VAL_BILINEAR_FR },
         { "3-point",  OPTION_VAL_3_POINT_FR },
         { "JINC2",    OPTION_VAL_JINC2_FR },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_FR,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_FR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_FR },
         { "all", OPTION_VAL_ALL_FR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_FR,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_FR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_FR },
         { "all", OPTION_VAL_ALL_FR },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_FR,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_FR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_FR,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_FR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_FR,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_FR,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_FR },
         { "2x",  OPTION_VAL_2X_FR },
         { "4x",  OPTION_VAL_4X_FR },
         { "8x",  OPTION_VAL_8X_FR },
         { "16x", OPTION_VAL_16X_FR },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_FR,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_FR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_FR,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_FR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_FR,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_FR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_FR,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_FR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_FR,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_FR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_FR,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_FR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_FR,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_FR,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_FR,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_FR,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_FR,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_FR,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_FR,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_FR,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_FR,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_FR,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_FR,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_FR,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_FR,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_FR,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_FR },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_FR },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_FR,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_FR,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_FR },
         { "dot",   OPTION_VAL_DOT_FR },
         { "off",   OPTION_VAL_OFF_FR },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_FR,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_FR,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_FR },
         { "blue", OPTION_VAL_BLUE_FR },
         { "green", OPTION_VAL_GREEN_FR },
         { "orange", OPTION_VAL_ORANGE_FR },
         { "yellow", OPTION_VAL_YELLOW_FR },
         { "cyan", OPTION_VAL_CYAN_FR },
         { "pink", OPTION_VAL_PINK_FR },
         { "purple", OPTION_VAL_PURPLE_FR },
         { "black", OPTION_VAL_BLACK_FR },
         { "white", OPTION_VAL_WHITE_FR },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_FR,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_FR,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_FR },
         { "red", OPTION_VAL_RED_FR },
         { "green", OPTION_VAL_GREEN_FR },
         { "orange", OPTION_VAL_ORANGE_FR },
         { "yellow", OPTION_VAL_YELLOW_FR },
         { "cyan", OPTION_VAL_CYAN_FR },
         { "pink", OPTION_VAL_PINK_FR },
         { "purple", OPTION_VAL_PURPLE_FR },
         { "black", OPTION_VAL_BLACK_FR },
         { "white", OPTION_VAL_WHITE_FR },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_FR,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_FR,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_FR },
         { "10%",  OPTION_VAL_10_FR },
         { "15%",  OPTION_VAL_15_FR },
         { "20%",  OPTION_VAL_20_FR },
         { "25%",  OPTION_VAL_25_FR },
         { "30%",  OPTION_VAL_30_FR },
         { "35%",  OPTION_VAL_35_FR },
         { "40%",  OPTION_VAL_40_FR },
         { "45%",  OPTION_VAL_45_FR },
         { "50%",  OPTION_VAL_50_FR },
         { "55%",  OPTION_VAL_55_FR },
         { "60%",  OPTION_VAL_60_FR },
         { "65%",  OPTION_VAL_65_FR },
         { "70%",  OPTION_VAL_70_FR },
         { "75%",  OPTION_VAL_75_FR },
         { "80%",  OPTION_VAL_80_FR },
         { "85%",  OPTION_VAL_85_FR },
         { "90%",  OPTION_VAL_90_FR },
         { "95%",  OPTION_VAL_95_FR },
         { "100%", OPTION_VAL_100_FR },
         { "105%", OPTION_VAL_105_FR },
         { "110%", OPTION_VAL_110_FR },
         { "115%", OPTION_VAL_115_FR },
         { "120%", OPTION_VAL_120_FR },
         { "125%", OPTION_VAL_125_FR },
         { "130%", OPTION_VAL_130_FR },
         { "135%", OPTION_VAL_135_FR },
         { "140%", OPTION_VAL_140_FR },
         { "145%", OPTION_VAL_145_FR },
         { "150%", OPTION_VAL_150_FR },
         { "155%", OPTION_VAL_155_FR },
         { "160%", OPTION_VAL_160_FR },
         { "165%", OPTION_VAL_165_FR },
         { "170%", OPTION_VAL_170_FR },
         { "175%", OPTION_VAL_175_FR },
         { "180%", OPTION_VAL_180_FR },
         { "185%", OPTION_VAL_185_FR },
         { "190%", OPTION_VAL_190_FR },
         { "195%", OPTION_VAL_195_FR },
         { "200%", OPTION_VAL_200_FR },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_FR,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_FR,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_FR },
         { "quadratic", OPTION_VAL_QUADRATIC_FR },
         { "cubic",     OPTION_VAL_CUBIC_FR },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_FR,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_FR,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_FR },
         { "5%",  OPTION_VAL_5_FR },
         { "10%", OPTION_VAL_10_FR },
         { "15%", OPTION_VAL_15_FR },
         { "20%", OPTION_VAL_20_FR },
         { "25%", OPTION_VAL_25_FR },
         { "30%", OPTION_VAL_30_FR },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_FR,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_FR,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_FR },
         { "mednafen", OPTION_VAL_MEDNAFEN_FR },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_FR,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_FR,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_FR,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_FR,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_FR,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_FR,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_FR,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_FR,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_FR },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_FR,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_FR,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_FR },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_FR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_FR,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_FR,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_FR },
         { "1px", OPTION_VAL_1PX_FR },
         { "2px", OPTION_VAL_2PX_FR },
         { "3px", OPTION_VAL_3PX_FR },
         { "4px", OPTION_VAL_4PX_FR },
         { "5px", OPTION_VAL_5PX_FR },
         { "6px", OPTION_VAL_6PX_FR },
         { "7px", OPTION_VAL_7PX_FR },
         { "8px", OPTION_VAL_8PX_FR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_FR,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_FR,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_FR,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_FR,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_FR,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_FR,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_FR,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_FR,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_FR },
         { "aggressive", OPTION_VAL_AGGRESSIVE_FR },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_FR,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_FR,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_FR,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_FR,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_FR },
         { "16:10", OPTION_VAL_16_10_FR },
         { "18:9",  OPTION_VAL_18_9_FR },
         { "19:9",  OPTION_VAL_19_9_FR },
         { "20:9",  OPTION_VAL_20_9_FR },
         { "21:9",  OPTION_VAL_21_9_FR }, // 64:27
         { "32:9",  OPTION_VAL_32_9_FR },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_FR,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_FR,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_FR },
         { "60%",           OPTION_VAL_60_FR },
         { "70%",           OPTION_VAL_70_FR },
         { "80%",           OPTION_VAL_80_FR },
         { "90%",           OPTION_VAL_90_FR },
         { "100%(native)", OPTION_VAL_100_NATIVE_FR },
         { "110%",          OPTION_VAL_110_FR },
         { "120%",          OPTION_VAL_120_FR },
         { "130%",          OPTION_VAL_130_FR },
         { "140%",          OPTION_VAL_140_FR },
         { "150%",          OPTION_VAL_150_FR },
         { "160%",          OPTION_VAL_160_FR },
         { "170%",          OPTION_VAL_170_FR },
         { "180%",          OPTION_VAL_180_FR },
         { "190%",          OPTION_VAL_190_FR },
         { "200%",          OPTION_VAL_200_FR },
         { "210%",          OPTION_VAL_210_FR },
         { "220%",          OPTION_VAL_220_FR },
         { "230%",          OPTION_VAL_230_FR },
         { "240%",          OPTION_VAL_240_FR },
         { "250%",          OPTION_VAL_250_FR },
         { "260%",          OPTION_VAL_260_FR },
         { "270%",          OPTION_VAL_270_FR },
         { "280%",          OPTION_VAL_280_FR },
         { "290%",          OPTION_VAL_290_FR },
         { "300%",          OPTION_VAL_300_FR },
         { "310%",          OPTION_VAL_310_FR },
         { "320%",          OPTION_VAL_320_FR },
         { "330%",          OPTION_VAL_330_FR },
         { "340%",          OPTION_VAL_340_FR },
         { "350%",          OPTION_VAL_350_FR },
         { "360%",          OPTION_VAL_360_FR },
         { "370%",          OPTION_VAL_370_FR },
         { "380%",          OPTION_VAL_380_FR },
         { "390%",          OPTION_VAL_390_FR },
         { "400%",          OPTION_VAL_400_FR },
         { "410%",          OPTION_VAL_410_FR },
         { "420%",          OPTION_VAL_420_FR },
         { "430%",          OPTION_VAL_430_FR },
         { "440%",          OPTION_VAL_440_FR },
         { "450%",          OPTION_VAL_450_FR },
         { "460%",          OPTION_VAL_460_FR },
         { "470%",          OPTION_VAL_470_FR },
         { "480%",          OPTION_VAL_480_FR },
         { "490%",          OPTION_VAL_490_FR },
         { "500%",          OPTION_VAL_500_FR },
         { "510%",          OPTION_VAL_510_FR },
         { "520%",          OPTION_VAL_520_FR },
         { "530%",          OPTION_VAL_530_FR },
         { "540%",          OPTION_VAL_540_FR },
         { "550%",          OPTION_VAL_550_FR },
         { "560%",          OPTION_VAL_560_FR },
         { "570%",          OPTION_VAL_570_FR },
         { "580%",          OPTION_VAL_580_FR },
         { "590%",          OPTION_VAL_590_FR },
         { "600%",          OPTION_VAL_600_FR },
         { "610%",          OPTION_VAL_610_FR },
         { "620%",          OPTION_VAL_620_FR },
         { "630%",          OPTION_VAL_630_FR },
         { "640%",          OPTION_VAL_640_FR },
         { "650%",          OPTION_VAL_650_FR },
         { "660%",          OPTION_VAL_660_FR },
         { "670%",          OPTION_VAL_670_FR },
         { "680%",          OPTION_VAL_680_FR },
         { "690%",          OPTION_VAL_690_FR },
         { "700%",          OPTION_VAL_700_FR },
         { "710%",          OPTION_VAL_710_FR },
         { "720%",          OPTION_VAL_720_FR },
         { "730%",          OPTION_VAL_730_FR },
         { "740%",          OPTION_VAL_740_FR },
         { "750%",          OPTION_VAL_750_FR },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_FR,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_FR,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_FR,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_FR,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_FR,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_FR,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_FR },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_FR },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_FR,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_FR,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_FR },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_FR },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_FR },
#endif
         { "software",    OPTION_VAL_SOFTWARE_FR },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_FR,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_FR,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_FR,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_FR,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_FR },
         { "execute",  OPTION_VAL_EXECUTE_FR },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_FR },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_FR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_FR,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_FR,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_FR },
         { "dma",  OPTION_VAL_DMA_FR },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_FR,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_FR,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_FR,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_FR,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_FR },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_FR },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_FR },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_FR,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_FR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_FR,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_FR,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_FR },
         { "static",  OPTION_VAL_STATIC_FR },
         { "smart", OPTION_VAL_SMART_FR },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_FR,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_FR,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_FR },
         { "2px",      OPTION_VAL_2PX_FR },
         { "3px",      OPTION_VAL_3PX_FR },
         { "4px",      OPTION_VAL_4PX_FR },
         { "5px",      OPTION_VAL_5PX_FR },
         { "6px",      OPTION_VAL_6PX_FR },
         { "7px",      OPTION_VAL_7PX_FR },
         { "8px",      OPTION_VAL_8PX_FR },
         { "9px",      OPTION_VAL_9PX_FR },
         { "10px",     OPTION_VAL_10PX_FR },
         { "11px",     OPTION_VAL_11PX_FR },
         { "12px",     OPTION_VAL_12PX_FR },
         { "13px",     OPTION_VAL_13PX_FR },
         { "14px",     OPTION_VAL_14PX_FR },
         { "15px",     OPTION_VAL_15PX_FR },
         { "16px",     OPTION_VAL_16PX_FR },
         { "17px",     OPTION_VAL_17PX_FR },
         { "18px",     OPTION_VAL_18PX_FR },
         { "19px",     OPTION_VAL_19PX_FR },
         { "20px",     OPTION_VAL_20PX_FR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_FR,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_FR,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_FR },
         { "-11px",    OPTION_VAL_11PX_O55_FR },
         { "-10px",    OPTION_VAL_10PX_O55_FR },
         { "-9px",     OPTION_VAL_9PX_O55_FR },
         { "-8px",     OPTION_VAL_8PX_O55_FR },
         { "-7px",     OPTION_VAL_7PX_O55_FR },
         { "-6px",     OPTION_VAL_6PX_O55_FR },
         { "-5px",     OPTION_VAL_5PX_O55_FR },
         { "-4px",     OPTION_VAL_4PX_O55_FR },
         { "-3px",     OPTION_VAL_3PX_O55_FR },
         { "-2px",     OPTION_VAL_2PX_O55_FR },
         { "-1px",     OPTION_VAL_1PX_O55_FR },
         { "disabled", OPTION_VAL_DISABLED_O55_FR },
         { "+1px",     OPTION_VAL_1PX_O55_0_FR },
         { "+2px",     OPTION_VAL_2PX_O55_0_FR },
         { "+3px",     OPTION_VAL_3PX_O55_0_FR },
         { "+4px",     OPTION_VAL_4PX_O55_0_FR },
         { "+5px",     OPTION_VAL_5PX_O55_0_FR },
         { "+6px",     OPTION_VAL_6PX_O55_0_FR },
         { "+7px",     OPTION_VAL_7PX_O55_0_FR },
         { "+8px",     OPTION_VAL_8PX_O55_0_FR },
         { "+9px",     OPTION_VAL_9PX_O55_0_FR },
         { "+10px",    OPTION_VAL_10PX_O55_0_FR },
         { "+11px",    OPTION_VAL_11PX_O55_0_FR },
         { "+12px",    OPTION_VAL_12PX_O55_0_FR },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_FR,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_FR,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_FR },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_FR,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_FR,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_FR },
         { "2x",         OPTION_VAL_2X_FR },
         { "4x",         OPTION_VAL_4X_FR },
         { "8x",         OPTION_VAL_8X_FR },
         { "16x",        OPTION_VAL_16X_FR },
         { "32x",        OPTION_VAL_32X_FR },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_FR,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_FR,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_FR },
         { "uncorrected", OPTION_VAL_UNCORRECTED_FR },
         { "4:3",  OPTION_VAL_4_3_FR },
         { "ntsc", OPTION_VAL_NTSC_FR },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_FR,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_FR,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_FR,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_FR,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_FR },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_FR,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_FR,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_FR,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_FR,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_FR },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_FR,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_FR,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_FR },
         { "async",    OPTION_VAL_ASYNC_FR },
         { "precache", OPTION_VAL_PRECACHE_FR },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_FR,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_FR,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_FR },
         { "4x",          OPTION_VAL_4X_FR },
         { "6x",          OPTION_VAL_6X_FR },
         { "8x",          OPTION_VAL_8X_FR },
         { "10x",         OPTION_VAL_10X_FR },
         { "12x",         OPTION_VAL_12X_FR },
         { "14x",         OPTION_VAL_14X_FR },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_fr = {
   option_cats_fr,
   option_defs_fr
};

/* RETRO_LANGUAGE_GL */

#define CATEGORY_VIDEO_LABEL_GL "Vídeo"
#define CATEGORY_VIDEO_INFO_0_GL NULL
#define CATEGORY_OSD_LABEL_GL "Notificacións en pantalla"
#define CATEGORY_OSD_INFO_0_GL NULL
#define CATEGORY_INPUT_LABEL_GL "Entrada"
#define CATEGORY_INPUT_INFO_0_GL NULL
#define CATEGORY_MEMCARDS_LABEL_GL "Tarxeta de memoria"
#define CATEGORY_MEMCARDS_INFO_0_GL NULL
#define CATEGORY_PGXP_LABEL_GL NULL
#define CATEGORY_PGXP_INFO_0_GL "Estas opcións controlan qué parámetros poden millorar os gráficos comparados coa consola orixinal PGXP pode desbotar texturas deformadas e problemas co eixe Z nos xogos de loita."
#define CATEGORY_HACKS_LABEL_GL "Hacks de emulación"
#define CATEGORY_HACKS_INFO_0_GL NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_GL "Resolución interna da GPU"
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_GL NULL
#define OPTION_VAL_1X_NATIVE_GL "1x (Nativo)"
#define OPTION_VAL_2X_GL NULL
#define OPTION_VAL_4X_GL NULL
#define OPTION_VAL_8X_GL NULL
#define OPTION_VAL_16X_GL NULL
#define BEETLE_OPT_DEPTH_LABEL_GL "Profundidade de Cor Interna"
#define BEETLE_OPT_DEPTH_INFO_0_GL NULL
#define OPTION_VAL_16BPP_NATIVE_GL "16 bpp (Nativo)"
#define OPTION_VAL_32BPP_GL NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_GL "Patrón Dithering"
#define BEETLE_OPT_DITHER_MODE_INFO_0_GL NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_GL "Resolución interna"
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_GL "Desprazamento UV da textura"
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_GL NULL
#define BEETLE_OPT_FILTER_LABEL_GL "Filtrado de Texturas"
#define BEETLE_OPT_FILTER_INFO_0_GL NULL
#define OPTION_VAL_NEAREST_GL NULL
#define OPTION_VAL_SABR_GL NULL
#define OPTION_VAL_XBR_GL NULL
#define OPTION_VAL_BILINEAR_GL NULL
#define OPTION_VAL_3_POINT_GL "3-puntos"
#define OPTION_VAL_JINC2_GL NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_GL "Exclúe os sprites do filtrado"
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_GL NULL
#define OPTION_VAL_OPAQUE_GL "Opaco únicamente"
#define OPTION_VAL_ALL_GL "Opaco e semi-transparente"
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_GL "Exclúe os polígonos 2D do filtrado"
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_GL "Non aplica o filtrado de texturas ós polígonos 2D. Os polígonos 2D son detectados cunha heurística e pode haber erros gráficos. Usar esta opción xunto co Suavizado Adaptativo ou con outro filtro de post-procesado para un millor efecto."
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_GL "Suavizado Adaptativo"
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_GL NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_GL "Supermostreo (redución da mostra á resolución nativa)"
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_GL NULL
#define BEETLE_OPT_MSAA_LABEL_GL NULL
#define BEETLE_OPT_MSAA_INFO_0_GL NULL
#define OPTION_VAL_1X_GL NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_GL "Filtro cromático MDEC YUV"
#define BEETLE_OPT_MDEC_YUV_INFO_0_GL NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_GL NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_GL NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_GL "Texturas de volcado"
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_GL NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_GL NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_GL NULL
#define BEETLE_OPT_WIREFRAME_LABEL_GL NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_GL NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_GL NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_GL NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_GL NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_GL NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_GL NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_GL NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_GL NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_GL NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_GL NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_GL NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_GL NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_GL NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_GL NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_GL NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_GL NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_GL NULL
#define OPTION_VAL_LIGHTGUN_GL NULL
#define OPTION_VAL_TOUCHSCREEN_GL NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_GL NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_GL NULL
#define OPTION_VAL_CROSS_GL NULL
#define OPTION_VAL_DOT_GL NULL
#define OPTION_VAL_OFF_GL NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_GL NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_GL NULL
#define OPTION_VAL_RED_GL "Vermello"
#define OPTION_VAL_BLUE_GL "Azul"
#define OPTION_VAL_GREEN_GL "Verde"
#define OPTION_VAL_ORANGE_GL "Laranxa"
#define OPTION_VAL_YELLOW_GL "Amarelo"
#define OPTION_VAL_CYAN_GL "Azul ceo"
#define OPTION_VAL_PINK_GL NULL
#define OPTION_VAL_PURPLE_GL "Malva"
#define OPTION_VAL_BLACK_GL "Negro"
#define OPTION_VAL_WHITE_GL "Branco"
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_GL NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_GL NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_GL NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_GL NULL
#define OPTION_VAL_5_GL NULL
#define OPTION_VAL_10_GL NULL
#define OPTION_VAL_15_GL NULL
#define OPTION_VAL_20_GL NULL
#define OPTION_VAL_25_GL NULL
#define OPTION_VAL_30_GL NULL
#define OPTION_VAL_35_GL NULL
#define OPTION_VAL_40_GL NULL
#define OPTION_VAL_45_GL NULL
#define OPTION_VAL_50_GL NULL
#define OPTION_VAL_55_GL NULL
#define OPTION_VAL_60_GL NULL
#define OPTION_VAL_65_GL NULL
#define OPTION_VAL_70_GL NULL
#define OPTION_VAL_75_GL NULL
#define OPTION_VAL_80_GL NULL
#define OPTION_VAL_85_GL NULL
#define OPTION_VAL_90_GL NULL
#define OPTION_VAL_95_GL NULL
#define OPTION_VAL_100_GL NULL
#define OPTION_VAL_105_GL NULL
#define OPTION_VAL_110_GL NULL
#define OPTION_VAL_115_GL NULL
#define OPTION_VAL_120_GL NULL
#define OPTION_VAL_125_GL NULL
#define OPTION_VAL_130_GL NULL
#define OPTION_VAL_135_GL NULL
#define OPTION_VAL_140_GL NULL
#define OPTION_VAL_145_GL NULL
#define OPTION_VAL_150_GL NULL
#define OPTION_VAL_155_GL NULL
#define OPTION_VAL_160_GL NULL
#define OPTION_VAL_165_GL NULL
#define OPTION_VAL_170_GL NULL
#define OPTION_VAL_175_GL NULL
#define OPTION_VAL_180_GL NULL
#define OPTION_VAL_185_GL NULL
#define OPTION_VAL_190_GL NULL
#define OPTION_VAL_195_GL NULL
#define OPTION_VAL_200_GL NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_GL NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_GL NULL
#define OPTION_VAL_LINEAR_GL NULL
#define OPTION_VAL_QUADRATIC_GL NULL
#define OPTION_VAL_CUBIC_GL NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_GL NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_GL NULL
#define OPTION_VAL_0_GL NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_GL NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_GL NULL
#define OPTION_VAL_LIBRETRO_GL NULL
#define OPTION_VAL_MEDNAFEN_GL NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_GL NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_GL NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_GL NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_GL NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_GL NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_GL NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_GL NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_GL NULL
#define OPTION_VAL_1_GL NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_GL NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_GL NULL
#define OPTION_VAL_MEMORY_ONLY_GL NULL
#define OPTION_VAL_MEMORY_CPU_GL NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_GL NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_GL NULL
#define OPTION_VAL_0PX_GL NULL
#define OPTION_VAL_1PX_GL NULL
#define OPTION_VAL_2PX_GL NULL
#define OPTION_VAL_3PX_GL NULL
#define OPTION_VAL_4PX_GL NULL
#define OPTION_VAL_5PX_GL NULL
#define OPTION_VAL_6PX_GL NULL
#define OPTION_VAL_7PX_GL NULL
#define OPTION_VAL_8PX_GL NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_GL NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_GL NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_GL NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_GL NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_GL NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_GL NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_GL NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_GL NULL
#define OPTION_VAL_DEFAULT_GL NULL
#define OPTION_VAL_AGGRESSIVE_GL NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_GL NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_GL NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_GL NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_GL NULL
#define OPTION_VAL_16_9_GL NULL
#define OPTION_VAL_16_10_GL NULL
#define OPTION_VAL_18_9_GL NULL
#define OPTION_VAL_19_9_GL NULL
#define OPTION_VAL_20_9_GL NULL
#define OPTION_VAL_21_9_GL NULL
#define OPTION_VAL_32_9_GL NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_GL NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_GL NULL
#define OPTION_VAL_100_NATIVE_GL NULL
#define OPTION_VAL_210_GL NULL
#define OPTION_VAL_220_GL NULL
#define OPTION_VAL_230_GL NULL
#define OPTION_VAL_240_GL NULL
#define OPTION_VAL_250_GL NULL
#define OPTION_VAL_260_GL NULL
#define OPTION_VAL_270_GL NULL
#define OPTION_VAL_280_GL NULL
#define OPTION_VAL_290_GL NULL
#define OPTION_VAL_300_GL NULL
#define OPTION_VAL_310_GL NULL
#define OPTION_VAL_320_GL NULL
#define OPTION_VAL_330_GL NULL
#define OPTION_VAL_340_GL NULL
#define OPTION_VAL_350_GL NULL
#define OPTION_VAL_360_GL NULL
#define OPTION_VAL_370_GL NULL
#define OPTION_VAL_380_GL NULL
#define OPTION_VAL_390_GL NULL
#define OPTION_VAL_400_GL NULL
#define OPTION_VAL_410_GL NULL
#define OPTION_VAL_420_GL NULL
#define OPTION_VAL_430_GL NULL
#define OPTION_VAL_440_GL NULL
#define OPTION_VAL_450_GL NULL
#define OPTION_VAL_460_GL NULL
#define OPTION_VAL_470_GL NULL
#define OPTION_VAL_480_GL NULL
#define OPTION_VAL_490_GL NULL
#define OPTION_VAL_500_GL NULL
#define OPTION_VAL_510_GL NULL
#define OPTION_VAL_520_GL NULL
#define OPTION_VAL_530_GL NULL
#define OPTION_VAL_540_GL NULL
#define OPTION_VAL_550_GL NULL
#define OPTION_VAL_560_GL NULL
#define OPTION_VAL_570_GL NULL
#define OPTION_VAL_580_GL NULL
#define OPTION_VAL_590_GL NULL
#define OPTION_VAL_600_GL NULL
#define OPTION_VAL_610_GL NULL
#define OPTION_VAL_620_GL NULL
#define OPTION_VAL_630_GL NULL
#define OPTION_VAL_640_GL NULL
#define OPTION_VAL_650_GL NULL
#define OPTION_VAL_660_GL NULL
#define OPTION_VAL_670_GL NULL
#define OPTION_VAL_680_GL NULL
#define OPTION_VAL_690_GL NULL
#define OPTION_VAL_700_GL NULL
#define OPTION_VAL_710_GL NULL
#define OPTION_VAL_720_GL NULL
#define OPTION_VAL_730_GL NULL
#define OPTION_VAL_740_GL NULL
#define OPTION_VAL_750_GL NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_GL NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_GL NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_GL NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_GL NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_GL NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_GL NULL
#define OPTION_VAL_PSXONPSP_GL NULL
#define OPTION_VAL_PS1_ROM_GL NULL
#define BEETLE_OPT_RENDERER_LABEL_GL NULL
#define BEETLE_OPT_RENDERER_INFO_0_GL NULL
#define OPTION_VAL_HARDWARE_GL NULL
#define OPTION_VAL_HARDWARE_GL_GL NULL
#define OPTION_VAL_HARDWARE_VK_GL NULL
#define OPTION_VAL_SOFTWARE_GL NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_GL NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_GL NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_GL NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_GL NULL
#define OPTION_VAL_DISABLED_GL NULL
#define OPTION_VAL_EXECUTE_GL NULL
#define OPTION_VAL_EXECUTE_ONE_GL NULL
#define OPTION_VAL_RUN_INTERPRETER_GL NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_GL NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_GL NULL
#define OPTION_VAL_FULL_GL NULL
#define OPTION_VAL_DMA_GL NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_GL NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_GL NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_GL NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_GL NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_GL NULL
#define OPTION_VAL_FORCE_INTERLACED_GL NULL
#define OPTION_VAL_AUTO_TOGGLE_GL NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_GL NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_GL NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_GL NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_GL NULL
#define OPTION_VAL_DISABLED_O53_GL "Ningún"
#define OPTION_VAL_STATIC_GL NULL
#define OPTION_VAL_SMART_GL NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_GL NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_GL NULL
#define OPTION_VAL_9PX_GL NULL
#define OPTION_VAL_10PX_GL NULL
#define OPTION_VAL_11PX_GL NULL
#define OPTION_VAL_12PX_GL NULL
#define OPTION_VAL_13PX_GL NULL
#define OPTION_VAL_14PX_GL NULL
#define OPTION_VAL_15PX_GL NULL
#define OPTION_VAL_16PX_GL NULL
#define OPTION_VAL_17PX_GL NULL
#define OPTION_VAL_18PX_GL NULL
#define OPTION_VAL_19PX_GL NULL
#define OPTION_VAL_20PX_GL NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_GL NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_GL NULL
#define OPTION_VAL_12PX_O55_GL NULL
#define OPTION_VAL_11PX_O55_GL NULL
#define OPTION_VAL_10PX_O55_GL NULL
#define OPTION_VAL_9PX_O55_GL NULL
#define OPTION_VAL_8PX_O55_GL NULL
#define OPTION_VAL_7PX_O55_GL NULL
#define OPTION_VAL_6PX_O55_GL NULL
#define OPTION_VAL_5PX_O55_GL NULL
#define OPTION_VAL_4PX_O55_GL NULL
#define OPTION_VAL_3PX_O55_GL NULL
#define OPTION_VAL_2PX_O55_GL NULL
#define OPTION_VAL_1PX_O55_GL NULL
#define OPTION_VAL_DISABLED_O55_GL NULL
#define OPTION_VAL_1PX_O55_0_GL NULL
#define OPTION_VAL_2PX_O55_0_GL NULL
#define OPTION_VAL_3PX_O55_0_GL NULL
#define OPTION_VAL_4PX_O55_0_GL NULL
#define OPTION_VAL_5PX_O55_0_GL NULL
#define OPTION_VAL_6PX_O55_0_GL NULL
#define OPTION_VAL_7PX_O55_0_GL NULL
#define OPTION_VAL_8PX_O55_0_GL NULL
#define OPTION_VAL_9PX_O55_0_GL NULL
#define OPTION_VAL_10PX_O55_0_GL NULL
#define OPTION_VAL_11PX_O55_0_GL NULL
#define OPTION_VAL_12PX_O55_0_GL NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_GL NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_GL NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_GL NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_GL NULL
#define OPTION_VAL_32X_GL NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_GL NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_GL NULL
#define OPTION_VAL_CORRECTED_GL NULL
#define OPTION_VAL_UNCORRECTED_GL NULL
#define OPTION_VAL_4_3_GL NULL
#define OPTION_VAL_NTSC_GL NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_GL NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_GL NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_GL NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_GL NULL
#define OPTION_VAL_239_GL NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_GL NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_GL NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_GL NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_GL NULL
#define OPTION_VAL_287_GL NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_GL NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_GL NULL
#define OPTION_VAL_SYNC_GL NULL
#define OPTION_VAL_ASYNC_GL NULL
#define OPTION_VAL_PRECACHE_GL NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_GL NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_GL NULL
#define OPTION_VAL_2X_NATIVE_GL NULL
#define OPTION_VAL_6X_GL NULL
#define OPTION_VAL_10X_GL NULL
#define OPTION_VAL_12X_GL NULL
#define OPTION_VAL_14X_GL NULL

struct retro_core_option_v2_category option_cats_gl[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_GL,
      CATEGORY_VIDEO_INFO_0_GL
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_GL,
      CATEGORY_OSD_INFO_0_GL
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_GL,
      CATEGORY_INPUT_INFO_0_GL
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_GL,
      CATEGORY_MEMCARDS_INFO_0_GL
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_GL,
      CATEGORY_PGXP_INFO_0_GL
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_GL,
      CATEGORY_HACKS_INFO_0_GL
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_gl[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_GL,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_GL,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_GL },
         { "2x",         OPTION_VAL_2X_GL },
         { "4x",         OPTION_VAL_4X_GL },
         { "8x",         OPTION_VAL_8X_GL },
         { "16x",        OPTION_VAL_16X_GL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_GL,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_GL,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_GL },
         { "32bpp",         OPTION_VAL_32BPP_GL },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_GL,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_GL,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_GL },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_GL },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_GL,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_GL,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_GL,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_GL,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_GL },
         { "SABR",     OPTION_VAL_SABR_GL },
         { "xBR",      OPTION_VAL_XBR_GL },
         { "bilinear", OPTION_VAL_BILINEAR_GL },
         { "3-point",  OPTION_VAL_3_POINT_GL },
         { "JINC2",    OPTION_VAL_JINC2_GL },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_GL,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_GL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_GL },
         { "all", OPTION_VAL_ALL_GL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_GL,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_GL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_GL },
         { "all", OPTION_VAL_ALL_GL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_GL,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_GL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_GL,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_GL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_GL,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_GL,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_GL },
         { "2x",  OPTION_VAL_2X_GL },
         { "4x",  OPTION_VAL_4X_GL },
         { "8x",  OPTION_VAL_8X_GL },
         { "16x", OPTION_VAL_16X_GL },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_GL,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_GL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_GL,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_GL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_GL,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_GL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_GL,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_GL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_GL,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_GL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_GL,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_GL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_GL,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_GL,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_GL,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_GL,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_GL,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_GL,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_GL,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_GL,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_GL,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_GL,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_GL,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_GL,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_GL,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_GL,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_GL },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_GL },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_GL,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_GL,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_GL },
         { "dot",   OPTION_VAL_DOT_GL },
         { "off",   OPTION_VAL_OFF_GL },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_GL,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_GL,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_GL },
         { "blue", OPTION_VAL_BLUE_GL },
         { "green", OPTION_VAL_GREEN_GL },
         { "orange", OPTION_VAL_ORANGE_GL },
         { "yellow", OPTION_VAL_YELLOW_GL },
         { "cyan", OPTION_VAL_CYAN_GL },
         { "pink", OPTION_VAL_PINK_GL },
         { "purple", OPTION_VAL_PURPLE_GL },
         { "black", OPTION_VAL_BLACK_GL },
         { "white", OPTION_VAL_WHITE_GL },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_GL,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_GL,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_GL },
         { "red", OPTION_VAL_RED_GL },
         { "green", OPTION_VAL_GREEN_GL },
         { "orange", OPTION_VAL_ORANGE_GL },
         { "yellow", OPTION_VAL_YELLOW_GL },
         { "cyan", OPTION_VAL_CYAN_GL },
         { "pink", OPTION_VAL_PINK_GL },
         { "purple", OPTION_VAL_PURPLE_GL },
         { "black", OPTION_VAL_BLACK_GL },
         { "white", OPTION_VAL_WHITE_GL },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_GL,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_GL,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_GL },
         { "10%",  OPTION_VAL_10_GL },
         { "15%",  OPTION_VAL_15_GL },
         { "20%",  OPTION_VAL_20_GL },
         { "25%",  OPTION_VAL_25_GL },
         { "30%",  OPTION_VAL_30_GL },
         { "35%",  OPTION_VAL_35_GL },
         { "40%",  OPTION_VAL_40_GL },
         { "45%",  OPTION_VAL_45_GL },
         { "50%",  OPTION_VAL_50_GL },
         { "55%",  OPTION_VAL_55_GL },
         { "60%",  OPTION_VAL_60_GL },
         { "65%",  OPTION_VAL_65_GL },
         { "70%",  OPTION_VAL_70_GL },
         { "75%",  OPTION_VAL_75_GL },
         { "80%",  OPTION_VAL_80_GL },
         { "85%",  OPTION_VAL_85_GL },
         { "90%",  OPTION_VAL_90_GL },
         { "95%",  OPTION_VAL_95_GL },
         { "100%", OPTION_VAL_100_GL },
         { "105%", OPTION_VAL_105_GL },
         { "110%", OPTION_VAL_110_GL },
         { "115%", OPTION_VAL_115_GL },
         { "120%", OPTION_VAL_120_GL },
         { "125%", OPTION_VAL_125_GL },
         { "130%", OPTION_VAL_130_GL },
         { "135%", OPTION_VAL_135_GL },
         { "140%", OPTION_VAL_140_GL },
         { "145%", OPTION_VAL_145_GL },
         { "150%", OPTION_VAL_150_GL },
         { "155%", OPTION_VAL_155_GL },
         { "160%", OPTION_VAL_160_GL },
         { "165%", OPTION_VAL_165_GL },
         { "170%", OPTION_VAL_170_GL },
         { "175%", OPTION_VAL_175_GL },
         { "180%", OPTION_VAL_180_GL },
         { "185%", OPTION_VAL_185_GL },
         { "190%", OPTION_VAL_190_GL },
         { "195%", OPTION_VAL_195_GL },
         { "200%", OPTION_VAL_200_GL },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_GL,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_GL,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_GL },
         { "quadratic", OPTION_VAL_QUADRATIC_GL },
         { "cubic",     OPTION_VAL_CUBIC_GL },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_GL,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_GL,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_GL },
         { "5%",  OPTION_VAL_5_GL },
         { "10%", OPTION_VAL_10_GL },
         { "15%", OPTION_VAL_15_GL },
         { "20%", OPTION_VAL_20_GL },
         { "25%", OPTION_VAL_25_GL },
         { "30%", OPTION_VAL_30_GL },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_GL,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_GL,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_GL },
         { "mednafen", OPTION_VAL_MEDNAFEN_GL },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_GL,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_GL,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_GL,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_GL,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_GL,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_GL,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_GL,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_GL,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_GL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_GL,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_GL,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_GL },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_GL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_GL,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_GL,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_GL },
         { "1px", OPTION_VAL_1PX_GL },
         { "2px", OPTION_VAL_2PX_GL },
         { "3px", OPTION_VAL_3PX_GL },
         { "4px", OPTION_VAL_4PX_GL },
         { "5px", OPTION_VAL_5PX_GL },
         { "6px", OPTION_VAL_6PX_GL },
         { "7px", OPTION_VAL_7PX_GL },
         { "8px", OPTION_VAL_8PX_GL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_GL,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_GL,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_GL,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_GL,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_GL,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_GL,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_GL,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_GL,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_GL },
         { "aggressive", OPTION_VAL_AGGRESSIVE_GL },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_GL,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_GL,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_GL,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_GL,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_GL },
         { "16:10", OPTION_VAL_16_10_GL },
         { "18:9",  OPTION_VAL_18_9_GL },
         { "19:9",  OPTION_VAL_19_9_GL },
         { "20:9",  OPTION_VAL_20_9_GL },
         { "21:9",  OPTION_VAL_21_9_GL }, // 64:27
         { "32:9",  OPTION_VAL_32_9_GL },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_GL,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_GL,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_GL },
         { "60%",           OPTION_VAL_60_GL },
         { "70%",           OPTION_VAL_70_GL },
         { "80%",           OPTION_VAL_80_GL },
         { "90%",           OPTION_VAL_90_GL },
         { "100%(native)", OPTION_VAL_100_NATIVE_GL },
         { "110%",          OPTION_VAL_110_GL },
         { "120%",          OPTION_VAL_120_GL },
         { "130%",          OPTION_VAL_130_GL },
         { "140%",          OPTION_VAL_140_GL },
         { "150%",          OPTION_VAL_150_GL },
         { "160%",          OPTION_VAL_160_GL },
         { "170%",          OPTION_VAL_170_GL },
         { "180%",          OPTION_VAL_180_GL },
         { "190%",          OPTION_VAL_190_GL },
         { "200%",          OPTION_VAL_200_GL },
         { "210%",          OPTION_VAL_210_GL },
         { "220%",          OPTION_VAL_220_GL },
         { "230%",          OPTION_VAL_230_GL },
         { "240%",          OPTION_VAL_240_GL },
         { "250%",          OPTION_VAL_250_GL },
         { "260%",          OPTION_VAL_260_GL },
         { "270%",          OPTION_VAL_270_GL },
         { "280%",          OPTION_VAL_280_GL },
         { "290%",          OPTION_VAL_290_GL },
         { "300%",          OPTION_VAL_300_GL },
         { "310%",          OPTION_VAL_310_GL },
         { "320%",          OPTION_VAL_320_GL },
         { "330%",          OPTION_VAL_330_GL },
         { "340%",          OPTION_VAL_340_GL },
         { "350%",          OPTION_VAL_350_GL },
         { "360%",          OPTION_VAL_360_GL },
         { "370%",          OPTION_VAL_370_GL },
         { "380%",          OPTION_VAL_380_GL },
         { "390%",          OPTION_VAL_390_GL },
         { "400%",          OPTION_VAL_400_GL },
         { "410%",          OPTION_VAL_410_GL },
         { "420%",          OPTION_VAL_420_GL },
         { "430%",          OPTION_VAL_430_GL },
         { "440%",          OPTION_VAL_440_GL },
         { "450%",          OPTION_VAL_450_GL },
         { "460%",          OPTION_VAL_460_GL },
         { "470%",          OPTION_VAL_470_GL },
         { "480%",          OPTION_VAL_480_GL },
         { "490%",          OPTION_VAL_490_GL },
         { "500%",          OPTION_VAL_500_GL },
         { "510%",          OPTION_VAL_510_GL },
         { "520%",          OPTION_VAL_520_GL },
         { "530%",          OPTION_VAL_530_GL },
         { "540%",          OPTION_VAL_540_GL },
         { "550%",          OPTION_VAL_550_GL },
         { "560%",          OPTION_VAL_560_GL },
         { "570%",          OPTION_VAL_570_GL },
         { "580%",          OPTION_VAL_580_GL },
         { "590%",          OPTION_VAL_590_GL },
         { "600%",          OPTION_VAL_600_GL },
         { "610%",          OPTION_VAL_610_GL },
         { "620%",          OPTION_VAL_620_GL },
         { "630%",          OPTION_VAL_630_GL },
         { "640%",          OPTION_VAL_640_GL },
         { "650%",          OPTION_VAL_650_GL },
         { "660%",          OPTION_VAL_660_GL },
         { "670%",          OPTION_VAL_670_GL },
         { "680%",          OPTION_VAL_680_GL },
         { "690%",          OPTION_VAL_690_GL },
         { "700%",          OPTION_VAL_700_GL },
         { "710%",          OPTION_VAL_710_GL },
         { "720%",          OPTION_VAL_720_GL },
         { "730%",          OPTION_VAL_730_GL },
         { "740%",          OPTION_VAL_740_GL },
         { "750%",          OPTION_VAL_750_GL },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_GL,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_GL,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_GL,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_GL,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_GL,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_GL,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_GL },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_GL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_GL,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_GL,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_GL },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_GL },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_GL },
#endif
         { "software",    OPTION_VAL_SOFTWARE_GL },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_GL,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_GL,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_GL,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_GL,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_GL },
         { "execute",  OPTION_VAL_EXECUTE_GL },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_GL },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_GL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_GL,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_GL,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_GL },
         { "dma",  OPTION_VAL_DMA_GL },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_GL,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_GL,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_GL,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_GL,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_GL },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_GL },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_GL },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_GL,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_GL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_GL,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_GL,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_GL },
         { "static",  OPTION_VAL_STATIC_GL },
         { "smart", OPTION_VAL_SMART_GL },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_GL,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_GL,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_GL },
         { "2px",      OPTION_VAL_2PX_GL },
         { "3px",      OPTION_VAL_3PX_GL },
         { "4px",      OPTION_VAL_4PX_GL },
         { "5px",      OPTION_VAL_5PX_GL },
         { "6px",      OPTION_VAL_6PX_GL },
         { "7px",      OPTION_VAL_7PX_GL },
         { "8px",      OPTION_VAL_8PX_GL },
         { "9px",      OPTION_VAL_9PX_GL },
         { "10px",     OPTION_VAL_10PX_GL },
         { "11px",     OPTION_VAL_11PX_GL },
         { "12px",     OPTION_VAL_12PX_GL },
         { "13px",     OPTION_VAL_13PX_GL },
         { "14px",     OPTION_VAL_14PX_GL },
         { "15px",     OPTION_VAL_15PX_GL },
         { "16px",     OPTION_VAL_16PX_GL },
         { "17px",     OPTION_VAL_17PX_GL },
         { "18px",     OPTION_VAL_18PX_GL },
         { "19px",     OPTION_VAL_19PX_GL },
         { "20px",     OPTION_VAL_20PX_GL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_GL,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_GL,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_GL },
         { "-11px",    OPTION_VAL_11PX_O55_GL },
         { "-10px",    OPTION_VAL_10PX_O55_GL },
         { "-9px",     OPTION_VAL_9PX_O55_GL },
         { "-8px",     OPTION_VAL_8PX_O55_GL },
         { "-7px",     OPTION_VAL_7PX_O55_GL },
         { "-6px",     OPTION_VAL_6PX_O55_GL },
         { "-5px",     OPTION_VAL_5PX_O55_GL },
         { "-4px",     OPTION_VAL_4PX_O55_GL },
         { "-3px",     OPTION_VAL_3PX_O55_GL },
         { "-2px",     OPTION_VAL_2PX_O55_GL },
         { "-1px",     OPTION_VAL_1PX_O55_GL },
         { "disabled", OPTION_VAL_DISABLED_O55_GL },
         { "+1px",     OPTION_VAL_1PX_O55_0_GL },
         { "+2px",     OPTION_VAL_2PX_O55_0_GL },
         { "+3px",     OPTION_VAL_3PX_O55_0_GL },
         { "+4px",     OPTION_VAL_4PX_O55_0_GL },
         { "+5px",     OPTION_VAL_5PX_O55_0_GL },
         { "+6px",     OPTION_VAL_6PX_O55_0_GL },
         { "+7px",     OPTION_VAL_7PX_O55_0_GL },
         { "+8px",     OPTION_VAL_8PX_O55_0_GL },
         { "+9px",     OPTION_VAL_9PX_O55_0_GL },
         { "+10px",    OPTION_VAL_10PX_O55_0_GL },
         { "+11px",    OPTION_VAL_11PX_O55_0_GL },
         { "+12px",    OPTION_VAL_12PX_O55_0_GL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_GL,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_GL,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_GL },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_GL,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_GL,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_GL },
         { "2x",         OPTION_VAL_2X_GL },
         { "4x",         OPTION_VAL_4X_GL },
         { "8x",         OPTION_VAL_8X_GL },
         { "16x",        OPTION_VAL_16X_GL },
         { "32x",        OPTION_VAL_32X_GL },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_GL,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_GL,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_GL },
         { "uncorrected", OPTION_VAL_UNCORRECTED_GL },
         { "4:3",  OPTION_VAL_4_3_GL },
         { "ntsc", OPTION_VAL_NTSC_GL },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_GL,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_GL,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_GL,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_GL,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_GL },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_GL,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_GL,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_GL,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_GL,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_GL },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_GL,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_GL,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_GL },
         { "async",    OPTION_VAL_ASYNC_GL },
         { "precache", OPTION_VAL_PRECACHE_GL },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_GL,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_GL,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_GL },
         { "4x",          OPTION_VAL_4X_GL },
         { "6x",          OPTION_VAL_6X_GL },
         { "8x",          OPTION_VAL_8X_GL },
         { "10x",         OPTION_VAL_10X_GL },
         { "12x",         OPTION_VAL_12X_GL },
         { "14x",         OPTION_VAL_14X_GL },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_gl = {
   option_cats_gl,
   option_defs_gl
};

/* RETRO_LANGUAGE_HE */

#define CATEGORY_VIDEO_LABEL_HE "וידאו"
#define CATEGORY_VIDEO_INFO_0_HE NULL
#define CATEGORY_OSD_LABEL_HE NULL
#define CATEGORY_OSD_INFO_0_HE NULL
#define CATEGORY_INPUT_LABEL_HE "קלט"
#define CATEGORY_INPUT_INFO_0_HE NULL
#define CATEGORY_MEMCARDS_LABEL_HE NULL
#define CATEGORY_MEMCARDS_INFO_0_HE NULL
#define CATEGORY_PGXP_LABEL_HE NULL
#define CATEGORY_PGXP_INFO_0_HE NULL
#define CATEGORY_HACKS_LABEL_HE NULL
#define CATEGORY_HACKS_INFO_0_HE NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_HE NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_HE NULL
#define OPTION_VAL_1X_NATIVE_HE NULL
#define OPTION_VAL_2X_HE NULL
#define OPTION_VAL_4X_HE NULL
#define OPTION_VAL_8X_HE NULL
#define OPTION_VAL_16X_HE NULL
#define BEETLE_OPT_DEPTH_LABEL_HE NULL
#define BEETLE_OPT_DEPTH_INFO_0_HE NULL
#define OPTION_VAL_16BPP_NATIVE_HE NULL
#define OPTION_VAL_32BPP_HE NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_HE NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_HE NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_HE NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_HE NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_HE NULL
#define BEETLE_OPT_FILTER_LABEL_HE NULL
#define BEETLE_OPT_FILTER_INFO_0_HE NULL
#define OPTION_VAL_NEAREST_HE NULL
#define OPTION_VAL_SABR_HE NULL
#define OPTION_VAL_XBR_HE NULL
#define OPTION_VAL_BILINEAR_HE NULL
#define OPTION_VAL_3_POINT_HE NULL
#define OPTION_VAL_JINC2_HE NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_HE NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_HE NULL
#define OPTION_VAL_OPAQUE_HE NULL
#define OPTION_VAL_ALL_HE NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_HE NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_HE NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_HE NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_HE NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_HE NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_HE NULL
#define BEETLE_OPT_MSAA_LABEL_HE NULL
#define BEETLE_OPT_MSAA_INFO_0_HE NULL
#define OPTION_VAL_1X_HE NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_HE NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_HE NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_HE NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_HE NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_HE NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_HE NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_HE NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_HE NULL
#define BEETLE_OPT_WIREFRAME_LABEL_HE NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_HE NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_HE NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_HE NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_HE NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_HE NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_HE NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_HE NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_HE NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_HE NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_HE NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_HE NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_HE NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_HE NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_HE NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_HE NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_HE NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_HE NULL
#define OPTION_VAL_LIGHTGUN_HE NULL
#define OPTION_VAL_TOUCHSCREEN_HE NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_HE NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_HE NULL
#define OPTION_VAL_CROSS_HE NULL
#define OPTION_VAL_DOT_HE NULL
#define OPTION_VAL_OFF_HE NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_HE NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_HE NULL
#define OPTION_VAL_RED_HE NULL
#define OPTION_VAL_BLUE_HE NULL
#define OPTION_VAL_GREEN_HE NULL
#define OPTION_VAL_ORANGE_HE NULL
#define OPTION_VAL_YELLOW_HE NULL
#define OPTION_VAL_CYAN_HE NULL
#define OPTION_VAL_PINK_HE NULL
#define OPTION_VAL_PURPLE_HE NULL
#define OPTION_VAL_BLACK_HE NULL
#define OPTION_VAL_WHITE_HE NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_HE NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_HE NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_HE NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_HE NULL
#define OPTION_VAL_5_HE NULL
#define OPTION_VAL_10_HE NULL
#define OPTION_VAL_15_HE NULL
#define OPTION_VAL_20_HE NULL
#define OPTION_VAL_25_HE NULL
#define OPTION_VAL_30_HE NULL
#define OPTION_VAL_35_HE NULL
#define OPTION_VAL_40_HE NULL
#define OPTION_VAL_45_HE NULL
#define OPTION_VAL_50_HE NULL
#define OPTION_VAL_55_HE NULL
#define OPTION_VAL_60_HE NULL
#define OPTION_VAL_65_HE NULL
#define OPTION_VAL_70_HE NULL
#define OPTION_VAL_75_HE NULL
#define OPTION_VAL_80_HE NULL
#define OPTION_VAL_85_HE NULL
#define OPTION_VAL_90_HE NULL
#define OPTION_VAL_95_HE NULL
#define OPTION_VAL_100_HE NULL
#define OPTION_VAL_105_HE NULL
#define OPTION_VAL_110_HE NULL
#define OPTION_VAL_115_HE NULL
#define OPTION_VAL_120_HE NULL
#define OPTION_VAL_125_HE NULL
#define OPTION_VAL_130_HE NULL
#define OPTION_VAL_135_HE NULL
#define OPTION_VAL_140_HE NULL
#define OPTION_VAL_145_HE NULL
#define OPTION_VAL_150_HE NULL
#define OPTION_VAL_155_HE NULL
#define OPTION_VAL_160_HE NULL
#define OPTION_VAL_165_HE NULL
#define OPTION_VAL_170_HE NULL
#define OPTION_VAL_175_HE NULL
#define OPTION_VAL_180_HE NULL
#define OPTION_VAL_185_HE NULL
#define OPTION_VAL_190_HE NULL
#define OPTION_VAL_195_HE NULL
#define OPTION_VAL_200_HE NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_HE NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_HE NULL
#define OPTION_VAL_LINEAR_HE NULL
#define OPTION_VAL_QUADRATIC_HE NULL
#define OPTION_VAL_CUBIC_HE NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_HE NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_HE NULL
#define OPTION_VAL_0_HE NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_HE NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_HE NULL
#define OPTION_VAL_LIBRETRO_HE NULL
#define OPTION_VAL_MEDNAFEN_HE NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_HE NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_HE NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_HE NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_HE NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_HE NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_HE NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_HE NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_HE NULL
#define OPTION_VAL_1_HE NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_HE NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_HE NULL
#define OPTION_VAL_MEMORY_ONLY_HE NULL
#define OPTION_VAL_MEMORY_CPU_HE NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_HE NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_HE NULL
#define OPTION_VAL_0PX_HE NULL
#define OPTION_VAL_1PX_HE NULL
#define OPTION_VAL_2PX_HE NULL
#define OPTION_VAL_3PX_HE NULL
#define OPTION_VAL_4PX_HE NULL
#define OPTION_VAL_5PX_HE NULL
#define OPTION_VAL_6PX_HE NULL
#define OPTION_VAL_7PX_HE NULL
#define OPTION_VAL_8PX_HE NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_HE NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_HE NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_HE NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_HE NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_HE NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_HE NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_HE NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_HE NULL
#define OPTION_VAL_DEFAULT_HE NULL
#define OPTION_VAL_AGGRESSIVE_HE NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_HE NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_HE NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_HE NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_HE NULL
#define OPTION_VAL_16_9_HE NULL
#define OPTION_VAL_16_10_HE NULL
#define OPTION_VAL_18_9_HE NULL
#define OPTION_VAL_19_9_HE NULL
#define OPTION_VAL_20_9_HE NULL
#define OPTION_VAL_21_9_HE NULL
#define OPTION_VAL_32_9_HE NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_HE NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_HE NULL
#define OPTION_VAL_100_NATIVE_HE NULL
#define OPTION_VAL_210_HE NULL
#define OPTION_VAL_220_HE NULL
#define OPTION_VAL_230_HE NULL
#define OPTION_VAL_240_HE NULL
#define OPTION_VAL_250_HE NULL
#define OPTION_VAL_260_HE NULL
#define OPTION_VAL_270_HE NULL
#define OPTION_VAL_280_HE NULL
#define OPTION_VAL_290_HE NULL
#define OPTION_VAL_300_HE NULL
#define OPTION_VAL_310_HE NULL
#define OPTION_VAL_320_HE NULL
#define OPTION_VAL_330_HE NULL
#define OPTION_VAL_340_HE NULL
#define OPTION_VAL_350_HE NULL
#define OPTION_VAL_360_HE NULL
#define OPTION_VAL_370_HE NULL
#define OPTION_VAL_380_HE NULL
#define OPTION_VAL_390_HE NULL
#define OPTION_VAL_400_HE NULL
#define OPTION_VAL_410_HE NULL
#define OPTION_VAL_420_HE NULL
#define OPTION_VAL_430_HE NULL
#define OPTION_VAL_440_HE NULL
#define OPTION_VAL_450_HE NULL
#define OPTION_VAL_460_HE NULL
#define OPTION_VAL_470_HE NULL
#define OPTION_VAL_480_HE NULL
#define OPTION_VAL_490_HE NULL
#define OPTION_VAL_500_HE NULL
#define OPTION_VAL_510_HE NULL
#define OPTION_VAL_520_HE NULL
#define OPTION_VAL_530_HE NULL
#define OPTION_VAL_540_HE NULL
#define OPTION_VAL_550_HE NULL
#define OPTION_VAL_560_HE NULL
#define OPTION_VAL_570_HE NULL
#define OPTION_VAL_580_HE NULL
#define OPTION_VAL_590_HE NULL
#define OPTION_VAL_600_HE NULL
#define OPTION_VAL_610_HE NULL
#define OPTION_VAL_620_HE NULL
#define OPTION_VAL_630_HE NULL
#define OPTION_VAL_640_HE NULL
#define OPTION_VAL_650_HE NULL
#define OPTION_VAL_660_HE NULL
#define OPTION_VAL_670_HE NULL
#define OPTION_VAL_680_HE NULL
#define OPTION_VAL_690_HE NULL
#define OPTION_VAL_700_HE NULL
#define OPTION_VAL_710_HE NULL
#define OPTION_VAL_720_HE NULL
#define OPTION_VAL_730_HE NULL
#define OPTION_VAL_740_HE NULL
#define OPTION_VAL_750_HE NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_HE NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_HE NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_HE NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_HE NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_HE NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_HE NULL
#define OPTION_VAL_PSXONPSP_HE NULL
#define OPTION_VAL_PS1_ROM_HE NULL
#define BEETLE_OPT_RENDERER_LABEL_HE NULL
#define BEETLE_OPT_RENDERER_INFO_0_HE NULL
#define OPTION_VAL_HARDWARE_HE NULL
#define OPTION_VAL_HARDWARE_GL_HE NULL
#define OPTION_VAL_HARDWARE_VK_HE NULL
#define OPTION_VAL_SOFTWARE_HE NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_HE NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_HE NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_HE NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_HE NULL
#define OPTION_VAL_DISABLED_HE NULL
#define OPTION_VAL_EXECUTE_HE NULL
#define OPTION_VAL_EXECUTE_ONE_HE NULL
#define OPTION_VAL_RUN_INTERPRETER_HE NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_HE NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_HE NULL
#define OPTION_VAL_FULL_HE NULL
#define OPTION_VAL_DMA_HE NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_HE NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_HE NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_HE NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_HE NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_HE NULL
#define OPTION_VAL_FORCE_INTERLACED_HE NULL
#define OPTION_VAL_AUTO_TOGGLE_HE NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_HE NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_HE NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_HE NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_HE NULL
#define OPTION_VAL_DISABLED_O53_HE NULL
#define OPTION_VAL_STATIC_HE NULL
#define OPTION_VAL_SMART_HE NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_HE NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_HE NULL
#define OPTION_VAL_9PX_HE NULL
#define OPTION_VAL_10PX_HE NULL
#define OPTION_VAL_11PX_HE NULL
#define OPTION_VAL_12PX_HE NULL
#define OPTION_VAL_13PX_HE NULL
#define OPTION_VAL_14PX_HE NULL
#define OPTION_VAL_15PX_HE NULL
#define OPTION_VAL_16PX_HE NULL
#define OPTION_VAL_17PX_HE NULL
#define OPTION_VAL_18PX_HE NULL
#define OPTION_VAL_19PX_HE NULL
#define OPTION_VAL_20PX_HE NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_HE NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_HE NULL
#define OPTION_VAL_12PX_O55_HE NULL
#define OPTION_VAL_11PX_O55_HE NULL
#define OPTION_VAL_10PX_O55_HE NULL
#define OPTION_VAL_9PX_O55_HE NULL
#define OPTION_VAL_8PX_O55_HE NULL
#define OPTION_VAL_7PX_O55_HE NULL
#define OPTION_VAL_6PX_O55_HE NULL
#define OPTION_VAL_5PX_O55_HE NULL
#define OPTION_VAL_4PX_O55_HE NULL
#define OPTION_VAL_3PX_O55_HE NULL
#define OPTION_VAL_2PX_O55_HE NULL
#define OPTION_VAL_1PX_O55_HE NULL
#define OPTION_VAL_DISABLED_O55_HE NULL
#define OPTION_VAL_1PX_O55_0_HE NULL
#define OPTION_VAL_2PX_O55_0_HE NULL
#define OPTION_VAL_3PX_O55_0_HE NULL
#define OPTION_VAL_4PX_O55_0_HE NULL
#define OPTION_VAL_5PX_O55_0_HE NULL
#define OPTION_VAL_6PX_O55_0_HE NULL
#define OPTION_VAL_7PX_O55_0_HE NULL
#define OPTION_VAL_8PX_O55_0_HE NULL
#define OPTION_VAL_9PX_O55_0_HE NULL
#define OPTION_VAL_10PX_O55_0_HE NULL
#define OPTION_VAL_11PX_O55_0_HE NULL
#define OPTION_VAL_12PX_O55_0_HE NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_HE NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_HE NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_HE NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_HE NULL
#define OPTION_VAL_32X_HE NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_HE NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_HE NULL
#define OPTION_VAL_CORRECTED_HE NULL
#define OPTION_VAL_UNCORRECTED_HE NULL
#define OPTION_VAL_4_3_HE NULL
#define OPTION_VAL_NTSC_HE NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_HE NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_HE NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_HE NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_HE NULL
#define OPTION_VAL_239_HE NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_HE NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_HE NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_HE NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_HE NULL
#define OPTION_VAL_287_HE NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_HE NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_HE NULL
#define OPTION_VAL_SYNC_HE NULL
#define OPTION_VAL_ASYNC_HE NULL
#define OPTION_VAL_PRECACHE_HE NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_HE NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_HE NULL
#define OPTION_VAL_2X_NATIVE_HE NULL
#define OPTION_VAL_6X_HE NULL
#define OPTION_VAL_10X_HE NULL
#define OPTION_VAL_12X_HE NULL
#define OPTION_VAL_14X_HE NULL

struct retro_core_option_v2_category option_cats_he[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_HE,
      CATEGORY_VIDEO_INFO_0_HE
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_HE,
      CATEGORY_OSD_INFO_0_HE
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_HE,
      CATEGORY_INPUT_INFO_0_HE
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_HE,
      CATEGORY_MEMCARDS_INFO_0_HE
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_HE,
      CATEGORY_PGXP_INFO_0_HE
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_HE,
      CATEGORY_HACKS_INFO_0_HE
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_he[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_HE,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_HE,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_HE },
         { "2x",         OPTION_VAL_2X_HE },
         { "4x",         OPTION_VAL_4X_HE },
         { "8x",         OPTION_VAL_8X_HE },
         { "16x",        OPTION_VAL_16X_HE },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_HE,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_HE,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_HE },
         { "32bpp",         OPTION_VAL_32BPP_HE },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_HE,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_HE,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_HE },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_HE },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_HE,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_HE,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_HE,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_HE,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_HE },
         { "SABR",     OPTION_VAL_SABR_HE },
         { "xBR",      OPTION_VAL_XBR_HE },
         { "bilinear", OPTION_VAL_BILINEAR_HE },
         { "3-point",  OPTION_VAL_3_POINT_HE },
         { "JINC2",    OPTION_VAL_JINC2_HE },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_HE,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_HE,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_HE },
         { "all", OPTION_VAL_ALL_HE },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_HE,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_HE,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_HE },
         { "all", OPTION_VAL_ALL_HE },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_HE,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_HE,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_HE,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_HE,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_HE,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_HE,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_HE },
         { "2x",  OPTION_VAL_2X_HE },
         { "4x",  OPTION_VAL_4X_HE },
         { "8x",  OPTION_VAL_8X_HE },
         { "16x", OPTION_VAL_16X_HE },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_HE,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_HE,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_HE,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_HE,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_HE,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_HE,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_HE,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_HE,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_HE,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_HE,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_HE,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_HE,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_HE,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_HE,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_HE,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_HE,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_HE,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_HE,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_HE,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_HE,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_HE,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_HE,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_HE,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_HE,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_HE,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_HE,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_HE },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_HE },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_HE,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_HE,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_HE },
         { "dot",   OPTION_VAL_DOT_HE },
         { "off",   OPTION_VAL_OFF_HE },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_HE,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_HE,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_HE },
         { "blue", OPTION_VAL_BLUE_HE },
         { "green", OPTION_VAL_GREEN_HE },
         { "orange", OPTION_VAL_ORANGE_HE },
         { "yellow", OPTION_VAL_YELLOW_HE },
         { "cyan", OPTION_VAL_CYAN_HE },
         { "pink", OPTION_VAL_PINK_HE },
         { "purple", OPTION_VAL_PURPLE_HE },
         { "black", OPTION_VAL_BLACK_HE },
         { "white", OPTION_VAL_WHITE_HE },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_HE,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_HE,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_HE },
         { "red", OPTION_VAL_RED_HE },
         { "green", OPTION_VAL_GREEN_HE },
         { "orange", OPTION_VAL_ORANGE_HE },
         { "yellow", OPTION_VAL_YELLOW_HE },
         { "cyan", OPTION_VAL_CYAN_HE },
         { "pink", OPTION_VAL_PINK_HE },
         { "purple", OPTION_VAL_PURPLE_HE },
         { "black", OPTION_VAL_BLACK_HE },
         { "white", OPTION_VAL_WHITE_HE },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_HE,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_HE,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_HE },
         { "10%",  OPTION_VAL_10_HE },
         { "15%",  OPTION_VAL_15_HE },
         { "20%",  OPTION_VAL_20_HE },
         { "25%",  OPTION_VAL_25_HE },
         { "30%",  OPTION_VAL_30_HE },
         { "35%",  OPTION_VAL_35_HE },
         { "40%",  OPTION_VAL_40_HE },
         { "45%",  OPTION_VAL_45_HE },
         { "50%",  OPTION_VAL_50_HE },
         { "55%",  OPTION_VAL_55_HE },
         { "60%",  OPTION_VAL_60_HE },
         { "65%",  OPTION_VAL_65_HE },
         { "70%",  OPTION_VAL_70_HE },
         { "75%",  OPTION_VAL_75_HE },
         { "80%",  OPTION_VAL_80_HE },
         { "85%",  OPTION_VAL_85_HE },
         { "90%",  OPTION_VAL_90_HE },
         { "95%",  OPTION_VAL_95_HE },
         { "100%", OPTION_VAL_100_HE },
         { "105%", OPTION_VAL_105_HE },
         { "110%", OPTION_VAL_110_HE },
         { "115%", OPTION_VAL_115_HE },
         { "120%", OPTION_VAL_120_HE },
         { "125%", OPTION_VAL_125_HE },
         { "130%", OPTION_VAL_130_HE },
         { "135%", OPTION_VAL_135_HE },
         { "140%", OPTION_VAL_140_HE },
         { "145%", OPTION_VAL_145_HE },
         { "150%", OPTION_VAL_150_HE },
         { "155%", OPTION_VAL_155_HE },
         { "160%", OPTION_VAL_160_HE },
         { "165%", OPTION_VAL_165_HE },
         { "170%", OPTION_VAL_170_HE },
         { "175%", OPTION_VAL_175_HE },
         { "180%", OPTION_VAL_180_HE },
         { "185%", OPTION_VAL_185_HE },
         { "190%", OPTION_VAL_190_HE },
         { "195%", OPTION_VAL_195_HE },
         { "200%", OPTION_VAL_200_HE },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_HE,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_HE,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_HE },
         { "quadratic", OPTION_VAL_QUADRATIC_HE },
         { "cubic",     OPTION_VAL_CUBIC_HE },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_HE,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_HE,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_HE },
         { "5%",  OPTION_VAL_5_HE },
         { "10%", OPTION_VAL_10_HE },
         { "15%", OPTION_VAL_15_HE },
         { "20%", OPTION_VAL_20_HE },
         { "25%", OPTION_VAL_25_HE },
         { "30%", OPTION_VAL_30_HE },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_HE,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_HE,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_HE },
         { "mednafen", OPTION_VAL_MEDNAFEN_HE },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_HE,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_HE,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_HE,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_HE,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_HE,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_HE,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_HE,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_HE,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_HE },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_HE,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_HE,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_HE },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_HE },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_HE,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_HE,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_HE },
         { "1px", OPTION_VAL_1PX_HE },
         { "2px", OPTION_VAL_2PX_HE },
         { "3px", OPTION_VAL_3PX_HE },
         { "4px", OPTION_VAL_4PX_HE },
         { "5px", OPTION_VAL_5PX_HE },
         { "6px", OPTION_VAL_6PX_HE },
         { "7px", OPTION_VAL_7PX_HE },
         { "8px", OPTION_VAL_8PX_HE },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_HE,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_HE,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_HE,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_HE,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_HE,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_HE,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_HE,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_HE,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_HE },
         { "aggressive", OPTION_VAL_AGGRESSIVE_HE },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_HE,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_HE,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_HE,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_HE,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_HE },
         { "16:10", OPTION_VAL_16_10_HE },
         { "18:9",  OPTION_VAL_18_9_HE },
         { "19:9",  OPTION_VAL_19_9_HE },
         { "20:9",  OPTION_VAL_20_9_HE },
         { "21:9",  OPTION_VAL_21_9_HE }, // 64:27
         { "32:9",  OPTION_VAL_32_9_HE },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_HE,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_HE,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_HE },
         { "60%",           OPTION_VAL_60_HE },
         { "70%",           OPTION_VAL_70_HE },
         { "80%",           OPTION_VAL_80_HE },
         { "90%",           OPTION_VAL_90_HE },
         { "100%(native)", OPTION_VAL_100_NATIVE_HE },
         { "110%",          OPTION_VAL_110_HE },
         { "120%",          OPTION_VAL_120_HE },
         { "130%",          OPTION_VAL_130_HE },
         { "140%",          OPTION_VAL_140_HE },
         { "150%",          OPTION_VAL_150_HE },
         { "160%",          OPTION_VAL_160_HE },
         { "170%",          OPTION_VAL_170_HE },
         { "180%",          OPTION_VAL_180_HE },
         { "190%",          OPTION_VAL_190_HE },
         { "200%",          OPTION_VAL_200_HE },
         { "210%",          OPTION_VAL_210_HE },
         { "220%",          OPTION_VAL_220_HE },
         { "230%",          OPTION_VAL_230_HE },
         { "240%",          OPTION_VAL_240_HE },
         { "250%",          OPTION_VAL_250_HE },
         { "260%",          OPTION_VAL_260_HE },
         { "270%",          OPTION_VAL_270_HE },
         { "280%",          OPTION_VAL_280_HE },
         { "290%",          OPTION_VAL_290_HE },
         { "300%",          OPTION_VAL_300_HE },
         { "310%",          OPTION_VAL_310_HE },
         { "320%",          OPTION_VAL_320_HE },
         { "330%",          OPTION_VAL_330_HE },
         { "340%",          OPTION_VAL_340_HE },
         { "350%",          OPTION_VAL_350_HE },
         { "360%",          OPTION_VAL_360_HE },
         { "370%",          OPTION_VAL_370_HE },
         { "380%",          OPTION_VAL_380_HE },
         { "390%",          OPTION_VAL_390_HE },
         { "400%",          OPTION_VAL_400_HE },
         { "410%",          OPTION_VAL_410_HE },
         { "420%",          OPTION_VAL_420_HE },
         { "430%",          OPTION_VAL_430_HE },
         { "440%",          OPTION_VAL_440_HE },
         { "450%",          OPTION_VAL_450_HE },
         { "460%",          OPTION_VAL_460_HE },
         { "470%",          OPTION_VAL_470_HE },
         { "480%",          OPTION_VAL_480_HE },
         { "490%",          OPTION_VAL_490_HE },
         { "500%",          OPTION_VAL_500_HE },
         { "510%",          OPTION_VAL_510_HE },
         { "520%",          OPTION_VAL_520_HE },
         { "530%",          OPTION_VAL_530_HE },
         { "540%",          OPTION_VAL_540_HE },
         { "550%",          OPTION_VAL_550_HE },
         { "560%",          OPTION_VAL_560_HE },
         { "570%",          OPTION_VAL_570_HE },
         { "580%",          OPTION_VAL_580_HE },
         { "590%",          OPTION_VAL_590_HE },
         { "600%",          OPTION_VAL_600_HE },
         { "610%",          OPTION_VAL_610_HE },
         { "620%",          OPTION_VAL_620_HE },
         { "630%",          OPTION_VAL_630_HE },
         { "640%",          OPTION_VAL_640_HE },
         { "650%",          OPTION_VAL_650_HE },
         { "660%",          OPTION_VAL_660_HE },
         { "670%",          OPTION_VAL_670_HE },
         { "680%",          OPTION_VAL_680_HE },
         { "690%",          OPTION_VAL_690_HE },
         { "700%",          OPTION_VAL_700_HE },
         { "710%",          OPTION_VAL_710_HE },
         { "720%",          OPTION_VAL_720_HE },
         { "730%",          OPTION_VAL_730_HE },
         { "740%",          OPTION_VAL_740_HE },
         { "750%",          OPTION_VAL_750_HE },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_HE,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_HE,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_HE,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_HE,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_HE,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_HE,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_HE },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_HE },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_HE,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_HE,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_HE },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_HE },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_HE },
#endif
         { "software",    OPTION_VAL_SOFTWARE_HE },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_HE,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_HE,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_HE,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_HE,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_HE },
         { "execute",  OPTION_VAL_EXECUTE_HE },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_HE },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_HE },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_HE,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_HE,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_HE },
         { "dma",  OPTION_VAL_DMA_HE },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_HE,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_HE,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_HE,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_HE,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_HE },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_HE },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_HE },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_HE,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_HE,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_HE,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_HE,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_HE },
         { "static",  OPTION_VAL_STATIC_HE },
         { "smart", OPTION_VAL_SMART_HE },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_HE,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_HE,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_HE },
         { "2px",      OPTION_VAL_2PX_HE },
         { "3px",      OPTION_VAL_3PX_HE },
         { "4px",      OPTION_VAL_4PX_HE },
         { "5px",      OPTION_VAL_5PX_HE },
         { "6px",      OPTION_VAL_6PX_HE },
         { "7px",      OPTION_VAL_7PX_HE },
         { "8px",      OPTION_VAL_8PX_HE },
         { "9px",      OPTION_VAL_9PX_HE },
         { "10px",     OPTION_VAL_10PX_HE },
         { "11px",     OPTION_VAL_11PX_HE },
         { "12px",     OPTION_VAL_12PX_HE },
         { "13px",     OPTION_VAL_13PX_HE },
         { "14px",     OPTION_VAL_14PX_HE },
         { "15px",     OPTION_VAL_15PX_HE },
         { "16px",     OPTION_VAL_16PX_HE },
         { "17px",     OPTION_VAL_17PX_HE },
         { "18px",     OPTION_VAL_18PX_HE },
         { "19px",     OPTION_VAL_19PX_HE },
         { "20px",     OPTION_VAL_20PX_HE },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_HE,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_HE,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_HE },
         { "-11px",    OPTION_VAL_11PX_O55_HE },
         { "-10px",    OPTION_VAL_10PX_O55_HE },
         { "-9px",     OPTION_VAL_9PX_O55_HE },
         { "-8px",     OPTION_VAL_8PX_O55_HE },
         { "-7px",     OPTION_VAL_7PX_O55_HE },
         { "-6px",     OPTION_VAL_6PX_O55_HE },
         { "-5px",     OPTION_VAL_5PX_O55_HE },
         { "-4px",     OPTION_VAL_4PX_O55_HE },
         { "-3px",     OPTION_VAL_3PX_O55_HE },
         { "-2px",     OPTION_VAL_2PX_O55_HE },
         { "-1px",     OPTION_VAL_1PX_O55_HE },
         { "disabled", OPTION_VAL_DISABLED_O55_HE },
         { "+1px",     OPTION_VAL_1PX_O55_0_HE },
         { "+2px",     OPTION_VAL_2PX_O55_0_HE },
         { "+3px",     OPTION_VAL_3PX_O55_0_HE },
         { "+4px",     OPTION_VAL_4PX_O55_0_HE },
         { "+5px",     OPTION_VAL_5PX_O55_0_HE },
         { "+6px",     OPTION_VAL_6PX_O55_0_HE },
         { "+7px",     OPTION_VAL_7PX_O55_0_HE },
         { "+8px",     OPTION_VAL_8PX_O55_0_HE },
         { "+9px",     OPTION_VAL_9PX_O55_0_HE },
         { "+10px",    OPTION_VAL_10PX_O55_0_HE },
         { "+11px",    OPTION_VAL_11PX_O55_0_HE },
         { "+12px",    OPTION_VAL_12PX_O55_0_HE },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_HE,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_HE,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_HE },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_HE,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_HE,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_HE },
         { "2x",         OPTION_VAL_2X_HE },
         { "4x",         OPTION_VAL_4X_HE },
         { "8x",         OPTION_VAL_8X_HE },
         { "16x",        OPTION_VAL_16X_HE },
         { "32x",        OPTION_VAL_32X_HE },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_HE,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_HE,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_HE },
         { "uncorrected", OPTION_VAL_UNCORRECTED_HE },
         { "4:3",  OPTION_VAL_4_3_HE },
         { "ntsc", OPTION_VAL_NTSC_HE },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_HE,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_HE,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_HE,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_HE,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_HE },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_HE,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_HE,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_HE,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_HE,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_HE },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_HE,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_HE,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_HE },
         { "async",    OPTION_VAL_ASYNC_HE },
         { "precache", OPTION_VAL_PRECACHE_HE },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_HE,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_HE,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_HE },
         { "4x",          OPTION_VAL_4X_HE },
         { "6x",          OPTION_VAL_6X_HE },
         { "8x",          OPTION_VAL_8X_HE },
         { "10x",         OPTION_VAL_10X_HE },
         { "12x",         OPTION_VAL_12X_HE },
         { "14x",         OPTION_VAL_14X_HE },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_he = {
   option_cats_he,
   option_defs_he
};

/* RETRO_LANGUAGE_HU */

#define CATEGORY_VIDEO_LABEL_HU "Videó"
#define CATEGORY_VIDEO_INFO_0_HU NULL
#define CATEGORY_OSD_LABEL_HU NULL
#define CATEGORY_OSD_INFO_0_HU NULL
#define CATEGORY_INPUT_LABEL_HU "Bevitel"
#define CATEGORY_INPUT_INFO_0_HU NULL
#define CATEGORY_MEMCARDS_LABEL_HU NULL
#define CATEGORY_MEMCARDS_INFO_0_HU NULL
#define CATEGORY_PGXP_LABEL_HU NULL
#define CATEGORY_PGXP_INFO_0_HU NULL
#define CATEGORY_HACKS_LABEL_HU NULL
#define CATEGORY_HACKS_INFO_0_HU NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_HU NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_HU NULL
#define OPTION_VAL_1X_NATIVE_HU NULL
#define OPTION_VAL_2X_HU NULL
#define OPTION_VAL_4X_HU NULL
#define OPTION_VAL_8X_HU NULL
#define OPTION_VAL_16X_HU NULL
#define BEETLE_OPT_DEPTH_LABEL_HU NULL
#define BEETLE_OPT_DEPTH_INFO_0_HU NULL
#define OPTION_VAL_16BPP_NATIVE_HU NULL
#define OPTION_VAL_32BPP_HU NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_HU NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_HU NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_HU NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_HU NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_HU NULL
#define BEETLE_OPT_FILTER_LABEL_HU NULL
#define BEETLE_OPT_FILTER_INFO_0_HU NULL
#define OPTION_VAL_NEAREST_HU NULL
#define OPTION_VAL_SABR_HU NULL
#define OPTION_VAL_XBR_HU NULL
#define OPTION_VAL_BILINEAR_HU "Bilineáris"
#define OPTION_VAL_3_POINT_HU NULL
#define OPTION_VAL_JINC2_HU NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_HU NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_HU NULL
#define OPTION_VAL_OPAQUE_HU NULL
#define OPTION_VAL_ALL_HU NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_HU NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_HU NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_HU NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_HU NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_HU NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_HU NULL
#define BEETLE_OPT_MSAA_LABEL_HU NULL
#define BEETLE_OPT_MSAA_INFO_0_HU NULL
#define OPTION_VAL_1X_HU NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_HU NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_HU NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_HU NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_HU NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_HU NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_HU NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_HU NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_HU NULL
#define BEETLE_OPT_WIREFRAME_LABEL_HU NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_HU NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_HU NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_HU NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_HU NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_HU NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_HU NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_HU NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_HU NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_HU NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_HU NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_HU NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_HU NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_HU NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_HU NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_HU NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_HU NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_HU NULL
#define OPTION_VAL_LIGHTGUN_HU NULL
#define OPTION_VAL_TOUCHSCREEN_HU NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_HU NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_HU NULL
#define OPTION_VAL_CROSS_HU NULL
#define OPTION_VAL_DOT_HU NULL
#define OPTION_VAL_OFF_HU NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_HU NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_HU NULL
#define OPTION_VAL_RED_HU NULL
#define OPTION_VAL_BLUE_HU NULL
#define OPTION_VAL_GREEN_HU NULL
#define OPTION_VAL_ORANGE_HU NULL
#define OPTION_VAL_YELLOW_HU NULL
#define OPTION_VAL_CYAN_HU NULL
#define OPTION_VAL_PINK_HU NULL
#define OPTION_VAL_PURPLE_HU NULL
#define OPTION_VAL_BLACK_HU NULL
#define OPTION_VAL_WHITE_HU NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_HU NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_HU NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_HU NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_HU NULL
#define OPTION_VAL_5_HU NULL
#define OPTION_VAL_10_HU NULL
#define OPTION_VAL_15_HU NULL
#define OPTION_VAL_20_HU NULL
#define OPTION_VAL_25_HU NULL
#define OPTION_VAL_30_HU NULL
#define OPTION_VAL_35_HU NULL
#define OPTION_VAL_40_HU NULL
#define OPTION_VAL_45_HU NULL
#define OPTION_VAL_50_HU NULL
#define OPTION_VAL_55_HU NULL
#define OPTION_VAL_60_HU NULL
#define OPTION_VAL_65_HU NULL
#define OPTION_VAL_70_HU NULL
#define OPTION_VAL_75_HU NULL
#define OPTION_VAL_80_HU NULL
#define OPTION_VAL_85_HU NULL
#define OPTION_VAL_90_HU NULL
#define OPTION_VAL_95_HU NULL
#define OPTION_VAL_100_HU NULL
#define OPTION_VAL_105_HU NULL
#define OPTION_VAL_110_HU NULL
#define OPTION_VAL_115_HU NULL
#define OPTION_VAL_120_HU NULL
#define OPTION_VAL_125_HU NULL
#define OPTION_VAL_130_HU NULL
#define OPTION_VAL_135_HU NULL
#define OPTION_VAL_140_HU NULL
#define OPTION_VAL_145_HU NULL
#define OPTION_VAL_150_HU NULL
#define OPTION_VAL_155_HU NULL
#define OPTION_VAL_160_HU NULL
#define OPTION_VAL_165_HU NULL
#define OPTION_VAL_170_HU NULL
#define OPTION_VAL_175_HU NULL
#define OPTION_VAL_180_HU NULL
#define OPTION_VAL_185_HU NULL
#define OPTION_VAL_190_HU NULL
#define OPTION_VAL_195_HU NULL
#define OPTION_VAL_200_HU NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_HU NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_HU NULL
#define OPTION_VAL_LINEAR_HU NULL
#define OPTION_VAL_QUADRATIC_HU NULL
#define OPTION_VAL_CUBIC_HU NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_HU NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_HU NULL
#define OPTION_VAL_0_HU NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_HU NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_HU NULL
#define OPTION_VAL_LIBRETRO_HU NULL
#define OPTION_VAL_MEDNAFEN_HU NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_HU NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_HU NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_HU NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_HU NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_HU NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_HU NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_HU NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_HU NULL
#define OPTION_VAL_1_HU NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_HU NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_HU NULL
#define OPTION_VAL_MEMORY_ONLY_HU NULL
#define OPTION_VAL_MEMORY_CPU_HU NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_HU NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_HU NULL
#define OPTION_VAL_0PX_HU NULL
#define OPTION_VAL_1PX_HU NULL
#define OPTION_VAL_2PX_HU NULL
#define OPTION_VAL_3PX_HU NULL
#define OPTION_VAL_4PX_HU NULL
#define OPTION_VAL_5PX_HU NULL
#define OPTION_VAL_6PX_HU NULL
#define OPTION_VAL_7PX_HU NULL
#define OPTION_VAL_8PX_HU NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_HU NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_HU NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_HU NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_HU NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_HU NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_HU NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_HU NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_HU NULL
#define OPTION_VAL_DEFAULT_HU NULL
#define OPTION_VAL_AGGRESSIVE_HU NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_HU NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_HU NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_HU NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_HU NULL
#define OPTION_VAL_16_9_HU NULL
#define OPTION_VAL_16_10_HU NULL
#define OPTION_VAL_18_9_HU NULL
#define OPTION_VAL_19_9_HU NULL
#define OPTION_VAL_20_9_HU NULL
#define OPTION_VAL_21_9_HU NULL
#define OPTION_VAL_32_9_HU NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_HU NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_HU NULL
#define OPTION_VAL_100_NATIVE_HU NULL
#define OPTION_VAL_210_HU NULL
#define OPTION_VAL_220_HU NULL
#define OPTION_VAL_230_HU NULL
#define OPTION_VAL_240_HU NULL
#define OPTION_VAL_250_HU NULL
#define OPTION_VAL_260_HU NULL
#define OPTION_VAL_270_HU NULL
#define OPTION_VAL_280_HU NULL
#define OPTION_VAL_290_HU NULL
#define OPTION_VAL_300_HU NULL
#define OPTION_VAL_310_HU NULL
#define OPTION_VAL_320_HU NULL
#define OPTION_VAL_330_HU NULL
#define OPTION_VAL_340_HU NULL
#define OPTION_VAL_350_HU NULL
#define OPTION_VAL_360_HU NULL
#define OPTION_VAL_370_HU NULL
#define OPTION_VAL_380_HU NULL
#define OPTION_VAL_390_HU NULL
#define OPTION_VAL_400_HU NULL
#define OPTION_VAL_410_HU NULL
#define OPTION_VAL_420_HU NULL
#define OPTION_VAL_430_HU NULL
#define OPTION_VAL_440_HU NULL
#define OPTION_VAL_450_HU NULL
#define OPTION_VAL_460_HU NULL
#define OPTION_VAL_470_HU NULL
#define OPTION_VAL_480_HU NULL
#define OPTION_VAL_490_HU NULL
#define OPTION_VAL_500_HU NULL
#define OPTION_VAL_510_HU NULL
#define OPTION_VAL_520_HU NULL
#define OPTION_VAL_530_HU NULL
#define OPTION_VAL_540_HU NULL
#define OPTION_VAL_550_HU NULL
#define OPTION_VAL_560_HU NULL
#define OPTION_VAL_570_HU NULL
#define OPTION_VAL_580_HU NULL
#define OPTION_VAL_590_HU NULL
#define OPTION_VAL_600_HU NULL
#define OPTION_VAL_610_HU NULL
#define OPTION_VAL_620_HU NULL
#define OPTION_VAL_630_HU NULL
#define OPTION_VAL_640_HU NULL
#define OPTION_VAL_650_HU NULL
#define OPTION_VAL_660_HU NULL
#define OPTION_VAL_670_HU NULL
#define OPTION_VAL_680_HU NULL
#define OPTION_VAL_690_HU NULL
#define OPTION_VAL_700_HU NULL
#define OPTION_VAL_710_HU NULL
#define OPTION_VAL_720_HU NULL
#define OPTION_VAL_730_HU NULL
#define OPTION_VAL_740_HU NULL
#define OPTION_VAL_750_HU NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_HU NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_HU NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_HU NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_HU NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_HU NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_HU NULL
#define OPTION_VAL_PSXONPSP_HU NULL
#define OPTION_VAL_PS1_ROM_HU NULL
#define BEETLE_OPT_RENDERER_LABEL_HU NULL
#define BEETLE_OPT_RENDERER_INFO_0_HU NULL
#define OPTION_VAL_HARDWARE_HU NULL
#define OPTION_VAL_HARDWARE_GL_HU NULL
#define OPTION_VAL_HARDWARE_VK_HU NULL
#define OPTION_VAL_SOFTWARE_HU NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_HU NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_HU NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_HU NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_HU NULL
#define OPTION_VAL_DISABLED_HU NULL
#define OPTION_VAL_EXECUTE_HU NULL
#define OPTION_VAL_EXECUTE_ONE_HU NULL
#define OPTION_VAL_RUN_INTERPRETER_HU NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_HU NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_HU NULL
#define OPTION_VAL_FULL_HU NULL
#define OPTION_VAL_DMA_HU NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_HU NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_HU NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_HU NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_HU NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_HU NULL
#define OPTION_VAL_FORCE_INTERLACED_HU NULL
#define OPTION_VAL_AUTO_TOGGLE_HU NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_HU NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_HU NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_HU NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_HU NULL
#define OPTION_VAL_DISABLED_O53_HU NULL
#define OPTION_VAL_STATIC_HU NULL
#define OPTION_VAL_SMART_HU NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_HU NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_HU NULL
#define OPTION_VAL_9PX_HU NULL
#define OPTION_VAL_10PX_HU NULL
#define OPTION_VAL_11PX_HU NULL
#define OPTION_VAL_12PX_HU NULL
#define OPTION_VAL_13PX_HU NULL
#define OPTION_VAL_14PX_HU NULL
#define OPTION_VAL_15PX_HU NULL
#define OPTION_VAL_16PX_HU NULL
#define OPTION_VAL_17PX_HU NULL
#define OPTION_VAL_18PX_HU NULL
#define OPTION_VAL_19PX_HU NULL
#define OPTION_VAL_20PX_HU NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_HU NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_HU NULL
#define OPTION_VAL_12PX_O55_HU NULL
#define OPTION_VAL_11PX_O55_HU NULL
#define OPTION_VAL_10PX_O55_HU NULL
#define OPTION_VAL_9PX_O55_HU NULL
#define OPTION_VAL_8PX_O55_HU NULL
#define OPTION_VAL_7PX_O55_HU NULL
#define OPTION_VAL_6PX_O55_HU NULL
#define OPTION_VAL_5PX_O55_HU NULL
#define OPTION_VAL_4PX_O55_HU NULL
#define OPTION_VAL_3PX_O55_HU NULL
#define OPTION_VAL_2PX_O55_HU NULL
#define OPTION_VAL_1PX_O55_HU NULL
#define OPTION_VAL_DISABLED_O55_HU NULL
#define OPTION_VAL_1PX_O55_0_HU NULL
#define OPTION_VAL_2PX_O55_0_HU NULL
#define OPTION_VAL_3PX_O55_0_HU NULL
#define OPTION_VAL_4PX_O55_0_HU NULL
#define OPTION_VAL_5PX_O55_0_HU NULL
#define OPTION_VAL_6PX_O55_0_HU NULL
#define OPTION_VAL_7PX_O55_0_HU NULL
#define OPTION_VAL_8PX_O55_0_HU NULL
#define OPTION_VAL_9PX_O55_0_HU NULL
#define OPTION_VAL_10PX_O55_0_HU NULL
#define OPTION_VAL_11PX_O55_0_HU NULL
#define OPTION_VAL_12PX_O55_0_HU NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_HU NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_HU NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_HU NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_HU NULL
#define OPTION_VAL_32X_HU NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_HU NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_HU NULL
#define OPTION_VAL_CORRECTED_HU NULL
#define OPTION_VAL_UNCORRECTED_HU NULL
#define OPTION_VAL_4_3_HU NULL
#define OPTION_VAL_NTSC_HU NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_HU NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_HU NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_HU NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_HU NULL
#define OPTION_VAL_239_HU NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_HU NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_HU NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_HU NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_HU NULL
#define OPTION_VAL_287_HU NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_HU NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_HU NULL
#define OPTION_VAL_SYNC_HU NULL
#define OPTION_VAL_ASYNC_HU NULL
#define OPTION_VAL_PRECACHE_HU NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_HU NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_HU NULL
#define OPTION_VAL_2X_NATIVE_HU NULL
#define OPTION_VAL_6X_HU NULL
#define OPTION_VAL_10X_HU NULL
#define OPTION_VAL_12X_HU NULL
#define OPTION_VAL_14X_HU NULL

struct retro_core_option_v2_category option_cats_hu[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_HU,
      CATEGORY_VIDEO_INFO_0_HU
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_HU,
      CATEGORY_OSD_INFO_0_HU
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_HU,
      CATEGORY_INPUT_INFO_0_HU
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_HU,
      CATEGORY_MEMCARDS_INFO_0_HU
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_HU,
      CATEGORY_PGXP_INFO_0_HU
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_HU,
      CATEGORY_HACKS_INFO_0_HU
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_hu[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_HU,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_HU,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_HU },
         { "2x",         OPTION_VAL_2X_HU },
         { "4x",         OPTION_VAL_4X_HU },
         { "8x",         OPTION_VAL_8X_HU },
         { "16x",        OPTION_VAL_16X_HU },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_HU,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_HU,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_HU },
         { "32bpp",         OPTION_VAL_32BPP_HU },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_HU,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_HU,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_HU },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_HU },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_HU,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_HU,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_HU,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_HU,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_HU },
         { "SABR",     OPTION_VAL_SABR_HU },
         { "xBR",      OPTION_VAL_XBR_HU },
         { "bilinear", OPTION_VAL_BILINEAR_HU },
         { "3-point",  OPTION_VAL_3_POINT_HU },
         { "JINC2",    OPTION_VAL_JINC2_HU },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_HU,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_HU,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_HU },
         { "all", OPTION_VAL_ALL_HU },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_HU,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_HU,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_HU },
         { "all", OPTION_VAL_ALL_HU },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_HU,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_HU,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_HU,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_HU,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_HU,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_HU,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_HU },
         { "2x",  OPTION_VAL_2X_HU },
         { "4x",  OPTION_VAL_4X_HU },
         { "8x",  OPTION_VAL_8X_HU },
         { "16x", OPTION_VAL_16X_HU },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_HU,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_HU,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_HU,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_HU,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_HU,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_HU,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_HU,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_HU,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_HU,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_HU,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_HU,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_HU,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_HU,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_HU,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_HU,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_HU,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_HU,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_HU,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_HU,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_HU,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_HU,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_HU,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_HU,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_HU,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_HU,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_HU,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_HU },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_HU },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_HU,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_HU,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_HU },
         { "dot",   OPTION_VAL_DOT_HU },
         { "off",   OPTION_VAL_OFF_HU },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_HU,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_HU,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_HU },
         { "blue", OPTION_VAL_BLUE_HU },
         { "green", OPTION_VAL_GREEN_HU },
         { "orange", OPTION_VAL_ORANGE_HU },
         { "yellow", OPTION_VAL_YELLOW_HU },
         { "cyan", OPTION_VAL_CYAN_HU },
         { "pink", OPTION_VAL_PINK_HU },
         { "purple", OPTION_VAL_PURPLE_HU },
         { "black", OPTION_VAL_BLACK_HU },
         { "white", OPTION_VAL_WHITE_HU },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_HU,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_HU,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_HU },
         { "red", OPTION_VAL_RED_HU },
         { "green", OPTION_VAL_GREEN_HU },
         { "orange", OPTION_VAL_ORANGE_HU },
         { "yellow", OPTION_VAL_YELLOW_HU },
         { "cyan", OPTION_VAL_CYAN_HU },
         { "pink", OPTION_VAL_PINK_HU },
         { "purple", OPTION_VAL_PURPLE_HU },
         { "black", OPTION_VAL_BLACK_HU },
         { "white", OPTION_VAL_WHITE_HU },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_HU,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_HU,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_HU },
         { "10%",  OPTION_VAL_10_HU },
         { "15%",  OPTION_VAL_15_HU },
         { "20%",  OPTION_VAL_20_HU },
         { "25%",  OPTION_VAL_25_HU },
         { "30%",  OPTION_VAL_30_HU },
         { "35%",  OPTION_VAL_35_HU },
         { "40%",  OPTION_VAL_40_HU },
         { "45%",  OPTION_VAL_45_HU },
         { "50%",  OPTION_VAL_50_HU },
         { "55%",  OPTION_VAL_55_HU },
         { "60%",  OPTION_VAL_60_HU },
         { "65%",  OPTION_VAL_65_HU },
         { "70%",  OPTION_VAL_70_HU },
         { "75%",  OPTION_VAL_75_HU },
         { "80%",  OPTION_VAL_80_HU },
         { "85%",  OPTION_VAL_85_HU },
         { "90%",  OPTION_VAL_90_HU },
         { "95%",  OPTION_VAL_95_HU },
         { "100%", OPTION_VAL_100_HU },
         { "105%", OPTION_VAL_105_HU },
         { "110%", OPTION_VAL_110_HU },
         { "115%", OPTION_VAL_115_HU },
         { "120%", OPTION_VAL_120_HU },
         { "125%", OPTION_VAL_125_HU },
         { "130%", OPTION_VAL_130_HU },
         { "135%", OPTION_VAL_135_HU },
         { "140%", OPTION_VAL_140_HU },
         { "145%", OPTION_VAL_145_HU },
         { "150%", OPTION_VAL_150_HU },
         { "155%", OPTION_VAL_155_HU },
         { "160%", OPTION_VAL_160_HU },
         { "165%", OPTION_VAL_165_HU },
         { "170%", OPTION_VAL_170_HU },
         { "175%", OPTION_VAL_175_HU },
         { "180%", OPTION_VAL_180_HU },
         { "185%", OPTION_VAL_185_HU },
         { "190%", OPTION_VAL_190_HU },
         { "195%", OPTION_VAL_195_HU },
         { "200%", OPTION_VAL_200_HU },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_HU,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_HU,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_HU },
         { "quadratic", OPTION_VAL_QUADRATIC_HU },
         { "cubic",     OPTION_VAL_CUBIC_HU },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_HU,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_HU,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_HU },
         { "5%",  OPTION_VAL_5_HU },
         { "10%", OPTION_VAL_10_HU },
         { "15%", OPTION_VAL_15_HU },
         { "20%", OPTION_VAL_20_HU },
         { "25%", OPTION_VAL_25_HU },
         { "30%", OPTION_VAL_30_HU },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_HU,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_HU,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_HU },
         { "mednafen", OPTION_VAL_MEDNAFEN_HU },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_HU,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_HU,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_HU,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_HU,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_HU,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_HU,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_HU,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_HU,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_HU },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_HU,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_HU,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_HU },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_HU },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_HU,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_HU,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_HU },
         { "1px", OPTION_VAL_1PX_HU },
         { "2px", OPTION_VAL_2PX_HU },
         { "3px", OPTION_VAL_3PX_HU },
         { "4px", OPTION_VAL_4PX_HU },
         { "5px", OPTION_VAL_5PX_HU },
         { "6px", OPTION_VAL_6PX_HU },
         { "7px", OPTION_VAL_7PX_HU },
         { "8px", OPTION_VAL_8PX_HU },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_HU,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_HU,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_HU,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_HU,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_HU,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_HU,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_HU,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_HU,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_HU },
         { "aggressive", OPTION_VAL_AGGRESSIVE_HU },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_HU,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_HU,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_HU,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_HU,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_HU },
         { "16:10", OPTION_VAL_16_10_HU },
         { "18:9",  OPTION_VAL_18_9_HU },
         { "19:9",  OPTION_VAL_19_9_HU },
         { "20:9",  OPTION_VAL_20_9_HU },
         { "21:9",  OPTION_VAL_21_9_HU }, // 64:27
         { "32:9",  OPTION_VAL_32_9_HU },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_HU,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_HU,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_HU },
         { "60%",           OPTION_VAL_60_HU },
         { "70%",           OPTION_VAL_70_HU },
         { "80%",           OPTION_VAL_80_HU },
         { "90%",           OPTION_VAL_90_HU },
         { "100%(native)", OPTION_VAL_100_NATIVE_HU },
         { "110%",          OPTION_VAL_110_HU },
         { "120%",          OPTION_VAL_120_HU },
         { "130%",          OPTION_VAL_130_HU },
         { "140%",          OPTION_VAL_140_HU },
         { "150%",          OPTION_VAL_150_HU },
         { "160%",          OPTION_VAL_160_HU },
         { "170%",          OPTION_VAL_170_HU },
         { "180%",          OPTION_VAL_180_HU },
         { "190%",          OPTION_VAL_190_HU },
         { "200%",          OPTION_VAL_200_HU },
         { "210%",          OPTION_VAL_210_HU },
         { "220%",          OPTION_VAL_220_HU },
         { "230%",          OPTION_VAL_230_HU },
         { "240%",          OPTION_VAL_240_HU },
         { "250%",          OPTION_VAL_250_HU },
         { "260%",          OPTION_VAL_260_HU },
         { "270%",          OPTION_VAL_270_HU },
         { "280%",          OPTION_VAL_280_HU },
         { "290%",          OPTION_VAL_290_HU },
         { "300%",          OPTION_VAL_300_HU },
         { "310%",          OPTION_VAL_310_HU },
         { "320%",          OPTION_VAL_320_HU },
         { "330%",          OPTION_VAL_330_HU },
         { "340%",          OPTION_VAL_340_HU },
         { "350%",          OPTION_VAL_350_HU },
         { "360%",          OPTION_VAL_360_HU },
         { "370%",          OPTION_VAL_370_HU },
         { "380%",          OPTION_VAL_380_HU },
         { "390%",          OPTION_VAL_390_HU },
         { "400%",          OPTION_VAL_400_HU },
         { "410%",          OPTION_VAL_410_HU },
         { "420%",          OPTION_VAL_420_HU },
         { "430%",          OPTION_VAL_430_HU },
         { "440%",          OPTION_VAL_440_HU },
         { "450%",          OPTION_VAL_450_HU },
         { "460%",          OPTION_VAL_460_HU },
         { "470%",          OPTION_VAL_470_HU },
         { "480%",          OPTION_VAL_480_HU },
         { "490%",          OPTION_VAL_490_HU },
         { "500%",          OPTION_VAL_500_HU },
         { "510%",          OPTION_VAL_510_HU },
         { "520%",          OPTION_VAL_520_HU },
         { "530%",          OPTION_VAL_530_HU },
         { "540%",          OPTION_VAL_540_HU },
         { "550%",          OPTION_VAL_550_HU },
         { "560%",          OPTION_VAL_560_HU },
         { "570%",          OPTION_VAL_570_HU },
         { "580%",          OPTION_VAL_580_HU },
         { "590%",          OPTION_VAL_590_HU },
         { "600%",          OPTION_VAL_600_HU },
         { "610%",          OPTION_VAL_610_HU },
         { "620%",          OPTION_VAL_620_HU },
         { "630%",          OPTION_VAL_630_HU },
         { "640%",          OPTION_VAL_640_HU },
         { "650%",          OPTION_VAL_650_HU },
         { "660%",          OPTION_VAL_660_HU },
         { "670%",          OPTION_VAL_670_HU },
         { "680%",          OPTION_VAL_680_HU },
         { "690%",          OPTION_VAL_690_HU },
         { "700%",          OPTION_VAL_700_HU },
         { "710%",          OPTION_VAL_710_HU },
         { "720%",          OPTION_VAL_720_HU },
         { "730%",          OPTION_VAL_730_HU },
         { "740%",          OPTION_VAL_740_HU },
         { "750%",          OPTION_VAL_750_HU },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_HU,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_HU,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_HU,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_HU,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_HU,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_HU,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_HU },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_HU },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_HU,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_HU,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_HU },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_HU },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_HU },
#endif
         { "software",    OPTION_VAL_SOFTWARE_HU },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_HU,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_HU,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_HU,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_HU,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_HU },
         { "execute",  OPTION_VAL_EXECUTE_HU },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_HU },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_HU },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_HU,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_HU,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_HU },
         { "dma",  OPTION_VAL_DMA_HU },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_HU,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_HU,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_HU,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_HU,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_HU },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_HU },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_HU },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_HU,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_HU,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_HU,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_HU,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_HU },
         { "static",  OPTION_VAL_STATIC_HU },
         { "smart", OPTION_VAL_SMART_HU },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_HU,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_HU,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_HU },
         { "2px",      OPTION_VAL_2PX_HU },
         { "3px",      OPTION_VAL_3PX_HU },
         { "4px",      OPTION_VAL_4PX_HU },
         { "5px",      OPTION_VAL_5PX_HU },
         { "6px",      OPTION_VAL_6PX_HU },
         { "7px",      OPTION_VAL_7PX_HU },
         { "8px",      OPTION_VAL_8PX_HU },
         { "9px",      OPTION_VAL_9PX_HU },
         { "10px",     OPTION_VAL_10PX_HU },
         { "11px",     OPTION_VAL_11PX_HU },
         { "12px",     OPTION_VAL_12PX_HU },
         { "13px",     OPTION_VAL_13PX_HU },
         { "14px",     OPTION_VAL_14PX_HU },
         { "15px",     OPTION_VAL_15PX_HU },
         { "16px",     OPTION_VAL_16PX_HU },
         { "17px",     OPTION_VAL_17PX_HU },
         { "18px",     OPTION_VAL_18PX_HU },
         { "19px",     OPTION_VAL_19PX_HU },
         { "20px",     OPTION_VAL_20PX_HU },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_HU,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_HU,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_HU },
         { "-11px",    OPTION_VAL_11PX_O55_HU },
         { "-10px",    OPTION_VAL_10PX_O55_HU },
         { "-9px",     OPTION_VAL_9PX_O55_HU },
         { "-8px",     OPTION_VAL_8PX_O55_HU },
         { "-7px",     OPTION_VAL_7PX_O55_HU },
         { "-6px",     OPTION_VAL_6PX_O55_HU },
         { "-5px",     OPTION_VAL_5PX_O55_HU },
         { "-4px",     OPTION_VAL_4PX_O55_HU },
         { "-3px",     OPTION_VAL_3PX_O55_HU },
         { "-2px",     OPTION_VAL_2PX_O55_HU },
         { "-1px",     OPTION_VAL_1PX_O55_HU },
         { "disabled", OPTION_VAL_DISABLED_O55_HU },
         { "+1px",     OPTION_VAL_1PX_O55_0_HU },
         { "+2px",     OPTION_VAL_2PX_O55_0_HU },
         { "+3px",     OPTION_VAL_3PX_O55_0_HU },
         { "+4px",     OPTION_VAL_4PX_O55_0_HU },
         { "+5px",     OPTION_VAL_5PX_O55_0_HU },
         { "+6px",     OPTION_VAL_6PX_O55_0_HU },
         { "+7px",     OPTION_VAL_7PX_O55_0_HU },
         { "+8px",     OPTION_VAL_8PX_O55_0_HU },
         { "+9px",     OPTION_VAL_9PX_O55_0_HU },
         { "+10px",    OPTION_VAL_10PX_O55_0_HU },
         { "+11px",    OPTION_VAL_11PX_O55_0_HU },
         { "+12px",    OPTION_VAL_12PX_O55_0_HU },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_HU,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_HU,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_HU },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_HU,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_HU,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_HU },
         { "2x",         OPTION_VAL_2X_HU },
         { "4x",         OPTION_VAL_4X_HU },
         { "8x",         OPTION_VAL_8X_HU },
         { "16x",        OPTION_VAL_16X_HU },
         { "32x",        OPTION_VAL_32X_HU },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_HU,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_HU,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_HU },
         { "uncorrected", OPTION_VAL_UNCORRECTED_HU },
         { "4:3",  OPTION_VAL_4_3_HU },
         { "ntsc", OPTION_VAL_NTSC_HU },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_HU,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_HU,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_HU,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_HU,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_HU },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_HU,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_HU,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_HU,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_HU,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_HU },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_HU,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_HU,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_HU },
         { "async",    OPTION_VAL_ASYNC_HU },
         { "precache", OPTION_VAL_PRECACHE_HU },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_HU,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_HU,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_HU },
         { "4x",          OPTION_VAL_4X_HU },
         { "6x",          OPTION_VAL_6X_HU },
         { "8x",          OPTION_VAL_8X_HU },
         { "10x",         OPTION_VAL_10X_HU },
         { "12x",         OPTION_VAL_12X_HU },
         { "14x",         OPTION_VAL_14X_HU },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_hu = {
   option_cats_hu,
   option_defs_hu
};

/* RETRO_LANGUAGE_ID */

#define CATEGORY_VIDEO_LABEL_ID NULL
#define CATEGORY_VIDEO_INFO_0_ID NULL
#define CATEGORY_OSD_LABEL_ID NULL
#define CATEGORY_OSD_INFO_0_ID NULL
#define CATEGORY_INPUT_LABEL_ID "Masukan"
#define CATEGORY_INPUT_INFO_0_ID NULL
#define CATEGORY_MEMCARDS_LABEL_ID NULL
#define CATEGORY_MEMCARDS_INFO_0_ID NULL
#define CATEGORY_PGXP_LABEL_ID NULL
#define CATEGORY_PGXP_INFO_0_ID NULL
#define CATEGORY_HACKS_LABEL_ID NULL
#define CATEGORY_HACKS_INFO_0_ID NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_ID NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_ID NULL
#define OPTION_VAL_1X_NATIVE_ID NULL
#define OPTION_VAL_2X_ID NULL
#define OPTION_VAL_4X_ID NULL
#define OPTION_VAL_8X_ID NULL
#define OPTION_VAL_16X_ID NULL
#define BEETLE_OPT_DEPTH_LABEL_ID NULL
#define BEETLE_OPT_DEPTH_INFO_0_ID NULL
#define OPTION_VAL_16BPP_NATIVE_ID NULL
#define OPTION_VAL_32BPP_ID NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_ID NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_ID NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_ID NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_ID NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_ID NULL
#define BEETLE_OPT_FILTER_LABEL_ID NULL
#define BEETLE_OPT_FILTER_INFO_0_ID NULL
#define OPTION_VAL_NEAREST_ID NULL
#define OPTION_VAL_SABR_ID NULL
#define OPTION_VAL_XBR_ID NULL
#define OPTION_VAL_BILINEAR_ID NULL
#define OPTION_VAL_3_POINT_ID NULL
#define OPTION_VAL_JINC2_ID NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_ID NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_ID NULL
#define OPTION_VAL_OPAQUE_ID NULL
#define OPTION_VAL_ALL_ID NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_ID NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_ID NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_ID NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_ID NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_ID NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_ID NULL
#define BEETLE_OPT_MSAA_LABEL_ID NULL
#define BEETLE_OPT_MSAA_INFO_0_ID NULL
#define OPTION_VAL_1X_ID NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_ID NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_ID NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_ID NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_ID NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_ID NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_ID NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_ID NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_ID NULL
#define BEETLE_OPT_WIREFRAME_LABEL_ID NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_ID NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_ID NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_ID NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_ID NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_ID NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_ID NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_ID NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_ID NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_ID NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_ID NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_ID NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_ID NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_ID NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_ID NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_ID NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_ID NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_ID NULL
#define OPTION_VAL_LIGHTGUN_ID NULL
#define OPTION_VAL_TOUCHSCREEN_ID NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_ID NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_ID NULL
#define OPTION_VAL_CROSS_ID NULL
#define OPTION_VAL_DOT_ID NULL
#define OPTION_VAL_OFF_ID NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_ID NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_ID NULL
#define OPTION_VAL_RED_ID NULL
#define OPTION_VAL_BLUE_ID NULL
#define OPTION_VAL_GREEN_ID NULL
#define OPTION_VAL_ORANGE_ID NULL
#define OPTION_VAL_YELLOW_ID NULL
#define OPTION_VAL_CYAN_ID NULL
#define OPTION_VAL_PINK_ID NULL
#define OPTION_VAL_PURPLE_ID NULL
#define OPTION_VAL_BLACK_ID NULL
#define OPTION_VAL_WHITE_ID NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_ID NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_ID NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_ID NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_ID NULL
#define OPTION_VAL_5_ID NULL
#define OPTION_VAL_10_ID NULL
#define OPTION_VAL_15_ID NULL
#define OPTION_VAL_20_ID NULL
#define OPTION_VAL_25_ID NULL
#define OPTION_VAL_30_ID NULL
#define OPTION_VAL_35_ID NULL
#define OPTION_VAL_40_ID NULL
#define OPTION_VAL_45_ID NULL
#define OPTION_VAL_50_ID NULL
#define OPTION_VAL_55_ID NULL
#define OPTION_VAL_60_ID NULL
#define OPTION_VAL_65_ID NULL
#define OPTION_VAL_70_ID NULL
#define OPTION_VAL_75_ID NULL
#define OPTION_VAL_80_ID NULL
#define OPTION_VAL_85_ID NULL
#define OPTION_VAL_90_ID NULL
#define OPTION_VAL_95_ID NULL
#define OPTION_VAL_100_ID NULL
#define OPTION_VAL_105_ID NULL
#define OPTION_VAL_110_ID NULL
#define OPTION_VAL_115_ID NULL
#define OPTION_VAL_120_ID NULL
#define OPTION_VAL_125_ID NULL
#define OPTION_VAL_130_ID NULL
#define OPTION_VAL_135_ID NULL
#define OPTION_VAL_140_ID NULL
#define OPTION_VAL_145_ID NULL
#define OPTION_VAL_150_ID NULL
#define OPTION_VAL_155_ID NULL
#define OPTION_VAL_160_ID NULL
#define OPTION_VAL_165_ID NULL
#define OPTION_VAL_170_ID NULL
#define OPTION_VAL_175_ID NULL
#define OPTION_VAL_180_ID NULL
#define OPTION_VAL_185_ID NULL
#define OPTION_VAL_190_ID NULL
#define OPTION_VAL_195_ID NULL
#define OPTION_VAL_200_ID NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_ID NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_ID NULL
#define OPTION_VAL_LINEAR_ID NULL
#define OPTION_VAL_QUADRATIC_ID NULL
#define OPTION_VAL_CUBIC_ID NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_ID NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_ID NULL
#define OPTION_VAL_0_ID NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_ID NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_ID NULL
#define OPTION_VAL_LIBRETRO_ID NULL
#define OPTION_VAL_MEDNAFEN_ID NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_ID NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_ID NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_ID NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_ID NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_ID NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_ID NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_ID NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_ID NULL
#define OPTION_VAL_1_ID NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_ID NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_ID NULL
#define OPTION_VAL_MEMORY_ONLY_ID NULL
#define OPTION_VAL_MEMORY_CPU_ID NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_ID NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_ID NULL
#define OPTION_VAL_0PX_ID NULL
#define OPTION_VAL_1PX_ID NULL
#define OPTION_VAL_2PX_ID NULL
#define OPTION_VAL_3PX_ID NULL
#define OPTION_VAL_4PX_ID NULL
#define OPTION_VAL_5PX_ID NULL
#define OPTION_VAL_6PX_ID NULL
#define OPTION_VAL_7PX_ID NULL
#define OPTION_VAL_8PX_ID NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_ID NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_ID NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_ID NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_ID NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_ID NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_ID NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_ID NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_ID NULL
#define OPTION_VAL_DEFAULT_ID NULL
#define OPTION_VAL_AGGRESSIVE_ID NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_ID NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_ID NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_ID NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_ID NULL
#define OPTION_VAL_16_9_ID NULL
#define OPTION_VAL_16_10_ID NULL
#define OPTION_VAL_18_9_ID NULL
#define OPTION_VAL_19_9_ID NULL
#define OPTION_VAL_20_9_ID NULL
#define OPTION_VAL_21_9_ID NULL
#define OPTION_VAL_32_9_ID NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_ID NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_ID NULL
#define OPTION_VAL_100_NATIVE_ID NULL
#define OPTION_VAL_210_ID NULL
#define OPTION_VAL_220_ID NULL
#define OPTION_VAL_230_ID NULL
#define OPTION_VAL_240_ID NULL
#define OPTION_VAL_250_ID NULL
#define OPTION_VAL_260_ID NULL
#define OPTION_VAL_270_ID NULL
#define OPTION_VAL_280_ID NULL
#define OPTION_VAL_290_ID NULL
#define OPTION_VAL_300_ID NULL
#define OPTION_VAL_310_ID NULL
#define OPTION_VAL_320_ID NULL
#define OPTION_VAL_330_ID NULL
#define OPTION_VAL_340_ID NULL
#define OPTION_VAL_350_ID NULL
#define OPTION_VAL_360_ID NULL
#define OPTION_VAL_370_ID NULL
#define OPTION_VAL_380_ID NULL
#define OPTION_VAL_390_ID NULL
#define OPTION_VAL_400_ID NULL
#define OPTION_VAL_410_ID NULL
#define OPTION_VAL_420_ID NULL
#define OPTION_VAL_430_ID NULL
#define OPTION_VAL_440_ID NULL
#define OPTION_VAL_450_ID NULL
#define OPTION_VAL_460_ID NULL
#define OPTION_VAL_470_ID NULL
#define OPTION_VAL_480_ID NULL
#define OPTION_VAL_490_ID NULL
#define OPTION_VAL_500_ID NULL
#define OPTION_VAL_510_ID NULL
#define OPTION_VAL_520_ID NULL
#define OPTION_VAL_530_ID NULL
#define OPTION_VAL_540_ID NULL
#define OPTION_VAL_550_ID NULL
#define OPTION_VAL_560_ID NULL
#define OPTION_VAL_570_ID NULL
#define OPTION_VAL_580_ID NULL
#define OPTION_VAL_590_ID NULL
#define OPTION_VAL_600_ID NULL
#define OPTION_VAL_610_ID NULL
#define OPTION_VAL_620_ID NULL
#define OPTION_VAL_630_ID NULL
#define OPTION_VAL_640_ID NULL
#define OPTION_VAL_650_ID NULL
#define OPTION_VAL_660_ID NULL
#define OPTION_VAL_670_ID NULL
#define OPTION_VAL_680_ID NULL
#define OPTION_VAL_690_ID NULL
#define OPTION_VAL_700_ID NULL
#define OPTION_VAL_710_ID NULL
#define OPTION_VAL_720_ID NULL
#define OPTION_VAL_730_ID NULL
#define OPTION_VAL_740_ID NULL
#define OPTION_VAL_750_ID NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_ID NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_ID NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_ID NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_ID NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_ID NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_ID NULL
#define OPTION_VAL_PSXONPSP_ID NULL
#define OPTION_VAL_PS1_ROM_ID NULL
#define BEETLE_OPT_RENDERER_LABEL_ID NULL
#define BEETLE_OPT_RENDERER_INFO_0_ID NULL
#define OPTION_VAL_HARDWARE_ID NULL
#define OPTION_VAL_HARDWARE_GL_ID NULL
#define OPTION_VAL_HARDWARE_VK_ID NULL
#define OPTION_VAL_SOFTWARE_ID NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_ID NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_ID NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_ID NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_ID NULL
#define OPTION_VAL_DISABLED_ID NULL
#define OPTION_VAL_EXECUTE_ID NULL
#define OPTION_VAL_EXECUTE_ONE_ID NULL
#define OPTION_VAL_RUN_INTERPRETER_ID NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_ID NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_ID NULL
#define OPTION_VAL_FULL_ID NULL
#define OPTION_VAL_DMA_ID NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_ID NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_ID NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_ID NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_ID NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_ID NULL
#define OPTION_VAL_FORCE_INTERLACED_ID NULL
#define OPTION_VAL_AUTO_TOGGLE_ID NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_ID NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_ID NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_ID NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_ID NULL
#define OPTION_VAL_DISABLED_O53_ID NULL
#define OPTION_VAL_STATIC_ID NULL
#define OPTION_VAL_SMART_ID NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_ID NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_ID NULL
#define OPTION_VAL_9PX_ID NULL
#define OPTION_VAL_10PX_ID NULL
#define OPTION_VAL_11PX_ID NULL
#define OPTION_VAL_12PX_ID NULL
#define OPTION_VAL_13PX_ID NULL
#define OPTION_VAL_14PX_ID NULL
#define OPTION_VAL_15PX_ID NULL
#define OPTION_VAL_16PX_ID NULL
#define OPTION_VAL_17PX_ID NULL
#define OPTION_VAL_18PX_ID NULL
#define OPTION_VAL_19PX_ID NULL
#define OPTION_VAL_20PX_ID NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_ID NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_ID NULL
#define OPTION_VAL_12PX_O55_ID NULL
#define OPTION_VAL_11PX_O55_ID NULL
#define OPTION_VAL_10PX_O55_ID NULL
#define OPTION_VAL_9PX_O55_ID NULL
#define OPTION_VAL_8PX_O55_ID NULL
#define OPTION_VAL_7PX_O55_ID NULL
#define OPTION_VAL_6PX_O55_ID NULL
#define OPTION_VAL_5PX_O55_ID NULL
#define OPTION_VAL_4PX_O55_ID NULL
#define OPTION_VAL_3PX_O55_ID NULL
#define OPTION_VAL_2PX_O55_ID NULL
#define OPTION_VAL_1PX_O55_ID NULL
#define OPTION_VAL_DISABLED_O55_ID NULL
#define OPTION_VAL_1PX_O55_0_ID NULL
#define OPTION_VAL_2PX_O55_0_ID NULL
#define OPTION_VAL_3PX_O55_0_ID NULL
#define OPTION_VAL_4PX_O55_0_ID NULL
#define OPTION_VAL_5PX_O55_0_ID NULL
#define OPTION_VAL_6PX_O55_0_ID NULL
#define OPTION_VAL_7PX_O55_0_ID NULL
#define OPTION_VAL_8PX_O55_0_ID NULL
#define OPTION_VAL_9PX_O55_0_ID NULL
#define OPTION_VAL_10PX_O55_0_ID NULL
#define OPTION_VAL_11PX_O55_0_ID NULL
#define OPTION_VAL_12PX_O55_0_ID NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_ID NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_ID NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_ID NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_ID NULL
#define OPTION_VAL_32X_ID NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_ID NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_ID NULL
#define OPTION_VAL_CORRECTED_ID NULL
#define OPTION_VAL_UNCORRECTED_ID NULL
#define OPTION_VAL_4_3_ID NULL
#define OPTION_VAL_NTSC_ID NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_ID NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_ID NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_ID NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_ID NULL
#define OPTION_VAL_239_ID NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_ID NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_ID NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_ID NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_ID NULL
#define OPTION_VAL_287_ID NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_ID NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_ID NULL
#define OPTION_VAL_SYNC_ID NULL
#define OPTION_VAL_ASYNC_ID NULL
#define OPTION_VAL_PRECACHE_ID NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_ID NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_ID NULL
#define OPTION_VAL_2X_NATIVE_ID NULL
#define OPTION_VAL_6X_ID NULL
#define OPTION_VAL_10X_ID NULL
#define OPTION_VAL_12X_ID NULL
#define OPTION_VAL_14X_ID NULL

struct retro_core_option_v2_category option_cats_id[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_ID,
      CATEGORY_VIDEO_INFO_0_ID
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_ID,
      CATEGORY_OSD_INFO_0_ID
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_ID,
      CATEGORY_INPUT_INFO_0_ID
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_ID,
      CATEGORY_MEMCARDS_INFO_0_ID
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_ID,
      CATEGORY_PGXP_INFO_0_ID
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_ID,
      CATEGORY_HACKS_INFO_0_ID
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_id[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_ID,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_ID,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_ID },
         { "2x",         OPTION_VAL_2X_ID },
         { "4x",         OPTION_VAL_4X_ID },
         { "8x",         OPTION_VAL_8X_ID },
         { "16x",        OPTION_VAL_16X_ID },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_ID,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_ID,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_ID },
         { "32bpp",         OPTION_VAL_32BPP_ID },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_ID,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_ID,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_ID },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_ID },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_ID,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_ID,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_ID,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_ID,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_ID },
         { "SABR",     OPTION_VAL_SABR_ID },
         { "xBR",      OPTION_VAL_XBR_ID },
         { "bilinear", OPTION_VAL_BILINEAR_ID },
         { "3-point",  OPTION_VAL_3_POINT_ID },
         { "JINC2",    OPTION_VAL_JINC2_ID },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_ID,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_ID,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_ID },
         { "all", OPTION_VAL_ALL_ID },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_ID,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_ID,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_ID },
         { "all", OPTION_VAL_ALL_ID },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_ID,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_ID,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_ID,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_ID,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_ID,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_ID,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_ID },
         { "2x",  OPTION_VAL_2X_ID },
         { "4x",  OPTION_VAL_4X_ID },
         { "8x",  OPTION_VAL_8X_ID },
         { "16x", OPTION_VAL_16X_ID },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_ID,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_ID,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_ID,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_ID,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_ID,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_ID,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_ID,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_ID,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_ID,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_ID,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_ID,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_ID,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_ID,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_ID,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_ID,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_ID,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_ID,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_ID,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_ID,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_ID,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_ID,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_ID,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_ID,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_ID,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_ID,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_ID,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_ID },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_ID },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_ID,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_ID,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_ID },
         { "dot",   OPTION_VAL_DOT_ID },
         { "off",   OPTION_VAL_OFF_ID },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_ID,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_ID,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_ID },
         { "blue", OPTION_VAL_BLUE_ID },
         { "green", OPTION_VAL_GREEN_ID },
         { "orange", OPTION_VAL_ORANGE_ID },
         { "yellow", OPTION_VAL_YELLOW_ID },
         { "cyan", OPTION_VAL_CYAN_ID },
         { "pink", OPTION_VAL_PINK_ID },
         { "purple", OPTION_VAL_PURPLE_ID },
         { "black", OPTION_VAL_BLACK_ID },
         { "white", OPTION_VAL_WHITE_ID },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_ID,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_ID,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_ID },
         { "red", OPTION_VAL_RED_ID },
         { "green", OPTION_VAL_GREEN_ID },
         { "orange", OPTION_VAL_ORANGE_ID },
         { "yellow", OPTION_VAL_YELLOW_ID },
         { "cyan", OPTION_VAL_CYAN_ID },
         { "pink", OPTION_VAL_PINK_ID },
         { "purple", OPTION_VAL_PURPLE_ID },
         { "black", OPTION_VAL_BLACK_ID },
         { "white", OPTION_VAL_WHITE_ID },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_ID,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_ID,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_ID },
         { "10%",  OPTION_VAL_10_ID },
         { "15%",  OPTION_VAL_15_ID },
         { "20%",  OPTION_VAL_20_ID },
         { "25%",  OPTION_VAL_25_ID },
         { "30%",  OPTION_VAL_30_ID },
         { "35%",  OPTION_VAL_35_ID },
         { "40%",  OPTION_VAL_40_ID },
         { "45%",  OPTION_VAL_45_ID },
         { "50%",  OPTION_VAL_50_ID },
         { "55%",  OPTION_VAL_55_ID },
         { "60%",  OPTION_VAL_60_ID },
         { "65%",  OPTION_VAL_65_ID },
         { "70%",  OPTION_VAL_70_ID },
         { "75%",  OPTION_VAL_75_ID },
         { "80%",  OPTION_VAL_80_ID },
         { "85%",  OPTION_VAL_85_ID },
         { "90%",  OPTION_VAL_90_ID },
         { "95%",  OPTION_VAL_95_ID },
         { "100%", OPTION_VAL_100_ID },
         { "105%", OPTION_VAL_105_ID },
         { "110%", OPTION_VAL_110_ID },
         { "115%", OPTION_VAL_115_ID },
         { "120%", OPTION_VAL_120_ID },
         { "125%", OPTION_VAL_125_ID },
         { "130%", OPTION_VAL_130_ID },
         { "135%", OPTION_VAL_135_ID },
         { "140%", OPTION_VAL_140_ID },
         { "145%", OPTION_VAL_145_ID },
         { "150%", OPTION_VAL_150_ID },
         { "155%", OPTION_VAL_155_ID },
         { "160%", OPTION_VAL_160_ID },
         { "165%", OPTION_VAL_165_ID },
         { "170%", OPTION_VAL_170_ID },
         { "175%", OPTION_VAL_175_ID },
         { "180%", OPTION_VAL_180_ID },
         { "185%", OPTION_VAL_185_ID },
         { "190%", OPTION_VAL_190_ID },
         { "195%", OPTION_VAL_195_ID },
         { "200%", OPTION_VAL_200_ID },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_ID,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_ID,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_ID },
         { "quadratic", OPTION_VAL_QUADRATIC_ID },
         { "cubic",     OPTION_VAL_CUBIC_ID },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_ID,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_ID,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_ID },
         { "5%",  OPTION_VAL_5_ID },
         { "10%", OPTION_VAL_10_ID },
         { "15%", OPTION_VAL_15_ID },
         { "20%", OPTION_VAL_20_ID },
         { "25%", OPTION_VAL_25_ID },
         { "30%", OPTION_VAL_30_ID },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_ID,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_ID,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_ID },
         { "mednafen", OPTION_VAL_MEDNAFEN_ID },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_ID,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_ID,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_ID,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_ID,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_ID,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_ID,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_ID,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_ID,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_ID },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_ID,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_ID,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_ID },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_ID },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_ID,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_ID,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_ID },
         { "1px", OPTION_VAL_1PX_ID },
         { "2px", OPTION_VAL_2PX_ID },
         { "3px", OPTION_VAL_3PX_ID },
         { "4px", OPTION_VAL_4PX_ID },
         { "5px", OPTION_VAL_5PX_ID },
         { "6px", OPTION_VAL_6PX_ID },
         { "7px", OPTION_VAL_7PX_ID },
         { "8px", OPTION_VAL_8PX_ID },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_ID,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_ID,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_ID,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_ID,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_ID,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_ID,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_ID,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_ID,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_ID },
         { "aggressive", OPTION_VAL_AGGRESSIVE_ID },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_ID,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_ID,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_ID,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_ID,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_ID },
         { "16:10", OPTION_VAL_16_10_ID },
         { "18:9",  OPTION_VAL_18_9_ID },
         { "19:9",  OPTION_VAL_19_9_ID },
         { "20:9",  OPTION_VAL_20_9_ID },
         { "21:9",  OPTION_VAL_21_9_ID }, // 64:27
         { "32:9",  OPTION_VAL_32_9_ID },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_ID,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_ID,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_ID },
         { "60%",           OPTION_VAL_60_ID },
         { "70%",           OPTION_VAL_70_ID },
         { "80%",           OPTION_VAL_80_ID },
         { "90%",           OPTION_VAL_90_ID },
         { "100%(native)", OPTION_VAL_100_NATIVE_ID },
         { "110%",          OPTION_VAL_110_ID },
         { "120%",          OPTION_VAL_120_ID },
         { "130%",          OPTION_VAL_130_ID },
         { "140%",          OPTION_VAL_140_ID },
         { "150%",          OPTION_VAL_150_ID },
         { "160%",          OPTION_VAL_160_ID },
         { "170%",          OPTION_VAL_170_ID },
         { "180%",          OPTION_VAL_180_ID },
         { "190%",          OPTION_VAL_190_ID },
         { "200%",          OPTION_VAL_200_ID },
         { "210%",          OPTION_VAL_210_ID },
         { "220%",          OPTION_VAL_220_ID },
         { "230%",          OPTION_VAL_230_ID },
         { "240%",          OPTION_VAL_240_ID },
         { "250%",          OPTION_VAL_250_ID },
         { "260%",          OPTION_VAL_260_ID },
         { "270%",          OPTION_VAL_270_ID },
         { "280%",          OPTION_VAL_280_ID },
         { "290%",          OPTION_VAL_290_ID },
         { "300%",          OPTION_VAL_300_ID },
         { "310%",          OPTION_VAL_310_ID },
         { "320%",          OPTION_VAL_320_ID },
         { "330%",          OPTION_VAL_330_ID },
         { "340%",          OPTION_VAL_340_ID },
         { "350%",          OPTION_VAL_350_ID },
         { "360%",          OPTION_VAL_360_ID },
         { "370%",          OPTION_VAL_370_ID },
         { "380%",          OPTION_VAL_380_ID },
         { "390%",          OPTION_VAL_390_ID },
         { "400%",          OPTION_VAL_400_ID },
         { "410%",          OPTION_VAL_410_ID },
         { "420%",          OPTION_VAL_420_ID },
         { "430%",          OPTION_VAL_430_ID },
         { "440%",          OPTION_VAL_440_ID },
         { "450%",          OPTION_VAL_450_ID },
         { "460%",          OPTION_VAL_460_ID },
         { "470%",          OPTION_VAL_470_ID },
         { "480%",          OPTION_VAL_480_ID },
         { "490%",          OPTION_VAL_490_ID },
         { "500%",          OPTION_VAL_500_ID },
         { "510%",          OPTION_VAL_510_ID },
         { "520%",          OPTION_VAL_520_ID },
         { "530%",          OPTION_VAL_530_ID },
         { "540%",          OPTION_VAL_540_ID },
         { "550%",          OPTION_VAL_550_ID },
         { "560%",          OPTION_VAL_560_ID },
         { "570%",          OPTION_VAL_570_ID },
         { "580%",          OPTION_VAL_580_ID },
         { "590%",          OPTION_VAL_590_ID },
         { "600%",          OPTION_VAL_600_ID },
         { "610%",          OPTION_VAL_610_ID },
         { "620%",          OPTION_VAL_620_ID },
         { "630%",          OPTION_VAL_630_ID },
         { "640%",          OPTION_VAL_640_ID },
         { "650%",          OPTION_VAL_650_ID },
         { "660%",          OPTION_VAL_660_ID },
         { "670%",          OPTION_VAL_670_ID },
         { "680%",          OPTION_VAL_680_ID },
         { "690%",          OPTION_VAL_690_ID },
         { "700%",          OPTION_VAL_700_ID },
         { "710%",          OPTION_VAL_710_ID },
         { "720%",          OPTION_VAL_720_ID },
         { "730%",          OPTION_VAL_730_ID },
         { "740%",          OPTION_VAL_740_ID },
         { "750%",          OPTION_VAL_750_ID },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_ID,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_ID,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_ID,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_ID,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_ID,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_ID,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_ID },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_ID },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_ID,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_ID,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_ID },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_ID },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_ID },
#endif
         { "software",    OPTION_VAL_SOFTWARE_ID },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_ID,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_ID,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_ID,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_ID,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_ID },
         { "execute",  OPTION_VAL_EXECUTE_ID },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_ID },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_ID },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_ID,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_ID,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_ID },
         { "dma",  OPTION_VAL_DMA_ID },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_ID,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_ID,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_ID,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_ID,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_ID },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_ID },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_ID },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_ID,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_ID,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_ID,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_ID,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_ID },
         { "static",  OPTION_VAL_STATIC_ID },
         { "smart", OPTION_VAL_SMART_ID },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_ID,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_ID,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_ID },
         { "2px",      OPTION_VAL_2PX_ID },
         { "3px",      OPTION_VAL_3PX_ID },
         { "4px",      OPTION_VAL_4PX_ID },
         { "5px",      OPTION_VAL_5PX_ID },
         { "6px",      OPTION_VAL_6PX_ID },
         { "7px",      OPTION_VAL_7PX_ID },
         { "8px",      OPTION_VAL_8PX_ID },
         { "9px",      OPTION_VAL_9PX_ID },
         { "10px",     OPTION_VAL_10PX_ID },
         { "11px",     OPTION_VAL_11PX_ID },
         { "12px",     OPTION_VAL_12PX_ID },
         { "13px",     OPTION_VAL_13PX_ID },
         { "14px",     OPTION_VAL_14PX_ID },
         { "15px",     OPTION_VAL_15PX_ID },
         { "16px",     OPTION_VAL_16PX_ID },
         { "17px",     OPTION_VAL_17PX_ID },
         { "18px",     OPTION_VAL_18PX_ID },
         { "19px",     OPTION_VAL_19PX_ID },
         { "20px",     OPTION_VAL_20PX_ID },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_ID,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_ID,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_ID },
         { "-11px",    OPTION_VAL_11PX_O55_ID },
         { "-10px",    OPTION_VAL_10PX_O55_ID },
         { "-9px",     OPTION_VAL_9PX_O55_ID },
         { "-8px",     OPTION_VAL_8PX_O55_ID },
         { "-7px",     OPTION_VAL_7PX_O55_ID },
         { "-6px",     OPTION_VAL_6PX_O55_ID },
         { "-5px",     OPTION_VAL_5PX_O55_ID },
         { "-4px",     OPTION_VAL_4PX_O55_ID },
         { "-3px",     OPTION_VAL_3PX_O55_ID },
         { "-2px",     OPTION_VAL_2PX_O55_ID },
         { "-1px",     OPTION_VAL_1PX_O55_ID },
         { "disabled", OPTION_VAL_DISABLED_O55_ID },
         { "+1px",     OPTION_VAL_1PX_O55_0_ID },
         { "+2px",     OPTION_VAL_2PX_O55_0_ID },
         { "+3px",     OPTION_VAL_3PX_O55_0_ID },
         { "+4px",     OPTION_VAL_4PX_O55_0_ID },
         { "+5px",     OPTION_VAL_5PX_O55_0_ID },
         { "+6px",     OPTION_VAL_6PX_O55_0_ID },
         { "+7px",     OPTION_VAL_7PX_O55_0_ID },
         { "+8px",     OPTION_VAL_8PX_O55_0_ID },
         { "+9px",     OPTION_VAL_9PX_O55_0_ID },
         { "+10px",    OPTION_VAL_10PX_O55_0_ID },
         { "+11px",    OPTION_VAL_11PX_O55_0_ID },
         { "+12px",    OPTION_VAL_12PX_O55_0_ID },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_ID,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_ID,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_ID },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_ID,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_ID,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_ID },
         { "2x",         OPTION_VAL_2X_ID },
         { "4x",         OPTION_VAL_4X_ID },
         { "8x",         OPTION_VAL_8X_ID },
         { "16x",        OPTION_VAL_16X_ID },
         { "32x",        OPTION_VAL_32X_ID },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_ID,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_ID,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_ID },
         { "uncorrected", OPTION_VAL_UNCORRECTED_ID },
         { "4:3",  OPTION_VAL_4_3_ID },
         { "ntsc", OPTION_VAL_NTSC_ID },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_ID,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_ID,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_ID,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_ID,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_ID },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_ID,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_ID,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_ID,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_ID,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_ID },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_ID,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_ID,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_ID },
         { "async",    OPTION_VAL_ASYNC_ID },
         { "precache", OPTION_VAL_PRECACHE_ID },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_ID,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_ID,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_ID },
         { "4x",          OPTION_VAL_4X_ID },
         { "6x",          OPTION_VAL_6X_ID },
         { "8x",          OPTION_VAL_8X_ID },
         { "10x",         OPTION_VAL_10X_ID },
         { "12x",         OPTION_VAL_12X_ID },
         { "14x",         OPTION_VAL_14X_ID },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_id = {
   option_cats_id,
   option_defs_id
};

/* RETRO_LANGUAGE_IT */

#define CATEGORY_VIDEO_LABEL_IT NULL
#define CATEGORY_VIDEO_INFO_0_IT "Cambia le proporzioni, il ritaglio, il filtro video e le impostazioni di salto dei fotogrammi."
#define CATEGORY_OSD_LABEL_IT "Notifiche A Schermo"
#define CATEGORY_OSD_INFO_0_IT "Modifica le notifiche visualizzate sullo schermo."
#define CATEGORY_INPUT_LABEL_IT NULL
#define CATEGORY_INPUT_INFO_0_IT "Cambia le impostazioni della pistola ottica, del mouse e del neGcon."
#define CATEGORY_MEMCARDS_LABEL_IT "Scheda Di Memoria"
#define CATEGORY_MEMCARDS_INFO_0_IT "Cambia le impostazioni relative alle schede di memoria virtuali utilizzate dal sistema."
#define CATEGORY_PGXP_LABEL_IT "Pgxp (Precision Geometry Transform Pipeline)"
#define CATEGORY_PGXP_INFO_0_IT "Queste opzioni controllano i miglioramenti che possono migliorare la grafica rispetto alla console originale. PGXP può sbarazzarsi di texture di deformazione e problemi di combattimento Z."
#define CATEGORY_HACKS_LABEL_IT "Emulazione hack"
#define CATEGORY_HACKS_INFO_0_IT "Cambia le impostazioni di overclocking e di precisione di emulazione del processore che influenzano prestazioni e compatibilità di basso livello."
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_IT "Risoluzione GPU Interna"
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_IT "Scegli il moltiplicatore di risoluzione interno. Risoluzioni superiori a '1x (Native)' migliorano la fedeltà dei modelli 3D a scapito di maggiori requisiti di prestazioni. Gli elementi 2D non sono generalmente influenzati da questa impostazione."
#define OPTION_VAL_1X_NATIVE_IT "1x (Nativo)"
#define OPTION_VAL_2X_IT NULL
#define OPTION_VAL_4X_IT NULL
#define OPTION_VAL_8X_IT NULL
#define OPTION_VAL_16X_IT NULL
#define BEETLE_OPT_DEPTH_LABEL_IT "Profondità Colori Interni"
#define BEETLE_OPT_DEPTH_INFO_0_IT "Scegli la profondità interna del colore. Profondità di colore più elevata può ridurre gli effetti di banding del colore senza l'uso di dithering. 16 bpp emula l'hardware originale ma può avere banding visibile se il dithering non è abilitato. 'Dithering Pattern' è consigliato di essere disabilitato quando questa opzione è impostata a 32 bpp."
#define OPTION_VAL_16BPP_NATIVE_IT "16 bpp (Nativo)"
#define OPTION_VAL_32BPP_IT NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_IT NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_IT "Scegli la configurazione del modello di dithering. '1x (Native)' emula il dithering nativo a bassa risoluzione usato dall'hardware originale per lisciare gli artefatti di banding a colori visibili a profondità di colore nativa. 'Risoluzione interna' scala la granularità del dithering alla risoluzione interna configurata per risultati più puliti. Consigliato di essere disabilitato quando si esegue a 32 bpp profondità di colore. Nota: Su Vulkan, abilitando questo forzerà il downsampling a profondità nativa del colore, mentre disabilitando automaticamente l'output verrà attivato a profondità di colore più alta."
#define OPTION_VAL_INTERNAL_RESOLUTION_IT "Risoluzione Interna"
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_IT "Offset Di Texture UV"
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_IT "Texture di esempio per poligoni 3D a uno offset per una risoluzione interna superiore a 1x. Riduce le cuciture di texture ma può causare difetti grafici indesiderati."
#define BEETLE_OPT_FILTER_LABEL_IT "Filtro Texture"
#define BEETLE_OPT_FILTER_INFO_0_IT "Scegli il metodo di filtraggio delle texture. 'Nearest' emula l'hardware originale. 'Bilinear' e '3-Point' sono filtri leviganti, che riducono la pixelazione tramite sfocatura. 'SABR', 'xBR' e 'JINC2' stanno aggiornando i filtri che possono migliorare la fedeltà/nitidezza della texture a scapito di maggiori requisiti di prestazioni. Supportato solo dai renderer hardware."
#define OPTION_VAL_NEAREST_IT "Più vicino"
#define OPTION_VAL_SABR_IT NULL
#define OPTION_VAL_XBR_IT NULL
#define OPTION_VAL_BILINEAR_IT "Bilineare"
#define OPTION_VAL_3_POINT_IT "3 Punti"
#define OPTION_VAL_JINC2_IT NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_IT "Escludi Sprite dal Filtro"
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_IT "Non applicare il filtraggio delle texture agli sprite. Previene cuciture in vari giochi con sfondi 2D renderizzati a sprite. Utilizzare insieme ad Adaptive Smoothing o ad un altro filtro post-elaborazione per il miglior effetto."
#define OPTION_VAL_OPAQUE_IT "Solo Opaco"
#define OPTION_VAL_ALL_IT "Opaco e semi-trasparente"
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_IT "Escludi poligoni 2D dal filtro"
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_IT "Non applicare il filtraggio delle texture ai poligoni 2D. I poligoni 2D vengono rilevati con un euristico e potrebbero esserci dei difetti. Utilizzare insieme ad Adaptive Smoothing o ad un altro filtro post-elaborazione per il miglior effetto."
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_IT "Smoothing Addativo"
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_IT "Liscia gli elementi di grafica 2D e interfaccia utente senza sfocare gli oggetti rendering 3D. Supportato solo dal renderer Vulkan."
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_IT "Supersampling"
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_IT "Downsample contenuto renderizzato da risoluzione interna upscaled fino a risoluzione nativa. Combinando questo con i moltiplicatori di risoluzione interna superiore consente di visualizzare i giochi con oggetti 3D anti-aliasing a bassa risoluzione nativa. Produce i migliori risultati quando applicato ai titoli che mescolano elementi 2D e 3D (ad es. Caratteri 3D su sfondo pre-renderizzato), e funziona bene in combinazione con ombreggiatori CRT. Supportato solo dal renderer Vulkan. Nota: si consiglia di disabilitare il 'Dithering Pattern' quando si attiva questa opzione."
#define BEETLE_OPT_MSAA_LABEL_IT "Multisample Anti-Aliasing (MSAA)"
#define BEETLE_OPT_MSAA_INFO_0_IT "Scegli il livello MSAA per il contenuto renderizzato. Migliora l'aspetto degli oggetti 3D. Supportato solo dal renderer Vulkan."
#define OPTION_VAL_1X_IT NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_IT "Filtro Chroma MDEC YUV Chroma"
#define BEETLE_OPT_MDEC_YUV_INFO_0_IT "Migliora la qualità della riproduzione FMV riducendo gli artefatti 'macroblocco' (squari/bordi frastagliati). supportati solo dal renderer Vulkan."
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_IT "Traccia Texture"
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_IT "Prerequisito per il dumping di texture e la sostituzione. Probabilmente si schianterà nella maggior parte dei giochi."
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_IT "Scarica Texture"
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_IT "Scarica le texture usate su <cd>-texture-dump/"
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_IT "Sostituisci Texture"
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_IT "Sostituisci le texture con versioni HD da <cd>-texture-replacements/"
#define BEETLE_OPT_WIREFRAME_LABEL_IT "Modalità Wireframe (Debug)"
#define BEETLE_OPT_WIREFRAME_INFO_0_IT "Render i modelli 3D in forma di contorno senza texture o ombreggiatura. Supportato solo dal renderer hardware OpenGL. Nota: Questo è per scopi di debug, e normalmente dovrebbe essere disabilitato."
#define BEETLE_OPT_FRAME_DUPING_LABEL_IT NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_IT "Quando abilitato e supportato dal frontend libretro, questo fornisce un piccolo aumento delle prestazioni dirigendo il frontend per ripetere il frame precedente se il core non ha nulla di nuovo da visualizzare."
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_IT "Visualizza Contatore FPS Interno"
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_IT "Visualizza il contatore del frame rate interno a cui viene renderizzato il contenuto del sistema PlayStation emulato. Nota: Richiede di essere abilitato l'opzione delle notifiche su schermo in libretro."
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_IT "Visualizza Full VRAM (Debug)"
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_IT "Visualizza l'intero VRAM della console emulata. Supportato solo dai renderer hardware OpenGL e Vulkan. Nota: Questo è per scopi di debug, e normalmente dovrebbe essere disabilitato."
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_IT "Auto-Calibrazione Analogici"
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_IT "Quando il dispositivo di ingresso è impostato su DualShock, Analog Controller, Analog Joystick, o neGcon, questa opzione consente la calibrazione dinamica degli ingressi analogici. I valori massimi registrati di input vengono monitorati in tempo reale e utilizzati per scalare le coordinate analogiche passate all'emulatore. Questo dovrebbe essere utilizzato per giochi come Mega Man Legends 2 che si aspettano valori più grandi di quello che i controller moderni forniscono. Per ottenere i migliori risultati, i bastoni analogici dovrebbero essere ruotati in tutta la misura per regolare l'algoritmo di calibrazione ogni volta che il contenuto viene caricato."
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_IT "Abilita Modalità Toggle Dualshock Analogico"
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_IT "Quando il tipo di dispositivo di ingresso è DualShock, questa opzione consente di attivare il DualShock emulato tra la modalità DIGITAL e ANALOG come l'hardware originale. Quando disabilitato, DualShock è bloccato in modalità ANALOG e quando abilitato, il DualShock può essere commutato tra la modalità DIGITAL e ANALOG premendo e tenendo premuto START+SELECT+L1+L2+R1+R2."
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_IT "Porta 1: Abilita Multitap"
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_IT "Abilita la funzionalità multitap sulla porta 1."
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_IT "Porta 2: Abilita Multitap"
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_IT "Abilita la funzionalità multitap sulla porta 2."
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_IT "Modalità Input Pistola"
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_IT "Scegli se usare un mouse controllato da Pistola ottica' o un ingresso 'Touchscreen' quando il tipo di dispositivo è impostato su 'Guncon/G-Con 45' o 'Justifier'."
#define OPTION_VAL_LIGHTGUN_IT "Pistola Ottica"
#define OPTION_VAL_TOUCHSCREEN_IT "Schermo tattile"
#define BEETLE_OPT_GUN_CURSOR_LABEL_IT "Cursore Pistola"
#define BEETLE_OPT_GUN_CURSOR_INFO_0_IT "Scegli il cursore della pistola da visualizzare sullo schermo mentre usi i tipi di dispositivo di input 'Guncon/G-Con 45' e 'Justifier'. Quando disabilitato, i mirini sono sempre nascosti."
#define OPTION_VAL_CROSS_IT "Croce"
#define OPTION_VAL_DOT_IT "Puntino"
#define OPTION_VAL_OFF_IT "Nessun Cursore"
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_IT "Porta 1: Colore Mirino Della Pistola"
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_IT "Scegli il colore del mirino della pistola leggera per la porta 1."
#define OPTION_VAL_RED_IT "Rosso"
#define OPTION_VAL_BLUE_IT "Blu"
#define OPTION_VAL_GREEN_IT "Verde"
#define OPTION_VAL_ORANGE_IT "Arancione"
#define OPTION_VAL_YELLOW_IT "Giallo"
#define OPTION_VAL_CYAN_IT "Ciano"
#define OPTION_VAL_PINK_IT "Rosa"
#define OPTION_VAL_PURPLE_IT "Viola"
#define OPTION_VAL_BLACK_IT "Nero"
#define OPTION_VAL_WHITE_IT "Bianco"
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_IT "Porta 2: Colore Mirino Della Pistola"
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_IT "Scegli il colore del mirino della pistola leggera per la porta 2."
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_IT "Sensibilità Mouse"
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_IT "Scegli la reattività del tipo di dispositivo di input 'Mouse'."
#define OPTION_VAL_5_IT NULL
#define OPTION_VAL_10_IT NULL
#define OPTION_VAL_15_IT NULL
#define OPTION_VAL_20_IT NULL
#define OPTION_VAL_25_IT NULL
#define OPTION_VAL_30_IT NULL
#define OPTION_VAL_35_IT NULL
#define OPTION_VAL_40_IT NULL
#define OPTION_VAL_45_IT NULL
#define OPTION_VAL_50_IT NULL
#define OPTION_VAL_55_IT NULL
#define OPTION_VAL_60_IT NULL
#define OPTION_VAL_65_IT NULL
#define OPTION_VAL_70_IT NULL
#define OPTION_VAL_75_IT NULL
#define OPTION_VAL_80_IT NULL
#define OPTION_VAL_85_IT NULL
#define OPTION_VAL_90_IT NULL
#define OPTION_VAL_95_IT NULL
#define OPTION_VAL_100_IT "100% (predefinito)"
#define OPTION_VAL_105_IT NULL
#define OPTION_VAL_110_IT NULL
#define OPTION_VAL_115_IT NULL
#define OPTION_VAL_120_IT NULL
#define OPTION_VAL_125_IT NULL
#define OPTION_VAL_130_IT NULL
#define OPTION_VAL_135_IT NULL
#define OPTION_VAL_140_IT NULL
#define OPTION_VAL_145_IT NULL
#define OPTION_VAL_150_IT NULL
#define OPTION_VAL_155_IT NULL
#define OPTION_VAL_160_IT NULL
#define OPTION_VAL_165_IT NULL
#define OPTION_VAL_170_IT NULL
#define OPTION_VAL_175_IT NULL
#define OPTION_VAL_180_IT NULL
#define OPTION_VAL_185_IT NULL
#define OPTION_VAL_190_IT NULL
#define OPTION_VAL_195_IT NULL
#define OPTION_VAL_200_IT NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_IT "risposta della torsione neGcon"
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_IT "Scegli il tipo di risposta della barra analogica RetroPad sinistra quando si simula l'azione 'twist' dei dispositivi di ingresso emulati 'neGcon'. Lo spostamento del bastone analogico può essere mappato sull'angolo di rotazione neGcon linearmente, quadraticamente o cubicamente. 'Quadratico' permette una maggiore precisione rispetto a 'lineare' quando si fanno piccoli movimenti. 'Cubic' aumenta ulteriormente la precisione di movimento piccolo, ma 'esagera' movimenti più grandi. Nota: 'Linear' è raccomandato solo quando si utilizzano le periferiche della ruota da corsa. I controllori convenzionali implementano input analogici in modo fondamentalmente diverso dal meccanismo neGcon 'twist', in modo tale che la mappatura lineare amplifica eccessivamente i piccoli movimenti, compromettendo il controllo fine. Nella maggior parte dei casi, 'Quadratico' fornisce la più vicina approssimazione di hardware reale."
#define OPTION_VAL_LINEAR_IT "Lineare"
#define OPTION_VAL_QUADRATIC_IT "Quadratico"
#define OPTION_VAL_CUBIC_IT "Cubico"
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_IT "zona morta della torsione del neGcon"
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_IT "Scegli la zona di chiusura della barra analogica sinistra RetroPad quando si simula l'azione 'twist' dei dispositivi di ingresso emulati 'neGcon'. Usato per eliminare la deriva del regolatore. Nota: la maggior parte dei titoli compatibili con neGcone forniscono opzioni di gioco per impostare un valore di zona di chiusura 'twist'. Per evitare la perdita di precisione, il deadzone di gioco dovrebbe *sempre* essere impostato a zero. Eventuali modifiche richieste dovrebbero *solo* essere applicate tramite questa opzione principale. Questo è particolarmente importante quando 'neGcon Twist Response' è impostato su 'Quadratico' o 'Cubic'."
#define OPTION_VAL_0_IT NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_IT "Metodo Memory Card 0 (necessita riavvio)"
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_IT "Seleziona il formato del salvataggio usato per la memory card 0. 'Libretro' è consigliato. 'Mednafen' può essere usato per compatibilità con la versione stand-alone di Mednafen."
#define OPTION_VAL_LIBRETRO_IT NULL
#define OPTION_VAL_MEDNAFEN_IT NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_IT "Abilita Memory Card 1"
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_IT "Emula una seconda scheda di memoria nello slot 1. Quando disabilitato, i giochi possono accedere solo alla scheda di memoria nello slot 0. Nota: alcuni giochi richiedono che questa opzione sia disabilitata per il corretto funzionamento (ad esempio Codename Tenka). Nota: la scheda di memoria 1 utilizza il formato di salvataggio Mednafen (.mcr)."
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_IT "Memory Cards Condivise (necessita riavvio)"
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_IT "Se abilitato, tutti i giochi salveranno e caricheranno dagli stessi file memory card. Se disabilitato, file memory card separati saranno generati per ogni oggetto di contenuto caricato. Nota: L'opzione 'Metodo Memory Card 0' deve essere impostato su 'Mednafen' per il funzionamento corretto delle memory card condivise."
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_IT "Indice Sinistro Memory Card"
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_IT "Cambia la scheda di memoria attualmente caricata nello slot a sinistra. Questa opzione funzionerà solo se il metodo della scheda di memoria 0 è impostato a Mednafen. La scheda predefinita è indice 0."
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_IT "Indice Destra Della Memory Card"
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_IT "Cambia la scheda di memoria attualmente caricata nello slot giusto. Questa opzione funzionerà solo se la scheda di memoria 1 è abilitata. La scheda predefinita è l'indice 1."
#define OPTION_VAL_1_IT "1 (Predefinito)"
#define BEETLE_OPT_PGXP_MODE_LABEL_IT "Modalità Operazione PGXP"
#define BEETLE_OPT_PGXP_MODE_INFO_0_IT "Permette agli oggetti 3D di essere renderizzati con precisione sub-pixel, minimizzando effetti di distorsione e jittering di oggetti 3D visti su hardware originario a causa di uso di punti prefissati per le coordinate dei vertici. 'Solo Memoria', avendo problemi di compatibilità minimi, è consigliato per uso generale. 'Memoria + CPU (Buggy)' può ridurre il jittering ulteriormente ma ha requisiti di performance alti e può causare vari errori geometrici."
#define OPTION_VAL_MEMORY_ONLY_IT "Solo Memoria"
#define OPTION_VAL_MEMORY_CPU_IT "Memoria + CPU (Buggy)"
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_IT "Tolerancia de geometría PGXP 2D"
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_IT "Ocultar errores más evidentes en las operaciones de PGXP: el valor especifica la tolerancia en la que se mantendrán los valores de PGXP en caso de geometrías sin la información de profundidad adecuada"
#define OPTION_VAL_0PX_IT NULL
#define OPTION_VAL_1PX_IT NULL
#define OPTION_VAL_2PX_IT NULL
#define OPTION_VAL_3PX_IT NULL
#define OPTION_VAL_4PX_IT NULL
#define OPTION_VAL_5PX_IT NULL
#define OPTION_VAL_6PX_IT NULL
#define OPTION_VAL_7PX_IT NULL
#define OPTION_VAL_8PX_IT NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_IT "Eliminación primitiva de PGXP"
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_IT "Utilice la implementación NCLIP de PGXP. Mejora la apariencia al reducir los agujeros en las geometrías con coordenadas PGXP. Se sabe que hace que algunos juegos se bloqueen en diversas circunstancias."
#define BEETLE_OPT_PGXP_VERTEX_LABEL_IT "Vertice Cache PGXP"
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_IT "Posizioni verticali migliorate per Cache PGXP per il riutilizzo tra disegni poligonali. Può potenzialmente migliorare l'allineamento degli oggetti e ridurre le cuciture visibili durante il rendering delle texture, ma i falsi positivi quando si interroga la cache possono produrre glitch grafici. Al momento si raccomanda di lasciare disabilitata questa opzione. Questa opzione è applicata solo quando la Modalità Operazione PGXP è abilitata. Supporta solo i renderer hardware."
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_IT "Prospettiva Texturing Corretta PGXP"
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_IT "Sostituisci la mappatura della trama PSX nativa con la mappatura della trama corretta in prospettiva. Elimina la distorsione dipendente dalla posizione e l'ordito delle texture, con conseguente coerenza delle texture. Questa opzione è applicata solo quando la Modalità Operazione PGXP è abilitata. Supporta solo i renderer hardware."
#define BEETLE_OPT_LINE_RENDER_LABEL_IT "Hack Line-to-Quad"
#define BEETLE_OPT_LINE_RENDER_INFO_0_IT "Scegli il metodo di hack line-to-quad. Alcuni giochi (ad esempio Doom, Hexen, Soul Blade, ecc. disegna linee orizzontali allungando triangoli alti di un pixel sullo schermo, che sono rasterizzati come una riga di pixel sull'hardware originale. Questo hack rileva questi piccoli triangoli e li converte in quadre secondo necessità, permettendo loro di essere visualizzati correttamente sui renderer hardware e a risoluzioni interne upscaled. 'Aggressivo' è richiesto per alcuni titoli (ad es. Forze Oscure, Duke Nukem) ma potrebbe altrimenti introdurre dei problemi grafici. Lasciare a 'Predefinito' se non è sicuro."
#define OPTION_VAL_DEFAULT_IT "Predefinito"
#define OPTION_VAL_AGGRESSIVE_IT "Aggressivo"
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_IT "Hack Modalità Widescreen"
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_IT "Render il contenuto 3D anamorficamente ed emette il framebuffer emulato ad un formato widescreen. Produce i migliori risultati con giochi completamente 3D. Gli elementi 2D saranno allungati orizzontalmente e potrebbero essere disallineati."
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_IT "Rapporto Dimensioni dell'Hack per Modalità Widescreen"
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_IT "Scegli il rapporto di proporzioni da usare dall'Hack della Modalità Widescreen."
#define OPTION_VAL_16_9_IT NULL
#define OPTION_VAL_16_10_IT NULL
#define OPTION_VAL_18_9_IT NULL
#define OPTION_VAL_19_9_IT NULL
#define OPTION_VAL_20_9_IT NULL
#define OPTION_VAL_21_9_IT NULL
#define OPTION_VAL_32_9_IT NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_IT "Frequenza CPU (Overclock)"
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_IT "Overclock (o underclock) della CPU PSX emulata. Overclocking può eliminare il rallentamento e migliorare i frame rate in alcuni giochi a scapito di maggiori requisiti di prestazioni. Si noti che alcuni giochi hanno un limitatore interno di frame rate e potrebbero non beneficiare di overclocking. Può causare determinati effetti ad animarsi più velocemente di quanto previsto in alcuni titoli quando sovraorologiato."
#define OPTION_VAL_100_NATIVE_IT "100% (Nativo)"
#define OPTION_VAL_210_IT NULL
#define OPTION_VAL_220_IT NULL
#define OPTION_VAL_230_IT NULL
#define OPTION_VAL_240_IT NULL
#define OPTION_VAL_250_IT NULL
#define OPTION_VAL_260_IT NULL
#define OPTION_VAL_270_IT NULL
#define OPTION_VAL_280_IT NULL
#define OPTION_VAL_290_IT NULL
#define OPTION_VAL_300_IT NULL
#define OPTION_VAL_310_IT NULL
#define OPTION_VAL_320_IT NULL
#define OPTION_VAL_330_IT NULL
#define OPTION_VAL_340_IT NULL
#define OPTION_VAL_350_IT NULL
#define OPTION_VAL_360_IT NULL
#define OPTION_VAL_370_IT NULL
#define OPTION_VAL_380_IT NULL
#define OPTION_VAL_390_IT NULL
#define OPTION_VAL_400_IT NULL
#define OPTION_VAL_410_IT NULL
#define OPTION_VAL_420_IT NULL
#define OPTION_VAL_430_IT NULL
#define OPTION_VAL_440_IT NULL
#define OPTION_VAL_450_IT NULL
#define OPTION_VAL_460_IT NULL
#define OPTION_VAL_470_IT NULL
#define OPTION_VAL_480_IT NULL
#define OPTION_VAL_490_IT NULL
#define OPTION_VAL_500_IT NULL
#define OPTION_VAL_510_IT NULL
#define OPTION_VAL_520_IT NULL
#define OPTION_VAL_530_IT NULL
#define OPTION_VAL_540_IT NULL
#define OPTION_VAL_550_IT NULL
#define OPTION_VAL_560_IT NULL
#define OPTION_VAL_570_IT NULL
#define OPTION_VAL_580_IT NULL
#define OPTION_VAL_590_IT NULL
#define OPTION_VAL_600_IT NULL
#define OPTION_VAL_610_IT NULL
#define OPTION_VAL_620_IT NULL
#define OPTION_VAL_630_IT NULL
#define OPTION_VAL_640_IT NULL
#define OPTION_VAL_650_IT NULL
#define OPTION_VAL_660_IT NULL
#define OPTION_VAL_670_IT NULL
#define OPTION_VAL_680_IT NULL
#define OPTION_VAL_690_IT NULL
#define OPTION_VAL_700_IT NULL
#define OPTION_VAL_710_IT NULL
#define OPTION_VAL_720_IT NULL
#define OPTION_VAL_730_IT NULL
#define OPTION_VAL_740_IT NULL
#define OPTION_VAL_750_IT NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_IT "Overclock GTE"
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_IT "Abbassa tutte le operazioni GTE emulate (CPU coprocessore per grafica 3D) ad una latenza costante di un ciclo. Per i giochi che fanno uso pesante del GTE, questo può migliorare notevolmente il frame rate e la stabilità del tempo del telaio."
#define BEETLE_OPT_SKIP_BIOS_LABEL_IT "Salta BIOS"
#define BEETLE_OPT_SKIP_BIOS_INFO_0_IT "Salta l'animazione di avvio del BIOS di PlayStation normalmente visualizzata durante il caricamento del contenuto. Nota: Abilitare questo causa problemi di compatibilità con un certo numero di giochi (PAL copia giochi protetti, Saga Frontier, ecc.)."
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_IT "Sovrascrivi BIOS (Riavvio Richiesto)"
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_IT "Scavalca il BIOS specifico della regione standard con uno senza regione se trovato."
#define OPTION_VAL_PSXONPSP_IT NULL
#define OPTION_VAL_PS1_ROM_IT NULL
#define BEETLE_OPT_RENDERER_LABEL_IT "Renderer (necessita riavvio)"
#define BEETLE_OPT_RENDERER_INFO_0_IT "Il renderer software è il più accurato, ma ha requisiti di prestazioni ripide quando si esegue a risoluzioni GPU interne aumentate. I renderer hardware, sebbene meno accurati, migliorano le prestazioni sul renderer software a risoluzioni interne aumentate e consentono vari miglioramenti grafici. 'Hardware (Auto)' seleziona automaticamente il renderer Vulkan o OpenGL, a seconda del driver video frontend libretro corrente. Se il driver video fornito non è compatibile con Vulkan o OpenGL 3.3, allora il core tornerà al renderer software."
#define OPTION_VAL_HARDWARE_IT "Hardware"
#define OPTION_VAL_HARDWARE_GL_IT NULL
#define OPTION_VAL_HARDWARE_VK_IT NULL
#define OPTION_VAL_SOFTWARE_IT NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_IT "Framebuffer Software"
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_IT "Abilita l'emulazione accurata di effetti framebuffer (es: motion blur, FF7 battle swirl) quando si utilizza renderer hardware usando una copia del renderer software a risoluzione nativa in sottofondo. Se disabilitato, le operazioni precedenti sono tralasciate (OpenGL) oppure renderizzate dalla GPU (Vulkan). Disabilitare questa impostazione può migliorare le performance ma potrebbe causare errori grafici gravi. In caso di incertezza lasciare 'Abilitato'."
#define BEETLE_OPT_CPU_DYNAREC_LABEL_IT "Ricompilazione Dinamica CPU (Dynarec)"
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_IT "Ricompila dinamicamente le istruzioni di CPU a istruzioni native. Molto più veloce dell'interpreter, ma i timing della CPU sono meno accurati e potrebbero avere bug."
#define OPTION_VAL_DISABLED_IT "Disabilitato (Beetle Interpreter)"
#define OPTION_VAL_EXECUTE_IT "Performance Massima"
#define OPTION_VAL_EXECUTE_ONE_IT "Controllo Tempi Ciclo"
#define OPTION_VAL_RUN_INTERPRETER_IT "Interprete Lightrec"
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_IT "Invalidamento Codice Dynarec"
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_IT "Alcuni giochi richiedono 'Full' invalidazione, alcuni richiedono 'DMA soltanto'."
#define OPTION_VAL_FULL_IT "Pieno"
#define OPTION_VAL_DMA_IT "Solo DMA (Leggermente più Veloce)"
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_IT "Cicli Eventi Dynarec DMA/GPU"
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_IT "Imposta quanti cicli possono passare nella CPU prima che un aggiornamento GPU o DMA è controllato. Un numero maggiore risulta in velocità maggiori, ma causa anche più probabilmente bug o crash. Questa impostazione ha molto meno impatto su beetle interpreter che su dynarec."
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_IT "Tempistica FPS segnalata dal core"
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_IT "Scegliere la tempistica FPS che il core riferirà al frontend. Attivazione automatica Permetterà al core di passare da tassi di segnalazione progressivi a tassi interlacciati, ma potrebbe causare la reinizione del driver video o audio."
#define OPTION_VAL_FORCE_PROGRESSIVE_IT "Tasso Progressivo"
#define OPTION_VAL_FORCE_INTERLACED_IT "Forza Tasso Interlacciato"
#define OPTION_VAL_AUTO_TOGGLE_IT "Consenti Attivazione Automatica"
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_IT "Sovrascrivi Video Pal (Europeo)"
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_IT "A causa di standard diversi, i giochi PAL appaiono spesso rallentati rispetto alle versioni NTSC americane o giapponesi. Questa opzione può essere utilizzata per sovrascrivere i timings PAL per tentare di eseguire questi giochi con il framerate NTSC. Questa opzione non ha effetto quando si esegue il contenuto NTSC."
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_IT "Taglia Overscan Orizzontale"
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_IT "'Nessuno' mantiene l'imbottitura (scatole pilastri su entrambi i lati dell'immagine per NTSC, su tutti i lati per PAL) per emulare le stesse barre nere generate in uscita video analogica da hardware PSX reale. 'Static' rimuove solo l'imbottitura orizzontale, 'Dynamic' rimuove tutte le imbottiture."
#define OPTION_VAL_DISABLED_O53_IT "Nessuno"
#define OPTION_VAL_STATIC_IT "Statico"
#define OPTION_VAL_SMART_IT "Dinamico (predefinito)"
#define BEETLE_OPT_IMAGE_CROP_LABEL_IT "Tagli Addizionali"
#define BEETLE_OPT_IMAGE_CROP_INFO_0_IT "Quando 'Ritaglia Overscan orizzontale' è abilitata, questa opzione riduce ulteriormente la larghezza dell'immagine ritagliata del numero di pixel specificato."
#define OPTION_VAL_9PX_IT NULL
#define OPTION_VAL_10PX_IT NULL
#define OPTION_VAL_11PX_IT NULL
#define OPTION_VAL_12PX_IT NULL
#define OPTION_VAL_13PX_IT NULL
#define OPTION_VAL_14PX_IT NULL
#define OPTION_VAL_15PX_IT NULL
#define OPTION_VAL_16PX_IT NULL
#define OPTION_VAL_17PX_IT NULL
#define OPTION_VAL_18PX_IT NULL
#define OPTION_VAL_19PX_IT NULL
#define OPTION_VAL_20PX_IT NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_IT "Offset Immagine Tagliata"
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_IT "Quando 'Ritaglia Overscan orizzontale' è abilitato, questo permette che l'immagine ritagliata risultante sia spostata orizzontalmente a destra (positiva) o a sinistra (negativa) del numero di pixel specificato. Può essere usato per correggere problemi di allineamento. Supportato solo dal renderer software."
#define OPTION_VAL_12PX_O55_IT NULL
#define OPTION_VAL_11PX_O55_IT NULL
#define OPTION_VAL_10PX_O55_IT NULL
#define OPTION_VAL_9PX_O55_IT NULL
#define OPTION_VAL_8PX_O55_IT NULL
#define OPTION_VAL_7PX_O55_IT NULL
#define OPTION_VAL_6PX_O55_IT NULL
#define OPTION_VAL_5PX_O55_IT NULL
#define OPTION_VAL_4PX_O55_IT NULL
#define OPTION_VAL_3PX_O55_IT NULL
#define OPTION_VAL_2PX_O55_IT NULL
#define OPTION_VAL_1PX_O55_IT NULL
#define OPTION_VAL_DISABLED_O55_IT "0 (Predefinito)"
#define OPTION_VAL_1PX_O55_0_IT NULL
#define OPTION_VAL_2PX_O55_0_IT NULL
#define OPTION_VAL_3PX_O55_0_IT NULL
#define OPTION_VAL_4PX_O55_0_IT NULL
#define OPTION_VAL_5PX_O55_0_IT NULL
#define OPTION_VAL_6PX_O55_0_IT NULL
#define OPTION_VAL_7PX_O55_0_IT NULL
#define OPTION_VAL_8PX_O55_0_IT NULL
#define OPTION_VAL_9PX_O55_0_IT NULL
#define OPTION_VAL_10PX_O55_0_IT NULL
#define OPTION_VAL_11PX_O55_0_IT NULL
#define OPTION_VAL_12PX_O55_0_IT NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_IT "Offset Immagine Orizzontale (Cicli GPU)"
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_IT "Scegli il numero di cicli GPU da cui spostare l'immagine. I valori positivi spostano l'immagine a destra, i valori negativi spostano l'immagine a sinistra. Sono supportati solo dai renderer hardware."
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_IT "Overclock Rasterizzatore GPU"
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_IT "Abilita l'overclock per il rasterizzatore 2D contenuto nella GPU del PSX emulato. Non migliora il rendering 3D e ha poco effetto in generale."
#define OPTION_VAL_32X_IT NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_IT "Rapporto d'aspetto Core"
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_IT "Scegli il rapporto di aspetto fornito dal nucleo. Questa impostazione viene ignorata quando le opzioni VRAM complete della modalità Widescreen Hack o Display sono abilitate."
#define OPTION_VAL_CORRECTED_IT "Corretto"
#define OPTION_VAL_UNCORRECTED_IT "Non Corretto"
#define OPTION_VAL_4_3_IT "Forza 4:3"
#define OPTION_VAL_NTSC_IT "Forza NTSC"
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_IT "Linea Iniziale Di Scansione - NTSC"
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_IT "Scegli la prima linea di scansione visualizzata quando esegui il contenuto NTSC. Valori maggiori di zero ridurranno l'altezza delle immagini in uscita ritagliando i pixel dal bordo più in alto. Può essere usato per contrastare la casella di lettere."
#define BEETLE_OPT_LAST_SCANLINE_LABEL_IT "Ultima Linea Di Scansione - NTSC"
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_IT "Scegli l'ultima linea di scansione visualizzata quando esegui il contenuto NTSC. Valori inferiori a 239 ridurranno l'altezza delle immagini in uscita ritagliando i pixel dal bordo più basso. Può essere usato per contrastare la casella di lettere."
#define OPTION_VAL_239_IT "239 (Predefinito)"
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_IT "Linea Iniziale Di Scansione - Pal"
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_IT "Scegliere la prima linea di scansione visualizzata quando si esegue il contenuto PAL. Valori maggiori di zero ridurranno l'altezza delle immagini in uscita ritagliando i pixel dal bordo più in alto. Può essere usato per contrastare la casella di lettere."
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_IT "Ultima Linea Di Scansione - Pal"
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_IT "Scegli l'ultima linea di scansione visualizzata quando si esegue il contenuto PAL. I valori inferiori a 287 ridurranno l'altezza delle immagini in uscita ritagliando i pixel dal bordo più basso. Può essere usato per contrastare la casella di lettere."
#define OPTION_VAL_287_IT "287 (Predefinito)"
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_IT "Metodo Accesso CD (necessita riavvio)"
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_IT "Scegli il metodo utilizzato per leggere i dati dalle immagini del disco del contenuto. 'Sincrono' imita l'hardware originale. 'Asynchronous' può ridurre la balbuzie su dispositivi con archiviazione lenta. 'Pre-Cache' carica l'intera immagine del disco in memoria quando si avvia il contenuto, che può migliorare i tempi di caricamento in gioco al costo di un ritardo iniziale all'avvio. 'Pre-Cache' può causare problemi sui sistemi con RAM bassa, e ricadrà su 'Sincrono' per i supporti fisici."
#define OPTION_VAL_SYNC_IT "Sincrono"
#define OPTION_VAL_ASYNC_IT "Asincrono"
#define OPTION_VAL_PRECACHE_IT NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_IT "Velocità Caricamento CD"
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_IT "Scegli moltiplicatore di velocità di accesso al disco. Valori superiori a '2x (Nativo)' possono ridurre notevolmente i tempi di caricamento in gioco, ma possono introdurre errori di temporizzazione. Alcuni giochi potrebbero non funzionare correttamente al di sopra di un certo valore."
#define OPTION_VAL_2X_NATIVE_IT "2x (Nativo)"
#define OPTION_VAL_6X_IT NULL
#define OPTION_VAL_10X_IT NULL
#define OPTION_VAL_12X_IT NULL
#define OPTION_VAL_14X_IT NULL

struct retro_core_option_v2_category option_cats_it[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_IT,
      CATEGORY_VIDEO_INFO_0_IT
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_IT,
      CATEGORY_OSD_INFO_0_IT
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_IT,
      CATEGORY_INPUT_INFO_0_IT
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_IT,
      CATEGORY_MEMCARDS_INFO_0_IT
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_IT,
      CATEGORY_PGXP_INFO_0_IT
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_IT,
      CATEGORY_HACKS_INFO_0_IT
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_it[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_IT,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_IT,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_IT },
         { "2x",         OPTION_VAL_2X_IT },
         { "4x",         OPTION_VAL_4X_IT },
         { "8x",         OPTION_VAL_8X_IT },
         { "16x",        OPTION_VAL_16X_IT },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_IT,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_IT,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_IT },
         { "32bpp",         OPTION_VAL_32BPP_IT },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_IT,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_IT,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_IT },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_IT },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_IT,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_IT,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_IT,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_IT,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_IT },
         { "SABR",     OPTION_VAL_SABR_IT },
         { "xBR",      OPTION_VAL_XBR_IT },
         { "bilinear", OPTION_VAL_BILINEAR_IT },
         { "3-point",  OPTION_VAL_3_POINT_IT },
         { "JINC2",    OPTION_VAL_JINC2_IT },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_IT,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_IT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_IT },
         { "all", OPTION_VAL_ALL_IT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_IT,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_IT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_IT },
         { "all", OPTION_VAL_ALL_IT },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_IT,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_IT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_IT,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_IT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_IT,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_IT,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_IT },
         { "2x",  OPTION_VAL_2X_IT },
         { "4x",  OPTION_VAL_4X_IT },
         { "8x",  OPTION_VAL_8X_IT },
         { "16x", OPTION_VAL_16X_IT },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_IT,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_IT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_IT,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_IT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_IT,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_IT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_IT,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_IT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_IT,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_IT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_IT,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_IT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_IT,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_IT,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_IT,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_IT,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_IT,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_IT,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_IT,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_IT,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_IT,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_IT,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_IT,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_IT,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_IT,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_IT,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_IT },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_IT },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_IT,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_IT,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_IT },
         { "dot",   OPTION_VAL_DOT_IT },
         { "off",   OPTION_VAL_OFF_IT },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_IT,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_IT,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_IT },
         { "blue", OPTION_VAL_BLUE_IT },
         { "green", OPTION_VAL_GREEN_IT },
         { "orange", OPTION_VAL_ORANGE_IT },
         { "yellow", OPTION_VAL_YELLOW_IT },
         { "cyan", OPTION_VAL_CYAN_IT },
         { "pink", OPTION_VAL_PINK_IT },
         { "purple", OPTION_VAL_PURPLE_IT },
         { "black", OPTION_VAL_BLACK_IT },
         { "white", OPTION_VAL_WHITE_IT },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_IT,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_IT,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_IT },
         { "red", OPTION_VAL_RED_IT },
         { "green", OPTION_VAL_GREEN_IT },
         { "orange", OPTION_VAL_ORANGE_IT },
         { "yellow", OPTION_VAL_YELLOW_IT },
         { "cyan", OPTION_VAL_CYAN_IT },
         { "pink", OPTION_VAL_PINK_IT },
         { "purple", OPTION_VAL_PURPLE_IT },
         { "black", OPTION_VAL_BLACK_IT },
         { "white", OPTION_VAL_WHITE_IT },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_IT,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_IT,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_IT },
         { "10%",  OPTION_VAL_10_IT },
         { "15%",  OPTION_VAL_15_IT },
         { "20%",  OPTION_VAL_20_IT },
         { "25%",  OPTION_VAL_25_IT },
         { "30%",  OPTION_VAL_30_IT },
         { "35%",  OPTION_VAL_35_IT },
         { "40%",  OPTION_VAL_40_IT },
         { "45%",  OPTION_VAL_45_IT },
         { "50%",  OPTION_VAL_50_IT },
         { "55%",  OPTION_VAL_55_IT },
         { "60%",  OPTION_VAL_60_IT },
         { "65%",  OPTION_VAL_65_IT },
         { "70%",  OPTION_VAL_70_IT },
         { "75%",  OPTION_VAL_75_IT },
         { "80%",  OPTION_VAL_80_IT },
         { "85%",  OPTION_VAL_85_IT },
         { "90%",  OPTION_VAL_90_IT },
         { "95%",  OPTION_VAL_95_IT },
         { "100%", OPTION_VAL_100_IT },
         { "105%", OPTION_VAL_105_IT },
         { "110%", OPTION_VAL_110_IT },
         { "115%", OPTION_VAL_115_IT },
         { "120%", OPTION_VAL_120_IT },
         { "125%", OPTION_VAL_125_IT },
         { "130%", OPTION_VAL_130_IT },
         { "135%", OPTION_VAL_135_IT },
         { "140%", OPTION_VAL_140_IT },
         { "145%", OPTION_VAL_145_IT },
         { "150%", OPTION_VAL_150_IT },
         { "155%", OPTION_VAL_155_IT },
         { "160%", OPTION_VAL_160_IT },
         { "165%", OPTION_VAL_165_IT },
         { "170%", OPTION_VAL_170_IT },
         { "175%", OPTION_VAL_175_IT },
         { "180%", OPTION_VAL_180_IT },
         { "185%", OPTION_VAL_185_IT },
         { "190%", OPTION_VAL_190_IT },
         { "195%", OPTION_VAL_195_IT },
         { "200%", OPTION_VAL_200_IT },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_IT,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_IT,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_IT },
         { "quadratic", OPTION_VAL_QUADRATIC_IT },
         { "cubic",     OPTION_VAL_CUBIC_IT },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_IT,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_IT,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_IT },
         { "5%",  OPTION_VAL_5_IT },
         { "10%", OPTION_VAL_10_IT },
         { "15%", OPTION_VAL_15_IT },
         { "20%", OPTION_VAL_20_IT },
         { "25%", OPTION_VAL_25_IT },
         { "30%", OPTION_VAL_30_IT },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_IT,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_IT,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_IT },
         { "mednafen", OPTION_VAL_MEDNAFEN_IT },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_IT,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_IT,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_IT,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_IT,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_IT,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_IT,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_IT,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_IT,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_IT },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_IT,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_IT,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_IT },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_IT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_IT,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_IT,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_IT },
         { "1px", OPTION_VAL_1PX_IT },
         { "2px", OPTION_VAL_2PX_IT },
         { "3px", OPTION_VAL_3PX_IT },
         { "4px", OPTION_VAL_4PX_IT },
         { "5px", OPTION_VAL_5PX_IT },
         { "6px", OPTION_VAL_6PX_IT },
         { "7px", OPTION_VAL_7PX_IT },
         { "8px", OPTION_VAL_8PX_IT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_IT,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_IT,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_IT,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_IT,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_IT,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_IT,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_IT,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_IT,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_IT },
         { "aggressive", OPTION_VAL_AGGRESSIVE_IT },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_IT,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_IT,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_IT,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_IT,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_IT },
         { "16:10", OPTION_VAL_16_10_IT },
         { "18:9",  OPTION_VAL_18_9_IT },
         { "19:9",  OPTION_VAL_19_9_IT },
         { "20:9",  OPTION_VAL_20_9_IT },
         { "21:9",  OPTION_VAL_21_9_IT }, // 64:27
         { "32:9",  OPTION_VAL_32_9_IT },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_IT,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_IT,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_IT },
         { "60%",           OPTION_VAL_60_IT },
         { "70%",           OPTION_VAL_70_IT },
         { "80%",           OPTION_VAL_80_IT },
         { "90%",           OPTION_VAL_90_IT },
         { "100%(native)", OPTION_VAL_100_NATIVE_IT },
         { "110%",          OPTION_VAL_110_IT },
         { "120%",          OPTION_VAL_120_IT },
         { "130%",          OPTION_VAL_130_IT },
         { "140%",          OPTION_VAL_140_IT },
         { "150%",          OPTION_VAL_150_IT },
         { "160%",          OPTION_VAL_160_IT },
         { "170%",          OPTION_VAL_170_IT },
         { "180%",          OPTION_VAL_180_IT },
         { "190%",          OPTION_VAL_190_IT },
         { "200%",          OPTION_VAL_200_IT },
         { "210%",          OPTION_VAL_210_IT },
         { "220%",          OPTION_VAL_220_IT },
         { "230%",          OPTION_VAL_230_IT },
         { "240%",          OPTION_VAL_240_IT },
         { "250%",          OPTION_VAL_250_IT },
         { "260%",          OPTION_VAL_260_IT },
         { "270%",          OPTION_VAL_270_IT },
         { "280%",          OPTION_VAL_280_IT },
         { "290%",          OPTION_VAL_290_IT },
         { "300%",          OPTION_VAL_300_IT },
         { "310%",          OPTION_VAL_310_IT },
         { "320%",          OPTION_VAL_320_IT },
         { "330%",          OPTION_VAL_330_IT },
         { "340%",          OPTION_VAL_340_IT },
         { "350%",          OPTION_VAL_350_IT },
         { "360%",          OPTION_VAL_360_IT },
         { "370%",          OPTION_VAL_370_IT },
         { "380%",          OPTION_VAL_380_IT },
         { "390%",          OPTION_VAL_390_IT },
         { "400%",          OPTION_VAL_400_IT },
         { "410%",          OPTION_VAL_410_IT },
         { "420%",          OPTION_VAL_420_IT },
         { "430%",          OPTION_VAL_430_IT },
         { "440%",          OPTION_VAL_440_IT },
         { "450%",          OPTION_VAL_450_IT },
         { "460%",          OPTION_VAL_460_IT },
         { "470%",          OPTION_VAL_470_IT },
         { "480%",          OPTION_VAL_480_IT },
         { "490%",          OPTION_VAL_490_IT },
         { "500%",          OPTION_VAL_500_IT },
         { "510%",          OPTION_VAL_510_IT },
         { "520%",          OPTION_VAL_520_IT },
         { "530%",          OPTION_VAL_530_IT },
         { "540%",          OPTION_VAL_540_IT },
         { "550%",          OPTION_VAL_550_IT },
         { "560%",          OPTION_VAL_560_IT },
         { "570%",          OPTION_VAL_570_IT },
         { "580%",          OPTION_VAL_580_IT },
         { "590%",          OPTION_VAL_590_IT },
         { "600%",          OPTION_VAL_600_IT },
         { "610%",          OPTION_VAL_610_IT },
         { "620%",          OPTION_VAL_620_IT },
         { "630%",          OPTION_VAL_630_IT },
         { "640%",          OPTION_VAL_640_IT },
         { "650%",          OPTION_VAL_650_IT },
         { "660%",          OPTION_VAL_660_IT },
         { "670%",          OPTION_VAL_670_IT },
         { "680%",          OPTION_VAL_680_IT },
         { "690%",          OPTION_VAL_690_IT },
         { "700%",          OPTION_VAL_700_IT },
         { "710%",          OPTION_VAL_710_IT },
         { "720%",          OPTION_VAL_720_IT },
         { "730%",          OPTION_VAL_730_IT },
         { "740%",          OPTION_VAL_740_IT },
         { "750%",          OPTION_VAL_750_IT },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_IT,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_IT,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_IT,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_IT,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_IT,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_IT,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_IT },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_IT },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_IT,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_IT,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_IT },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_IT },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_IT },
#endif
         { "software",    OPTION_VAL_SOFTWARE_IT },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_IT,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_IT,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_IT,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_IT,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_IT },
         { "execute",  OPTION_VAL_EXECUTE_IT },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_IT },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_IT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_IT,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_IT,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_IT },
         { "dma",  OPTION_VAL_DMA_IT },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_IT,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_IT,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_IT,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_IT,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_IT },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_IT },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_IT },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_IT,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_IT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_IT,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_IT,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_IT },
         { "static",  OPTION_VAL_STATIC_IT },
         { "smart", OPTION_VAL_SMART_IT },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_IT,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_IT,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_IT },
         { "2px",      OPTION_VAL_2PX_IT },
         { "3px",      OPTION_VAL_3PX_IT },
         { "4px",      OPTION_VAL_4PX_IT },
         { "5px",      OPTION_VAL_5PX_IT },
         { "6px",      OPTION_VAL_6PX_IT },
         { "7px",      OPTION_VAL_7PX_IT },
         { "8px",      OPTION_VAL_8PX_IT },
         { "9px",      OPTION_VAL_9PX_IT },
         { "10px",     OPTION_VAL_10PX_IT },
         { "11px",     OPTION_VAL_11PX_IT },
         { "12px",     OPTION_VAL_12PX_IT },
         { "13px",     OPTION_VAL_13PX_IT },
         { "14px",     OPTION_VAL_14PX_IT },
         { "15px",     OPTION_VAL_15PX_IT },
         { "16px",     OPTION_VAL_16PX_IT },
         { "17px",     OPTION_VAL_17PX_IT },
         { "18px",     OPTION_VAL_18PX_IT },
         { "19px",     OPTION_VAL_19PX_IT },
         { "20px",     OPTION_VAL_20PX_IT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_IT,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_IT,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_IT },
         { "-11px",    OPTION_VAL_11PX_O55_IT },
         { "-10px",    OPTION_VAL_10PX_O55_IT },
         { "-9px",     OPTION_VAL_9PX_O55_IT },
         { "-8px",     OPTION_VAL_8PX_O55_IT },
         { "-7px",     OPTION_VAL_7PX_O55_IT },
         { "-6px",     OPTION_VAL_6PX_O55_IT },
         { "-5px",     OPTION_VAL_5PX_O55_IT },
         { "-4px",     OPTION_VAL_4PX_O55_IT },
         { "-3px",     OPTION_VAL_3PX_O55_IT },
         { "-2px",     OPTION_VAL_2PX_O55_IT },
         { "-1px",     OPTION_VAL_1PX_O55_IT },
         { "disabled", OPTION_VAL_DISABLED_O55_IT },
         { "+1px",     OPTION_VAL_1PX_O55_0_IT },
         { "+2px",     OPTION_VAL_2PX_O55_0_IT },
         { "+3px",     OPTION_VAL_3PX_O55_0_IT },
         { "+4px",     OPTION_VAL_4PX_O55_0_IT },
         { "+5px",     OPTION_VAL_5PX_O55_0_IT },
         { "+6px",     OPTION_VAL_6PX_O55_0_IT },
         { "+7px",     OPTION_VAL_7PX_O55_0_IT },
         { "+8px",     OPTION_VAL_8PX_O55_0_IT },
         { "+9px",     OPTION_VAL_9PX_O55_0_IT },
         { "+10px",    OPTION_VAL_10PX_O55_0_IT },
         { "+11px",    OPTION_VAL_11PX_O55_0_IT },
         { "+12px",    OPTION_VAL_12PX_O55_0_IT },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_IT,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_IT,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_IT },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_IT,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_IT,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_IT },
         { "2x",         OPTION_VAL_2X_IT },
         { "4x",         OPTION_VAL_4X_IT },
         { "8x",         OPTION_VAL_8X_IT },
         { "16x",        OPTION_VAL_16X_IT },
         { "32x",        OPTION_VAL_32X_IT },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_IT,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_IT,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_IT },
         { "uncorrected", OPTION_VAL_UNCORRECTED_IT },
         { "4:3",  OPTION_VAL_4_3_IT },
         { "ntsc", OPTION_VAL_NTSC_IT },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_IT,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_IT,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_IT,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_IT,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_IT },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_IT,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_IT,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_IT,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_IT,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_IT },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_IT,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_IT,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_IT },
         { "async",    OPTION_VAL_ASYNC_IT },
         { "precache", OPTION_VAL_PRECACHE_IT },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_IT,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_IT,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_IT },
         { "4x",          OPTION_VAL_4X_IT },
         { "6x",          OPTION_VAL_6X_IT },
         { "8x",          OPTION_VAL_8X_IT },
         { "10x",         OPTION_VAL_10X_IT },
         { "12x",         OPTION_VAL_12X_IT },
         { "14x",         OPTION_VAL_14X_IT },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_it = {
   option_cats_it,
   option_defs_it
};

/* RETRO_LANGUAGE_JA */

#define CATEGORY_VIDEO_LABEL_JA "ビデオのドライバ"
#define CATEGORY_VIDEO_INFO_0_JA "アスペクト比、表示トリミング、ビデオフィルター、フレームスキップの設定を変更します。"
#define CATEGORY_OSD_LABEL_JA "OSD通知"
#define CATEGORY_OSD_INFO_0_JA NULL
#define CATEGORY_INPUT_LABEL_JA "入力"
#define CATEGORY_INPUT_INFO_0_JA NULL
#define CATEGORY_MEMCARDS_LABEL_JA NULL
#define CATEGORY_MEMCARDS_INFO_0_JA NULL
#define CATEGORY_PGXP_LABEL_JA NULL
#define CATEGORY_PGXP_INFO_0_JA NULL
#define CATEGORY_HACKS_LABEL_JA NULL
#define CATEGORY_HACKS_INFO_0_JA NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_JA NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_JA NULL
#define OPTION_VAL_1X_NATIVE_JA NULL
#define OPTION_VAL_2X_JA NULL
#define OPTION_VAL_4X_JA NULL
#define OPTION_VAL_8X_JA NULL
#define OPTION_VAL_16X_JA NULL
#define BEETLE_OPT_DEPTH_LABEL_JA NULL
#define BEETLE_OPT_DEPTH_INFO_0_JA NULL
#define OPTION_VAL_16BPP_NATIVE_JA NULL
#define OPTION_VAL_32BPP_JA NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_JA NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_JA NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_JA NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_JA NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_JA NULL
#define BEETLE_OPT_FILTER_LABEL_JA NULL
#define BEETLE_OPT_FILTER_INFO_0_JA NULL
#define OPTION_VAL_NEAREST_JA "ニアレスト"
#define OPTION_VAL_SABR_JA NULL
#define OPTION_VAL_XBR_JA NULL
#define OPTION_VAL_BILINEAR_JA "バイリニア（線形補間）"
#define OPTION_VAL_3_POINT_JA NULL
#define OPTION_VAL_JINC2_JA NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_JA NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_JA NULL
#define OPTION_VAL_OPAQUE_JA NULL
#define OPTION_VAL_ALL_JA NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_JA NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_JA NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_JA NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_JA NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_JA NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_JA NULL
#define BEETLE_OPT_MSAA_LABEL_JA NULL
#define BEETLE_OPT_MSAA_INFO_0_JA NULL
#define OPTION_VAL_1X_JA NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_JA NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_JA NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_JA NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_JA NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_JA NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_JA NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_JA NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_JA NULL
#define BEETLE_OPT_WIREFRAME_LABEL_JA NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_JA NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_JA NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_JA NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_JA NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_JA NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_JA NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_JA NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_JA NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_JA NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_JA NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_JA NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_JA NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_JA NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_JA NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_JA NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_JA NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_JA NULL
#define OPTION_VAL_LIGHTGUN_JA "ライトガン"
#define OPTION_VAL_TOUCHSCREEN_JA NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_JA NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_JA NULL
#define OPTION_VAL_CROSS_JA NULL
#define OPTION_VAL_DOT_JA NULL
#define OPTION_VAL_OFF_JA NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_JA NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_JA NULL
#define OPTION_VAL_RED_JA "レッド"
#define OPTION_VAL_BLUE_JA "ブルー"
#define OPTION_VAL_GREEN_JA "グリーン"
#define OPTION_VAL_ORANGE_JA NULL
#define OPTION_VAL_YELLOW_JA "イエロー"
#define OPTION_VAL_CYAN_JA NULL
#define OPTION_VAL_PINK_JA NULL
#define OPTION_VAL_PURPLE_JA NULL
#define OPTION_VAL_BLACK_JA NULL
#define OPTION_VAL_WHITE_JA NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_JA NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_JA NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_JA NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_JA NULL
#define OPTION_VAL_5_JA NULL
#define OPTION_VAL_10_JA NULL
#define OPTION_VAL_15_JA NULL
#define OPTION_VAL_20_JA NULL
#define OPTION_VAL_25_JA NULL
#define OPTION_VAL_30_JA NULL
#define OPTION_VAL_35_JA NULL
#define OPTION_VAL_40_JA NULL
#define OPTION_VAL_45_JA NULL
#define OPTION_VAL_50_JA NULL
#define OPTION_VAL_55_JA NULL
#define OPTION_VAL_60_JA NULL
#define OPTION_VAL_65_JA NULL
#define OPTION_VAL_70_JA NULL
#define OPTION_VAL_75_JA NULL
#define OPTION_VAL_80_JA NULL
#define OPTION_VAL_85_JA NULL
#define OPTION_VAL_90_JA NULL
#define OPTION_VAL_95_JA NULL
#define OPTION_VAL_100_JA "100% (デフォルト)"
#define OPTION_VAL_105_JA NULL
#define OPTION_VAL_110_JA NULL
#define OPTION_VAL_115_JA NULL
#define OPTION_VAL_120_JA NULL
#define OPTION_VAL_125_JA NULL
#define OPTION_VAL_130_JA NULL
#define OPTION_VAL_135_JA NULL
#define OPTION_VAL_140_JA NULL
#define OPTION_VAL_145_JA NULL
#define OPTION_VAL_150_JA NULL
#define OPTION_VAL_155_JA NULL
#define OPTION_VAL_160_JA NULL
#define OPTION_VAL_165_JA NULL
#define OPTION_VAL_170_JA NULL
#define OPTION_VAL_175_JA NULL
#define OPTION_VAL_180_JA NULL
#define OPTION_VAL_185_JA NULL
#define OPTION_VAL_190_JA NULL
#define OPTION_VAL_195_JA NULL
#define OPTION_VAL_200_JA NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_JA NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_JA NULL
#define OPTION_VAL_LINEAR_JA "リニア"
#define OPTION_VAL_QUADRATIC_JA NULL
#define OPTION_VAL_CUBIC_JA NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_JA NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_JA NULL
#define OPTION_VAL_0_JA NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_JA NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_JA NULL
#define OPTION_VAL_LIBRETRO_JA NULL
#define OPTION_VAL_MEDNAFEN_JA NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_JA NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_JA NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_JA NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_JA NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_JA NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_JA NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_JA NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_JA NULL
#define OPTION_VAL_1_JA NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_JA NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_JA NULL
#define OPTION_VAL_MEMORY_ONLY_JA NULL
#define OPTION_VAL_MEMORY_CPU_JA NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_JA NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_JA NULL
#define OPTION_VAL_0PX_JA NULL
#define OPTION_VAL_1PX_JA NULL
#define OPTION_VAL_2PX_JA NULL
#define OPTION_VAL_3PX_JA NULL
#define OPTION_VAL_4PX_JA NULL
#define OPTION_VAL_5PX_JA NULL
#define OPTION_VAL_6PX_JA NULL
#define OPTION_VAL_7PX_JA NULL
#define OPTION_VAL_8PX_JA NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_JA NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_JA NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_JA NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_JA NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_JA NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_JA NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_JA NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_JA NULL
#define OPTION_VAL_DEFAULT_JA "デフォルト"
#define OPTION_VAL_AGGRESSIVE_JA NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_JA NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_JA NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_JA NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_JA NULL
#define OPTION_VAL_16_9_JA NULL
#define OPTION_VAL_16_10_JA NULL
#define OPTION_VAL_18_9_JA NULL
#define OPTION_VAL_19_9_JA NULL
#define OPTION_VAL_20_9_JA NULL
#define OPTION_VAL_21_9_JA NULL
#define OPTION_VAL_32_9_JA NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_JA NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_JA NULL
#define OPTION_VAL_100_NATIVE_JA NULL
#define OPTION_VAL_210_JA NULL
#define OPTION_VAL_220_JA NULL
#define OPTION_VAL_230_JA NULL
#define OPTION_VAL_240_JA NULL
#define OPTION_VAL_250_JA NULL
#define OPTION_VAL_260_JA NULL
#define OPTION_VAL_270_JA NULL
#define OPTION_VAL_280_JA NULL
#define OPTION_VAL_290_JA NULL
#define OPTION_VAL_300_JA NULL
#define OPTION_VAL_310_JA NULL
#define OPTION_VAL_320_JA NULL
#define OPTION_VAL_330_JA NULL
#define OPTION_VAL_340_JA NULL
#define OPTION_VAL_350_JA NULL
#define OPTION_VAL_360_JA NULL
#define OPTION_VAL_370_JA NULL
#define OPTION_VAL_380_JA NULL
#define OPTION_VAL_390_JA NULL
#define OPTION_VAL_400_JA NULL
#define OPTION_VAL_410_JA NULL
#define OPTION_VAL_420_JA NULL
#define OPTION_VAL_430_JA NULL
#define OPTION_VAL_440_JA NULL
#define OPTION_VAL_450_JA NULL
#define OPTION_VAL_460_JA NULL
#define OPTION_VAL_470_JA NULL
#define OPTION_VAL_480_JA NULL
#define OPTION_VAL_490_JA NULL
#define OPTION_VAL_500_JA NULL
#define OPTION_VAL_510_JA NULL
#define OPTION_VAL_520_JA NULL
#define OPTION_VAL_530_JA NULL
#define OPTION_VAL_540_JA NULL
#define OPTION_VAL_550_JA NULL
#define OPTION_VAL_560_JA NULL
#define OPTION_VAL_570_JA NULL
#define OPTION_VAL_580_JA NULL
#define OPTION_VAL_590_JA NULL
#define OPTION_VAL_600_JA NULL
#define OPTION_VAL_610_JA NULL
#define OPTION_VAL_620_JA NULL
#define OPTION_VAL_630_JA NULL
#define OPTION_VAL_640_JA NULL
#define OPTION_VAL_650_JA NULL
#define OPTION_VAL_660_JA NULL
#define OPTION_VAL_670_JA NULL
#define OPTION_VAL_680_JA NULL
#define OPTION_VAL_690_JA NULL
#define OPTION_VAL_700_JA NULL
#define OPTION_VAL_710_JA NULL
#define OPTION_VAL_720_JA NULL
#define OPTION_VAL_730_JA NULL
#define OPTION_VAL_740_JA NULL
#define OPTION_VAL_750_JA NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_JA NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_JA NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_JA NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_JA NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_JA NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_JA NULL
#define OPTION_VAL_PSXONPSP_JA NULL
#define OPTION_VAL_PS1_ROM_JA NULL
#define BEETLE_OPT_RENDERER_LABEL_JA NULL
#define BEETLE_OPT_RENDERER_INFO_0_JA NULL
#define OPTION_VAL_HARDWARE_JA NULL
#define OPTION_VAL_HARDWARE_GL_JA NULL
#define OPTION_VAL_HARDWARE_VK_JA NULL
#define OPTION_VAL_SOFTWARE_JA NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_JA NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_JA NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_JA NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_JA NULL
#define OPTION_VAL_DISABLED_JA NULL
#define OPTION_VAL_EXECUTE_JA NULL
#define OPTION_VAL_EXECUTE_ONE_JA NULL
#define OPTION_VAL_RUN_INTERPRETER_JA NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_JA NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_JA NULL
#define OPTION_VAL_FULL_JA NULL
#define OPTION_VAL_DMA_JA NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_JA NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_JA NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_JA NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_JA NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_JA NULL
#define OPTION_VAL_FORCE_INTERLACED_JA NULL
#define OPTION_VAL_AUTO_TOGGLE_JA NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_JA NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_JA NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_JA NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_JA NULL
#define OPTION_VAL_DISABLED_O53_JA "なし"
#define OPTION_VAL_STATIC_JA NULL
#define OPTION_VAL_SMART_JA NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_JA NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_JA NULL
#define OPTION_VAL_9PX_JA NULL
#define OPTION_VAL_10PX_JA NULL
#define OPTION_VAL_11PX_JA NULL
#define OPTION_VAL_12PX_JA NULL
#define OPTION_VAL_13PX_JA NULL
#define OPTION_VAL_14PX_JA NULL
#define OPTION_VAL_15PX_JA NULL
#define OPTION_VAL_16PX_JA NULL
#define OPTION_VAL_17PX_JA NULL
#define OPTION_VAL_18PX_JA NULL
#define OPTION_VAL_19PX_JA NULL
#define OPTION_VAL_20PX_JA NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_JA NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_JA NULL
#define OPTION_VAL_12PX_O55_JA NULL
#define OPTION_VAL_11PX_O55_JA NULL
#define OPTION_VAL_10PX_O55_JA NULL
#define OPTION_VAL_9PX_O55_JA NULL
#define OPTION_VAL_8PX_O55_JA NULL
#define OPTION_VAL_7PX_O55_JA NULL
#define OPTION_VAL_6PX_O55_JA NULL
#define OPTION_VAL_5PX_O55_JA NULL
#define OPTION_VAL_4PX_O55_JA NULL
#define OPTION_VAL_3PX_O55_JA NULL
#define OPTION_VAL_2PX_O55_JA NULL
#define OPTION_VAL_1PX_O55_JA NULL
#define OPTION_VAL_DISABLED_O55_JA NULL
#define OPTION_VAL_1PX_O55_0_JA NULL
#define OPTION_VAL_2PX_O55_0_JA NULL
#define OPTION_VAL_3PX_O55_0_JA NULL
#define OPTION_VAL_4PX_O55_0_JA NULL
#define OPTION_VAL_5PX_O55_0_JA NULL
#define OPTION_VAL_6PX_O55_0_JA NULL
#define OPTION_VAL_7PX_O55_0_JA NULL
#define OPTION_VAL_8PX_O55_0_JA NULL
#define OPTION_VAL_9PX_O55_0_JA NULL
#define OPTION_VAL_10PX_O55_0_JA NULL
#define OPTION_VAL_11PX_O55_0_JA NULL
#define OPTION_VAL_12PX_O55_0_JA NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_JA NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_JA NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_JA NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_JA NULL
#define OPTION_VAL_32X_JA NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_JA NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_JA NULL
#define OPTION_VAL_CORRECTED_JA NULL
#define OPTION_VAL_UNCORRECTED_JA NULL
#define OPTION_VAL_4_3_JA NULL
#define OPTION_VAL_NTSC_JA NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_JA NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_JA NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_JA NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_JA NULL
#define OPTION_VAL_239_JA NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_JA NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_JA NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_JA NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_JA NULL
#define OPTION_VAL_287_JA NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_JA NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_JA NULL
#define OPTION_VAL_SYNC_JA NULL
#define OPTION_VAL_ASYNC_JA NULL
#define OPTION_VAL_PRECACHE_JA NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_JA NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_JA NULL
#define OPTION_VAL_2X_NATIVE_JA NULL
#define OPTION_VAL_6X_JA NULL
#define OPTION_VAL_10X_JA NULL
#define OPTION_VAL_12X_JA NULL
#define OPTION_VAL_14X_JA NULL

struct retro_core_option_v2_category option_cats_ja[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_JA,
      CATEGORY_VIDEO_INFO_0_JA
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_JA,
      CATEGORY_OSD_INFO_0_JA
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_JA,
      CATEGORY_INPUT_INFO_0_JA
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_JA,
      CATEGORY_MEMCARDS_INFO_0_JA
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_JA,
      CATEGORY_PGXP_INFO_0_JA
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_JA,
      CATEGORY_HACKS_INFO_0_JA
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_ja[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_JA,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_JA,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_JA },
         { "2x",         OPTION_VAL_2X_JA },
         { "4x",         OPTION_VAL_4X_JA },
         { "8x",         OPTION_VAL_8X_JA },
         { "16x",        OPTION_VAL_16X_JA },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_JA,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_JA,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_JA },
         { "32bpp",         OPTION_VAL_32BPP_JA },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_JA,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_JA,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_JA },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_JA },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_JA,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_JA,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_JA,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_JA,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_JA },
         { "SABR",     OPTION_VAL_SABR_JA },
         { "xBR",      OPTION_VAL_XBR_JA },
         { "bilinear", OPTION_VAL_BILINEAR_JA },
         { "3-point",  OPTION_VAL_3_POINT_JA },
         { "JINC2",    OPTION_VAL_JINC2_JA },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_JA,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_JA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_JA },
         { "all", OPTION_VAL_ALL_JA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_JA,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_JA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_JA },
         { "all", OPTION_VAL_ALL_JA },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_JA,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_JA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_JA,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_JA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_JA,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_JA,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_JA },
         { "2x",  OPTION_VAL_2X_JA },
         { "4x",  OPTION_VAL_4X_JA },
         { "8x",  OPTION_VAL_8X_JA },
         { "16x", OPTION_VAL_16X_JA },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_JA,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_JA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_JA,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_JA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_JA,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_JA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_JA,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_JA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_JA,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_JA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_JA,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_JA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_JA,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_JA,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_JA,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_JA,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_JA,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_JA,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_JA,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_JA,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_JA,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_JA,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_JA,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_JA,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_JA,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_JA,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_JA },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_JA },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_JA,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_JA,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_JA },
         { "dot",   OPTION_VAL_DOT_JA },
         { "off",   OPTION_VAL_OFF_JA },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_JA,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_JA,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_JA },
         { "blue", OPTION_VAL_BLUE_JA },
         { "green", OPTION_VAL_GREEN_JA },
         { "orange", OPTION_VAL_ORANGE_JA },
         { "yellow", OPTION_VAL_YELLOW_JA },
         { "cyan", OPTION_VAL_CYAN_JA },
         { "pink", OPTION_VAL_PINK_JA },
         { "purple", OPTION_VAL_PURPLE_JA },
         { "black", OPTION_VAL_BLACK_JA },
         { "white", OPTION_VAL_WHITE_JA },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_JA,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_JA,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_JA },
         { "red", OPTION_VAL_RED_JA },
         { "green", OPTION_VAL_GREEN_JA },
         { "orange", OPTION_VAL_ORANGE_JA },
         { "yellow", OPTION_VAL_YELLOW_JA },
         { "cyan", OPTION_VAL_CYAN_JA },
         { "pink", OPTION_VAL_PINK_JA },
         { "purple", OPTION_VAL_PURPLE_JA },
         { "black", OPTION_VAL_BLACK_JA },
         { "white", OPTION_VAL_WHITE_JA },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_JA,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_JA,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_JA },
         { "10%",  OPTION_VAL_10_JA },
         { "15%",  OPTION_VAL_15_JA },
         { "20%",  OPTION_VAL_20_JA },
         { "25%",  OPTION_VAL_25_JA },
         { "30%",  OPTION_VAL_30_JA },
         { "35%",  OPTION_VAL_35_JA },
         { "40%",  OPTION_VAL_40_JA },
         { "45%",  OPTION_VAL_45_JA },
         { "50%",  OPTION_VAL_50_JA },
         { "55%",  OPTION_VAL_55_JA },
         { "60%",  OPTION_VAL_60_JA },
         { "65%",  OPTION_VAL_65_JA },
         { "70%",  OPTION_VAL_70_JA },
         { "75%",  OPTION_VAL_75_JA },
         { "80%",  OPTION_VAL_80_JA },
         { "85%",  OPTION_VAL_85_JA },
         { "90%",  OPTION_VAL_90_JA },
         { "95%",  OPTION_VAL_95_JA },
         { "100%", OPTION_VAL_100_JA },
         { "105%", OPTION_VAL_105_JA },
         { "110%", OPTION_VAL_110_JA },
         { "115%", OPTION_VAL_115_JA },
         { "120%", OPTION_VAL_120_JA },
         { "125%", OPTION_VAL_125_JA },
         { "130%", OPTION_VAL_130_JA },
         { "135%", OPTION_VAL_135_JA },
         { "140%", OPTION_VAL_140_JA },
         { "145%", OPTION_VAL_145_JA },
         { "150%", OPTION_VAL_150_JA },
         { "155%", OPTION_VAL_155_JA },
         { "160%", OPTION_VAL_160_JA },
         { "165%", OPTION_VAL_165_JA },
         { "170%", OPTION_VAL_170_JA },
         { "175%", OPTION_VAL_175_JA },
         { "180%", OPTION_VAL_180_JA },
         { "185%", OPTION_VAL_185_JA },
         { "190%", OPTION_VAL_190_JA },
         { "195%", OPTION_VAL_195_JA },
         { "200%", OPTION_VAL_200_JA },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_JA,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_JA,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_JA },
         { "quadratic", OPTION_VAL_QUADRATIC_JA },
         { "cubic",     OPTION_VAL_CUBIC_JA },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_JA,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_JA,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_JA },
         { "5%",  OPTION_VAL_5_JA },
         { "10%", OPTION_VAL_10_JA },
         { "15%", OPTION_VAL_15_JA },
         { "20%", OPTION_VAL_20_JA },
         { "25%", OPTION_VAL_25_JA },
         { "30%", OPTION_VAL_30_JA },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_JA,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_JA,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_JA },
         { "mednafen", OPTION_VAL_MEDNAFEN_JA },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_JA,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_JA,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_JA,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_JA,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_JA,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_JA,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_JA,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_JA,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_JA },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_JA,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_JA,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_JA },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_JA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_JA,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_JA,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_JA },
         { "1px", OPTION_VAL_1PX_JA },
         { "2px", OPTION_VAL_2PX_JA },
         { "3px", OPTION_VAL_3PX_JA },
         { "4px", OPTION_VAL_4PX_JA },
         { "5px", OPTION_VAL_5PX_JA },
         { "6px", OPTION_VAL_6PX_JA },
         { "7px", OPTION_VAL_7PX_JA },
         { "8px", OPTION_VAL_8PX_JA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_JA,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_JA,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_JA,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_JA,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_JA,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_JA,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_JA,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_JA,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_JA },
         { "aggressive", OPTION_VAL_AGGRESSIVE_JA },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_JA,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_JA,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_JA,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_JA,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_JA },
         { "16:10", OPTION_VAL_16_10_JA },
         { "18:9",  OPTION_VAL_18_9_JA },
         { "19:9",  OPTION_VAL_19_9_JA },
         { "20:9",  OPTION_VAL_20_9_JA },
         { "21:9",  OPTION_VAL_21_9_JA }, // 64:27
         { "32:9",  OPTION_VAL_32_9_JA },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_JA,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_JA,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_JA },
         { "60%",           OPTION_VAL_60_JA },
         { "70%",           OPTION_VAL_70_JA },
         { "80%",           OPTION_VAL_80_JA },
         { "90%",           OPTION_VAL_90_JA },
         { "100%(native)", OPTION_VAL_100_NATIVE_JA },
         { "110%",          OPTION_VAL_110_JA },
         { "120%",          OPTION_VAL_120_JA },
         { "130%",          OPTION_VAL_130_JA },
         { "140%",          OPTION_VAL_140_JA },
         { "150%",          OPTION_VAL_150_JA },
         { "160%",          OPTION_VAL_160_JA },
         { "170%",          OPTION_VAL_170_JA },
         { "180%",          OPTION_VAL_180_JA },
         { "190%",          OPTION_VAL_190_JA },
         { "200%",          OPTION_VAL_200_JA },
         { "210%",          OPTION_VAL_210_JA },
         { "220%",          OPTION_VAL_220_JA },
         { "230%",          OPTION_VAL_230_JA },
         { "240%",          OPTION_VAL_240_JA },
         { "250%",          OPTION_VAL_250_JA },
         { "260%",          OPTION_VAL_260_JA },
         { "270%",          OPTION_VAL_270_JA },
         { "280%",          OPTION_VAL_280_JA },
         { "290%",          OPTION_VAL_290_JA },
         { "300%",          OPTION_VAL_300_JA },
         { "310%",          OPTION_VAL_310_JA },
         { "320%",          OPTION_VAL_320_JA },
         { "330%",          OPTION_VAL_330_JA },
         { "340%",          OPTION_VAL_340_JA },
         { "350%",          OPTION_VAL_350_JA },
         { "360%",          OPTION_VAL_360_JA },
         { "370%",          OPTION_VAL_370_JA },
         { "380%",          OPTION_VAL_380_JA },
         { "390%",          OPTION_VAL_390_JA },
         { "400%",          OPTION_VAL_400_JA },
         { "410%",          OPTION_VAL_410_JA },
         { "420%",          OPTION_VAL_420_JA },
         { "430%",          OPTION_VAL_430_JA },
         { "440%",          OPTION_VAL_440_JA },
         { "450%",          OPTION_VAL_450_JA },
         { "460%",          OPTION_VAL_460_JA },
         { "470%",          OPTION_VAL_470_JA },
         { "480%",          OPTION_VAL_480_JA },
         { "490%",          OPTION_VAL_490_JA },
         { "500%",          OPTION_VAL_500_JA },
         { "510%",          OPTION_VAL_510_JA },
         { "520%",          OPTION_VAL_520_JA },
         { "530%",          OPTION_VAL_530_JA },
         { "540%",          OPTION_VAL_540_JA },
         { "550%",          OPTION_VAL_550_JA },
         { "560%",          OPTION_VAL_560_JA },
         { "570%",          OPTION_VAL_570_JA },
         { "580%",          OPTION_VAL_580_JA },
         { "590%",          OPTION_VAL_590_JA },
         { "600%",          OPTION_VAL_600_JA },
         { "610%",          OPTION_VAL_610_JA },
         { "620%",          OPTION_VAL_620_JA },
         { "630%",          OPTION_VAL_630_JA },
         { "640%",          OPTION_VAL_640_JA },
         { "650%",          OPTION_VAL_650_JA },
         { "660%",          OPTION_VAL_660_JA },
         { "670%",          OPTION_VAL_670_JA },
         { "680%",          OPTION_VAL_680_JA },
         { "690%",          OPTION_VAL_690_JA },
         { "700%",          OPTION_VAL_700_JA },
         { "710%",          OPTION_VAL_710_JA },
         { "720%",          OPTION_VAL_720_JA },
         { "730%",          OPTION_VAL_730_JA },
         { "740%",          OPTION_VAL_740_JA },
         { "750%",          OPTION_VAL_750_JA },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_JA,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_JA,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_JA,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_JA,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_JA,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_JA,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_JA },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_JA },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_JA,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_JA,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_JA },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_JA },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_JA },
#endif
         { "software",    OPTION_VAL_SOFTWARE_JA },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_JA,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_JA,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_JA,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_JA,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_JA },
         { "execute",  OPTION_VAL_EXECUTE_JA },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_JA },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_JA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_JA,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_JA,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_JA },
         { "dma",  OPTION_VAL_DMA_JA },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_JA,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_JA,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_JA,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_JA,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_JA },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_JA },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_JA },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_JA,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_JA,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_JA,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_JA,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_JA },
         { "static",  OPTION_VAL_STATIC_JA },
         { "smart", OPTION_VAL_SMART_JA },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_JA,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_JA,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_JA },
         { "2px",      OPTION_VAL_2PX_JA },
         { "3px",      OPTION_VAL_3PX_JA },
         { "4px",      OPTION_VAL_4PX_JA },
         { "5px",      OPTION_VAL_5PX_JA },
         { "6px",      OPTION_VAL_6PX_JA },
         { "7px",      OPTION_VAL_7PX_JA },
         { "8px",      OPTION_VAL_8PX_JA },
         { "9px",      OPTION_VAL_9PX_JA },
         { "10px",     OPTION_VAL_10PX_JA },
         { "11px",     OPTION_VAL_11PX_JA },
         { "12px",     OPTION_VAL_12PX_JA },
         { "13px",     OPTION_VAL_13PX_JA },
         { "14px",     OPTION_VAL_14PX_JA },
         { "15px",     OPTION_VAL_15PX_JA },
         { "16px",     OPTION_VAL_16PX_JA },
         { "17px",     OPTION_VAL_17PX_JA },
         { "18px",     OPTION_VAL_18PX_JA },
         { "19px",     OPTION_VAL_19PX_JA },
         { "20px",     OPTION_VAL_20PX_JA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_JA,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_JA,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_JA },
         { "-11px",    OPTION_VAL_11PX_O55_JA },
         { "-10px",    OPTION_VAL_10PX_O55_JA },
         { "-9px",     OPTION_VAL_9PX_O55_JA },
         { "-8px",     OPTION_VAL_8PX_O55_JA },
         { "-7px",     OPTION_VAL_7PX_O55_JA },
         { "-6px",     OPTION_VAL_6PX_O55_JA },
         { "-5px",     OPTION_VAL_5PX_O55_JA },
         { "-4px",     OPTION_VAL_4PX_O55_JA },
         { "-3px",     OPTION_VAL_3PX_O55_JA },
         { "-2px",     OPTION_VAL_2PX_O55_JA },
         { "-1px",     OPTION_VAL_1PX_O55_JA },
         { "disabled", OPTION_VAL_DISABLED_O55_JA },
         { "+1px",     OPTION_VAL_1PX_O55_0_JA },
         { "+2px",     OPTION_VAL_2PX_O55_0_JA },
         { "+3px",     OPTION_VAL_3PX_O55_0_JA },
         { "+4px",     OPTION_VAL_4PX_O55_0_JA },
         { "+5px",     OPTION_VAL_5PX_O55_0_JA },
         { "+6px",     OPTION_VAL_6PX_O55_0_JA },
         { "+7px",     OPTION_VAL_7PX_O55_0_JA },
         { "+8px",     OPTION_VAL_8PX_O55_0_JA },
         { "+9px",     OPTION_VAL_9PX_O55_0_JA },
         { "+10px",    OPTION_VAL_10PX_O55_0_JA },
         { "+11px",    OPTION_VAL_11PX_O55_0_JA },
         { "+12px",    OPTION_VAL_12PX_O55_0_JA },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_JA,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_JA,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_JA },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_JA,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_JA,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_JA },
         { "2x",         OPTION_VAL_2X_JA },
         { "4x",         OPTION_VAL_4X_JA },
         { "8x",         OPTION_VAL_8X_JA },
         { "16x",        OPTION_VAL_16X_JA },
         { "32x",        OPTION_VAL_32X_JA },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_JA,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_JA,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_JA },
         { "uncorrected", OPTION_VAL_UNCORRECTED_JA },
         { "4:3",  OPTION_VAL_4_3_JA },
         { "ntsc", OPTION_VAL_NTSC_JA },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_JA,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_JA,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_JA,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_JA,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_JA },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_JA,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_JA,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_JA,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_JA,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_JA },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_JA,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_JA,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_JA },
         { "async",    OPTION_VAL_ASYNC_JA },
         { "precache", OPTION_VAL_PRECACHE_JA },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_JA,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_JA,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_JA },
         { "4x",          OPTION_VAL_4X_JA },
         { "6x",          OPTION_VAL_6X_JA },
         { "8x",          OPTION_VAL_8X_JA },
         { "10x",         OPTION_VAL_10X_JA },
         { "12x",         OPTION_VAL_12X_JA },
         { "14x",         OPTION_VAL_14X_JA },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_ja = {
   option_cats_ja,
   option_defs_ja
};

/* RETRO_LANGUAGE_KO */

#define CATEGORY_VIDEO_LABEL_KO "비디오"
#define CATEGORY_VIDEO_INFO_0_KO "화면비, 잘라내기, 비디오 필터, 프레임 스킵 등의 설정을 변경합니다."
#define CATEGORY_OSD_LABEL_KO "OSD 알림"
#define CATEGORY_OSD_INFO_0_KO "화면에 표시되는 OSD 알림을 설정합니다."
#define CATEGORY_INPUT_LABEL_KO "입력"
#define CATEGORY_INPUT_INFO_0_KO "라이트 건, 마우스, neGcon 등을 설정합니다."
#define CATEGORY_MEMCARDS_LABEL_KO "메모리 카드"
#define CATEGORY_MEMCARDS_INFO_0_KO "시스템이 사용할 가상의 메모리 카드 설정을 변경합니다."
#define CATEGORY_PGXP_LABEL_KO NULL
#define CATEGORY_PGXP_INFO_0_KO "그래픽을 원본 하드웨어보다 더 좋게 개선하는 설정을 조정합니다. PGXP는 텍스쳐 뒤틀림과 Z-파이팅 문제를 해결할 수 있습니다."
#define CATEGORY_HACKS_LABEL_KO "에뮬레이션 핵"
#define CATEGORY_HACKS_INFO_0_KO "성능과 호환성에 영향을 끼치는 프로세서 오버클러킹 및 에뮬레이션 정확도 설정 등을 변경합니다."
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_KO "내부 GPU 해상도"
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_KO "내부 해상도의 배수를 설정합니다. '1x (네이티브)'보다 높은 값으로 설정할 경우 3D 모델의 품질이 개선되지만 요구되는 성능이 높아집니다. 2D 요소들은 일반적으로 이 설정에 아무런 영향을 받지 않습니다."
#define OPTION_VAL_1X_NATIVE_KO "1x (네이티브)"
#define OPTION_VAL_2X_KO NULL
#define OPTION_VAL_4X_KO NULL
#define OPTION_VAL_8X_KO NULL
#define OPTION_VAL_16X_KO NULL
#define BEETLE_OPT_DEPTH_LABEL_KO "내부 색 깊이"
#define BEETLE_OPT_DEPTH_INFO_0_KO "내부에서 사용할 색 깊이를 선택합니다. 높은 색 깊이는 디더링을 사용하지 않을 때 나타나는 색 밴딩 현상을 완화할 수 있습니다. 16 bpp는 원본 하드웨어를 에뮬레이트하며 디더링을 사용하지 않을 경우 눈에 띄는 색 밴딩이 나타날 수 있습니다. 이 옵션을 32 bpp로 설정할 경우 '디더링 패턴'을 비활성화할 것을 권장합니다."
#define OPTION_VAL_16BPP_NATIVE_KO "16 bpp (네이티브)"
#define OPTION_VAL_32BPP_KO NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_KO "디더링 패턴"
#define BEETLE_OPT_DITHER_MODE_INFO_0_KO "디더링 패턴을 설정합니다. '1x (네이티브)'는 원본 하드웨어의 저해상도 디더링을 에뮬레이트하여 네이티브 색 깊이에서 나타나는 색 밴딩 현상을 자연스럽게 숨깁니다. '내부 해상도'는 디더링을 내장 해상도에 맞춰 설정하여 깔끔한 결과물을 제공합니다. 32 bpp 색 깊이를 사용할 때는 비활성화할 것을 권장합니다. 주의: Vulcan에서 이 옵션을 사용하면 색 깊이가 네이티브 수치로 강제 다운샘플링되며 사용하지 않으면 자동으로 높은 색 깊이를 사용합니다."
#define OPTION_VAL_INTERNAL_RESOLUTION_KO "내부 해상도"
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_KO "텍스쳐 UV 오프셋"
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_KO "3D 폴리곤을 높은 해상도에서 표시할 때 텍스쳐를 설정한 오프셋에서 샘플링합니다. 텍스쳐 사이에 틈이 나타나는 것을 줄여주지만 의도되지 않은 그래픽 문제를 일으킬 수 있습니다."
#define BEETLE_OPT_FILTER_LABEL_KO "텍스쳐 필터링"
#define BEETLE_OPT_FILTER_INFO_0_KO "텍스쳐 필터링 방식을 선택합니다. '최근접 이웃'은 원본 하드웨어의 행동을 에뮬레이트합니다. '이중선형' 및 '3포인트'는 텍스쳐의 각짐을 줄이고 부드럽게 표시합니다. 'SABR', 'xBR', 'JINC2'는 업스케일링 필터로 텍스쳐의 품질/선명도를 개선할 수도 있지만 요구하는 성능이 더 높아집니다. 하드웨어 렌더러를 사용할 경우에만 적용됩니다."
#define OPTION_VAL_NEAREST_KO "최근접 이웃"
#define OPTION_VAL_SABR_KO NULL
#define OPTION_VAL_XBR_KO NULL
#define OPTION_VAL_BILINEAR_KO "이중선형"
#define OPTION_VAL_3_POINT_KO "3포인트"
#define OPTION_VAL_JINC2_KO NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_KO "스프라이트 필터링 안 함"
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_KO "스프라이트에는 텍스쳐 필터링을 적용하지 않습니다. 2D 스프라이트로 배경을 그리는 다양한 게임에서 틈이 생기는 것을 방지해줍니다. 최선의 효과를 얻으려면 선택적 스무딩 또는 다른 후처리 필터와 함께 사용하십시오."
#define OPTION_VAL_OPAQUE_KO "불투명 스프라이트만"
#define OPTION_VAL_ALL_KO "불투명 및 반투명 스프라이트"
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_KO "2D 폴리곤 필터링 안 함"
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_KO "2D 폴리곤에는 텍스쳐 필터링을 적용하지 않습니다. 2D 폴리곤은 휴리스틱으로 감지되며 오류가 있을 수 있습니다. 최선의 효과를 얻으려면 선택적 스무딩 또는 다른 후처리 필터와 함께 사용하십시오."
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_KO "선택적 스무딩"
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_KO "3D로 그려지는 개체를 제외한 2D 그림과 UI만 부드럽게 표시합니다. Vulkan 렌더러에서만 지원됩니다."
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_KO "슈퍼샘플링 (네이티브 해상도로 다운샘플)"
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_KO "높은 내부 해상도로 렌더된 컨텐츠를 네이티브 해상도로 다운샘플링하여 표시합니다. 이 옵션을 높은 내부 해상도와 함께 사용할 경우 게임을 3D 개체에 안티에일리어싱 효과가 적용된 네이티브 해상도로 표시할 수 있습니다. 2D와 3D 요소를 섞어 사용하는 게임(예: 미리 렌더된 배경 위 3D 캐릭터)에 적용했을 때 최선의 효과를 얻을 수 있으며, CRT 셰이더와 함께 사용하기 좋습니다. Vulkan 렌더러에서만 지원됩니다. 주의: 이 옵션을 사용할 경우 '디더링 패턴'을 비활성화하는 것을 추천합니다."
#define BEETLE_OPT_MSAA_LABEL_KO "멀티 샘플 안티에일리어싱 (MSAA)"
#define BEETLE_OPT_MSAA_INFO_0_KO "렌더링될 컨텐츠의 MSAA 수준을 선택합니다. 3D 개체의 표현을 개선합니다. Vulkan 렌더러에서만 지원됩니다."
#define OPTION_VAL_1X_KO NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_KO "MDEC YUV 크로마 필터"
#define BEETLE_OPT_MDEC_YUV_INFO_0_KO "'매크로블로킹' 아티팩트(사각형/날카로운 외곽선)를 감소시켜 FMV의 품질을 향상시킵니다. Vulkan 렌더러에서만 지원됩니다."
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_KO "텍스쳐 추적"
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_KO "텍스쳐를 덤프하거나 교체하기 위해 필요합니다. 대부분의 게임에서 오류를 일으킵니다."
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_KO "텍스쳐 덤프하기"
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_KO "사용된 텍스쳐를 <cd>-texture-dump/에 덤프합니다."
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_KO "텍스쳐 교체하기"
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_KO "텍스쳐를 <cd>-texture-replacements/의 HD 버전으로 교체합니다."
#define BEETLE_OPT_WIREFRAME_LABEL_KO "와이어프레임 모드 (디버그)"
#define BEETLE_OPT_WIREFRAME_INFO_0_KO "사용할 경우, 3D 모델을 텍스쳐 및 셰이딩 없이 외곽선으로만 표시합니다. OpenGL 하드웨어 렌더러에서만 지원됩니다. 주의: 이 옵션은 디버깅용으로, 일반적으로는 비활성화되어야 합니다."
#define BEETLE_OPT_FRAME_DUPING_LABEL_KO "프레임 복제 (가속)"
#define BEETLE_OPT_FRAME_DUPING_INFO_0_KO "지원되는 libretro 프론트엔드에서 사용할 경우, 코어가 새로 표시할 내용이 없을 때 프론트엔드가 이전 프레임을 반복하게 하여 성능을 약간 향상시킵니다."
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_KO "내부 FPS 표시"
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_KO "에뮬레이트된 PlayStation 시스템이 컨텐츠를 렌더링하는 내부 프레임 레이트를 표시합니다. 주의: libretro 프론트엔드에서 OSD 알림을 활성화해야 합니다."
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_KO "전체 VRAM 표시 (디버그)"
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_KO "에뮬레이트되는 콘솔의 VRAM을 전부 표시합니다. OpenGL 및 Vulkan 하드웨어 렌더러에서만 지원됩니다. 주의: 이 옵션은 디버깅용으로, 일반적으로는 비활성화되어야 합니다."
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_KO "아날로그 자가 교정"
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_KO "입력 장치가 DualShock, 아날로그 컨트롤러, 아날로그 조이스틱, neGcon으로 설정된 경우, 이 옵션은 아날로그 입력을 동적으로 교정하도록 합니다. 입력되는 최대 값을 실시간으로 확인하여 에뮬레이터에 조정된 아날로그 수치를 전달합니다. 이 설정은 Mega Man Legends 2처럼 현대의 컨트롤러들이 제공하는 값보다 더 큰 값을 기대하는 게임을 플레이할 때 사용되어야 합니다. 최선의 효과를 위해서는 컨텐츠를 불러올 때마다 아날로그 스틱들을 최대한 끝까지 밀고 한 바퀴 돌리는 동작을 수행하여 교정 알고리즘을 조율해야 합니다."
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_KO "DualShock 아날로그 모드 토글 활성화"
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_KO "입력 장치가 DualShock일 때, 에뮬레이트된 DualShock이 실제 하드웨어처럼 DIGITAL과 ANALOG 모드를 전환할 수 있어야 할지를 결정합니다. 비활성화할 경우 DualShock이 ANALOG 모드로 고정되며, 활성화할 경우 시작+선택+L1+L2+R1+R2 키를 꾹 눌러 DIGITAL과 ANALOG 모드를 전환할 수 있습니다."
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_KO "1번 포트에서 멀티탭 사용"
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_KO "1번 포트에 멀티탭 기능을 활성화합니다."
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_KO "2번 포트에서 멀티탭 사용"
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_KO "2번 포트에 멀티탭 기능을 활성화합니다."
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_KO "건 입력 모드"
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_KO "입력 장치가 'Guncon/G-Con 45' 또는 'Justifier'로 설정되었을 때, 마우스로 조작되는 '라이트 건'을 사용할 것인지 '터치스크린' 입력을 사용할 것인지 선택합니다."
#define OPTION_VAL_LIGHTGUN_KO "라이트 건"
#define OPTION_VAL_TOUCHSCREEN_KO "터치스크린"
#define BEETLE_OPT_GUN_CURSOR_LABEL_KO "건 커서"
#define BEETLE_OPT_GUN_CURSOR_INFO_0_KO "입력 장치가 'Guncon/G-Con 45' 또는 'Justifier'로 설정되었을 때 화면에 표시될 건 커서를 선택합니다. 비활성화할 경우 십자선이 표시되지 않습니다."
#define OPTION_VAL_CROSS_KO "십자"
#define OPTION_VAL_DOT_KO "점"
#define OPTION_VAL_OFF_KO "커서 없음"
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_KO "1번 포트 건 십자선 색상"
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_KO "1번 포트 라이트 건의 십자선 색을 선택합니다."
#define OPTION_VAL_RED_KO "빨강"
#define OPTION_VAL_BLUE_KO "파랑"
#define OPTION_VAL_GREEN_KO "초록"
#define OPTION_VAL_ORANGE_KO "오렌지"
#define OPTION_VAL_YELLOW_KO "노랑"
#define OPTION_VAL_CYAN_KO "청록"
#define OPTION_VAL_PINK_KO "핑크"
#define OPTION_VAL_PURPLE_KO "보라"
#define OPTION_VAL_BLACK_KO "검정"
#define OPTION_VAL_WHITE_KO "흰색"
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_KO "2번 포트 건 십자선 색상"
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_KO "2번 포트 라이트 건의 십자선 색을 선택합니다."
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_KO "마우스 감도"
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_KO "'마우스' 형식 입력 장치의 반응 정도를 설정합니다."
#define OPTION_VAL_5_KO NULL
#define OPTION_VAL_10_KO NULL
#define OPTION_VAL_15_KO NULL
#define OPTION_VAL_20_KO NULL
#define OPTION_VAL_25_KO NULL
#define OPTION_VAL_30_KO NULL
#define OPTION_VAL_35_KO NULL
#define OPTION_VAL_40_KO NULL
#define OPTION_VAL_45_KO NULL
#define OPTION_VAL_50_KO NULL
#define OPTION_VAL_55_KO NULL
#define OPTION_VAL_60_KO NULL
#define OPTION_VAL_65_KO NULL
#define OPTION_VAL_70_KO NULL
#define OPTION_VAL_75_KO NULL
#define OPTION_VAL_80_KO NULL
#define OPTION_VAL_85_KO NULL
#define OPTION_VAL_90_KO NULL
#define OPTION_VAL_95_KO NULL
#define OPTION_VAL_100_KO "100% (기본)"
#define OPTION_VAL_105_KO NULL
#define OPTION_VAL_110_KO NULL
#define OPTION_VAL_115_KO NULL
#define OPTION_VAL_120_KO NULL
#define OPTION_VAL_125_KO NULL
#define OPTION_VAL_130_KO NULL
#define OPTION_VAL_135_KO NULL
#define OPTION_VAL_140_KO NULL
#define OPTION_VAL_145_KO NULL
#define OPTION_VAL_150_KO NULL
#define OPTION_VAL_155_KO NULL
#define OPTION_VAL_160_KO NULL
#define OPTION_VAL_165_KO NULL
#define OPTION_VAL_170_KO NULL
#define OPTION_VAL_175_KO NULL
#define OPTION_VAL_180_KO NULL
#define OPTION_VAL_185_KO NULL
#define OPTION_VAL_190_KO NULL
#define OPTION_VAL_195_KO NULL
#define OPTION_VAL_200_KO NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_KO "neGcon 뒤틀기 감도"
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_KO "RetroPad 왼쪽 아날로그 스틱으로 'neGcon' 입력 장치의 '뒤틀기' 입력을 흉내낼 때의 반응 방식을 설정합니다. 아날로그 스틱 입력은 neGcon 회전에 선형, 정방(제곱), 입방(세제곱)으로 매핑될 수 있습니다. '정방'은 작은 움직임을 '선형'보다 더 정확하게 입력할 수 있습니다. '입방'은 작은 움직임을 더욱 정확하게 감지하지만, 큰 움직임이 '과장'됩니다. 주의: '선형'은 레이싱 휠을 사용할 때만 권장합니다. 일반적인 컨트롤러의 아날로그 입력은 neGcon의 '비틀기' 입력과 전혀 다르게 설계되어 있으므로 선형 매핑은 작은 움직임을 과장하여 미세 조작을 힘들게 합니다. 일반적으로 '정방'이 실제 하드웨어와 가장 비슷한 느낌을 제공합니다."
#define OPTION_VAL_LINEAR_KO "선형"
#define OPTION_VAL_QUADRATIC_KO "정방"
#define OPTION_VAL_CUBIC_KO "입방"
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_KO "neGcon 뒤틀기 데드존"
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_KO "RetroPad 왼쪽 아날로그 스틱으로 'neGcon' 입력 장치의 '뒤틀기' 입력을 흉내낼 때의 데드존을 설정합니다. 컨트롤러 쏠림 현장을 방지하기 위해 사용됩니다. 주의: 대부분의 neGcon 호환 타이틀은 게임 내에서 '뒤틀기' 데드존 값을 설정하는 것을 지원합니다. 가장 정확한 입력을 위해서는 게임 내 데드존 설정이 *반드시* 0으로 설정되어야 하며, 관련 조정은 *반드시* 이 코어 설정을 통해서만 이루어져야 합니다. 특히 'neGcon 뒤틀기 감도'가 '정방' 또는 '입방'일 경우에는 이렇게 하는 것이 중요합니다."
#define OPTION_VAL_0_KO NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_KO "메모리 카드 0 방식 (재시작 필요)"
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_KO "메모리 카드 0을 저장할 데이터 포맷을 선택합니다. 'Mednafen'은 단독 버전의 Mednafen과의 호환성을 위해 사용될 수 있습니다. Beetle PSX에서 사용할 경우, Libretro(.srm)와 Mednafen(.mcr) 저장 파일은 내부적으로 동일한 형식이며 파일 이름을 바꾸는 것으로 상호 변환할 수 있습니다."
#define OPTION_VAL_LIBRETRO_KO NULL
#define OPTION_VAL_MEDNAFEN_KO NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_KO "메모리 카드 1 활성화 (재시작 필요)"
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_KO "슬롯 1에 두 번째 메모리 카드를 에뮬레이트합니다. 비활성화할 경우, 게임은 슬롯 0의 메모리 카드에만 접근할 수 있습니다. 주의: 일부 게임(예: Codename Tenka)은 이 옵션을 비활성화해야 정상 작동합니다. 메모리 카드 1은 Mednafen(.mcr) 저장 형식을 사용합니다."
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_KO "공유 메모리 카드 (재시작 필요)"
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_KO "사용할 경우, 모든 게임이 같은 메모리 카드 파일에 저장하고 불러옵니다. 사용하지 않을 경우, 불러온 컨텐츠마다 별도의 메모리 카드 파일을 사용합니다. 주의: '메모리 카드 0 방식'이 'Libretro'일 경우 오른쪽 메모리 카드에만 적용됩니다."
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_KO "왼쪽 메모리 카드 인덱스"
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_KO "왼쪽 슬롯에 삽입될 메모리 카드를 변경합니다. 이 옵션은 메모리 카드 0 방식이 Mednafen으로 설정되어 있어야 작동합니다. 기본 카드 인덱스는 0입니다."
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_KO "오른쪽 메모리 카드 인덱스"
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_KO "오른쪽 슬롯에 삽입될 메모리 카드를 변경합니다. 이 옵션은 메모리 카드 1이 활성화되어 있어야 작동합니다. 기본 카드 인덱스는 1입니다."
#define OPTION_VAL_1_KO "1 (기본)"
#define BEETLE_OPT_PGXP_MODE_LABEL_KO "PGXP 작동 모드"
#define BEETLE_OPT_PGXP_MODE_INFO_0_KO "3D 개체가 서브픽셀 단위 정확도로 렌더링될 수 있게 합니다. 이는 원본 하드웨어가 버텍스 좌표에 고정소수점을 사용하여 발생하는 3D 개체의 뒤틀림과 떨림 현상을 최소화합니다. '메모리만'은 호환성 문제가 적으며 일반적인 사용에 적합합니다. '메모리 + CPU (불안정)'은 떨림 현상을 더 많이 줄일 수 있지만 성능 요구사항이 높으며 다양한 그래픽 오류가 발생할 수 있습니다."
#define OPTION_VAL_MEMORY_ONLY_KO "메모리만"
#define OPTION_VAL_MEMORY_CPU_KO "메모리 + CPU (불안정)"
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_KO "PGXP 2D 기하 허용오차"
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_KO "PGXP 작업에서 더 눈에 띄는 오류를 숨깁니다. 개체에 적절한 깊이 정보가 없는 경우 지정한 만큼의 PGXP 값이 오차로서 허용됩니다."
#define OPTION_VAL_0PX_KO NULL
#define OPTION_VAL_1PX_KO NULL
#define OPTION_VAL_2PX_KO NULL
#define OPTION_VAL_3PX_KO NULL
#define OPTION_VAL_4PX_KO NULL
#define OPTION_VAL_5PX_KO NULL
#define OPTION_VAL_6PX_KO NULL
#define OPTION_VAL_7PX_KO NULL
#define OPTION_VAL_8PX_KO NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_KO "PGXP 프리미티브 컬링"
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_KO "PGXP의 NCLIP 구현을 사용합니다. PGXP 좌표의 폴리곤에 나타나는 구멍을 줄여 외형을 개선합니다. 일부 게임이 다양한 상황에서 멈추는 부작용이 있습니다."
#define BEETLE_OPT_PGXP_VERTEX_LABEL_KO "PGXP 버텍스 캐시"
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_KO "PGXP 개선된 버텍스 위치를 캐싱하여 다양한 폴리곤 그리기에 재사용합니다. 텍스쳐를 렌더링할 때 개체 정렬을 개선하고 틈을 줄이는 등의 개선 효과를 볼 수 있지만, 캐시 쿼리 시 오탐으로 인해 그래픽 오류가 발생할 수 있습니다. 현재는 사용하지 않는 것이 권장됩니다. 이 설정은 PGXP 작동 모드가 활성화되어 있어야 적용됩니다. 하드웨어 렌더러에서만 지원됩니다."
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_KO "PGXP 원근 교정 텍스쳐링"
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_KO "네이티브 PSX 아핀 텍스쳐 매핑을 원근 교정 텍스쳐 매핑으로 대체합니다. 위치 기반 왜곡 및 뒤틀림을 제거하여 텍스쳐가 올바르게 표시되게 합니다. 이 설정은 PGXP 작동 모드가 활성화되어 있어야 적용됩니다. 하드웨어 렌더러에서만 지원됩니다."
#define BEETLE_OPT_LINE_RENDER_LABEL_KO "Line-to-Quad 핵"
#define BEETLE_OPT_LINE_RENDER_INFO_0_KO "Line-to-Quad 핵의 작동 방식을 선택합니다. 일부 게임(예: Doom, Hexen, Soul Blade 등)은 수평선을 원본 하드웨어에서 한 줄의 픽셀로 래스터화되는 1픽셀 높이의 가로로 긴 삼각형을 그리는 방식으로 구현합니다. 이 핵은 그러한 작은 삼각형을 탐지하여 하드웨어 렌더러에서 올바르게 그려지고 업스케일링도 할 수 있는 사각형으로 변환합니다. '과감하게'는 일부 타이틀(예: Dark Forces, Duke Nukem)의 구동에 필요하나 이외의 경우 그래픽 오류를 유발할 수 있습니다. 불확실할 경우 '기본'으로 설정하십시오."
#define OPTION_VAL_DEFAULT_KO "기본"
#define OPTION_VAL_AGGRESSIVE_KO "과감하게"
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_KO "와이드스크린 모드 핵"
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_KO "3D 컨텐츠를 아나모픽하게 렌더링한 뒤 에뮬레이트되는 프레임버퍼에 와이드스크린 화면비로 출력합니다. 풀 3D 게임에서 최선의 효과를 얻을 수 있습니다. 2D 요소는 가로로 늘어나며 뒤틀릴 수 있습니다."
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_KO "와이드스크린 모드 핵 화면비"
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_KO "와이드스크린 모드 핵에서 사용될 화면비를 선택합니다."
#define OPTION_VAL_16_9_KO NULL
#define OPTION_VAL_16_10_KO NULL
#define OPTION_VAL_18_9_KO NULL
#define OPTION_VAL_19_9_KO NULL
#define OPTION_VAL_20_9_KO NULL
#define OPTION_VAL_21_9_KO NULL
#define OPTION_VAL_32_9_KO NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_KO "CPU 속도 스케일링 (오버클럭)"
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_KO "에뮬레이트되는 PSX CPU를 오버클럭(언더클럭)합니다. 오버클러킹은 높은 사양을 요구하는 대신 일부 게임에서 느려짐 증상을 없애고 프레임레이트를 개선할 수 있습니다. 일부 게임은 프레임레이트 리미터가 내장되어 있으므로 오버클러킹의 이득이 없을 수도 있습니다. 일부 타이틀에서 오버클럭을 할 경우 일부 효과가 의도된 것보다 빠르게 재생될 수 있습니다."
#define OPTION_VAL_100_NATIVE_KO "100% (네이티브)"
#define OPTION_VAL_210_KO NULL
#define OPTION_VAL_220_KO NULL
#define OPTION_VAL_230_KO NULL
#define OPTION_VAL_240_KO NULL
#define OPTION_VAL_250_KO NULL
#define OPTION_VAL_260_KO NULL
#define OPTION_VAL_270_KO NULL
#define OPTION_VAL_280_KO NULL
#define OPTION_VAL_290_KO NULL
#define OPTION_VAL_300_KO NULL
#define OPTION_VAL_310_KO NULL
#define OPTION_VAL_320_KO NULL
#define OPTION_VAL_330_KO NULL
#define OPTION_VAL_340_KO NULL
#define OPTION_VAL_350_KO NULL
#define OPTION_VAL_360_KO NULL
#define OPTION_VAL_370_KO NULL
#define OPTION_VAL_380_KO NULL
#define OPTION_VAL_390_KO NULL
#define OPTION_VAL_400_KO NULL
#define OPTION_VAL_410_KO NULL
#define OPTION_VAL_420_KO NULL
#define OPTION_VAL_430_KO NULL
#define OPTION_VAL_440_KO NULL
#define OPTION_VAL_450_KO NULL
#define OPTION_VAL_460_KO NULL
#define OPTION_VAL_470_KO NULL
#define OPTION_VAL_480_KO NULL
#define OPTION_VAL_490_KO NULL
#define OPTION_VAL_500_KO NULL
#define OPTION_VAL_510_KO NULL
#define OPTION_VAL_520_KO NULL
#define OPTION_VAL_530_KO NULL
#define OPTION_VAL_540_KO NULL
#define OPTION_VAL_550_KO NULL
#define OPTION_VAL_560_KO NULL
#define OPTION_VAL_570_KO NULL
#define OPTION_VAL_580_KO NULL
#define OPTION_VAL_590_KO NULL
#define OPTION_VAL_600_KO NULL
#define OPTION_VAL_610_KO NULL
#define OPTION_VAL_620_KO NULL
#define OPTION_VAL_630_KO NULL
#define OPTION_VAL_640_KO NULL
#define OPTION_VAL_650_KO NULL
#define OPTION_VAL_660_KO NULL
#define OPTION_VAL_670_KO NULL
#define OPTION_VAL_680_KO NULL
#define OPTION_VAL_690_KO NULL
#define OPTION_VAL_700_KO NULL
#define OPTION_VAL_710_KO NULL
#define OPTION_VAL_720_KO NULL
#define OPTION_VAL_730_KO NULL
#define OPTION_VAL_740_KO NULL
#define OPTION_VAL_750_KO NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_KO "GTE 오버클럭"
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_KO "에뮬레이트되는 GTE(3D 그래픽 보조 처리장치) 연산을 모두 1사이클 시간 내에 처리합니다. GTE를 많이 사용하는 게임에서 프레임레이트와 프레임 시간 안정성을 크게 향상시킬 수 있습니다."
#define BEETLE_OPT_SKIP_BIOS_LABEL_KO "BIOS 건너뛰기"
#define BEETLE_OPT_SKIP_BIOS_INFO_0_KO "컨텐츠를 불러올 때 표시되는 PlayStation BIOS 부트 애니메이션을 건너뜁니다. 주의: 이 옵션을 사용하면 일부 게임(PAL 복사 방지 게임, Saga Frontier 등)에서 호환성 문제가 발생합니다."
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_KO "대체 BIOS 사용 (재시작 필요)"
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_KO "존재할 경우 기존의 지역 제한 BIOS를 지역 제한이 없는 BIOS로 대체합니다."
#define OPTION_VAL_PSXONPSP_KO NULL
#define OPTION_VAL_PS1_ROM_KO NULL
#define BEETLE_OPT_RENDERER_LABEL_KO "렌더러 (재시작 필요)"
#define BEETLE_OPT_RENDERER_INFO_0_KO "소프트웨어 렌더러는 가장 정확하지만 내부 GPU 해상도를 높여 사용할 경우 요구 사양이 높아집니다. 하드웨어 렌더러는 조금 더 부정확하지만 높은 내부 GPU 해상도에서 소프트웨어 렌더러 대비 성능이 향상되며 다양한 그래픽 개선을 적용할 수 있습니다. '하드웨어 (자동)'은 현재 libretro 프론트엔드 비디오 드라이버에 따라 Vulkan 또는 OpenGL 중 적절한 렌더러를 선택합니다. 제공된 비디오 드라이버가 Vulkan 또는 OpenGL 3.3과 호환되지 않을 경우, 코어는 소프트웨어 렌더러를 사용할 것입니다."
#define OPTION_VAL_HARDWARE_KO "하드웨어 (자동)"
#define OPTION_VAL_HARDWARE_GL_KO "하드웨어 (OpenGL)"
#define OPTION_VAL_HARDWARE_VK_KO "하드웨어 (Vulkan)"
#define OPTION_VAL_SOFTWARE_KO "소프트웨어"
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_KO "소프트웨어 프레임버퍼"
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_KO "하드웨어 렌더러 사용 시 1배 해상도의 소프트웨어 렌더러를 백그라운드에서 함께 구동하여 프레임버퍼 효과(모션 블러, FF7 전투 개시 효과 등)를 정확하게 에뮬레이트합니다. 비활성화할 경우, 이러한 효과는 무시되거나(OpenGL) GPU에서 렌더됩니다(Vulkan). 비활성화 시 성능이 개선되지만 심각한 그래픽 오류를 일으킬 수 있습니다. 불확실할 경우 활성으로 설정하십시오."
#define BEETLE_OPT_CPU_DYNAREC_LABEL_KO "CPU 동적 리컴파일러"
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_KO "CPU 명령어를 네이티브 명령어로 동적 리컴파일합니다. 인터프리터보다 훨씬 빠르지만, CPU 타이밍이 부정확해지며, 오류를 일으킬 수 있습니다."
#define OPTION_VAL_DISABLED_KO "비활성화 (Beetle 인터프리터)"
#define OPTION_VAL_EXECUTE_KO "최대 성능"
#define OPTION_VAL_EXECUTE_ONE_KO "사이클 타이밍 검사"
#define OPTION_VAL_RUN_INTERPRETER_KO "Lightrec 인터프리터"
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_KO "동적 리컴파일러 코드 무효화"
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_KO "일부 게임은 '모두' 무효화를 필요로 하며, 일부는 'DMA만'을 필요로 합니다."
#define OPTION_VAL_FULL_KO "모두"
#define OPTION_VAL_DMA_KO "DMA만 (조금 더 빠름)"
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_KO "동적 리컴파일러 DMA/GPU 이벤트 사이클"
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_KO "GPU 또는 DMA 업데이트 확인 전에 구동할 최대 CPU 사이클 수입니다. 높은 값으로 설정하면 성능이 더 빨라지며, 동적 리컴파일러에 비해 Beetle 인터프리터에는 큰 효과가 없습니다."
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_KO "코어 보고 FPS 타이밍"
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_KO "코어가 프론트엔드에 보고할 FPS 타이밍을 선택합니다. 자동 전환을 선택하면 코어가 프로그레시브 및 인터레이스 주사율을 전환할 수 있게 하며, 프론트엔드의 비디오/오디오 드라이버의 초기화를 일으킬 수 있습니다."
#define OPTION_VAL_FORCE_PROGRESSIVE_KO "프로그레시브 주사율"
#define OPTION_VAL_FORCE_INTERLACED_KO "인터레이스 주사율 강제"
#define OPTION_VAL_AUTO_TOGGLE_KO "자동 전환 허용"
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_KO "PAL(유럽) 비디오 타이밍 오버라이드"
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_KO "서로 다른 표준으로 인해 PAL 게임은 미국 또는 일본 NTSC 게임에 비해 다소 느리게 구동되기도 합니다. 이 옵션은 PAL 타이밍을 오버라이드하여 NTSC 게임과 동일한 프레임레이트로 구동되게 합니다. 이 옵션은 NTSC 컨텐츠를 실행할 땐 아무런 효과가 없습니다."
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_KO "오버스캔 잘라내기"
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_KO "'없음'은 패딩(NTSC 좌우 기둥, PAL 전 방향 테두리)을 유지하여 원본 PSX 하드웨어의 아날로그 비디오 출력에 존재하는 검은 막대를 에뮬레이트합니다. '정적'은 수평 패딩만 제거하며, '동적'은 모든 패딩을 제거합니다."
#define OPTION_VAL_DISABLED_O53_KO "없음"
#define OPTION_VAL_STATIC_KO "정적"
#define OPTION_VAL_SMART_KO "동적 (기본값)"
#define BEETLE_OPT_IMAGE_CROP_LABEL_KO "추가 잘라내기"
#define BEETLE_OPT_IMAGE_CROP_INFO_0_KO "'가로 오버스캔 잘라내기'가 활성화된 경우, 이 옵션에 설정한 픽셀 수만큼 화면의 폭을 추가로 줄입니다."
#define OPTION_VAL_9PX_KO NULL
#define OPTION_VAL_10PX_KO NULL
#define OPTION_VAL_11PX_KO NULL
#define OPTION_VAL_12PX_KO NULL
#define OPTION_VAL_13PX_KO NULL
#define OPTION_VAL_14PX_KO NULL
#define OPTION_VAL_15PX_KO NULL
#define OPTION_VAL_16PX_KO NULL
#define OPTION_VAL_17PX_KO NULL
#define OPTION_VAL_18PX_KO NULL
#define OPTION_VAL_19PX_KO NULL
#define OPTION_VAL_20PX_KO NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_KO "잘라낸 이미지 위치 조정"
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_KO "'가로 오버스캔 잘라내기'가 활성화된 경우, 이 옵션에 설정한 픽셀 수만큼 화면을 오른쪽(양수) 또는 왼쪽(음수)으로 이동합니다. 맞춤 문제를 교정하는 데 사용될 수 있습니다. 소프트웨어 렌더러에서만 지원됩니다."
#define OPTION_VAL_12PX_O55_KO NULL
#define OPTION_VAL_11PX_O55_KO NULL
#define OPTION_VAL_10PX_O55_KO NULL
#define OPTION_VAL_9PX_O55_KO NULL
#define OPTION_VAL_8PX_O55_KO NULL
#define OPTION_VAL_7PX_O55_KO NULL
#define OPTION_VAL_6PX_O55_KO NULL
#define OPTION_VAL_5PX_O55_KO NULL
#define OPTION_VAL_4PX_O55_KO NULL
#define OPTION_VAL_3PX_O55_KO NULL
#define OPTION_VAL_2PX_O55_KO NULL
#define OPTION_VAL_1PX_O55_KO NULL
#define OPTION_VAL_DISABLED_O55_KO "0 (기본)"
#define OPTION_VAL_1PX_O55_0_KO NULL
#define OPTION_VAL_2PX_O55_0_KO NULL
#define OPTION_VAL_3PX_O55_0_KO NULL
#define OPTION_VAL_4PX_O55_0_KO NULL
#define OPTION_VAL_5PX_O55_0_KO NULL
#define OPTION_VAL_6PX_O55_0_KO NULL
#define OPTION_VAL_7PX_O55_0_KO NULL
#define OPTION_VAL_8PX_O55_0_KO NULL
#define OPTION_VAL_9PX_O55_0_KO NULL
#define OPTION_VAL_10PX_O55_0_KO NULL
#define OPTION_VAL_11PX_O55_0_KO NULL
#define OPTION_VAL_12PX_O55_0_KO NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_KO "가로 이미지 위치 조정 (GPU 사이클)"
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_KO "이미지를 위치 조정할 GPU 사이클 수를 선택합니다. 양수는 이미지를 오른쪽으로, 음수는 왼쪽으로 이동시킵니다. 하드웨어 렌더러에서만 지원됩니다."
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_KO "GPU 래스터라이저 오버클럭"
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_KO "에뮬레이트되는 PSX GPU의 2D 래스터라이저를 오버클럭합니다. 3D 렌더링은 개선되지 않으며, 전반적으로 큰 효과는 없습니다."
#define OPTION_VAL_32X_KO "32배"
#define BEETLE_OPT_ASPECT_RATIO_LABEL_KO "코어 화면비"
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_KO "코어가 제공할 화면비를 선택합니다. 이 설정은 와이드스크린 모드 핵 또는 전체 VRAM 표시 옵션이 활성화된 경우 무시됩니다."
#define OPTION_VAL_CORRECTED_KO "교정됨"
#define OPTION_VAL_UNCORRECTED_KO "교정 안 됨"
#define OPTION_VAL_4_3_KO "강제 4:3"
#define OPTION_VAL_NTSC_KO "강제 NTSC"
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_KO "첫 스캔라인 - NTSC"
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_KO "NTSC 컨텐츠를 실행할 때 표시할 첫 번째 스캔라인을 선택합니다. 0보다 큰 값으로 설정할 경우 출력되는 이미지를 위에서부터 잘라내 높이를 줄입니다. 레터박스를 없애는 데 사용될 수 있습니다."
#define BEETLE_OPT_LAST_SCANLINE_LABEL_KO "마지막 스캔라인 - NTSC"
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_KO "NTSC 컨텐츠를 실행할 때 표시할 마지막 스캔라인을 선택합니다. 239보다 작은 값으로 설정할 경우 출력되는 이미지를 아래에서부터 잘라내 높이를 줄입니다. 레터박스를 없애는 데 사용될 수 있습니다."
#define OPTION_VAL_239_KO "239 (기본)"
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_KO "첫 스캔라인 - PAL"
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_KO "PAL 컨텐츠를 실행할 때 표시할 첫 번째 스캔라인을 선택합니다. 0보다 큰 값으로 설정할 경우 출력되는 이미지를 위에서부터 잘라내 높이를 줄입니다. 레터박스를 없애는 데 사용될 수 있습니다."
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_KO "마지막 스캔라인 - PAL"
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_KO "PAL 컨텐츠를 실행할 때 표시할 마지막 스캔라인을 선택합니다. 287보다 작은 값으로 설정할 경우 출력되는 이미지를 아래에서부터 잘라내 높이를 줄입니다. 레터박스를 없애는 데 사용될 수 있습니다."
#define OPTION_VAL_287_KO "287 (기본)"
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_KO "CD 액세스 방식 (재시작 필요)"
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_KO "컨텐츠의 디스크 이미지에서 데이터를 읽어올 방식을 선택합니다. '동기'는 원본 하드웨어의 동작을 흉내냅니다. '비동기'는 저장소가 느린 장치에서 버벅임을 줄일 수 있습니다. '미리 캐싱'은 컨텐츠를 실행할 때 전체 디스크 이미지를 메모리에 불러옵니다. 첫 시작 시 딜레이가 생기지만 인게임 로딩 시간이 줄어듭니다. '미리 캐싱'은 RAM이 적은 장치에서 문제를 일으킬 수 있으며, 물리적 미디어를 사용할 경우 '동기'가 사용됩니다."
#define OPTION_VAL_SYNC_KO "동기"
#define OPTION_VAL_ASYNC_KO "비동기"
#define OPTION_VAL_PRECACHE_KO "미리 캐싱"
#define BEETLE_OPT_CD_FASTLOAD_LABEL_KO "CD 로딩 속도"
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_KO "디스크 액세스 배속을 선택합니다. '2배 (네이티브)'를 초과하는 값은 인게임 로딩 시간을 크게 줄일 수 있지만, 타이밍 오류를 유발하기도 합니다. 일부 게임은 일정 속도 이상에서 올바르게 작동하지 않을 수 있습니다."
#define OPTION_VAL_2X_NATIVE_KO "2배 (Native)"
#define OPTION_VAL_6X_KO NULL
#define OPTION_VAL_10X_KO "10배"
#define OPTION_VAL_12X_KO "12배"
#define OPTION_VAL_14X_KO "14배"

struct retro_core_option_v2_category option_cats_ko[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_KO,
      CATEGORY_VIDEO_INFO_0_KO
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_KO,
      CATEGORY_OSD_INFO_0_KO
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_KO,
      CATEGORY_INPUT_INFO_0_KO
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_KO,
      CATEGORY_MEMCARDS_INFO_0_KO
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_KO,
      CATEGORY_PGXP_INFO_0_KO
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_KO,
      CATEGORY_HACKS_INFO_0_KO
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_ko[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_KO,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_KO,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_KO },
         { "2x",         OPTION_VAL_2X_KO },
         { "4x",         OPTION_VAL_4X_KO },
         { "8x",         OPTION_VAL_8X_KO },
         { "16x",        OPTION_VAL_16X_KO },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_KO,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_KO,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_KO },
         { "32bpp",         OPTION_VAL_32BPP_KO },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_KO,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_KO,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_KO },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_KO },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_KO,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_KO,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_KO,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_KO,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_KO },
         { "SABR",     OPTION_VAL_SABR_KO },
         { "xBR",      OPTION_VAL_XBR_KO },
         { "bilinear", OPTION_VAL_BILINEAR_KO },
         { "3-point",  OPTION_VAL_3_POINT_KO },
         { "JINC2",    OPTION_VAL_JINC2_KO },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_KO,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_KO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_KO },
         { "all", OPTION_VAL_ALL_KO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_KO,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_KO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_KO },
         { "all", OPTION_VAL_ALL_KO },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_KO,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_KO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_KO,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_KO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_KO,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_KO,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_KO },
         { "2x",  OPTION_VAL_2X_KO },
         { "4x",  OPTION_VAL_4X_KO },
         { "8x",  OPTION_VAL_8X_KO },
         { "16x", OPTION_VAL_16X_KO },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_KO,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_KO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_KO,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_KO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_KO,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_KO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_KO,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_KO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_KO,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_KO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_KO,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_KO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_KO,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_KO,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_KO,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_KO,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_KO,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_KO,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_KO,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_KO,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_KO,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_KO,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_KO,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_KO,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_KO,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_KO,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_KO },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_KO },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_KO,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_KO,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_KO },
         { "dot",   OPTION_VAL_DOT_KO },
         { "off",   OPTION_VAL_OFF_KO },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_KO,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_KO,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_KO },
         { "blue", OPTION_VAL_BLUE_KO },
         { "green", OPTION_VAL_GREEN_KO },
         { "orange", OPTION_VAL_ORANGE_KO },
         { "yellow", OPTION_VAL_YELLOW_KO },
         { "cyan", OPTION_VAL_CYAN_KO },
         { "pink", OPTION_VAL_PINK_KO },
         { "purple", OPTION_VAL_PURPLE_KO },
         { "black", OPTION_VAL_BLACK_KO },
         { "white", OPTION_VAL_WHITE_KO },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_KO,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_KO,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_KO },
         { "red", OPTION_VAL_RED_KO },
         { "green", OPTION_VAL_GREEN_KO },
         { "orange", OPTION_VAL_ORANGE_KO },
         { "yellow", OPTION_VAL_YELLOW_KO },
         { "cyan", OPTION_VAL_CYAN_KO },
         { "pink", OPTION_VAL_PINK_KO },
         { "purple", OPTION_VAL_PURPLE_KO },
         { "black", OPTION_VAL_BLACK_KO },
         { "white", OPTION_VAL_WHITE_KO },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_KO,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_KO,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_KO },
         { "10%",  OPTION_VAL_10_KO },
         { "15%",  OPTION_VAL_15_KO },
         { "20%",  OPTION_VAL_20_KO },
         { "25%",  OPTION_VAL_25_KO },
         { "30%",  OPTION_VAL_30_KO },
         { "35%",  OPTION_VAL_35_KO },
         { "40%",  OPTION_VAL_40_KO },
         { "45%",  OPTION_VAL_45_KO },
         { "50%",  OPTION_VAL_50_KO },
         { "55%",  OPTION_VAL_55_KO },
         { "60%",  OPTION_VAL_60_KO },
         { "65%",  OPTION_VAL_65_KO },
         { "70%",  OPTION_VAL_70_KO },
         { "75%",  OPTION_VAL_75_KO },
         { "80%",  OPTION_VAL_80_KO },
         { "85%",  OPTION_VAL_85_KO },
         { "90%",  OPTION_VAL_90_KO },
         { "95%",  OPTION_VAL_95_KO },
         { "100%", OPTION_VAL_100_KO },
         { "105%", OPTION_VAL_105_KO },
         { "110%", OPTION_VAL_110_KO },
         { "115%", OPTION_VAL_115_KO },
         { "120%", OPTION_VAL_120_KO },
         { "125%", OPTION_VAL_125_KO },
         { "130%", OPTION_VAL_130_KO },
         { "135%", OPTION_VAL_135_KO },
         { "140%", OPTION_VAL_140_KO },
         { "145%", OPTION_VAL_145_KO },
         { "150%", OPTION_VAL_150_KO },
         { "155%", OPTION_VAL_155_KO },
         { "160%", OPTION_VAL_160_KO },
         { "165%", OPTION_VAL_165_KO },
         { "170%", OPTION_VAL_170_KO },
         { "175%", OPTION_VAL_175_KO },
         { "180%", OPTION_VAL_180_KO },
         { "185%", OPTION_VAL_185_KO },
         { "190%", OPTION_VAL_190_KO },
         { "195%", OPTION_VAL_195_KO },
         { "200%", OPTION_VAL_200_KO },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_KO,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_KO,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_KO },
         { "quadratic", OPTION_VAL_QUADRATIC_KO },
         { "cubic",     OPTION_VAL_CUBIC_KO },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_KO,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_KO,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_KO },
         { "5%",  OPTION_VAL_5_KO },
         { "10%", OPTION_VAL_10_KO },
         { "15%", OPTION_VAL_15_KO },
         { "20%", OPTION_VAL_20_KO },
         { "25%", OPTION_VAL_25_KO },
         { "30%", OPTION_VAL_30_KO },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_KO,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_KO,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_KO },
         { "mednafen", OPTION_VAL_MEDNAFEN_KO },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_KO,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_KO,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_KO,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_KO,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_KO,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_KO,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_KO,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_KO,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_KO },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_KO,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_KO,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_KO },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_KO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_KO,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_KO,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_KO },
         { "1px", OPTION_VAL_1PX_KO },
         { "2px", OPTION_VAL_2PX_KO },
         { "3px", OPTION_VAL_3PX_KO },
         { "4px", OPTION_VAL_4PX_KO },
         { "5px", OPTION_VAL_5PX_KO },
         { "6px", OPTION_VAL_6PX_KO },
         { "7px", OPTION_VAL_7PX_KO },
         { "8px", OPTION_VAL_8PX_KO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_KO,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_KO,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_KO,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_KO,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_KO,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_KO,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_KO,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_KO,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_KO },
         { "aggressive", OPTION_VAL_AGGRESSIVE_KO },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_KO,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_KO,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_KO,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_KO,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_KO },
         { "16:10", OPTION_VAL_16_10_KO },
         { "18:9",  OPTION_VAL_18_9_KO },
         { "19:9",  OPTION_VAL_19_9_KO },
         { "20:9",  OPTION_VAL_20_9_KO },
         { "21:9",  OPTION_VAL_21_9_KO }, // 64:27
         { "32:9",  OPTION_VAL_32_9_KO },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_KO,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_KO,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_KO },
         { "60%",           OPTION_VAL_60_KO },
         { "70%",           OPTION_VAL_70_KO },
         { "80%",           OPTION_VAL_80_KO },
         { "90%",           OPTION_VAL_90_KO },
         { "100%(native)", OPTION_VAL_100_NATIVE_KO },
         { "110%",          OPTION_VAL_110_KO },
         { "120%",          OPTION_VAL_120_KO },
         { "130%",          OPTION_VAL_130_KO },
         { "140%",          OPTION_VAL_140_KO },
         { "150%",          OPTION_VAL_150_KO },
         { "160%",          OPTION_VAL_160_KO },
         { "170%",          OPTION_VAL_170_KO },
         { "180%",          OPTION_VAL_180_KO },
         { "190%",          OPTION_VAL_190_KO },
         { "200%",          OPTION_VAL_200_KO },
         { "210%",          OPTION_VAL_210_KO },
         { "220%",          OPTION_VAL_220_KO },
         { "230%",          OPTION_VAL_230_KO },
         { "240%",          OPTION_VAL_240_KO },
         { "250%",          OPTION_VAL_250_KO },
         { "260%",          OPTION_VAL_260_KO },
         { "270%",          OPTION_VAL_270_KO },
         { "280%",          OPTION_VAL_280_KO },
         { "290%",          OPTION_VAL_290_KO },
         { "300%",          OPTION_VAL_300_KO },
         { "310%",          OPTION_VAL_310_KO },
         { "320%",          OPTION_VAL_320_KO },
         { "330%",          OPTION_VAL_330_KO },
         { "340%",          OPTION_VAL_340_KO },
         { "350%",          OPTION_VAL_350_KO },
         { "360%",          OPTION_VAL_360_KO },
         { "370%",          OPTION_VAL_370_KO },
         { "380%",          OPTION_VAL_380_KO },
         { "390%",          OPTION_VAL_390_KO },
         { "400%",          OPTION_VAL_400_KO },
         { "410%",          OPTION_VAL_410_KO },
         { "420%",          OPTION_VAL_420_KO },
         { "430%",          OPTION_VAL_430_KO },
         { "440%",          OPTION_VAL_440_KO },
         { "450%",          OPTION_VAL_450_KO },
         { "460%",          OPTION_VAL_460_KO },
         { "470%",          OPTION_VAL_470_KO },
         { "480%",          OPTION_VAL_480_KO },
         { "490%",          OPTION_VAL_490_KO },
         { "500%",          OPTION_VAL_500_KO },
         { "510%",          OPTION_VAL_510_KO },
         { "520%",          OPTION_VAL_520_KO },
         { "530%",          OPTION_VAL_530_KO },
         { "540%",          OPTION_VAL_540_KO },
         { "550%",          OPTION_VAL_550_KO },
         { "560%",          OPTION_VAL_560_KO },
         { "570%",          OPTION_VAL_570_KO },
         { "580%",          OPTION_VAL_580_KO },
         { "590%",          OPTION_VAL_590_KO },
         { "600%",          OPTION_VAL_600_KO },
         { "610%",          OPTION_VAL_610_KO },
         { "620%",          OPTION_VAL_620_KO },
         { "630%",          OPTION_VAL_630_KO },
         { "640%",          OPTION_VAL_640_KO },
         { "650%",          OPTION_VAL_650_KO },
         { "660%",          OPTION_VAL_660_KO },
         { "670%",          OPTION_VAL_670_KO },
         { "680%",          OPTION_VAL_680_KO },
         { "690%",          OPTION_VAL_690_KO },
         { "700%",          OPTION_VAL_700_KO },
         { "710%",          OPTION_VAL_710_KO },
         { "720%",          OPTION_VAL_720_KO },
         { "730%",          OPTION_VAL_730_KO },
         { "740%",          OPTION_VAL_740_KO },
         { "750%",          OPTION_VAL_750_KO },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_KO,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_KO,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_KO,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_KO,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_KO,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_KO,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_KO },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_KO },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_KO,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_KO,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_KO },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_KO },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_KO },
#endif
         { "software",    OPTION_VAL_SOFTWARE_KO },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_KO,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_KO,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_KO,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_KO,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_KO },
         { "execute",  OPTION_VAL_EXECUTE_KO },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_KO },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_KO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_KO,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_KO,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_KO },
         { "dma",  OPTION_VAL_DMA_KO },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_KO,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_KO,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_KO,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_KO,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_KO },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_KO },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_KO },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_KO,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_KO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_KO,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_KO,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_KO },
         { "static",  OPTION_VAL_STATIC_KO },
         { "smart", OPTION_VAL_SMART_KO },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_KO,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_KO,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_KO },
         { "2px",      OPTION_VAL_2PX_KO },
         { "3px",      OPTION_VAL_3PX_KO },
         { "4px",      OPTION_VAL_4PX_KO },
         { "5px",      OPTION_VAL_5PX_KO },
         { "6px",      OPTION_VAL_6PX_KO },
         { "7px",      OPTION_VAL_7PX_KO },
         { "8px",      OPTION_VAL_8PX_KO },
         { "9px",      OPTION_VAL_9PX_KO },
         { "10px",     OPTION_VAL_10PX_KO },
         { "11px",     OPTION_VAL_11PX_KO },
         { "12px",     OPTION_VAL_12PX_KO },
         { "13px",     OPTION_VAL_13PX_KO },
         { "14px",     OPTION_VAL_14PX_KO },
         { "15px",     OPTION_VAL_15PX_KO },
         { "16px",     OPTION_VAL_16PX_KO },
         { "17px",     OPTION_VAL_17PX_KO },
         { "18px",     OPTION_VAL_18PX_KO },
         { "19px",     OPTION_VAL_19PX_KO },
         { "20px",     OPTION_VAL_20PX_KO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_KO,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_KO,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_KO },
         { "-11px",    OPTION_VAL_11PX_O55_KO },
         { "-10px",    OPTION_VAL_10PX_O55_KO },
         { "-9px",     OPTION_VAL_9PX_O55_KO },
         { "-8px",     OPTION_VAL_8PX_O55_KO },
         { "-7px",     OPTION_VAL_7PX_O55_KO },
         { "-6px",     OPTION_VAL_6PX_O55_KO },
         { "-5px",     OPTION_VAL_5PX_O55_KO },
         { "-4px",     OPTION_VAL_4PX_O55_KO },
         { "-3px",     OPTION_VAL_3PX_O55_KO },
         { "-2px",     OPTION_VAL_2PX_O55_KO },
         { "-1px",     OPTION_VAL_1PX_O55_KO },
         { "disabled", OPTION_VAL_DISABLED_O55_KO },
         { "+1px",     OPTION_VAL_1PX_O55_0_KO },
         { "+2px",     OPTION_VAL_2PX_O55_0_KO },
         { "+3px",     OPTION_VAL_3PX_O55_0_KO },
         { "+4px",     OPTION_VAL_4PX_O55_0_KO },
         { "+5px",     OPTION_VAL_5PX_O55_0_KO },
         { "+6px",     OPTION_VAL_6PX_O55_0_KO },
         { "+7px",     OPTION_VAL_7PX_O55_0_KO },
         { "+8px",     OPTION_VAL_8PX_O55_0_KO },
         { "+9px",     OPTION_VAL_9PX_O55_0_KO },
         { "+10px",    OPTION_VAL_10PX_O55_0_KO },
         { "+11px",    OPTION_VAL_11PX_O55_0_KO },
         { "+12px",    OPTION_VAL_12PX_O55_0_KO },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_KO,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_KO,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_KO },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_KO,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_KO,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_KO },
         { "2x",         OPTION_VAL_2X_KO },
         { "4x",         OPTION_VAL_4X_KO },
         { "8x",         OPTION_VAL_8X_KO },
         { "16x",        OPTION_VAL_16X_KO },
         { "32x",        OPTION_VAL_32X_KO },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_KO,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_KO,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_KO },
         { "uncorrected", OPTION_VAL_UNCORRECTED_KO },
         { "4:3",  OPTION_VAL_4_3_KO },
         { "ntsc", OPTION_VAL_NTSC_KO },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_KO,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_KO,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_KO,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_KO,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_KO },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_KO,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_KO,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_KO,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_KO,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_KO },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_KO,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_KO,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_KO },
         { "async",    OPTION_VAL_ASYNC_KO },
         { "precache", OPTION_VAL_PRECACHE_KO },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_KO,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_KO,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_KO },
         { "4x",          OPTION_VAL_4X_KO },
         { "6x",          OPTION_VAL_6X_KO },
         { "8x",          OPTION_VAL_8X_KO },
         { "10x",         OPTION_VAL_10X_KO },
         { "12x",         OPTION_VAL_12X_KO },
         { "14x",         OPTION_VAL_14X_KO },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_ko = {
   option_cats_ko,
   option_defs_ko
};

/* RETRO_LANGUAGE_MT */

#define CATEGORY_VIDEO_LABEL_MT NULL
#define CATEGORY_VIDEO_INFO_0_MT NULL
#define CATEGORY_OSD_LABEL_MT NULL
#define CATEGORY_OSD_INFO_0_MT NULL
#define CATEGORY_INPUT_LABEL_MT NULL
#define CATEGORY_INPUT_INFO_0_MT NULL
#define CATEGORY_MEMCARDS_LABEL_MT NULL
#define CATEGORY_MEMCARDS_INFO_0_MT NULL
#define CATEGORY_PGXP_LABEL_MT NULL
#define CATEGORY_PGXP_INFO_0_MT NULL
#define CATEGORY_HACKS_LABEL_MT NULL
#define CATEGORY_HACKS_INFO_0_MT NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_MT NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_MT NULL
#define OPTION_VAL_1X_NATIVE_MT NULL
#define OPTION_VAL_2X_MT NULL
#define OPTION_VAL_4X_MT NULL
#define OPTION_VAL_8X_MT NULL
#define OPTION_VAL_16X_MT NULL
#define BEETLE_OPT_DEPTH_LABEL_MT NULL
#define BEETLE_OPT_DEPTH_INFO_0_MT NULL
#define OPTION_VAL_16BPP_NATIVE_MT NULL
#define OPTION_VAL_32BPP_MT NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_MT NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_MT NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_MT NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_MT NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_MT NULL
#define BEETLE_OPT_FILTER_LABEL_MT NULL
#define BEETLE_OPT_FILTER_INFO_0_MT NULL
#define OPTION_VAL_NEAREST_MT NULL
#define OPTION_VAL_SABR_MT NULL
#define OPTION_VAL_XBR_MT NULL
#define OPTION_VAL_BILINEAR_MT NULL
#define OPTION_VAL_3_POINT_MT NULL
#define OPTION_VAL_JINC2_MT NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_MT NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_MT NULL
#define OPTION_VAL_OPAQUE_MT NULL
#define OPTION_VAL_ALL_MT NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_MT NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_MT NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_MT NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_MT NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_MT NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_MT NULL
#define BEETLE_OPT_MSAA_LABEL_MT NULL
#define BEETLE_OPT_MSAA_INFO_0_MT NULL
#define OPTION_VAL_1X_MT NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_MT NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_MT NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_MT NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_MT NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_MT NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_MT NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_MT NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_MT NULL
#define BEETLE_OPT_WIREFRAME_LABEL_MT NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_MT NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_MT NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_MT NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_MT NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_MT NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_MT NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_MT NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_MT NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_MT NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_MT NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_MT NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_MT NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_MT NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_MT NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_MT NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_MT NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_MT NULL
#define OPTION_VAL_LIGHTGUN_MT NULL
#define OPTION_VAL_TOUCHSCREEN_MT NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_MT NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_MT NULL
#define OPTION_VAL_CROSS_MT NULL
#define OPTION_VAL_DOT_MT NULL
#define OPTION_VAL_OFF_MT NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_MT NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_MT NULL
#define OPTION_VAL_RED_MT NULL
#define OPTION_VAL_BLUE_MT NULL
#define OPTION_VAL_GREEN_MT NULL
#define OPTION_VAL_ORANGE_MT NULL
#define OPTION_VAL_YELLOW_MT NULL
#define OPTION_VAL_CYAN_MT NULL
#define OPTION_VAL_PINK_MT NULL
#define OPTION_VAL_PURPLE_MT NULL
#define OPTION_VAL_BLACK_MT NULL
#define OPTION_VAL_WHITE_MT NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_MT NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_MT NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_MT NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_MT NULL
#define OPTION_VAL_5_MT NULL
#define OPTION_VAL_10_MT NULL
#define OPTION_VAL_15_MT NULL
#define OPTION_VAL_20_MT NULL
#define OPTION_VAL_25_MT NULL
#define OPTION_VAL_30_MT NULL
#define OPTION_VAL_35_MT NULL
#define OPTION_VAL_40_MT NULL
#define OPTION_VAL_45_MT NULL
#define OPTION_VAL_50_MT NULL
#define OPTION_VAL_55_MT NULL
#define OPTION_VAL_60_MT NULL
#define OPTION_VAL_65_MT NULL
#define OPTION_VAL_70_MT NULL
#define OPTION_VAL_75_MT NULL
#define OPTION_VAL_80_MT NULL
#define OPTION_VAL_85_MT NULL
#define OPTION_VAL_90_MT NULL
#define OPTION_VAL_95_MT NULL
#define OPTION_VAL_100_MT NULL
#define OPTION_VAL_105_MT NULL
#define OPTION_VAL_110_MT NULL
#define OPTION_VAL_115_MT NULL
#define OPTION_VAL_120_MT NULL
#define OPTION_VAL_125_MT NULL
#define OPTION_VAL_130_MT NULL
#define OPTION_VAL_135_MT NULL
#define OPTION_VAL_140_MT NULL
#define OPTION_VAL_145_MT NULL
#define OPTION_VAL_150_MT NULL
#define OPTION_VAL_155_MT NULL
#define OPTION_VAL_160_MT NULL
#define OPTION_VAL_165_MT NULL
#define OPTION_VAL_170_MT NULL
#define OPTION_VAL_175_MT NULL
#define OPTION_VAL_180_MT NULL
#define OPTION_VAL_185_MT NULL
#define OPTION_VAL_190_MT NULL
#define OPTION_VAL_195_MT NULL
#define OPTION_VAL_200_MT NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_MT NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_MT NULL
#define OPTION_VAL_LINEAR_MT NULL
#define OPTION_VAL_QUADRATIC_MT NULL
#define OPTION_VAL_CUBIC_MT NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_MT NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_MT NULL
#define OPTION_VAL_0_MT NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_MT NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_MT NULL
#define OPTION_VAL_LIBRETRO_MT NULL
#define OPTION_VAL_MEDNAFEN_MT NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_MT NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_MT NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_MT NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_MT NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_MT NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_MT NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_MT NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_MT NULL
#define OPTION_VAL_1_MT NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_MT NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_MT NULL
#define OPTION_VAL_MEMORY_ONLY_MT NULL
#define OPTION_VAL_MEMORY_CPU_MT NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_MT NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_MT NULL
#define OPTION_VAL_0PX_MT NULL
#define OPTION_VAL_1PX_MT NULL
#define OPTION_VAL_2PX_MT NULL
#define OPTION_VAL_3PX_MT NULL
#define OPTION_VAL_4PX_MT NULL
#define OPTION_VAL_5PX_MT NULL
#define OPTION_VAL_6PX_MT NULL
#define OPTION_VAL_7PX_MT NULL
#define OPTION_VAL_8PX_MT NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_MT NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_MT NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_MT NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_MT NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_MT NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_MT NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_MT NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_MT NULL
#define OPTION_VAL_DEFAULT_MT NULL
#define OPTION_VAL_AGGRESSIVE_MT NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_MT NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_MT NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_MT NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_MT NULL
#define OPTION_VAL_16_9_MT NULL
#define OPTION_VAL_16_10_MT NULL
#define OPTION_VAL_18_9_MT NULL
#define OPTION_VAL_19_9_MT NULL
#define OPTION_VAL_20_9_MT NULL
#define OPTION_VAL_21_9_MT NULL
#define OPTION_VAL_32_9_MT NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_MT NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_MT NULL
#define OPTION_VAL_100_NATIVE_MT NULL
#define OPTION_VAL_210_MT NULL
#define OPTION_VAL_220_MT NULL
#define OPTION_VAL_230_MT NULL
#define OPTION_VAL_240_MT NULL
#define OPTION_VAL_250_MT NULL
#define OPTION_VAL_260_MT NULL
#define OPTION_VAL_270_MT NULL
#define OPTION_VAL_280_MT NULL
#define OPTION_VAL_290_MT NULL
#define OPTION_VAL_300_MT NULL
#define OPTION_VAL_310_MT NULL
#define OPTION_VAL_320_MT NULL
#define OPTION_VAL_330_MT NULL
#define OPTION_VAL_340_MT NULL
#define OPTION_VAL_350_MT NULL
#define OPTION_VAL_360_MT NULL
#define OPTION_VAL_370_MT NULL
#define OPTION_VAL_380_MT NULL
#define OPTION_VAL_390_MT NULL
#define OPTION_VAL_400_MT NULL
#define OPTION_VAL_410_MT NULL
#define OPTION_VAL_420_MT NULL
#define OPTION_VAL_430_MT NULL
#define OPTION_VAL_440_MT NULL
#define OPTION_VAL_450_MT NULL
#define OPTION_VAL_460_MT NULL
#define OPTION_VAL_470_MT NULL
#define OPTION_VAL_480_MT NULL
#define OPTION_VAL_490_MT NULL
#define OPTION_VAL_500_MT NULL
#define OPTION_VAL_510_MT NULL
#define OPTION_VAL_520_MT NULL
#define OPTION_VAL_530_MT NULL
#define OPTION_VAL_540_MT NULL
#define OPTION_VAL_550_MT NULL
#define OPTION_VAL_560_MT NULL
#define OPTION_VAL_570_MT NULL
#define OPTION_VAL_580_MT NULL
#define OPTION_VAL_590_MT NULL
#define OPTION_VAL_600_MT NULL
#define OPTION_VAL_610_MT NULL
#define OPTION_VAL_620_MT NULL
#define OPTION_VAL_630_MT NULL
#define OPTION_VAL_640_MT NULL
#define OPTION_VAL_650_MT NULL
#define OPTION_VAL_660_MT NULL
#define OPTION_VAL_670_MT NULL
#define OPTION_VAL_680_MT NULL
#define OPTION_VAL_690_MT NULL
#define OPTION_VAL_700_MT NULL
#define OPTION_VAL_710_MT NULL
#define OPTION_VAL_720_MT NULL
#define OPTION_VAL_730_MT NULL
#define OPTION_VAL_740_MT NULL
#define OPTION_VAL_750_MT NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_MT NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_MT NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_MT NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_MT NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_MT NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_MT NULL
#define OPTION_VAL_PSXONPSP_MT NULL
#define OPTION_VAL_PS1_ROM_MT NULL
#define BEETLE_OPT_RENDERER_LABEL_MT NULL
#define BEETLE_OPT_RENDERER_INFO_0_MT NULL
#define OPTION_VAL_HARDWARE_MT NULL
#define OPTION_VAL_HARDWARE_GL_MT NULL
#define OPTION_VAL_HARDWARE_VK_MT NULL
#define OPTION_VAL_SOFTWARE_MT NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_MT NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_MT NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_MT NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_MT NULL
#define OPTION_VAL_DISABLED_MT NULL
#define OPTION_VAL_EXECUTE_MT NULL
#define OPTION_VAL_EXECUTE_ONE_MT NULL
#define OPTION_VAL_RUN_INTERPRETER_MT NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_MT NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_MT NULL
#define OPTION_VAL_FULL_MT NULL
#define OPTION_VAL_DMA_MT NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_MT NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_MT NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_MT NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_MT NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_MT NULL
#define OPTION_VAL_FORCE_INTERLACED_MT NULL
#define OPTION_VAL_AUTO_TOGGLE_MT NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_MT NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_MT NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_MT NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_MT NULL
#define OPTION_VAL_DISABLED_O53_MT NULL
#define OPTION_VAL_STATIC_MT NULL
#define OPTION_VAL_SMART_MT NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_MT NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_MT NULL
#define OPTION_VAL_9PX_MT NULL
#define OPTION_VAL_10PX_MT NULL
#define OPTION_VAL_11PX_MT NULL
#define OPTION_VAL_12PX_MT NULL
#define OPTION_VAL_13PX_MT NULL
#define OPTION_VAL_14PX_MT NULL
#define OPTION_VAL_15PX_MT NULL
#define OPTION_VAL_16PX_MT NULL
#define OPTION_VAL_17PX_MT NULL
#define OPTION_VAL_18PX_MT NULL
#define OPTION_VAL_19PX_MT NULL
#define OPTION_VAL_20PX_MT NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_MT NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_MT NULL
#define OPTION_VAL_12PX_O55_MT NULL
#define OPTION_VAL_11PX_O55_MT NULL
#define OPTION_VAL_10PX_O55_MT NULL
#define OPTION_VAL_9PX_O55_MT NULL
#define OPTION_VAL_8PX_O55_MT NULL
#define OPTION_VAL_7PX_O55_MT NULL
#define OPTION_VAL_6PX_O55_MT NULL
#define OPTION_VAL_5PX_O55_MT NULL
#define OPTION_VAL_4PX_O55_MT NULL
#define OPTION_VAL_3PX_O55_MT NULL
#define OPTION_VAL_2PX_O55_MT NULL
#define OPTION_VAL_1PX_O55_MT NULL
#define OPTION_VAL_DISABLED_O55_MT NULL
#define OPTION_VAL_1PX_O55_0_MT NULL
#define OPTION_VAL_2PX_O55_0_MT NULL
#define OPTION_VAL_3PX_O55_0_MT NULL
#define OPTION_VAL_4PX_O55_0_MT NULL
#define OPTION_VAL_5PX_O55_0_MT NULL
#define OPTION_VAL_6PX_O55_0_MT NULL
#define OPTION_VAL_7PX_O55_0_MT NULL
#define OPTION_VAL_8PX_O55_0_MT NULL
#define OPTION_VAL_9PX_O55_0_MT NULL
#define OPTION_VAL_10PX_O55_0_MT NULL
#define OPTION_VAL_11PX_O55_0_MT NULL
#define OPTION_VAL_12PX_O55_0_MT NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_MT NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_MT NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_MT NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_MT NULL
#define OPTION_VAL_32X_MT NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_MT NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_MT NULL
#define OPTION_VAL_CORRECTED_MT NULL
#define OPTION_VAL_UNCORRECTED_MT NULL
#define OPTION_VAL_4_3_MT NULL
#define OPTION_VAL_NTSC_MT NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_MT NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_MT NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_MT NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_MT NULL
#define OPTION_VAL_239_MT NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_MT NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_MT NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_MT NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_MT NULL
#define OPTION_VAL_287_MT NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_MT NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_MT NULL
#define OPTION_VAL_SYNC_MT NULL
#define OPTION_VAL_ASYNC_MT NULL
#define OPTION_VAL_PRECACHE_MT NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_MT NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_MT NULL
#define OPTION_VAL_2X_NATIVE_MT NULL
#define OPTION_VAL_6X_MT NULL
#define OPTION_VAL_10X_MT NULL
#define OPTION_VAL_12X_MT NULL
#define OPTION_VAL_14X_MT NULL

struct retro_core_option_v2_category option_cats_mt[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_MT,
      CATEGORY_VIDEO_INFO_0_MT
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_MT,
      CATEGORY_OSD_INFO_0_MT
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_MT,
      CATEGORY_INPUT_INFO_0_MT
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_MT,
      CATEGORY_MEMCARDS_INFO_0_MT
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_MT,
      CATEGORY_PGXP_INFO_0_MT
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_MT,
      CATEGORY_HACKS_INFO_0_MT
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_mt[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_MT,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_MT,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_MT },
         { "2x",         OPTION_VAL_2X_MT },
         { "4x",         OPTION_VAL_4X_MT },
         { "8x",         OPTION_VAL_8X_MT },
         { "16x",        OPTION_VAL_16X_MT },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_MT,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_MT,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_MT },
         { "32bpp",         OPTION_VAL_32BPP_MT },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_MT,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_MT,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_MT },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_MT },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_MT,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_MT,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_MT,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_MT,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_MT },
         { "SABR",     OPTION_VAL_SABR_MT },
         { "xBR",      OPTION_VAL_XBR_MT },
         { "bilinear", OPTION_VAL_BILINEAR_MT },
         { "3-point",  OPTION_VAL_3_POINT_MT },
         { "JINC2",    OPTION_VAL_JINC2_MT },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_MT,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_MT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_MT },
         { "all", OPTION_VAL_ALL_MT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_MT,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_MT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_MT },
         { "all", OPTION_VAL_ALL_MT },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_MT,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_MT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_MT,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_MT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_MT,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_MT,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_MT },
         { "2x",  OPTION_VAL_2X_MT },
         { "4x",  OPTION_VAL_4X_MT },
         { "8x",  OPTION_VAL_8X_MT },
         { "16x", OPTION_VAL_16X_MT },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_MT,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_MT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_MT,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_MT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_MT,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_MT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_MT,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_MT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_MT,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_MT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_MT,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_MT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_MT,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_MT,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_MT,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_MT,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_MT,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_MT,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_MT,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_MT,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_MT,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_MT,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_MT,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_MT,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_MT,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_MT,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_MT },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_MT },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_MT,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_MT,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_MT },
         { "dot",   OPTION_VAL_DOT_MT },
         { "off",   OPTION_VAL_OFF_MT },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_MT,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_MT,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_MT },
         { "blue", OPTION_VAL_BLUE_MT },
         { "green", OPTION_VAL_GREEN_MT },
         { "orange", OPTION_VAL_ORANGE_MT },
         { "yellow", OPTION_VAL_YELLOW_MT },
         { "cyan", OPTION_VAL_CYAN_MT },
         { "pink", OPTION_VAL_PINK_MT },
         { "purple", OPTION_VAL_PURPLE_MT },
         { "black", OPTION_VAL_BLACK_MT },
         { "white", OPTION_VAL_WHITE_MT },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_MT,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_MT,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_MT },
         { "red", OPTION_VAL_RED_MT },
         { "green", OPTION_VAL_GREEN_MT },
         { "orange", OPTION_VAL_ORANGE_MT },
         { "yellow", OPTION_VAL_YELLOW_MT },
         { "cyan", OPTION_VAL_CYAN_MT },
         { "pink", OPTION_VAL_PINK_MT },
         { "purple", OPTION_VAL_PURPLE_MT },
         { "black", OPTION_VAL_BLACK_MT },
         { "white", OPTION_VAL_WHITE_MT },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_MT,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_MT,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_MT },
         { "10%",  OPTION_VAL_10_MT },
         { "15%",  OPTION_VAL_15_MT },
         { "20%",  OPTION_VAL_20_MT },
         { "25%",  OPTION_VAL_25_MT },
         { "30%",  OPTION_VAL_30_MT },
         { "35%",  OPTION_VAL_35_MT },
         { "40%",  OPTION_VAL_40_MT },
         { "45%",  OPTION_VAL_45_MT },
         { "50%",  OPTION_VAL_50_MT },
         { "55%",  OPTION_VAL_55_MT },
         { "60%",  OPTION_VAL_60_MT },
         { "65%",  OPTION_VAL_65_MT },
         { "70%",  OPTION_VAL_70_MT },
         { "75%",  OPTION_VAL_75_MT },
         { "80%",  OPTION_VAL_80_MT },
         { "85%",  OPTION_VAL_85_MT },
         { "90%",  OPTION_VAL_90_MT },
         { "95%",  OPTION_VAL_95_MT },
         { "100%", OPTION_VAL_100_MT },
         { "105%", OPTION_VAL_105_MT },
         { "110%", OPTION_VAL_110_MT },
         { "115%", OPTION_VAL_115_MT },
         { "120%", OPTION_VAL_120_MT },
         { "125%", OPTION_VAL_125_MT },
         { "130%", OPTION_VAL_130_MT },
         { "135%", OPTION_VAL_135_MT },
         { "140%", OPTION_VAL_140_MT },
         { "145%", OPTION_VAL_145_MT },
         { "150%", OPTION_VAL_150_MT },
         { "155%", OPTION_VAL_155_MT },
         { "160%", OPTION_VAL_160_MT },
         { "165%", OPTION_VAL_165_MT },
         { "170%", OPTION_VAL_170_MT },
         { "175%", OPTION_VAL_175_MT },
         { "180%", OPTION_VAL_180_MT },
         { "185%", OPTION_VAL_185_MT },
         { "190%", OPTION_VAL_190_MT },
         { "195%", OPTION_VAL_195_MT },
         { "200%", OPTION_VAL_200_MT },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_MT,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_MT,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_MT },
         { "quadratic", OPTION_VAL_QUADRATIC_MT },
         { "cubic",     OPTION_VAL_CUBIC_MT },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_MT,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_MT,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_MT },
         { "5%",  OPTION_VAL_5_MT },
         { "10%", OPTION_VAL_10_MT },
         { "15%", OPTION_VAL_15_MT },
         { "20%", OPTION_VAL_20_MT },
         { "25%", OPTION_VAL_25_MT },
         { "30%", OPTION_VAL_30_MT },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_MT,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_MT,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_MT },
         { "mednafen", OPTION_VAL_MEDNAFEN_MT },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_MT,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_MT,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_MT,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_MT,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_MT,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_MT,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_MT,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_MT,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_MT },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_MT,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_MT,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_MT },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_MT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_MT,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_MT,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_MT },
         { "1px", OPTION_VAL_1PX_MT },
         { "2px", OPTION_VAL_2PX_MT },
         { "3px", OPTION_VAL_3PX_MT },
         { "4px", OPTION_VAL_4PX_MT },
         { "5px", OPTION_VAL_5PX_MT },
         { "6px", OPTION_VAL_6PX_MT },
         { "7px", OPTION_VAL_7PX_MT },
         { "8px", OPTION_VAL_8PX_MT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_MT,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_MT,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_MT,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_MT,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_MT,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_MT,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_MT,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_MT,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_MT },
         { "aggressive", OPTION_VAL_AGGRESSIVE_MT },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_MT,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_MT,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_MT,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_MT,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_MT },
         { "16:10", OPTION_VAL_16_10_MT },
         { "18:9",  OPTION_VAL_18_9_MT },
         { "19:9",  OPTION_VAL_19_9_MT },
         { "20:9",  OPTION_VAL_20_9_MT },
         { "21:9",  OPTION_VAL_21_9_MT }, // 64:27
         { "32:9",  OPTION_VAL_32_9_MT },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_MT,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_MT,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_MT },
         { "60%",           OPTION_VAL_60_MT },
         { "70%",           OPTION_VAL_70_MT },
         { "80%",           OPTION_VAL_80_MT },
         { "90%",           OPTION_VAL_90_MT },
         { "100%(native)", OPTION_VAL_100_NATIVE_MT },
         { "110%",          OPTION_VAL_110_MT },
         { "120%",          OPTION_VAL_120_MT },
         { "130%",          OPTION_VAL_130_MT },
         { "140%",          OPTION_VAL_140_MT },
         { "150%",          OPTION_VAL_150_MT },
         { "160%",          OPTION_VAL_160_MT },
         { "170%",          OPTION_VAL_170_MT },
         { "180%",          OPTION_VAL_180_MT },
         { "190%",          OPTION_VAL_190_MT },
         { "200%",          OPTION_VAL_200_MT },
         { "210%",          OPTION_VAL_210_MT },
         { "220%",          OPTION_VAL_220_MT },
         { "230%",          OPTION_VAL_230_MT },
         { "240%",          OPTION_VAL_240_MT },
         { "250%",          OPTION_VAL_250_MT },
         { "260%",          OPTION_VAL_260_MT },
         { "270%",          OPTION_VAL_270_MT },
         { "280%",          OPTION_VAL_280_MT },
         { "290%",          OPTION_VAL_290_MT },
         { "300%",          OPTION_VAL_300_MT },
         { "310%",          OPTION_VAL_310_MT },
         { "320%",          OPTION_VAL_320_MT },
         { "330%",          OPTION_VAL_330_MT },
         { "340%",          OPTION_VAL_340_MT },
         { "350%",          OPTION_VAL_350_MT },
         { "360%",          OPTION_VAL_360_MT },
         { "370%",          OPTION_VAL_370_MT },
         { "380%",          OPTION_VAL_380_MT },
         { "390%",          OPTION_VAL_390_MT },
         { "400%",          OPTION_VAL_400_MT },
         { "410%",          OPTION_VAL_410_MT },
         { "420%",          OPTION_VAL_420_MT },
         { "430%",          OPTION_VAL_430_MT },
         { "440%",          OPTION_VAL_440_MT },
         { "450%",          OPTION_VAL_450_MT },
         { "460%",          OPTION_VAL_460_MT },
         { "470%",          OPTION_VAL_470_MT },
         { "480%",          OPTION_VAL_480_MT },
         { "490%",          OPTION_VAL_490_MT },
         { "500%",          OPTION_VAL_500_MT },
         { "510%",          OPTION_VAL_510_MT },
         { "520%",          OPTION_VAL_520_MT },
         { "530%",          OPTION_VAL_530_MT },
         { "540%",          OPTION_VAL_540_MT },
         { "550%",          OPTION_VAL_550_MT },
         { "560%",          OPTION_VAL_560_MT },
         { "570%",          OPTION_VAL_570_MT },
         { "580%",          OPTION_VAL_580_MT },
         { "590%",          OPTION_VAL_590_MT },
         { "600%",          OPTION_VAL_600_MT },
         { "610%",          OPTION_VAL_610_MT },
         { "620%",          OPTION_VAL_620_MT },
         { "630%",          OPTION_VAL_630_MT },
         { "640%",          OPTION_VAL_640_MT },
         { "650%",          OPTION_VAL_650_MT },
         { "660%",          OPTION_VAL_660_MT },
         { "670%",          OPTION_VAL_670_MT },
         { "680%",          OPTION_VAL_680_MT },
         { "690%",          OPTION_VAL_690_MT },
         { "700%",          OPTION_VAL_700_MT },
         { "710%",          OPTION_VAL_710_MT },
         { "720%",          OPTION_VAL_720_MT },
         { "730%",          OPTION_VAL_730_MT },
         { "740%",          OPTION_VAL_740_MT },
         { "750%",          OPTION_VAL_750_MT },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_MT,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_MT,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_MT,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_MT,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_MT,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_MT,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_MT },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_MT },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_MT,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_MT,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_MT },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_MT },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_MT },
#endif
         { "software",    OPTION_VAL_SOFTWARE_MT },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_MT,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_MT,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_MT,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_MT,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_MT },
         { "execute",  OPTION_VAL_EXECUTE_MT },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_MT },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_MT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_MT,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_MT,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_MT },
         { "dma",  OPTION_VAL_DMA_MT },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_MT,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_MT,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_MT,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_MT,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_MT },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_MT },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_MT },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_MT,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_MT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_MT,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_MT,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_MT },
         { "static",  OPTION_VAL_STATIC_MT },
         { "smart", OPTION_VAL_SMART_MT },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_MT,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_MT,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_MT },
         { "2px",      OPTION_VAL_2PX_MT },
         { "3px",      OPTION_VAL_3PX_MT },
         { "4px",      OPTION_VAL_4PX_MT },
         { "5px",      OPTION_VAL_5PX_MT },
         { "6px",      OPTION_VAL_6PX_MT },
         { "7px",      OPTION_VAL_7PX_MT },
         { "8px",      OPTION_VAL_8PX_MT },
         { "9px",      OPTION_VAL_9PX_MT },
         { "10px",     OPTION_VAL_10PX_MT },
         { "11px",     OPTION_VAL_11PX_MT },
         { "12px",     OPTION_VAL_12PX_MT },
         { "13px",     OPTION_VAL_13PX_MT },
         { "14px",     OPTION_VAL_14PX_MT },
         { "15px",     OPTION_VAL_15PX_MT },
         { "16px",     OPTION_VAL_16PX_MT },
         { "17px",     OPTION_VAL_17PX_MT },
         { "18px",     OPTION_VAL_18PX_MT },
         { "19px",     OPTION_VAL_19PX_MT },
         { "20px",     OPTION_VAL_20PX_MT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_MT,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_MT,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_MT },
         { "-11px",    OPTION_VAL_11PX_O55_MT },
         { "-10px",    OPTION_VAL_10PX_O55_MT },
         { "-9px",     OPTION_VAL_9PX_O55_MT },
         { "-8px",     OPTION_VAL_8PX_O55_MT },
         { "-7px",     OPTION_VAL_7PX_O55_MT },
         { "-6px",     OPTION_VAL_6PX_O55_MT },
         { "-5px",     OPTION_VAL_5PX_O55_MT },
         { "-4px",     OPTION_VAL_4PX_O55_MT },
         { "-3px",     OPTION_VAL_3PX_O55_MT },
         { "-2px",     OPTION_VAL_2PX_O55_MT },
         { "-1px",     OPTION_VAL_1PX_O55_MT },
         { "disabled", OPTION_VAL_DISABLED_O55_MT },
         { "+1px",     OPTION_VAL_1PX_O55_0_MT },
         { "+2px",     OPTION_VAL_2PX_O55_0_MT },
         { "+3px",     OPTION_VAL_3PX_O55_0_MT },
         { "+4px",     OPTION_VAL_4PX_O55_0_MT },
         { "+5px",     OPTION_VAL_5PX_O55_0_MT },
         { "+6px",     OPTION_VAL_6PX_O55_0_MT },
         { "+7px",     OPTION_VAL_7PX_O55_0_MT },
         { "+8px",     OPTION_VAL_8PX_O55_0_MT },
         { "+9px",     OPTION_VAL_9PX_O55_0_MT },
         { "+10px",    OPTION_VAL_10PX_O55_0_MT },
         { "+11px",    OPTION_VAL_11PX_O55_0_MT },
         { "+12px",    OPTION_VAL_12PX_O55_0_MT },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_MT,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_MT,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_MT },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_MT,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_MT,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_MT },
         { "2x",         OPTION_VAL_2X_MT },
         { "4x",         OPTION_VAL_4X_MT },
         { "8x",         OPTION_VAL_8X_MT },
         { "16x",        OPTION_VAL_16X_MT },
         { "32x",        OPTION_VAL_32X_MT },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_MT,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_MT,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_MT },
         { "uncorrected", OPTION_VAL_UNCORRECTED_MT },
         { "4:3",  OPTION_VAL_4_3_MT },
         { "ntsc", OPTION_VAL_NTSC_MT },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_MT,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_MT,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_MT,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_MT,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_MT },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_MT,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_MT,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_MT,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_MT,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_MT },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_MT,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_MT,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_MT },
         { "async",    OPTION_VAL_ASYNC_MT },
         { "precache", OPTION_VAL_PRECACHE_MT },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_MT,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_MT,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_MT },
         { "4x",          OPTION_VAL_4X_MT },
         { "6x",          OPTION_VAL_6X_MT },
         { "8x",          OPTION_VAL_8X_MT },
         { "10x",         OPTION_VAL_10X_MT },
         { "12x",         OPTION_VAL_12X_MT },
         { "14x",         OPTION_VAL_14X_MT },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_mt = {
   option_cats_mt,
   option_defs_mt
};

/* RETRO_LANGUAGE_NL */

#define CATEGORY_VIDEO_LABEL_NL NULL
#define CATEGORY_VIDEO_INFO_0_NL NULL
#define CATEGORY_OSD_LABEL_NL "Onscreen meldingen"
#define CATEGORY_OSD_INFO_0_NL NULL
#define CATEGORY_INPUT_LABEL_NL "Invoer"
#define CATEGORY_INPUT_INFO_0_NL NULL
#define CATEGORY_MEMCARDS_LABEL_NL NULL
#define CATEGORY_MEMCARDS_INFO_0_NL NULL
#define CATEGORY_PGXP_LABEL_NL NULL
#define CATEGORY_PGXP_INFO_0_NL NULL
#define CATEGORY_HACKS_LABEL_NL NULL
#define CATEGORY_HACKS_INFO_0_NL NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_NL NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_NL NULL
#define OPTION_VAL_1X_NATIVE_NL NULL
#define OPTION_VAL_2X_NL NULL
#define OPTION_VAL_4X_NL NULL
#define OPTION_VAL_8X_NL NULL
#define OPTION_VAL_16X_NL NULL
#define BEETLE_OPT_DEPTH_LABEL_NL NULL
#define BEETLE_OPT_DEPTH_INFO_0_NL NULL
#define OPTION_VAL_16BPP_NATIVE_NL NULL
#define OPTION_VAL_32BPP_NL NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_NL NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_NL NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_NL NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_NL NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_NL NULL
#define BEETLE_OPT_FILTER_LABEL_NL NULL
#define BEETLE_OPT_FILTER_INFO_0_NL NULL
#define OPTION_VAL_NEAREST_NL "Naaste"
#define OPTION_VAL_SABR_NL NULL
#define OPTION_VAL_XBR_NL NULL
#define OPTION_VAL_BILINEAR_NL "Bilineair"
#define OPTION_VAL_3_POINT_NL NULL
#define OPTION_VAL_JINC2_NL NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_NL NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_NL NULL
#define OPTION_VAL_OPAQUE_NL NULL
#define OPTION_VAL_ALL_NL NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_NL NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_NL NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_NL NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_NL NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_NL NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_NL NULL
#define BEETLE_OPT_MSAA_LABEL_NL NULL
#define BEETLE_OPT_MSAA_INFO_0_NL NULL
#define OPTION_VAL_1X_NL NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_NL NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_NL NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_NL NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_NL NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_NL NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_NL NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_NL NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_NL NULL
#define BEETLE_OPT_WIREFRAME_LABEL_NL NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_NL NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_NL NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_NL NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_NL NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_NL NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_NL NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_NL NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_NL NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_NL NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_NL NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_NL NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_NL NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_NL NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_NL NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_NL NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_NL NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_NL NULL
#define OPTION_VAL_LIGHTGUN_NL NULL
#define OPTION_VAL_TOUCHSCREEN_NL NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_NL NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_NL NULL
#define OPTION_VAL_CROSS_NL NULL
#define OPTION_VAL_DOT_NL NULL
#define OPTION_VAL_OFF_NL NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_NL NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_NL NULL
#define OPTION_VAL_RED_NL "Rood"
#define OPTION_VAL_BLUE_NL "Blauw"
#define OPTION_VAL_GREEN_NL "Groen"
#define OPTION_VAL_ORANGE_NL NULL
#define OPTION_VAL_YELLOW_NL "Geel"
#define OPTION_VAL_CYAN_NL NULL
#define OPTION_VAL_PINK_NL NULL
#define OPTION_VAL_PURPLE_NL NULL
#define OPTION_VAL_BLACK_NL NULL
#define OPTION_VAL_WHITE_NL NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_NL NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_NL NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_NL NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_NL NULL
#define OPTION_VAL_5_NL NULL
#define OPTION_VAL_10_NL NULL
#define OPTION_VAL_15_NL NULL
#define OPTION_VAL_20_NL NULL
#define OPTION_VAL_25_NL NULL
#define OPTION_VAL_30_NL NULL
#define OPTION_VAL_35_NL NULL
#define OPTION_VAL_40_NL NULL
#define OPTION_VAL_45_NL NULL
#define OPTION_VAL_50_NL NULL
#define OPTION_VAL_55_NL NULL
#define OPTION_VAL_60_NL NULL
#define OPTION_VAL_65_NL NULL
#define OPTION_VAL_70_NL NULL
#define OPTION_VAL_75_NL NULL
#define OPTION_VAL_80_NL NULL
#define OPTION_VAL_85_NL NULL
#define OPTION_VAL_90_NL NULL
#define OPTION_VAL_95_NL NULL
#define OPTION_VAL_100_NL NULL
#define OPTION_VAL_105_NL NULL
#define OPTION_VAL_110_NL NULL
#define OPTION_VAL_115_NL NULL
#define OPTION_VAL_120_NL NULL
#define OPTION_VAL_125_NL NULL
#define OPTION_VAL_130_NL NULL
#define OPTION_VAL_135_NL NULL
#define OPTION_VAL_140_NL NULL
#define OPTION_VAL_145_NL NULL
#define OPTION_VAL_150_NL NULL
#define OPTION_VAL_155_NL NULL
#define OPTION_VAL_160_NL NULL
#define OPTION_VAL_165_NL NULL
#define OPTION_VAL_170_NL NULL
#define OPTION_VAL_175_NL NULL
#define OPTION_VAL_180_NL NULL
#define OPTION_VAL_185_NL NULL
#define OPTION_VAL_190_NL NULL
#define OPTION_VAL_195_NL NULL
#define OPTION_VAL_200_NL NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_NL NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_NL NULL
#define OPTION_VAL_LINEAR_NL "Lineair"
#define OPTION_VAL_QUADRATIC_NL NULL
#define OPTION_VAL_CUBIC_NL NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_NL NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_NL NULL
#define OPTION_VAL_0_NL NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_NL NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_NL NULL
#define OPTION_VAL_LIBRETRO_NL NULL
#define OPTION_VAL_MEDNAFEN_NL NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_NL NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_NL NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_NL NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_NL NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_NL NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_NL NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_NL NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_NL NULL
#define OPTION_VAL_1_NL NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_NL NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_NL NULL
#define OPTION_VAL_MEMORY_ONLY_NL NULL
#define OPTION_VAL_MEMORY_CPU_NL NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_NL NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_NL NULL
#define OPTION_VAL_0PX_NL NULL
#define OPTION_VAL_1PX_NL NULL
#define OPTION_VAL_2PX_NL NULL
#define OPTION_VAL_3PX_NL NULL
#define OPTION_VAL_4PX_NL NULL
#define OPTION_VAL_5PX_NL NULL
#define OPTION_VAL_6PX_NL NULL
#define OPTION_VAL_7PX_NL NULL
#define OPTION_VAL_8PX_NL NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_NL NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_NL NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_NL NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_NL NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_NL NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_NL NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_NL NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_NL NULL
#define OPTION_VAL_DEFAULT_NL NULL
#define OPTION_VAL_AGGRESSIVE_NL NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_NL NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_NL NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_NL NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_NL NULL
#define OPTION_VAL_16_9_NL NULL
#define OPTION_VAL_16_10_NL NULL
#define OPTION_VAL_18_9_NL NULL
#define OPTION_VAL_19_9_NL NULL
#define OPTION_VAL_20_9_NL NULL
#define OPTION_VAL_21_9_NL NULL
#define OPTION_VAL_32_9_NL NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_NL NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_NL NULL
#define OPTION_VAL_100_NATIVE_NL NULL
#define OPTION_VAL_210_NL NULL
#define OPTION_VAL_220_NL NULL
#define OPTION_VAL_230_NL NULL
#define OPTION_VAL_240_NL NULL
#define OPTION_VAL_250_NL NULL
#define OPTION_VAL_260_NL NULL
#define OPTION_VAL_270_NL NULL
#define OPTION_VAL_280_NL NULL
#define OPTION_VAL_290_NL NULL
#define OPTION_VAL_300_NL NULL
#define OPTION_VAL_310_NL NULL
#define OPTION_VAL_320_NL NULL
#define OPTION_VAL_330_NL NULL
#define OPTION_VAL_340_NL NULL
#define OPTION_VAL_350_NL NULL
#define OPTION_VAL_360_NL NULL
#define OPTION_VAL_370_NL NULL
#define OPTION_VAL_380_NL NULL
#define OPTION_VAL_390_NL NULL
#define OPTION_VAL_400_NL NULL
#define OPTION_VAL_410_NL NULL
#define OPTION_VAL_420_NL NULL
#define OPTION_VAL_430_NL NULL
#define OPTION_VAL_440_NL NULL
#define OPTION_VAL_450_NL NULL
#define OPTION_VAL_460_NL NULL
#define OPTION_VAL_470_NL NULL
#define OPTION_VAL_480_NL NULL
#define OPTION_VAL_490_NL NULL
#define OPTION_VAL_500_NL NULL
#define OPTION_VAL_510_NL NULL
#define OPTION_VAL_520_NL NULL
#define OPTION_VAL_530_NL NULL
#define OPTION_VAL_540_NL NULL
#define OPTION_VAL_550_NL NULL
#define OPTION_VAL_560_NL NULL
#define OPTION_VAL_570_NL NULL
#define OPTION_VAL_580_NL NULL
#define OPTION_VAL_590_NL NULL
#define OPTION_VAL_600_NL NULL
#define OPTION_VAL_610_NL NULL
#define OPTION_VAL_620_NL NULL
#define OPTION_VAL_630_NL NULL
#define OPTION_VAL_640_NL NULL
#define OPTION_VAL_650_NL NULL
#define OPTION_VAL_660_NL NULL
#define OPTION_VAL_670_NL NULL
#define OPTION_VAL_680_NL NULL
#define OPTION_VAL_690_NL NULL
#define OPTION_VAL_700_NL NULL
#define OPTION_VAL_710_NL NULL
#define OPTION_VAL_720_NL NULL
#define OPTION_VAL_730_NL NULL
#define OPTION_VAL_740_NL NULL
#define OPTION_VAL_750_NL NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_NL NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_NL NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_NL NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_NL NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_NL NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_NL NULL
#define OPTION_VAL_PSXONPSP_NL NULL
#define OPTION_VAL_PS1_ROM_NL NULL
#define BEETLE_OPT_RENDERER_LABEL_NL NULL
#define BEETLE_OPT_RENDERER_INFO_0_NL NULL
#define OPTION_VAL_HARDWARE_NL NULL
#define OPTION_VAL_HARDWARE_GL_NL NULL
#define OPTION_VAL_HARDWARE_VK_NL NULL
#define OPTION_VAL_SOFTWARE_NL NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_NL NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_NL NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_NL NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_NL NULL
#define OPTION_VAL_DISABLED_NL NULL
#define OPTION_VAL_EXECUTE_NL NULL
#define OPTION_VAL_EXECUTE_ONE_NL NULL
#define OPTION_VAL_RUN_INTERPRETER_NL NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_NL NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_NL NULL
#define OPTION_VAL_FULL_NL NULL
#define OPTION_VAL_DMA_NL NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_NL NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_NL NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_NL NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_NL NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_NL NULL
#define OPTION_VAL_FORCE_INTERLACED_NL NULL
#define OPTION_VAL_AUTO_TOGGLE_NL NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_NL NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_NL NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_NL NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_NL NULL
#define OPTION_VAL_DISABLED_O53_NL "Geen"
#define OPTION_VAL_STATIC_NL NULL
#define OPTION_VAL_SMART_NL NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_NL NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_NL NULL
#define OPTION_VAL_9PX_NL NULL
#define OPTION_VAL_10PX_NL NULL
#define OPTION_VAL_11PX_NL NULL
#define OPTION_VAL_12PX_NL NULL
#define OPTION_VAL_13PX_NL NULL
#define OPTION_VAL_14PX_NL NULL
#define OPTION_VAL_15PX_NL NULL
#define OPTION_VAL_16PX_NL NULL
#define OPTION_VAL_17PX_NL NULL
#define OPTION_VAL_18PX_NL NULL
#define OPTION_VAL_19PX_NL NULL
#define OPTION_VAL_20PX_NL NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_NL NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_NL NULL
#define OPTION_VAL_12PX_O55_NL NULL
#define OPTION_VAL_11PX_O55_NL NULL
#define OPTION_VAL_10PX_O55_NL NULL
#define OPTION_VAL_9PX_O55_NL NULL
#define OPTION_VAL_8PX_O55_NL NULL
#define OPTION_VAL_7PX_O55_NL NULL
#define OPTION_VAL_6PX_O55_NL NULL
#define OPTION_VAL_5PX_O55_NL NULL
#define OPTION_VAL_4PX_O55_NL NULL
#define OPTION_VAL_3PX_O55_NL NULL
#define OPTION_VAL_2PX_O55_NL NULL
#define OPTION_VAL_1PX_O55_NL NULL
#define OPTION_VAL_DISABLED_O55_NL NULL
#define OPTION_VAL_1PX_O55_0_NL NULL
#define OPTION_VAL_2PX_O55_0_NL NULL
#define OPTION_VAL_3PX_O55_0_NL NULL
#define OPTION_VAL_4PX_O55_0_NL NULL
#define OPTION_VAL_5PX_O55_0_NL NULL
#define OPTION_VAL_6PX_O55_0_NL NULL
#define OPTION_VAL_7PX_O55_0_NL NULL
#define OPTION_VAL_8PX_O55_0_NL NULL
#define OPTION_VAL_9PX_O55_0_NL NULL
#define OPTION_VAL_10PX_O55_0_NL NULL
#define OPTION_VAL_11PX_O55_0_NL NULL
#define OPTION_VAL_12PX_O55_0_NL NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_NL NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_NL NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_NL NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_NL NULL
#define OPTION_VAL_32X_NL NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_NL NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_NL NULL
#define OPTION_VAL_CORRECTED_NL NULL
#define OPTION_VAL_UNCORRECTED_NL NULL
#define OPTION_VAL_4_3_NL NULL
#define OPTION_VAL_NTSC_NL NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_NL NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_NL NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_NL NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_NL NULL
#define OPTION_VAL_239_NL NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_NL NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_NL NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_NL NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_NL NULL
#define OPTION_VAL_287_NL NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_NL NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_NL NULL
#define OPTION_VAL_SYNC_NL NULL
#define OPTION_VAL_ASYNC_NL NULL
#define OPTION_VAL_PRECACHE_NL NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_NL NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_NL NULL
#define OPTION_VAL_2X_NATIVE_NL NULL
#define OPTION_VAL_6X_NL NULL
#define OPTION_VAL_10X_NL NULL
#define OPTION_VAL_12X_NL NULL
#define OPTION_VAL_14X_NL NULL

struct retro_core_option_v2_category option_cats_nl[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_NL,
      CATEGORY_VIDEO_INFO_0_NL
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_NL,
      CATEGORY_OSD_INFO_0_NL
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_NL,
      CATEGORY_INPUT_INFO_0_NL
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_NL,
      CATEGORY_MEMCARDS_INFO_0_NL
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_NL,
      CATEGORY_PGXP_INFO_0_NL
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_NL,
      CATEGORY_HACKS_INFO_0_NL
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_nl[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_NL,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_NL,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_NL },
         { "2x",         OPTION_VAL_2X_NL },
         { "4x",         OPTION_VAL_4X_NL },
         { "8x",         OPTION_VAL_8X_NL },
         { "16x",        OPTION_VAL_16X_NL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_NL,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_NL,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_NL },
         { "32bpp",         OPTION_VAL_32BPP_NL },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_NL,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_NL,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_NL },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_NL },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_NL,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_NL,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_NL,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_NL,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_NL },
         { "SABR",     OPTION_VAL_SABR_NL },
         { "xBR",      OPTION_VAL_XBR_NL },
         { "bilinear", OPTION_VAL_BILINEAR_NL },
         { "3-point",  OPTION_VAL_3_POINT_NL },
         { "JINC2",    OPTION_VAL_JINC2_NL },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_NL,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_NL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_NL },
         { "all", OPTION_VAL_ALL_NL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_NL,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_NL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_NL },
         { "all", OPTION_VAL_ALL_NL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_NL,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_NL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_NL,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_NL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_NL,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_NL,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_NL },
         { "2x",  OPTION_VAL_2X_NL },
         { "4x",  OPTION_VAL_4X_NL },
         { "8x",  OPTION_VAL_8X_NL },
         { "16x", OPTION_VAL_16X_NL },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_NL,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_NL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_NL,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_NL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_NL,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_NL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_NL,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_NL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_NL,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_NL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_NL,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_NL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_NL,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_NL,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_NL,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_NL,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_NL,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_NL,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_NL,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_NL,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_NL,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_NL,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_NL,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_NL,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_NL,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_NL,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_NL },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_NL },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_NL,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_NL,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_NL },
         { "dot",   OPTION_VAL_DOT_NL },
         { "off",   OPTION_VAL_OFF_NL },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_NL,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_NL,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_NL },
         { "blue", OPTION_VAL_BLUE_NL },
         { "green", OPTION_VAL_GREEN_NL },
         { "orange", OPTION_VAL_ORANGE_NL },
         { "yellow", OPTION_VAL_YELLOW_NL },
         { "cyan", OPTION_VAL_CYAN_NL },
         { "pink", OPTION_VAL_PINK_NL },
         { "purple", OPTION_VAL_PURPLE_NL },
         { "black", OPTION_VAL_BLACK_NL },
         { "white", OPTION_VAL_WHITE_NL },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_NL,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_NL,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_NL },
         { "red", OPTION_VAL_RED_NL },
         { "green", OPTION_VAL_GREEN_NL },
         { "orange", OPTION_VAL_ORANGE_NL },
         { "yellow", OPTION_VAL_YELLOW_NL },
         { "cyan", OPTION_VAL_CYAN_NL },
         { "pink", OPTION_VAL_PINK_NL },
         { "purple", OPTION_VAL_PURPLE_NL },
         { "black", OPTION_VAL_BLACK_NL },
         { "white", OPTION_VAL_WHITE_NL },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_NL,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_NL,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_NL },
         { "10%",  OPTION_VAL_10_NL },
         { "15%",  OPTION_VAL_15_NL },
         { "20%",  OPTION_VAL_20_NL },
         { "25%",  OPTION_VAL_25_NL },
         { "30%",  OPTION_VAL_30_NL },
         { "35%",  OPTION_VAL_35_NL },
         { "40%",  OPTION_VAL_40_NL },
         { "45%",  OPTION_VAL_45_NL },
         { "50%",  OPTION_VAL_50_NL },
         { "55%",  OPTION_VAL_55_NL },
         { "60%",  OPTION_VAL_60_NL },
         { "65%",  OPTION_VAL_65_NL },
         { "70%",  OPTION_VAL_70_NL },
         { "75%",  OPTION_VAL_75_NL },
         { "80%",  OPTION_VAL_80_NL },
         { "85%",  OPTION_VAL_85_NL },
         { "90%",  OPTION_VAL_90_NL },
         { "95%",  OPTION_VAL_95_NL },
         { "100%", OPTION_VAL_100_NL },
         { "105%", OPTION_VAL_105_NL },
         { "110%", OPTION_VAL_110_NL },
         { "115%", OPTION_VAL_115_NL },
         { "120%", OPTION_VAL_120_NL },
         { "125%", OPTION_VAL_125_NL },
         { "130%", OPTION_VAL_130_NL },
         { "135%", OPTION_VAL_135_NL },
         { "140%", OPTION_VAL_140_NL },
         { "145%", OPTION_VAL_145_NL },
         { "150%", OPTION_VAL_150_NL },
         { "155%", OPTION_VAL_155_NL },
         { "160%", OPTION_VAL_160_NL },
         { "165%", OPTION_VAL_165_NL },
         { "170%", OPTION_VAL_170_NL },
         { "175%", OPTION_VAL_175_NL },
         { "180%", OPTION_VAL_180_NL },
         { "185%", OPTION_VAL_185_NL },
         { "190%", OPTION_VAL_190_NL },
         { "195%", OPTION_VAL_195_NL },
         { "200%", OPTION_VAL_200_NL },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_NL,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_NL,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_NL },
         { "quadratic", OPTION_VAL_QUADRATIC_NL },
         { "cubic",     OPTION_VAL_CUBIC_NL },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_NL,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_NL,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_NL },
         { "5%",  OPTION_VAL_5_NL },
         { "10%", OPTION_VAL_10_NL },
         { "15%", OPTION_VAL_15_NL },
         { "20%", OPTION_VAL_20_NL },
         { "25%", OPTION_VAL_25_NL },
         { "30%", OPTION_VAL_30_NL },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_NL,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_NL,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_NL },
         { "mednafen", OPTION_VAL_MEDNAFEN_NL },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_NL,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_NL,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_NL,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_NL,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_NL,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_NL,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_NL,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_NL,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_NL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_NL,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_NL,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_NL },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_NL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_NL,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_NL,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_NL },
         { "1px", OPTION_VAL_1PX_NL },
         { "2px", OPTION_VAL_2PX_NL },
         { "3px", OPTION_VAL_3PX_NL },
         { "4px", OPTION_VAL_4PX_NL },
         { "5px", OPTION_VAL_5PX_NL },
         { "6px", OPTION_VAL_6PX_NL },
         { "7px", OPTION_VAL_7PX_NL },
         { "8px", OPTION_VAL_8PX_NL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_NL,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_NL,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_NL,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_NL,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_NL,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_NL,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_NL,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_NL,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_NL },
         { "aggressive", OPTION_VAL_AGGRESSIVE_NL },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_NL,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_NL,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_NL,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_NL,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_NL },
         { "16:10", OPTION_VAL_16_10_NL },
         { "18:9",  OPTION_VAL_18_9_NL },
         { "19:9",  OPTION_VAL_19_9_NL },
         { "20:9",  OPTION_VAL_20_9_NL },
         { "21:9",  OPTION_VAL_21_9_NL }, // 64:27
         { "32:9",  OPTION_VAL_32_9_NL },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_NL,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_NL,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_NL },
         { "60%",           OPTION_VAL_60_NL },
         { "70%",           OPTION_VAL_70_NL },
         { "80%",           OPTION_VAL_80_NL },
         { "90%",           OPTION_VAL_90_NL },
         { "100%(native)", OPTION_VAL_100_NATIVE_NL },
         { "110%",          OPTION_VAL_110_NL },
         { "120%",          OPTION_VAL_120_NL },
         { "130%",          OPTION_VAL_130_NL },
         { "140%",          OPTION_VAL_140_NL },
         { "150%",          OPTION_VAL_150_NL },
         { "160%",          OPTION_VAL_160_NL },
         { "170%",          OPTION_VAL_170_NL },
         { "180%",          OPTION_VAL_180_NL },
         { "190%",          OPTION_VAL_190_NL },
         { "200%",          OPTION_VAL_200_NL },
         { "210%",          OPTION_VAL_210_NL },
         { "220%",          OPTION_VAL_220_NL },
         { "230%",          OPTION_VAL_230_NL },
         { "240%",          OPTION_VAL_240_NL },
         { "250%",          OPTION_VAL_250_NL },
         { "260%",          OPTION_VAL_260_NL },
         { "270%",          OPTION_VAL_270_NL },
         { "280%",          OPTION_VAL_280_NL },
         { "290%",          OPTION_VAL_290_NL },
         { "300%",          OPTION_VAL_300_NL },
         { "310%",          OPTION_VAL_310_NL },
         { "320%",          OPTION_VAL_320_NL },
         { "330%",          OPTION_VAL_330_NL },
         { "340%",          OPTION_VAL_340_NL },
         { "350%",          OPTION_VAL_350_NL },
         { "360%",          OPTION_VAL_360_NL },
         { "370%",          OPTION_VAL_370_NL },
         { "380%",          OPTION_VAL_380_NL },
         { "390%",          OPTION_VAL_390_NL },
         { "400%",          OPTION_VAL_400_NL },
         { "410%",          OPTION_VAL_410_NL },
         { "420%",          OPTION_VAL_420_NL },
         { "430%",          OPTION_VAL_430_NL },
         { "440%",          OPTION_VAL_440_NL },
         { "450%",          OPTION_VAL_450_NL },
         { "460%",          OPTION_VAL_460_NL },
         { "470%",          OPTION_VAL_470_NL },
         { "480%",          OPTION_VAL_480_NL },
         { "490%",          OPTION_VAL_490_NL },
         { "500%",          OPTION_VAL_500_NL },
         { "510%",          OPTION_VAL_510_NL },
         { "520%",          OPTION_VAL_520_NL },
         { "530%",          OPTION_VAL_530_NL },
         { "540%",          OPTION_VAL_540_NL },
         { "550%",          OPTION_VAL_550_NL },
         { "560%",          OPTION_VAL_560_NL },
         { "570%",          OPTION_VAL_570_NL },
         { "580%",          OPTION_VAL_580_NL },
         { "590%",          OPTION_VAL_590_NL },
         { "600%",          OPTION_VAL_600_NL },
         { "610%",          OPTION_VAL_610_NL },
         { "620%",          OPTION_VAL_620_NL },
         { "630%",          OPTION_VAL_630_NL },
         { "640%",          OPTION_VAL_640_NL },
         { "650%",          OPTION_VAL_650_NL },
         { "660%",          OPTION_VAL_660_NL },
         { "670%",          OPTION_VAL_670_NL },
         { "680%",          OPTION_VAL_680_NL },
         { "690%",          OPTION_VAL_690_NL },
         { "700%",          OPTION_VAL_700_NL },
         { "710%",          OPTION_VAL_710_NL },
         { "720%",          OPTION_VAL_720_NL },
         { "730%",          OPTION_VAL_730_NL },
         { "740%",          OPTION_VAL_740_NL },
         { "750%",          OPTION_VAL_750_NL },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_NL,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_NL,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_NL,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_NL,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_NL,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_NL,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_NL },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_NL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_NL,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_NL,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_NL },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_NL },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_NL },
#endif
         { "software",    OPTION_VAL_SOFTWARE_NL },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_NL,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_NL,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_NL,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_NL,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_NL },
         { "execute",  OPTION_VAL_EXECUTE_NL },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_NL },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_NL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_NL,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_NL,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_NL },
         { "dma",  OPTION_VAL_DMA_NL },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_NL,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_NL,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_NL,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_NL,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_NL },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_NL },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_NL },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_NL,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_NL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_NL,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_NL,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_NL },
         { "static",  OPTION_VAL_STATIC_NL },
         { "smart", OPTION_VAL_SMART_NL },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_NL,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_NL,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_NL },
         { "2px",      OPTION_VAL_2PX_NL },
         { "3px",      OPTION_VAL_3PX_NL },
         { "4px",      OPTION_VAL_4PX_NL },
         { "5px",      OPTION_VAL_5PX_NL },
         { "6px",      OPTION_VAL_6PX_NL },
         { "7px",      OPTION_VAL_7PX_NL },
         { "8px",      OPTION_VAL_8PX_NL },
         { "9px",      OPTION_VAL_9PX_NL },
         { "10px",     OPTION_VAL_10PX_NL },
         { "11px",     OPTION_VAL_11PX_NL },
         { "12px",     OPTION_VAL_12PX_NL },
         { "13px",     OPTION_VAL_13PX_NL },
         { "14px",     OPTION_VAL_14PX_NL },
         { "15px",     OPTION_VAL_15PX_NL },
         { "16px",     OPTION_VAL_16PX_NL },
         { "17px",     OPTION_VAL_17PX_NL },
         { "18px",     OPTION_VAL_18PX_NL },
         { "19px",     OPTION_VAL_19PX_NL },
         { "20px",     OPTION_VAL_20PX_NL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_NL,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_NL,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_NL },
         { "-11px",    OPTION_VAL_11PX_O55_NL },
         { "-10px",    OPTION_VAL_10PX_O55_NL },
         { "-9px",     OPTION_VAL_9PX_O55_NL },
         { "-8px",     OPTION_VAL_8PX_O55_NL },
         { "-7px",     OPTION_VAL_7PX_O55_NL },
         { "-6px",     OPTION_VAL_6PX_O55_NL },
         { "-5px",     OPTION_VAL_5PX_O55_NL },
         { "-4px",     OPTION_VAL_4PX_O55_NL },
         { "-3px",     OPTION_VAL_3PX_O55_NL },
         { "-2px",     OPTION_VAL_2PX_O55_NL },
         { "-1px",     OPTION_VAL_1PX_O55_NL },
         { "disabled", OPTION_VAL_DISABLED_O55_NL },
         { "+1px",     OPTION_VAL_1PX_O55_0_NL },
         { "+2px",     OPTION_VAL_2PX_O55_0_NL },
         { "+3px",     OPTION_VAL_3PX_O55_0_NL },
         { "+4px",     OPTION_VAL_4PX_O55_0_NL },
         { "+5px",     OPTION_VAL_5PX_O55_0_NL },
         { "+6px",     OPTION_VAL_6PX_O55_0_NL },
         { "+7px",     OPTION_VAL_7PX_O55_0_NL },
         { "+8px",     OPTION_VAL_8PX_O55_0_NL },
         { "+9px",     OPTION_VAL_9PX_O55_0_NL },
         { "+10px",    OPTION_VAL_10PX_O55_0_NL },
         { "+11px",    OPTION_VAL_11PX_O55_0_NL },
         { "+12px",    OPTION_VAL_12PX_O55_0_NL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_NL,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_NL,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_NL },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_NL,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_NL,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_NL },
         { "2x",         OPTION_VAL_2X_NL },
         { "4x",         OPTION_VAL_4X_NL },
         { "8x",         OPTION_VAL_8X_NL },
         { "16x",        OPTION_VAL_16X_NL },
         { "32x",        OPTION_VAL_32X_NL },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_NL,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_NL,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_NL },
         { "uncorrected", OPTION_VAL_UNCORRECTED_NL },
         { "4:3",  OPTION_VAL_4_3_NL },
         { "ntsc", OPTION_VAL_NTSC_NL },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_NL,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_NL,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_NL,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_NL,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_NL },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_NL,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_NL,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_NL,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_NL,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_NL },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_NL,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_NL,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_NL },
         { "async",    OPTION_VAL_ASYNC_NL },
         { "precache", OPTION_VAL_PRECACHE_NL },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_NL,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_NL,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_NL },
         { "4x",          OPTION_VAL_4X_NL },
         { "6x",          OPTION_VAL_6X_NL },
         { "8x",          OPTION_VAL_8X_NL },
         { "10x",         OPTION_VAL_10X_NL },
         { "12x",         OPTION_VAL_12X_NL },
         { "14x",         OPTION_VAL_14X_NL },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_nl = {
   option_cats_nl,
   option_defs_nl
};

/* RETRO_LANGUAGE_NO */

#define CATEGORY_VIDEO_LABEL_NO NULL
#define CATEGORY_VIDEO_INFO_0_NO NULL
#define CATEGORY_OSD_LABEL_NO NULL
#define CATEGORY_OSD_INFO_0_NO NULL
#define CATEGORY_INPUT_LABEL_NO "Inndata"
#define CATEGORY_INPUT_INFO_0_NO NULL
#define CATEGORY_MEMCARDS_LABEL_NO NULL
#define CATEGORY_MEMCARDS_INFO_0_NO NULL
#define CATEGORY_PGXP_LABEL_NO NULL
#define CATEGORY_PGXP_INFO_0_NO NULL
#define CATEGORY_HACKS_LABEL_NO NULL
#define CATEGORY_HACKS_INFO_0_NO NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_NO NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_NO NULL
#define OPTION_VAL_1X_NATIVE_NO NULL
#define OPTION_VAL_2X_NO NULL
#define OPTION_VAL_4X_NO NULL
#define OPTION_VAL_8X_NO NULL
#define OPTION_VAL_16X_NO NULL
#define BEETLE_OPT_DEPTH_LABEL_NO NULL
#define BEETLE_OPT_DEPTH_INFO_0_NO NULL
#define OPTION_VAL_16BPP_NATIVE_NO NULL
#define OPTION_VAL_32BPP_NO NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_NO NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_NO NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_NO "Intern oppløsning"
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_NO NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_NO NULL
#define BEETLE_OPT_FILTER_LABEL_NO NULL
#define BEETLE_OPT_FILTER_INFO_0_NO NULL
#define OPTION_VAL_NEAREST_NO NULL
#define OPTION_VAL_SABR_NO NULL
#define OPTION_VAL_XBR_NO NULL
#define OPTION_VAL_BILINEAR_NO "Bilineær"
#define OPTION_VAL_3_POINT_NO NULL
#define OPTION_VAL_JINC2_NO NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_NO NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_NO NULL
#define OPTION_VAL_OPAQUE_NO NULL
#define OPTION_VAL_ALL_NO NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_NO NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_NO NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_NO NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_NO NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_NO NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_NO NULL
#define BEETLE_OPT_MSAA_LABEL_NO NULL
#define BEETLE_OPT_MSAA_INFO_0_NO NULL
#define OPTION_VAL_1X_NO NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_NO NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_NO NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_NO NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_NO NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_NO NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_NO NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_NO NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_NO NULL
#define BEETLE_OPT_WIREFRAME_LABEL_NO NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_NO NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_NO NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_NO NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_NO NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_NO NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_NO NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_NO NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_NO NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_NO NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_NO NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_NO NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_NO NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_NO NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_NO NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_NO NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_NO NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_NO NULL
#define OPTION_VAL_LIGHTGUN_NO NULL
#define OPTION_VAL_TOUCHSCREEN_NO NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_NO NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_NO NULL
#define OPTION_VAL_CROSS_NO NULL
#define OPTION_VAL_DOT_NO NULL
#define OPTION_VAL_OFF_NO NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_NO NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_NO NULL
#define OPTION_VAL_RED_NO NULL
#define OPTION_VAL_BLUE_NO NULL
#define OPTION_VAL_GREEN_NO NULL
#define OPTION_VAL_ORANGE_NO NULL
#define OPTION_VAL_YELLOW_NO NULL
#define OPTION_VAL_CYAN_NO NULL
#define OPTION_VAL_PINK_NO NULL
#define OPTION_VAL_PURPLE_NO NULL
#define OPTION_VAL_BLACK_NO NULL
#define OPTION_VAL_WHITE_NO NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_NO NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_NO NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_NO NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_NO NULL
#define OPTION_VAL_5_NO NULL
#define OPTION_VAL_10_NO NULL
#define OPTION_VAL_15_NO NULL
#define OPTION_VAL_20_NO NULL
#define OPTION_VAL_25_NO NULL
#define OPTION_VAL_30_NO NULL
#define OPTION_VAL_35_NO NULL
#define OPTION_VAL_40_NO NULL
#define OPTION_VAL_45_NO NULL
#define OPTION_VAL_50_NO NULL
#define OPTION_VAL_55_NO NULL
#define OPTION_VAL_60_NO NULL
#define OPTION_VAL_65_NO NULL
#define OPTION_VAL_70_NO NULL
#define OPTION_VAL_75_NO NULL
#define OPTION_VAL_80_NO NULL
#define OPTION_VAL_85_NO NULL
#define OPTION_VAL_90_NO NULL
#define OPTION_VAL_95_NO NULL
#define OPTION_VAL_100_NO NULL
#define OPTION_VAL_105_NO NULL
#define OPTION_VAL_110_NO NULL
#define OPTION_VAL_115_NO NULL
#define OPTION_VAL_120_NO NULL
#define OPTION_VAL_125_NO NULL
#define OPTION_VAL_130_NO NULL
#define OPTION_VAL_135_NO NULL
#define OPTION_VAL_140_NO NULL
#define OPTION_VAL_145_NO NULL
#define OPTION_VAL_150_NO NULL
#define OPTION_VAL_155_NO NULL
#define OPTION_VAL_160_NO NULL
#define OPTION_VAL_165_NO NULL
#define OPTION_VAL_170_NO NULL
#define OPTION_VAL_175_NO NULL
#define OPTION_VAL_180_NO NULL
#define OPTION_VAL_185_NO NULL
#define OPTION_VAL_190_NO NULL
#define OPTION_VAL_195_NO NULL
#define OPTION_VAL_200_NO NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_NO NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_NO NULL
#define OPTION_VAL_LINEAR_NO NULL
#define OPTION_VAL_QUADRATIC_NO NULL
#define OPTION_VAL_CUBIC_NO NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_NO NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_NO NULL
#define OPTION_VAL_0_NO NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_NO NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_NO NULL
#define OPTION_VAL_LIBRETRO_NO NULL
#define OPTION_VAL_MEDNAFEN_NO NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_NO NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_NO NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_NO NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_NO NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_NO NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_NO NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_NO NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_NO NULL
#define OPTION_VAL_1_NO NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_NO NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_NO NULL
#define OPTION_VAL_MEMORY_ONLY_NO NULL
#define OPTION_VAL_MEMORY_CPU_NO NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_NO NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_NO NULL
#define OPTION_VAL_0PX_NO NULL
#define OPTION_VAL_1PX_NO NULL
#define OPTION_VAL_2PX_NO NULL
#define OPTION_VAL_3PX_NO NULL
#define OPTION_VAL_4PX_NO NULL
#define OPTION_VAL_5PX_NO NULL
#define OPTION_VAL_6PX_NO NULL
#define OPTION_VAL_7PX_NO NULL
#define OPTION_VAL_8PX_NO NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_NO NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_NO NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_NO NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_NO NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_NO NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_NO NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_NO NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_NO NULL
#define OPTION_VAL_DEFAULT_NO NULL
#define OPTION_VAL_AGGRESSIVE_NO NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_NO NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_NO NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_NO NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_NO NULL
#define OPTION_VAL_16_9_NO NULL
#define OPTION_VAL_16_10_NO NULL
#define OPTION_VAL_18_9_NO NULL
#define OPTION_VAL_19_9_NO NULL
#define OPTION_VAL_20_9_NO NULL
#define OPTION_VAL_21_9_NO NULL
#define OPTION_VAL_32_9_NO NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_NO NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_NO NULL
#define OPTION_VAL_100_NATIVE_NO NULL
#define OPTION_VAL_210_NO NULL
#define OPTION_VAL_220_NO NULL
#define OPTION_VAL_230_NO NULL
#define OPTION_VAL_240_NO NULL
#define OPTION_VAL_250_NO NULL
#define OPTION_VAL_260_NO NULL
#define OPTION_VAL_270_NO NULL
#define OPTION_VAL_280_NO NULL
#define OPTION_VAL_290_NO NULL
#define OPTION_VAL_300_NO NULL
#define OPTION_VAL_310_NO NULL
#define OPTION_VAL_320_NO NULL
#define OPTION_VAL_330_NO NULL
#define OPTION_VAL_340_NO NULL
#define OPTION_VAL_350_NO NULL
#define OPTION_VAL_360_NO NULL
#define OPTION_VAL_370_NO NULL
#define OPTION_VAL_380_NO NULL
#define OPTION_VAL_390_NO NULL
#define OPTION_VAL_400_NO NULL
#define OPTION_VAL_410_NO NULL
#define OPTION_VAL_420_NO NULL
#define OPTION_VAL_430_NO NULL
#define OPTION_VAL_440_NO NULL
#define OPTION_VAL_450_NO NULL
#define OPTION_VAL_460_NO NULL
#define OPTION_VAL_470_NO NULL
#define OPTION_VAL_480_NO NULL
#define OPTION_VAL_490_NO NULL
#define OPTION_VAL_500_NO NULL
#define OPTION_VAL_510_NO NULL
#define OPTION_VAL_520_NO NULL
#define OPTION_VAL_530_NO NULL
#define OPTION_VAL_540_NO NULL
#define OPTION_VAL_550_NO NULL
#define OPTION_VAL_560_NO NULL
#define OPTION_VAL_570_NO NULL
#define OPTION_VAL_580_NO NULL
#define OPTION_VAL_590_NO NULL
#define OPTION_VAL_600_NO NULL
#define OPTION_VAL_610_NO NULL
#define OPTION_VAL_620_NO NULL
#define OPTION_VAL_630_NO NULL
#define OPTION_VAL_640_NO NULL
#define OPTION_VAL_650_NO NULL
#define OPTION_VAL_660_NO NULL
#define OPTION_VAL_670_NO NULL
#define OPTION_VAL_680_NO NULL
#define OPTION_VAL_690_NO NULL
#define OPTION_VAL_700_NO NULL
#define OPTION_VAL_710_NO NULL
#define OPTION_VAL_720_NO NULL
#define OPTION_VAL_730_NO NULL
#define OPTION_VAL_740_NO NULL
#define OPTION_VAL_750_NO NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_NO NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_NO NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_NO NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_NO NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_NO NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_NO NULL
#define OPTION_VAL_PSXONPSP_NO NULL
#define OPTION_VAL_PS1_ROM_NO NULL
#define BEETLE_OPT_RENDERER_LABEL_NO NULL
#define BEETLE_OPT_RENDERER_INFO_0_NO NULL
#define OPTION_VAL_HARDWARE_NO NULL
#define OPTION_VAL_HARDWARE_GL_NO NULL
#define OPTION_VAL_HARDWARE_VK_NO NULL
#define OPTION_VAL_SOFTWARE_NO NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_NO NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_NO NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_NO NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_NO NULL
#define OPTION_VAL_DISABLED_NO NULL
#define OPTION_VAL_EXECUTE_NO NULL
#define OPTION_VAL_EXECUTE_ONE_NO NULL
#define OPTION_VAL_RUN_INTERPRETER_NO NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_NO NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_NO NULL
#define OPTION_VAL_FULL_NO NULL
#define OPTION_VAL_DMA_NO NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_NO NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_NO NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_NO NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_NO NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_NO NULL
#define OPTION_VAL_FORCE_INTERLACED_NO NULL
#define OPTION_VAL_AUTO_TOGGLE_NO NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_NO NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_NO NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_NO NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_NO NULL
#define OPTION_VAL_DISABLED_O53_NO NULL
#define OPTION_VAL_STATIC_NO NULL
#define OPTION_VAL_SMART_NO NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_NO NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_NO NULL
#define OPTION_VAL_9PX_NO NULL
#define OPTION_VAL_10PX_NO NULL
#define OPTION_VAL_11PX_NO NULL
#define OPTION_VAL_12PX_NO NULL
#define OPTION_VAL_13PX_NO NULL
#define OPTION_VAL_14PX_NO NULL
#define OPTION_VAL_15PX_NO NULL
#define OPTION_VAL_16PX_NO NULL
#define OPTION_VAL_17PX_NO NULL
#define OPTION_VAL_18PX_NO NULL
#define OPTION_VAL_19PX_NO NULL
#define OPTION_VAL_20PX_NO NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_NO NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_NO NULL
#define OPTION_VAL_12PX_O55_NO NULL
#define OPTION_VAL_11PX_O55_NO NULL
#define OPTION_VAL_10PX_O55_NO NULL
#define OPTION_VAL_9PX_O55_NO NULL
#define OPTION_VAL_8PX_O55_NO NULL
#define OPTION_VAL_7PX_O55_NO NULL
#define OPTION_VAL_6PX_O55_NO NULL
#define OPTION_VAL_5PX_O55_NO NULL
#define OPTION_VAL_4PX_O55_NO NULL
#define OPTION_VAL_3PX_O55_NO NULL
#define OPTION_VAL_2PX_O55_NO NULL
#define OPTION_VAL_1PX_O55_NO NULL
#define OPTION_VAL_DISABLED_O55_NO NULL
#define OPTION_VAL_1PX_O55_0_NO NULL
#define OPTION_VAL_2PX_O55_0_NO NULL
#define OPTION_VAL_3PX_O55_0_NO NULL
#define OPTION_VAL_4PX_O55_0_NO NULL
#define OPTION_VAL_5PX_O55_0_NO NULL
#define OPTION_VAL_6PX_O55_0_NO NULL
#define OPTION_VAL_7PX_O55_0_NO NULL
#define OPTION_VAL_8PX_O55_0_NO NULL
#define OPTION_VAL_9PX_O55_0_NO NULL
#define OPTION_VAL_10PX_O55_0_NO NULL
#define OPTION_VAL_11PX_O55_0_NO NULL
#define OPTION_VAL_12PX_O55_0_NO NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_NO NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_NO NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_NO NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_NO NULL
#define OPTION_VAL_32X_NO NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_NO NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_NO NULL
#define OPTION_VAL_CORRECTED_NO NULL
#define OPTION_VAL_UNCORRECTED_NO NULL
#define OPTION_VAL_4_3_NO NULL
#define OPTION_VAL_NTSC_NO NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_NO NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_NO NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_NO NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_NO NULL
#define OPTION_VAL_239_NO NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_NO NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_NO NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_NO NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_NO NULL
#define OPTION_VAL_287_NO NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_NO NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_NO NULL
#define OPTION_VAL_SYNC_NO NULL
#define OPTION_VAL_ASYNC_NO NULL
#define OPTION_VAL_PRECACHE_NO NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_NO NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_NO NULL
#define OPTION_VAL_2X_NATIVE_NO NULL
#define OPTION_VAL_6X_NO NULL
#define OPTION_VAL_10X_NO NULL
#define OPTION_VAL_12X_NO NULL
#define OPTION_VAL_14X_NO NULL

struct retro_core_option_v2_category option_cats_no[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_NO,
      CATEGORY_VIDEO_INFO_0_NO
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_NO,
      CATEGORY_OSD_INFO_0_NO
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_NO,
      CATEGORY_INPUT_INFO_0_NO
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_NO,
      CATEGORY_MEMCARDS_INFO_0_NO
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_NO,
      CATEGORY_PGXP_INFO_0_NO
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_NO,
      CATEGORY_HACKS_INFO_0_NO
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_no[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_NO,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_NO,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_NO },
         { "2x",         OPTION_VAL_2X_NO },
         { "4x",         OPTION_VAL_4X_NO },
         { "8x",         OPTION_VAL_8X_NO },
         { "16x",        OPTION_VAL_16X_NO },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_NO,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_NO,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_NO },
         { "32bpp",         OPTION_VAL_32BPP_NO },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_NO,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_NO,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_NO },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_NO },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_NO,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_NO,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_NO,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_NO,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_NO },
         { "SABR",     OPTION_VAL_SABR_NO },
         { "xBR",      OPTION_VAL_XBR_NO },
         { "bilinear", OPTION_VAL_BILINEAR_NO },
         { "3-point",  OPTION_VAL_3_POINT_NO },
         { "JINC2",    OPTION_VAL_JINC2_NO },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_NO,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_NO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_NO },
         { "all", OPTION_VAL_ALL_NO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_NO,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_NO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_NO },
         { "all", OPTION_VAL_ALL_NO },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_NO,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_NO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_NO,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_NO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_NO,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_NO,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_NO },
         { "2x",  OPTION_VAL_2X_NO },
         { "4x",  OPTION_VAL_4X_NO },
         { "8x",  OPTION_VAL_8X_NO },
         { "16x", OPTION_VAL_16X_NO },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_NO,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_NO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_NO,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_NO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_NO,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_NO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_NO,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_NO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_NO,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_NO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_NO,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_NO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_NO,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_NO,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_NO,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_NO,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_NO,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_NO,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_NO,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_NO,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_NO,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_NO,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_NO,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_NO,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_NO,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_NO,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_NO },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_NO },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_NO,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_NO,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_NO },
         { "dot",   OPTION_VAL_DOT_NO },
         { "off",   OPTION_VAL_OFF_NO },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_NO,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_NO,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_NO },
         { "blue", OPTION_VAL_BLUE_NO },
         { "green", OPTION_VAL_GREEN_NO },
         { "orange", OPTION_VAL_ORANGE_NO },
         { "yellow", OPTION_VAL_YELLOW_NO },
         { "cyan", OPTION_VAL_CYAN_NO },
         { "pink", OPTION_VAL_PINK_NO },
         { "purple", OPTION_VAL_PURPLE_NO },
         { "black", OPTION_VAL_BLACK_NO },
         { "white", OPTION_VAL_WHITE_NO },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_NO,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_NO,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_NO },
         { "red", OPTION_VAL_RED_NO },
         { "green", OPTION_VAL_GREEN_NO },
         { "orange", OPTION_VAL_ORANGE_NO },
         { "yellow", OPTION_VAL_YELLOW_NO },
         { "cyan", OPTION_VAL_CYAN_NO },
         { "pink", OPTION_VAL_PINK_NO },
         { "purple", OPTION_VAL_PURPLE_NO },
         { "black", OPTION_VAL_BLACK_NO },
         { "white", OPTION_VAL_WHITE_NO },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_NO,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_NO,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_NO },
         { "10%",  OPTION_VAL_10_NO },
         { "15%",  OPTION_VAL_15_NO },
         { "20%",  OPTION_VAL_20_NO },
         { "25%",  OPTION_VAL_25_NO },
         { "30%",  OPTION_VAL_30_NO },
         { "35%",  OPTION_VAL_35_NO },
         { "40%",  OPTION_VAL_40_NO },
         { "45%",  OPTION_VAL_45_NO },
         { "50%",  OPTION_VAL_50_NO },
         { "55%",  OPTION_VAL_55_NO },
         { "60%",  OPTION_VAL_60_NO },
         { "65%",  OPTION_VAL_65_NO },
         { "70%",  OPTION_VAL_70_NO },
         { "75%",  OPTION_VAL_75_NO },
         { "80%",  OPTION_VAL_80_NO },
         { "85%",  OPTION_VAL_85_NO },
         { "90%",  OPTION_VAL_90_NO },
         { "95%",  OPTION_VAL_95_NO },
         { "100%", OPTION_VAL_100_NO },
         { "105%", OPTION_VAL_105_NO },
         { "110%", OPTION_VAL_110_NO },
         { "115%", OPTION_VAL_115_NO },
         { "120%", OPTION_VAL_120_NO },
         { "125%", OPTION_VAL_125_NO },
         { "130%", OPTION_VAL_130_NO },
         { "135%", OPTION_VAL_135_NO },
         { "140%", OPTION_VAL_140_NO },
         { "145%", OPTION_VAL_145_NO },
         { "150%", OPTION_VAL_150_NO },
         { "155%", OPTION_VAL_155_NO },
         { "160%", OPTION_VAL_160_NO },
         { "165%", OPTION_VAL_165_NO },
         { "170%", OPTION_VAL_170_NO },
         { "175%", OPTION_VAL_175_NO },
         { "180%", OPTION_VAL_180_NO },
         { "185%", OPTION_VAL_185_NO },
         { "190%", OPTION_VAL_190_NO },
         { "195%", OPTION_VAL_195_NO },
         { "200%", OPTION_VAL_200_NO },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_NO,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_NO,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_NO },
         { "quadratic", OPTION_VAL_QUADRATIC_NO },
         { "cubic",     OPTION_VAL_CUBIC_NO },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_NO,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_NO,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_NO },
         { "5%",  OPTION_VAL_5_NO },
         { "10%", OPTION_VAL_10_NO },
         { "15%", OPTION_VAL_15_NO },
         { "20%", OPTION_VAL_20_NO },
         { "25%", OPTION_VAL_25_NO },
         { "30%", OPTION_VAL_30_NO },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_NO,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_NO,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_NO },
         { "mednafen", OPTION_VAL_MEDNAFEN_NO },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_NO,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_NO,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_NO,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_NO,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_NO,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_NO,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_NO,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_NO,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_NO },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_NO,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_NO,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_NO },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_NO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_NO,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_NO,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_NO },
         { "1px", OPTION_VAL_1PX_NO },
         { "2px", OPTION_VAL_2PX_NO },
         { "3px", OPTION_VAL_3PX_NO },
         { "4px", OPTION_VAL_4PX_NO },
         { "5px", OPTION_VAL_5PX_NO },
         { "6px", OPTION_VAL_6PX_NO },
         { "7px", OPTION_VAL_7PX_NO },
         { "8px", OPTION_VAL_8PX_NO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_NO,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_NO,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_NO,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_NO,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_NO,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_NO,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_NO,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_NO,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_NO },
         { "aggressive", OPTION_VAL_AGGRESSIVE_NO },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_NO,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_NO,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_NO,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_NO,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_NO },
         { "16:10", OPTION_VAL_16_10_NO },
         { "18:9",  OPTION_VAL_18_9_NO },
         { "19:9",  OPTION_VAL_19_9_NO },
         { "20:9",  OPTION_VAL_20_9_NO },
         { "21:9",  OPTION_VAL_21_9_NO }, // 64:27
         { "32:9",  OPTION_VAL_32_9_NO },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_NO,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_NO,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_NO },
         { "60%",           OPTION_VAL_60_NO },
         { "70%",           OPTION_VAL_70_NO },
         { "80%",           OPTION_VAL_80_NO },
         { "90%",           OPTION_VAL_90_NO },
         { "100%(native)", OPTION_VAL_100_NATIVE_NO },
         { "110%",          OPTION_VAL_110_NO },
         { "120%",          OPTION_VAL_120_NO },
         { "130%",          OPTION_VAL_130_NO },
         { "140%",          OPTION_VAL_140_NO },
         { "150%",          OPTION_VAL_150_NO },
         { "160%",          OPTION_VAL_160_NO },
         { "170%",          OPTION_VAL_170_NO },
         { "180%",          OPTION_VAL_180_NO },
         { "190%",          OPTION_VAL_190_NO },
         { "200%",          OPTION_VAL_200_NO },
         { "210%",          OPTION_VAL_210_NO },
         { "220%",          OPTION_VAL_220_NO },
         { "230%",          OPTION_VAL_230_NO },
         { "240%",          OPTION_VAL_240_NO },
         { "250%",          OPTION_VAL_250_NO },
         { "260%",          OPTION_VAL_260_NO },
         { "270%",          OPTION_VAL_270_NO },
         { "280%",          OPTION_VAL_280_NO },
         { "290%",          OPTION_VAL_290_NO },
         { "300%",          OPTION_VAL_300_NO },
         { "310%",          OPTION_VAL_310_NO },
         { "320%",          OPTION_VAL_320_NO },
         { "330%",          OPTION_VAL_330_NO },
         { "340%",          OPTION_VAL_340_NO },
         { "350%",          OPTION_VAL_350_NO },
         { "360%",          OPTION_VAL_360_NO },
         { "370%",          OPTION_VAL_370_NO },
         { "380%",          OPTION_VAL_380_NO },
         { "390%",          OPTION_VAL_390_NO },
         { "400%",          OPTION_VAL_400_NO },
         { "410%",          OPTION_VAL_410_NO },
         { "420%",          OPTION_VAL_420_NO },
         { "430%",          OPTION_VAL_430_NO },
         { "440%",          OPTION_VAL_440_NO },
         { "450%",          OPTION_VAL_450_NO },
         { "460%",          OPTION_VAL_460_NO },
         { "470%",          OPTION_VAL_470_NO },
         { "480%",          OPTION_VAL_480_NO },
         { "490%",          OPTION_VAL_490_NO },
         { "500%",          OPTION_VAL_500_NO },
         { "510%",          OPTION_VAL_510_NO },
         { "520%",          OPTION_VAL_520_NO },
         { "530%",          OPTION_VAL_530_NO },
         { "540%",          OPTION_VAL_540_NO },
         { "550%",          OPTION_VAL_550_NO },
         { "560%",          OPTION_VAL_560_NO },
         { "570%",          OPTION_VAL_570_NO },
         { "580%",          OPTION_VAL_580_NO },
         { "590%",          OPTION_VAL_590_NO },
         { "600%",          OPTION_VAL_600_NO },
         { "610%",          OPTION_VAL_610_NO },
         { "620%",          OPTION_VAL_620_NO },
         { "630%",          OPTION_VAL_630_NO },
         { "640%",          OPTION_VAL_640_NO },
         { "650%",          OPTION_VAL_650_NO },
         { "660%",          OPTION_VAL_660_NO },
         { "670%",          OPTION_VAL_670_NO },
         { "680%",          OPTION_VAL_680_NO },
         { "690%",          OPTION_VAL_690_NO },
         { "700%",          OPTION_VAL_700_NO },
         { "710%",          OPTION_VAL_710_NO },
         { "720%",          OPTION_VAL_720_NO },
         { "730%",          OPTION_VAL_730_NO },
         { "740%",          OPTION_VAL_740_NO },
         { "750%",          OPTION_VAL_750_NO },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_NO,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_NO,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_NO,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_NO,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_NO,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_NO,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_NO },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_NO },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_NO,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_NO,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_NO },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_NO },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_NO },
#endif
         { "software",    OPTION_VAL_SOFTWARE_NO },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_NO,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_NO,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_NO,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_NO,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_NO },
         { "execute",  OPTION_VAL_EXECUTE_NO },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_NO },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_NO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_NO,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_NO,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_NO },
         { "dma",  OPTION_VAL_DMA_NO },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_NO,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_NO,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_NO,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_NO,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_NO },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_NO },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_NO },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_NO,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_NO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_NO,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_NO,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_NO },
         { "static",  OPTION_VAL_STATIC_NO },
         { "smart", OPTION_VAL_SMART_NO },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_NO,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_NO,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_NO },
         { "2px",      OPTION_VAL_2PX_NO },
         { "3px",      OPTION_VAL_3PX_NO },
         { "4px",      OPTION_VAL_4PX_NO },
         { "5px",      OPTION_VAL_5PX_NO },
         { "6px",      OPTION_VAL_6PX_NO },
         { "7px",      OPTION_VAL_7PX_NO },
         { "8px",      OPTION_VAL_8PX_NO },
         { "9px",      OPTION_VAL_9PX_NO },
         { "10px",     OPTION_VAL_10PX_NO },
         { "11px",     OPTION_VAL_11PX_NO },
         { "12px",     OPTION_VAL_12PX_NO },
         { "13px",     OPTION_VAL_13PX_NO },
         { "14px",     OPTION_VAL_14PX_NO },
         { "15px",     OPTION_VAL_15PX_NO },
         { "16px",     OPTION_VAL_16PX_NO },
         { "17px",     OPTION_VAL_17PX_NO },
         { "18px",     OPTION_VAL_18PX_NO },
         { "19px",     OPTION_VAL_19PX_NO },
         { "20px",     OPTION_VAL_20PX_NO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_NO,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_NO,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_NO },
         { "-11px",    OPTION_VAL_11PX_O55_NO },
         { "-10px",    OPTION_VAL_10PX_O55_NO },
         { "-9px",     OPTION_VAL_9PX_O55_NO },
         { "-8px",     OPTION_VAL_8PX_O55_NO },
         { "-7px",     OPTION_VAL_7PX_O55_NO },
         { "-6px",     OPTION_VAL_6PX_O55_NO },
         { "-5px",     OPTION_VAL_5PX_O55_NO },
         { "-4px",     OPTION_VAL_4PX_O55_NO },
         { "-3px",     OPTION_VAL_3PX_O55_NO },
         { "-2px",     OPTION_VAL_2PX_O55_NO },
         { "-1px",     OPTION_VAL_1PX_O55_NO },
         { "disabled", OPTION_VAL_DISABLED_O55_NO },
         { "+1px",     OPTION_VAL_1PX_O55_0_NO },
         { "+2px",     OPTION_VAL_2PX_O55_0_NO },
         { "+3px",     OPTION_VAL_3PX_O55_0_NO },
         { "+4px",     OPTION_VAL_4PX_O55_0_NO },
         { "+5px",     OPTION_VAL_5PX_O55_0_NO },
         { "+6px",     OPTION_VAL_6PX_O55_0_NO },
         { "+7px",     OPTION_VAL_7PX_O55_0_NO },
         { "+8px",     OPTION_VAL_8PX_O55_0_NO },
         { "+9px",     OPTION_VAL_9PX_O55_0_NO },
         { "+10px",    OPTION_VAL_10PX_O55_0_NO },
         { "+11px",    OPTION_VAL_11PX_O55_0_NO },
         { "+12px",    OPTION_VAL_12PX_O55_0_NO },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_NO,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_NO,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_NO },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_NO,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_NO,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_NO },
         { "2x",         OPTION_VAL_2X_NO },
         { "4x",         OPTION_VAL_4X_NO },
         { "8x",         OPTION_VAL_8X_NO },
         { "16x",        OPTION_VAL_16X_NO },
         { "32x",        OPTION_VAL_32X_NO },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_NO,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_NO,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_NO },
         { "uncorrected", OPTION_VAL_UNCORRECTED_NO },
         { "4:3",  OPTION_VAL_4_3_NO },
         { "ntsc", OPTION_VAL_NTSC_NO },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_NO,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_NO,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_NO,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_NO,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_NO },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_NO,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_NO,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_NO,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_NO,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_NO },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_NO,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_NO,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_NO },
         { "async",    OPTION_VAL_ASYNC_NO },
         { "precache", OPTION_VAL_PRECACHE_NO },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_NO,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_NO,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_NO },
         { "4x",          OPTION_VAL_4X_NO },
         { "6x",          OPTION_VAL_6X_NO },
         { "8x",          OPTION_VAL_8X_NO },
         { "10x",         OPTION_VAL_10X_NO },
         { "12x",         OPTION_VAL_12X_NO },
         { "14x",         OPTION_VAL_14X_NO },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_no = {
   option_cats_no,
   option_defs_no
};

/* RETRO_LANGUAGE_OC */

#define CATEGORY_VIDEO_LABEL_OC "Vidèo"
#define CATEGORY_VIDEO_INFO_0_OC NULL
#define CATEGORY_OSD_LABEL_OC NULL
#define CATEGORY_OSD_INFO_0_OC NULL
#define CATEGORY_INPUT_LABEL_OC NULL
#define CATEGORY_INPUT_INFO_0_OC NULL
#define CATEGORY_MEMCARDS_LABEL_OC NULL
#define CATEGORY_MEMCARDS_INFO_0_OC NULL
#define CATEGORY_PGXP_LABEL_OC NULL
#define CATEGORY_PGXP_INFO_0_OC NULL
#define CATEGORY_HACKS_LABEL_OC NULL
#define CATEGORY_HACKS_INFO_0_OC NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_OC NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_OC NULL
#define OPTION_VAL_1X_NATIVE_OC NULL
#define OPTION_VAL_2X_OC NULL
#define OPTION_VAL_4X_OC NULL
#define OPTION_VAL_8X_OC NULL
#define OPTION_VAL_16X_OC NULL
#define BEETLE_OPT_DEPTH_LABEL_OC NULL
#define BEETLE_OPT_DEPTH_INFO_0_OC NULL
#define OPTION_VAL_16BPP_NATIVE_OC NULL
#define OPTION_VAL_32BPP_OC NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_OC NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_OC NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_OC NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_OC NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_OC NULL
#define BEETLE_OPT_FILTER_LABEL_OC NULL
#define BEETLE_OPT_FILTER_INFO_0_OC NULL
#define OPTION_VAL_NEAREST_OC NULL
#define OPTION_VAL_SABR_OC NULL
#define OPTION_VAL_XBR_OC NULL
#define OPTION_VAL_BILINEAR_OC NULL
#define OPTION_VAL_3_POINT_OC NULL
#define OPTION_VAL_JINC2_OC NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_OC NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_OC NULL
#define OPTION_VAL_OPAQUE_OC NULL
#define OPTION_VAL_ALL_OC NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_OC NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_OC NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_OC NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_OC NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_OC NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_OC NULL
#define BEETLE_OPT_MSAA_LABEL_OC NULL
#define BEETLE_OPT_MSAA_INFO_0_OC NULL
#define OPTION_VAL_1X_OC NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_OC NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_OC NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_OC NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_OC NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_OC NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_OC NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_OC NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_OC NULL
#define BEETLE_OPT_WIREFRAME_LABEL_OC NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_OC NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_OC NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_OC NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_OC NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_OC NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_OC NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_OC NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_OC NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_OC NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_OC NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_OC NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_OC NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_OC NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_OC NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_OC NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_OC NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_OC NULL
#define OPTION_VAL_LIGHTGUN_OC NULL
#define OPTION_VAL_TOUCHSCREEN_OC NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_OC NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_OC NULL
#define OPTION_VAL_CROSS_OC NULL
#define OPTION_VAL_DOT_OC NULL
#define OPTION_VAL_OFF_OC NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_OC NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_OC NULL
#define OPTION_VAL_RED_OC NULL
#define OPTION_VAL_BLUE_OC NULL
#define OPTION_VAL_GREEN_OC NULL
#define OPTION_VAL_ORANGE_OC NULL
#define OPTION_VAL_YELLOW_OC NULL
#define OPTION_VAL_CYAN_OC NULL
#define OPTION_VAL_PINK_OC NULL
#define OPTION_VAL_PURPLE_OC NULL
#define OPTION_VAL_BLACK_OC NULL
#define OPTION_VAL_WHITE_OC NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_OC NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_OC NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_OC NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_OC NULL
#define OPTION_VAL_5_OC NULL
#define OPTION_VAL_10_OC NULL
#define OPTION_VAL_15_OC NULL
#define OPTION_VAL_20_OC NULL
#define OPTION_VAL_25_OC NULL
#define OPTION_VAL_30_OC NULL
#define OPTION_VAL_35_OC NULL
#define OPTION_VAL_40_OC NULL
#define OPTION_VAL_45_OC NULL
#define OPTION_VAL_50_OC NULL
#define OPTION_VAL_55_OC NULL
#define OPTION_VAL_60_OC NULL
#define OPTION_VAL_65_OC NULL
#define OPTION_VAL_70_OC NULL
#define OPTION_VAL_75_OC NULL
#define OPTION_VAL_80_OC NULL
#define OPTION_VAL_85_OC NULL
#define OPTION_VAL_90_OC NULL
#define OPTION_VAL_95_OC NULL
#define OPTION_VAL_100_OC NULL
#define OPTION_VAL_105_OC NULL
#define OPTION_VAL_110_OC NULL
#define OPTION_VAL_115_OC NULL
#define OPTION_VAL_120_OC NULL
#define OPTION_VAL_125_OC NULL
#define OPTION_VAL_130_OC NULL
#define OPTION_VAL_135_OC NULL
#define OPTION_VAL_140_OC NULL
#define OPTION_VAL_145_OC NULL
#define OPTION_VAL_150_OC NULL
#define OPTION_VAL_155_OC NULL
#define OPTION_VAL_160_OC NULL
#define OPTION_VAL_165_OC NULL
#define OPTION_VAL_170_OC NULL
#define OPTION_VAL_175_OC NULL
#define OPTION_VAL_180_OC NULL
#define OPTION_VAL_185_OC NULL
#define OPTION_VAL_190_OC NULL
#define OPTION_VAL_195_OC NULL
#define OPTION_VAL_200_OC NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_OC NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_OC NULL
#define OPTION_VAL_LINEAR_OC NULL
#define OPTION_VAL_QUADRATIC_OC NULL
#define OPTION_VAL_CUBIC_OC NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_OC NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_OC NULL
#define OPTION_VAL_0_OC NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_OC NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_OC NULL
#define OPTION_VAL_LIBRETRO_OC NULL
#define OPTION_VAL_MEDNAFEN_OC NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_OC NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_OC NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_OC NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_OC NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_OC NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_OC NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_OC NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_OC NULL
#define OPTION_VAL_1_OC NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_OC NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_OC NULL
#define OPTION_VAL_MEMORY_ONLY_OC NULL
#define OPTION_VAL_MEMORY_CPU_OC NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_OC NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_OC NULL
#define OPTION_VAL_0PX_OC NULL
#define OPTION_VAL_1PX_OC NULL
#define OPTION_VAL_2PX_OC NULL
#define OPTION_VAL_3PX_OC NULL
#define OPTION_VAL_4PX_OC NULL
#define OPTION_VAL_5PX_OC NULL
#define OPTION_VAL_6PX_OC NULL
#define OPTION_VAL_7PX_OC NULL
#define OPTION_VAL_8PX_OC NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_OC NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_OC NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_OC NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_OC NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_OC NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_OC NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_OC NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_OC NULL
#define OPTION_VAL_DEFAULT_OC NULL
#define OPTION_VAL_AGGRESSIVE_OC NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_OC NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_OC NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_OC NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_OC NULL
#define OPTION_VAL_16_9_OC NULL
#define OPTION_VAL_16_10_OC NULL
#define OPTION_VAL_18_9_OC NULL
#define OPTION_VAL_19_9_OC NULL
#define OPTION_VAL_20_9_OC NULL
#define OPTION_VAL_21_9_OC NULL
#define OPTION_VAL_32_9_OC NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_OC NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_OC NULL
#define OPTION_VAL_100_NATIVE_OC NULL
#define OPTION_VAL_210_OC NULL
#define OPTION_VAL_220_OC NULL
#define OPTION_VAL_230_OC NULL
#define OPTION_VAL_240_OC NULL
#define OPTION_VAL_250_OC NULL
#define OPTION_VAL_260_OC NULL
#define OPTION_VAL_270_OC NULL
#define OPTION_VAL_280_OC NULL
#define OPTION_VAL_290_OC NULL
#define OPTION_VAL_300_OC NULL
#define OPTION_VAL_310_OC NULL
#define OPTION_VAL_320_OC NULL
#define OPTION_VAL_330_OC NULL
#define OPTION_VAL_340_OC NULL
#define OPTION_VAL_350_OC NULL
#define OPTION_VAL_360_OC NULL
#define OPTION_VAL_370_OC NULL
#define OPTION_VAL_380_OC NULL
#define OPTION_VAL_390_OC NULL
#define OPTION_VAL_400_OC NULL
#define OPTION_VAL_410_OC NULL
#define OPTION_VAL_420_OC NULL
#define OPTION_VAL_430_OC NULL
#define OPTION_VAL_440_OC NULL
#define OPTION_VAL_450_OC NULL
#define OPTION_VAL_460_OC NULL
#define OPTION_VAL_470_OC NULL
#define OPTION_VAL_480_OC NULL
#define OPTION_VAL_490_OC NULL
#define OPTION_VAL_500_OC NULL
#define OPTION_VAL_510_OC NULL
#define OPTION_VAL_520_OC NULL
#define OPTION_VAL_530_OC NULL
#define OPTION_VAL_540_OC NULL
#define OPTION_VAL_550_OC NULL
#define OPTION_VAL_560_OC NULL
#define OPTION_VAL_570_OC NULL
#define OPTION_VAL_580_OC NULL
#define OPTION_VAL_590_OC NULL
#define OPTION_VAL_600_OC NULL
#define OPTION_VAL_610_OC NULL
#define OPTION_VAL_620_OC NULL
#define OPTION_VAL_630_OC NULL
#define OPTION_VAL_640_OC NULL
#define OPTION_VAL_650_OC NULL
#define OPTION_VAL_660_OC NULL
#define OPTION_VAL_670_OC NULL
#define OPTION_VAL_680_OC NULL
#define OPTION_VAL_690_OC NULL
#define OPTION_VAL_700_OC NULL
#define OPTION_VAL_710_OC NULL
#define OPTION_VAL_720_OC NULL
#define OPTION_VAL_730_OC NULL
#define OPTION_VAL_740_OC NULL
#define OPTION_VAL_750_OC NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_OC NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_OC NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_OC NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_OC NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_OC NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_OC NULL
#define OPTION_VAL_PSXONPSP_OC NULL
#define OPTION_VAL_PS1_ROM_OC NULL
#define BEETLE_OPT_RENDERER_LABEL_OC NULL
#define BEETLE_OPT_RENDERER_INFO_0_OC NULL
#define OPTION_VAL_HARDWARE_OC NULL
#define OPTION_VAL_HARDWARE_GL_OC NULL
#define OPTION_VAL_HARDWARE_VK_OC NULL
#define OPTION_VAL_SOFTWARE_OC NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_OC NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_OC NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_OC NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_OC NULL
#define OPTION_VAL_DISABLED_OC NULL
#define OPTION_VAL_EXECUTE_OC NULL
#define OPTION_VAL_EXECUTE_ONE_OC NULL
#define OPTION_VAL_RUN_INTERPRETER_OC NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_OC NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_OC NULL
#define OPTION_VAL_FULL_OC NULL
#define OPTION_VAL_DMA_OC NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_OC NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_OC NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_OC NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_OC NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_OC NULL
#define OPTION_VAL_FORCE_INTERLACED_OC NULL
#define OPTION_VAL_AUTO_TOGGLE_OC NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_OC NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_OC NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_OC NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_OC NULL
#define OPTION_VAL_DISABLED_O53_OC NULL
#define OPTION_VAL_STATIC_OC NULL
#define OPTION_VAL_SMART_OC NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_OC NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_OC NULL
#define OPTION_VAL_9PX_OC NULL
#define OPTION_VAL_10PX_OC NULL
#define OPTION_VAL_11PX_OC NULL
#define OPTION_VAL_12PX_OC NULL
#define OPTION_VAL_13PX_OC NULL
#define OPTION_VAL_14PX_OC NULL
#define OPTION_VAL_15PX_OC NULL
#define OPTION_VAL_16PX_OC NULL
#define OPTION_VAL_17PX_OC NULL
#define OPTION_VAL_18PX_OC NULL
#define OPTION_VAL_19PX_OC NULL
#define OPTION_VAL_20PX_OC NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_OC NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_OC NULL
#define OPTION_VAL_12PX_O55_OC NULL
#define OPTION_VAL_11PX_O55_OC NULL
#define OPTION_VAL_10PX_O55_OC NULL
#define OPTION_VAL_9PX_O55_OC NULL
#define OPTION_VAL_8PX_O55_OC NULL
#define OPTION_VAL_7PX_O55_OC NULL
#define OPTION_VAL_6PX_O55_OC NULL
#define OPTION_VAL_5PX_O55_OC NULL
#define OPTION_VAL_4PX_O55_OC NULL
#define OPTION_VAL_3PX_O55_OC NULL
#define OPTION_VAL_2PX_O55_OC NULL
#define OPTION_VAL_1PX_O55_OC NULL
#define OPTION_VAL_DISABLED_O55_OC NULL
#define OPTION_VAL_1PX_O55_0_OC NULL
#define OPTION_VAL_2PX_O55_0_OC NULL
#define OPTION_VAL_3PX_O55_0_OC NULL
#define OPTION_VAL_4PX_O55_0_OC NULL
#define OPTION_VAL_5PX_O55_0_OC NULL
#define OPTION_VAL_6PX_O55_0_OC NULL
#define OPTION_VAL_7PX_O55_0_OC NULL
#define OPTION_VAL_8PX_O55_0_OC NULL
#define OPTION_VAL_9PX_O55_0_OC NULL
#define OPTION_VAL_10PX_O55_0_OC NULL
#define OPTION_VAL_11PX_O55_0_OC NULL
#define OPTION_VAL_12PX_O55_0_OC NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_OC NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_OC NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_OC NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_OC NULL
#define OPTION_VAL_32X_OC NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_OC NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_OC NULL
#define OPTION_VAL_CORRECTED_OC NULL
#define OPTION_VAL_UNCORRECTED_OC NULL
#define OPTION_VAL_4_3_OC NULL
#define OPTION_VAL_NTSC_OC NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_OC NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_OC NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_OC NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_OC NULL
#define OPTION_VAL_239_OC NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_OC NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_OC NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_OC NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_OC NULL
#define OPTION_VAL_287_OC NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_OC NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_OC NULL
#define OPTION_VAL_SYNC_OC NULL
#define OPTION_VAL_ASYNC_OC NULL
#define OPTION_VAL_PRECACHE_OC NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_OC NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_OC NULL
#define OPTION_VAL_2X_NATIVE_OC NULL
#define OPTION_VAL_6X_OC NULL
#define OPTION_VAL_10X_OC NULL
#define OPTION_VAL_12X_OC NULL
#define OPTION_VAL_14X_OC NULL

struct retro_core_option_v2_category option_cats_oc[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_OC,
      CATEGORY_VIDEO_INFO_0_OC
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_OC,
      CATEGORY_OSD_INFO_0_OC
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_OC,
      CATEGORY_INPUT_INFO_0_OC
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_OC,
      CATEGORY_MEMCARDS_INFO_0_OC
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_OC,
      CATEGORY_PGXP_INFO_0_OC
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_OC,
      CATEGORY_HACKS_INFO_0_OC
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_oc[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_OC,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_OC,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_OC },
         { "2x",         OPTION_VAL_2X_OC },
         { "4x",         OPTION_VAL_4X_OC },
         { "8x",         OPTION_VAL_8X_OC },
         { "16x",        OPTION_VAL_16X_OC },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_OC,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_OC,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_OC },
         { "32bpp",         OPTION_VAL_32BPP_OC },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_OC,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_OC,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_OC },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_OC },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_OC,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_OC,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_OC,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_OC,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_OC },
         { "SABR",     OPTION_VAL_SABR_OC },
         { "xBR",      OPTION_VAL_XBR_OC },
         { "bilinear", OPTION_VAL_BILINEAR_OC },
         { "3-point",  OPTION_VAL_3_POINT_OC },
         { "JINC2",    OPTION_VAL_JINC2_OC },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_OC,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_OC,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_OC },
         { "all", OPTION_VAL_ALL_OC },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_OC,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_OC,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_OC },
         { "all", OPTION_VAL_ALL_OC },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_OC,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_OC,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_OC,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_OC,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_OC,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_OC,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_OC },
         { "2x",  OPTION_VAL_2X_OC },
         { "4x",  OPTION_VAL_4X_OC },
         { "8x",  OPTION_VAL_8X_OC },
         { "16x", OPTION_VAL_16X_OC },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_OC,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_OC,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_OC,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_OC,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_OC,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_OC,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_OC,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_OC,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_OC,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_OC,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_OC,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_OC,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_OC,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_OC,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_OC,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_OC,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_OC,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_OC,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_OC,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_OC,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_OC,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_OC,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_OC,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_OC,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_OC,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_OC,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_OC },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_OC },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_OC,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_OC,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_OC },
         { "dot",   OPTION_VAL_DOT_OC },
         { "off",   OPTION_VAL_OFF_OC },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_OC,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_OC,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_OC },
         { "blue", OPTION_VAL_BLUE_OC },
         { "green", OPTION_VAL_GREEN_OC },
         { "orange", OPTION_VAL_ORANGE_OC },
         { "yellow", OPTION_VAL_YELLOW_OC },
         { "cyan", OPTION_VAL_CYAN_OC },
         { "pink", OPTION_VAL_PINK_OC },
         { "purple", OPTION_VAL_PURPLE_OC },
         { "black", OPTION_VAL_BLACK_OC },
         { "white", OPTION_VAL_WHITE_OC },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_OC,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_OC,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_OC },
         { "red", OPTION_VAL_RED_OC },
         { "green", OPTION_VAL_GREEN_OC },
         { "orange", OPTION_VAL_ORANGE_OC },
         { "yellow", OPTION_VAL_YELLOW_OC },
         { "cyan", OPTION_VAL_CYAN_OC },
         { "pink", OPTION_VAL_PINK_OC },
         { "purple", OPTION_VAL_PURPLE_OC },
         { "black", OPTION_VAL_BLACK_OC },
         { "white", OPTION_VAL_WHITE_OC },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_OC,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_OC,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_OC },
         { "10%",  OPTION_VAL_10_OC },
         { "15%",  OPTION_VAL_15_OC },
         { "20%",  OPTION_VAL_20_OC },
         { "25%",  OPTION_VAL_25_OC },
         { "30%",  OPTION_VAL_30_OC },
         { "35%",  OPTION_VAL_35_OC },
         { "40%",  OPTION_VAL_40_OC },
         { "45%",  OPTION_VAL_45_OC },
         { "50%",  OPTION_VAL_50_OC },
         { "55%",  OPTION_VAL_55_OC },
         { "60%",  OPTION_VAL_60_OC },
         { "65%",  OPTION_VAL_65_OC },
         { "70%",  OPTION_VAL_70_OC },
         { "75%",  OPTION_VAL_75_OC },
         { "80%",  OPTION_VAL_80_OC },
         { "85%",  OPTION_VAL_85_OC },
         { "90%",  OPTION_VAL_90_OC },
         { "95%",  OPTION_VAL_95_OC },
         { "100%", OPTION_VAL_100_OC },
         { "105%", OPTION_VAL_105_OC },
         { "110%", OPTION_VAL_110_OC },
         { "115%", OPTION_VAL_115_OC },
         { "120%", OPTION_VAL_120_OC },
         { "125%", OPTION_VAL_125_OC },
         { "130%", OPTION_VAL_130_OC },
         { "135%", OPTION_VAL_135_OC },
         { "140%", OPTION_VAL_140_OC },
         { "145%", OPTION_VAL_145_OC },
         { "150%", OPTION_VAL_150_OC },
         { "155%", OPTION_VAL_155_OC },
         { "160%", OPTION_VAL_160_OC },
         { "165%", OPTION_VAL_165_OC },
         { "170%", OPTION_VAL_170_OC },
         { "175%", OPTION_VAL_175_OC },
         { "180%", OPTION_VAL_180_OC },
         { "185%", OPTION_VAL_185_OC },
         { "190%", OPTION_VAL_190_OC },
         { "195%", OPTION_VAL_195_OC },
         { "200%", OPTION_VAL_200_OC },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_OC,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_OC,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_OC },
         { "quadratic", OPTION_VAL_QUADRATIC_OC },
         { "cubic",     OPTION_VAL_CUBIC_OC },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_OC,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_OC,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_OC },
         { "5%",  OPTION_VAL_5_OC },
         { "10%", OPTION_VAL_10_OC },
         { "15%", OPTION_VAL_15_OC },
         { "20%", OPTION_VAL_20_OC },
         { "25%", OPTION_VAL_25_OC },
         { "30%", OPTION_VAL_30_OC },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_OC,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_OC,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_OC },
         { "mednafen", OPTION_VAL_MEDNAFEN_OC },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_OC,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_OC,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_OC,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_OC,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_OC,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_OC,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_OC,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_OC,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_OC },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_OC,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_OC,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_OC },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_OC },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_OC,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_OC,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_OC },
         { "1px", OPTION_VAL_1PX_OC },
         { "2px", OPTION_VAL_2PX_OC },
         { "3px", OPTION_VAL_3PX_OC },
         { "4px", OPTION_VAL_4PX_OC },
         { "5px", OPTION_VAL_5PX_OC },
         { "6px", OPTION_VAL_6PX_OC },
         { "7px", OPTION_VAL_7PX_OC },
         { "8px", OPTION_VAL_8PX_OC },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_OC,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_OC,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_OC,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_OC,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_OC,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_OC,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_OC,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_OC,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_OC },
         { "aggressive", OPTION_VAL_AGGRESSIVE_OC },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_OC,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_OC,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_OC,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_OC,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_OC },
         { "16:10", OPTION_VAL_16_10_OC },
         { "18:9",  OPTION_VAL_18_9_OC },
         { "19:9",  OPTION_VAL_19_9_OC },
         { "20:9",  OPTION_VAL_20_9_OC },
         { "21:9",  OPTION_VAL_21_9_OC }, // 64:27
         { "32:9",  OPTION_VAL_32_9_OC },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_OC,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_OC,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_OC },
         { "60%",           OPTION_VAL_60_OC },
         { "70%",           OPTION_VAL_70_OC },
         { "80%",           OPTION_VAL_80_OC },
         { "90%",           OPTION_VAL_90_OC },
         { "100%(native)", OPTION_VAL_100_NATIVE_OC },
         { "110%",          OPTION_VAL_110_OC },
         { "120%",          OPTION_VAL_120_OC },
         { "130%",          OPTION_VAL_130_OC },
         { "140%",          OPTION_VAL_140_OC },
         { "150%",          OPTION_VAL_150_OC },
         { "160%",          OPTION_VAL_160_OC },
         { "170%",          OPTION_VAL_170_OC },
         { "180%",          OPTION_VAL_180_OC },
         { "190%",          OPTION_VAL_190_OC },
         { "200%",          OPTION_VAL_200_OC },
         { "210%",          OPTION_VAL_210_OC },
         { "220%",          OPTION_VAL_220_OC },
         { "230%",          OPTION_VAL_230_OC },
         { "240%",          OPTION_VAL_240_OC },
         { "250%",          OPTION_VAL_250_OC },
         { "260%",          OPTION_VAL_260_OC },
         { "270%",          OPTION_VAL_270_OC },
         { "280%",          OPTION_VAL_280_OC },
         { "290%",          OPTION_VAL_290_OC },
         { "300%",          OPTION_VAL_300_OC },
         { "310%",          OPTION_VAL_310_OC },
         { "320%",          OPTION_VAL_320_OC },
         { "330%",          OPTION_VAL_330_OC },
         { "340%",          OPTION_VAL_340_OC },
         { "350%",          OPTION_VAL_350_OC },
         { "360%",          OPTION_VAL_360_OC },
         { "370%",          OPTION_VAL_370_OC },
         { "380%",          OPTION_VAL_380_OC },
         { "390%",          OPTION_VAL_390_OC },
         { "400%",          OPTION_VAL_400_OC },
         { "410%",          OPTION_VAL_410_OC },
         { "420%",          OPTION_VAL_420_OC },
         { "430%",          OPTION_VAL_430_OC },
         { "440%",          OPTION_VAL_440_OC },
         { "450%",          OPTION_VAL_450_OC },
         { "460%",          OPTION_VAL_460_OC },
         { "470%",          OPTION_VAL_470_OC },
         { "480%",          OPTION_VAL_480_OC },
         { "490%",          OPTION_VAL_490_OC },
         { "500%",          OPTION_VAL_500_OC },
         { "510%",          OPTION_VAL_510_OC },
         { "520%",          OPTION_VAL_520_OC },
         { "530%",          OPTION_VAL_530_OC },
         { "540%",          OPTION_VAL_540_OC },
         { "550%",          OPTION_VAL_550_OC },
         { "560%",          OPTION_VAL_560_OC },
         { "570%",          OPTION_VAL_570_OC },
         { "580%",          OPTION_VAL_580_OC },
         { "590%",          OPTION_VAL_590_OC },
         { "600%",          OPTION_VAL_600_OC },
         { "610%",          OPTION_VAL_610_OC },
         { "620%",          OPTION_VAL_620_OC },
         { "630%",          OPTION_VAL_630_OC },
         { "640%",          OPTION_VAL_640_OC },
         { "650%",          OPTION_VAL_650_OC },
         { "660%",          OPTION_VAL_660_OC },
         { "670%",          OPTION_VAL_670_OC },
         { "680%",          OPTION_VAL_680_OC },
         { "690%",          OPTION_VAL_690_OC },
         { "700%",          OPTION_VAL_700_OC },
         { "710%",          OPTION_VAL_710_OC },
         { "720%",          OPTION_VAL_720_OC },
         { "730%",          OPTION_VAL_730_OC },
         { "740%",          OPTION_VAL_740_OC },
         { "750%",          OPTION_VAL_750_OC },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_OC,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_OC,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_OC,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_OC,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_OC,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_OC,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_OC },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_OC },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_OC,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_OC,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_OC },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_OC },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_OC },
#endif
         { "software",    OPTION_VAL_SOFTWARE_OC },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_OC,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_OC,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_OC,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_OC,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_OC },
         { "execute",  OPTION_VAL_EXECUTE_OC },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_OC },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_OC },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_OC,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_OC,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_OC },
         { "dma",  OPTION_VAL_DMA_OC },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_OC,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_OC,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_OC,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_OC,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_OC },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_OC },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_OC },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_OC,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_OC,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_OC,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_OC,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_OC },
         { "static",  OPTION_VAL_STATIC_OC },
         { "smart", OPTION_VAL_SMART_OC },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_OC,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_OC,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_OC },
         { "2px",      OPTION_VAL_2PX_OC },
         { "3px",      OPTION_VAL_3PX_OC },
         { "4px",      OPTION_VAL_4PX_OC },
         { "5px",      OPTION_VAL_5PX_OC },
         { "6px",      OPTION_VAL_6PX_OC },
         { "7px",      OPTION_VAL_7PX_OC },
         { "8px",      OPTION_VAL_8PX_OC },
         { "9px",      OPTION_VAL_9PX_OC },
         { "10px",     OPTION_VAL_10PX_OC },
         { "11px",     OPTION_VAL_11PX_OC },
         { "12px",     OPTION_VAL_12PX_OC },
         { "13px",     OPTION_VAL_13PX_OC },
         { "14px",     OPTION_VAL_14PX_OC },
         { "15px",     OPTION_VAL_15PX_OC },
         { "16px",     OPTION_VAL_16PX_OC },
         { "17px",     OPTION_VAL_17PX_OC },
         { "18px",     OPTION_VAL_18PX_OC },
         { "19px",     OPTION_VAL_19PX_OC },
         { "20px",     OPTION_VAL_20PX_OC },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_OC,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_OC,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_OC },
         { "-11px",    OPTION_VAL_11PX_O55_OC },
         { "-10px",    OPTION_VAL_10PX_O55_OC },
         { "-9px",     OPTION_VAL_9PX_O55_OC },
         { "-8px",     OPTION_VAL_8PX_O55_OC },
         { "-7px",     OPTION_VAL_7PX_O55_OC },
         { "-6px",     OPTION_VAL_6PX_O55_OC },
         { "-5px",     OPTION_VAL_5PX_O55_OC },
         { "-4px",     OPTION_VAL_4PX_O55_OC },
         { "-3px",     OPTION_VAL_3PX_O55_OC },
         { "-2px",     OPTION_VAL_2PX_O55_OC },
         { "-1px",     OPTION_VAL_1PX_O55_OC },
         { "disabled", OPTION_VAL_DISABLED_O55_OC },
         { "+1px",     OPTION_VAL_1PX_O55_0_OC },
         { "+2px",     OPTION_VAL_2PX_O55_0_OC },
         { "+3px",     OPTION_VAL_3PX_O55_0_OC },
         { "+4px",     OPTION_VAL_4PX_O55_0_OC },
         { "+5px",     OPTION_VAL_5PX_O55_0_OC },
         { "+6px",     OPTION_VAL_6PX_O55_0_OC },
         { "+7px",     OPTION_VAL_7PX_O55_0_OC },
         { "+8px",     OPTION_VAL_8PX_O55_0_OC },
         { "+9px",     OPTION_VAL_9PX_O55_0_OC },
         { "+10px",    OPTION_VAL_10PX_O55_0_OC },
         { "+11px",    OPTION_VAL_11PX_O55_0_OC },
         { "+12px",    OPTION_VAL_12PX_O55_0_OC },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_OC,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_OC,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_OC },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_OC,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_OC,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_OC },
         { "2x",         OPTION_VAL_2X_OC },
         { "4x",         OPTION_VAL_4X_OC },
         { "8x",         OPTION_VAL_8X_OC },
         { "16x",        OPTION_VAL_16X_OC },
         { "32x",        OPTION_VAL_32X_OC },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_OC,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_OC,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_OC },
         { "uncorrected", OPTION_VAL_UNCORRECTED_OC },
         { "4:3",  OPTION_VAL_4_3_OC },
         { "ntsc", OPTION_VAL_NTSC_OC },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_OC,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_OC,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_OC,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_OC,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_OC },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_OC,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_OC,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_OC,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_OC,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_OC },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_OC,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_OC,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_OC },
         { "async",    OPTION_VAL_ASYNC_OC },
         { "precache", OPTION_VAL_PRECACHE_OC },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_OC,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_OC,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_OC },
         { "4x",          OPTION_VAL_4X_OC },
         { "6x",          OPTION_VAL_6X_OC },
         { "8x",          OPTION_VAL_8X_OC },
         { "10x",         OPTION_VAL_10X_OC },
         { "12x",         OPTION_VAL_12X_OC },
         { "14x",         OPTION_VAL_14X_OC },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_oc = {
   option_cats_oc,
   option_defs_oc
};

/* RETRO_LANGUAGE_PL */

#define CATEGORY_VIDEO_LABEL_PL "Wideo"
#define CATEGORY_VIDEO_INFO_0_PL "Zmień proporcje obrazów, przycinanie wyświetlaczy, filtr wideo i pomijanie ustawień ramki."
#define CATEGORY_OSD_LABEL_PL "Powiadomienia na ekranie"
#define CATEGORY_OSD_INFO_0_PL "Zmień powiadomienia wyświetlane na ekranie."
#define CATEGORY_INPUT_LABEL_PL "Wejście"
#define CATEGORY_INPUT_INFO_0_PL "Zmień ustawienia pistoletu, myszy i neGcon."
#define CATEGORY_MEMCARDS_LABEL_PL "Karta pamięci"
#define CATEGORY_MEMCARDS_INFO_0_PL "Zmień ustawienia związane z wirtualnymi kartami pamięci używanymi przez system."
#define CATEGORY_PGXP_LABEL_PL "Ulepszenie geometrii tekstur PGXP (Precision Geometry Transform Pipeline)"
#define CATEGORY_PGXP_INFO_0_PL "Te opcje kontrolują ulepszenia, które mogą poprawić grafikę w porównaniu z oryginalną konsolą. PGXP pomaga pozbyć się pływających tekstur i problemów z Z-buforem."
#define CATEGORY_HACKS_LABEL_PL "Hacki emulacyjne"
#define CATEGORY_HACKS_INFO_0_PL "Zmiana ustawień przetaktowania procesora i dokładności emulacji wpływająca na niską wydajność i kompatybilność."
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_PL "Wewnętrzna rozdzielczość GPU"
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_PL NULL
#define OPTION_VAL_1X_NATIVE_PL "1x (natywne)"
#define OPTION_VAL_2X_PL NULL
#define OPTION_VAL_4X_PL NULL
#define OPTION_VAL_8X_PL NULL
#define OPTION_VAL_16X_PL NULL
#define BEETLE_OPT_DEPTH_LABEL_PL "Wewnętrzna głębia koloru"
#define BEETLE_OPT_DEPTH_INFO_0_PL NULL
#define OPTION_VAL_16BPP_NATIVE_PL "16 bpp (natywna)"
#define OPTION_VAL_32BPP_PL NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_PL "Wzorzec ditheringu"
#define BEETLE_OPT_DITHER_MODE_INFO_0_PL NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_PL "Wewnętrzna rozdzielczość"
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_PL NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_PL NULL
#define BEETLE_OPT_FILTER_LABEL_PL "Filtrowanie tekstur"
#define BEETLE_OPT_FILTER_INFO_0_PL NULL
#define OPTION_VAL_NEAREST_PL "Najbliższe"
#define OPTION_VAL_SABR_PL NULL
#define OPTION_VAL_XBR_PL NULL
#define OPTION_VAL_BILINEAR_PL "Dwuliniowy"
#define OPTION_VAL_3_POINT_PL "3-Punktowy"
#define OPTION_VAL_JINC2_PL NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_PL "Wyklucz duszki z filtrowania"
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_PL NULL
#define OPTION_VAL_OPAQUE_PL NULL
#define OPTION_VAL_ALL_PL NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_PL NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_PL NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_PL NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_PL NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_PL NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_PL NULL
#define BEETLE_OPT_MSAA_LABEL_PL NULL
#define BEETLE_OPT_MSAA_INFO_0_PL NULL
#define OPTION_VAL_1X_PL NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_PL NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_PL NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_PL NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_PL NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_PL NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_PL NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_PL NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_PL NULL
#define BEETLE_OPT_WIREFRAME_LABEL_PL NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_PL NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_PL NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_PL NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_PL NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_PL NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_PL NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_PL NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_PL NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_PL NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_PL NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_PL NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_PL NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_PL NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_PL NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_PL NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_PL NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_PL NULL
#define OPTION_VAL_LIGHTGUN_PL "Pistolet Świetlny"
#define OPTION_VAL_TOUCHSCREEN_PL "Ekran dotykowy"
#define BEETLE_OPT_GUN_CURSOR_LABEL_PL NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_PL NULL
#define OPTION_VAL_CROSS_PL NULL
#define OPTION_VAL_DOT_PL NULL
#define OPTION_VAL_OFF_PL NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_PL NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_PL NULL
#define OPTION_VAL_RED_PL "Czerwony"
#define OPTION_VAL_BLUE_PL "Niebieski"
#define OPTION_VAL_GREEN_PL "Zielony"
#define OPTION_VAL_ORANGE_PL NULL
#define OPTION_VAL_YELLOW_PL "Żółty"
#define OPTION_VAL_CYAN_PL NULL
#define OPTION_VAL_PINK_PL NULL
#define OPTION_VAL_PURPLE_PL NULL
#define OPTION_VAL_BLACK_PL NULL
#define OPTION_VAL_WHITE_PL NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_PL NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_PL NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_PL "Czułość myszy"
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_PL NULL
#define OPTION_VAL_5_PL NULL
#define OPTION_VAL_10_PL NULL
#define OPTION_VAL_15_PL NULL
#define OPTION_VAL_20_PL NULL
#define OPTION_VAL_25_PL NULL
#define OPTION_VAL_30_PL "30 %"
#define OPTION_VAL_35_PL NULL
#define OPTION_VAL_40_PL NULL
#define OPTION_VAL_45_PL NULL
#define OPTION_VAL_50_PL "50 %"
#define OPTION_VAL_55_PL NULL
#define OPTION_VAL_60_PL "60 %"
#define OPTION_VAL_65_PL NULL
#define OPTION_VAL_70_PL NULL
#define OPTION_VAL_75_PL NULL
#define OPTION_VAL_80_PL "80 %"
#define OPTION_VAL_85_PL NULL
#define OPTION_VAL_90_PL NULL
#define OPTION_VAL_95_PL NULL
#define OPTION_VAL_100_PL NULL
#define OPTION_VAL_105_PL NULL
#define OPTION_VAL_110_PL NULL
#define OPTION_VAL_115_PL NULL
#define OPTION_VAL_120_PL NULL
#define OPTION_VAL_125_PL NULL
#define OPTION_VAL_130_PL NULL
#define OPTION_VAL_135_PL NULL
#define OPTION_VAL_140_PL NULL
#define OPTION_VAL_145_PL NULL
#define OPTION_VAL_150_PL NULL
#define OPTION_VAL_155_PL NULL
#define OPTION_VAL_160_PL NULL
#define OPTION_VAL_165_PL NULL
#define OPTION_VAL_170_PL NULL
#define OPTION_VAL_175_PL NULL
#define OPTION_VAL_180_PL NULL
#define OPTION_VAL_185_PL NULL
#define OPTION_VAL_190_PL NULL
#define OPTION_VAL_195_PL NULL
#define OPTION_VAL_200_PL NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_PL "odpowiedź neGcon Twist"
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_PL NULL
#define OPTION_VAL_LINEAR_PL "Liniowy"
#define OPTION_VAL_QUADRATIC_PL NULL
#define OPTION_VAL_CUBIC_PL NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_PL NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_PL NULL
#define OPTION_VAL_0_PL NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_PL NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_PL NULL
#define OPTION_VAL_LIBRETRO_PL NULL
#define OPTION_VAL_MEDNAFEN_PL NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_PL NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_PL NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_PL NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_PL NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_PL NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_PL NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_PL NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_PL NULL
#define OPTION_VAL_1_PL NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_PL NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_PL NULL
#define OPTION_VAL_MEMORY_ONLY_PL NULL
#define OPTION_VAL_MEMORY_CPU_PL NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_PL NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_PL NULL
#define OPTION_VAL_0PX_PL NULL
#define OPTION_VAL_1PX_PL NULL
#define OPTION_VAL_2PX_PL NULL
#define OPTION_VAL_3PX_PL NULL
#define OPTION_VAL_4PX_PL NULL
#define OPTION_VAL_5PX_PL NULL
#define OPTION_VAL_6PX_PL NULL
#define OPTION_VAL_7PX_PL NULL
#define OPTION_VAL_8PX_PL NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_PL NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_PL NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_PL NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_PL NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_PL NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_PL NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_PL NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_PL NULL
#define OPTION_VAL_DEFAULT_PL "Domyślny"
#define OPTION_VAL_AGGRESSIVE_PL NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_PL NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_PL NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_PL NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_PL NULL
#define OPTION_VAL_16_9_PL NULL
#define OPTION_VAL_16_10_PL NULL
#define OPTION_VAL_18_9_PL NULL
#define OPTION_VAL_19_9_PL NULL
#define OPTION_VAL_20_9_PL NULL
#define OPTION_VAL_21_9_PL NULL
#define OPTION_VAL_32_9_PL NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_PL NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_PL NULL
#define OPTION_VAL_100_NATIVE_PL NULL
#define OPTION_VAL_210_PL NULL
#define OPTION_VAL_220_PL NULL
#define OPTION_VAL_230_PL NULL
#define OPTION_VAL_240_PL NULL
#define OPTION_VAL_250_PL NULL
#define OPTION_VAL_260_PL NULL
#define OPTION_VAL_270_PL NULL
#define OPTION_VAL_280_PL NULL
#define OPTION_VAL_290_PL NULL
#define OPTION_VAL_300_PL NULL
#define OPTION_VAL_310_PL NULL
#define OPTION_VAL_320_PL NULL
#define OPTION_VAL_330_PL NULL
#define OPTION_VAL_340_PL NULL
#define OPTION_VAL_350_PL NULL
#define OPTION_VAL_360_PL NULL
#define OPTION_VAL_370_PL NULL
#define OPTION_VAL_380_PL NULL
#define OPTION_VAL_390_PL NULL
#define OPTION_VAL_400_PL NULL
#define OPTION_VAL_410_PL NULL
#define OPTION_VAL_420_PL NULL
#define OPTION_VAL_430_PL NULL
#define OPTION_VAL_440_PL NULL
#define OPTION_VAL_450_PL NULL
#define OPTION_VAL_460_PL NULL
#define OPTION_VAL_470_PL NULL
#define OPTION_VAL_480_PL NULL
#define OPTION_VAL_490_PL NULL
#define OPTION_VAL_500_PL NULL
#define OPTION_VAL_510_PL NULL
#define OPTION_VAL_520_PL NULL
#define OPTION_VAL_530_PL NULL
#define OPTION_VAL_540_PL NULL
#define OPTION_VAL_550_PL NULL
#define OPTION_VAL_560_PL NULL
#define OPTION_VAL_570_PL NULL
#define OPTION_VAL_580_PL NULL
#define OPTION_VAL_590_PL NULL
#define OPTION_VAL_600_PL NULL
#define OPTION_VAL_610_PL NULL
#define OPTION_VAL_620_PL NULL
#define OPTION_VAL_630_PL NULL
#define OPTION_VAL_640_PL NULL
#define OPTION_VAL_650_PL NULL
#define OPTION_VAL_660_PL NULL
#define OPTION_VAL_670_PL NULL
#define OPTION_VAL_680_PL NULL
#define OPTION_VAL_690_PL NULL
#define OPTION_VAL_700_PL NULL
#define OPTION_VAL_710_PL NULL
#define OPTION_VAL_720_PL NULL
#define OPTION_VAL_730_PL NULL
#define OPTION_VAL_740_PL NULL
#define OPTION_VAL_750_PL NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_PL NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_PL NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_PL NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_PL NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_PL NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_PL NULL
#define OPTION_VAL_PSXONPSP_PL NULL
#define OPTION_VAL_PS1_ROM_PL NULL
#define BEETLE_OPT_RENDERER_LABEL_PL NULL
#define BEETLE_OPT_RENDERER_INFO_0_PL NULL
#define OPTION_VAL_HARDWARE_PL NULL
#define OPTION_VAL_HARDWARE_GL_PL NULL
#define OPTION_VAL_HARDWARE_VK_PL NULL
#define OPTION_VAL_SOFTWARE_PL NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_PL NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_PL NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_PL NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_PL NULL
#define OPTION_VAL_DISABLED_PL NULL
#define OPTION_VAL_EXECUTE_PL NULL
#define OPTION_VAL_EXECUTE_ONE_PL NULL
#define OPTION_VAL_RUN_INTERPRETER_PL NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_PL NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_PL NULL
#define OPTION_VAL_FULL_PL "Pełny"
#define OPTION_VAL_DMA_PL NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_PL NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_PL NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_PL NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_PL NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_PL NULL
#define OPTION_VAL_FORCE_INTERLACED_PL NULL
#define OPTION_VAL_AUTO_TOGGLE_PL NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_PL NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_PL NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_PL "Przytnij overscan"
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_PL NULL
#define OPTION_VAL_DISABLED_O53_PL "Brak"
#define OPTION_VAL_STATIC_PL NULL
#define OPTION_VAL_SMART_PL NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_PL NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_PL NULL
#define OPTION_VAL_9PX_PL NULL
#define OPTION_VAL_10PX_PL NULL
#define OPTION_VAL_11PX_PL NULL
#define OPTION_VAL_12PX_PL NULL
#define OPTION_VAL_13PX_PL NULL
#define OPTION_VAL_14PX_PL NULL
#define OPTION_VAL_15PX_PL NULL
#define OPTION_VAL_16PX_PL NULL
#define OPTION_VAL_17PX_PL NULL
#define OPTION_VAL_18PX_PL NULL
#define OPTION_VAL_19PX_PL NULL
#define OPTION_VAL_20PX_PL NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_PL NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_PL NULL
#define OPTION_VAL_12PX_O55_PL NULL
#define OPTION_VAL_11PX_O55_PL NULL
#define OPTION_VAL_10PX_O55_PL NULL
#define OPTION_VAL_9PX_O55_PL NULL
#define OPTION_VAL_8PX_O55_PL NULL
#define OPTION_VAL_7PX_O55_PL NULL
#define OPTION_VAL_6PX_O55_PL NULL
#define OPTION_VAL_5PX_O55_PL NULL
#define OPTION_VAL_4PX_O55_PL NULL
#define OPTION_VAL_3PX_O55_PL NULL
#define OPTION_VAL_2PX_O55_PL NULL
#define OPTION_VAL_1PX_O55_PL NULL
#define OPTION_VAL_DISABLED_O55_PL "0 (domyślnie)"
#define OPTION_VAL_1PX_O55_0_PL NULL
#define OPTION_VAL_2PX_O55_0_PL NULL
#define OPTION_VAL_3PX_O55_0_PL NULL
#define OPTION_VAL_4PX_O55_0_PL NULL
#define OPTION_VAL_5PX_O55_0_PL NULL
#define OPTION_VAL_6PX_O55_0_PL NULL
#define OPTION_VAL_7PX_O55_0_PL NULL
#define OPTION_VAL_8PX_O55_0_PL NULL
#define OPTION_VAL_9PX_O55_0_PL NULL
#define OPTION_VAL_10PX_O55_0_PL NULL
#define OPTION_VAL_11PX_O55_0_PL NULL
#define OPTION_VAL_12PX_O55_0_PL NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_PL NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_PL NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_PL NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_PL NULL
#define OPTION_VAL_32X_PL NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_PL NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_PL NULL
#define OPTION_VAL_CORRECTED_PL NULL
#define OPTION_VAL_UNCORRECTED_PL "Niepoprawione"
#define OPTION_VAL_4_3_PL NULL
#define OPTION_VAL_NTSC_PL NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_PL NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_PL NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_PL NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_PL NULL
#define OPTION_VAL_239_PL "239 (domyślnie)"
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_PL NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_PL NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_PL NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_PL NULL
#define OPTION_VAL_287_PL "287 (domyślnie)"
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_PL NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_PL NULL
#define OPTION_VAL_SYNC_PL NULL
#define OPTION_VAL_ASYNC_PL NULL
#define OPTION_VAL_PRECACHE_PL NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_PL NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_PL NULL
#define OPTION_VAL_2X_NATIVE_PL NULL
#define OPTION_VAL_6X_PL NULL
#define OPTION_VAL_10X_PL NULL
#define OPTION_VAL_12X_PL NULL
#define OPTION_VAL_14X_PL NULL

struct retro_core_option_v2_category option_cats_pl[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_PL,
      CATEGORY_VIDEO_INFO_0_PL
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_PL,
      CATEGORY_OSD_INFO_0_PL
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_PL,
      CATEGORY_INPUT_INFO_0_PL
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_PL,
      CATEGORY_MEMCARDS_INFO_0_PL
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_PL,
      CATEGORY_PGXP_INFO_0_PL
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_PL,
      CATEGORY_HACKS_INFO_0_PL
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_pl[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_PL,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_PL,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_PL },
         { "2x",         OPTION_VAL_2X_PL },
         { "4x",         OPTION_VAL_4X_PL },
         { "8x",         OPTION_VAL_8X_PL },
         { "16x",        OPTION_VAL_16X_PL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_PL,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_PL,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_PL },
         { "32bpp",         OPTION_VAL_32BPP_PL },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_PL,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_PL,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_PL },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_PL },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_PL,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_PL,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_PL,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_PL,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_PL },
         { "SABR",     OPTION_VAL_SABR_PL },
         { "xBR",      OPTION_VAL_XBR_PL },
         { "bilinear", OPTION_VAL_BILINEAR_PL },
         { "3-point",  OPTION_VAL_3_POINT_PL },
         { "JINC2",    OPTION_VAL_JINC2_PL },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_PL,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_PL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_PL },
         { "all", OPTION_VAL_ALL_PL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_PL,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_PL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_PL },
         { "all", OPTION_VAL_ALL_PL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_PL,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_PL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_PL,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_PL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_PL,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_PL,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_PL },
         { "2x",  OPTION_VAL_2X_PL },
         { "4x",  OPTION_VAL_4X_PL },
         { "8x",  OPTION_VAL_8X_PL },
         { "16x", OPTION_VAL_16X_PL },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_PL,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_PL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_PL,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_PL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_PL,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_PL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_PL,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_PL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_PL,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_PL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_PL,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_PL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_PL,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_PL,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_PL,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_PL,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_PL,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_PL,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_PL,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_PL,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_PL,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_PL,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_PL,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_PL,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_PL,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_PL,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_PL },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_PL },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_PL,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_PL,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_PL },
         { "dot",   OPTION_VAL_DOT_PL },
         { "off",   OPTION_VAL_OFF_PL },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_PL,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_PL,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_PL },
         { "blue", OPTION_VAL_BLUE_PL },
         { "green", OPTION_VAL_GREEN_PL },
         { "orange", OPTION_VAL_ORANGE_PL },
         { "yellow", OPTION_VAL_YELLOW_PL },
         { "cyan", OPTION_VAL_CYAN_PL },
         { "pink", OPTION_VAL_PINK_PL },
         { "purple", OPTION_VAL_PURPLE_PL },
         { "black", OPTION_VAL_BLACK_PL },
         { "white", OPTION_VAL_WHITE_PL },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_PL,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_PL,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_PL },
         { "red", OPTION_VAL_RED_PL },
         { "green", OPTION_VAL_GREEN_PL },
         { "orange", OPTION_VAL_ORANGE_PL },
         { "yellow", OPTION_VAL_YELLOW_PL },
         { "cyan", OPTION_VAL_CYAN_PL },
         { "pink", OPTION_VAL_PINK_PL },
         { "purple", OPTION_VAL_PURPLE_PL },
         { "black", OPTION_VAL_BLACK_PL },
         { "white", OPTION_VAL_WHITE_PL },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_PL,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_PL,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_PL },
         { "10%",  OPTION_VAL_10_PL },
         { "15%",  OPTION_VAL_15_PL },
         { "20%",  OPTION_VAL_20_PL },
         { "25%",  OPTION_VAL_25_PL },
         { "30%",  OPTION_VAL_30_PL },
         { "35%",  OPTION_VAL_35_PL },
         { "40%",  OPTION_VAL_40_PL },
         { "45%",  OPTION_VAL_45_PL },
         { "50%",  OPTION_VAL_50_PL },
         { "55%",  OPTION_VAL_55_PL },
         { "60%",  OPTION_VAL_60_PL },
         { "65%",  OPTION_VAL_65_PL },
         { "70%",  OPTION_VAL_70_PL },
         { "75%",  OPTION_VAL_75_PL },
         { "80%",  OPTION_VAL_80_PL },
         { "85%",  OPTION_VAL_85_PL },
         { "90%",  OPTION_VAL_90_PL },
         { "95%",  OPTION_VAL_95_PL },
         { "100%", OPTION_VAL_100_PL },
         { "105%", OPTION_VAL_105_PL },
         { "110%", OPTION_VAL_110_PL },
         { "115%", OPTION_VAL_115_PL },
         { "120%", OPTION_VAL_120_PL },
         { "125%", OPTION_VAL_125_PL },
         { "130%", OPTION_VAL_130_PL },
         { "135%", OPTION_VAL_135_PL },
         { "140%", OPTION_VAL_140_PL },
         { "145%", OPTION_VAL_145_PL },
         { "150%", OPTION_VAL_150_PL },
         { "155%", OPTION_VAL_155_PL },
         { "160%", OPTION_VAL_160_PL },
         { "165%", OPTION_VAL_165_PL },
         { "170%", OPTION_VAL_170_PL },
         { "175%", OPTION_VAL_175_PL },
         { "180%", OPTION_VAL_180_PL },
         { "185%", OPTION_VAL_185_PL },
         { "190%", OPTION_VAL_190_PL },
         { "195%", OPTION_VAL_195_PL },
         { "200%", OPTION_VAL_200_PL },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_PL,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_PL,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_PL },
         { "quadratic", OPTION_VAL_QUADRATIC_PL },
         { "cubic",     OPTION_VAL_CUBIC_PL },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_PL,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_PL,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_PL },
         { "5%",  OPTION_VAL_5_PL },
         { "10%", OPTION_VAL_10_PL },
         { "15%", OPTION_VAL_15_PL },
         { "20%", OPTION_VAL_20_PL },
         { "25%", OPTION_VAL_25_PL },
         { "30%", OPTION_VAL_30_PL },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_PL,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_PL,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_PL },
         { "mednafen", OPTION_VAL_MEDNAFEN_PL },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_PL,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_PL,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_PL,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_PL,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_PL,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_PL,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_PL,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_PL,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_PL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_PL,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_PL,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_PL },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_PL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_PL,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_PL,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_PL },
         { "1px", OPTION_VAL_1PX_PL },
         { "2px", OPTION_VAL_2PX_PL },
         { "3px", OPTION_VAL_3PX_PL },
         { "4px", OPTION_VAL_4PX_PL },
         { "5px", OPTION_VAL_5PX_PL },
         { "6px", OPTION_VAL_6PX_PL },
         { "7px", OPTION_VAL_7PX_PL },
         { "8px", OPTION_VAL_8PX_PL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_PL,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_PL,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_PL,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_PL,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_PL,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_PL,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_PL,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_PL,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_PL },
         { "aggressive", OPTION_VAL_AGGRESSIVE_PL },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_PL,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_PL,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_PL,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_PL,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_PL },
         { "16:10", OPTION_VAL_16_10_PL },
         { "18:9",  OPTION_VAL_18_9_PL },
         { "19:9",  OPTION_VAL_19_9_PL },
         { "20:9",  OPTION_VAL_20_9_PL },
         { "21:9",  OPTION_VAL_21_9_PL }, // 64:27
         { "32:9",  OPTION_VAL_32_9_PL },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_PL,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_PL,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_PL },
         { "60%",           OPTION_VAL_60_PL },
         { "70%",           OPTION_VAL_70_PL },
         { "80%",           OPTION_VAL_80_PL },
         { "90%",           OPTION_VAL_90_PL },
         { "100%(native)", OPTION_VAL_100_NATIVE_PL },
         { "110%",          OPTION_VAL_110_PL },
         { "120%",          OPTION_VAL_120_PL },
         { "130%",          OPTION_VAL_130_PL },
         { "140%",          OPTION_VAL_140_PL },
         { "150%",          OPTION_VAL_150_PL },
         { "160%",          OPTION_VAL_160_PL },
         { "170%",          OPTION_VAL_170_PL },
         { "180%",          OPTION_VAL_180_PL },
         { "190%",          OPTION_VAL_190_PL },
         { "200%",          OPTION_VAL_200_PL },
         { "210%",          OPTION_VAL_210_PL },
         { "220%",          OPTION_VAL_220_PL },
         { "230%",          OPTION_VAL_230_PL },
         { "240%",          OPTION_VAL_240_PL },
         { "250%",          OPTION_VAL_250_PL },
         { "260%",          OPTION_VAL_260_PL },
         { "270%",          OPTION_VAL_270_PL },
         { "280%",          OPTION_VAL_280_PL },
         { "290%",          OPTION_VAL_290_PL },
         { "300%",          OPTION_VAL_300_PL },
         { "310%",          OPTION_VAL_310_PL },
         { "320%",          OPTION_VAL_320_PL },
         { "330%",          OPTION_VAL_330_PL },
         { "340%",          OPTION_VAL_340_PL },
         { "350%",          OPTION_VAL_350_PL },
         { "360%",          OPTION_VAL_360_PL },
         { "370%",          OPTION_VAL_370_PL },
         { "380%",          OPTION_VAL_380_PL },
         { "390%",          OPTION_VAL_390_PL },
         { "400%",          OPTION_VAL_400_PL },
         { "410%",          OPTION_VAL_410_PL },
         { "420%",          OPTION_VAL_420_PL },
         { "430%",          OPTION_VAL_430_PL },
         { "440%",          OPTION_VAL_440_PL },
         { "450%",          OPTION_VAL_450_PL },
         { "460%",          OPTION_VAL_460_PL },
         { "470%",          OPTION_VAL_470_PL },
         { "480%",          OPTION_VAL_480_PL },
         { "490%",          OPTION_VAL_490_PL },
         { "500%",          OPTION_VAL_500_PL },
         { "510%",          OPTION_VAL_510_PL },
         { "520%",          OPTION_VAL_520_PL },
         { "530%",          OPTION_VAL_530_PL },
         { "540%",          OPTION_VAL_540_PL },
         { "550%",          OPTION_VAL_550_PL },
         { "560%",          OPTION_VAL_560_PL },
         { "570%",          OPTION_VAL_570_PL },
         { "580%",          OPTION_VAL_580_PL },
         { "590%",          OPTION_VAL_590_PL },
         { "600%",          OPTION_VAL_600_PL },
         { "610%",          OPTION_VAL_610_PL },
         { "620%",          OPTION_VAL_620_PL },
         { "630%",          OPTION_VAL_630_PL },
         { "640%",          OPTION_VAL_640_PL },
         { "650%",          OPTION_VAL_650_PL },
         { "660%",          OPTION_VAL_660_PL },
         { "670%",          OPTION_VAL_670_PL },
         { "680%",          OPTION_VAL_680_PL },
         { "690%",          OPTION_VAL_690_PL },
         { "700%",          OPTION_VAL_700_PL },
         { "710%",          OPTION_VAL_710_PL },
         { "720%",          OPTION_VAL_720_PL },
         { "730%",          OPTION_VAL_730_PL },
         { "740%",          OPTION_VAL_740_PL },
         { "750%",          OPTION_VAL_750_PL },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_PL,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_PL,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_PL,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_PL,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_PL,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_PL,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_PL },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_PL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_PL,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_PL,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_PL },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_PL },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_PL },
#endif
         { "software",    OPTION_VAL_SOFTWARE_PL },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_PL,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_PL,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_PL,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_PL,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_PL },
         { "execute",  OPTION_VAL_EXECUTE_PL },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_PL },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_PL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_PL,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_PL,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_PL },
         { "dma",  OPTION_VAL_DMA_PL },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_PL,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_PL,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_PL,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_PL,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_PL },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_PL },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_PL },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_PL,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_PL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_PL,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_PL,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_PL },
         { "static",  OPTION_VAL_STATIC_PL },
         { "smart", OPTION_VAL_SMART_PL },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_PL,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_PL,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_PL },
         { "2px",      OPTION_VAL_2PX_PL },
         { "3px",      OPTION_VAL_3PX_PL },
         { "4px",      OPTION_VAL_4PX_PL },
         { "5px",      OPTION_VAL_5PX_PL },
         { "6px",      OPTION_VAL_6PX_PL },
         { "7px",      OPTION_VAL_7PX_PL },
         { "8px",      OPTION_VAL_8PX_PL },
         { "9px",      OPTION_VAL_9PX_PL },
         { "10px",     OPTION_VAL_10PX_PL },
         { "11px",     OPTION_VAL_11PX_PL },
         { "12px",     OPTION_VAL_12PX_PL },
         { "13px",     OPTION_VAL_13PX_PL },
         { "14px",     OPTION_VAL_14PX_PL },
         { "15px",     OPTION_VAL_15PX_PL },
         { "16px",     OPTION_VAL_16PX_PL },
         { "17px",     OPTION_VAL_17PX_PL },
         { "18px",     OPTION_VAL_18PX_PL },
         { "19px",     OPTION_VAL_19PX_PL },
         { "20px",     OPTION_VAL_20PX_PL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_PL,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_PL,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_PL },
         { "-11px",    OPTION_VAL_11PX_O55_PL },
         { "-10px",    OPTION_VAL_10PX_O55_PL },
         { "-9px",     OPTION_VAL_9PX_O55_PL },
         { "-8px",     OPTION_VAL_8PX_O55_PL },
         { "-7px",     OPTION_VAL_7PX_O55_PL },
         { "-6px",     OPTION_VAL_6PX_O55_PL },
         { "-5px",     OPTION_VAL_5PX_O55_PL },
         { "-4px",     OPTION_VAL_4PX_O55_PL },
         { "-3px",     OPTION_VAL_3PX_O55_PL },
         { "-2px",     OPTION_VAL_2PX_O55_PL },
         { "-1px",     OPTION_VAL_1PX_O55_PL },
         { "disabled", OPTION_VAL_DISABLED_O55_PL },
         { "+1px",     OPTION_VAL_1PX_O55_0_PL },
         { "+2px",     OPTION_VAL_2PX_O55_0_PL },
         { "+3px",     OPTION_VAL_3PX_O55_0_PL },
         { "+4px",     OPTION_VAL_4PX_O55_0_PL },
         { "+5px",     OPTION_VAL_5PX_O55_0_PL },
         { "+6px",     OPTION_VAL_6PX_O55_0_PL },
         { "+7px",     OPTION_VAL_7PX_O55_0_PL },
         { "+8px",     OPTION_VAL_8PX_O55_0_PL },
         { "+9px",     OPTION_VAL_9PX_O55_0_PL },
         { "+10px",    OPTION_VAL_10PX_O55_0_PL },
         { "+11px",    OPTION_VAL_11PX_O55_0_PL },
         { "+12px",    OPTION_VAL_12PX_O55_0_PL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_PL,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_PL,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_PL },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_PL,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_PL,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_PL },
         { "2x",         OPTION_VAL_2X_PL },
         { "4x",         OPTION_VAL_4X_PL },
         { "8x",         OPTION_VAL_8X_PL },
         { "16x",        OPTION_VAL_16X_PL },
         { "32x",        OPTION_VAL_32X_PL },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_PL,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_PL,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_PL },
         { "uncorrected", OPTION_VAL_UNCORRECTED_PL },
         { "4:3",  OPTION_VAL_4_3_PL },
         { "ntsc", OPTION_VAL_NTSC_PL },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_PL,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_PL,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_PL,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_PL,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_PL },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_PL,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_PL,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_PL,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_PL,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_PL },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_PL,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_PL,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_PL },
         { "async",    OPTION_VAL_ASYNC_PL },
         { "precache", OPTION_VAL_PRECACHE_PL },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_PL,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_PL,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_PL },
         { "4x",          OPTION_VAL_4X_PL },
         { "6x",          OPTION_VAL_6X_PL },
         { "8x",          OPTION_VAL_8X_PL },
         { "10x",         OPTION_VAL_10X_PL },
         { "12x",         OPTION_VAL_12X_PL },
         { "14x",         OPTION_VAL_14X_PL },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_pl = {
   option_cats_pl,
   option_defs_pl
};

/* RETRO_LANGUAGE_PT_BR */

#define CATEGORY_VIDEO_LABEL_PT_BR "Vídeo"
#define CATEGORY_VIDEO_INFO_0_PT_BR "Altera a proporção da tela, o corte, o filtro de vídeo e as configurações do salto de quadros."
#define CATEGORY_OSD_LABEL_PT_BR "Notificações na tela"
#define CATEGORY_OSD_INFO_0_PT_BR "Seleciona as notificações sendo exibidas na tela."
#define CATEGORY_INPUT_LABEL_PT_BR "Entrada"
#define CATEGORY_INPUT_INFO_0_PT_BR "Altera as configurações das pistolas de luz, do mouse e o neGcon."
#define CATEGORY_MEMCARDS_LABEL_PT_BR "Cartão de memória"
#define CATEGORY_MEMCARDS_INFO_0_PT_BR "Altera as configurações dos cartões de memoria usados pelo sistema."
#define CATEGORY_PGXP_LABEL_PT_BR "PGXP (Canal de Transformação de Geometria de Precisão)"
#define CATEGORY_PGXP_INFO_0_PT_BR "Estas opções controlam aprimoramentos que podem melhorar os gráficos em comparação com o console original. O PGXP pode se livrar de texturas deformadas e problemas de polígonos no eixo Z."
#define CATEGORY_HACKS_LABEL_PT_BR "Hacks de emulação"
#define CATEGORY_HACKS_INFO_0_PT_BR "Seleciona as configurações de precisão do overclock e da emulação do processador que afetam o baixo desempenho e a compatibilidade."
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_PT_BR "Resolução interna da GPU"
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_PT_BR "Seleciona o multiplicador de resolução interno. Qualquer resolução maior do que '1x (nativa)' irá melhor a fidelidade dos modelos 3D ao custo de maiores exigências de desempenho. Os elementos 2D geralmente não são afetados."
#define OPTION_VAL_1X_NATIVE_PT_BR "1x (nativa)"
#define OPTION_VAL_2X_PT_BR NULL
#define OPTION_VAL_4X_PT_BR NULL
#define OPTION_VAL_8X_PT_BR NULL
#define OPTION_VAL_16X_PT_BR NULL
#define BEETLE_OPT_DEPTH_LABEL_PT_BR "Profundidade de cor interna"
#define BEETLE_OPT_DEPTH_INFO_0_PT_BR "Seleciona a profundidade interna da cor. Uma maior profundidade de cor pode reduzir os efeitos de gradientes da cor sem o uso de pontilhamento. 16 bpp emula o hardware original, mas terá um efeito de gradiente da cor se o pontilhamento não for ativado. Recomenda-se desativar o 'Pontilhamento' quando esta opção estiver configurada para 32 bpp."
#define OPTION_VAL_16BPP_NATIVE_PT_BR "16 bpp (nativo)"
#define OPTION_VAL_32BPP_PT_BR NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_PT_BR "Pontilhamento"
#define BEETLE_OPT_DITHER_MODE_INFO_0_PT_BR "Seleciona a configuração do pontilhamento. \"1x (nativa)\" simula o pontilhamento nativo em baixa resolução usado pelo hardware original para suavizar os efeitos da faixa de gradientes na profundidade da cor nativa. 'Resolução interna' redimensiona o pontilhamento à resolução interna configurada para produzir um resultado mais limpo. É recomendável desativar esta opção quando se utiliza 32 bpp de profundidade de cor. Nota: A ativação desta opção no Vulkan desativará a redução da cor até a profundidade nativa e permitirá uma maior profundidade interna."
#define OPTION_VAL_INTERNAL_RESOLUTION_PT_BR "Resolução interna"
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_PT_BR "Deslocamento UV da textura"
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_PT_BR "Amostra de texturas para polígonos 3D em um deslocamento para uma resolução interna superior a 1x. Reduz as emendas de textura, mas pode causar falhas gráficas não intencionais."
#define BEETLE_OPT_FILTER_LABEL_PT_BR "Filtragem de textura"
#define BEETLE_OPT_FILTER_INFO_0_PT_BR "Seleciona o método de filtragem de textura. O 'Mais próximo' emula o hardware original. Os filtros \"Bilinear\" e \"3 pontos\" são filtros suavizantes, que reduzem a pixelização por embaçamento. Os filtros 'SABR', 'xBR', e 'JINC2' são filtros de ampliação que podem melhorar a fidelidade/ruído da textura às custas do aumento dos requisitos de desempenho. Somente suportado por renderizadores de hardware."
#define OPTION_VAL_NEAREST_PT_BR "Mais próximo"
#define OPTION_VAL_SABR_PT_BR NULL
#define OPTION_VAL_XBR_PT_BR NULL
#define OPTION_VAL_BILINEAR_PT_BR NULL
#define OPTION_VAL_3_POINT_PT_BR "3 pontos"
#define OPTION_VAL_JINC2_PT_BR NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_PT_BR "Excluir sprites da filtragem"
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_PT_BR "Não aplicará filtragem de textura aos sprites. Previne costuras em vários jogos com fundo 2D renderizado com sprite. Use junto com a Suavização adaptativa ou outro filtro de pós-processamento para obter o melhor efeito."
#define OPTION_VAL_OPAQUE_PT_BR "Apenas sprites opacos"
#define OPTION_VAL_ALL_PT_BR "Sprites opacos e semitransparente"
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_PT_BR "Excluir polígonos 2D da filtragem"
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_PT_BR "Não aplicará filtragem de textura a polígonos 2D. Os polígonos 2D são detectados com uma heurística e pode haver falhas. Use junto com a Suavização adaptativa ou outro filtro de pós-processamento para obter o melhor efeito."
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_PT_BR "Suavização adaptativa"
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_PT_BR "Suaviza os gráficos e elementos 2D da interface sem embaçar os objetos renderizados em 3D. Somente suportado pelo renderizador Vulkan."
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_PT_BR "Superamostragem (redução para resolução nativa)"
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_PT_BR "Reduz o conteúdo renderizado de uma resolução interna superior a nativa. Ao combinar isso com multiplicadores de aumento de resolução interna permite que os jogos sejam exibidos com objetos 3D suavizados em baixa resolução nativa. Produz melhores resultados quando aplicado a títulos que misturam elementos 2D e 3D (por exemplo, personagens 3D em fundos pré-renderizados), e funciona bem em conjunto com shaders CRT. Somente suportado pelo renderizador Vulkan. Nota: É recomendado desativar o 'Pontilhamento' quando esta opção estiver ativada."
#define BEETLE_OPT_MSAA_LABEL_PT_BR "Anti-serrilhado MSAA"
#define BEETLE_OPT_MSAA_INFO_0_PT_BR "Seleciona o nível do MSAA para o conteúdo renderizado. Melhora a aparência de objetos 3D. Somente suportado pelo renderizador Vulkan."
#define OPTION_VAL_1X_PT_BR NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_PT_BR "Filtro cromático YUV para MDEC"
#define BEETLE_OPT_MDEC_YUV_INFO_0_PT_BR "Melhora a qualidade da reprodução de FMV, reduzindo os artefatos dos 'macroblocos' (quadrados e arestas recortadas). Somente suportado pelo renderizador Vulkan."
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_PT_BR "Rastreio de texturas"
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_PT_BR "Pré-requisito para o despejo e substituição da textura.  Provavelmente, irá falhar na maioria dos jogos."
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_PT_BR "Despejo de texturas"
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_PT_BR "Despeja as texturas usadas par <cd>-texture-dump/"
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_PT_BR "Substituir texturas"
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_PT_BR "Substitui as texturas usando versões HD de <cd>-texture-replacements/"
#define BEETLE_OPT_WIREFRAME_LABEL_PT_BR "Modo de malhas (depuração)"
#define BEETLE_OPT_WIREFRAME_INFO_0_PT_BR "Renderiza os modelos 3D em forma de contorno sem texturas ou sombreamento. Somente suportado pelo renderizador de hardware OpenGL. Nota: Isto é para fins de depuração, e normalmente deve ser desativado."
#define BEETLE_OPT_FRAME_DUPING_LABEL_PT_BR "Duplicidade de quadros (maior velocidade)"
#define BEETLE_OPT_FRAME_DUPING_INFO_0_PT_BR "Quando ativado e suportado pela interface libretro, proporciona um pequeno aumento de desempenho ao direcionar a interface para repetir o quadro anterior se o núcleo não tiver nada de novo para exibir."
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_PT_BR "Exibir FPS interno"
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_PT_BR "Exibir a taxa de quadros internos na qual o sistema PlayStation emulado está renderizando o conteúdo. Nota: Requer que as notificações na tela sejam habilitadas na interface libretro."
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_PT_BR "Exibir a VRAM completa (depuração)"
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_PT_BR "Visualiza toda a VRAM do console emulado. Somente suportada pelos renderizadores de hardware OpenGL e Vulkan. Nota: Isto é para fins de depuração, e normalmente deve estar desativado."
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_PT_BR "Auto-calibração do analógico"
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_PT_BR "Quando o dispositivo de entrada é ajustado para DualShock, Controle analógico, Joystick analógico ou neGcon, esta opção permite a calibração dinâmica das entradas analógicas. Os valores máximos de entrada registrados são monitorados em tempo real e usados para escalar as coordenadas analógicas passadas para o emulador. Isto deve ser usado para jogos como o Mega Man Legends 2 que esperam valores maiores do que o que os controladores modernos fornecem. Para melhores resultados, os direcionais analógicos devem ser girados em toda a extensão para calibrar o algoritmo cada vez que o conteúdo é carregado."
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_PT_BR "Alternador de modo analógico do DualShock"
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_PT_BR "Quando o tipo de dispositivo de entrada for DualShock, esta opção permite que o DualShock emulado pode alternar entre os modos digital e analógico, como faz o hardware original. A desativação desta opção bloqueará o DualShock no modo analógico e permitirá que o DualShock mude entre os modos digital e analógico, mantendo a combinação START+SELECT+L1+L2+R1+R2 pressionada."
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_PT_BR "Porta 1: Ativar Multitap"
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_PT_BR "Ativa o sistema Multitap na porta 1."
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_PT_BR "Porta 2: Ativar Multitap"
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_PT_BR "Ativa o sistema Multitap na porta 2."
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_PT_BR "Modo de entrada de pistolas de luz"
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_PT_BR "Seleciona se deve usar uma 'Pistola de luz' controlada pelo mouse ou uma entrada de 'Tela sensível ao toque' quando o tipo de dispositivo estiver definido como 'Guncon / G-Con 45' ou 'Justifier'."
#define OPTION_VAL_LIGHTGUN_PT_BR "Pistola de luz"
#define OPTION_VAL_TOUCHSCREEN_PT_BR "Tela sensível ao toque"
#define BEETLE_OPT_GUN_CURSOR_LABEL_PT_BR "Cursor da arma"
#define BEETLE_OPT_GUN_CURSOR_INFO_0_PT_BR "Seleciona o cursor da arma a ser exibido na tela enquanto usa os tipos de dispositivos de entrada 'Guncon/G-Con 45' e 'Justifier'. Quando desativado, as miras estarão sempre escondidas."
#define OPTION_VAL_CROSS_PT_BR "Cruz"
#define OPTION_VAL_DOT_PT_BR "Ponto"
#define OPTION_VAL_OFF_PT_BR "Sem cursor"
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_PT_BR "Porta 1: Cor da mira da pistola"
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_PT_BR "Seleciona a cor da mira da pistola de luz conectada na porta 1."
#define OPTION_VAL_RED_PT_BR "Vermelha"
#define OPTION_VAL_BLUE_PT_BR "Azul"
#define OPTION_VAL_GREEN_PT_BR "Verde"
#define OPTION_VAL_ORANGE_PT_BR "Laranja"
#define OPTION_VAL_YELLOW_PT_BR "Amarela"
#define OPTION_VAL_CYAN_PT_BR "Azul-marinho"
#define OPTION_VAL_PINK_PT_BR "Rosa"
#define OPTION_VAL_PURPLE_PT_BR "Violeta"
#define OPTION_VAL_BLACK_PT_BR "Preta"
#define OPTION_VAL_WHITE_PT_BR "Branca"
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_PT_BR "Porta 2: Cor da mira da pistola"
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_PT_BR "Seleciona a cor da mira da pistola de luz conectada na porta 2."
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_PT_BR "Sensibilidade do mouse"
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_PT_BR "Seleciona a capacidade de resposta do tipo de dispositivo de entrada 'Mouse'."
#define OPTION_VAL_5_PT_BR NULL
#define OPTION_VAL_10_PT_BR NULL
#define OPTION_VAL_15_PT_BR NULL
#define OPTION_VAL_20_PT_BR NULL
#define OPTION_VAL_25_PT_BR NULL
#define OPTION_VAL_30_PT_BR NULL
#define OPTION_VAL_35_PT_BR NULL
#define OPTION_VAL_40_PT_BR NULL
#define OPTION_VAL_45_PT_BR NULL
#define OPTION_VAL_50_PT_BR NULL
#define OPTION_VAL_55_PT_BR NULL
#define OPTION_VAL_60_PT_BR NULL
#define OPTION_VAL_65_PT_BR NULL
#define OPTION_VAL_70_PT_BR NULL
#define OPTION_VAL_75_PT_BR NULL
#define OPTION_VAL_80_PT_BR NULL
#define OPTION_VAL_85_PT_BR NULL
#define OPTION_VAL_90_PT_BR NULL
#define OPTION_VAL_95_PT_BR NULL
#define OPTION_VAL_100_PT_BR "100% (padrão)"
#define OPTION_VAL_105_PT_BR NULL
#define OPTION_VAL_110_PT_BR NULL
#define OPTION_VAL_115_PT_BR NULL
#define OPTION_VAL_120_PT_BR NULL
#define OPTION_VAL_125_PT_BR NULL
#define OPTION_VAL_130_PT_BR NULL
#define OPTION_VAL_135_PT_BR NULL
#define OPTION_VAL_140_PT_BR NULL
#define OPTION_VAL_145_PT_BR NULL
#define OPTION_VAL_150_PT_BR NULL
#define OPTION_VAL_155_PT_BR NULL
#define OPTION_VAL_160_PT_BR NULL
#define OPTION_VAL_165_PT_BR NULL
#define OPTION_VAL_170_PT_BR NULL
#define OPTION_VAL_175_PT_BR NULL
#define OPTION_VAL_180_PT_BR NULL
#define OPTION_VAL_185_PT_BR NULL
#define OPTION_VAL_190_PT_BR NULL
#define OPTION_VAL_195_PT_BR NULL
#define OPTION_VAL_200_PT_BR NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_PT_BR "Resposta ao torcer o neGcon"
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_PT_BR "Seleciona o tipo de resposta do direcional analógico esquerdo do RetroPad ao simular a ação de torcer um dispositivo de entrada neGcon emulado. O deslocamento do direcional analógico pode ser mapeado para a rotação do neGcon de forma linear, quadrática ou cúbica. 'Quadrático' dá uma precisão maior do que 'Linear' em movimentos mais sutis. 'Cúbico' aumenta a precisão de movimentos mais sutis, mas exagera os mais longos. Nota: 'Linear' é recomendado somente para uso com periféricos do tipo volante de corrida. Os controles convencionais manipulam a entrada analógica de uma maneira muito diferente do mecanismo de rotação do neGcon, de modo que a atribuição linear amplifica os movimentos sutis, o que afeta o controle preciso. Na maioria dos casos, a opção 'Quadrático' produz a melhor aproximação possível ao hardware real."
#define OPTION_VAL_LINEAR_PT_BR NULL
#define OPTION_VAL_QUADRATIC_PT_BR "Quadrático"
#define OPTION_VAL_CUBIC_PT_BR "Cúbico"
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_PT_BR "Zona morta ao torcer o NegCon"
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_PT_BR "Seleciona a zona morta do direcional analógico esquerdo do RetroPad ao simular a ação de 'torção' do dispositivo de entrada 'neGcon' emulado. Serve para evitar que o controle registre movimentos não realizados. Nota: A maioria dos títulos compatíveis com neGcon fornecem opções dentro do jogo para definir um valor de zona morta para a 'torção'. Para evitar perda de precisão, a zona morta dentro do jogo deve *sempre* ser definida como zero. Quaisquer ajustes necessários *somente* devem ser aplicados através desta opção central. Isto é particularmente importante quando a 'Resposta ao torcer o neGcon' for definida como 'Quadrática' ou 'Cúbica'."
#define OPTION_VAL_0_PT_BR NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_PT_BR "Método do cartão de memória 0 (requer reinício)"
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_PT_BR "Escolha o formato dos dados salvos usado no cartão de memória 0. A opção 'Mednafen' pode ser usada para a compatibilidade com a versão autônoma do Mednafen. Ao usar os arquivos salvos com o Beetle PSX, os arquivos do Libretro (.srm) e Mednafen (.mcr) são internamente idênticos e podem ser convertidos entre si por meio de renomeação."
#define OPTION_VAL_LIBRETRO_PT_BR NULL
#define OPTION_VAL_MEDNAFEN_PT_BR NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_PT_BR "Ativa o cartão de memória 1 (requer reinício)"
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_PT_BR "Emula um segundo cartão de memória no compartimento 1. Quando desativado, os jogos só podem acessar o cartão de memória no compartimento 0. Nota: Alguns jogos requerem que esta opção seja desativada para o funcionamento correto (ex: Codename Tenka). Nota: O cartão de memória 1 usa o formato de salvamento Mednafen (.mcr)."
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_PT_BR "Compartilhar cartões de memória (requer reinício)"
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_PT_BR "Quando ativado, todos os jogos salvarão e carregarão pelos mesmos arquivos de cartão de memória. Quando desativado, arquivos de cartão de memória separado serão gerados para cada item de conteúdo carregado. Nota: Se o 'Método do cartão de memória 0' estiver definido como 'Libretro', esta opção só afetará o cartão de memória no compartimento 1."
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_PT_BR "Índice do cartão de memória esquerdo"
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_PT_BR "Seleciona o cartão de memória atualmente carregado no compartimento esquerdo. Esta opção só funcionará se o 'Método do cartão de memória 0' estiver definido para 'Mednafen'. O cartão de memória padrão é o índice 0."
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_PT_BR "Índice do cartão de memória direito"
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_PT_BR "Muda o cartão de memória atualmente carregado no compartimento direito. Esta opção só funcionará se o cartão de memória 1 estiver ativado. O cartão de memória padrão é o índice 1."
#define OPTION_VAL_1_PT_BR "1 (padrão)"
#define BEETLE_OPT_PGXP_MODE_LABEL_PT_BR "Modo de operação do PGXP"
#define BEETLE_OPT_PGXP_MODE_INFO_0_PT_BR "Renderiza objetos 3D com precisão de subpixel, usando coordenadas de vértices de ponto fixo para minimizar a distorção e o jitter em objetos 3D que o hardware original tinha. O modo 'Apenas memória' praticamente não dá problemas de compatibilidade e é recomendado para uso geral. o modo 'Memória + CPU (instável)' pode reduzir ainda mais o jitter, mas tem requisitos de desempenho elevados e pode levar a falhas de geometria."
#define OPTION_VAL_MEMORY_ONLY_PT_BR "Apenas memória"
#define OPTION_VAL_MEMORY_CPU_PT_BR "Memória + CPU (instável)"
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_PT_BR "Tolerância à geometria 2D do PGXP"
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_PT_BR "Oculta erros mais evidentes nas operações do PGXP: este valor especifica a tolerância em que os valores do PGXP serão mantidos no caso de geometrias sem informações de profundidade adequadas."
#define OPTION_VAL_0PX_PT_BR NULL
#define OPTION_VAL_1PX_PT_BR NULL
#define OPTION_VAL_2PX_PT_BR NULL
#define OPTION_VAL_3PX_PT_BR NULL
#define OPTION_VAL_4PX_PT_BR NULL
#define OPTION_VAL_5PX_PT_BR NULL
#define OPTION_VAL_6PX_PT_BR NULL
#define OPTION_VAL_7PX_PT_BR NULL
#define OPTION_VAL_8PX_PT_BR NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_PT_BR "Seleção de primitivos do PGXP"
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_PT_BR "Usa a implementação de NCLIP do PGXP. Melhora a aparência visual ao preencher os furos nas geometrias que tenham coordenadas PGXP. Provoca colisões em certos jogos e circunstâncias."
#define BEETLE_OPT_PGXP_VERTEX_LABEL_PT_BR "Cache de vértice do PGXP"
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_PT_BR "Faz o cache das posições de vértices melhoradas pelo PGXP para reutilização ao desenhar polígonos. Pode melhorar o alinhamento dos objetos e reduzir bordas, mas os falsos positivos ao usar o cache podem produzir defeitos visuais. Atualmente é recomendado desativar esta opção. Só se aplicará quando o modo de operação PGXP estiver ativado. Funciona somente com renderizadores de hardware."
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_PT_BR "Textura fiel à perspectiva do PGXP"
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_PT_BR "Substitui o mapeamento de textura afim nativo de PSX pelo mapeamento de textura fiel à perspectiva. Elimina distorções posicionais e deformações de textura, produzindo texturas corretamente alinhadas. Somente se aplicará quando o 'Modo de operação do PGXP' estiver ativado. Funciona somente com renderizadores de hardware."
#define BEETLE_OPT_LINE_RENDER_LABEL_PT_BR "Hack para o efeito 'Line-to-Quad'"
#define BEETLE_OPT_LINE_RENDER_INFO_0_PT_BR "Selecione o método de execução do hack para converter linhas em retângulos. Certos jogos (Doom, Hexen, Soul Blade, etc.) desenham linhas horizontais esticando triângulos de um pixel de altura através da tela, que são então rasterizados como uma fileira de pixels no hardware original. Este hack detecta esses triângulos e os converte em retângulos conforme necessário, permitindo que sejam exibidos corretamente em renderizadores de hardware e em resoluções internas superiores às nativas. A opção 'Agressivo' é necessária em certos títulos (ex: Dark Forces, Duke Nukem), mas pode produzir defeitos visuais em outros. Em caso de dúvida, selecione 'Padrão'."
#define OPTION_VAL_DEFAULT_PT_BR "Padrão"
#define OPTION_VAL_AGGRESSIVE_PT_BR "Agressivo"
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_PT_BR "Hack de modificação de widescreen"
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_PT_BR "Renderiza o conteúdo 3D em formato anamórfico e torna o quadro de buffer emulado em uma proporção de tela widescreen. Produz os melhores resultados com jogos feitos inteiramente em 3D. Os elementos 2D serão esticados horizontalmente e não poderão mais ser alinhados."
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_PT_BR "Proporção da tela do hack de modificação de widescreen"
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_PT_BR "Seleciona a proporção de tela a ser usada pelo hack de modificação de widescreen."
#define OPTION_VAL_16_9_PT_BR NULL
#define OPTION_VAL_16_10_PT_BR NULL
#define OPTION_VAL_18_9_PT_BR NULL
#define OPTION_VAL_19_9_PT_BR NULL
#define OPTION_VAL_20_9_PT_BR NULL
#define OPTION_VAL_21_9_PT_BR NULL
#define OPTION_VAL_32_9_PT_BR NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_PT_BR "Escala de frequência da CPU (overclock)"
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_PT_BR "Aumenta (ou diminui) a velocidade do relógio emulado da CPU do PSX. Uma maior velocidade pode eliminar lentidão e melhorar as taxas de quadros em certos jogos, ao custo de maiores exigências de desempenho. Note que certos jogos incluem um limitador de quadro interno e não obterão nenhum benefício com o aumento da velocidade. Pode ocasionar de certos efeitos ficarem mais rápidos do que o normal em certos jogos."
#define OPTION_VAL_100_NATIVE_PT_BR "100% (Nativo)"
#define OPTION_VAL_210_PT_BR NULL
#define OPTION_VAL_220_PT_BR NULL
#define OPTION_VAL_230_PT_BR NULL
#define OPTION_VAL_240_PT_BR NULL
#define OPTION_VAL_250_PT_BR NULL
#define OPTION_VAL_260_PT_BR NULL
#define OPTION_VAL_270_PT_BR NULL
#define OPTION_VAL_280_PT_BR NULL
#define OPTION_VAL_290_PT_BR NULL
#define OPTION_VAL_300_PT_BR NULL
#define OPTION_VAL_310_PT_BR NULL
#define OPTION_VAL_320_PT_BR NULL
#define OPTION_VAL_330_PT_BR NULL
#define OPTION_VAL_340_PT_BR NULL
#define OPTION_VAL_350_PT_BR NULL
#define OPTION_VAL_360_PT_BR NULL
#define OPTION_VAL_370_PT_BR NULL
#define OPTION_VAL_380_PT_BR NULL
#define OPTION_VAL_390_PT_BR NULL
#define OPTION_VAL_400_PT_BR NULL
#define OPTION_VAL_410_PT_BR NULL
#define OPTION_VAL_420_PT_BR NULL
#define OPTION_VAL_430_PT_BR NULL
#define OPTION_VAL_440_PT_BR NULL
#define OPTION_VAL_450_PT_BR NULL
#define OPTION_VAL_460_PT_BR NULL
#define OPTION_VAL_470_PT_BR NULL
#define OPTION_VAL_480_PT_BR NULL
#define OPTION_VAL_490_PT_BR NULL
#define OPTION_VAL_500_PT_BR NULL
#define OPTION_VAL_510_PT_BR NULL
#define OPTION_VAL_520_PT_BR NULL
#define OPTION_VAL_530_PT_BR NULL
#define OPTION_VAL_540_PT_BR NULL
#define OPTION_VAL_550_PT_BR NULL
#define OPTION_VAL_560_PT_BR NULL
#define OPTION_VAL_570_PT_BR NULL
#define OPTION_VAL_580_PT_BR NULL
#define OPTION_VAL_590_PT_BR NULL
#define OPTION_VAL_600_PT_BR NULL
#define OPTION_VAL_610_PT_BR NULL
#define OPTION_VAL_620_PT_BR NULL
#define OPTION_VAL_630_PT_BR NULL
#define OPTION_VAL_640_PT_BR NULL
#define OPTION_VAL_650_PT_BR NULL
#define OPTION_VAL_660_PT_BR NULL
#define OPTION_VAL_670_PT_BR NULL
#define OPTION_VAL_680_PT_BR NULL
#define OPTION_VAL_690_PT_BR NULL
#define OPTION_VAL_700_PT_BR NULL
#define OPTION_VAL_710_PT_BR NULL
#define OPTION_VAL_720_PT_BR NULL
#define OPTION_VAL_730_PT_BR NULL
#define OPTION_VAL_740_PT_BR NULL
#define OPTION_VAL_750_PT_BR NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_PT_BR "Overclock do GTE"
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_PT_BR "Reduz todas as operações do GTE (coprocessador da CPU para gráficos 3D) emuladas a uma latência constante de um ciclo. Para jogos que fazem uso pesado do GTE, isto pode melhorar muito a taxa de quadros e a estabilidade do tempo de quadros."
#define BEETLE_OPT_SKIP_BIOS_LABEL_PT_BR "Pular BIOS"
#define BEETLE_OPT_SKIP_BIOS_INFO_0_PT_BR "Omite a animação de inicialização da BIOS do PlayStation normalmente exibida ao carregar um conteúdo. Nota: Ativar isso causa problemas de compatibilidade com vários jogos (jogos PAL com proteção anticópia, Saga Frontier, etc.)."
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_PT_BR "Substituir BIOS (requer reinício)"
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_PT_BR "Substitui a BIOS padrão específica da região por uma BIOS sem região, caso seja encontrada."
#define OPTION_VAL_PSXONPSP_PT_BR "BIOS de PS1 de PSP"
#define OPTION_VAL_PS1_ROM_PT_BR "BIOS de PS1 de PS3"
#define BEETLE_OPT_RENDERER_LABEL_PT_BR "Renderizador (requer reinício)"
#define BEETLE_OPT_RENDERER_INFO_0_PT_BR "O renderizador de software é o mais preciso, mas suas exigências são muito altas quando executado com uma resolução interna mais alta do que a GPU. Os renderizadores de hardware são menos precisos, mas têm melhor desempenho ao utilizar resoluções internas mais altas e permitem várias melhorias gráficas. 'Hardware (Automático)' selecionará automaticamente o renderizador Vulkan ou OpenGL com base no driver de vídeo atual da interface do libretro. Se o driver não suportar Vulkan ou OpenGL 3.3, o renderizador por software será usado pelo núcleo."
#define OPTION_VAL_HARDWARE_PT_BR "Hardware (Automático)"
#define OPTION_VAL_HARDWARE_GL_PT_BR NULL
#define OPTION_VAL_HARDWARE_VK_PT_BR NULL
#define OPTION_VAL_SOFTWARE_PT_BR NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_PT_BR "Quadro de buffer por software"
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_PT_BR "Permite emular com precisão os efeitos de quadro de buffer (por exemplo, desfoque de movimento, espiral de batalha FF7) ao usar renderizadores de hardware, executando uma cópia do renderizador de software com resolução nativa em segundo plano. A desativação desta opção irá omitir estas operações (OpenGL) ou serão renderizadas na GPU (Vulkan). A desativação desta opção pode melhorar o desempenho ao custo de erros gráficos graves. Em caso de dúvida, deixe esta opção ativada."
#define BEETLE_OPT_CPU_DYNAREC_LABEL_PT_BR "Dynarec de CPU"
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_PT_BR "Recompilar dinamicamente as instruções da CPU para instruções nativas. Muito mais rápido do que o intérprete, mas o tempo da CPU é menos preciso e pode ter erros."
#define OPTION_VAL_DISABLED_PT_BR "Desativada (interpretor de Beetle)"
#define OPTION_VAL_EXECUTE_PT_BR "Máximo desempenho"
#define OPTION_VAL_EXECUTE_ONE_PT_BR "Verificação de intervalo entre ciclos"
#define OPTION_VAL_RUN_INTERPRETER_PT_BR "Interpretador Lightrec"
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_PT_BR "Invalidação de código do dynarec"
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_PT_BR "Alguns jogos requerem invalidação 'Completa', alguns requerem 'Apenas DMA'."
#define OPTION_VAL_FULL_PT_BR "Completa"
#define OPTION_VAL_DMA_PT_BR "Apenas DMA (um pouco mais rápido)"
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_PT_BR "Ciclos de eventos de DMA/GPU do dynarec"
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_PT_BR "Número máximo de ciclos executados pela CPU antes da verificar a DMA ou a GPU. Um valor mais alto será mais rápido. Tem menos impacto sobre o interpretador Beetle do que sobre o dynarec."
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_PT_BR "Tempos dos quadros reportado pelo núcleo"
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_PT_BR "Seleciona os tempos de quadros por segundos que o núcleo indicará para a interface. 'Permitir alternância automática' permite que o núcleo mude entre taxas progressivas e entrelaçadas, mas pode causar reinícios nos drivers de vídeo e no áudio da interface."
#define OPTION_VAL_FORCE_PROGRESSIVE_PT_BR "Taxa progressiva"
#define OPTION_VAL_FORCE_INTERLACED_PT_BR "Forçar taxa entrelaçada"
#define OPTION_VAL_AUTO_TOGGLE_PT_BR "Permitir alternância automática"
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_PT_BR "Substituir sincronia de vídeo PAL (europeu)"
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_PT_BR "Devido a diferentes padrões, os jogos PAL costumam parecer lentos em comparação com os lançamentos Americanos ou Japoneses NTSC. Esta opção pode ser usada para substituir a sincronia de vídeo PAL para tentar executar esses jogos com a taxa de quadros NTSC. Esta opção não tem efeito ao executar o conteúdo NTSC."
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_PT_BR "Cortar overscan"
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_PT_BR "'Nenhum' retém as bordas (colunas pretas em ambos os lados no caso de imagens NTSC, bordas nos quatro lados para imagens PAL) para simular as barras pretas produzidas pelo hardware real de PSX em um sinal de vídeo analógico. \"Estático\" simplesmente remove as bordas horizontais, enquanto 'Dinâmico' remove todas as bordas."
#define OPTION_VAL_DISABLED_O53_PT_BR "Nenhum"
#define OPTION_VAL_STATIC_PT_BR "Estático"
#define OPTION_VAL_SMART_PT_BR "Dinâmico (padrão)"
#define BEETLE_OPT_IMAGE_CROP_LABEL_PT_BR "Corte adicional"
#define BEETLE_OPT_IMAGE_CROP_INFO_0_PT_BR "Quando a opção 'Cortar overscan horizontal' estiver ativada, esta opção permite reduzir a largura da imagem cortada usando um valor específico em pixels."
#define OPTION_VAL_9PX_PT_BR NULL
#define OPTION_VAL_10PX_PT_BR NULL
#define OPTION_VAL_11PX_PT_BR NULL
#define OPTION_VAL_12PX_PT_BR NULL
#define OPTION_VAL_13PX_PT_BR NULL
#define OPTION_VAL_14PX_PT_BR NULL
#define OPTION_VAL_15PX_PT_BR NULL
#define OPTION_VAL_16PX_PT_BR NULL
#define OPTION_VAL_17PX_PT_BR NULL
#define OPTION_VAL_18PX_PT_BR NULL
#define OPTION_VAL_19PX_PT_BR NULL
#define OPTION_VAL_20PX_PT_BR NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_PT_BR "Deslocar imagem cortada"
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_PT_BR "Quando a opção \"Cortar overscan horizontal\" estiver ativada, isso permite que a imagem cortada seja deslocada horizontalmente para a direita (valores positivos) ou para a esquerda (valores negativos) usando um valor específico em pixels. Pode ser usado para corrigir problemas de alinhamento. Somente suportado pelo renderizador por software."
#define OPTION_VAL_12PX_O55_PT_BR NULL
#define OPTION_VAL_11PX_O55_PT_BR NULL
#define OPTION_VAL_10PX_O55_PT_BR NULL
#define OPTION_VAL_9PX_O55_PT_BR NULL
#define OPTION_VAL_8PX_O55_PT_BR NULL
#define OPTION_VAL_7PX_O55_PT_BR NULL
#define OPTION_VAL_6PX_O55_PT_BR NULL
#define OPTION_VAL_5PX_O55_PT_BR NULL
#define OPTION_VAL_4PX_O55_PT_BR NULL
#define OPTION_VAL_3PX_O55_PT_BR NULL
#define OPTION_VAL_2PX_O55_PT_BR NULL
#define OPTION_VAL_1PX_O55_PT_BR NULL
#define OPTION_VAL_DISABLED_O55_PT_BR "0 (padrão)"
#define OPTION_VAL_1PX_O55_0_PT_BR NULL
#define OPTION_VAL_2PX_O55_0_PT_BR NULL
#define OPTION_VAL_3PX_O55_0_PT_BR NULL
#define OPTION_VAL_4PX_O55_0_PT_BR NULL
#define OPTION_VAL_5PX_O55_0_PT_BR NULL
#define OPTION_VAL_6PX_O55_0_PT_BR NULL
#define OPTION_VAL_7PX_O55_0_PT_BR NULL
#define OPTION_VAL_8PX_O55_0_PT_BR NULL
#define OPTION_VAL_9PX_O55_0_PT_BR NULL
#define OPTION_VAL_10PX_O55_0_PT_BR NULL
#define OPTION_VAL_11PX_O55_0_PT_BR NULL
#define OPTION_VAL_12PX_O55_0_PT_BR NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_PT_BR "Deslocar imagem horizontal (ciclos de GPU)"
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_PT_BR "Seleciona o número de ciclos de GPU com os quais se deve deslocar a imagem. Valores positivos movem a imagem para a direita, valores negativos movem a imagem para a esquerda. Funciona somente com renderizadores de hardware."
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_PT_BR "Overclock do rasterizador da GPU"
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_PT_BR "Ativa o overclocking do rasterizador 2D contido dentro da GPU emulada do PSX. Não melhora a renderização 3D, e em geral tem pouco efeito."
#define OPTION_VAL_32X_PT_BR NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_PT_BR "Proporção de tela do núcleo"
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_PT_BR "Seleciona a proporção de tela do núcleo. Esta configuração é ignorada quando as opções 'Hack de modificação de widescreen' ou 'Exibir a VRAM completa' são ativadas."
#define OPTION_VAL_CORRECTED_PT_BR "Corrigida"
#define OPTION_VAL_UNCORRECTED_PT_BR "Não corrigida"
#define OPTION_VAL_4_3_PT_BR "Forçar 4:3"
#define OPTION_VAL_NTSC_PT_BR "Forçar NTSC"
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_PT_BR "Linha de varredura inicial em formato NTSC"
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_PT_BR "Seleciona a primeira linha de varredura a ser exibida ao executar conteúdos NTSC. Um valor maior que zero reduzirá a altura das imagens geradas, cortando os pixels da parte superior. Isto pode ser usado para evitar o efeito 'letterboxing'."
#define BEETLE_OPT_LAST_SCANLINE_LABEL_PT_BR "Linha de varredura final em formato NTSC"
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_PT_BR "Seleciona a última linha de varredura a ser exibida ao executar conteúdos NTSC. Um valor menor que 239 reduzirá a altura das imagens geradas, cortando os pixels da parte inferior. Isto pode ser usado para evitar o efeito 'letterboxing'."
#define OPTION_VAL_239_PT_BR "239 (padrão)"
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_PT_BR "Linha de varredura inicial em formato PAL"
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_PT_BR "Seleciona a primeira linha de varredura a ser exibida ao executar conteúdos PAL. Um valor maior que zero reduzirá a altura das imagens geradas, cortando os pixels da parte superior. Isto pode ser usado para evitar o efeito 'letterboxing'."
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_PT_BR "Linha de varredura final em formato PAL"
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_PT_BR "Seleciona a última linha de varredura a ser exibida ao executar conteúdos PAL. Um valor inferior a 287 reduzirá a altura das imagens geradas, cortando os pixels da parte inferior. Isto pode ser usado para evitar o efeito 'letterboxing'."
#define OPTION_VAL_287_PT_BR "287 (padrão)"
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_PT_BR "Método de acesso ao CD (requer reinício)"
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_PT_BR "Seleciona o método usado para ler os dados das imagens do disco de conteúdo. 'Síncrono' simula o hardware original, 'Assíncrono' pode reduzir os travamentos em dispositivos com armazenamento lento, e 'Pré-cache' carrega toda a imagem do disco para a memória ao executar o conteúdo, o que pode melhorar os tempos de carga do jogo ao custo de atrasar o boot inicial. 'Pré-cache' pode causar problemas em sistemas com pouca RAM."
#define OPTION_VAL_SYNC_PT_BR "Síncrono"
#define OPTION_VAL_ASYNC_PT_BR "Assíncrono"
#define OPTION_VAL_PRECACHE_PT_BR "Pré-cache"
#define BEETLE_OPT_CD_FASTLOAD_LABEL_PT_BR "Velocidade de carregamento do CD"
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_PT_BR "Seleciona o multiplicador de velocidade de acesso ao disco. Definir um valor maior do que '2x (Nativo)' pode reduzir muito os tempos de carregamento no jogo, mas pode introduzir erros de tempo. Alguns jogos podem não funcionar corretamente se esta opção for aumentada acima de um determinado valor."
#define OPTION_VAL_2X_NATIVE_PT_BR "2x (nativa)"
#define OPTION_VAL_6X_PT_BR NULL
#define OPTION_VAL_10X_PT_BR NULL
#define OPTION_VAL_12X_PT_BR NULL
#define OPTION_VAL_14X_PT_BR NULL

struct retro_core_option_v2_category option_cats_pt_br[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_PT_BR,
      CATEGORY_VIDEO_INFO_0_PT_BR
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_PT_BR,
      CATEGORY_OSD_INFO_0_PT_BR
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_PT_BR,
      CATEGORY_INPUT_INFO_0_PT_BR
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_PT_BR,
      CATEGORY_MEMCARDS_INFO_0_PT_BR
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_PT_BR,
      CATEGORY_PGXP_INFO_0_PT_BR
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_PT_BR,
      CATEGORY_HACKS_INFO_0_PT_BR
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_pt_br[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_PT_BR },
         { "2x",         OPTION_VAL_2X_PT_BR },
         { "4x",         OPTION_VAL_4X_PT_BR },
         { "8x",         OPTION_VAL_8X_PT_BR },
         { "16x",        OPTION_VAL_16X_PT_BR },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_PT_BR },
         { "32bpp",         OPTION_VAL_32BPP_PT_BR },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_PT_BR },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_PT_BR },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_PT_BR },
         { "SABR",     OPTION_VAL_SABR_PT_BR },
         { "xBR",      OPTION_VAL_XBR_PT_BR },
         { "bilinear", OPTION_VAL_BILINEAR_PT_BR },
         { "3-point",  OPTION_VAL_3_POINT_PT_BR },
         { "JINC2",    OPTION_VAL_JINC2_PT_BR },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_PT_BR },
         { "all", OPTION_VAL_ALL_PT_BR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_PT_BR },
         { "all", OPTION_VAL_ALL_PT_BR },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_PT_BR },
         { "2x",  OPTION_VAL_2X_PT_BR },
         { "4x",  OPTION_VAL_4X_PT_BR },
         { "8x",  OPTION_VAL_8X_PT_BR },
         { "16x", OPTION_VAL_16X_PT_BR },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_PT_BR,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_PT_BR,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_PT_BR,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_PT_BR,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_PT_BR,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_PT_BR,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_PT_BR,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_PT_BR },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_PT_BR },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_PT_BR,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_PT_BR },
         { "dot",   OPTION_VAL_DOT_PT_BR },
         { "off",   OPTION_VAL_OFF_PT_BR },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_PT_BR,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_PT_BR },
         { "blue", OPTION_VAL_BLUE_PT_BR },
         { "green", OPTION_VAL_GREEN_PT_BR },
         { "orange", OPTION_VAL_ORANGE_PT_BR },
         { "yellow", OPTION_VAL_YELLOW_PT_BR },
         { "cyan", OPTION_VAL_CYAN_PT_BR },
         { "pink", OPTION_VAL_PINK_PT_BR },
         { "purple", OPTION_VAL_PURPLE_PT_BR },
         { "black", OPTION_VAL_BLACK_PT_BR },
         { "white", OPTION_VAL_WHITE_PT_BR },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_PT_BR,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_PT_BR },
         { "red", OPTION_VAL_RED_PT_BR },
         { "green", OPTION_VAL_GREEN_PT_BR },
         { "orange", OPTION_VAL_ORANGE_PT_BR },
         { "yellow", OPTION_VAL_YELLOW_PT_BR },
         { "cyan", OPTION_VAL_CYAN_PT_BR },
         { "pink", OPTION_VAL_PINK_PT_BR },
         { "purple", OPTION_VAL_PURPLE_PT_BR },
         { "black", OPTION_VAL_BLACK_PT_BR },
         { "white", OPTION_VAL_WHITE_PT_BR },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_PT_BR,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_PT_BR },
         { "10%",  OPTION_VAL_10_PT_BR },
         { "15%",  OPTION_VAL_15_PT_BR },
         { "20%",  OPTION_VAL_20_PT_BR },
         { "25%",  OPTION_VAL_25_PT_BR },
         { "30%",  OPTION_VAL_30_PT_BR },
         { "35%",  OPTION_VAL_35_PT_BR },
         { "40%",  OPTION_VAL_40_PT_BR },
         { "45%",  OPTION_VAL_45_PT_BR },
         { "50%",  OPTION_VAL_50_PT_BR },
         { "55%",  OPTION_VAL_55_PT_BR },
         { "60%",  OPTION_VAL_60_PT_BR },
         { "65%",  OPTION_VAL_65_PT_BR },
         { "70%",  OPTION_VAL_70_PT_BR },
         { "75%",  OPTION_VAL_75_PT_BR },
         { "80%",  OPTION_VAL_80_PT_BR },
         { "85%",  OPTION_VAL_85_PT_BR },
         { "90%",  OPTION_VAL_90_PT_BR },
         { "95%",  OPTION_VAL_95_PT_BR },
         { "100%", OPTION_VAL_100_PT_BR },
         { "105%", OPTION_VAL_105_PT_BR },
         { "110%", OPTION_VAL_110_PT_BR },
         { "115%", OPTION_VAL_115_PT_BR },
         { "120%", OPTION_VAL_120_PT_BR },
         { "125%", OPTION_VAL_125_PT_BR },
         { "130%", OPTION_VAL_130_PT_BR },
         { "135%", OPTION_VAL_135_PT_BR },
         { "140%", OPTION_VAL_140_PT_BR },
         { "145%", OPTION_VAL_145_PT_BR },
         { "150%", OPTION_VAL_150_PT_BR },
         { "155%", OPTION_VAL_155_PT_BR },
         { "160%", OPTION_VAL_160_PT_BR },
         { "165%", OPTION_VAL_165_PT_BR },
         { "170%", OPTION_VAL_170_PT_BR },
         { "175%", OPTION_VAL_175_PT_BR },
         { "180%", OPTION_VAL_180_PT_BR },
         { "185%", OPTION_VAL_185_PT_BR },
         { "190%", OPTION_VAL_190_PT_BR },
         { "195%", OPTION_VAL_195_PT_BR },
         { "200%", OPTION_VAL_200_PT_BR },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_PT_BR,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_PT_BR },
         { "quadratic", OPTION_VAL_QUADRATIC_PT_BR },
         { "cubic",     OPTION_VAL_CUBIC_PT_BR },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_PT_BR,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_PT_BR },
         { "5%",  OPTION_VAL_5_PT_BR },
         { "10%", OPTION_VAL_10_PT_BR },
         { "15%", OPTION_VAL_15_PT_BR },
         { "20%", OPTION_VAL_20_PT_BR },
         { "25%", OPTION_VAL_25_PT_BR },
         { "30%", OPTION_VAL_30_PT_BR },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_PT_BR,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_PT_BR },
         { "mednafen", OPTION_VAL_MEDNAFEN_PT_BR },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_PT_BR,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_PT_BR,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_PT_BR,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_PT_BR,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_PT_BR },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_PT_BR,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_PT_BR },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_PT_BR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_PT_BR,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_PT_BR },
         { "1px", OPTION_VAL_1PX_PT_BR },
         { "2px", OPTION_VAL_2PX_PT_BR },
         { "3px", OPTION_VAL_3PX_PT_BR },
         { "4px", OPTION_VAL_4PX_PT_BR },
         { "5px", OPTION_VAL_5PX_PT_BR },
         { "6px", OPTION_VAL_6PX_PT_BR },
         { "7px", OPTION_VAL_7PX_PT_BR },
         { "8px", OPTION_VAL_8PX_PT_BR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_PT_BR,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_PT_BR,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_PT_BR,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_PT_BR,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_PT_BR },
         { "aggressive", OPTION_VAL_AGGRESSIVE_PT_BR },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_PT_BR,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_PT_BR,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_PT_BR },
         { "16:10", OPTION_VAL_16_10_PT_BR },
         { "18:9",  OPTION_VAL_18_9_PT_BR },
         { "19:9",  OPTION_VAL_19_9_PT_BR },
         { "20:9",  OPTION_VAL_20_9_PT_BR },
         { "21:9",  OPTION_VAL_21_9_PT_BR }, // 64:27
         { "32:9",  OPTION_VAL_32_9_PT_BR },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_PT_BR,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_PT_BR },
         { "60%",           OPTION_VAL_60_PT_BR },
         { "70%",           OPTION_VAL_70_PT_BR },
         { "80%",           OPTION_VAL_80_PT_BR },
         { "90%",           OPTION_VAL_90_PT_BR },
         { "100%(native)", OPTION_VAL_100_NATIVE_PT_BR },
         { "110%",          OPTION_VAL_110_PT_BR },
         { "120%",          OPTION_VAL_120_PT_BR },
         { "130%",          OPTION_VAL_130_PT_BR },
         { "140%",          OPTION_VAL_140_PT_BR },
         { "150%",          OPTION_VAL_150_PT_BR },
         { "160%",          OPTION_VAL_160_PT_BR },
         { "170%",          OPTION_VAL_170_PT_BR },
         { "180%",          OPTION_VAL_180_PT_BR },
         { "190%",          OPTION_VAL_190_PT_BR },
         { "200%",          OPTION_VAL_200_PT_BR },
         { "210%",          OPTION_VAL_210_PT_BR },
         { "220%",          OPTION_VAL_220_PT_BR },
         { "230%",          OPTION_VAL_230_PT_BR },
         { "240%",          OPTION_VAL_240_PT_BR },
         { "250%",          OPTION_VAL_250_PT_BR },
         { "260%",          OPTION_VAL_260_PT_BR },
         { "270%",          OPTION_VAL_270_PT_BR },
         { "280%",          OPTION_VAL_280_PT_BR },
         { "290%",          OPTION_VAL_290_PT_BR },
         { "300%",          OPTION_VAL_300_PT_BR },
         { "310%",          OPTION_VAL_310_PT_BR },
         { "320%",          OPTION_VAL_320_PT_BR },
         { "330%",          OPTION_VAL_330_PT_BR },
         { "340%",          OPTION_VAL_340_PT_BR },
         { "350%",          OPTION_VAL_350_PT_BR },
         { "360%",          OPTION_VAL_360_PT_BR },
         { "370%",          OPTION_VAL_370_PT_BR },
         { "380%",          OPTION_VAL_380_PT_BR },
         { "390%",          OPTION_VAL_390_PT_BR },
         { "400%",          OPTION_VAL_400_PT_BR },
         { "410%",          OPTION_VAL_410_PT_BR },
         { "420%",          OPTION_VAL_420_PT_BR },
         { "430%",          OPTION_VAL_430_PT_BR },
         { "440%",          OPTION_VAL_440_PT_BR },
         { "450%",          OPTION_VAL_450_PT_BR },
         { "460%",          OPTION_VAL_460_PT_BR },
         { "470%",          OPTION_VAL_470_PT_BR },
         { "480%",          OPTION_VAL_480_PT_BR },
         { "490%",          OPTION_VAL_490_PT_BR },
         { "500%",          OPTION_VAL_500_PT_BR },
         { "510%",          OPTION_VAL_510_PT_BR },
         { "520%",          OPTION_VAL_520_PT_BR },
         { "530%",          OPTION_VAL_530_PT_BR },
         { "540%",          OPTION_VAL_540_PT_BR },
         { "550%",          OPTION_VAL_550_PT_BR },
         { "560%",          OPTION_VAL_560_PT_BR },
         { "570%",          OPTION_VAL_570_PT_BR },
         { "580%",          OPTION_VAL_580_PT_BR },
         { "590%",          OPTION_VAL_590_PT_BR },
         { "600%",          OPTION_VAL_600_PT_BR },
         { "610%",          OPTION_VAL_610_PT_BR },
         { "620%",          OPTION_VAL_620_PT_BR },
         { "630%",          OPTION_VAL_630_PT_BR },
         { "640%",          OPTION_VAL_640_PT_BR },
         { "650%",          OPTION_VAL_650_PT_BR },
         { "660%",          OPTION_VAL_660_PT_BR },
         { "670%",          OPTION_VAL_670_PT_BR },
         { "680%",          OPTION_VAL_680_PT_BR },
         { "690%",          OPTION_VAL_690_PT_BR },
         { "700%",          OPTION_VAL_700_PT_BR },
         { "710%",          OPTION_VAL_710_PT_BR },
         { "720%",          OPTION_VAL_720_PT_BR },
         { "730%",          OPTION_VAL_730_PT_BR },
         { "740%",          OPTION_VAL_740_PT_BR },
         { "750%",          OPTION_VAL_750_PT_BR },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_PT_BR,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_PT_BR,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_PT_BR,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_PT_BR },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_PT_BR },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_PT_BR },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_PT_BR },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_PT_BR },
#endif
         { "software",    OPTION_VAL_SOFTWARE_PT_BR },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_PT_BR },
         { "execute",  OPTION_VAL_EXECUTE_PT_BR },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_PT_BR },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_PT_BR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_PT_BR },
         { "dma",  OPTION_VAL_DMA_PT_BR },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_PT_BR },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_PT_BR },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_PT_BR },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_PT_BR },
         { "static",  OPTION_VAL_STATIC_PT_BR },
         { "smart", OPTION_VAL_SMART_PT_BR },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_PT_BR },
         { "2px",      OPTION_VAL_2PX_PT_BR },
         { "3px",      OPTION_VAL_3PX_PT_BR },
         { "4px",      OPTION_VAL_4PX_PT_BR },
         { "5px",      OPTION_VAL_5PX_PT_BR },
         { "6px",      OPTION_VAL_6PX_PT_BR },
         { "7px",      OPTION_VAL_7PX_PT_BR },
         { "8px",      OPTION_VAL_8PX_PT_BR },
         { "9px",      OPTION_VAL_9PX_PT_BR },
         { "10px",     OPTION_VAL_10PX_PT_BR },
         { "11px",     OPTION_VAL_11PX_PT_BR },
         { "12px",     OPTION_VAL_12PX_PT_BR },
         { "13px",     OPTION_VAL_13PX_PT_BR },
         { "14px",     OPTION_VAL_14PX_PT_BR },
         { "15px",     OPTION_VAL_15PX_PT_BR },
         { "16px",     OPTION_VAL_16PX_PT_BR },
         { "17px",     OPTION_VAL_17PX_PT_BR },
         { "18px",     OPTION_VAL_18PX_PT_BR },
         { "19px",     OPTION_VAL_19PX_PT_BR },
         { "20px",     OPTION_VAL_20PX_PT_BR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_PT_BR },
         { "-11px",    OPTION_VAL_11PX_O55_PT_BR },
         { "-10px",    OPTION_VAL_10PX_O55_PT_BR },
         { "-9px",     OPTION_VAL_9PX_O55_PT_BR },
         { "-8px",     OPTION_VAL_8PX_O55_PT_BR },
         { "-7px",     OPTION_VAL_7PX_O55_PT_BR },
         { "-6px",     OPTION_VAL_6PX_O55_PT_BR },
         { "-5px",     OPTION_VAL_5PX_O55_PT_BR },
         { "-4px",     OPTION_VAL_4PX_O55_PT_BR },
         { "-3px",     OPTION_VAL_3PX_O55_PT_BR },
         { "-2px",     OPTION_VAL_2PX_O55_PT_BR },
         { "-1px",     OPTION_VAL_1PX_O55_PT_BR },
         { "disabled", OPTION_VAL_DISABLED_O55_PT_BR },
         { "+1px",     OPTION_VAL_1PX_O55_0_PT_BR },
         { "+2px",     OPTION_VAL_2PX_O55_0_PT_BR },
         { "+3px",     OPTION_VAL_3PX_O55_0_PT_BR },
         { "+4px",     OPTION_VAL_4PX_O55_0_PT_BR },
         { "+5px",     OPTION_VAL_5PX_O55_0_PT_BR },
         { "+6px",     OPTION_VAL_6PX_O55_0_PT_BR },
         { "+7px",     OPTION_VAL_7PX_O55_0_PT_BR },
         { "+8px",     OPTION_VAL_8PX_O55_0_PT_BR },
         { "+9px",     OPTION_VAL_9PX_O55_0_PT_BR },
         { "+10px",    OPTION_VAL_10PX_O55_0_PT_BR },
         { "+11px",    OPTION_VAL_11PX_O55_0_PT_BR },
         { "+12px",    OPTION_VAL_12PX_O55_0_PT_BR },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_PT_BR },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_PT_BR },
         { "2x",         OPTION_VAL_2X_PT_BR },
         { "4x",         OPTION_VAL_4X_PT_BR },
         { "8x",         OPTION_VAL_8X_PT_BR },
         { "16x",        OPTION_VAL_16X_PT_BR },
         { "32x",        OPTION_VAL_32X_PT_BR },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_PT_BR },
         { "uncorrected", OPTION_VAL_UNCORRECTED_PT_BR },
         { "4:3",  OPTION_VAL_4_3_PT_BR },
         { "ntsc", OPTION_VAL_NTSC_PT_BR },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_PT_BR },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_PT_BR,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_PT_BR },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_PT_BR },
         { "async",    OPTION_VAL_ASYNC_PT_BR },
         { "precache", OPTION_VAL_PRECACHE_PT_BR },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_PT_BR,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_PT_BR },
         { "4x",          OPTION_VAL_4X_PT_BR },
         { "6x",          OPTION_VAL_6X_PT_BR },
         { "8x",          OPTION_VAL_8X_PT_BR },
         { "10x",         OPTION_VAL_10X_PT_BR },
         { "12x",         OPTION_VAL_12X_PT_BR },
         { "14x",         OPTION_VAL_14X_PT_BR },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_pt_br = {
   option_cats_pt_br,
   option_defs_pt_br
};

/* RETRO_LANGUAGE_PT_PT */

#define CATEGORY_VIDEO_LABEL_PT_PT "Vídeo"
#define CATEGORY_VIDEO_INFO_0_PT_PT NULL
#define CATEGORY_OSD_LABEL_PT_PT "Notificações no ecrã"
#define CATEGORY_OSD_INFO_0_PT_PT NULL
#define CATEGORY_INPUT_LABEL_PT_PT "Entrada"
#define CATEGORY_INPUT_INFO_0_PT_PT NULL
#define CATEGORY_MEMCARDS_LABEL_PT_PT NULL
#define CATEGORY_MEMCARDS_INFO_0_PT_PT NULL
#define CATEGORY_PGXP_LABEL_PT_PT NULL
#define CATEGORY_PGXP_INFO_0_PT_PT NULL
#define CATEGORY_HACKS_LABEL_PT_PT NULL
#define CATEGORY_HACKS_INFO_0_PT_PT NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_PT_PT NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_PT_PT NULL
#define OPTION_VAL_1X_NATIVE_PT_PT NULL
#define OPTION_VAL_2X_PT_PT NULL
#define OPTION_VAL_4X_PT_PT NULL
#define OPTION_VAL_8X_PT_PT NULL
#define OPTION_VAL_16X_PT_PT NULL
#define BEETLE_OPT_DEPTH_LABEL_PT_PT NULL
#define BEETLE_OPT_DEPTH_INFO_0_PT_PT NULL
#define OPTION_VAL_16BPP_NATIVE_PT_PT NULL
#define OPTION_VAL_32BPP_PT_PT NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_PT_PT NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_PT_PT NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_PT_PT NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_PT_PT NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_PT_PT NULL
#define BEETLE_OPT_FILTER_LABEL_PT_PT NULL
#define BEETLE_OPT_FILTER_INFO_0_PT_PT NULL
#define OPTION_VAL_NEAREST_PT_PT "O mais próximo"
#define OPTION_VAL_SABR_PT_PT NULL
#define OPTION_VAL_XBR_PT_PT NULL
#define OPTION_VAL_BILINEAR_PT_PT NULL
#define OPTION_VAL_3_POINT_PT_PT NULL
#define OPTION_VAL_JINC2_PT_PT NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_PT_PT NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_PT_PT NULL
#define OPTION_VAL_OPAQUE_PT_PT NULL
#define OPTION_VAL_ALL_PT_PT NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_PT_PT NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_PT_PT NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_PT_PT NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_PT_PT NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_PT_PT NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_PT_PT NULL
#define BEETLE_OPT_MSAA_LABEL_PT_PT NULL
#define BEETLE_OPT_MSAA_INFO_0_PT_PT NULL
#define OPTION_VAL_1X_PT_PT NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_PT_PT NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_PT_PT NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_PT_PT NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_PT_PT NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_PT_PT NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_PT_PT NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_PT_PT NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_PT_PT NULL
#define BEETLE_OPT_WIREFRAME_LABEL_PT_PT NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_PT_PT NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_PT_PT NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_PT_PT NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_PT_PT NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_PT_PT NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_PT_PT NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_PT_PT NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_PT_PT NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_PT_PT NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_PT_PT NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_PT_PT NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_PT_PT NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_PT_PT NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_PT_PT NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_PT_PT NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_PT_PT NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_PT_PT NULL
#define OPTION_VAL_LIGHTGUN_PT_PT NULL
#define OPTION_VAL_TOUCHSCREEN_PT_PT NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_PT_PT NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_PT_PT NULL
#define OPTION_VAL_CROSS_PT_PT NULL
#define OPTION_VAL_DOT_PT_PT NULL
#define OPTION_VAL_OFF_PT_PT NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_PT_PT NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_PT_PT NULL
#define OPTION_VAL_RED_PT_PT "Vermelho"
#define OPTION_VAL_BLUE_PT_PT "Azul"
#define OPTION_VAL_GREEN_PT_PT "Verde"
#define OPTION_VAL_ORANGE_PT_PT NULL
#define OPTION_VAL_YELLOW_PT_PT "Amarelo"
#define OPTION_VAL_CYAN_PT_PT NULL
#define OPTION_VAL_PINK_PT_PT NULL
#define OPTION_VAL_PURPLE_PT_PT NULL
#define OPTION_VAL_BLACK_PT_PT NULL
#define OPTION_VAL_WHITE_PT_PT NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_PT_PT NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_PT_PT NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_PT_PT NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_PT_PT NULL
#define OPTION_VAL_5_PT_PT NULL
#define OPTION_VAL_10_PT_PT NULL
#define OPTION_VAL_15_PT_PT NULL
#define OPTION_VAL_20_PT_PT NULL
#define OPTION_VAL_25_PT_PT NULL
#define OPTION_VAL_30_PT_PT NULL
#define OPTION_VAL_35_PT_PT NULL
#define OPTION_VAL_40_PT_PT NULL
#define OPTION_VAL_45_PT_PT NULL
#define OPTION_VAL_50_PT_PT NULL
#define OPTION_VAL_55_PT_PT NULL
#define OPTION_VAL_60_PT_PT NULL
#define OPTION_VAL_65_PT_PT NULL
#define OPTION_VAL_70_PT_PT NULL
#define OPTION_VAL_75_PT_PT NULL
#define OPTION_VAL_80_PT_PT NULL
#define OPTION_VAL_85_PT_PT NULL
#define OPTION_VAL_90_PT_PT NULL
#define OPTION_VAL_95_PT_PT NULL
#define OPTION_VAL_100_PT_PT NULL
#define OPTION_VAL_105_PT_PT NULL
#define OPTION_VAL_110_PT_PT NULL
#define OPTION_VAL_115_PT_PT NULL
#define OPTION_VAL_120_PT_PT NULL
#define OPTION_VAL_125_PT_PT NULL
#define OPTION_VAL_130_PT_PT NULL
#define OPTION_VAL_135_PT_PT NULL
#define OPTION_VAL_140_PT_PT NULL
#define OPTION_VAL_145_PT_PT NULL
#define OPTION_VAL_150_PT_PT NULL
#define OPTION_VAL_155_PT_PT NULL
#define OPTION_VAL_160_PT_PT NULL
#define OPTION_VAL_165_PT_PT NULL
#define OPTION_VAL_170_PT_PT NULL
#define OPTION_VAL_175_PT_PT NULL
#define OPTION_VAL_180_PT_PT NULL
#define OPTION_VAL_185_PT_PT NULL
#define OPTION_VAL_190_PT_PT NULL
#define OPTION_VAL_195_PT_PT NULL
#define OPTION_VAL_200_PT_PT NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_PT_PT NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_PT_PT NULL
#define OPTION_VAL_LINEAR_PT_PT NULL
#define OPTION_VAL_QUADRATIC_PT_PT NULL
#define OPTION_VAL_CUBIC_PT_PT NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_PT_PT NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_PT_PT NULL
#define OPTION_VAL_0_PT_PT NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_PT_PT NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_PT_PT NULL
#define OPTION_VAL_LIBRETRO_PT_PT NULL
#define OPTION_VAL_MEDNAFEN_PT_PT NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_PT_PT NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_PT_PT NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_PT_PT NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_PT_PT NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_PT_PT NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_PT_PT NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_PT_PT NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_PT_PT NULL
#define OPTION_VAL_1_PT_PT NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_PT_PT NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_PT_PT NULL
#define OPTION_VAL_MEMORY_ONLY_PT_PT NULL
#define OPTION_VAL_MEMORY_CPU_PT_PT NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_PT_PT NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_PT_PT NULL
#define OPTION_VAL_0PX_PT_PT NULL
#define OPTION_VAL_1PX_PT_PT NULL
#define OPTION_VAL_2PX_PT_PT NULL
#define OPTION_VAL_3PX_PT_PT NULL
#define OPTION_VAL_4PX_PT_PT NULL
#define OPTION_VAL_5PX_PT_PT NULL
#define OPTION_VAL_6PX_PT_PT NULL
#define OPTION_VAL_7PX_PT_PT NULL
#define OPTION_VAL_8PX_PT_PT NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_PT_PT NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_PT_PT NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_PT_PT NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_PT_PT NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_PT_PT NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_PT_PT NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_PT_PT NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_PT_PT NULL
#define OPTION_VAL_DEFAULT_PT_PT NULL
#define OPTION_VAL_AGGRESSIVE_PT_PT NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_PT_PT NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_PT_PT NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_PT_PT NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_PT_PT NULL
#define OPTION_VAL_16_9_PT_PT NULL
#define OPTION_VAL_16_10_PT_PT NULL
#define OPTION_VAL_18_9_PT_PT NULL
#define OPTION_VAL_19_9_PT_PT NULL
#define OPTION_VAL_20_9_PT_PT NULL
#define OPTION_VAL_21_9_PT_PT NULL
#define OPTION_VAL_32_9_PT_PT NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_PT_PT NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_PT_PT NULL
#define OPTION_VAL_100_NATIVE_PT_PT NULL
#define OPTION_VAL_210_PT_PT NULL
#define OPTION_VAL_220_PT_PT NULL
#define OPTION_VAL_230_PT_PT NULL
#define OPTION_VAL_240_PT_PT NULL
#define OPTION_VAL_250_PT_PT NULL
#define OPTION_VAL_260_PT_PT NULL
#define OPTION_VAL_270_PT_PT NULL
#define OPTION_VAL_280_PT_PT NULL
#define OPTION_VAL_290_PT_PT NULL
#define OPTION_VAL_300_PT_PT NULL
#define OPTION_VAL_310_PT_PT NULL
#define OPTION_VAL_320_PT_PT NULL
#define OPTION_VAL_330_PT_PT NULL
#define OPTION_VAL_340_PT_PT NULL
#define OPTION_VAL_350_PT_PT NULL
#define OPTION_VAL_360_PT_PT NULL
#define OPTION_VAL_370_PT_PT NULL
#define OPTION_VAL_380_PT_PT NULL
#define OPTION_VAL_390_PT_PT NULL
#define OPTION_VAL_400_PT_PT NULL
#define OPTION_VAL_410_PT_PT NULL
#define OPTION_VAL_420_PT_PT NULL
#define OPTION_VAL_430_PT_PT NULL
#define OPTION_VAL_440_PT_PT NULL
#define OPTION_VAL_450_PT_PT NULL
#define OPTION_VAL_460_PT_PT NULL
#define OPTION_VAL_470_PT_PT NULL
#define OPTION_VAL_480_PT_PT NULL
#define OPTION_VAL_490_PT_PT NULL
#define OPTION_VAL_500_PT_PT NULL
#define OPTION_VAL_510_PT_PT NULL
#define OPTION_VAL_520_PT_PT NULL
#define OPTION_VAL_530_PT_PT NULL
#define OPTION_VAL_540_PT_PT NULL
#define OPTION_VAL_550_PT_PT NULL
#define OPTION_VAL_560_PT_PT NULL
#define OPTION_VAL_570_PT_PT NULL
#define OPTION_VAL_580_PT_PT NULL
#define OPTION_VAL_590_PT_PT NULL
#define OPTION_VAL_600_PT_PT NULL
#define OPTION_VAL_610_PT_PT NULL
#define OPTION_VAL_620_PT_PT NULL
#define OPTION_VAL_630_PT_PT NULL
#define OPTION_VAL_640_PT_PT NULL
#define OPTION_VAL_650_PT_PT NULL
#define OPTION_VAL_660_PT_PT NULL
#define OPTION_VAL_670_PT_PT NULL
#define OPTION_VAL_680_PT_PT NULL
#define OPTION_VAL_690_PT_PT NULL
#define OPTION_VAL_700_PT_PT NULL
#define OPTION_VAL_710_PT_PT NULL
#define OPTION_VAL_720_PT_PT NULL
#define OPTION_VAL_730_PT_PT NULL
#define OPTION_VAL_740_PT_PT NULL
#define OPTION_VAL_750_PT_PT NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_PT_PT NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_PT_PT NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_PT_PT NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_PT_PT NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_PT_PT NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_PT_PT NULL
#define OPTION_VAL_PSXONPSP_PT_PT NULL
#define OPTION_VAL_PS1_ROM_PT_PT NULL
#define BEETLE_OPT_RENDERER_LABEL_PT_PT NULL
#define BEETLE_OPT_RENDERER_INFO_0_PT_PT NULL
#define OPTION_VAL_HARDWARE_PT_PT NULL
#define OPTION_VAL_HARDWARE_GL_PT_PT NULL
#define OPTION_VAL_HARDWARE_VK_PT_PT NULL
#define OPTION_VAL_SOFTWARE_PT_PT NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_PT_PT NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_PT_PT NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_PT_PT NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_PT_PT NULL
#define OPTION_VAL_DISABLED_PT_PT NULL
#define OPTION_VAL_EXECUTE_PT_PT NULL
#define OPTION_VAL_EXECUTE_ONE_PT_PT NULL
#define OPTION_VAL_RUN_INTERPRETER_PT_PT NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_PT_PT NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_PT_PT NULL
#define OPTION_VAL_FULL_PT_PT NULL
#define OPTION_VAL_DMA_PT_PT NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_PT_PT NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_PT_PT NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_PT_PT NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_PT_PT NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_PT_PT NULL
#define OPTION_VAL_FORCE_INTERLACED_PT_PT NULL
#define OPTION_VAL_AUTO_TOGGLE_PT_PT NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_PT_PT NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_PT_PT NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_PT_PT NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_PT_PT NULL
#define OPTION_VAL_DISABLED_O53_PT_PT "Nenhum"
#define OPTION_VAL_STATIC_PT_PT NULL
#define OPTION_VAL_SMART_PT_PT NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_PT_PT NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_PT_PT NULL
#define OPTION_VAL_9PX_PT_PT NULL
#define OPTION_VAL_10PX_PT_PT NULL
#define OPTION_VAL_11PX_PT_PT NULL
#define OPTION_VAL_12PX_PT_PT NULL
#define OPTION_VAL_13PX_PT_PT NULL
#define OPTION_VAL_14PX_PT_PT NULL
#define OPTION_VAL_15PX_PT_PT NULL
#define OPTION_VAL_16PX_PT_PT NULL
#define OPTION_VAL_17PX_PT_PT NULL
#define OPTION_VAL_18PX_PT_PT NULL
#define OPTION_VAL_19PX_PT_PT NULL
#define OPTION_VAL_20PX_PT_PT NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_PT_PT NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_PT_PT NULL
#define OPTION_VAL_12PX_O55_PT_PT NULL
#define OPTION_VAL_11PX_O55_PT_PT NULL
#define OPTION_VAL_10PX_O55_PT_PT NULL
#define OPTION_VAL_9PX_O55_PT_PT NULL
#define OPTION_VAL_8PX_O55_PT_PT NULL
#define OPTION_VAL_7PX_O55_PT_PT NULL
#define OPTION_VAL_6PX_O55_PT_PT NULL
#define OPTION_VAL_5PX_O55_PT_PT NULL
#define OPTION_VAL_4PX_O55_PT_PT NULL
#define OPTION_VAL_3PX_O55_PT_PT NULL
#define OPTION_VAL_2PX_O55_PT_PT NULL
#define OPTION_VAL_1PX_O55_PT_PT NULL
#define OPTION_VAL_DISABLED_O55_PT_PT NULL
#define OPTION_VAL_1PX_O55_0_PT_PT NULL
#define OPTION_VAL_2PX_O55_0_PT_PT NULL
#define OPTION_VAL_3PX_O55_0_PT_PT NULL
#define OPTION_VAL_4PX_O55_0_PT_PT NULL
#define OPTION_VAL_5PX_O55_0_PT_PT NULL
#define OPTION_VAL_6PX_O55_0_PT_PT NULL
#define OPTION_VAL_7PX_O55_0_PT_PT NULL
#define OPTION_VAL_8PX_O55_0_PT_PT NULL
#define OPTION_VAL_9PX_O55_0_PT_PT NULL
#define OPTION_VAL_10PX_O55_0_PT_PT NULL
#define OPTION_VAL_11PX_O55_0_PT_PT NULL
#define OPTION_VAL_12PX_O55_0_PT_PT NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_PT_PT NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_PT_PT NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_PT_PT NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_PT_PT NULL
#define OPTION_VAL_32X_PT_PT NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_PT_PT NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_PT_PT NULL
#define OPTION_VAL_CORRECTED_PT_PT NULL
#define OPTION_VAL_UNCORRECTED_PT_PT NULL
#define OPTION_VAL_4_3_PT_PT NULL
#define OPTION_VAL_NTSC_PT_PT NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_PT_PT NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_PT_PT NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_PT_PT NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_PT_PT NULL
#define OPTION_VAL_239_PT_PT NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_PT_PT NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_PT_PT NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_PT_PT NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_PT_PT NULL
#define OPTION_VAL_287_PT_PT NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_PT_PT NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_PT_PT NULL
#define OPTION_VAL_SYNC_PT_PT NULL
#define OPTION_VAL_ASYNC_PT_PT NULL
#define OPTION_VAL_PRECACHE_PT_PT NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_PT_PT NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_PT_PT NULL
#define OPTION_VAL_2X_NATIVE_PT_PT NULL
#define OPTION_VAL_6X_PT_PT NULL
#define OPTION_VAL_10X_PT_PT NULL
#define OPTION_VAL_12X_PT_PT NULL
#define OPTION_VAL_14X_PT_PT NULL

struct retro_core_option_v2_category option_cats_pt_pt[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_PT_PT,
      CATEGORY_VIDEO_INFO_0_PT_PT
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_PT_PT,
      CATEGORY_OSD_INFO_0_PT_PT
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_PT_PT,
      CATEGORY_INPUT_INFO_0_PT_PT
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_PT_PT,
      CATEGORY_MEMCARDS_INFO_0_PT_PT
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_PT_PT,
      CATEGORY_PGXP_INFO_0_PT_PT
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_PT_PT,
      CATEGORY_HACKS_INFO_0_PT_PT
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_pt_pt[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_PT_PT },
         { "2x",         OPTION_VAL_2X_PT_PT },
         { "4x",         OPTION_VAL_4X_PT_PT },
         { "8x",         OPTION_VAL_8X_PT_PT },
         { "16x",        OPTION_VAL_16X_PT_PT },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_PT_PT },
         { "32bpp",         OPTION_VAL_32BPP_PT_PT },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_PT_PT },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_PT_PT },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_PT_PT },
         { "SABR",     OPTION_VAL_SABR_PT_PT },
         { "xBR",      OPTION_VAL_XBR_PT_PT },
         { "bilinear", OPTION_VAL_BILINEAR_PT_PT },
         { "3-point",  OPTION_VAL_3_POINT_PT_PT },
         { "JINC2",    OPTION_VAL_JINC2_PT_PT },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_PT_PT },
         { "all", OPTION_VAL_ALL_PT_PT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_PT_PT },
         { "all", OPTION_VAL_ALL_PT_PT },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_PT_PT },
         { "2x",  OPTION_VAL_2X_PT_PT },
         { "4x",  OPTION_VAL_4X_PT_PT },
         { "8x",  OPTION_VAL_8X_PT_PT },
         { "16x", OPTION_VAL_16X_PT_PT },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_PT_PT,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_PT_PT,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_PT_PT,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_PT_PT,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_PT_PT,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_PT_PT,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_PT_PT,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_PT_PT },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_PT_PT },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_PT_PT,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_PT_PT },
         { "dot",   OPTION_VAL_DOT_PT_PT },
         { "off",   OPTION_VAL_OFF_PT_PT },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_PT_PT,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_PT_PT },
         { "blue", OPTION_VAL_BLUE_PT_PT },
         { "green", OPTION_VAL_GREEN_PT_PT },
         { "orange", OPTION_VAL_ORANGE_PT_PT },
         { "yellow", OPTION_VAL_YELLOW_PT_PT },
         { "cyan", OPTION_VAL_CYAN_PT_PT },
         { "pink", OPTION_VAL_PINK_PT_PT },
         { "purple", OPTION_VAL_PURPLE_PT_PT },
         { "black", OPTION_VAL_BLACK_PT_PT },
         { "white", OPTION_VAL_WHITE_PT_PT },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_PT_PT,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_PT_PT },
         { "red", OPTION_VAL_RED_PT_PT },
         { "green", OPTION_VAL_GREEN_PT_PT },
         { "orange", OPTION_VAL_ORANGE_PT_PT },
         { "yellow", OPTION_VAL_YELLOW_PT_PT },
         { "cyan", OPTION_VAL_CYAN_PT_PT },
         { "pink", OPTION_VAL_PINK_PT_PT },
         { "purple", OPTION_VAL_PURPLE_PT_PT },
         { "black", OPTION_VAL_BLACK_PT_PT },
         { "white", OPTION_VAL_WHITE_PT_PT },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_PT_PT,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_PT_PT },
         { "10%",  OPTION_VAL_10_PT_PT },
         { "15%",  OPTION_VAL_15_PT_PT },
         { "20%",  OPTION_VAL_20_PT_PT },
         { "25%",  OPTION_VAL_25_PT_PT },
         { "30%",  OPTION_VAL_30_PT_PT },
         { "35%",  OPTION_VAL_35_PT_PT },
         { "40%",  OPTION_VAL_40_PT_PT },
         { "45%",  OPTION_VAL_45_PT_PT },
         { "50%",  OPTION_VAL_50_PT_PT },
         { "55%",  OPTION_VAL_55_PT_PT },
         { "60%",  OPTION_VAL_60_PT_PT },
         { "65%",  OPTION_VAL_65_PT_PT },
         { "70%",  OPTION_VAL_70_PT_PT },
         { "75%",  OPTION_VAL_75_PT_PT },
         { "80%",  OPTION_VAL_80_PT_PT },
         { "85%",  OPTION_VAL_85_PT_PT },
         { "90%",  OPTION_VAL_90_PT_PT },
         { "95%",  OPTION_VAL_95_PT_PT },
         { "100%", OPTION_VAL_100_PT_PT },
         { "105%", OPTION_VAL_105_PT_PT },
         { "110%", OPTION_VAL_110_PT_PT },
         { "115%", OPTION_VAL_115_PT_PT },
         { "120%", OPTION_VAL_120_PT_PT },
         { "125%", OPTION_VAL_125_PT_PT },
         { "130%", OPTION_VAL_130_PT_PT },
         { "135%", OPTION_VAL_135_PT_PT },
         { "140%", OPTION_VAL_140_PT_PT },
         { "145%", OPTION_VAL_145_PT_PT },
         { "150%", OPTION_VAL_150_PT_PT },
         { "155%", OPTION_VAL_155_PT_PT },
         { "160%", OPTION_VAL_160_PT_PT },
         { "165%", OPTION_VAL_165_PT_PT },
         { "170%", OPTION_VAL_170_PT_PT },
         { "175%", OPTION_VAL_175_PT_PT },
         { "180%", OPTION_VAL_180_PT_PT },
         { "185%", OPTION_VAL_185_PT_PT },
         { "190%", OPTION_VAL_190_PT_PT },
         { "195%", OPTION_VAL_195_PT_PT },
         { "200%", OPTION_VAL_200_PT_PT },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_PT_PT,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_PT_PT },
         { "quadratic", OPTION_VAL_QUADRATIC_PT_PT },
         { "cubic",     OPTION_VAL_CUBIC_PT_PT },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_PT_PT,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_PT_PT },
         { "5%",  OPTION_VAL_5_PT_PT },
         { "10%", OPTION_VAL_10_PT_PT },
         { "15%", OPTION_VAL_15_PT_PT },
         { "20%", OPTION_VAL_20_PT_PT },
         { "25%", OPTION_VAL_25_PT_PT },
         { "30%", OPTION_VAL_30_PT_PT },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_PT_PT,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_PT_PT },
         { "mednafen", OPTION_VAL_MEDNAFEN_PT_PT },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_PT_PT,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_PT_PT,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_PT_PT,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_PT_PT,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_PT_PT },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_PT_PT,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_PT_PT },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_PT_PT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_PT_PT,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_PT_PT },
         { "1px", OPTION_VAL_1PX_PT_PT },
         { "2px", OPTION_VAL_2PX_PT_PT },
         { "3px", OPTION_VAL_3PX_PT_PT },
         { "4px", OPTION_VAL_4PX_PT_PT },
         { "5px", OPTION_VAL_5PX_PT_PT },
         { "6px", OPTION_VAL_6PX_PT_PT },
         { "7px", OPTION_VAL_7PX_PT_PT },
         { "8px", OPTION_VAL_8PX_PT_PT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_PT_PT,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_PT_PT,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_PT_PT,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_PT_PT,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_PT_PT },
         { "aggressive", OPTION_VAL_AGGRESSIVE_PT_PT },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_PT_PT,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_PT_PT,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_PT_PT },
         { "16:10", OPTION_VAL_16_10_PT_PT },
         { "18:9",  OPTION_VAL_18_9_PT_PT },
         { "19:9",  OPTION_VAL_19_9_PT_PT },
         { "20:9",  OPTION_VAL_20_9_PT_PT },
         { "21:9",  OPTION_VAL_21_9_PT_PT }, // 64:27
         { "32:9",  OPTION_VAL_32_9_PT_PT },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_PT_PT,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_PT_PT },
         { "60%",           OPTION_VAL_60_PT_PT },
         { "70%",           OPTION_VAL_70_PT_PT },
         { "80%",           OPTION_VAL_80_PT_PT },
         { "90%",           OPTION_VAL_90_PT_PT },
         { "100%(native)", OPTION_VAL_100_NATIVE_PT_PT },
         { "110%",          OPTION_VAL_110_PT_PT },
         { "120%",          OPTION_VAL_120_PT_PT },
         { "130%",          OPTION_VAL_130_PT_PT },
         { "140%",          OPTION_VAL_140_PT_PT },
         { "150%",          OPTION_VAL_150_PT_PT },
         { "160%",          OPTION_VAL_160_PT_PT },
         { "170%",          OPTION_VAL_170_PT_PT },
         { "180%",          OPTION_VAL_180_PT_PT },
         { "190%",          OPTION_VAL_190_PT_PT },
         { "200%",          OPTION_VAL_200_PT_PT },
         { "210%",          OPTION_VAL_210_PT_PT },
         { "220%",          OPTION_VAL_220_PT_PT },
         { "230%",          OPTION_VAL_230_PT_PT },
         { "240%",          OPTION_VAL_240_PT_PT },
         { "250%",          OPTION_VAL_250_PT_PT },
         { "260%",          OPTION_VAL_260_PT_PT },
         { "270%",          OPTION_VAL_270_PT_PT },
         { "280%",          OPTION_VAL_280_PT_PT },
         { "290%",          OPTION_VAL_290_PT_PT },
         { "300%",          OPTION_VAL_300_PT_PT },
         { "310%",          OPTION_VAL_310_PT_PT },
         { "320%",          OPTION_VAL_320_PT_PT },
         { "330%",          OPTION_VAL_330_PT_PT },
         { "340%",          OPTION_VAL_340_PT_PT },
         { "350%",          OPTION_VAL_350_PT_PT },
         { "360%",          OPTION_VAL_360_PT_PT },
         { "370%",          OPTION_VAL_370_PT_PT },
         { "380%",          OPTION_VAL_380_PT_PT },
         { "390%",          OPTION_VAL_390_PT_PT },
         { "400%",          OPTION_VAL_400_PT_PT },
         { "410%",          OPTION_VAL_410_PT_PT },
         { "420%",          OPTION_VAL_420_PT_PT },
         { "430%",          OPTION_VAL_430_PT_PT },
         { "440%",          OPTION_VAL_440_PT_PT },
         { "450%",          OPTION_VAL_450_PT_PT },
         { "460%",          OPTION_VAL_460_PT_PT },
         { "470%",          OPTION_VAL_470_PT_PT },
         { "480%",          OPTION_VAL_480_PT_PT },
         { "490%",          OPTION_VAL_490_PT_PT },
         { "500%",          OPTION_VAL_500_PT_PT },
         { "510%",          OPTION_VAL_510_PT_PT },
         { "520%",          OPTION_VAL_520_PT_PT },
         { "530%",          OPTION_VAL_530_PT_PT },
         { "540%",          OPTION_VAL_540_PT_PT },
         { "550%",          OPTION_VAL_550_PT_PT },
         { "560%",          OPTION_VAL_560_PT_PT },
         { "570%",          OPTION_VAL_570_PT_PT },
         { "580%",          OPTION_VAL_580_PT_PT },
         { "590%",          OPTION_VAL_590_PT_PT },
         { "600%",          OPTION_VAL_600_PT_PT },
         { "610%",          OPTION_VAL_610_PT_PT },
         { "620%",          OPTION_VAL_620_PT_PT },
         { "630%",          OPTION_VAL_630_PT_PT },
         { "640%",          OPTION_VAL_640_PT_PT },
         { "650%",          OPTION_VAL_650_PT_PT },
         { "660%",          OPTION_VAL_660_PT_PT },
         { "670%",          OPTION_VAL_670_PT_PT },
         { "680%",          OPTION_VAL_680_PT_PT },
         { "690%",          OPTION_VAL_690_PT_PT },
         { "700%",          OPTION_VAL_700_PT_PT },
         { "710%",          OPTION_VAL_710_PT_PT },
         { "720%",          OPTION_VAL_720_PT_PT },
         { "730%",          OPTION_VAL_730_PT_PT },
         { "740%",          OPTION_VAL_740_PT_PT },
         { "750%",          OPTION_VAL_750_PT_PT },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_PT_PT,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_PT_PT,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_PT_PT,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_PT_PT },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_PT_PT },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_PT_PT },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_PT_PT },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_PT_PT },
#endif
         { "software",    OPTION_VAL_SOFTWARE_PT_PT },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_PT_PT },
         { "execute",  OPTION_VAL_EXECUTE_PT_PT },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_PT_PT },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_PT_PT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_PT_PT },
         { "dma",  OPTION_VAL_DMA_PT_PT },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_PT_PT },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_PT_PT },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_PT_PT },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_PT_PT },
         { "static",  OPTION_VAL_STATIC_PT_PT },
         { "smart", OPTION_VAL_SMART_PT_PT },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_PT_PT },
         { "2px",      OPTION_VAL_2PX_PT_PT },
         { "3px",      OPTION_VAL_3PX_PT_PT },
         { "4px",      OPTION_VAL_4PX_PT_PT },
         { "5px",      OPTION_VAL_5PX_PT_PT },
         { "6px",      OPTION_VAL_6PX_PT_PT },
         { "7px",      OPTION_VAL_7PX_PT_PT },
         { "8px",      OPTION_VAL_8PX_PT_PT },
         { "9px",      OPTION_VAL_9PX_PT_PT },
         { "10px",     OPTION_VAL_10PX_PT_PT },
         { "11px",     OPTION_VAL_11PX_PT_PT },
         { "12px",     OPTION_VAL_12PX_PT_PT },
         { "13px",     OPTION_VAL_13PX_PT_PT },
         { "14px",     OPTION_VAL_14PX_PT_PT },
         { "15px",     OPTION_VAL_15PX_PT_PT },
         { "16px",     OPTION_VAL_16PX_PT_PT },
         { "17px",     OPTION_VAL_17PX_PT_PT },
         { "18px",     OPTION_VAL_18PX_PT_PT },
         { "19px",     OPTION_VAL_19PX_PT_PT },
         { "20px",     OPTION_VAL_20PX_PT_PT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_PT_PT },
         { "-11px",    OPTION_VAL_11PX_O55_PT_PT },
         { "-10px",    OPTION_VAL_10PX_O55_PT_PT },
         { "-9px",     OPTION_VAL_9PX_O55_PT_PT },
         { "-8px",     OPTION_VAL_8PX_O55_PT_PT },
         { "-7px",     OPTION_VAL_7PX_O55_PT_PT },
         { "-6px",     OPTION_VAL_6PX_O55_PT_PT },
         { "-5px",     OPTION_VAL_5PX_O55_PT_PT },
         { "-4px",     OPTION_VAL_4PX_O55_PT_PT },
         { "-3px",     OPTION_VAL_3PX_O55_PT_PT },
         { "-2px",     OPTION_VAL_2PX_O55_PT_PT },
         { "-1px",     OPTION_VAL_1PX_O55_PT_PT },
         { "disabled", OPTION_VAL_DISABLED_O55_PT_PT },
         { "+1px",     OPTION_VAL_1PX_O55_0_PT_PT },
         { "+2px",     OPTION_VAL_2PX_O55_0_PT_PT },
         { "+3px",     OPTION_VAL_3PX_O55_0_PT_PT },
         { "+4px",     OPTION_VAL_4PX_O55_0_PT_PT },
         { "+5px",     OPTION_VAL_5PX_O55_0_PT_PT },
         { "+6px",     OPTION_VAL_6PX_O55_0_PT_PT },
         { "+7px",     OPTION_VAL_7PX_O55_0_PT_PT },
         { "+8px",     OPTION_VAL_8PX_O55_0_PT_PT },
         { "+9px",     OPTION_VAL_9PX_O55_0_PT_PT },
         { "+10px",    OPTION_VAL_10PX_O55_0_PT_PT },
         { "+11px",    OPTION_VAL_11PX_O55_0_PT_PT },
         { "+12px",    OPTION_VAL_12PX_O55_0_PT_PT },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_PT_PT },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_PT_PT },
         { "2x",         OPTION_VAL_2X_PT_PT },
         { "4x",         OPTION_VAL_4X_PT_PT },
         { "8x",         OPTION_VAL_8X_PT_PT },
         { "16x",        OPTION_VAL_16X_PT_PT },
         { "32x",        OPTION_VAL_32X_PT_PT },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_PT_PT },
         { "uncorrected", OPTION_VAL_UNCORRECTED_PT_PT },
         { "4:3",  OPTION_VAL_4_3_PT_PT },
         { "ntsc", OPTION_VAL_NTSC_PT_PT },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_PT_PT },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_PT_PT,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_PT_PT },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_PT_PT },
         { "async",    OPTION_VAL_ASYNC_PT_PT },
         { "precache", OPTION_VAL_PRECACHE_PT_PT },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_PT_PT,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_PT_PT },
         { "4x",          OPTION_VAL_4X_PT_PT },
         { "6x",          OPTION_VAL_6X_PT_PT },
         { "8x",          OPTION_VAL_8X_PT_PT },
         { "10x",         OPTION_VAL_10X_PT_PT },
         { "12x",         OPTION_VAL_12X_PT_PT },
         { "14x",         OPTION_VAL_14X_PT_PT },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_pt_pt = {
   option_cats_pt_pt,
   option_defs_pt_pt
};

/* RETRO_LANGUAGE_RO */

#define CATEGORY_VIDEO_LABEL_RO NULL
#define CATEGORY_VIDEO_INFO_0_RO NULL
#define CATEGORY_OSD_LABEL_RO NULL
#define CATEGORY_OSD_INFO_0_RO NULL
#define CATEGORY_INPUT_LABEL_RO NULL
#define CATEGORY_INPUT_INFO_0_RO NULL
#define CATEGORY_MEMCARDS_LABEL_RO NULL
#define CATEGORY_MEMCARDS_INFO_0_RO NULL
#define CATEGORY_PGXP_LABEL_RO NULL
#define CATEGORY_PGXP_INFO_0_RO NULL
#define CATEGORY_HACKS_LABEL_RO NULL
#define CATEGORY_HACKS_INFO_0_RO NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_RO NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_RO NULL
#define OPTION_VAL_1X_NATIVE_RO NULL
#define OPTION_VAL_2X_RO NULL
#define OPTION_VAL_4X_RO NULL
#define OPTION_VAL_8X_RO NULL
#define OPTION_VAL_16X_RO NULL
#define BEETLE_OPT_DEPTH_LABEL_RO NULL
#define BEETLE_OPT_DEPTH_INFO_0_RO NULL
#define OPTION_VAL_16BPP_NATIVE_RO NULL
#define OPTION_VAL_32BPP_RO NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_RO NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_RO NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_RO NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_RO NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_RO NULL
#define BEETLE_OPT_FILTER_LABEL_RO NULL
#define BEETLE_OPT_FILTER_INFO_0_RO NULL
#define OPTION_VAL_NEAREST_RO NULL
#define OPTION_VAL_SABR_RO NULL
#define OPTION_VAL_XBR_RO NULL
#define OPTION_VAL_BILINEAR_RO NULL
#define OPTION_VAL_3_POINT_RO NULL
#define OPTION_VAL_JINC2_RO NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_RO NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_RO NULL
#define OPTION_VAL_OPAQUE_RO NULL
#define OPTION_VAL_ALL_RO NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_RO NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_RO NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_RO NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_RO NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_RO NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_RO NULL
#define BEETLE_OPT_MSAA_LABEL_RO NULL
#define BEETLE_OPT_MSAA_INFO_0_RO NULL
#define OPTION_VAL_1X_RO NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_RO NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_RO NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_RO NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_RO NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_RO NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_RO NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_RO NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_RO NULL
#define BEETLE_OPT_WIREFRAME_LABEL_RO NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_RO NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_RO NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_RO NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_RO NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_RO NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_RO NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_RO NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_RO NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_RO NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_RO NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_RO NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_RO NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_RO NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_RO NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_RO NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_RO NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_RO NULL
#define OPTION_VAL_LIGHTGUN_RO NULL
#define OPTION_VAL_TOUCHSCREEN_RO NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_RO NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_RO NULL
#define OPTION_VAL_CROSS_RO NULL
#define OPTION_VAL_DOT_RO NULL
#define OPTION_VAL_OFF_RO NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_RO NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_RO NULL
#define OPTION_VAL_RED_RO NULL
#define OPTION_VAL_BLUE_RO NULL
#define OPTION_VAL_GREEN_RO NULL
#define OPTION_VAL_ORANGE_RO NULL
#define OPTION_VAL_YELLOW_RO NULL
#define OPTION_VAL_CYAN_RO NULL
#define OPTION_VAL_PINK_RO NULL
#define OPTION_VAL_PURPLE_RO NULL
#define OPTION_VAL_BLACK_RO NULL
#define OPTION_VAL_WHITE_RO NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_RO NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_RO NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_RO NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_RO NULL
#define OPTION_VAL_5_RO NULL
#define OPTION_VAL_10_RO NULL
#define OPTION_VAL_15_RO NULL
#define OPTION_VAL_20_RO NULL
#define OPTION_VAL_25_RO NULL
#define OPTION_VAL_30_RO NULL
#define OPTION_VAL_35_RO NULL
#define OPTION_VAL_40_RO NULL
#define OPTION_VAL_45_RO NULL
#define OPTION_VAL_50_RO NULL
#define OPTION_VAL_55_RO NULL
#define OPTION_VAL_60_RO NULL
#define OPTION_VAL_65_RO NULL
#define OPTION_VAL_70_RO NULL
#define OPTION_VAL_75_RO NULL
#define OPTION_VAL_80_RO NULL
#define OPTION_VAL_85_RO NULL
#define OPTION_VAL_90_RO NULL
#define OPTION_VAL_95_RO NULL
#define OPTION_VAL_100_RO NULL
#define OPTION_VAL_105_RO NULL
#define OPTION_VAL_110_RO NULL
#define OPTION_VAL_115_RO NULL
#define OPTION_VAL_120_RO NULL
#define OPTION_VAL_125_RO NULL
#define OPTION_VAL_130_RO NULL
#define OPTION_VAL_135_RO NULL
#define OPTION_VAL_140_RO NULL
#define OPTION_VAL_145_RO NULL
#define OPTION_VAL_150_RO NULL
#define OPTION_VAL_155_RO NULL
#define OPTION_VAL_160_RO NULL
#define OPTION_VAL_165_RO NULL
#define OPTION_VAL_170_RO NULL
#define OPTION_VAL_175_RO NULL
#define OPTION_VAL_180_RO NULL
#define OPTION_VAL_185_RO NULL
#define OPTION_VAL_190_RO NULL
#define OPTION_VAL_195_RO NULL
#define OPTION_VAL_200_RO NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_RO NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_RO NULL
#define OPTION_VAL_LINEAR_RO NULL
#define OPTION_VAL_QUADRATIC_RO NULL
#define OPTION_VAL_CUBIC_RO NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_RO NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_RO NULL
#define OPTION_VAL_0_RO NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_RO NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_RO NULL
#define OPTION_VAL_LIBRETRO_RO NULL
#define OPTION_VAL_MEDNAFEN_RO NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_RO NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_RO NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_RO NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_RO NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_RO NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_RO NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_RO NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_RO NULL
#define OPTION_VAL_1_RO NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_RO NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_RO NULL
#define OPTION_VAL_MEMORY_ONLY_RO NULL
#define OPTION_VAL_MEMORY_CPU_RO NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_RO NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_RO NULL
#define OPTION_VAL_0PX_RO NULL
#define OPTION_VAL_1PX_RO NULL
#define OPTION_VAL_2PX_RO NULL
#define OPTION_VAL_3PX_RO NULL
#define OPTION_VAL_4PX_RO NULL
#define OPTION_VAL_5PX_RO NULL
#define OPTION_VAL_6PX_RO NULL
#define OPTION_VAL_7PX_RO NULL
#define OPTION_VAL_8PX_RO NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_RO NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_RO NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_RO NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_RO NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_RO NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_RO NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_RO NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_RO NULL
#define OPTION_VAL_DEFAULT_RO NULL
#define OPTION_VAL_AGGRESSIVE_RO NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_RO NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_RO NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_RO NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_RO NULL
#define OPTION_VAL_16_9_RO NULL
#define OPTION_VAL_16_10_RO NULL
#define OPTION_VAL_18_9_RO NULL
#define OPTION_VAL_19_9_RO NULL
#define OPTION_VAL_20_9_RO NULL
#define OPTION_VAL_21_9_RO NULL
#define OPTION_VAL_32_9_RO NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_RO NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_RO NULL
#define OPTION_VAL_100_NATIVE_RO NULL
#define OPTION_VAL_210_RO NULL
#define OPTION_VAL_220_RO NULL
#define OPTION_VAL_230_RO NULL
#define OPTION_VAL_240_RO NULL
#define OPTION_VAL_250_RO NULL
#define OPTION_VAL_260_RO NULL
#define OPTION_VAL_270_RO NULL
#define OPTION_VAL_280_RO NULL
#define OPTION_VAL_290_RO NULL
#define OPTION_VAL_300_RO NULL
#define OPTION_VAL_310_RO NULL
#define OPTION_VAL_320_RO NULL
#define OPTION_VAL_330_RO NULL
#define OPTION_VAL_340_RO NULL
#define OPTION_VAL_350_RO NULL
#define OPTION_VAL_360_RO NULL
#define OPTION_VAL_370_RO NULL
#define OPTION_VAL_380_RO NULL
#define OPTION_VAL_390_RO NULL
#define OPTION_VAL_400_RO NULL
#define OPTION_VAL_410_RO NULL
#define OPTION_VAL_420_RO NULL
#define OPTION_VAL_430_RO NULL
#define OPTION_VAL_440_RO NULL
#define OPTION_VAL_450_RO NULL
#define OPTION_VAL_460_RO NULL
#define OPTION_VAL_470_RO NULL
#define OPTION_VAL_480_RO NULL
#define OPTION_VAL_490_RO NULL
#define OPTION_VAL_500_RO NULL
#define OPTION_VAL_510_RO NULL
#define OPTION_VAL_520_RO NULL
#define OPTION_VAL_530_RO NULL
#define OPTION_VAL_540_RO NULL
#define OPTION_VAL_550_RO NULL
#define OPTION_VAL_560_RO NULL
#define OPTION_VAL_570_RO NULL
#define OPTION_VAL_580_RO NULL
#define OPTION_VAL_590_RO NULL
#define OPTION_VAL_600_RO NULL
#define OPTION_VAL_610_RO NULL
#define OPTION_VAL_620_RO NULL
#define OPTION_VAL_630_RO NULL
#define OPTION_VAL_640_RO NULL
#define OPTION_VAL_650_RO NULL
#define OPTION_VAL_660_RO NULL
#define OPTION_VAL_670_RO NULL
#define OPTION_VAL_680_RO NULL
#define OPTION_VAL_690_RO NULL
#define OPTION_VAL_700_RO NULL
#define OPTION_VAL_710_RO NULL
#define OPTION_VAL_720_RO NULL
#define OPTION_VAL_730_RO NULL
#define OPTION_VAL_740_RO NULL
#define OPTION_VAL_750_RO NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_RO NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_RO NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_RO NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_RO NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_RO NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_RO NULL
#define OPTION_VAL_PSXONPSP_RO NULL
#define OPTION_VAL_PS1_ROM_RO NULL
#define BEETLE_OPT_RENDERER_LABEL_RO NULL
#define BEETLE_OPT_RENDERER_INFO_0_RO NULL
#define OPTION_VAL_HARDWARE_RO NULL
#define OPTION_VAL_HARDWARE_GL_RO NULL
#define OPTION_VAL_HARDWARE_VK_RO NULL
#define OPTION_VAL_SOFTWARE_RO NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_RO NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_RO NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_RO NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_RO NULL
#define OPTION_VAL_DISABLED_RO NULL
#define OPTION_VAL_EXECUTE_RO NULL
#define OPTION_VAL_EXECUTE_ONE_RO NULL
#define OPTION_VAL_RUN_INTERPRETER_RO NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_RO NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_RO NULL
#define OPTION_VAL_FULL_RO NULL
#define OPTION_VAL_DMA_RO NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_RO NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_RO NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_RO NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_RO NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_RO NULL
#define OPTION_VAL_FORCE_INTERLACED_RO NULL
#define OPTION_VAL_AUTO_TOGGLE_RO NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_RO NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_RO NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_RO NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_RO NULL
#define OPTION_VAL_DISABLED_O53_RO NULL
#define OPTION_VAL_STATIC_RO NULL
#define OPTION_VAL_SMART_RO NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_RO NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_RO NULL
#define OPTION_VAL_9PX_RO NULL
#define OPTION_VAL_10PX_RO NULL
#define OPTION_VAL_11PX_RO NULL
#define OPTION_VAL_12PX_RO NULL
#define OPTION_VAL_13PX_RO NULL
#define OPTION_VAL_14PX_RO NULL
#define OPTION_VAL_15PX_RO NULL
#define OPTION_VAL_16PX_RO NULL
#define OPTION_VAL_17PX_RO NULL
#define OPTION_VAL_18PX_RO NULL
#define OPTION_VAL_19PX_RO NULL
#define OPTION_VAL_20PX_RO NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_RO NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_RO NULL
#define OPTION_VAL_12PX_O55_RO NULL
#define OPTION_VAL_11PX_O55_RO NULL
#define OPTION_VAL_10PX_O55_RO NULL
#define OPTION_VAL_9PX_O55_RO NULL
#define OPTION_VAL_8PX_O55_RO NULL
#define OPTION_VAL_7PX_O55_RO NULL
#define OPTION_VAL_6PX_O55_RO NULL
#define OPTION_VAL_5PX_O55_RO NULL
#define OPTION_VAL_4PX_O55_RO NULL
#define OPTION_VAL_3PX_O55_RO NULL
#define OPTION_VAL_2PX_O55_RO NULL
#define OPTION_VAL_1PX_O55_RO NULL
#define OPTION_VAL_DISABLED_O55_RO NULL
#define OPTION_VAL_1PX_O55_0_RO NULL
#define OPTION_VAL_2PX_O55_0_RO NULL
#define OPTION_VAL_3PX_O55_0_RO NULL
#define OPTION_VAL_4PX_O55_0_RO NULL
#define OPTION_VAL_5PX_O55_0_RO NULL
#define OPTION_VAL_6PX_O55_0_RO NULL
#define OPTION_VAL_7PX_O55_0_RO NULL
#define OPTION_VAL_8PX_O55_0_RO NULL
#define OPTION_VAL_9PX_O55_0_RO NULL
#define OPTION_VAL_10PX_O55_0_RO NULL
#define OPTION_VAL_11PX_O55_0_RO NULL
#define OPTION_VAL_12PX_O55_0_RO NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_RO NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_RO NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_RO NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_RO NULL
#define OPTION_VAL_32X_RO NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_RO NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_RO NULL
#define OPTION_VAL_CORRECTED_RO NULL
#define OPTION_VAL_UNCORRECTED_RO NULL
#define OPTION_VAL_4_3_RO NULL
#define OPTION_VAL_NTSC_RO NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_RO NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_RO NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_RO NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_RO NULL
#define OPTION_VAL_239_RO NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_RO NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_RO NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_RO NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_RO NULL
#define OPTION_VAL_287_RO NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_RO NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_RO NULL
#define OPTION_VAL_SYNC_RO NULL
#define OPTION_VAL_ASYNC_RO NULL
#define OPTION_VAL_PRECACHE_RO NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_RO NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_RO NULL
#define OPTION_VAL_2X_NATIVE_RO NULL
#define OPTION_VAL_6X_RO NULL
#define OPTION_VAL_10X_RO NULL
#define OPTION_VAL_12X_RO NULL
#define OPTION_VAL_14X_RO NULL

struct retro_core_option_v2_category option_cats_ro[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_RO,
      CATEGORY_VIDEO_INFO_0_RO
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_RO,
      CATEGORY_OSD_INFO_0_RO
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_RO,
      CATEGORY_INPUT_INFO_0_RO
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_RO,
      CATEGORY_MEMCARDS_INFO_0_RO
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_RO,
      CATEGORY_PGXP_INFO_0_RO
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_RO,
      CATEGORY_HACKS_INFO_0_RO
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_ro[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_RO,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_RO,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_RO },
         { "2x",         OPTION_VAL_2X_RO },
         { "4x",         OPTION_VAL_4X_RO },
         { "8x",         OPTION_VAL_8X_RO },
         { "16x",        OPTION_VAL_16X_RO },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_RO,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_RO,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_RO },
         { "32bpp",         OPTION_VAL_32BPP_RO },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_RO,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_RO,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_RO },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_RO },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_RO,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_RO,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_RO,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_RO,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_RO },
         { "SABR",     OPTION_VAL_SABR_RO },
         { "xBR",      OPTION_VAL_XBR_RO },
         { "bilinear", OPTION_VAL_BILINEAR_RO },
         { "3-point",  OPTION_VAL_3_POINT_RO },
         { "JINC2",    OPTION_VAL_JINC2_RO },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_RO,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_RO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_RO },
         { "all", OPTION_VAL_ALL_RO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_RO,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_RO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_RO },
         { "all", OPTION_VAL_ALL_RO },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_RO,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_RO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_RO,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_RO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_RO,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_RO,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_RO },
         { "2x",  OPTION_VAL_2X_RO },
         { "4x",  OPTION_VAL_4X_RO },
         { "8x",  OPTION_VAL_8X_RO },
         { "16x", OPTION_VAL_16X_RO },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_RO,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_RO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_RO,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_RO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_RO,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_RO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_RO,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_RO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_RO,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_RO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_RO,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_RO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_RO,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_RO,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_RO,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_RO,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_RO,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_RO,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_RO,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_RO,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_RO,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_RO,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_RO,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_RO,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_RO,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_RO,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_RO },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_RO },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_RO,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_RO,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_RO },
         { "dot",   OPTION_VAL_DOT_RO },
         { "off",   OPTION_VAL_OFF_RO },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_RO,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_RO,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_RO },
         { "blue", OPTION_VAL_BLUE_RO },
         { "green", OPTION_VAL_GREEN_RO },
         { "orange", OPTION_VAL_ORANGE_RO },
         { "yellow", OPTION_VAL_YELLOW_RO },
         { "cyan", OPTION_VAL_CYAN_RO },
         { "pink", OPTION_VAL_PINK_RO },
         { "purple", OPTION_VAL_PURPLE_RO },
         { "black", OPTION_VAL_BLACK_RO },
         { "white", OPTION_VAL_WHITE_RO },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_RO,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_RO,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_RO },
         { "red", OPTION_VAL_RED_RO },
         { "green", OPTION_VAL_GREEN_RO },
         { "orange", OPTION_VAL_ORANGE_RO },
         { "yellow", OPTION_VAL_YELLOW_RO },
         { "cyan", OPTION_VAL_CYAN_RO },
         { "pink", OPTION_VAL_PINK_RO },
         { "purple", OPTION_VAL_PURPLE_RO },
         { "black", OPTION_VAL_BLACK_RO },
         { "white", OPTION_VAL_WHITE_RO },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_RO,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_RO,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_RO },
         { "10%",  OPTION_VAL_10_RO },
         { "15%",  OPTION_VAL_15_RO },
         { "20%",  OPTION_VAL_20_RO },
         { "25%",  OPTION_VAL_25_RO },
         { "30%",  OPTION_VAL_30_RO },
         { "35%",  OPTION_VAL_35_RO },
         { "40%",  OPTION_VAL_40_RO },
         { "45%",  OPTION_VAL_45_RO },
         { "50%",  OPTION_VAL_50_RO },
         { "55%",  OPTION_VAL_55_RO },
         { "60%",  OPTION_VAL_60_RO },
         { "65%",  OPTION_VAL_65_RO },
         { "70%",  OPTION_VAL_70_RO },
         { "75%",  OPTION_VAL_75_RO },
         { "80%",  OPTION_VAL_80_RO },
         { "85%",  OPTION_VAL_85_RO },
         { "90%",  OPTION_VAL_90_RO },
         { "95%",  OPTION_VAL_95_RO },
         { "100%", OPTION_VAL_100_RO },
         { "105%", OPTION_VAL_105_RO },
         { "110%", OPTION_VAL_110_RO },
         { "115%", OPTION_VAL_115_RO },
         { "120%", OPTION_VAL_120_RO },
         { "125%", OPTION_VAL_125_RO },
         { "130%", OPTION_VAL_130_RO },
         { "135%", OPTION_VAL_135_RO },
         { "140%", OPTION_VAL_140_RO },
         { "145%", OPTION_VAL_145_RO },
         { "150%", OPTION_VAL_150_RO },
         { "155%", OPTION_VAL_155_RO },
         { "160%", OPTION_VAL_160_RO },
         { "165%", OPTION_VAL_165_RO },
         { "170%", OPTION_VAL_170_RO },
         { "175%", OPTION_VAL_175_RO },
         { "180%", OPTION_VAL_180_RO },
         { "185%", OPTION_VAL_185_RO },
         { "190%", OPTION_VAL_190_RO },
         { "195%", OPTION_VAL_195_RO },
         { "200%", OPTION_VAL_200_RO },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_RO,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_RO,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_RO },
         { "quadratic", OPTION_VAL_QUADRATIC_RO },
         { "cubic",     OPTION_VAL_CUBIC_RO },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_RO,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_RO,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_RO },
         { "5%",  OPTION_VAL_5_RO },
         { "10%", OPTION_VAL_10_RO },
         { "15%", OPTION_VAL_15_RO },
         { "20%", OPTION_VAL_20_RO },
         { "25%", OPTION_VAL_25_RO },
         { "30%", OPTION_VAL_30_RO },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_RO,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_RO,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_RO },
         { "mednafen", OPTION_VAL_MEDNAFEN_RO },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_RO,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_RO,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_RO,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_RO,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_RO,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_RO,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_RO,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_RO,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_RO },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_RO,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_RO,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_RO },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_RO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_RO,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_RO,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_RO },
         { "1px", OPTION_VAL_1PX_RO },
         { "2px", OPTION_VAL_2PX_RO },
         { "3px", OPTION_VAL_3PX_RO },
         { "4px", OPTION_VAL_4PX_RO },
         { "5px", OPTION_VAL_5PX_RO },
         { "6px", OPTION_VAL_6PX_RO },
         { "7px", OPTION_VAL_7PX_RO },
         { "8px", OPTION_VAL_8PX_RO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_RO,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_RO,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_RO,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_RO,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_RO,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_RO,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_RO,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_RO,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_RO },
         { "aggressive", OPTION_VAL_AGGRESSIVE_RO },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_RO,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_RO,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_RO,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_RO,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_RO },
         { "16:10", OPTION_VAL_16_10_RO },
         { "18:9",  OPTION_VAL_18_9_RO },
         { "19:9",  OPTION_VAL_19_9_RO },
         { "20:9",  OPTION_VAL_20_9_RO },
         { "21:9",  OPTION_VAL_21_9_RO }, // 64:27
         { "32:9",  OPTION_VAL_32_9_RO },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_RO,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_RO,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_RO },
         { "60%",           OPTION_VAL_60_RO },
         { "70%",           OPTION_VAL_70_RO },
         { "80%",           OPTION_VAL_80_RO },
         { "90%",           OPTION_VAL_90_RO },
         { "100%(native)", OPTION_VAL_100_NATIVE_RO },
         { "110%",          OPTION_VAL_110_RO },
         { "120%",          OPTION_VAL_120_RO },
         { "130%",          OPTION_VAL_130_RO },
         { "140%",          OPTION_VAL_140_RO },
         { "150%",          OPTION_VAL_150_RO },
         { "160%",          OPTION_VAL_160_RO },
         { "170%",          OPTION_VAL_170_RO },
         { "180%",          OPTION_VAL_180_RO },
         { "190%",          OPTION_VAL_190_RO },
         { "200%",          OPTION_VAL_200_RO },
         { "210%",          OPTION_VAL_210_RO },
         { "220%",          OPTION_VAL_220_RO },
         { "230%",          OPTION_VAL_230_RO },
         { "240%",          OPTION_VAL_240_RO },
         { "250%",          OPTION_VAL_250_RO },
         { "260%",          OPTION_VAL_260_RO },
         { "270%",          OPTION_VAL_270_RO },
         { "280%",          OPTION_VAL_280_RO },
         { "290%",          OPTION_VAL_290_RO },
         { "300%",          OPTION_VAL_300_RO },
         { "310%",          OPTION_VAL_310_RO },
         { "320%",          OPTION_VAL_320_RO },
         { "330%",          OPTION_VAL_330_RO },
         { "340%",          OPTION_VAL_340_RO },
         { "350%",          OPTION_VAL_350_RO },
         { "360%",          OPTION_VAL_360_RO },
         { "370%",          OPTION_VAL_370_RO },
         { "380%",          OPTION_VAL_380_RO },
         { "390%",          OPTION_VAL_390_RO },
         { "400%",          OPTION_VAL_400_RO },
         { "410%",          OPTION_VAL_410_RO },
         { "420%",          OPTION_VAL_420_RO },
         { "430%",          OPTION_VAL_430_RO },
         { "440%",          OPTION_VAL_440_RO },
         { "450%",          OPTION_VAL_450_RO },
         { "460%",          OPTION_VAL_460_RO },
         { "470%",          OPTION_VAL_470_RO },
         { "480%",          OPTION_VAL_480_RO },
         { "490%",          OPTION_VAL_490_RO },
         { "500%",          OPTION_VAL_500_RO },
         { "510%",          OPTION_VAL_510_RO },
         { "520%",          OPTION_VAL_520_RO },
         { "530%",          OPTION_VAL_530_RO },
         { "540%",          OPTION_VAL_540_RO },
         { "550%",          OPTION_VAL_550_RO },
         { "560%",          OPTION_VAL_560_RO },
         { "570%",          OPTION_VAL_570_RO },
         { "580%",          OPTION_VAL_580_RO },
         { "590%",          OPTION_VAL_590_RO },
         { "600%",          OPTION_VAL_600_RO },
         { "610%",          OPTION_VAL_610_RO },
         { "620%",          OPTION_VAL_620_RO },
         { "630%",          OPTION_VAL_630_RO },
         { "640%",          OPTION_VAL_640_RO },
         { "650%",          OPTION_VAL_650_RO },
         { "660%",          OPTION_VAL_660_RO },
         { "670%",          OPTION_VAL_670_RO },
         { "680%",          OPTION_VAL_680_RO },
         { "690%",          OPTION_VAL_690_RO },
         { "700%",          OPTION_VAL_700_RO },
         { "710%",          OPTION_VAL_710_RO },
         { "720%",          OPTION_VAL_720_RO },
         { "730%",          OPTION_VAL_730_RO },
         { "740%",          OPTION_VAL_740_RO },
         { "750%",          OPTION_VAL_750_RO },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_RO,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_RO,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_RO,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_RO,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_RO,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_RO,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_RO },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_RO },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_RO,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_RO,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_RO },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_RO },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_RO },
#endif
         { "software",    OPTION_VAL_SOFTWARE_RO },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_RO,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_RO,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_RO,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_RO,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_RO },
         { "execute",  OPTION_VAL_EXECUTE_RO },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_RO },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_RO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_RO,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_RO,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_RO },
         { "dma",  OPTION_VAL_DMA_RO },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_RO,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_RO,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_RO,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_RO,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_RO },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_RO },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_RO },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_RO,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_RO,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_RO,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_RO,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_RO },
         { "static",  OPTION_VAL_STATIC_RO },
         { "smart", OPTION_VAL_SMART_RO },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_RO,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_RO,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_RO },
         { "2px",      OPTION_VAL_2PX_RO },
         { "3px",      OPTION_VAL_3PX_RO },
         { "4px",      OPTION_VAL_4PX_RO },
         { "5px",      OPTION_VAL_5PX_RO },
         { "6px",      OPTION_VAL_6PX_RO },
         { "7px",      OPTION_VAL_7PX_RO },
         { "8px",      OPTION_VAL_8PX_RO },
         { "9px",      OPTION_VAL_9PX_RO },
         { "10px",     OPTION_VAL_10PX_RO },
         { "11px",     OPTION_VAL_11PX_RO },
         { "12px",     OPTION_VAL_12PX_RO },
         { "13px",     OPTION_VAL_13PX_RO },
         { "14px",     OPTION_VAL_14PX_RO },
         { "15px",     OPTION_VAL_15PX_RO },
         { "16px",     OPTION_VAL_16PX_RO },
         { "17px",     OPTION_VAL_17PX_RO },
         { "18px",     OPTION_VAL_18PX_RO },
         { "19px",     OPTION_VAL_19PX_RO },
         { "20px",     OPTION_VAL_20PX_RO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_RO,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_RO,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_RO },
         { "-11px",    OPTION_VAL_11PX_O55_RO },
         { "-10px",    OPTION_VAL_10PX_O55_RO },
         { "-9px",     OPTION_VAL_9PX_O55_RO },
         { "-8px",     OPTION_VAL_8PX_O55_RO },
         { "-7px",     OPTION_VAL_7PX_O55_RO },
         { "-6px",     OPTION_VAL_6PX_O55_RO },
         { "-5px",     OPTION_VAL_5PX_O55_RO },
         { "-4px",     OPTION_VAL_4PX_O55_RO },
         { "-3px",     OPTION_VAL_3PX_O55_RO },
         { "-2px",     OPTION_VAL_2PX_O55_RO },
         { "-1px",     OPTION_VAL_1PX_O55_RO },
         { "disabled", OPTION_VAL_DISABLED_O55_RO },
         { "+1px",     OPTION_VAL_1PX_O55_0_RO },
         { "+2px",     OPTION_VAL_2PX_O55_0_RO },
         { "+3px",     OPTION_VAL_3PX_O55_0_RO },
         { "+4px",     OPTION_VAL_4PX_O55_0_RO },
         { "+5px",     OPTION_VAL_5PX_O55_0_RO },
         { "+6px",     OPTION_VAL_6PX_O55_0_RO },
         { "+7px",     OPTION_VAL_7PX_O55_0_RO },
         { "+8px",     OPTION_VAL_8PX_O55_0_RO },
         { "+9px",     OPTION_VAL_9PX_O55_0_RO },
         { "+10px",    OPTION_VAL_10PX_O55_0_RO },
         { "+11px",    OPTION_VAL_11PX_O55_0_RO },
         { "+12px",    OPTION_VAL_12PX_O55_0_RO },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_RO,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_RO,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_RO },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_RO,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_RO,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_RO },
         { "2x",         OPTION_VAL_2X_RO },
         { "4x",         OPTION_VAL_4X_RO },
         { "8x",         OPTION_VAL_8X_RO },
         { "16x",        OPTION_VAL_16X_RO },
         { "32x",        OPTION_VAL_32X_RO },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_RO,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_RO,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_RO },
         { "uncorrected", OPTION_VAL_UNCORRECTED_RO },
         { "4:3",  OPTION_VAL_4_3_RO },
         { "ntsc", OPTION_VAL_NTSC_RO },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_RO,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_RO,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_RO,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_RO,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_RO },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_RO,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_RO,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_RO,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_RO,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_RO },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_RO,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_RO,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_RO },
         { "async",    OPTION_VAL_ASYNC_RO },
         { "precache", OPTION_VAL_PRECACHE_RO },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_RO,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_RO,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_RO },
         { "4x",          OPTION_VAL_4X_RO },
         { "6x",          OPTION_VAL_6X_RO },
         { "8x",          OPTION_VAL_8X_RO },
         { "10x",         OPTION_VAL_10X_RO },
         { "12x",         OPTION_VAL_12X_RO },
         { "14x",         OPTION_VAL_14X_RO },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_ro = {
   option_cats_ro,
   option_defs_ro
};

/* RETRO_LANGUAGE_RU */

#define CATEGORY_VIDEO_LABEL_RU "Видео"
#define CATEGORY_VIDEO_INFO_0_RU "Настройки соотношения сторон, кадрирования, графических фильтров и пропуска кадров."
#define CATEGORY_OSD_LABEL_RU "Экранные уведомления"
#define CATEGORY_OSD_INFO_0_RU "Настройки отображаемых на экране уведомлений."
#define CATEGORY_INPUT_LABEL_RU "Ввод"
#define CATEGORY_INPUT_INFO_0_RU "Настройки светового пистолета, мыши и neGcon."
#define CATEGORY_MEMCARDS_LABEL_RU "Карты памяти"
#define CATEGORY_MEMCARDS_INFO_0_RU "Настройка параметров используемых системой виртуальных карт памяти."
#define CATEGORY_PGXP_LABEL_RU NULL
#define CATEGORY_PGXP_INFO_0_RU "Настройки улучшений, позволяющих добиться качества графики выше уровня оригинальной консоли. PGXP помогает избавиться от деформации текстур и Z-конфликтов."
#define CATEGORY_HACKS_LABEL_RU "Хаки эмуляции"
#define CATEGORY_HACKS_INFO_0_RU "Настройка разгона процессора и параметров точности эмуляции, влияющих на производительность и совместимость."
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_RU "Внутреннее разрешение GPU"
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_RU "Установка множителя внутреннего разрешения. Значения выше '1x (нативное)' улучшают качество 3D-моделей, но повышают требования к мощности устройства. Данная настройка, как правило, не влияет на 2D-элементы."
#define OPTION_VAL_1X_NATIVE_RU "1x (нативное)"
#define OPTION_VAL_2X_RU NULL
#define OPTION_VAL_4X_RU NULL
#define OPTION_VAL_8X_RU NULL
#define OPTION_VAL_16X_RU NULL
#define BEETLE_OPT_DEPTH_LABEL_RU "Внутренняя глубина цвета"
#define BEETLE_OPT_DEPTH_INFO_0_RU "Установка внутренней глубины цвета. Высокая глубина цвета позволяет скрывать ступенчатые градиенты (бандинг), не используя дизеринг. '16 бит/пкс' имитирует оригинальную консоль, но при откл. дизеринге делает заметным бандинг. При выборе '32 бит/пкс' рекомендуется отключать опцию 'Паттерн дизеринга'."
#define OPTION_VAL_16BPP_NATIVE_RU "16 бит/пкс (нативная)"
#define OPTION_VAL_32BPP_RU "32 бит/пкс"
#define BEETLE_OPT_DITHER_MODE_LABEL_RU "Паттерн дизеринга"
#define BEETLE_OPT_DITHER_MODE_INFO_0_RU "Выбор конфигурации паттерна дизеринга. '1x (нативно)' имитирует дизеринг в оригинальном низком разрешении консоли, используемого для смягчения ступенчатых градиентов, заметных при нативной глубине цвета. 'Внутреннее разрешение' масштабирует плотность дизеринга под внутр. разрешение для лучшего эффекта. Рекомендуется откл. при выборе 32-битной глубины цвета. Примечание: при рендеринге на Vulkan включение опции активирует принудительный даунсэмплинг до нативной глубины цвета, а отключение автоматически вкл. высокую глубину цвета."
#define OPTION_VAL_INTERNAL_RESOLUTION_RU "Внутреннее разрешение"
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_RU "Смещение текстур по UV"
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_RU "Сэмплировать текстуры для 3D-полигонов, смещаемых при внутреннем разрешении выше 1x. Скрывает стыки текстур, но приводит к случайным проблемам с графикой."
#define BEETLE_OPT_FILTER_LABEL_RU "Сглаживание текстур"
#define BEETLE_OPT_FILTER_INFO_0_RU NULL
#define OPTION_VAL_NEAREST_RU "Метод ближайшего соседа"
#define OPTION_VAL_SABR_RU NULL
#define OPTION_VAL_XBR_RU NULL
#define OPTION_VAL_BILINEAR_RU "Билинейное"
#define OPTION_VAL_3_POINT_RU "По трём точкам"
#define OPTION_VAL_JINC2_RU NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_RU "Исключать из фильтрации спрайты"
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_RU NULL
#define OPTION_VAL_OPAQUE_RU "Только непрозрачные"
#define OPTION_VAL_ALL_RU "Непрозрачные и полупрозрачные"
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_RU "Исключать из фильтрации 2D-полигоны"
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_RU "Не применять фильтрацию текстур к 2D-полигонам. 2D-полигоны определяются эвристически, поэтому возможны искажения графики. Для лучшего эффекта используйте вместе с опцией 'Адаптивное сглаживание' или другим фильтром пост-обработки."
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_RU "Адаптивное сглаживание"
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_RU NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_RU "Суперсэмплинг (понижать до нативного разрешения)"
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_RU NULL
#define BEETLE_OPT_MSAA_LABEL_RU "Множественная выборка сглаживания"
#define BEETLE_OPT_MSAA_INFO_0_RU NULL
#define OPTION_VAL_1X_RU NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_RU "Сглаживание YUV MDEC"
#define BEETLE_OPT_MDEC_YUV_INFO_0_RU NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_RU "Отслеживать текстуры"
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_RU "Требуется для выгрузки и замещения текстур. В большинстве игр будет приводить к вылетам."
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_RU "Дамп текстур"
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_RU NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_RU "Замена текстур"
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_RU NULL
#define BEETLE_OPT_WIREFRAME_LABEL_RU "Режим каркаса (отладка)"
#define BEETLE_OPT_WIREFRAME_INFO_0_RU NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_RU "Дублирование кадра (ускорение)"
#define BEETLE_OPT_FRAME_DUPING_INFO_0_RU NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_RU "Показывать частоту кадров"
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_RU "Отображать внутреннюю частоту кадров, с которой эмулируемая PlayStation производит рендеринг. Примечание: требуется включение уведомлений в настройках фронтенда."
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_RU "Показывать VRAM (отладка)"
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_RU NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_RU "Автокалибровка аналогового ввода"
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_RU NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_RU "Переключатель аналогового режима DualShock"
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_RU NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_RU "Multitap подключен в порт 1"
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_RU NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_RU "Multitap подключен в порт 2"
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_RU NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_RU "Режим светового пистолета"
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_RU NULL
#define OPTION_VAL_LIGHTGUN_RU "Световой пистолет"
#define OPTION_VAL_TOUCHSCREEN_RU "Сенсорный экран"
#define BEETLE_OPT_GUN_CURSOR_LABEL_RU "Курсор пистолета"
#define BEETLE_OPT_GUN_CURSOR_INFO_0_RU NULL
#define OPTION_VAL_CROSS_RU "Перекрестье"
#define OPTION_VAL_DOT_RU "Точка"
#define OPTION_VAL_OFF_RU NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_RU "Порт 1: цвет прицела"
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_RU NULL
#define OPTION_VAL_RED_RU "Красный"
#define OPTION_VAL_BLUE_RU "Голубой"
#define OPTION_VAL_GREEN_RU "Зелёный"
#define OPTION_VAL_ORANGE_RU "Оранжевый"
#define OPTION_VAL_YELLOW_RU "Жёлтый"
#define OPTION_VAL_CYAN_RU "Сине-зелёный"
#define OPTION_VAL_PINK_RU "Розовый"
#define OPTION_VAL_PURPLE_RU "Фиолетовый"
#define OPTION_VAL_BLACK_RU "Чёрный"
#define OPTION_VAL_WHITE_RU "Белый"
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_RU "Порт 1: цвет прицела"
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_RU NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_RU "Чувствительность мыши"
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_RU NULL
#define OPTION_VAL_5_RU NULL
#define OPTION_VAL_10_RU NULL
#define OPTION_VAL_15_RU NULL
#define OPTION_VAL_20_RU NULL
#define OPTION_VAL_25_RU NULL
#define OPTION_VAL_30_RU NULL
#define OPTION_VAL_35_RU NULL
#define OPTION_VAL_40_RU NULL
#define OPTION_VAL_45_RU NULL
#define OPTION_VAL_50_RU NULL
#define OPTION_VAL_55_RU NULL
#define OPTION_VAL_60_RU NULL
#define OPTION_VAL_65_RU NULL
#define OPTION_VAL_70_RU NULL
#define OPTION_VAL_75_RU NULL
#define OPTION_VAL_80_RU NULL
#define OPTION_VAL_85_RU NULL
#define OPTION_VAL_90_RU NULL
#define OPTION_VAL_95_RU NULL
#define OPTION_VAL_100_RU NULL
#define OPTION_VAL_105_RU NULL
#define OPTION_VAL_110_RU NULL
#define OPTION_VAL_115_RU NULL
#define OPTION_VAL_120_RU NULL
#define OPTION_VAL_125_RU NULL
#define OPTION_VAL_130_RU NULL
#define OPTION_VAL_135_RU NULL
#define OPTION_VAL_140_RU NULL
#define OPTION_VAL_145_RU NULL
#define OPTION_VAL_150_RU NULL
#define OPTION_VAL_155_RU NULL
#define OPTION_VAL_160_RU NULL
#define OPTION_VAL_165_RU NULL
#define OPTION_VAL_170_RU NULL
#define OPTION_VAL_175_RU NULL
#define OPTION_VAL_180_RU NULL
#define OPTION_VAL_185_RU NULL
#define OPTION_VAL_190_RU NULL
#define OPTION_VAL_195_RU NULL
#define OPTION_VAL_200_RU NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_RU NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_RU NULL
#define OPTION_VAL_LINEAR_RU "Линейный"
#define OPTION_VAL_QUADRATIC_RU "Квадратичный"
#define OPTION_VAL_CUBIC_RU "Кубический"
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_RU NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_RU NULL
#define OPTION_VAL_0_RU NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_RU "Формат карты памяти 0 (требуется перезапуск)"
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_RU "Выбор формата сохранения данных для карты памяти 0. 'Mednafen' может использоваться для совместимости с отдельной версией Mednafen. При использовании с Beetle PSX, файлы сохранений Libretro (.srm) и Mednafen (.mcr) имеют идентичный формат и могут быть сконвертированы через переименование."
#define OPTION_VAL_LIBRETRO_RU NULL
#define OPTION_VAL_MEDNAFEN_RU NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_RU "Включить карту памяти 1 (требуется перезапуск)"
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_RU NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_RU "Общие карты памяти (требуется перезапуск)"
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_RU "При включении все игры будут использовать одни файлы карт памяти для сохранения и загрузки. При отключении для каждой игры создаются индивидуальные карты памяти. Примечание: если опция 'Формат карты памяти 0' имеет значение 'Libretro', настройка будет затрагивать только правую карту памяти."
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_RU "Индекс карты памяти слева"
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_RU NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_RU "Номер карты памяти справа"
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_RU NULL
#define OPTION_VAL_1_RU NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_RU "Режим работы PGXP"
#define BEETLE_OPT_PGXP_MODE_INFO_0_RU "Позволяет выполнять рендеринг 3D с субпиксельной точностью, минимизируя искажение и дрожание 3D-объектов, имеющих место на оригинальной консоли из-за использования координат вершин с фиксированной запятой. Режим 'Только память' обладает лучшей совместимостью и рекомендован для обычного использования. Режим 'Память + CPU (нестабильно)' ещё сильнее уменьшает дрожание, но повышает нагрузку на устройство и может вызывать искажения геометрии."
#define OPTION_VAL_MEMORY_ONLY_RU "Только память"
#define OPTION_VAL_MEMORY_CPU_RU "Память + CPU (нестабильно)"
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_RU "Допуск 2D-геометрии PGXP"
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_RU "Скрывает больше выраженных ошибок при операциях PGXP: настройка задаёт область допуска значений PGXP, используемых для геометрий без точной информации о глубине."
#define OPTION_VAL_0PX_RU "0 пикс."
#define OPTION_VAL_1PX_RU "1 пикс."
#define OPTION_VAL_2PX_RU "2 пикс."
#define OPTION_VAL_3PX_RU "3 пикс."
#define OPTION_VAL_4PX_RU "4 пикс."
#define OPTION_VAL_5PX_RU "5 пикс."
#define OPTION_VAL_6PX_RU "6 пикс."
#define OPTION_VAL_7PX_RU "7 пикс."
#define OPTION_VAL_8PX_RU "8 пикс."
#define BEETLE_OPT_PGXP_NCLIP_LABEL_RU "Отбраковка примитивов PGXP"
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_RU "Использовать PGXP-реализацию NCLIP. Улучшает графику за счёт уменьшения провалов в геометрии с помощью PGXP-координат. В некоторых случаях может приводить к зависанию игр."
#define BEETLE_OPT_PGXP_VERTEX_LABEL_RU "Вершинный кэш PGXP"
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_RU NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_RU "Перспективно-корректное текстурирование PGXP"
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_RU NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_RU "Хак линия-в-четырёхугольник"
#define BEETLE_OPT_LINE_RENDER_INFO_0_RU "Способ хака линия-в-четырёхугольник. В ряде игр (напр. Doom, Hexen, Soul Blade и др.) отрисовка горизонтальных линий производится путём растягивания на весь экран треугольников высотой в один пиксель, которые на оригинальной консоли растеризуются как ряд пикселей. Данный хак определяет эти небольшие треугольники и преобразует их в четырёхугольники для правильного вывода аппаратными рендерами и при апскейлинге. 'Агрессивный' необходим для ряда игр (напр. Dark Forces, Duke Nukem), но также может вызывать ошибки графики. Если не уверены, оставьте 'Стандартный'."
#define OPTION_VAL_DEFAULT_RU "Стандартный"
#define OPTION_VAL_AGGRESSIVE_RU "Агрессивный"
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_RU "Широкоформатный хак"
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_RU NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_RU "Пропорции экрана с широкоформатным хаком"
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_RU NULL
#define OPTION_VAL_16_9_RU NULL
#define OPTION_VAL_16_10_RU NULL
#define OPTION_VAL_18_9_RU NULL
#define OPTION_VAL_19_9_RU NULL
#define OPTION_VAL_20_9_RU NULL
#define OPTION_VAL_21_9_RU NULL
#define OPTION_VAL_32_9_RU NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_RU "Масштабирование частоты CPU (разгон)"
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_RU NULL
#define OPTION_VAL_100_NATIVE_RU "100% (нативно)"
#define OPTION_VAL_210_RU NULL
#define OPTION_VAL_220_RU NULL
#define OPTION_VAL_230_RU NULL
#define OPTION_VAL_240_RU NULL
#define OPTION_VAL_250_RU NULL
#define OPTION_VAL_260_RU NULL
#define OPTION_VAL_270_RU NULL
#define OPTION_VAL_280_RU NULL
#define OPTION_VAL_290_RU NULL
#define OPTION_VAL_300_RU NULL
#define OPTION_VAL_310_RU NULL
#define OPTION_VAL_320_RU NULL
#define OPTION_VAL_330_RU NULL
#define OPTION_VAL_340_RU NULL
#define OPTION_VAL_350_RU NULL
#define OPTION_VAL_360_RU NULL
#define OPTION_VAL_370_RU NULL
#define OPTION_VAL_380_RU NULL
#define OPTION_VAL_390_RU NULL
#define OPTION_VAL_400_RU NULL
#define OPTION_VAL_410_RU NULL
#define OPTION_VAL_420_RU NULL
#define OPTION_VAL_430_RU NULL
#define OPTION_VAL_440_RU NULL
#define OPTION_VAL_450_RU NULL
#define OPTION_VAL_460_RU NULL
#define OPTION_VAL_470_RU NULL
#define OPTION_VAL_480_RU NULL
#define OPTION_VAL_490_RU NULL
#define OPTION_VAL_500_RU NULL
#define OPTION_VAL_510_RU NULL
#define OPTION_VAL_520_RU NULL
#define OPTION_VAL_530_RU NULL
#define OPTION_VAL_540_RU NULL
#define OPTION_VAL_550_RU NULL
#define OPTION_VAL_560_RU NULL
#define OPTION_VAL_570_RU NULL
#define OPTION_VAL_580_RU NULL
#define OPTION_VAL_590_RU NULL
#define OPTION_VAL_600_RU NULL
#define OPTION_VAL_610_RU NULL
#define OPTION_VAL_620_RU NULL
#define OPTION_VAL_630_RU NULL
#define OPTION_VAL_640_RU NULL
#define OPTION_VAL_650_RU NULL
#define OPTION_VAL_660_RU NULL
#define OPTION_VAL_670_RU NULL
#define OPTION_VAL_680_RU NULL
#define OPTION_VAL_690_RU NULL
#define OPTION_VAL_700_RU NULL
#define OPTION_VAL_710_RU NULL
#define OPTION_VAL_720_RU NULL
#define OPTION_VAL_730_RU NULL
#define OPTION_VAL_740_RU NULL
#define OPTION_VAL_750_RU NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_RU "Разгон GTE"
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_RU NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_RU "Пропускать BIOS"
#define BEETLE_OPT_SKIP_BIOS_INFO_0_RU NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_RU NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_RU "Заменяет BIOS определённого региона на образ без региональной привязки."
#define OPTION_VAL_PSXONPSP_RU NULL
#define OPTION_VAL_PS1_ROM_RU NULL
#define BEETLE_OPT_RENDERER_LABEL_RU "Графический движок (требуется перезапуск)"
#define BEETLE_OPT_RENDERER_INFO_0_RU NULL
#define OPTION_VAL_HARDWARE_RU "Аппаратный (авто)"
#define OPTION_VAL_HARDWARE_GL_RU "Аппаратный (OpenGL)"
#define OPTION_VAL_HARDWARE_VK_RU "Аппаратный (Vulkan)"
#define OPTION_VAL_SOFTWARE_RU "Программный"
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_RU "Программный фреймбуфер"
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_RU "Обеспечивает точную эмуляцию эффектов фреймбуфера для аппаратных рендеров (напр. размытие движения, вихрь перед схватками в FF7), запуская в фоне копию программного рендера в нативном разрешении. Если отключено, данные операции пропускаются (OpenGL) или отрисовываются средствами GPU (Vulkan). Отключение улучшает производительность, но может приводить к графическим ошибкам. Оставьте включенным, если не уверены."
#define BEETLE_OPT_CPU_DYNAREC_LABEL_RU NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_RU "Динамически преобразует инструкции CPU в нативные. Работает значительно быстрее интерпретатора, но снижает точность таймингов CPU и может приводить к ошибкам."
#define OPTION_VAL_DISABLED_RU "Отключено (интерпретатор Beetle)"
#define OPTION_VAL_EXECUTE_RU "Макс. производительность"
#define OPTION_VAL_EXECUTE_ONE_RU "Проверка таймингов такта"
#define OPTION_VAL_RUN_INTERPRETER_RU "Интерпретатор Lightrec"
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_RU "Инвалидация кода dynarec"
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_RU "Для некоторых игр требуется 'Полная' инвалидация, для других 'Только DMA'."
#define OPTION_VAL_FULL_RU "Полная"
#define OPTION_VAL_DMA_RU "Только DMA (немного быстрее)"
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_RU "Циклы событий DMA/GPU в dynarec"
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_RU "Максимум циклов, выполняемых CPU до проверки обновления GPU или DMA. Большие значения повышают скорость. Эффект более выражен для dynarec, чем для интерпретатора Beetle."
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_RU "Частота тайминга ядра"
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_RU NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_RU NULL
#define OPTION_VAL_FORCE_INTERLACED_RU "Чересстрочная частота принудительно"
#define OPTION_VAL_AUTO_TOGGLE_RU "Разрешить автопереключение"
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_RU "Переопределение тайминга PAL"
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_RU "Из-за разницы в стандартах, игры PAL зачастую работали медленнее релизов для Америки или Японии. Данная настройка позволяет изменить тайминги PAL для запуска игр этого региона с кадровой частотой NTSC. Не работает при запуске NTSC-версий игр."
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_RU "Обрезать вылеты развёртки"
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_RU NULL
#define OPTION_VAL_DISABLED_O53_RU "Нет"
#define OPTION_VAL_STATIC_RU "Статически"
#define OPTION_VAL_SMART_RU NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_RU "Дополнительная обрезка"
#define BEETLE_OPT_IMAGE_CROP_INFO_0_RU NULL
#define OPTION_VAL_9PX_RU "9 пикс."
#define OPTION_VAL_10PX_RU "10 пикс."
#define OPTION_VAL_11PX_RU "11  пикс."
#define OPTION_VAL_12PX_RU "12 пикс."
#define OPTION_VAL_13PX_RU "13 пикс."
#define OPTION_VAL_14PX_RU "14 пикс."
#define OPTION_VAL_15PX_RU "15 пикс."
#define OPTION_VAL_16PX_RU "16 пикс."
#define OPTION_VAL_17PX_RU "17 пикс."
#define OPTION_VAL_18PX_RU "18 пикс."
#define OPTION_VAL_19PX_RU "19 пикс."
#define OPTION_VAL_20PX_RU "20 пикс."
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_RU "Сдвиг изображения после обрезки"
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_RU "При включении опции 'Обрезать вылеты развёртки', позволяет смещать скадрированное изображение вправо (плюс) или влево (минус) на указанное количество пикселей. Может использоваться для устранения проблем с выравниванием. Поддерживается только программным рендером."
#define OPTION_VAL_12PX_O55_RU "-12 пикс."
#define OPTION_VAL_11PX_O55_RU "-11 пикс."
#define OPTION_VAL_10PX_O55_RU "-10 пикс."
#define OPTION_VAL_9PX_O55_RU "-9 пикс."
#define OPTION_VAL_8PX_O55_RU "-8 пикс."
#define OPTION_VAL_7PX_O55_RU "-7 пикс."
#define OPTION_VAL_6PX_O55_RU "-6 пикс."
#define OPTION_VAL_5PX_O55_RU "-5 пикс."
#define OPTION_VAL_4PX_O55_RU "-4 пикс."
#define OPTION_VAL_3PX_O55_RU "-3 пикс."
#define OPTION_VAL_2PX_O55_RU "-2 пикс."
#define OPTION_VAL_1PX_O55_RU "-1 пикс."
#define OPTION_VAL_DISABLED_O55_RU "0 (по умолчанию)"
#define OPTION_VAL_1PX_O55_0_RU "+1 пикс."
#define OPTION_VAL_2PX_O55_0_RU "+2 пикс."
#define OPTION_VAL_3PX_O55_0_RU "+3 пикс."
#define OPTION_VAL_4PX_O55_0_RU "+4 пикс."
#define OPTION_VAL_5PX_O55_0_RU "+5 пикс."
#define OPTION_VAL_6PX_O55_0_RU "+6 пикс."
#define OPTION_VAL_7PX_O55_0_RU "+7 пикс."
#define OPTION_VAL_8PX_O55_0_RU "+8 пикс."
#define OPTION_VAL_9PX_O55_0_RU "+9 пикс."
#define OPTION_VAL_10PX_O55_0_RU "+10 пикс."
#define OPTION_VAL_11PX_O55_0_RU "+11 пикс."
#define OPTION_VAL_12PX_O55_0_RU "+12 пикс."
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_RU "Сдвиг изображения по горизонтали (в тактах GPU)"
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_RU NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_RU "Разгон растеризатора GPU"
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_RU "Включает разгон 2D-растеризатора для эмулируемого GPU PSX. Не улучшает качество 3D-рендеринга и в целом не оказывает значимого эффекта."
#define OPTION_VAL_32X_RU NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_RU "Соотношение сторон ядра"
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_RU NULL
#define OPTION_VAL_CORRECTED_RU "Скорректированное"
#define OPTION_VAL_UNCORRECTED_RU "Нескорректированное"
#define OPTION_VAL_4_3_RU "4:3 принудительно"
#define OPTION_VAL_NTSC_RU "NTSC принудительно"
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_RU "Начальная строка развёртки - NTSC"
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_RU NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_RU "Последняя строка развёртки - NTSC"
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_RU NULL
#define OPTION_VAL_239_RU "239 (по умолчанию)"
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_RU "Начальная строка развёртки - PAL"
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_RU NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_RU "Последняя строка развёртки - PAL"
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_RU NULL
#define OPTION_VAL_287_RU "287 (по умолчанию)"
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_RU "Режим доступа к CD (требуется перезапуск)"
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_RU NULL
#define OPTION_VAL_SYNC_RU "Синхронный"
#define OPTION_VAL_ASYNC_RU "Асинхронный"
#define OPTION_VAL_PRECACHE_RU "Предзагрузка"
#define BEETLE_OPT_CD_FASTLOAD_LABEL_RU "Скорость чтения CD"
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_RU NULL
#define OPTION_VAL_2X_NATIVE_RU "2x (нативно)"
#define OPTION_VAL_6X_RU NULL
#define OPTION_VAL_10X_RU NULL
#define OPTION_VAL_12X_RU NULL
#define OPTION_VAL_14X_RU NULL

struct retro_core_option_v2_category option_cats_ru[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_RU,
      CATEGORY_VIDEO_INFO_0_RU
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_RU,
      CATEGORY_OSD_INFO_0_RU
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_RU,
      CATEGORY_INPUT_INFO_0_RU
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_RU,
      CATEGORY_MEMCARDS_INFO_0_RU
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_RU,
      CATEGORY_PGXP_INFO_0_RU
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_RU,
      CATEGORY_HACKS_INFO_0_RU
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_ru[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_RU,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_RU,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_RU },
         { "2x",         OPTION_VAL_2X_RU },
         { "4x",         OPTION_VAL_4X_RU },
         { "8x",         OPTION_VAL_8X_RU },
         { "16x",        OPTION_VAL_16X_RU },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_RU,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_RU,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_RU },
         { "32bpp",         OPTION_VAL_32BPP_RU },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_RU,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_RU,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_RU },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_RU },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_RU,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_RU,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_RU,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_RU,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_RU },
         { "SABR",     OPTION_VAL_SABR_RU },
         { "xBR",      OPTION_VAL_XBR_RU },
         { "bilinear", OPTION_VAL_BILINEAR_RU },
         { "3-point",  OPTION_VAL_3_POINT_RU },
         { "JINC2",    OPTION_VAL_JINC2_RU },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_RU,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_RU,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_RU },
         { "all", OPTION_VAL_ALL_RU },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_RU,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_RU,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_RU },
         { "all", OPTION_VAL_ALL_RU },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_RU,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_RU,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_RU,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_RU,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_RU,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_RU,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_RU },
         { "2x",  OPTION_VAL_2X_RU },
         { "4x",  OPTION_VAL_4X_RU },
         { "8x",  OPTION_VAL_8X_RU },
         { "16x", OPTION_VAL_16X_RU },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_RU,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_RU,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_RU,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_RU,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_RU,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_RU,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_RU,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_RU,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_RU,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_RU,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_RU,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_RU,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_RU,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_RU,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_RU,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_RU,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_RU,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_RU,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_RU,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_RU,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_RU,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_RU,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_RU,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_RU,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_RU,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_RU,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_RU },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_RU },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_RU,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_RU,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_RU },
         { "dot",   OPTION_VAL_DOT_RU },
         { "off",   OPTION_VAL_OFF_RU },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_RU,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_RU,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_RU },
         { "blue", OPTION_VAL_BLUE_RU },
         { "green", OPTION_VAL_GREEN_RU },
         { "orange", OPTION_VAL_ORANGE_RU },
         { "yellow", OPTION_VAL_YELLOW_RU },
         { "cyan", OPTION_VAL_CYAN_RU },
         { "pink", OPTION_VAL_PINK_RU },
         { "purple", OPTION_VAL_PURPLE_RU },
         { "black", OPTION_VAL_BLACK_RU },
         { "white", OPTION_VAL_WHITE_RU },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_RU,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_RU,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_RU },
         { "red", OPTION_VAL_RED_RU },
         { "green", OPTION_VAL_GREEN_RU },
         { "orange", OPTION_VAL_ORANGE_RU },
         { "yellow", OPTION_VAL_YELLOW_RU },
         { "cyan", OPTION_VAL_CYAN_RU },
         { "pink", OPTION_VAL_PINK_RU },
         { "purple", OPTION_VAL_PURPLE_RU },
         { "black", OPTION_VAL_BLACK_RU },
         { "white", OPTION_VAL_WHITE_RU },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_RU,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_RU,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_RU },
         { "10%",  OPTION_VAL_10_RU },
         { "15%",  OPTION_VAL_15_RU },
         { "20%",  OPTION_VAL_20_RU },
         { "25%",  OPTION_VAL_25_RU },
         { "30%",  OPTION_VAL_30_RU },
         { "35%",  OPTION_VAL_35_RU },
         { "40%",  OPTION_VAL_40_RU },
         { "45%",  OPTION_VAL_45_RU },
         { "50%",  OPTION_VAL_50_RU },
         { "55%",  OPTION_VAL_55_RU },
         { "60%",  OPTION_VAL_60_RU },
         { "65%",  OPTION_VAL_65_RU },
         { "70%",  OPTION_VAL_70_RU },
         { "75%",  OPTION_VAL_75_RU },
         { "80%",  OPTION_VAL_80_RU },
         { "85%",  OPTION_VAL_85_RU },
         { "90%",  OPTION_VAL_90_RU },
         { "95%",  OPTION_VAL_95_RU },
         { "100%", OPTION_VAL_100_RU },
         { "105%", OPTION_VAL_105_RU },
         { "110%", OPTION_VAL_110_RU },
         { "115%", OPTION_VAL_115_RU },
         { "120%", OPTION_VAL_120_RU },
         { "125%", OPTION_VAL_125_RU },
         { "130%", OPTION_VAL_130_RU },
         { "135%", OPTION_VAL_135_RU },
         { "140%", OPTION_VAL_140_RU },
         { "145%", OPTION_VAL_145_RU },
         { "150%", OPTION_VAL_150_RU },
         { "155%", OPTION_VAL_155_RU },
         { "160%", OPTION_VAL_160_RU },
         { "165%", OPTION_VAL_165_RU },
         { "170%", OPTION_VAL_170_RU },
         { "175%", OPTION_VAL_175_RU },
         { "180%", OPTION_VAL_180_RU },
         { "185%", OPTION_VAL_185_RU },
         { "190%", OPTION_VAL_190_RU },
         { "195%", OPTION_VAL_195_RU },
         { "200%", OPTION_VAL_200_RU },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_RU,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_RU,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_RU },
         { "quadratic", OPTION_VAL_QUADRATIC_RU },
         { "cubic",     OPTION_VAL_CUBIC_RU },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_RU,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_RU,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_RU },
         { "5%",  OPTION_VAL_5_RU },
         { "10%", OPTION_VAL_10_RU },
         { "15%", OPTION_VAL_15_RU },
         { "20%", OPTION_VAL_20_RU },
         { "25%", OPTION_VAL_25_RU },
         { "30%", OPTION_VAL_30_RU },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_RU,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_RU,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_RU },
         { "mednafen", OPTION_VAL_MEDNAFEN_RU },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_RU,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_RU,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_RU,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_RU,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_RU,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_RU,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_RU,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_RU,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_RU },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_RU,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_RU,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_RU },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_RU },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_RU,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_RU,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_RU },
         { "1px", OPTION_VAL_1PX_RU },
         { "2px", OPTION_VAL_2PX_RU },
         { "3px", OPTION_VAL_3PX_RU },
         { "4px", OPTION_VAL_4PX_RU },
         { "5px", OPTION_VAL_5PX_RU },
         { "6px", OPTION_VAL_6PX_RU },
         { "7px", OPTION_VAL_7PX_RU },
         { "8px", OPTION_VAL_8PX_RU },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_RU,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_RU,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_RU,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_RU,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_RU,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_RU,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_RU,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_RU,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_RU },
         { "aggressive", OPTION_VAL_AGGRESSIVE_RU },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_RU,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_RU,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_RU,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_RU,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_RU },
         { "16:10", OPTION_VAL_16_10_RU },
         { "18:9",  OPTION_VAL_18_9_RU },
         { "19:9",  OPTION_VAL_19_9_RU },
         { "20:9",  OPTION_VAL_20_9_RU },
         { "21:9",  OPTION_VAL_21_9_RU }, // 64:27
         { "32:9",  OPTION_VAL_32_9_RU },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_RU,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_RU,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_RU },
         { "60%",           OPTION_VAL_60_RU },
         { "70%",           OPTION_VAL_70_RU },
         { "80%",           OPTION_VAL_80_RU },
         { "90%",           OPTION_VAL_90_RU },
         { "100%(native)", OPTION_VAL_100_NATIVE_RU },
         { "110%",          OPTION_VAL_110_RU },
         { "120%",          OPTION_VAL_120_RU },
         { "130%",          OPTION_VAL_130_RU },
         { "140%",          OPTION_VAL_140_RU },
         { "150%",          OPTION_VAL_150_RU },
         { "160%",          OPTION_VAL_160_RU },
         { "170%",          OPTION_VAL_170_RU },
         { "180%",          OPTION_VAL_180_RU },
         { "190%",          OPTION_VAL_190_RU },
         { "200%",          OPTION_VAL_200_RU },
         { "210%",          OPTION_VAL_210_RU },
         { "220%",          OPTION_VAL_220_RU },
         { "230%",          OPTION_VAL_230_RU },
         { "240%",          OPTION_VAL_240_RU },
         { "250%",          OPTION_VAL_250_RU },
         { "260%",          OPTION_VAL_260_RU },
         { "270%",          OPTION_VAL_270_RU },
         { "280%",          OPTION_VAL_280_RU },
         { "290%",          OPTION_VAL_290_RU },
         { "300%",          OPTION_VAL_300_RU },
         { "310%",          OPTION_VAL_310_RU },
         { "320%",          OPTION_VAL_320_RU },
         { "330%",          OPTION_VAL_330_RU },
         { "340%",          OPTION_VAL_340_RU },
         { "350%",          OPTION_VAL_350_RU },
         { "360%",          OPTION_VAL_360_RU },
         { "370%",          OPTION_VAL_370_RU },
         { "380%",          OPTION_VAL_380_RU },
         { "390%",          OPTION_VAL_390_RU },
         { "400%",          OPTION_VAL_400_RU },
         { "410%",          OPTION_VAL_410_RU },
         { "420%",          OPTION_VAL_420_RU },
         { "430%",          OPTION_VAL_430_RU },
         { "440%",          OPTION_VAL_440_RU },
         { "450%",          OPTION_VAL_450_RU },
         { "460%",          OPTION_VAL_460_RU },
         { "470%",          OPTION_VAL_470_RU },
         { "480%",          OPTION_VAL_480_RU },
         { "490%",          OPTION_VAL_490_RU },
         { "500%",          OPTION_VAL_500_RU },
         { "510%",          OPTION_VAL_510_RU },
         { "520%",          OPTION_VAL_520_RU },
         { "530%",          OPTION_VAL_530_RU },
         { "540%",          OPTION_VAL_540_RU },
         { "550%",          OPTION_VAL_550_RU },
         { "560%",          OPTION_VAL_560_RU },
         { "570%",          OPTION_VAL_570_RU },
         { "580%",          OPTION_VAL_580_RU },
         { "590%",          OPTION_VAL_590_RU },
         { "600%",          OPTION_VAL_600_RU },
         { "610%",          OPTION_VAL_610_RU },
         { "620%",          OPTION_VAL_620_RU },
         { "630%",          OPTION_VAL_630_RU },
         { "640%",          OPTION_VAL_640_RU },
         { "650%",          OPTION_VAL_650_RU },
         { "660%",          OPTION_VAL_660_RU },
         { "670%",          OPTION_VAL_670_RU },
         { "680%",          OPTION_VAL_680_RU },
         { "690%",          OPTION_VAL_690_RU },
         { "700%",          OPTION_VAL_700_RU },
         { "710%",          OPTION_VAL_710_RU },
         { "720%",          OPTION_VAL_720_RU },
         { "730%",          OPTION_VAL_730_RU },
         { "740%",          OPTION_VAL_740_RU },
         { "750%",          OPTION_VAL_750_RU },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_RU,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_RU,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_RU,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_RU,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_RU,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_RU,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_RU },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_RU },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_RU,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_RU,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_RU },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_RU },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_RU },
#endif
         { "software",    OPTION_VAL_SOFTWARE_RU },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_RU,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_RU,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_RU,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_RU,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_RU },
         { "execute",  OPTION_VAL_EXECUTE_RU },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_RU },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_RU },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_RU,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_RU,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_RU },
         { "dma",  OPTION_VAL_DMA_RU },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_RU,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_RU,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_RU,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_RU,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_RU },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_RU },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_RU },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_RU,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_RU,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_RU,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_RU,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_RU },
         { "static",  OPTION_VAL_STATIC_RU },
         { "smart", OPTION_VAL_SMART_RU },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_RU,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_RU,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_RU },
         { "2px",      OPTION_VAL_2PX_RU },
         { "3px",      OPTION_VAL_3PX_RU },
         { "4px",      OPTION_VAL_4PX_RU },
         { "5px",      OPTION_VAL_5PX_RU },
         { "6px",      OPTION_VAL_6PX_RU },
         { "7px",      OPTION_VAL_7PX_RU },
         { "8px",      OPTION_VAL_8PX_RU },
         { "9px",      OPTION_VAL_9PX_RU },
         { "10px",     OPTION_VAL_10PX_RU },
         { "11px",     OPTION_VAL_11PX_RU },
         { "12px",     OPTION_VAL_12PX_RU },
         { "13px",     OPTION_VAL_13PX_RU },
         { "14px",     OPTION_VAL_14PX_RU },
         { "15px",     OPTION_VAL_15PX_RU },
         { "16px",     OPTION_VAL_16PX_RU },
         { "17px",     OPTION_VAL_17PX_RU },
         { "18px",     OPTION_VAL_18PX_RU },
         { "19px",     OPTION_VAL_19PX_RU },
         { "20px",     OPTION_VAL_20PX_RU },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_RU,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_RU,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_RU },
         { "-11px",    OPTION_VAL_11PX_O55_RU },
         { "-10px",    OPTION_VAL_10PX_O55_RU },
         { "-9px",     OPTION_VAL_9PX_O55_RU },
         { "-8px",     OPTION_VAL_8PX_O55_RU },
         { "-7px",     OPTION_VAL_7PX_O55_RU },
         { "-6px",     OPTION_VAL_6PX_O55_RU },
         { "-5px",     OPTION_VAL_5PX_O55_RU },
         { "-4px",     OPTION_VAL_4PX_O55_RU },
         { "-3px",     OPTION_VAL_3PX_O55_RU },
         { "-2px",     OPTION_VAL_2PX_O55_RU },
         { "-1px",     OPTION_VAL_1PX_O55_RU },
         { "disabled", OPTION_VAL_DISABLED_O55_RU },
         { "+1px",     OPTION_VAL_1PX_O55_0_RU },
         { "+2px",     OPTION_VAL_2PX_O55_0_RU },
         { "+3px",     OPTION_VAL_3PX_O55_0_RU },
         { "+4px",     OPTION_VAL_4PX_O55_0_RU },
         { "+5px",     OPTION_VAL_5PX_O55_0_RU },
         { "+6px",     OPTION_VAL_6PX_O55_0_RU },
         { "+7px",     OPTION_VAL_7PX_O55_0_RU },
         { "+8px",     OPTION_VAL_8PX_O55_0_RU },
         { "+9px",     OPTION_VAL_9PX_O55_0_RU },
         { "+10px",    OPTION_VAL_10PX_O55_0_RU },
         { "+11px",    OPTION_VAL_11PX_O55_0_RU },
         { "+12px",    OPTION_VAL_12PX_O55_0_RU },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_RU,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_RU,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_RU },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_RU,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_RU,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_RU },
         { "2x",         OPTION_VAL_2X_RU },
         { "4x",         OPTION_VAL_4X_RU },
         { "8x",         OPTION_VAL_8X_RU },
         { "16x",        OPTION_VAL_16X_RU },
         { "32x",        OPTION_VAL_32X_RU },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_RU,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_RU,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_RU },
         { "uncorrected", OPTION_VAL_UNCORRECTED_RU },
         { "4:3",  OPTION_VAL_4_3_RU },
         { "ntsc", OPTION_VAL_NTSC_RU },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_RU,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_RU,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_RU,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_RU,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_RU },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_RU,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_RU,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_RU,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_RU,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_RU },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_RU,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_RU,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_RU },
         { "async",    OPTION_VAL_ASYNC_RU },
         { "precache", OPTION_VAL_PRECACHE_RU },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_RU,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_RU,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_RU },
         { "4x",          OPTION_VAL_4X_RU },
         { "6x",          OPTION_VAL_6X_RU },
         { "8x",          OPTION_VAL_8X_RU },
         { "10x",         OPTION_VAL_10X_RU },
         { "12x",         OPTION_VAL_12X_RU },
         { "14x",         OPTION_VAL_14X_RU },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_ru = {
   option_cats_ru,
   option_defs_ru
};

/* RETRO_LANGUAGE_SI */

#define CATEGORY_VIDEO_LABEL_SI NULL
#define CATEGORY_VIDEO_INFO_0_SI NULL
#define CATEGORY_OSD_LABEL_SI NULL
#define CATEGORY_OSD_INFO_0_SI NULL
#define CATEGORY_INPUT_LABEL_SI NULL
#define CATEGORY_INPUT_INFO_0_SI NULL
#define CATEGORY_MEMCARDS_LABEL_SI NULL
#define CATEGORY_MEMCARDS_INFO_0_SI NULL
#define CATEGORY_PGXP_LABEL_SI NULL
#define CATEGORY_PGXP_INFO_0_SI NULL
#define CATEGORY_HACKS_LABEL_SI NULL
#define CATEGORY_HACKS_INFO_0_SI NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_SI NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_SI NULL
#define OPTION_VAL_1X_NATIVE_SI NULL
#define OPTION_VAL_2X_SI NULL
#define OPTION_VAL_4X_SI NULL
#define OPTION_VAL_8X_SI NULL
#define OPTION_VAL_16X_SI NULL
#define BEETLE_OPT_DEPTH_LABEL_SI NULL
#define BEETLE_OPT_DEPTH_INFO_0_SI NULL
#define OPTION_VAL_16BPP_NATIVE_SI NULL
#define OPTION_VAL_32BPP_SI NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_SI NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_SI NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_SI NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_SI NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_SI NULL
#define BEETLE_OPT_FILTER_LABEL_SI NULL
#define BEETLE_OPT_FILTER_INFO_0_SI NULL
#define OPTION_VAL_NEAREST_SI NULL
#define OPTION_VAL_SABR_SI NULL
#define OPTION_VAL_XBR_SI NULL
#define OPTION_VAL_BILINEAR_SI NULL
#define OPTION_VAL_3_POINT_SI NULL
#define OPTION_VAL_JINC2_SI NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_SI NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_SI NULL
#define OPTION_VAL_OPAQUE_SI NULL
#define OPTION_VAL_ALL_SI NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_SI NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_SI NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_SI NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_SI NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_SI NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_SI NULL
#define BEETLE_OPT_MSAA_LABEL_SI NULL
#define BEETLE_OPT_MSAA_INFO_0_SI NULL
#define OPTION_VAL_1X_SI NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_SI NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_SI NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_SI NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_SI NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_SI NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_SI NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_SI NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_SI NULL
#define BEETLE_OPT_WIREFRAME_LABEL_SI NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_SI NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_SI NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_SI NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_SI NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_SI NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_SI NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_SI NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_SI NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_SI NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_SI NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_SI NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_SI NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_SI NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_SI NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_SI NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_SI NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_SI NULL
#define OPTION_VAL_LIGHTGUN_SI NULL
#define OPTION_VAL_TOUCHSCREEN_SI NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_SI NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_SI NULL
#define OPTION_VAL_CROSS_SI NULL
#define OPTION_VAL_DOT_SI NULL
#define OPTION_VAL_OFF_SI NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_SI NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_SI NULL
#define OPTION_VAL_RED_SI NULL
#define OPTION_VAL_BLUE_SI NULL
#define OPTION_VAL_GREEN_SI NULL
#define OPTION_VAL_ORANGE_SI NULL
#define OPTION_VAL_YELLOW_SI NULL
#define OPTION_VAL_CYAN_SI NULL
#define OPTION_VAL_PINK_SI NULL
#define OPTION_VAL_PURPLE_SI NULL
#define OPTION_VAL_BLACK_SI NULL
#define OPTION_VAL_WHITE_SI NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_SI NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_SI NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_SI NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_SI NULL
#define OPTION_VAL_5_SI NULL
#define OPTION_VAL_10_SI NULL
#define OPTION_VAL_15_SI NULL
#define OPTION_VAL_20_SI NULL
#define OPTION_VAL_25_SI NULL
#define OPTION_VAL_30_SI NULL
#define OPTION_VAL_35_SI NULL
#define OPTION_VAL_40_SI NULL
#define OPTION_VAL_45_SI NULL
#define OPTION_VAL_50_SI NULL
#define OPTION_VAL_55_SI NULL
#define OPTION_VAL_60_SI NULL
#define OPTION_VAL_65_SI NULL
#define OPTION_VAL_70_SI NULL
#define OPTION_VAL_75_SI NULL
#define OPTION_VAL_80_SI NULL
#define OPTION_VAL_85_SI NULL
#define OPTION_VAL_90_SI NULL
#define OPTION_VAL_95_SI NULL
#define OPTION_VAL_100_SI NULL
#define OPTION_VAL_105_SI NULL
#define OPTION_VAL_110_SI NULL
#define OPTION_VAL_115_SI NULL
#define OPTION_VAL_120_SI NULL
#define OPTION_VAL_125_SI NULL
#define OPTION_VAL_130_SI NULL
#define OPTION_VAL_135_SI NULL
#define OPTION_VAL_140_SI NULL
#define OPTION_VAL_145_SI NULL
#define OPTION_VAL_150_SI NULL
#define OPTION_VAL_155_SI NULL
#define OPTION_VAL_160_SI NULL
#define OPTION_VAL_165_SI NULL
#define OPTION_VAL_170_SI NULL
#define OPTION_VAL_175_SI NULL
#define OPTION_VAL_180_SI NULL
#define OPTION_VAL_185_SI NULL
#define OPTION_VAL_190_SI NULL
#define OPTION_VAL_195_SI NULL
#define OPTION_VAL_200_SI NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_SI NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_SI NULL
#define OPTION_VAL_LINEAR_SI NULL
#define OPTION_VAL_QUADRATIC_SI NULL
#define OPTION_VAL_CUBIC_SI NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_SI NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_SI NULL
#define OPTION_VAL_0_SI NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_SI NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_SI NULL
#define OPTION_VAL_LIBRETRO_SI NULL
#define OPTION_VAL_MEDNAFEN_SI NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_SI NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_SI NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_SI NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_SI NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_SI NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_SI NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_SI NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_SI NULL
#define OPTION_VAL_1_SI NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_SI NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_SI NULL
#define OPTION_VAL_MEMORY_ONLY_SI NULL
#define OPTION_VAL_MEMORY_CPU_SI NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_SI NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_SI NULL
#define OPTION_VAL_0PX_SI NULL
#define OPTION_VAL_1PX_SI NULL
#define OPTION_VAL_2PX_SI NULL
#define OPTION_VAL_3PX_SI NULL
#define OPTION_VAL_4PX_SI NULL
#define OPTION_VAL_5PX_SI NULL
#define OPTION_VAL_6PX_SI NULL
#define OPTION_VAL_7PX_SI NULL
#define OPTION_VAL_8PX_SI NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_SI NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_SI NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_SI NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_SI NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_SI NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_SI NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_SI NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_SI NULL
#define OPTION_VAL_DEFAULT_SI NULL
#define OPTION_VAL_AGGRESSIVE_SI NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_SI NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_SI NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_SI NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_SI NULL
#define OPTION_VAL_16_9_SI NULL
#define OPTION_VAL_16_10_SI NULL
#define OPTION_VAL_18_9_SI NULL
#define OPTION_VAL_19_9_SI NULL
#define OPTION_VAL_20_9_SI NULL
#define OPTION_VAL_21_9_SI NULL
#define OPTION_VAL_32_9_SI NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_SI NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_SI NULL
#define OPTION_VAL_100_NATIVE_SI NULL
#define OPTION_VAL_210_SI NULL
#define OPTION_VAL_220_SI NULL
#define OPTION_VAL_230_SI NULL
#define OPTION_VAL_240_SI NULL
#define OPTION_VAL_250_SI NULL
#define OPTION_VAL_260_SI NULL
#define OPTION_VAL_270_SI NULL
#define OPTION_VAL_280_SI NULL
#define OPTION_VAL_290_SI NULL
#define OPTION_VAL_300_SI NULL
#define OPTION_VAL_310_SI NULL
#define OPTION_VAL_320_SI NULL
#define OPTION_VAL_330_SI NULL
#define OPTION_VAL_340_SI NULL
#define OPTION_VAL_350_SI NULL
#define OPTION_VAL_360_SI NULL
#define OPTION_VAL_370_SI NULL
#define OPTION_VAL_380_SI NULL
#define OPTION_VAL_390_SI NULL
#define OPTION_VAL_400_SI NULL
#define OPTION_VAL_410_SI NULL
#define OPTION_VAL_420_SI NULL
#define OPTION_VAL_430_SI NULL
#define OPTION_VAL_440_SI NULL
#define OPTION_VAL_450_SI NULL
#define OPTION_VAL_460_SI NULL
#define OPTION_VAL_470_SI NULL
#define OPTION_VAL_480_SI NULL
#define OPTION_VAL_490_SI NULL
#define OPTION_VAL_500_SI NULL
#define OPTION_VAL_510_SI NULL
#define OPTION_VAL_520_SI NULL
#define OPTION_VAL_530_SI NULL
#define OPTION_VAL_540_SI NULL
#define OPTION_VAL_550_SI NULL
#define OPTION_VAL_560_SI NULL
#define OPTION_VAL_570_SI NULL
#define OPTION_VAL_580_SI NULL
#define OPTION_VAL_590_SI NULL
#define OPTION_VAL_600_SI NULL
#define OPTION_VAL_610_SI NULL
#define OPTION_VAL_620_SI NULL
#define OPTION_VAL_630_SI NULL
#define OPTION_VAL_640_SI NULL
#define OPTION_VAL_650_SI NULL
#define OPTION_VAL_660_SI NULL
#define OPTION_VAL_670_SI NULL
#define OPTION_VAL_680_SI NULL
#define OPTION_VAL_690_SI NULL
#define OPTION_VAL_700_SI NULL
#define OPTION_VAL_710_SI NULL
#define OPTION_VAL_720_SI NULL
#define OPTION_VAL_730_SI NULL
#define OPTION_VAL_740_SI NULL
#define OPTION_VAL_750_SI NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_SI NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_SI NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_SI NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_SI NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_SI NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_SI NULL
#define OPTION_VAL_PSXONPSP_SI NULL
#define OPTION_VAL_PS1_ROM_SI NULL
#define BEETLE_OPT_RENDERER_LABEL_SI NULL
#define BEETLE_OPT_RENDERER_INFO_0_SI NULL
#define OPTION_VAL_HARDWARE_SI NULL
#define OPTION_VAL_HARDWARE_GL_SI NULL
#define OPTION_VAL_HARDWARE_VK_SI NULL
#define OPTION_VAL_SOFTWARE_SI NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_SI NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_SI NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_SI NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_SI NULL
#define OPTION_VAL_DISABLED_SI NULL
#define OPTION_VAL_EXECUTE_SI NULL
#define OPTION_VAL_EXECUTE_ONE_SI NULL
#define OPTION_VAL_RUN_INTERPRETER_SI NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_SI NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_SI NULL
#define OPTION_VAL_FULL_SI NULL
#define OPTION_VAL_DMA_SI NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_SI NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_SI NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_SI NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_SI NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_SI NULL
#define OPTION_VAL_FORCE_INTERLACED_SI NULL
#define OPTION_VAL_AUTO_TOGGLE_SI NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_SI NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_SI NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_SI NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_SI NULL
#define OPTION_VAL_DISABLED_O53_SI NULL
#define OPTION_VAL_STATIC_SI NULL
#define OPTION_VAL_SMART_SI NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_SI NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_SI NULL
#define OPTION_VAL_9PX_SI NULL
#define OPTION_VAL_10PX_SI NULL
#define OPTION_VAL_11PX_SI NULL
#define OPTION_VAL_12PX_SI NULL
#define OPTION_VAL_13PX_SI NULL
#define OPTION_VAL_14PX_SI NULL
#define OPTION_VAL_15PX_SI NULL
#define OPTION_VAL_16PX_SI NULL
#define OPTION_VAL_17PX_SI NULL
#define OPTION_VAL_18PX_SI NULL
#define OPTION_VAL_19PX_SI NULL
#define OPTION_VAL_20PX_SI NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_SI NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_SI NULL
#define OPTION_VAL_12PX_O55_SI NULL
#define OPTION_VAL_11PX_O55_SI NULL
#define OPTION_VAL_10PX_O55_SI NULL
#define OPTION_VAL_9PX_O55_SI NULL
#define OPTION_VAL_8PX_O55_SI NULL
#define OPTION_VAL_7PX_O55_SI NULL
#define OPTION_VAL_6PX_O55_SI NULL
#define OPTION_VAL_5PX_O55_SI NULL
#define OPTION_VAL_4PX_O55_SI NULL
#define OPTION_VAL_3PX_O55_SI NULL
#define OPTION_VAL_2PX_O55_SI NULL
#define OPTION_VAL_1PX_O55_SI NULL
#define OPTION_VAL_DISABLED_O55_SI NULL
#define OPTION_VAL_1PX_O55_0_SI NULL
#define OPTION_VAL_2PX_O55_0_SI NULL
#define OPTION_VAL_3PX_O55_0_SI NULL
#define OPTION_VAL_4PX_O55_0_SI NULL
#define OPTION_VAL_5PX_O55_0_SI NULL
#define OPTION_VAL_6PX_O55_0_SI NULL
#define OPTION_VAL_7PX_O55_0_SI NULL
#define OPTION_VAL_8PX_O55_0_SI NULL
#define OPTION_VAL_9PX_O55_0_SI NULL
#define OPTION_VAL_10PX_O55_0_SI NULL
#define OPTION_VAL_11PX_O55_0_SI NULL
#define OPTION_VAL_12PX_O55_0_SI NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_SI NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_SI NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_SI NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_SI NULL
#define OPTION_VAL_32X_SI NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_SI NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_SI NULL
#define OPTION_VAL_CORRECTED_SI NULL
#define OPTION_VAL_UNCORRECTED_SI NULL
#define OPTION_VAL_4_3_SI NULL
#define OPTION_VAL_NTSC_SI NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_SI NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_SI NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_SI NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_SI NULL
#define OPTION_VAL_239_SI NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_SI NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_SI NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_SI NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_SI NULL
#define OPTION_VAL_287_SI NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_SI NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_SI NULL
#define OPTION_VAL_SYNC_SI NULL
#define OPTION_VAL_ASYNC_SI NULL
#define OPTION_VAL_PRECACHE_SI NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_SI NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_SI NULL
#define OPTION_VAL_2X_NATIVE_SI NULL
#define OPTION_VAL_6X_SI NULL
#define OPTION_VAL_10X_SI NULL
#define OPTION_VAL_12X_SI NULL
#define OPTION_VAL_14X_SI NULL

struct retro_core_option_v2_category option_cats_si[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_SI,
      CATEGORY_VIDEO_INFO_0_SI
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_SI,
      CATEGORY_OSD_INFO_0_SI
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_SI,
      CATEGORY_INPUT_INFO_0_SI
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_SI,
      CATEGORY_MEMCARDS_INFO_0_SI
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_SI,
      CATEGORY_PGXP_INFO_0_SI
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_SI,
      CATEGORY_HACKS_INFO_0_SI
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_si[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_SI,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_SI,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_SI },
         { "2x",         OPTION_VAL_2X_SI },
         { "4x",         OPTION_VAL_4X_SI },
         { "8x",         OPTION_VAL_8X_SI },
         { "16x",        OPTION_VAL_16X_SI },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_SI,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_SI,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_SI },
         { "32bpp",         OPTION_VAL_32BPP_SI },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_SI,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_SI,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_SI },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_SI },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_SI,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_SI,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_SI,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_SI,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_SI },
         { "SABR",     OPTION_VAL_SABR_SI },
         { "xBR",      OPTION_VAL_XBR_SI },
         { "bilinear", OPTION_VAL_BILINEAR_SI },
         { "3-point",  OPTION_VAL_3_POINT_SI },
         { "JINC2",    OPTION_VAL_JINC2_SI },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_SI,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_SI,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_SI },
         { "all", OPTION_VAL_ALL_SI },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_SI,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_SI,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_SI },
         { "all", OPTION_VAL_ALL_SI },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_SI,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_SI,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_SI,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_SI,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_SI,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_SI,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_SI },
         { "2x",  OPTION_VAL_2X_SI },
         { "4x",  OPTION_VAL_4X_SI },
         { "8x",  OPTION_VAL_8X_SI },
         { "16x", OPTION_VAL_16X_SI },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_SI,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_SI,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_SI,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_SI,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_SI,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_SI,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_SI,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_SI,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_SI,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_SI,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_SI,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_SI,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_SI,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_SI,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_SI,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_SI,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_SI,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_SI,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_SI,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_SI,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_SI,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_SI,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_SI,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_SI,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_SI,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_SI,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_SI },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_SI },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_SI,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_SI,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_SI },
         { "dot",   OPTION_VAL_DOT_SI },
         { "off",   OPTION_VAL_OFF_SI },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_SI,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_SI,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_SI },
         { "blue", OPTION_VAL_BLUE_SI },
         { "green", OPTION_VAL_GREEN_SI },
         { "orange", OPTION_VAL_ORANGE_SI },
         { "yellow", OPTION_VAL_YELLOW_SI },
         { "cyan", OPTION_VAL_CYAN_SI },
         { "pink", OPTION_VAL_PINK_SI },
         { "purple", OPTION_VAL_PURPLE_SI },
         { "black", OPTION_VAL_BLACK_SI },
         { "white", OPTION_VAL_WHITE_SI },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_SI,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_SI,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_SI },
         { "red", OPTION_VAL_RED_SI },
         { "green", OPTION_VAL_GREEN_SI },
         { "orange", OPTION_VAL_ORANGE_SI },
         { "yellow", OPTION_VAL_YELLOW_SI },
         { "cyan", OPTION_VAL_CYAN_SI },
         { "pink", OPTION_VAL_PINK_SI },
         { "purple", OPTION_VAL_PURPLE_SI },
         { "black", OPTION_VAL_BLACK_SI },
         { "white", OPTION_VAL_WHITE_SI },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_SI,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_SI,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_SI },
         { "10%",  OPTION_VAL_10_SI },
         { "15%",  OPTION_VAL_15_SI },
         { "20%",  OPTION_VAL_20_SI },
         { "25%",  OPTION_VAL_25_SI },
         { "30%",  OPTION_VAL_30_SI },
         { "35%",  OPTION_VAL_35_SI },
         { "40%",  OPTION_VAL_40_SI },
         { "45%",  OPTION_VAL_45_SI },
         { "50%",  OPTION_VAL_50_SI },
         { "55%",  OPTION_VAL_55_SI },
         { "60%",  OPTION_VAL_60_SI },
         { "65%",  OPTION_VAL_65_SI },
         { "70%",  OPTION_VAL_70_SI },
         { "75%",  OPTION_VAL_75_SI },
         { "80%",  OPTION_VAL_80_SI },
         { "85%",  OPTION_VAL_85_SI },
         { "90%",  OPTION_VAL_90_SI },
         { "95%",  OPTION_VAL_95_SI },
         { "100%", OPTION_VAL_100_SI },
         { "105%", OPTION_VAL_105_SI },
         { "110%", OPTION_VAL_110_SI },
         { "115%", OPTION_VAL_115_SI },
         { "120%", OPTION_VAL_120_SI },
         { "125%", OPTION_VAL_125_SI },
         { "130%", OPTION_VAL_130_SI },
         { "135%", OPTION_VAL_135_SI },
         { "140%", OPTION_VAL_140_SI },
         { "145%", OPTION_VAL_145_SI },
         { "150%", OPTION_VAL_150_SI },
         { "155%", OPTION_VAL_155_SI },
         { "160%", OPTION_VAL_160_SI },
         { "165%", OPTION_VAL_165_SI },
         { "170%", OPTION_VAL_170_SI },
         { "175%", OPTION_VAL_175_SI },
         { "180%", OPTION_VAL_180_SI },
         { "185%", OPTION_VAL_185_SI },
         { "190%", OPTION_VAL_190_SI },
         { "195%", OPTION_VAL_195_SI },
         { "200%", OPTION_VAL_200_SI },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_SI,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_SI,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_SI },
         { "quadratic", OPTION_VAL_QUADRATIC_SI },
         { "cubic",     OPTION_VAL_CUBIC_SI },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_SI,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_SI,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_SI },
         { "5%",  OPTION_VAL_5_SI },
         { "10%", OPTION_VAL_10_SI },
         { "15%", OPTION_VAL_15_SI },
         { "20%", OPTION_VAL_20_SI },
         { "25%", OPTION_VAL_25_SI },
         { "30%", OPTION_VAL_30_SI },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_SI,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_SI,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_SI },
         { "mednafen", OPTION_VAL_MEDNAFEN_SI },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_SI,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_SI,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_SI,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_SI,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_SI,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_SI,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_SI,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_SI,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_SI },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_SI,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_SI,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_SI },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_SI },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_SI,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_SI,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_SI },
         { "1px", OPTION_VAL_1PX_SI },
         { "2px", OPTION_VAL_2PX_SI },
         { "3px", OPTION_VAL_3PX_SI },
         { "4px", OPTION_VAL_4PX_SI },
         { "5px", OPTION_VAL_5PX_SI },
         { "6px", OPTION_VAL_6PX_SI },
         { "7px", OPTION_VAL_7PX_SI },
         { "8px", OPTION_VAL_8PX_SI },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_SI,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_SI,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_SI,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_SI,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_SI,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_SI,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_SI,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_SI,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_SI },
         { "aggressive", OPTION_VAL_AGGRESSIVE_SI },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_SI,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_SI,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_SI,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_SI,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_SI },
         { "16:10", OPTION_VAL_16_10_SI },
         { "18:9",  OPTION_VAL_18_9_SI },
         { "19:9",  OPTION_VAL_19_9_SI },
         { "20:9",  OPTION_VAL_20_9_SI },
         { "21:9",  OPTION_VAL_21_9_SI }, // 64:27
         { "32:9",  OPTION_VAL_32_9_SI },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_SI,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_SI,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_SI },
         { "60%",           OPTION_VAL_60_SI },
         { "70%",           OPTION_VAL_70_SI },
         { "80%",           OPTION_VAL_80_SI },
         { "90%",           OPTION_VAL_90_SI },
         { "100%(native)", OPTION_VAL_100_NATIVE_SI },
         { "110%",          OPTION_VAL_110_SI },
         { "120%",          OPTION_VAL_120_SI },
         { "130%",          OPTION_VAL_130_SI },
         { "140%",          OPTION_VAL_140_SI },
         { "150%",          OPTION_VAL_150_SI },
         { "160%",          OPTION_VAL_160_SI },
         { "170%",          OPTION_VAL_170_SI },
         { "180%",          OPTION_VAL_180_SI },
         { "190%",          OPTION_VAL_190_SI },
         { "200%",          OPTION_VAL_200_SI },
         { "210%",          OPTION_VAL_210_SI },
         { "220%",          OPTION_VAL_220_SI },
         { "230%",          OPTION_VAL_230_SI },
         { "240%",          OPTION_VAL_240_SI },
         { "250%",          OPTION_VAL_250_SI },
         { "260%",          OPTION_VAL_260_SI },
         { "270%",          OPTION_VAL_270_SI },
         { "280%",          OPTION_VAL_280_SI },
         { "290%",          OPTION_VAL_290_SI },
         { "300%",          OPTION_VAL_300_SI },
         { "310%",          OPTION_VAL_310_SI },
         { "320%",          OPTION_VAL_320_SI },
         { "330%",          OPTION_VAL_330_SI },
         { "340%",          OPTION_VAL_340_SI },
         { "350%",          OPTION_VAL_350_SI },
         { "360%",          OPTION_VAL_360_SI },
         { "370%",          OPTION_VAL_370_SI },
         { "380%",          OPTION_VAL_380_SI },
         { "390%",          OPTION_VAL_390_SI },
         { "400%",          OPTION_VAL_400_SI },
         { "410%",          OPTION_VAL_410_SI },
         { "420%",          OPTION_VAL_420_SI },
         { "430%",          OPTION_VAL_430_SI },
         { "440%",          OPTION_VAL_440_SI },
         { "450%",          OPTION_VAL_450_SI },
         { "460%",          OPTION_VAL_460_SI },
         { "470%",          OPTION_VAL_470_SI },
         { "480%",          OPTION_VAL_480_SI },
         { "490%",          OPTION_VAL_490_SI },
         { "500%",          OPTION_VAL_500_SI },
         { "510%",          OPTION_VAL_510_SI },
         { "520%",          OPTION_VAL_520_SI },
         { "530%",          OPTION_VAL_530_SI },
         { "540%",          OPTION_VAL_540_SI },
         { "550%",          OPTION_VAL_550_SI },
         { "560%",          OPTION_VAL_560_SI },
         { "570%",          OPTION_VAL_570_SI },
         { "580%",          OPTION_VAL_580_SI },
         { "590%",          OPTION_VAL_590_SI },
         { "600%",          OPTION_VAL_600_SI },
         { "610%",          OPTION_VAL_610_SI },
         { "620%",          OPTION_VAL_620_SI },
         { "630%",          OPTION_VAL_630_SI },
         { "640%",          OPTION_VAL_640_SI },
         { "650%",          OPTION_VAL_650_SI },
         { "660%",          OPTION_VAL_660_SI },
         { "670%",          OPTION_VAL_670_SI },
         { "680%",          OPTION_VAL_680_SI },
         { "690%",          OPTION_VAL_690_SI },
         { "700%",          OPTION_VAL_700_SI },
         { "710%",          OPTION_VAL_710_SI },
         { "720%",          OPTION_VAL_720_SI },
         { "730%",          OPTION_VAL_730_SI },
         { "740%",          OPTION_VAL_740_SI },
         { "750%",          OPTION_VAL_750_SI },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_SI,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_SI,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_SI,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_SI,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_SI,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_SI,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_SI },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_SI },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_SI,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_SI,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_SI },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_SI },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_SI },
#endif
         { "software",    OPTION_VAL_SOFTWARE_SI },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_SI,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_SI,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_SI,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_SI,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_SI },
         { "execute",  OPTION_VAL_EXECUTE_SI },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_SI },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_SI },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_SI,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_SI,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_SI },
         { "dma",  OPTION_VAL_DMA_SI },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_SI,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_SI,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_SI,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_SI,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_SI },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_SI },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_SI },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_SI,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_SI,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_SI,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_SI,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_SI },
         { "static",  OPTION_VAL_STATIC_SI },
         { "smart", OPTION_VAL_SMART_SI },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_SI,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_SI,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_SI },
         { "2px",      OPTION_VAL_2PX_SI },
         { "3px",      OPTION_VAL_3PX_SI },
         { "4px",      OPTION_VAL_4PX_SI },
         { "5px",      OPTION_VAL_5PX_SI },
         { "6px",      OPTION_VAL_6PX_SI },
         { "7px",      OPTION_VAL_7PX_SI },
         { "8px",      OPTION_VAL_8PX_SI },
         { "9px",      OPTION_VAL_9PX_SI },
         { "10px",     OPTION_VAL_10PX_SI },
         { "11px",     OPTION_VAL_11PX_SI },
         { "12px",     OPTION_VAL_12PX_SI },
         { "13px",     OPTION_VAL_13PX_SI },
         { "14px",     OPTION_VAL_14PX_SI },
         { "15px",     OPTION_VAL_15PX_SI },
         { "16px",     OPTION_VAL_16PX_SI },
         { "17px",     OPTION_VAL_17PX_SI },
         { "18px",     OPTION_VAL_18PX_SI },
         { "19px",     OPTION_VAL_19PX_SI },
         { "20px",     OPTION_VAL_20PX_SI },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_SI,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_SI,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_SI },
         { "-11px",    OPTION_VAL_11PX_O55_SI },
         { "-10px",    OPTION_VAL_10PX_O55_SI },
         { "-9px",     OPTION_VAL_9PX_O55_SI },
         { "-8px",     OPTION_VAL_8PX_O55_SI },
         { "-7px",     OPTION_VAL_7PX_O55_SI },
         { "-6px",     OPTION_VAL_6PX_O55_SI },
         { "-5px",     OPTION_VAL_5PX_O55_SI },
         { "-4px",     OPTION_VAL_4PX_O55_SI },
         { "-3px",     OPTION_VAL_3PX_O55_SI },
         { "-2px",     OPTION_VAL_2PX_O55_SI },
         { "-1px",     OPTION_VAL_1PX_O55_SI },
         { "disabled", OPTION_VAL_DISABLED_O55_SI },
         { "+1px",     OPTION_VAL_1PX_O55_0_SI },
         { "+2px",     OPTION_VAL_2PX_O55_0_SI },
         { "+3px",     OPTION_VAL_3PX_O55_0_SI },
         { "+4px",     OPTION_VAL_4PX_O55_0_SI },
         { "+5px",     OPTION_VAL_5PX_O55_0_SI },
         { "+6px",     OPTION_VAL_6PX_O55_0_SI },
         { "+7px",     OPTION_VAL_7PX_O55_0_SI },
         { "+8px",     OPTION_VAL_8PX_O55_0_SI },
         { "+9px",     OPTION_VAL_9PX_O55_0_SI },
         { "+10px",    OPTION_VAL_10PX_O55_0_SI },
         { "+11px",    OPTION_VAL_11PX_O55_0_SI },
         { "+12px",    OPTION_VAL_12PX_O55_0_SI },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_SI,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_SI,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_SI },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_SI,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_SI,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_SI },
         { "2x",         OPTION_VAL_2X_SI },
         { "4x",         OPTION_VAL_4X_SI },
         { "8x",         OPTION_VAL_8X_SI },
         { "16x",        OPTION_VAL_16X_SI },
         { "32x",        OPTION_VAL_32X_SI },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_SI,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_SI,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_SI },
         { "uncorrected", OPTION_VAL_UNCORRECTED_SI },
         { "4:3",  OPTION_VAL_4_3_SI },
         { "ntsc", OPTION_VAL_NTSC_SI },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_SI,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_SI,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_SI,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_SI,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_SI },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_SI,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_SI,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_SI,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_SI,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_SI },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_SI,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_SI,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_SI },
         { "async",    OPTION_VAL_ASYNC_SI },
         { "precache", OPTION_VAL_PRECACHE_SI },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_SI,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_SI,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_SI },
         { "4x",          OPTION_VAL_4X_SI },
         { "6x",          OPTION_VAL_6X_SI },
         { "8x",          OPTION_VAL_8X_SI },
         { "10x",         OPTION_VAL_10X_SI },
         { "12x",         OPTION_VAL_12X_SI },
         { "14x",         OPTION_VAL_14X_SI },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_si = {
   option_cats_si,
   option_defs_si
};

/* RETRO_LANGUAGE_SK */

#define CATEGORY_VIDEO_LABEL_SK NULL
#define CATEGORY_VIDEO_INFO_0_SK NULL
#define CATEGORY_OSD_LABEL_SK NULL
#define CATEGORY_OSD_INFO_0_SK NULL
#define CATEGORY_INPUT_LABEL_SK "Vstup"
#define CATEGORY_INPUT_INFO_0_SK NULL
#define CATEGORY_MEMCARDS_LABEL_SK NULL
#define CATEGORY_MEMCARDS_INFO_0_SK NULL
#define CATEGORY_PGXP_LABEL_SK NULL
#define CATEGORY_PGXP_INFO_0_SK NULL
#define CATEGORY_HACKS_LABEL_SK NULL
#define CATEGORY_HACKS_INFO_0_SK NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_SK NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_SK NULL
#define OPTION_VAL_1X_NATIVE_SK NULL
#define OPTION_VAL_2X_SK NULL
#define OPTION_VAL_4X_SK NULL
#define OPTION_VAL_8X_SK NULL
#define OPTION_VAL_16X_SK NULL
#define BEETLE_OPT_DEPTH_LABEL_SK NULL
#define BEETLE_OPT_DEPTH_INFO_0_SK NULL
#define OPTION_VAL_16BPP_NATIVE_SK NULL
#define OPTION_VAL_32BPP_SK NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_SK NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_SK NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_SK NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_SK NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_SK NULL
#define BEETLE_OPT_FILTER_LABEL_SK NULL
#define BEETLE_OPT_FILTER_INFO_0_SK NULL
#define OPTION_VAL_NEAREST_SK NULL
#define OPTION_VAL_SABR_SK NULL
#define OPTION_VAL_XBR_SK NULL
#define OPTION_VAL_BILINEAR_SK "Bilineárna"
#define OPTION_VAL_3_POINT_SK NULL
#define OPTION_VAL_JINC2_SK NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_SK NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_SK NULL
#define OPTION_VAL_OPAQUE_SK NULL
#define OPTION_VAL_ALL_SK NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_SK NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_SK NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_SK NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_SK NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_SK NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_SK NULL
#define BEETLE_OPT_MSAA_LABEL_SK NULL
#define BEETLE_OPT_MSAA_INFO_0_SK NULL
#define OPTION_VAL_1X_SK NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_SK NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_SK NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_SK NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_SK NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_SK NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_SK NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_SK NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_SK NULL
#define BEETLE_OPT_WIREFRAME_LABEL_SK NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_SK NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_SK NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_SK NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_SK NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_SK NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_SK NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_SK NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_SK NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_SK NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_SK NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_SK NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_SK NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_SK NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_SK NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_SK NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_SK NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_SK NULL
#define OPTION_VAL_LIGHTGUN_SK NULL
#define OPTION_VAL_TOUCHSCREEN_SK NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_SK NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_SK NULL
#define OPTION_VAL_CROSS_SK NULL
#define OPTION_VAL_DOT_SK NULL
#define OPTION_VAL_OFF_SK NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_SK NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_SK NULL
#define OPTION_VAL_RED_SK "Červená"
#define OPTION_VAL_BLUE_SK "Modrá"
#define OPTION_VAL_GREEN_SK "Zelená"
#define OPTION_VAL_ORANGE_SK NULL
#define OPTION_VAL_YELLOW_SK NULL
#define OPTION_VAL_CYAN_SK NULL
#define OPTION_VAL_PINK_SK NULL
#define OPTION_VAL_PURPLE_SK NULL
#define OPTION_VAL_BLACK_SK NULL
#define OPTION_VAL_WHITE_SK NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_SK NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_SK NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_SK NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_SK NULL
#define OPTION_VAL_5_SK NULL
#define OPTION_VAL_10_SK NULL
#define OPTION_VAL_15_SK NULL
#define OPTION_VAL_20_SK NULL
#define OPTION_VAL_25_SK NULL
#define OPTION_VAL_30_SK NULL
#define OPTION_VAL_35_SK NULL
#define OPTION_VAL_40_SK NULL
#define OPTION_VAL_45_SK NULL
#define OPTION_VAL_50_SK NULL
#define OPTION_VAL_55_SK NULL
#define OPTION_VAL_60_SK NULL
#define OPTION_VAL_65_SK NULL
#define OPTION_VAL_70_SK NULL
#define OPTION_VAL_75_SK NULL
#define OPTION_VAL_80_SK NULL
#define OPTION_VAL_85_SK NULL
#define OPTION_VAL_90_SK NULL
#define OPTION_VAL_95_SK NULL
#define OPTION_VAL_100_SK NULL
#define OPTION_VAL_105_SK NULL
#define OPTION_VAL_110_SK NULL
#define OPTION_VAL_115_SK NULL
#define OPTION_VAL_120_SK NULL
#define OPTION_VAL_125_SK NULL
#define OPTION_VAL_130_SK NULL
#define OPTION_VAL_135_SK NULL
#define OPTION_VAL_140_SK NULL
#define OPTION_VAL_145_SK NULL
#define OPTION_VAL_150_SK NULL
#define OPTION_VAL_155_SK NULL
#define OPTION_VAL_160_SK NULL
#define OPTION_VAL_165_SK NULL
#define OPTION_VAL_170_SK NULL
#define OPTION_VAL_175_SK NULL
#define OPTION_VAL_180_SK NULL
#define OPTION_VAL_185_SK NULL
#define OPTION_VAL_190_SK NULL
#define OPTION_VAL_195_SK NULL
#define OPTION_VAL_200_SK NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_SK NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_SK NULL
#define OPTION_VAL_LINEAR_SK "Lineárny"
#define OPTION_VAL_QUADRATIC_SK NULL
#define OPTION_VAL_CUBIC_SK NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_SK NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_SK NULL
#define OPTION_VAL_0_SK NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_SK NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_SK NULL
#define OPTION_VAL_LIBRETRO_SK NULL
#define OPTION_VAL_MEDNAFEN_SK NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_SK NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_SK NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_SK NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_SK NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_SK NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_SK NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_SK NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_SK NULL
#define OPTION_VAL_1_SK NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_SK NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_SK NULL
#define OPTION_VAL_MEMORY_ONLY_SK NULL
#define OPTION_VAL_MEMORY_CPU_SK NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_SK NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_SK NULL
#define OPTION_VAL_0PX_SK NULL
#define OPTION_VAL_1PX_SK NULL
#define OPTION_VAL_2PX_SK NULL
#define OPTION_VAL_3PX_SK NULL
#define OPTION_VAL_4PX_SK NULL
#define OPTION_VAL_5PX_SK NULL
#define OPTION_VAL_6PX_SK NULL
#define OPTION_VAL_7PX_SK NULL
#define OPTION_VAL_8PX_SK NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_SK NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_SK NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_SK NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_SK NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_SK NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_SK NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_SK NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_SK NULL
#define OPTION_VAL_DEFAULT_SK NULL
#define OPTION_VAL_AGGRESSIVE_SK NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_SK NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_SK NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_SK NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_SK NULL
#define OPTION_VAL_16_9_SK NULL
#define OPTION_VAL_16_10_SK NULL
#define OPTION_VAL_18_9_SK NULL
#define OPTION_VAL_19_9_SK NULL
#define OPTION_VAL_20_9_SK NULL
#define OPTION_VAL_21_9_SK NULL
#define OPTION_VAL_32_9_SK NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_SK NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_SK NULL
#define OPTION_VAL_100_NATIVE_SK NULL
#define OPTION_VAL_210_SK NULL
#define OPTION_VAL_220_SK NULL
#define OPTION_VAL_230_SK NULL
#define OPTION_VAL_240_SK NULL
#define OPTION_VAL_250_SK NULL
#define OPTION_VAL_260_SK NULL
#define OPTION_VAL_270_SK NULL
#define OPTION_VAL_280_SK NULL
#define OPTION_VAL_290_SK NULL
#define OPTION_VAL_300_SK NULL
#define OPTION_VAL_310_SK NULL
#define OPTION_VAL_320_SK NULL
#define OPTION_VAL_330_SK NULL
#define OPTION_VAL_340_SK NULL
#define OPTION_VAL_350_SK NULL
#define OPTION_VAL_360_SK NULL
#define OPTION_VAL_370_SK NULL
#define OPTION_VAL_380_SK NULL
#define OPTION_VAL_390_SK NULL
#define OPTION_VAL_400_SK NULL
#define OPTION_VAL_410_SK NULL
#define OPTION_VAL_420_SK NULL
#define OPTION_VAL_430_SK NULL
#define OPTION_VAL_440_SK NULL
#define OPTION_VAL_450_SK NULL
#define OPTION_VAL_460_SK NULL
#define OPTION_VAL_470_SK NULL
#define OPTION_VAL_480_SK NULL
#define OPTION_VAL_490_SK NULL
#define OPTION_VAL_500_SK NULL
#define OPTION_VAL_510_SK NULL
#define OPTION_VAL_520_SK NULL
#define OPTION_VAL_530_SK NULL
#define OPTION_VAL_540_SK NULL
#define OPTION_VAL_550_SK NULL
#define OPTION_VAL_560_SK NULL
#define OPTION_VAL_570_SK NULL
#define OPTION_VAL_580_SK NULL
#define OPTION_VAL_590_SK NULL
#define OPTION_VAL_600_SK NULL
#define OPTION_VAL_610_SK NULL
#define OPTION_VAL_620_SK NULL
#define OPTION_VAL_630_SK NULL
#define OPTION_VAL_640_SK NULL
#define OPTION_VAL_650_SK NULL
#define OPTION_VAL_660_SK NULL
#define OPTION_VAL_670_SK NULL
#define OPTION_VAL_680_SK NULL
#define OPTION_VAL_690_SK NULL
#define OPTION_VAL_700_SK NULL
#define OPTION_VAL_710_SK NULL
#define OPTION_VAL_720_SK NULL
#define OPTION_VAL_730_SK NULL
#define OPTION_VAL_740_SK NULL
#define OPTION_VAL_750_SK NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_SK NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_SK NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_SK NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_SK NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_SK NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_SK NULL
#define OPTION_VAL_PSXONPSP_SK NULL
#define OPTION_VAL_PS1_ROM_SK NULL
#define BEETLE_OPT_RENDERER_LABEL_SK NULL
#define BEETLE_OPT_RENDERER_INFO_0_SK NULL
#define OPTION_VAL_HARDWARE_SK NULL
#define OPTION_VAL_HARDWARE_GL_SK NULL
#define OPTION_VAL_HARDWARE_VK_SK NULL
#define OPTION_VAL_SOFTWARE_SK NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_SK NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_SK NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_SK NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_SK NULL
#define OPTION_VAL_DISABLED_SK NULL
#define OPTION_VAL_EXECUTE_SK NULL
#define OPTION_VAL_EXECUTE_ONE_SK NULL
#define OPTION_VAL_RUN_INTERPRETER_SK NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_SK NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_SK NULL
#define OPTION_VAL_FULL_SK NULL
#define OPTION_VAL_DMA_SK NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_SK NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_SK NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_SK NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_SK NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_SK NULL
#define OPTION_VAL_FORCE_INTERLACED_SK NULL
#define OPTION_VAL_AUTO_TOGGLE_SK NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_SK NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_SK NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_SK NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_SK NULL
#define OPTION_VAL_DISABLED_O53_SK "Žiadne"
#define OPTION_VAL_STATIC_SK NULL
#define OPTION_VAL_SMART_SK NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_SK NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_SK NULL
#define OPTION_VAL_9PX_SK NULL
#define OPTION_VAL_10PX_SK NULL
#define OPTION_VAL_11PX_SK NULL
#define OPTION_VAL_12PX_SK NULL
#define OPTION_VAL_13PX_SK NULL
#define OPTION_VAL_14PX_SK NULL
#define OPTION_VAL_15PX_SK NULL
#define OPTION_VAL_16PX_SK NULL
#define OPTION_VAL_17PX_SK NULL
#define OPTION_VAL_18PX_SK NULL
#define OPTION_VAL_19PX_SK NULL
#define OPTION_VAL_20PX_SK NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_SK NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_SK NULL
#define OPTION_VAL_12PX_O55_SK NULL
#define OPTION_VAL_11PX_O55_SK NULL
#define OPTION_VAL_10PX_O55_SK NULL
#define OPTION_VAL_9PX_O55_SK NULL
#define OPTION_VAL_8PX_O55_SK NULL
#define OPTION_VAL_7PX_O55_SK NULL
#define OPTION_VAL_6PX_O55_SK NULL
#define OPTION_VAL_5PX_O55_SK NULL
#define OPTION_VAL_4PX_O55_SK NULL
#define OPTION_VAL_3PX_O55_SK NULL
#define OPTION_VAL_2PX_O55_SK NULL
#define OPTION_VAL_1PX_O55_SK NULL
#define OPTION_VAL_DISABLED_O55_SK NULL
#define OPTION_VAL_1PX_O55_0_SK NULL
#define OPTION_VAL_2PX_O55_0_SK NULL
#define OPTION_VAL_3PX_O55_0_SK NULL
#define OPTION_VAL_4PX_O55_0_SK NULL
#define OPTION_VAL_5PX_O55_0_SK NULL
#define OPTION_VAL_6PX_O55_0_SK NULL
#define OPTION_VAL_7PX_O55_0_SK NULL
#define OPTION_VAL_8PX_O55_0_SK NULL
#define OPTION_VAL_9PX_O55_0_SK NULL
#define OPTION_VAL_10PX_O55_0_SK NULL
#define OPTION_VAL_11PX_O55_0_SK NULL
#define OPTION_VAL_12PX_O55_0_SK NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_SK NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_SK NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_SK NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_SK NULL
#define OPTION_VAL_32X_SK NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_SK NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_SK NULL
#define OPTION_VAL_CORRECTED_SK NULL
#define OPTION_VAL_UNCORRECTED_SK NULL
#define OPTION_VAL_4_3_SK NULL
#define OPTION_VAL_NTSC_SK NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_SK NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_SK NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_SK NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_SK NULL
#define OPTION_VAL_239_SK NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_SK NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_SK NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_SK NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_SK NULL
#define OPTION_VAL_287_SK NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_SK NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_SK NULL
#define OPTION_VAL_SYNC_SK NULL
#define OPTION_VAL_ASYNC_SK NULL
#define OPTION_VAL_PRECACHE_SK NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_SK NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_SK NULL
#define OPTION_VAL_2X_NATIVE_SK NULL
#define OPTION_VAL_6X_SK NULL
#define OPTION_VAL_10X_SK NULL
#define OPTION_VAL_12X_SK NULL
#define OPTION_VAL_14X_SK NULL

struct retro_core_option_v2_category option_cats_sk[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_SK,
      CATEGORY_VIDEO_INFO_0_SK
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_SK,
      CATEGORY_OSD_INFO_0_SK
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_SK,
      CATEGORY_INPUT_INFO_0_SK
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_SK,
      CATEGORY_MEMCARDS_INFO_0_SK
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_SK,
      CATEGORY_PGXP_INFO_0_SK
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_SK,
      CATEGORY_HACKS_INFO_0_SK
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_sk[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_SK,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_SK,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_SK },
         { "2x",         OPTION_VAL_2X_SK },
         { "4x",         OPTION_VAL_4X_SK },
         { "8x",         OPTION_VAL_8X_SK },
         { "16x",        OPTION_VAL_16X_SK },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_SK,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_SK,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_SK },
         { "32bpp",         OPTION_VAL_32BPP_SK },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_SK,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_SK,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_SK },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_SK },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_SK,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_SK,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_SK,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_SK,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_SK },
         { "SABR",     OPTION_VAL_SABR_SK },
         { "xBR",      OPTION_VAL_XBR_SK },
         { "bilinear", OPTION_VAL_BILINEAR_SK },
         { "3-point",  OPTION_VAL_3_POINT_SK },
         { "JINC2",    OPTION_VAL_JINC2_SK },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_SK,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_SK,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_SK },
         { "all", OPTION_VAL_ALL_SK },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_SK,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_SK,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_SK },
         { "all", OPTION_VAL_ALL_SK },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_SK,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_SK,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_SK,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_SK,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_SK,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_SK,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_SK },
         { "2x",  OPTION_VAL_2X_SK },
         { "4x",  OPTION_VAL_4X_SK },
         { "8x",  OPTION_VAL_8X_SK },
         { "16x", OPTION_VAL_16X_SK },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_SK,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_SK,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_SK,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_SK,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_SK,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_SK,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_SK,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_SK,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_SK,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_SK,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_SK,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_SK,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_SK,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_SK,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_SK,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_SK,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_SK,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_SK,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_SK,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_SK,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_SK,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_SK,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_SK,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_SK,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_SK,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_SK,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_SK },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_SK },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_SK,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_SK,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_SK },
         { "dot",   OPTION_VAL_DOT_SK },
         { "off",   OPTION_VAL_OFF_SK },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_SK,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_SK,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_SK },
         { "blue", OPTION_VAL_BLUE_SK },
         { "green", OPTION_VAL_GREEN_SK },
         { "orange", OPTION_VAL_ORANGE_SK },
         { "yellow", OPTION_VAL_YELLOW_SK },
         { "cyan", OPTION_VAL_CYAN_SK },
         { "pink", OPTION_VAL_PINK_SK },
         { "purple", OPTION_VAL_PURPLE_SK },
         { "black", OPTION_VAL_BLACK_SK },
         { "white", OPTION_VAL_WHITE_SK },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_SK,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_SK,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_SK },
         { "red", OPTION_VAL_RED_SK },
         { "green", OPTION_VAL_GREEN_SK },
         { "orange", OPTION_VAL_ORANGE_SK },
         { "yellow", OPTION_VAL_YELLOW_SK },
         { "cyan", OPTION_VAL_CYAN_SK },
         { "pink", OPTION_VAL_PINK_SK },
         { "purple", OPTION_VAL_PURPLE_SK },
         { "black", OPTION_VAL_BLACK_SK },
         { "white", OPTION_VAL_WHITE_SK },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_SK,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_SK,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_SK },
         { "10%",  OPTION_VAL_10_SK },
         { "15%",  OPTION_VAL_15_SK },
         { "20%",  OPTION_VAL_20_SK },
         { "25%",  OPTION_VAL_25_SK },
         { "30%",  OPTION_VAL_30_SK },
         { "35%",  OPTION_VAL_35_SK },
         { "40%",  OPTION_VAL_40_SK },
         { "45%",  OPTION_VAL_45_SK },
         { "50%",  OPTION_VAL_50_SK },
         { "55%",  OPTION_VAL_55_SK },
         { "60%",  OPTION_VAL_60_SK },
         { "65%",  OPTION_VAL_65_SK },
         { "70%",  OPTION_VAL_70_SK },
         { "75%",  OPTION_VAL_75_SK },
         { "80%",  OPTION_VAL_80_SK },
         { "85%",  OPTION_VAL_85_SK },
         { "90%",  OPTION_VAL_90_SK },
         { "95%",  OPTION_VAL_95_SK },
         { "100%", OPTION_VAL_100_SK },
         { "105%", OPTION_VAL_105_SK },
         { "110%", OPTION_VAL_110_SK },
         { "115%", OPTION_VAL_115_SK },
         { "120%", OPTION_VAL_120_SK },
         { "125%", OPTION_VAL_125_SK },
         { "130%", OPTION_VAL_130_SK },
         { "135%", OPTION_VAL_135_SK },
         { "140%", OPTION_VAL_140_SK },
         { "145%", OPTION_VAL_145_SK },
         { "150%", OPTION_VAL_150_SK },
         { "155%", OPTION_VAL_155_SK },
         { "160%", OPTION_VAL_160_SK },
         { "165%", OPTION_VAL_165_SK },
         { "170%", OPTION_VAL_170_SK },
         { "175%", OPTION_VAL_175_SK },
         { "180%", OPTION_VAL_180_SK },
         { "185%", OPTION_VAL_185_SK },
         { "190%", OPTION_VAL_190_SK },
         { "195%", OPTION_VAL_195_SK },
         { "200%", OPTION_VAL_200_SK },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_SK,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_SK,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_SK },
         { "quadratic", OPTION_VAL_QUADRATIC_SK },
         { "cubic",     OPTION_VAL_CUBIC_SK },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_SK,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_SK,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_SK },
         { "5%",  OPTION_VAL_5_SK },
         { "10%", OPTION_VAL_10_SK },
         { "15%", OPTION_VAL_15_SK },
         { "20%", OPTION_VAL_20_SK },
         { "25%", OPTION_VAL_25_SK },
         { "30%", OPTION_VAL_30_SK },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_SK,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_SK,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_SK },
         { "mednafen", OPTION_VAL_MEDNAFEN_SK },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_SK,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_SK,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_SK,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_SK,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_SK,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_SK,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_SK,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_SK,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_SK },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_SK,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_SK,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_SK },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_SK },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_SK,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_SK,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_SK },
         { "1px", OPTION_VAL_1PX_SK },
         { "2px", OPTION_VAL_2PX_SK },
         { "3px", OPTION_VAL_3PX_SK },
         { "4px", OPTION_VAL_4PX_SK },
         { "5px", OPTION_VAL_5PX_SK },
         { "6px", OPTION_VAL_6PX_SK },
         { "7px", OPTION_VAL_7PX_SK },
         { "8px", OPTION_VAL_8PX_SK },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_SK,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_SK,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_SK,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_SK,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_SK,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_SK,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_SK,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_SK,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_SK },
         { "aggressive", OPTION_VAL_AGGRESSIVE_SK },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_SK,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_SK,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_SK,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_SK,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_SK },
         { "16:10", OPTION_VAL_16_10_SK },
         { "18:9",  OPTION_VAL_18_9_SK },
         { "19:9",  OPTION_VAL_19_9_SK },
         { "20:9",  OPTION_VAL_20_9_SK },
         { "21:9",  OPTION_VAL_21_9_SK }, // 64:27
         { "32:9",  OPTION_VAL_32_9_SK },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_SK,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_SK,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_SK },
         { "60%",           OPTION_VAL_60_SK },
         { "70%",           OPTION_VAL_70_SK },
         { "80%",           OPTION_VAL_80_SK },
         { "90%",           OPTION_VAL_90_SK },
         { "100%(native)", OPTION_VAL_100_NATIVE_SK },
         { "110%",          OPTION_VAL_110_SK },
         { "120%",          OPTION_VAL_120_SK },
         { "130%",          OPTION_VAL_130_SK },
         { "140%",          OPTION_VAL_140_SK },
         { "150%",          OPTION_VAL_150_SK },
         { "160%",          OPTION_VAL_160_SK },
         { "170%",          OPTION_VAL_170_SK },
         { "180%",          OPTION_VAL_180_SK },
         { "190%",          OPTION_VAL_190_SK },
         { "200%",          OPTION_VAL_200_SK },
         { "210%",          OPTION_VAL_210_SK },
         { "220%",          OPTION_VAL_220_SK },
         { "230%",          OPTION_VAL_230_SK },
         { "240%",          OPTION_VAL_240_SK },
         { "250%",          OPTION_VAL_250_SK },
         { "260%",          OPTION_VAL_260_SK },
         { "270%",          OPTION_VAL_270_SK },
         { "280%",          OPTION_VAL_280_SK },
         { "290%",          OPTION_VAL_290_SK },
         { "300%",          OPTION_VAL_300_SK },
         { "310%",          OPTION_VAL_310_SK },
         { "320%",          OPTION_VAL_320_SK },
         { "330%",          OPTION_VAL_330_SK },
         { "340%",          OPTION_VAL_340_SK },
         { "350%",          OPTION_VAL_350_SK },
         { "360%",          OPTION_VAL_360_SK },
         { "370%",          OPTION_VAL_370_SK },
         { "380%",          OPTION_VAL_380_SK },
         { "390%",          OPTION_VAL_390_SK },
         { "400%",          OPTION_VAL_400_SK },
         { "410%",          OPTION_VAL_410_SK },
         { "420%",          OPTION_VAL_420_SK },
         { "430%",          OPTION_VAL_430_SK },
         { "440%",          OPTION_VAL_440_SK },
         { "450%",          OPTION_VAL_450_SK },
         { "460%",          OPTION_VAL_460_SK },
         { "470%",          OPTION_VAL_470_SK },
         { "480%",          OPTION_VAL_480_SK },
         { "490%",          OPTION_VAL_490_SK },
         { "500%",          OPTION_VAL_500_SK },
         { "510%",          OPTION_VAL_510_SK },
         { "520%",          OPTION_VAL_520_SK },
         { "530%",          OPTION_VAL_530_SK },
         { "540%",          OPTION_VAL_540_SK },
         { "550%",          OPTION_VAL_550_SK },
         { "560%",          OPTION_VAL_560_SK },
         { "570%",          OPTION_VAL_570_SK },
         { "580%",          OPTION_VAL_580_SK },
         { "590%",          OPTION_VAL_590_SK },
         { "600%",          OPTION_VAL_600_SK },
         { "610%",          OPTION_VAL_610_SK },
         { "620%",          OPTION_VAL_620_SK },
         { "630%",          OPTION_VAL_630_SK },
         { "640%",          OPTION_VAL_640_SK },
         { "650%",          OPTION_VAL_650_SK },
         { "660%",          OPTION_VAL_660_SK },
         { "670%",          OPTION_VAL_670_SK },
         { "680%",          OPTION_VAL_680_SK },
         { "690%",          OPTION_VAL_690_SK },
         { "700%",          OPTION_VAL_700_SK },
         { "710%",          OPTION_VAL_710_SK },
         { "720%",          OPTION_VAL_720_SK },
         { "730%",          OPTION_VAL_730_SK },
         { "740%",          OPTION_VAL_740_SK },
         { "750%",          OPTION_VAL_750_SK },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_SK,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_SK,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_SK,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_SK,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_SK,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_SK,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_SK },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_SK },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_SK,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_SK,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_SK },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_SK },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_SK },
#endif
         { "software",    OPTION_VAL_SOFTWARE_SK },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_SK,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_SK,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_SK,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_SK,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_SK },
         { "execute",  OPTION_VAL_EXECUTE_SK },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_SK },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_SK },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_SK,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_SK,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_SK },
         { "dma",  OPTION_VAL_DMA_SK },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_SK,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_SK,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_SK,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_SK,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_SK },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_SK },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_SK },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_SK,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_SK,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_SK,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_SK,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_SK },
         { "static",  OPTION_VAL_STATIC_SK },
         { "smart", OPTION_VAL_SMART_SK },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_SK,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_SK,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_SK },
         { "2px",      OPTION_VAL_2PX_SK },
         { "3px",      OPTION_VAL_3PX_SK },
         { "4px",      OPTION_VAL_4PX_SK },
         { "5px",      OPTION_VAL_5PX_SK },
         { "6px",      OPTION_VAL_6PX_SK },
         { "7px",      OPTION_VAL_7PX_SK },
         { "8px",      OPTION_VAL_8PX_SK },
         { "9px",      OPTION_VAL_9PX_SK },
         { "10px",     OPTION_VAL_10PX_SK },
         { "11px",     OPTION_VAL_11PX_SK },
         { "12px",     OPTION_VAL_12PX_SK },
         { "13px",     OPTION_VAL_13PX_SK },
         { "14px",     OPTION_VAL_14PX_SK },
         { "15px",     OPTION_VAL_15PX_SK },
         { "16px",     OPTION_VAL_16PX_SK },
         { "17px",     OPTION_VAL_17PX_SK },
         { "18px",     OPTION_VAL_18PX_SK },
         { "19px",     OPTION_VAL_19PX_SK },
         { "20px",     OPTION_VAL_20PX_SK },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_SK,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_SK,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_SK },
         { "-11px",    OPTION_VAL_11PX_O55_SK },
         { "-10px",    OPTION_VAL_10PX_O55_SK },
         { "-9px",     OPTION_VAL_9PX_O55_SK },
         { "-8px",     OPTION_VAL_8PX_O55_SK },
         { "-7px",     OPTION_VAL_7PX_O55_SK },
         { "-6px",     OPTION_VAL_6PX_O55_SK },
         { "-5px",     OPTION_VAL_5PX_O55_SK },
         { "-4px",     OPTION_VAL_4PX_O55_SK },
         { "-3px",     OPTION_VAL_3PX_O55_SK },
         { "-2px",     OPTION_VAL_2PX_O55_SK },
         { "-1px",     OPTION_VAL_1PX_O55_SK },
         { "disabled", OPTION_VAL_DISABLED_O55_SK },
         { "+1px",     OPTION_VAL_1PX_O55_0_SK },
         { "+2px",     OPTION_VAL_2PX_O55_0_SK },
         { "+3px",     OPTION_VAL_3PX_O55_0_SK },
         { "+4px",     OPTION_VAL_4PX_O55_0_SK },
         { "+5px",     OPTION_VAL_5PX_O55_0_SK },
         { "+6px",     OPTION_VAL_6PX_O55_0_SK },
         { "+7px",     OPTION_VAL_7PX_O55_0_SK },
         { "+8px",     OPTION_VAL_8PX_O55_0_SK },
         { "+9px",     OPTION_VAL_9PX_O55_0_SK },
         { "+10px",    OPTION_VAL_10PX_O55_0_SK },
         { "+11px",    OPTION_VAL_11PX_O55_0_SK },
         { "+12px",    OPTION_VAL_12PX_O55_0_SK },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_SK,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_SK,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_SK },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_SK,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_SK,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_SK },
         { "2x",         OPTION_VAL_2X_SK },
         { "4x",         OPTION_VAL_4X_SK },
         { "8x",         OPTION_VAL_8X_SK },
         { "16x",        OPTION_VAL_16X_SK },
         { "32x",        OPTION_VAL_32X_SK },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_SK,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_SK,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_SK },
         { "uncorrected", OPTION_VAL_UNCORRECTED_SK },
         { "4:3",  OPTION_VAL_4_3_SK },
         { "ntsc", OPTION_VAL_NTSC_SK },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_SK,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_SK,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_SK,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_SK,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_SK },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_SK,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_SK,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_SK,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_SK,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_SK },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_SK,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_SK,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_SK },
         { "async",    OPTION_VAL_ASYNC_SK },
         { "precache", OPTION_VAL_PRECACHE_SK },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_SK,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_SK,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_SK },
         { "4x",          OPTION_VAL_4X_SK },
         { "6x",          OPTION_VAL_6X_SK },
         { "8x",          OPTION_VAL_8X_SK },
         { "10x",         OPTION_VAL_10X_SK },
         { "12x",         OPTION_VAL_12X_SK },
         { "14x",         OPTION_VAL_14X_SK },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_sk = {
   option_cats_sk,
   option_defs_sk
};

/* RETRO_LANGUAGE_SR */

#define CATEGORY_VIDEO_LABEL_SR NULL
#define CATEGORY_VIDEO_INFO_0_SR NULL
#define CATEGORY_OSD_LABEL_SR NULL
#define CATEGORY_OSD_INFO_0_SR NULL
#define CATEGORY_INPUT_LABEL_SR "Ulaz"
#define CATEGORY_INPUT_INFO_0_SR NULL
#define CATEGORY_MEMCARDS_LABEL_SR NULL
#define CATEGORY_MEMCARDS_INFO_0_SR NULL
#define CATEGORY_PGXP_LABEL_SR NULL
#define CATEGORY_PGXP_INFO_0_SR NULL
#define CATEGORY_HACKS_LABEL_SR NULL
#define CATEGORY_HACKS_INFO_0_SR NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_SR NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_SR NULL
#define OPTION_VAL_1X_NATIVE_SR NULL
#define OPTION_VAL_2X_SR NULL
#define OPTION_VAL_4X_SR NULL
#define OPTION_VAL_8X_SR NULL
#define OPTION_VAL_16X_SR NULL
#define BEETLE_OPT_DEPTH_LABEL_SR NULL
#define BEETLE_OPT_DEPTH_INFO_0_SR NULL
#define OPTION_VAL_16BPP_NATIVE_SR NULL
#define OPTION_VAL_32BPP_SR NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_SR NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_SR NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_SR NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_SR NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_SR NULL
#define BEETLE_OPT_FILTER_LABEL_SR NULL
#define BEETLE_OPT_FILTER_INFO_0_SR NULL
#define OPTION_VAL_NEAREST_SR NULL
#define OPTION_VAL_SABR_SR NULL
#define OPTION_VAL_XBR_SR NULL
#define OPTION_VAL_BILINEAR_SR "Bilinearno"
#define OPTION_VAL_3_POINT_SR NULL
#define OPTION_VAL_JINC2_SR NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_SR NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_SR NULL
#define OPTION_VAL_OPAQUE_SR NULL
#define OPTION_VAL_ALL_SR NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_SR NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_SR NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_SR NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_SR NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_SR NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_SR NULL
#define BEETLE_OPT_MSAA_LABEL_SR NULL
#define BEETLE_OPT_MSAA_INFO_0_SR NULL
#define OPTION_VAL_1X_SR NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_SR NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_SR NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_SR NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_SR NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_SR NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_SR NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_SR NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_SR NULL
#define BEETLE_OPT_WIREFRAME_LABEL_SR NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_SR NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_SR NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_SR NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_SR NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_SR NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_SR NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_SR NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_SR NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_SR NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_SR NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_SR NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_SR NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_SR NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_SR NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_SR NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_SR NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_SR NULL
#define OPTION_VAL_LIGHTGUN_SR NULL
#define OPTION_VAL_TOUCHSCREEN_SR NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_SR NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_SR NULL
#define OPTION_VAL_CROSS_SR NULL
#define OPTION_VAL_DOT_SR NULL
#define OPTION_VAL_OFF_SR NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_SR NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_SR NULL
#define OPTION_VAL_RED_SR NULL
#define OPTION_VAL_BLUE_SR NULL
#define OPTION_VAL_GREEN_SR NULL
#define OPTION_VAL_ORANGE_SR NULL
#define OPTION_VAL_YELLOW_SR NULL
#define OPTION_VAL_CYAN_SR NULL
#define OPTION_VAL_PINK_SR NULL
#define OPTION_VAL_PURPLE_SR NULL
#define OPTION_VAL_BLACK_SR NULL
#define OPTION_VAL_WHITE_SR NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_SR NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_SR NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_SR NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_SR NULL
#define OPTION_VAL_5_SR NULL
#define OPTION_VAL_10_SR NULL
#define OPTION_VAL_15_SR NULL
#define OPTION_VAL_20_SR NULL
#define OPTION_VAL_25_SR NULL
#define OPTION_VAL_30_SR NULL
#define OPTION_VAL_35_SR NULL
#define OPTION_VAL_40_SR NULL
#define OPTION_VAL_45_SR NULL
#define OPTION_VAL_50_SR NULL
#define OPTION_VAL_55_SR NULL
#define OPTION_VAL_60_SR NULL
#define OPTION_VAL_65_SR NULL
#define OPTION_VAL_70_SR NULL
#define OPTION_VAL_75_SR NULL
#define OPTION_VAL_80_SR NULL
#define OPTION_VAL_85_SR NULL
#define OPTION_VAL_90_SR NULL
#define OPTION_VAL_95_SR NULL
#define OPTION_VAL_100_SR NULL
#define OPTION_VAL_105_SR NULL
#define OPTION_VAL_110_SR NULL
#define OPTION_VAL_115_SR NULL
#define OPTION_VAL_120_SR NULL
#define OPTION_VAL_125_SR NULL
#define OPTION_VAL_130_SR NULL
#define OPTION_VAL_135_SR NULL
#define OPTION_VAL_140_SR NULL
#define OPTION_VAL_145_SR NULL
#define OPTION_VAL_150_SR NULL
#define OPTION_VAL_155_SR NULL
#define OPTION_VAL_160_SR NULL
#define OPTION_VAL_165_SR NULL
#define OPTION_VAL_170_SR NULL
#define OPTION_VAL_175_SR NULL
#define OPTION_VAL_180_SR NULL
#define OPTION_VAL_185_SR NULL
#define OPTION_VAL_190_SR NULL
#define OPTION_VAL_195_SR NULL
#define OPTION_VAL_200_SR NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_SR NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_SR NULL
#define OPTION_VAL_LINEAR_SR NULL
#define OPTION_VAL_QUADRATIC_SR NULL
#define OPTION_VAL_CUBIC_SR NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_SR NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_SR NULL
#define OPTION_VAL_0_SR NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_SR NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_SR NULL
#define OPTION_VAL_LIBRETRO_SR NULL
#define OPTION_VAL_MEDNAFEN_SR NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_SR NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_SR NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_SR NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_SR NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_SR NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_SR NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_SR NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_SR NULL
#define OPTION_VAL_1_SR NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_SR NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_SR NULL
#define OPTION_VAL_MEMORY_ONLY_SR NULL
#define OPTION_VAL_MEMORY_CPU_SR NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_SR NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_SR NULL
#define OPTION_VAL_0PX_SR NULL
#define OPTION_VAL_1PX_SR NULL
#define OPTION_VAL_2PX_SR NULL
#define OPTION_VAL_3PX_SR NULL
#define OPTION_VAL_4PX_SR NULL
#define OPTION_VAL_5PX_SR NULL
#define OPTION_VAL_6PX_SR NULL
#define OPTION_VAL_7PX_SR NULL
#define OPTION_VAL_8PX_SR NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_SR NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_SR NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_SR NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_SR NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_SR NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_SR NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_SR NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_SR NULL
#define OPTION_VAL_DEFAULT_SR NULL
#define OPTION_VAL_AGGRESSIVE_SR NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_SR NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_SR NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_SR NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_SR NULL
#define OPTION_VAL_16_9_SR NULL
#define OPTION_VAL_16_10_SR NULL
#define OPTION_VAL_18_9_SR NULL
#define OPTION_VAL_19_9_SR NULL
#define OPTION_VAL_20_9_SR NULL
#define OPTION_VAL_21_9_SR NULL
#define OPTION_VAL_32_9_SR NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_SR NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_SR NULL
#define OPTION_VAL_100_NATIVE_SR NULL
#define OPTION_VAL_210_SR NULL
#define OPTION_VAL_220_SR NULL
#define OPTION_VAL_230_SR NULL
#define OPTION_VAL_240_SR NULL
#define OPTION_VAL_250_SR NULL
#define OPTION_VAL_260_SR NULL
#define OPTION_VAL_270_SR NULL
#define OPTION_VAL_280_SR NULL
#define OPTION_VAL_290_SR NULL
#define OPTION_VAL_300_SR NULL
#define OPTION_VAL_310_SR NULL
#define OPTION_VAL_320_SR NULL
#define OPTION_VAL_330_SR NULL
#define OPTION_VAL_340_SR NULL
#define OPTION_VAL_350_SR NULL
#define OPTION_VAL_360_SR NULL
#define OPTION_VAL_370_SR NULL
#define OPTION_VAL_380_SR NULL
#define OPTION_VAL_390_SR NULL
#define OPTION_VAL_400_SR NULL
#define OPTION_VAL_410_SR NULL
#define OPTION_VAL_420_SR NULL
#define OPTION_VAL_430_SR NULL
#define OPTION_VAL_440_SR NULL
#define OPTION_VAL_450_SR NULL
#define OPTION_VAL_460_SR NULL
#define OPTION_VAL_470_SR NULL
#define OPTION_VAL_480_SR NULL
#define OPTION_VAL_490_SR NULL
#define OPTION_VAL_500_SR NULL
#define OPTION_VAL_510_SR NULL
#define OPTION_VAL_520_SR NULL
#define OPTION_VAL_530_SR NULL
#define OPTION_VAL_540_SR NULL
#define OPTION_VAL_550_SR NULL
#define OPTION_VAL_560_SR NULL
#define OPTION_VAL_570_SR NULL
#define OPTION_VAL_580_SR NULL
#define OPTION_VAL_590_SR NULL
#define OPTION_VAL_600_SR NULL
#define OPTION_VAL_610_SR NULL
#define OPTION_VAL_620_SR NULL
#define OPTION_VAL_630_SR NULL
#define OPTION_VAL_640_SR NULL
#define OPTION_VAL_650_SR NULL
#define OPTION_VAL_660_SR NULL
#define OPTION_VAL_670_SR NULL
#define OPTION_VAL_680_SR NULL
#define OPTION_VAL_690_SR NULL
#define OPTION_VAL_700_SR NULL
#define OPTION_VAL_710_SR NULL
#define OPTION_VAL_720_SR NULL
#define OPTION_VAL_730_SR NULL
#define OPTION_VAL_740_SR NULL
#define OPTION_VAL_750_SR NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_SR NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_SR NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_SR NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_SR NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_SR NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_SR NULL
#define OPTION_VAL_PSXONPSP_SR NULL
#define OPTION_VAL_PS1_ROM_SR NULL
#define BEETLE_OPT_RENDERER_LABEL_SR NULL
#define BEETLE_OPT_RENDERER_INFO_0_SR NULL
#define OPTION_VAL_HARDWARE_SR NULL
#define OPTION_VAL_HARDWARE_GL_SR NULL
#define OPTION_VAL_HARDWARE_VK_SR NULL
#define OPTION_VAL_SOFTWARE_SR NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_SR NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_SR NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_SR NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_SR NULL
#define OPTION_VAL_DISABLED_SR NULL
#define OPTION_VAL_EXECUTE_SR NULL
#define OPTION_VAL_EXECUTE_ONE_SR NULL
#define OPTION_VAL_RUN_INTERPRETER_SR NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_SR NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_SR NULL
#define OPTION_VAL_FULL_SR NULL
#define OPTION_VAL_DMA_SR NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_SR NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_SR NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_SR NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_SR NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_SR NULL
#define OPTION_VAL_FORCE_INTERLACED_SR NULL
#define OPTION_VAL_AUTO_TOGGLE_SR NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_SR NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_SR NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_SR NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_SR NULL
#define OPTION_VAL_DISABLED_O53_SR NULL
#define OPTION_VAL_STATIC_SR NULL
#define OPTION_VAL_SMART_SR NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_SR NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_SR NULL
#define OPTION_VAL_9PX_SR NULL
#define OPTION_VAL_10PX_SR NULL
#define OPTION_VAL_11PX_SR NULL
#define OPTION_VAL_12PX_SR NULL
#define OPTION_VAL_13PX_SR NULL
#define OPTION_VAL_14PX_SR NULL
#define OPTION_VAL_15PX_SR NULL
#define OPTION_VAL_16PX_SR NULL
#define OPTION_VAL_17PX_SR NULL
#define OPTION_VAL_18PX_SR NULL
#define OPTION_VAL_19PX_SR NULL
#define OPTION_VAL_20PX_SR NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_SR NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_SR NULL
#define OPTION_VAL_12PX_O55_SR NULL
#define OPTION_VAL_11PX_O55_SR NULL
#define OPTION_VAL_10PX_O55_SR NULL
#define OPTION_VAL_9PX_O55_SR NULL
#define OPTION_VAL_8PX_O55_SR NULL
#define OPTION_VAL_7PX_O55_SR NULL
#define OPTION_VAL_6PX_O55_SR NULL
#define OPTION_VAL_5PX_O55_SR NULL
#define OPTION_VAL_4PX_O55_SR NULL
#define OPTION_VAL_3PX_O55_SR NULL
#define OPTION_VAL_2PX_O55_SR NULL
#define OPTION_VAL_1PX_O55_SR NULL
#define OPTION_VAL_DISABLED_O55_SR NULL
#define OPTION_VAL_1PX_O55_0_SR NULL
#define OPTION_VAL_2PX_O55_0_SR NULL
#define OPTION_VAL_3PX_O55_0_SR NULL
#define OPTION_VAL_4PX_O55_0_SR NULL
#define OPTION_VAL_5PX_O55_0_SR NULL
#define OPTION_VAL_6PX_O55_0_SR NULL
#define OPTION_VAL_7PX_O55_0_SR NULL
#define OPTION_VAL_8PX_O55_0_SR NULL
#define OPTION_VAL_9PX_O55_0_SR NULL
#define OPTION_VAL_10PX_O55_0_SR NULL
#define OPTION_VAL_11PX_O55_0_SR NULL
#define OPTION_VAL_12PX_O55_0_SR NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_SR NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_SR NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_SR NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_SR NULL
#define OPTION_VAL_32X_SR NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_SR NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_SR NULL
#define OPTION_VAL_CORRECTED_SR NULL
#define OPTION_VAL_UNCORRECTED_SR NULL
#define OPTION_VAL_4_3_SR NULL
#define OPTION_VAL_NTSC_SR NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_SR NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_SR NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_SR NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_SR NULL
#define OPTION_VAL_239_SR NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_SR NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_SR NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_SR NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_SR NULL
#define OPTION_VAL_287_SR NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_SR NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_SR NULL
#define OPTION_VAL_SYNC_SR NULL
#define OPTION_VAL_ASYNC_SR NULL
#define OPTION_VAL_PRECACHE_SR NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_SR NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_SR NULL
#define OPTION_VAL_2X_NATIVE_SR NULL
#define OPTION_VAL_6X_SR NULL
#define OPTION_VAL_10X_SR NULL
#define OPTION_VAL_12X_SR NULL
#define OPTION_VAL_14X_SR NULL

struct retro_core_option_v2_category option_cats_sr[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_SR,
      CATEGORY_VIDEO_INFO_0_SR
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_SR,
      CATEGORY_OSD_INFO_0_SR
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_SR,
      CATEGORY_INPUT_INFO_0_SR
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_SR,
      CATEGORY_MEMCARDS_INFO_0_SR
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_SR,
      CATEGORY_PGXP_INFO_0_SR
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_SR,
      CATEGORY_HACKS_INFO_0_SR
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_sr[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_SR,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_SR,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_SR },
         { "2x",         OPTION_VAL_2X_SR },
         { "4x",         OPTION_VAL_4X_SR },
         { "8x",         OPTION_VAL_8X_SR },
         { "16x",        OPTION_VAL_16X_SR },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_SR,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_SR,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_SR },
         { "32bpp",         OPTION_VAL_32BPP_SR },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_SR,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_SR,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_SR },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_SR },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_SR,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_SR,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_SR,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_SR,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_SR },
         { "SABR",     OPTION_VAL_SABR_SR },
         { "xBR",      OPTION_VAL_XBR_SR },
         { "bilinear", OPTION_VAL_BILINEAR_SR },
         { "3-point",  OPTION_VAL_3_POINT_SR },
         { "JINC2",    OPTION_VAL_JINC2_SR },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_SR,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_SR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_SR },
         { "all", OPTION_VAL_ALL_SR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_SR,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_SR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_SR },
         { "all", OPTION_VAL_ALL_SR },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_SR,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_SR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_SR,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_SR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_SR,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_SR,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_SR },
         { "2x",  OPTION_VAL_2X_SR },
         { "4x",  OPTION_VAL_4X_SR },
         { "8x",  OPTION_VAL_8X_SR },
         { "16x", OPTION_VAL_16X_SR },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_SR,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_SR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_SR,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_SR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_SR,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_SR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_SR,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_SR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_SR,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_SR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_SR,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_SR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_SR,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_SR,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_SR,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_SR,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_SR,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_SR,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_SR,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_SR,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_SR,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_SR,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_SR,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_SR,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_SR,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_SR,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_SR },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_SR },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_SR,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_SR,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_SR },
         { "dot",   OPTION_VAL_DOT_SR },
         { "off",   OPTION_VAL_OFF_SR },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_SR,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_SR,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_SR },
         { "blue", OPTION_VAL_BLUE_SR },
         { "green", OPTION_VAL_GREEN_SR },
         { "orange", OPTION_VAL_ORANGE_SR },
         { "yellow", OPTION_VAL_YELLOW_SR },
         { "cyan", OPTION_VAL_CYAN_SR },
         { "pink", OPTION_VAL_PINK_SR },
         { "purple", OPTION_VAL_PURPLE_SR },
         { "black", OPTION_VAL_BLACK_SR },
         { "white", OPTION_VAL_WHITE_SR },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_SR,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_SR,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_SR },
         { "red", OPTION_VAL_RED_SR },
         { "green", OPTION_VAL_GREEN_SR },
         { "orange", OPTION_VAL_ORANGE_SR },
         { "yellow", OPTION_VAL_YELLOW_SR },
         { "cyan", OPTION_VAL_CYAN_SR },
         { "pink", OPTION_VAL_PINK_SR },
         { "purple", OPTION_VAL_PURPLE_SR },
         { "black", OPTION_VAL_BLACK_SR },
         { "white", OPTION_VAL_WHITE_SR },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_SR,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_SR,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_SR },
         { "10%",  OPTION_VAL_10_SR },
         { "15%",  OPTION_VAL_15_SR },
         { "20%",  OPTION_VAL_20_SR },
         { "25%",  OPTION_VAL_25_SR },
         { "30%",  OPTION_VAL_30_SR },
         { "35%",  OPTION_VAL_35_SR },
         { "40%",  OPTION_VAL_40_SR },
         { "45%",  OPTION_VAL_45_SR },
         { "50%",  OPTION_VAL_50_SR },
         { "55%",  OPTION_VAL_55_SR },
         { "60%",  OPTION_VAL_60_SR },
         { "65%",  OPTION_VAL_65_SR },
         { "70%",  OPTION_VAL_70_SR },
         { "75%",  OPTION_VAL_75_SR },
         { "80%",  OPTION_VAL_80_SR },
         { "85%",  OPTION_VAL_85_SR },
         { "90%",  OPTION_VAL_90_SR },
         { "95%",  OPTION_VAL_95_SR },
         { "100%", OPTION_VAL_100_SR },
         { "105%", OPTION_VAL_105_SR },
         { "110%", OPTION_VAL_110_SR },
         { "115%", OPTION_VAL_115_SR },
         { "120%", OPTION_VAL_120_SR },
         { "125%", OPTION_VAL_125_SR },
         { "130%", OPTION_VAL_130_SR },
         { "135%", OPTION_VAL_135_SR },
         { "140%", OPTION_VAL_140_SR },
         { "145%", OPTION_VAL_145_SR },
         { "150%", OPTION_VAL_150_SR },
         { "155%", OPTION_VAL_155_SR },
         { "160%", OPTION_VAL_160_SR },
         { "165%", OPTION_VAL_165_SR },
         { "170%", OPTION_VAL_170_SR },
         { "175%", OPTION_VAL_175_SR },
         { "180%", OPTION_VAL_180_SR },
         { "185%", OPTION_VAL_185_SR },
         { "190%", OPTION_VAL_190_SR },
         { "195%", OPTION_VAL_195_SR },
         { "200%", OPTION_VAL_200_SR },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_SR,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_SR,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_SR },
         { "quadratic", OPTION_VAL_QUADRATIC_SR },
         { "cubic",     OPTION_VAL_CUBIC_SR },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_SR,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_SR,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_SR },
         { "5%",  OPTION_VAL_5_SR },
         { "10%", OPTION_VAL_10_SR },
         { "15%", OPTION_VAL_15_SR },
         { "20%", OPTION_VAL_20_SR },
         { "25%", OPTION_VAL_25_SR },
         { "30%", OPTION_VAL_30_SR },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_SR,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_SR,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_SR },
         { "mednafen", OPTION_VAL_MEDNAFEN_SR },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_SR,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_SR,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_SR,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_SR,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_SR,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_SR,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_SR,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_SR,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_SR },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_SR,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_SR,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_SR },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_SR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_SR,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_SR,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_SR },
         { "1px", OPTION_VAL_1PX_SR },
         { "2px", OPTION_VAL_2PX_SR },
         { "3px", OPTION_VAL_3PX_SR },
         { "4px", OPTION_VAL_4PX_SR },
         { "5px", OPTION_VAL_5PX_SR },
         { "6px", OPTION_VAL_6PX_SR },
         { "7px", OPTION_VAL_7PX_SR },
         { "8px", OPTION_VAL_8PX_SR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_SR,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_SR,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_SR,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_SR,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_SR,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_SR,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_SR,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_SR,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_SR },
         { "aggressive", OPTION_VAL_AGGRESSIVE_SR },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_SR,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_SR,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_SR,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_SR,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_SR },
         { "16:10", OPTION_VAL_16_10_SR },
         { "18:9",  OPTION_VAL_18_9_SR },
         { "19:9",  OPTION_VAL_19_9_SR },
         { "20:9",  OPTION_VAL_20_9_SR },
         { "21:9",  OPTION_VAL_21_9_SR }, // 64:27
         { "32:9",  OPTION_VAL_32_9_SR },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_SR,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_SR,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_SR },
         { "60%",           OPTION_VAL_60_SR },
         { "70%",           OPTION_VAL_70_SR },
         { "80%",           OPTION_VAL_80_SR },
         { "90%",           OPTION_VAL_90_SR },
         { "100%(native)", OPTION_VAL_100_NATIVE_SR },
         { "110%",          OPTION_VAL_110_SR },
         { "120%",          OPTION_VAL_120_SR },
         { "130%",          OPTION_VAL_130_SR },
         { "140%",          OPTION_VAL_140_SR },
         { "150%",          OPTION_VAL_150_SR },
         { "160%",          OPTION_VAL_160_SR },
         { "170%",          OPTION_VAL_170_SR },
         { "180%",          OPTION_VAL_180_SR },
         { "190%",          OPTION_VAL_190_SR },
         { "200%",          OPTION_VAL_200_SR },
         { "210%",          OPTION_VAL_210_SR },
         { "220%",          OPTION_VAL_220_SR },
         { "230%",          OPTION_VAL_230_SR },
         { "240%",          OPTION_VAL_240_SR },
         { "250%",          OPTION_VAL_250_SR },
         { "260%",          OPTION_VAL_260_SR },
         { "270%",          OPTION_VAL_270_SR },
         { "280%",          OPTION_VAL_280_SR },
         { "290%",          OPTION_VAL_290_SR },
         { "300%",          OPTION_VAL_300_SR },
         { "310%",          OPTION_VAL_310_SR },
         { "320%",          OPTION_VAL_320_SR },
         { "330%",          OPTION_VAL_330_SR },
         { "340%",          OPTION_VAL_340_SR },
         { "350%",          OPTION_VAL_350_SR },
         { "360%",          OPTION_VAL_360_SR },
         { "370%",          OPTION_VAL_370_SR },
         { "380%",          OPTION_VAL_380_SR },
         { "390%",          OPTION_VAL_390_SR },
         { "400%",          OPTION_VAL_400_SR },
         { "410%",          OPTION_VAL_410_SR },
         { "420%",          OPTION_VAL_420_SR },
         { "430%",          OPTION_VAL_430_SR },
         { "440%",          OPTION_VAL_440_SR },
         { "450%",          OPTION_VAL_450_SR },
         { "460%",          OPTION_VAL_460_SR },
         { "470%",          OPTION_VAL_470_SR },
         { "480%",          OPTION_VAL_480_SR },
         { "490%",          OPTION_VAL_490_SR },
         { "500%",          OPTION_VAL_500_SR },
         { "510%",          OPTION_VAL_510_SR },
         { "520%",          OPTION_VAL_520_SR },
         { "530%",          OPTION_VAL_530_SR },
         { "540%",          OPTION_VAL_540_SR },
         { "550%",          OPTION_VAL_550_SR },
         { "560%",          OPTION_VAL_560_SR },
         { "570%",          OPTION_VAL_570_SR },
         { "580%",          OPTION_VAL_580_SR },
         { "590%",          OPTION_VAL_590_SR },
         { "600%",          OPTION_VAL_600_SR },
         { "610%",          OPTION_VAL_610_SR },
         { "620%",          OPTION_VAL_620_SR },
         { "630%",          OPTION_VAL_630_SR },
         { "640%",          OPTION_VAL_640_SR },
         { "650%",          OPTION_VAL_650_SR },
         { "660%",          OPTION_VAL_660_SR },
         { "670%",          OPTION_VAL_670_SR },
         { "680%",          OPTION_VAL_680_SR },
         { "690%",          OPTION_VAL_690_SR },
         { "700%",          OPTION_VAL_700_SR },
         { "710%",          OPTION_VAL_710_SR },
         { "720%",          OPTION_VAL_720_SR },
         { "730%",          OPTION_VAL_730_SR },
         { "740%",          OPTION_VAL_740_SR },
         { "750%",          OPTION_VAL_750_SR },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_SR,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_SR,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_SR,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_SR,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_SR,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_SR,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_SR },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_SR },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_SR,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_SR,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_SR },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_SR },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_SR },
#endif
         { "software",    OPTION_VAL_SOFTWARE_SR },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_SR,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_SR,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_SR,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_SR,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_SR },
         { "execute",  OPTION_VAL_EXECUTE_SR },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_SR },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_SR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_SR,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_SR,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_SR },
         { "dma",  OPTION_VAL_DMA_SR },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_SR,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_SR,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_SR,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_SR,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_SR },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_SR },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_SR },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_SR,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_SR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_SR,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_SR,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_SR },
         { "static",  OPTION_VAL_STATIC_SR },
         { "smart", OPTION_VAL_SMART_SR },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_SR,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_SR,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_SR },
         { "2px",      OPTION_VAL_2PX_SR },
         { "3px",      OPTION_VAL_3PX_SR },
         { "4px",      OPTION_VAL_4PX_SR },
         { "5px",      OPTION_VAL_5PX_SR },
         { "6px",      OPTION_VAL_6PX_SR },
         { "7px",      OPTION_VAL_7PX_SR },
         { "8px",      OPTION_VAL_8PX_SR },
         { "9px",      OPTION_VAL_9PX_SR },
         { "10px",     OPTION_VAL_10PX_SR },
         { "11px",     OPTION_VAL_11PX_SR },
         { "12px",     OPTION_VAL_12PX_SR },
         { "13px",     OPTION_VAL_13PX_SR },
         { "14px",     OPTION_VAL_14PX_SR },
         { "15px",     OPTION_VAL_15PX_SR },
         { "16px",     OPTION_VAL_16PX_SR },
         { "17px",     OPTION_VAL_17PX_SR },
         { "18px",     OPTION_VAL_18PX_SR },
         { "19px",     OPTION_VAL_19PX_SR },
         { "20px",     OPTION_VAL_20PX_SR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_SR,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_SR,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_SR },
         { "-11px",    OPTION_VAL_11PX_O55_SR },
         { "-10px",    OPTION_VAL_10PX_O55_SR },
         { "-9px",     OPTION_VAL_9PX_O55_SR },
         { "-8px",     OPTION_VAL_8PX_O55_SR },
         { "-7px",     OPTION_VAL_7PX_O55_SR },
         { "-6px",     OPTION_VAL_6PX_O55_SR },
         { "-5px",     OPTION_VAL_5PX_O55_SR },
         { "-4px",     OPTION_VAL_4PX_O55_SR },
         { "-3px",     OPTION_VAL_3PX_O55_SR },
         { "-2px",     OPTION_VAL_2PX_O55_SR },
         { "-1px",     OPTION_VAL_1PX_O55_SR },
         { "disabled", OPTION_VAL_DISABLED_O55_SR },
         { "+1px",     OPTION_VAL_1PX_O55_0_SR },
         { "+2px",     OPTION_VAL_2PX_O55_0_SR },
         { "+3px",     OPTION_VAL_3PX_O55_0_SR },
         { "+4px",     OPTION_VAL_4PX_O55_0_SR },
         { "+5px",     OPTION_VAL_5PX_O55_0_SR },
         { "+6px",     OPTION_VAL_6PX_O55_0_SR },
         { "+7px",     OPTION_VAL_7PX_O55_0_SR },
         { "+8px",     OPTION_VAL_8PX_O55_0_SR },
         { "+9px",     OPTION_VAL_9PX_O55_0_SR },
         { "+10px",    OPTION_VAL_10PX_O55_0_SR },
         { "+11px",    OPTION_VAL_11PX_O55_0_SR },
         { "+12px",    OPTION_VAL_12PX_O55_0_SR },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_SR,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_SR,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_SR },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_SR,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_SR,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_SR },
         { "2x",         OPTION_VAL_2X_SR },
         { "4x",         OPTION_VAL_4X_SR },
         { "8x",         OPTION_VAL_8X_SR },
         { "16x",        OPTION_VAL_16X_SR },
         { "32x",        OPTION_VAL_32X_SR },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_SR,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_SR,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_SR },
         { "uncorrected", OPTION_VAL_UNCORRECTED_SR },
         { "4:3",  OPTION_VAL_4_3_SR },
         { "ntsc", OPTION_VAL_NTSC_SR },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_SR,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_SR,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_SR,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_SR,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_SR },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_SR,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_SR,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_SR,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_SR,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_SR },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_SR,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_SR,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_SR },
         { "async",    OPTION_VAL_ASYNC_SR },
         { "precache", OPTION_VAL_PRECACHE_SR },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_SR,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_SR,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_SR },
         { "4x",          OPTION_VAL_4X_SR },
         { "6x",          OPTION_VAL_6X_SR },
         { "8x",          OPTION_VAL_8X_SR },
         { "10x",         OPTION_VAL_10X_SR },
         { "12x",         OPTION_VAL_12X_SR },
         { "14x",         OPTION_VAL_14X_SR },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_sr = {
   option_cats_sr,
   option_defs_sr
};

/* RETRO_LANGUAGE_SV */

#define CATEGORY_VIDEO_LABEL_SV "Bild"
#define CATEGORY_VIDEO_INFO_0_SV NULL
#define CATEGORY_OSD_LABEL_SV NULL
#define CATEGORY_OSD_INFO_0_SV NULL
#define CATEGORY_INPUT_LABEL_SV "Inmatning"
#define CATEGORY_INPUT_INFO_0_SV NULL
#define CATEGORY_MEMCARDS_LABEL_SV "Minneskort"
#define CATEGORY_MEMCARDS_INFO_0_SV NULL
#define CATEGORY_PGXP_LABEL_SV NULL
#define CATEGORY_PGXP_INFO_0_SV NULL
#define CATEGORY_HACKS_LABEL_SV NULL
#define CATEGORY_HACKS_INFO_0_SV NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_SV NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_SV NULL
#define OPTION_VAL_1X_NATIVE_SV NULL
#define OPTION_VAL_2X_SV NULL
#define OPTION_VAL_4X_SV NULL
#define OPTION_VAL_8X_SV NULL
#define OPTION_VAL_16X_SV NULL
#define BEETLE_OPT_DEPTH_LABEL_SV NULL
#define BEETLE_OPT_DEPTH_INFO_0_SV NULL
#define OPTION_VAL_16BPP_NATIVE_SV NULL
#define OPTION_VAL_32BPP_SV NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_SV NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_SV NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_SV "Intern upplösning"
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_SV NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_SV NULL
#define BEETLE_OPT_FILTER_LABEL_SV NULL
#define BEETLE_OPT_FILTER_INFO_0_SV NULL
#define OPTION_VAL_NEAREST_SV "Närmaste"
#define OPTION_VAL_SABR_SV NULL
#define OPTION_VAL_XBR_SV NULL
#define OPTION_VAL_BILINEAR_SV "Bilinjär"
#define OPTION_VAL_3_POINT_SV NULL
#define OPTION_VAL_JINC2_SV NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_SV NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_SV NULL
#define OPTION_VAL_OPAQUE_SV NULL
#define OPTION_VAL_ALL_SV NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_SV NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_SV NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_SV NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_SV NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_SV NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_SV NULL
#define BEETLE_OPT_MSAA_LABEL_SV NULL
#define BEETLE_OPT_MSAA_INFO_0_SV NULL
#define OPTION_VAL_1X_SV NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_SV NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_SV NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_SV NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_SV NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_SV "Dumpa texturer"
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_SV NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_SV "Ersätt texturer"
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_SV NULL
#define BEETLE_OPT_WIREFRAME_LABEL_SV NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_SV NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_SV NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_SV NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_SV NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_SV NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_SV NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_SV NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_SV NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_SV NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_SV NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_SV NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_SV NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_SV NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_SV NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_SV NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_SV NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_SV NULL
#define OPTION_VAL_LIGHTGUN_SV NULL
#define OPTION_VAL_TOUCHSCREEN_SV "Pekskärm"
#define BEETLE_OPT_GUN_CURSOR_LABEL_SV NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_SV NULL
#define OPTION_VAL_CROSS_SV NULL
#define OPTION_VAL_DOT_SV NULL
#define OPTION_VAL_OFF_SV NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_SV NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_SV NULL
#define OPTION_VAL_RED_SV "Röd"
#define OPTION_VAL_BLUE_SV "Blå"
#define OPTION_VAL_GREEN_SV "Grön"
#define OPTION_VAL_ORANGE_SV NULL
#define OPTION_VAL_YELLOW_SV "Gul"
#define OPTION_VAL_CYAN_SV NULL
#define OPTION_VAL_PINK_SV "Rosa"
#define OPTION_VAL_PURPLE_SV "Lila"
#define OPTION_VAL_BLACK_SV "Svart"
#define OPTION_VAL_WHITE_SV "Vit"
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_SV NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_SV NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_SV NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_SV NULL
#define OPTION_VAL_5_SV NULL
#define OPTION_VAL_10_SV NULL
#define OPTION_VAL_15_SV NULL
#define OPTION_VAL_20_SV NULL
#define OPTION_VAL_25_SV NULL
#define OPTION_VAL_30_SV NULL
#define OPTION_VAL_35_SV NULL
#define OPTION_VAL_40_SV NULL
#define OPTION_VAL_45_SV NULL
#define OPTION_VAL_50_SV NULL
#define OPTION_VAL_55_SV NULL
#define OPTION_VAL_60_SV NULL
#define OPTION_VAL_65_SV NULL
#define OPTION_VAL_70_SV NULL
#define OPTION_VAL_75_SV NULL
#define OPTION_VAL_80_SV NULL
#define OPTION_VAL_85_SV NULL
#define OPTION_VAL_90_SV NULL
#define OPTION_VAL_95_SV NULL
#define OPTION_VAL_100_SV NULL
#define OPTION_VAL_105_SV NULL
#define OPTION_VAL_110_SV NULL
#define OPTION_VAL_115_SV NULL
#define OPTION_VAL_120_SV NULL
#define OPTION_VAL_125_SV NULL
#define OPTION_VAL_130_SV NULL
#define OPTION_VAL_135_SV NULL
#define OPTION_VAL_140_SV NULL
#define OPTION_VAL_145_SV NULL
#define OPTION_VAL_150_SV NULL
#define OPTION_VAL_155_SV NULL
#define OPTION_VAL_160_SV NULL
#define OPTION_VAL_165_SV NULL
#define OPTION_VAL_170_SV NULL
#define OPTION_VAL_175_SV NULL
#define OPTION_VAL_180_SV NULL
#define OPTION_VAL_185_SV NULL
#define OPTION_VAL_190_SV NULL
#define OPTION_VAL_195_SV NULL
#define OPTION_VAL_200_SV NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_SV NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_SV NULL
#define OPTION_VAL_LINEAR_SV "Linjär"
#define OPTION_VAL_QUADRATIC_SV "Kvadratisk"
#define OPTION_VAL_CUBIC_SV NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_SV NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_SV NULL
#define OPTION_VAL_0_SV NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_SV NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_SV NULL
#define OPTION_VAL_LIBRETRO_SV NULL
#define OPTION_VAL_MEDNAFEN_SV NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_SV NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_SV NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_SV NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_SV NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_SV NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_SV NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_SV NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_SV NULL
#define OPTION_VAL_1_SV NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_SV NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_SV NULL
#define OPTION_VAL_MEMORY_ONLY_SV "Endast minne"
#define OPTION_VAL_MEMORY_CPU_SV NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_SV NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_SV NULL
#define OPTION_VAL_0PX_SV NULL
#define OPTION_VAL_1PX_SV NULL
#define OPTION_VAL_2PX_SV NULL
#define OPTION_VAL_3PX_SV NULL
#define OPTION_VAL_4PX_SV NULL
#define OPTION_VAL_5PX_SV NULL
#define OPTION_VAL_6PX_SV NULL
#define OPTION_VAL_7PX_SV NULL
#define OPTION_VAL_8PX_SV NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_SV NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_SV NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_SV NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_SV NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_SV NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_SV NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_SV NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_SV NULL
#define OPTION_VAL_DEFAULT_SV NULL
#define OPTION_VAL_AGGRESSIVE_SV "Aggressiv"
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_SV NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_SV NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_SV NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_SV NULL
#define OPTION_VAL_16_9_SV NULL
#define OPTION_VAL_16_10_SV NULL
#define OPTION_VAL_18_9_SV NULL
#define OPTION_VAL_19_9_SV NULL
#define OPTION_VAL_20_9_SV NULL
#define OPTION_VAL_21_9_SV NULL
#define OPTION_VAL_32_9_SV NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_SV NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_SV NULL
#define OPTION_VAL_100_NATIVE_SV NULL
#define OPTION_VAL_210_SV NULL
#define OPTION_VAL_220_SV NULL
#define OPTION_VAL_230_SV NULL
#define OPTION_VAL_240_SV NULL
#define OPTION_VAL_250_SV NULL
#define OPTION_VAL_260_SV NULL
#define OPTION_VAL_270_SV NULL
#define OPTION_VAL_280_SV NULL
#define OPTION_VAL_290_SV NULL
#define OPTION_VAL_300_SV NULL
#define OPTION_VAL_310_SV NULL
#define OPTION_VAL_320_SV NULL
#define OPTION_VAL_330_SV NULL
#define OPTION_VAL_340_SV NULL
#define OPTION_VAL_350_SV NULL
#define OPTION_VAL_360_SV NULL
#define OPTION_VAL_370_SV NULL
#define OPTION_VAL_380_SV NULL
#define OPTION_VAL_390_SV NULL
#define OPTION_VAL_400_SV NULL
#define OPTION_VAL_410_SV NULL
#define OPTION_VAL_420_SV NULL
#define OPTION_VAL_430_SV NULL
#define OPTION_VAL_440_SV NULL
#define OPTION_VAL_450_SV NULL
#define OPTION_VAL_460_SV NULL
#define OPTION_VAL_470_SV NULL
#define OPTION_VAL_480_SV NULL
#define OPTION_VAL_490_SV NULL
#define OPTION_VAL_500_SV NULL
#define OPTION_VAL_510_SV NULL
#define OPTION_VAL_520_SV NULL
#define OPTION_VAL_530_SV NULL
#define OPTION_VAL_540_SV NULL
#define OPTION_VAL_550_SV NULL
#define OPTION_VAL_560_SV NULL
#define OPTION_VAL_570_SV NULL
#define OPTION_VAL_580_SV NULL
#define OPTION_VAL_590_SV NULL
#define OPTION_VAL_600_SV NULL
#define OPTION_VAL_610_SV NULL
#define OPTION_VAL_620_SV NULL
#define OPTION_VAL_630_SV NULL
#define OPTION_VAL_640_SV NULL
#define OPTION_VAL_650_SV NULL
#define OPTION_VAL_660_SV NULL
#define OPTION_VAL_670_SV NULL
#define OPTION_VAL_680_SV NULL
#define OPTION_VAL_690_SV NULL
#define OPTION_VAL_700_SV NULL
#define OPTION_VAL_710_SV NULL
#define OPTION_VAL_720_SV NULL
#define OPTION_VAL_730_SV NULL
#define OPTION_VAL_740_SV NULL
#define OPTION_VAL_750_SV NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_SV NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_SV NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_SV NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_SV NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_SV NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_SV NULL
#define OPTION_VAL_PSXONPSP_SV NULL
#define OPTION_VAL_PS1_ROM_SV NULL
#define BEETLE_OPT_RENDERER_LABEL_SV NULL
#define BEETLE_OPT_RENDERER_INFO_0_SV NULL
#define OPTION_VAL_HARDWARE_SV "Hårdvara (Auto)"
#define OPTION_VAL_HARDWARE_GL_SV "Hårdvara (OpenGL)"
#define OPTION_VAL_HARDWARE_VK_SV NULL
#define OPTION_VAL_SOFTWARE_SV "Mjukvara"
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_SV NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_SV NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_SV NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_SV NULL
#define OPTION_VAL_DISABLED_SV NULL
#define OPTION_VAL_EXECUTE_SV NULL
#define OPTION_VAL_EXECUTE_ONE_SV NULL
#define OPTION_VAL_RUN_INTERPRETER_SV NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_SV NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_SV NULL
#define OPTION_VAL_FULL_SV NULL
#define OPTION_VAL_DMA_SV NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_SV NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_SV NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_SV NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_SV NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_SV NULL
#define OPTION_VAL_FORCE_INTERLACED_SV NULL
#define OPTION_VAL_AUTO_TOGGLE_SV NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_SV NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_SV NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_SV NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_SV NULL
#define OPTION_VAL_DISABLED_O53_SV "Ingen"
#define OPTION_VAL_STATIC_SV NULL
#define OPTION_VAL_SMART_SV NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_SV NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_SV NULL
#define OPTION_VAL_9PX_SV NULL
#define OPTION_VAL_10PX_SV NULL
#define OPTION_VAL_11PX_SV NULL
#define OPTION_VAL_12PX_SV NULL
#define OPTION_VAL_13PX_SV NULL
#define OPTION_VAL_14PX_SV NULL
#define OPTION_VAL_15PX_SV NULL
#define OPTION_VAL_16PX_SV NULL
#define OPTION_VAL_17PX_SV NULL
#define OPTION_VAL_18PX_SV NULL
#define OPTION_VAL_19PX_SV NULL
#define OPTION_VAL_20PX_SV NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_SV NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_SV NULL
#define OPTION_VAL_12PX_O55_SV NULL
#define OPTION_VAL_11PX_O55_SV NULL
#define OPTION_VAL_10PX_O55_SV NULL
#define OPTION_VAL_9PX_O55_SV NULL
#define OPTION_VAL_8PX_O55_SV NULL
#define OPTION_VAL_7PX_O55_SV NULL
#define OPTION_VAL_6PX_O55_SV NULL
#define OPTION_VAL_5PX_O55_SV NULL
#define OPTION_VAL_4PX_O55_SV NULL
#define OPTION_VAL_3PX_O55_SV NULL
#define OPTION_VAL_2PX_O55_SV NULL
#define OPTION_VAL_1PX_O55_SV NULL
#define OPTION_VAL_DISABLED_O55_SV NULL
#define OPTION_VAL_1PX_O55_0_SV NULL
#define OPTION_VAL_2PX_O55_0_SV NULL
#define OPTION_VAL_3PX_O55_0_SV NULL
#define OPTION_VAL_4PX_O55_0_SV NULL
#define OPTION_VAL_5PX_O55_0_SV NULL
#define OPTION_VAL_6PX_O55_0_SV NULL
#define OPTION_VAL_7PX_O55_0_SV NULL
#define OPTION_VAL_8PX_O55_0_SV NULL
#define OPTION_VAL_9PX_O55_0_SV NULL
#define OPTION_VAL_10PX_O55_0_SV NULL
#define OPTION_VAL_11PX_O55_0_SV NULL
#define OPTION_VAL_12PX_O55_0_SV NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_SV NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_SV NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_SV NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_SV NULL
#define OPTION_VAL_32X_SV NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_SV NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_SV NULL
#define OPTION_VAL_CORRECTED_SV NULL
#define OPTION_VAL_UNCORRECTED_SV NULL
#define OPTION_VAL_4_3_SV "Tvinga 4:3"
#define OPTION_VAL_NTSC_SV "Tvinga NTSC"
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_SV NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_SV NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_SV NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_SV NULL
#define OPTION_VAL_239_SV NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_SV NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_SV NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_SV NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_SV NULL
#define OPTION_VAL_287_SV NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_SV NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_SV NULL
#define OPTION_VAL_SYNC_SV NULL
#define OPTION_VAL_ASYNC_SV NULL
#define OPTION_VAL_PRECACHE_SV NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_SV NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_SV NULL
#define OPTION_VAL_2X_NATIVE_SV NULL
#define OPTION_VAL_6X_SV NULL
#define OPTION_VAL_10X_SV NULL
#define OPTION_VAL_12X_SV NULL
#define OPTION_VAL_14X_SV NULL

struct retro_core_option_v2_category option_cats_sv[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_SV,
      CATEGORY_VIDEO_INFO_0_SV
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_SV,
      CATEGORY_OSD_INFO_0_SV
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_SV,
      CATEGORY_INPUT_INFO_0_SV
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_SV,
      CATEGORY_MEMCARDS_INFO_0_SV
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_SV,
      CATEGORY_PGXP_INFO_0_SV
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_SV,
      CATEGORY_HACKS_INFO_0_SV
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_sv[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_SV,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_SV,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_SV },
         { "2x",         OPTION_VAL_2X_SV },
         { "4x",         OPTION_VAL_4X_SV },
         { "8x",         OPTION_VAL_8X_SV },
         { "16x",        OPTION_VAL_16X_SV },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_SV,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_SV,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_SV },
         { "32bpp",         OPTION_VAL_32BPP_SV },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_SV,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_SV,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_SV },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_SV },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_SV,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_SV,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_SV,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_SV,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_SV },
         { "SABR",     OPTION_VAL_SABR_SV },
         { "xBR",      OPTION_VAL_XBR_SV },
         { "bilinear", OPTION_VAL_BILINEAR_SV },
         { "3-point",  OPTION_VAL_3_POINT_SV },
         { "JINC2",    OPTION_VAL_JINC2_SV },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_SV,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_SV,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_SV },
         { "all", OPTION_VAL_ALL_SV },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_SV,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_SV,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_SV },
         { "all", OPTION_VAL_ALL_SV },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_SV,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_SV,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_SV,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_SV,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_SV,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_SV,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_SV },
         { "2x",  OPTION_VAL_2X_SV },
         { "4x",  OPTION_VAL_4X_SV },
         { "8x",  OPTION_VAL_8X_SV },
         { "16x", OPTION_VAL_16X_SV },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_SV,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_SV,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_SV,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_SV,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_SV,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_SV,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_SV,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_SV,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_SV,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_SV,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_SV,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_SV,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_SV,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_SV,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_SV,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_SV,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_SV,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_SV,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_SV,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_SV,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_SV,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_SV,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_SV,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_SV,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_SV,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_SV,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_SV },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_SV },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_SV,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_SV,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_SV },
         { "dot",   OPTION_VAL_DOT_SV },
         { "off",   OPTION_VAL_OFF_SV },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_SV,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_SV,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_SV },
         { "blue", OPTION_VAL_BLUE_SV },
         { "green", OPTION_VAL_GREEN_SV },
         { "orange", OPTION_VAL_ORANGE_SV },
         { "yellow", OPTION_VAL_YELLOW_SV },
         { "cyan", OPTION_VAL_CYAN_SV },
         { "pink", OPTION_VAL_PINK_SV },
         { "purple", OPTION_VAL_PURPLE_SV },
         { "black", OPTION_VAL_BLACK_SV },
         { "white", OPTION_VAL_WHITE_SV },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_SV,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_SV,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_SV },
         { "red", OPTION_VAL_RED_SV },
         { "green", OPTION_VAL_GREEN_SV },
         { "orange", OPTION_VAL_ORANGE_SV },
         { "yellow", OPTION_VAL_YELLOW_SV },
         { "cyan", OPTION_VAL_CYAN_SV },
         { "pink", OPTION_VAL_PINK_SV },
         { "purple", OPTION_VAL_PURPLE_SV },
         { "black", OPTION_VAL_BLACK_SV },
         { "white", OPTION_VAL_WHITE_SV },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_SV,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_SV,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_SV },
         { "10%",  OPTION_VAL_10_SV },
         { "15%",  OPTION_VAL_15_SV },
         { "20%",  OPTION_VAL_20_SV },
         { "25%",  OPTION_VAL_25_SV },
         { "30%",  OPTION_VAL_30_SV },
         { "35%",  OPTION_VAL_35_SV },
         { "40%",  OPTION_VAL_40_SV },
         { "45%",  OPTION_VAL_45_SV },
         { "50%",  OPTION_VAL_50_SV },
         { "55%",  OPTION_VAL_55_SV },
         { "60%",  OPTION_VAL_60_SV },
         { "65%",  OPTION_VAL_65_SV },
         { "70%",  OPTION_VAL_70_SV },
         { "75%",  OPTION_VAL_75_SV },
         { "80%",  OPTION_VAL_80_SV },
         { "85%",  OPTION_VAL_85_SV },
         { "90%",  OPTION_VAL_90_SV },
         { "95%",  OPTION_VAL_95_SV },
         { "100%", OPTION_VAL_100_SV },
         { "105%", OPTION_VAL_105_SV },
         { "110%", OPTION_VAL_110_SV },
         { "115%", OPTION_VAL_115_SV },
         { "120%", OPTION_VAL_120_SV },
         { "125%", OPTION_VAL_125_SV },
         { "130%", OPTION_VAL_130_SV },
         { "135%", OPTION_VAL_135_SV },
         { "140%", OPTION_VAL_140_SV },
         { "145%", OPTION_VAL_145_SV },
         { "150%", OPTION_VAL_150_SV },
         { "155%", OPTION_VAL_155_SV },
         { "160%", OPTION_VAL_160_SV },
         { "165%", OPTION_VAL_165_SV },
         { "170%", OPTION_VAL_170_SV },
         { "175%", OPTION_VAL_175_SV },
         { "180%", OPTION_VAL_180_SV },
         { "185%", OPTION_VAL_185_SV },
         { "190%", OPTION_VAL_190_SV },
         { "195%", OPTION_VAL_195_SV },
         { "200%", OPTION_VAL_200_SV },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_SV,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_SV,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_SV },
         { "quadratic", OPTION_VAL_QUADRATIC_SV },
         { "cubic",     OPTION_VAL_CUBIC_SV },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_SV,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_SV,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_SV },
         { "5%",  OPTION_VAL_5_SV },
         { "10%", OPTION_VAL_10_SV },
         { "15%", OPTION_VAL_15_SV },
         { "20%", OPTION_VAL_20_SV },
         { "25%", OPTION_VAL_25_SV },
         { "30%", OPTION_VAL_30_SV },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_SV,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_SV,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_SV },
         { "mednafen", OPTION_VAL_MEDNAFEN_SV },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_SV,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_SV,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_SV,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_SV,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_SV,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_SV,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_SV,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_SV,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_SV },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_SV,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_SV,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_SV },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_SV },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_SV,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_SV,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_SV },
         { "1px", OPTION_VAL_1PX_SV },
         { "2px", OPTION_VAL_2PX_SV },
         { "3px", OPTION_VAL_3PX_SV },
         { "4px", OPTION_VAL_4PX_SV },
         { "5px", OPTION_VAL_5PX_SV },
         { "6px", OPTION_VAL_6PX_SV },
         { "7px", OPTION_VAL_7PX_SV },
         { "8px", OPTION_VAL_8PX_SV },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_SV,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_SV,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_SV,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_SV,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_SV,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_SV,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_SV,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_SV,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_SV },
         { "aggressive", OPTION_VAL_AGGRESSIVE_SV },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_SV,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_SV,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_SV,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_SV,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_SV },
         { "16:10", OPTION_VAL_16_10_SV },
         { "18:9",  OPTION_VAL_18_9_SV },
         { "19:9",  OPTION_VAL_19_9_SV },
         { "20:9",  OPTION_VAL_20_9_SV },
         { "21:9",  OPTION_VAL_21_9_SV }, // 64:27
         { "32:9",  OPTION_VAL_32_9_SV },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_SV,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_SV,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_SV },
         { "60%",           OPTION_VAL_60_SV },
         { "70%",           OPTION_VAL_70_SV },
         { "80%",           OPTION_VAL_80_SV },
         { "90%",           OPTION_VAL_90_SV },
         { "100%(native)", OPTION_VAL_100_NATIVE_SV },
         { "110%",          OPTION_VAL_110_SV },
         { "120%",          OPTION_VAL_120_SV },
         { "130%",          OPTION_VAL_130_SV },
         { "140%",          OPTION_VAL_140_SV },
         { "150%",          OPTION_VAL_150_SV },
         { "160%",          OPTION_VAL_160_SV },
         { "170%",          OPTION_VAL_170_SV },
         { "180%",          OPTION_VAL_180_SV },
         { "190%",          OPTION_VAL_190_SV },
         { "200%",          OPTION_VAL_200_SV },
         { "210%",          OPTION_VAL_210_SV },
         { "220%",          OPTION_VAL_220_SV },
         { "230%",          OPTION_VAL_230_SV },
         { "240%",          OPTION_VAL_240_SV },
         { "250%",          OPTION_VAL_250_SV },
         { "260%",          OPTION_VAL_260_SV },
         { "270%",          OPTION_VAL_270_SV },
         { "280%",          OPTION_VAL_280_SV },
         { "290%",          OPTION_VAL_290_SV },
         { "300%",          OPTION_VAL_300_SV },
         { "310%",          OPTION_VAL_310_SV },
         { "320%",          OPTION_VAL_320_SV },
         { "330%",          OPTION_VAL_330_SV },
         { "340%",          OPTION_VAL_340_SV },
         { "350%",          OPTION_VAL_350_SV },
         { "360%",          OPTION_VAL_360_SV },
         { "370%",          OPTION_VAL_370_SV },
         { "380%",          OPTION_VAL_380_SV },
         { "390%",          OPTION_VAL_390_SV },
         { "400%",          OPTION_VAL_400_SV },
         { "410%",          OPTION_VAL_410_SV },
         { "420%",          OPTION_VAL_420_SV },
         { "430%",          OPTION_VAL_430_SV },
         { "440%",          OPTION_VAL_440_SV },
         { "450%",          OPTION_VAL_450_SV },
         { "460%",          OPTION_VAL_460_SV },
         { "470%",          OPTION_VAL_470_SV },
         { "480%",          OPTION_VAL_480_SV },
         { "490%",          OPTION_VAL_490_SV },
         { "500%",          OPTION_VAL_500_SV },
         { "510%",          OPTION_VAL_510_SV },
         { "520%",          OPTION_VAL_520_SV },
         { "530%",          OPTION_VAL_530_SV },
         { "540%",          OPTION_VAL_540_SV },
         { "550%",          OPTION_VAL_550_SV },
         { "560%",          OPTION_VAL_560_SV },
         { "570%",          OPTION_VAL_570_SV },
         { "580%",          OPTION_VAL_580_SV },
         { "590%",          OPTION_VAL_590_SV },
         { "600%",          OPTION_VAL_600_SV },
         { "610%",          OPTION_VAL_610_SV },
         { "620%",          OPTION_VAL_620_SV },
         { "630%",          OPTION_VAL_630_SV },
         { "640%",          OPTION_VAL_640_SV },
         { "650%",          OPTION_VAL_650_SV },
         { "660%",          OPTION_VAL_660_SV },
         { "670%",          OPTION_VAL_670_SV },
         { "680%",          OPTION_VAL_680_SV },
         { "690%",          OPTION_VAL_690_SV },
         { "700%",          OPTION_VAL_700_SV },
         { "710%",          OPTION_VAL_710_SV },
         { "720%",          OPTION_VAL_720_SV },
         { "730%",          OPTION_VAL_730_SV },
         { "740%",          OPTION_VAL_740_SV },
         { "750%",          OPTION_VAL_750_SV },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_SV,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_SV,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_SV,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_SV,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_SV,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_SV,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_SV },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_SV },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_SV,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_SV,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_SV },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_SV },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_SV },
#endif
         { "software",    OPTION_VAL_SOFTWARE_SV },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_SV,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_SV,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_SV,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_SV,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_SV },
         { "execute",  OPTION_VAL_EXECUTE_SV },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_SV },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_SV },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_SV,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_SV,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_SV },
         { "dma",  OPTION_VAL_DMA_SV },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_SV,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_SV,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_SV,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_SV,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_SV },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_SV },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_SV },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_SV,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_SV,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_SV,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_SV,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_SV },
         { "static",  OPTION_VAL_STATIC_SV },
         { "smart", OPTION_VAL_SMART_SV },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_SV,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_SV,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_SV },
         { "2px",      OPTION_VAL_2PX_SV },
         { "3px",      OPTION_VAL_3PX_SV },
         { "4px",      OPTION_VAL_4PX_SV },
         { "5px",      OPTION_VAL_5PX_SV },
         { "6px",      OPTION_VAL_6PX_SV },
         { "7px",      OPTION_VAL_7PX_SV },
         { "8px",      OPTION_VAL_8PX_SV },
         { "9px",      OPTION_VAL_9PX_SV },
         { "10px",     OPTION_VAL_10PX_SV },
         { "11px",     OPTION_VAL_11PX_SV },
         { "12px",     OPTION_VAL_12PX_SV },
         { "13px",     OPTION_VAL_13PX_SV },
         { "14px",     OPTION_VAL_14PX_SV },
         { "15px",     OPTION_VAL_15PX_SV },
         { "16px",     OPTION_VAL_16PX_SV },
         { "17px",     OPTION_VAL_17PX_SV },
         { "18px",     OPTION_VAL_18PX_SV },
         { "19px",     OPTION_VAL_19PX_SV },
         { "20px",     OPTION_VAL_20PX_SV },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_SV,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_SV,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_SV },
         { "-11px",    OPTION_VAL_11PX_O55_SV },
         { "-10px",    OPTION_VAL_10PX_O55_SV },
         { "-9px",     OPTION_VAL_9PX_O55_SV },
         { "-8px",     OPTION_VAL_8PX_O55_SV },
         { "-7px",     OPTION_VAL_7PX_O55_SV },
         { "-6px",     OPTION_VAL_6PX_O55_SV },
         { "-5px",     OPTION_VAL_5PX_O55_SV },
         { "-4px",     OPTION_VAL_4PX_O55_SV },
         { "-3px",     OPTION_VAL_3PX_O55_SV },
         { "-2px",     OPTION_VAL_2PX_O55_SV },
         { "-1px",     OPTION_VAL_1PX_O55_SV },
         { "disabled", OPTION_VAL_DISABLED_O55_SV },
         { "+1px",     OPTION_VAL_1PX_O55_0_SV },
         { "+2px",     OPTION_VAL_2PX_O55_0_SV },
         { "+3px",     OPTION_VAL_3PX_O55_0_SV },
         { "+4px",     OPTION_VAL_4PX_O55_0_SV },
         { "+5px",     OPTION_VAL_5PX_O55_0_SV },
         { "+6px",     OPTION_VAL_6PX_O55_0_SV },
         { "+7px",     OPTION_VAL_7PX_O55_0_SV },
         { "+8px",     OPTION_VAL_8PX_O55_0_SV },
         { "+9px",     OPTION_VAL_9PX_O55_0_SV },
         { "+10px",    OPTION_VAL_10PX_O55_0_SV },
         { "+11px",    OPTION_VAL_11PX_O55_0_SV },
         { "+12px",    OPTION_VAL_12PX_O55_0_SV },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_SV,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_SV,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_SV },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_SV,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_SV,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_SV },
         { "2x",         OPTION_VAL_2X_SV },
         { "4x",         OPTION_VAL_4X_SV },
         { "8x",         OPTION_VAL_8X_SV },
         { "16x",        OPTION_VAL_16X_SV },
         { "32x",        OPTION_VAL_32X_SV },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_SV,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_SV,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_SV },
         { "uncorrected", OPTION_VAL_UNCORRECTED_SV },
         { "4:3",  OPTION_VAL_4_3_SV },
         { "ntsc", OPTION_VAL_NTSC_SV },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_SV,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_SV,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_SV,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_SV,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_SV },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_SV,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_SV,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_SV,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_SV,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_SV },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_SV,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_SV,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_SV },
         { "async",    OPTION_VAL_ASYNC_SV },
         { "precache", OPTION_VAL_PRECACHE_SV },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_SV,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_SV,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_SV },
         { "4x",          OPTION_VAL_4X_SV },
         { "6x",          OPTION_VAL_6X_SV },
         { "8x",          OPTION_VAL_8X_SV },
         { "10x",         OPTION_VAL_10X_SV },
         { "12x",         OPTION_VAL_12X_SV },
         { "14x",         OPTION_VAL_14X_SV },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_sv = {
   option_cats_sv,
   option_defs_sv
};

/* RETRO_LANGUAGE_TR */

#define CATEGORY_VIDEO_LABEL_TR NULL
#define CATEGORY_VIDEO_INFO_0_TR "En boy oranını, ekran kırpmayı, video filtresini ve kare atlama ayarlarını değiştirin."
#define CATEGORY_OSD_LABEL_TR "Ekran Bildirimleri"
#define CATEGORY_OSD_INFO_0_TR "Ekranda gösterilen bildirimleri değiştirin."
#define CATEGORY_INPUT_LABEL_TR "Girdi"
#define CATEGORY_INPUT_INFO_0_TR NULL
#define CATEGORY_MEMCARDS_LABEL_TR "Bellek Kartı"
#define CATEGORY_MEMCARDS_INFO_0_TR NULL
#define CATEGORY_PGXP_LABEL_TR NULL
#define CATEGORY_PGXP_INFO_0_TR NULL
#define CATEGORY_HACKS_LABEL_TR "Emülatör geliştirmeleri"
#define CATEGORY_HACKS_INFO_0_TR "Düşük seviyeli performansı ve uyumluluğu etkileyen işlemci hız aşırtma ve taklit doğruluğu ayarlarını değiştirin."
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_TR "Dahili GPU Çözünürlüğü"
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_TR NULL
#define OPTION_VAL_1X_NATIVE_TR "1x (Doğal)"
#define OPTION_VAL_2X_TR NULL
#define OPTION_VAL_4X_TR NULL
#define OPTION_VAL_8X_TR NULL
#define OPTION_VAL_16X_TR NULL
#define BEETLE_OPT_DEPTH_LABEL_TR "Dahili Renk Derinliği"
#define BEETLE_OPT_DEPTH_INFO_0_TR NULL
#define OPTION_VAL_16BPP_NATIVE_TR "16 bpp (Doğal)"
#define OPTION_VAL_32BPP_TR NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_TR "Titreşim Kalıbı"
#define BEETLE_OPT_DITHER_MODE_INFO_0_TR NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_TR "Dahili Çözünürlük"
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_TR NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_TR NULL
#define BEETLE_OPT_FILTER_LABEL_TR NULL
#define BEETLE_OPT_FILTER_INFO_0_TR NULL
#define OPTION_VAL_NEAREST_TR "En Yakın"
#define OPTION_VAL_SABR_TR NULL
#define OPTION_VAL_XBR_TR NULL
#define OPTION_VAL_BILINEAR_TR "İkili Doğrusal"
#define OPTION_VAL_3_POINT_TR NULL
#define OPTION_VAL_JINC2_TR NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_TR NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_TR NULL
#define OPTION_VAL_OPAQUE_TR NULL
#define OPTION_VAL_ALL_TR NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_TR NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_TR NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_TR "Uyarlanabilir Yumuşatma"
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_TR NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_TR NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_TR NULL
#define BEETLE_OPT_MSAA_LABEL_TR NULL
#define BEETLE_OPT_MSAA_INFO_0_TR NULL
#define OPTION_VAL_1X_TR NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_TR NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_TR NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_TR "Dokuları İzle"
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_TR "Doku saklama ve değiştirme için ön koşul. Muhtemelen çoğu oyunda çökecektir."
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_TR "Dokuları Sakla"
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_TR "Kullanılan dokuları <cd>-texture-dump/ dizinine saklayın"
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_TR "Dokuları Değiştir"
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_TR "<cd>-texture-replacements/ adresindeki HD sürümlerini kullanarak dokuları değiştirin"
#define BEETLE_OPT_WIREFRAME_LABEL_TR "Tel Kafes Kipi (Hata Ayıklama)"
#define BEETLE_OPT_WIREFRAME_INFO_0_TR "3B modelleri doku veya gölgeleme olmadan anahat biçiminde işleyin. Yalnızca OpenGL donanım oluşturucusu tarafından desteklenir. Not: Bu, hata ayıklama amaçlıdır ve normalde devre dışı bırakılmalıdır."
#define BEETLE_OPT_FRAME_DUPING_LABEL_TR "Kareleri Çoğalt (Hızlandır)"
#define BEETLE_OPT_FRAME_DUPING_INFO_0_TR NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_TR "Dahili FPS'yi Görüntüle"
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_TR NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_TR "Tam VRAM Görüntüle (Hata Ayıklama)"
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_TR NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_TR NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_TR NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_TR NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_TR NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_TR NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_TR NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_TR NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_TR NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_TR NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_TR NULL
#define OPTION_VAL_LIGHTGUN_TR NULL
#define OPTION_VAL_TOUCHSCREEN_TR "Dokunmatik Ekran"
#define BEETLE_OPT_GUN_CURSOR_LABEL_TR "Silah İmleci"
#define BEETLE_OPT_GUN_CURSOR_INFO_0_TR "'Guncon/G-Con 45' ve 'Justifier' giriş cihazı türlerini kullanırken ekranda görüntülenecek silah imlecini seçin. Devre dışı bırakıldığında, artı işareti her zaman gizlenir."
#define OPTION_VAL_CROSS_TR "Çarpı"
#define OPTION_VAL_DOT_TR "Nokta"
#define OPTION_VAL_OFF_TR "İmleç Yok"
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_TR "1. Port: Silah Nişangah Rengi"
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_TR "1ç port için hafif silah artı imleci rengini seçin."
#define OPTION_VAL_RED_TR "Kırmızı"
#define OPTION_VAL_BLUE_TR "Mavi"
#define OPTION_VAL_GREEN_TR "Yeşil"
#define OPTION_VAL_ORANGE_TR "Turuncu"
#define OPTION_VAL_YELLOW_TR "Sarı"
#define OPTION_VAL_CYAN_TR "Camgöbeği"
#define OPTION_VAL_PINK_TR "Pembe"
#define OPTION_VAL_PURPLE_TR "Mor"
#define OPTION_VAL_BLACK_TR "Siyah"
#define OPTION_VAL_WHITE_TR "Beyaz"
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_TR "2. Port: Silah Nişangah Rengi"
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_TR NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_TR "Fare Hassasiyeti"
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_TR NULL
#define OPTION_VAL_5_TR "%5"
#define OPTION_VAL_10_TR "%10"
#define OPTION_VAL_15_TR "%15"
#define OPTION_VAL_20_TR "%20"
#define OPTION_VAL_25_TR "%25"
#define OPTION_VAL_30_TR "%30"
#define OPTION_VAL_35_TR "%35"
#define OPTION_VAL_40_TR "%40"
#define OPTION_VAL_45_TR "%45"
#define OPTION_VAL_50_TR "%50"
#define OPTION_VAL_55_TR "%55"
#define OPTION_VAL_60_TR "%60"
#define OPTION_VAL_65_TR "%65"
#define OPTION_VAL_70_TR "%70"
#define OPTION_VAL_75_TR "%75"
#define OPTION_VAL_80_TR "%80"
#define OPTION_VAL_85_TR "%85"
#define OPTION_VAL_90_TR "%90"
#define OPTION_VAL_95_TR "%95"
#define OPTION_VAL_100_TR "%100 (Varsayılan)"
#define OPTION_VAL_105_TR "%105"
#define OPTION_VAL_110_TR "%110"
#define OPTION_VAL_115_TR "%115"
#define OPTION_VAL_120_TR "%120"
#define OPTION_VAL_125_TR "%125"
#define OPTION_VAL_130_TR "%130"
#define OPTION_VAL_135_TR "%135"
#define OPTION_VAL_140_TR "%140"
#define OPTION_VAL_145_TR "%145"
#define OPTION_VAL_150_TR "%150"
#define OPTION_VAL_155_TR "%155"
#define OPTION_VAL_160_TR "%160"
#define OPTION_VAL_165_TR "%165"
#define OPTION_VAL_170_TR "%170"
#define OPTION_VAL_175_TR "%175"
#define OPTION_VAL_180_TR "%180"
#define OPTION_VAL_185_TR "%185"
#define OPTION_VAL_190_TR "%190"
#define OPTION_VAL_195_TR "%195"
#define OPTION_VAL_200_TR "%200"
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_TR NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_TR NULL
#define OPTION_VAL_LINEAR_TR "Doğrusal"
#define OPTION_VAL_QUADRATIC_TR "Karesel"
#define OPTION_VAL_CUBIC_TR "Kübik"
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_TR NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_TR NULL
#define OPTION_VAL_0_TR "%0"
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_TR NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_TR NULL
#define OPTION_VAL_LIBRETRO_TR NULL
#define OPTION_VAL_MEDNAFEN_TR NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_TR NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_TR NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_TR NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_TR NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_TR NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_TR NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_TR NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_TR NULL
#define OPTION_VAL_1_TR "1 (Varsayılan)"
#define BEETLE_OPT_PGXP_MODE_LABEL_TR NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_TR NULL
#define OPTION_VAL_MEMORY_ONLY_TR NULL
#define OPTION_VAL_MEMORY_CPU_TR NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_TR NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_TR NULL
#define OPTION_VAL_0PX_TR NULL
#define OPTION_VAL_1PX_TR NULL
#define OPTION_VAL_2PX_TR NULL
#define OPTION_VAL_3PX_TR NULL
#define OPTION_VAL_4PX_TR NULL
#define OPTION_VAL_5PX_TR NULL
#define OPTION_VAL_6PX_TR NULL
#define OPTION_VAL_7PX_TR NULL
#define OPTION_VAL_8PX_TR NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_TR NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_TR NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_TR NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_TR NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_TR NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_TR NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_TR NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_TR NULL
#define OPTION_VAL_DEFAULT_TR "Varsayılan"
#define OPTION_VAL_AGGRESSIVE_TR "Agresif"
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_TR "Geniş Ekran Geliştirmesi"
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_TR NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_TR NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_TR NULL
#define OPTION_VAL_16_9_TR NULL
#define OPTION_VAL_16_10_TR NULL
#define OPTION_VAL_18_9_TR NULL
#define OPTION_VAL_19_9_TR NULL
#define OPTION_VAL_20_9_TR NULL
#define OPTION_VAL_21_9_TR NULL
#define OPTION_VAL_32_9_TR NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_TR NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_TR NULL
#define OPTION_VAL_100_NATIVE_TR "%100 (Doğal)"
#define OPTION_VAL_210_TR "%210"
#define OPTION_VAL_220_TR "%220"
#define OPTION_VAL_230_TR "%230"
#define OPTION_VAL_240_TR "%240"
#define OPTION_VAL_250_TR "%250"
#define OPTION_VAL_260_TR "%260"
#define OPTION_VAL_270_TR "%270"
#define OPTION_VAL_280_TR "%280"
#define OPTION_VAL_290_TR "%290"
#define OPTION_VAL_300_TR "%300"
#define OPTION_VAL_310_TR "%310"
#define OPTION_VAL_320_TR "%320"
#define OPTION_VAL_330_TR "%330"
#define OPTION_VAL_340_TR "%340"
#define OPTION_VAL_350_TR "%350"
#define OPTION_VAL_360_TR "%360"
#define OPTION_VAL_370_TR "%370"
#define OPTION_VAL_380_TR "%380"
#define OPTION_VAL_390_TR "%390"
#define OPTION_VAL_400_TR "%400"
#define OPTION_VAL_410_TR "%410"
#define OPTION_VAL_420_TR "%420"
#define OPTION_VAL_430_TR "%430"
#define OPTION_VAL_440_TR "%440"
#define OPTION_VAL_450_TR "%450"
#define OPTION_VAL_460_TR "%460"
#define OPTION_VAL_470_TR "%470"
#define OPTION_VAL_480_TR "%480"
#define OPTION_VAL_490_TR "%490"
#define OPTION_VAL_500_TR "%500"
#define OPTION_VAL_510_TR "%510"
#define OPTION_VAL_520_TR "%520"
#define OPTION_VAL_530_TR "%530"
#define OPTION_VAL_540_TR "%540"
#define OPTION_VAL_550_TR "%550"
#define OPTION_VAL_560_TR "%560"
#define OPTION_VAL_570_TR "%570"
#define OPTION_VAL_580_TR "%580"
#define OPTION_VAL_590_TR "%590"
#define OPTION_VAL_600_TR "%600"
#define OPTION_VAL_610_TR "%610"
#define OPTION_VAL_620_TR "%620"
#define OPTION_VAL_630_TR "%630"
#define OPTION_VAL_640_TR "%640"
#define OPTION_VAL_650_TR "%650"
#define OPTION_VAL_660_TR "%660"
#define OPTION_VAL_670_TR "%670"
#define OPTION_VAL_680_TR "%680"
#define OPTION_VAL_690_TR "%690"
#define OPTION_VAL_700_TR "%700"
#define OPTION_VAL_710_TR "%710"
#define OPTION_VAL_720_TR "%720"
#define OPTION_VAL_730_TR "%730"
#define OPTION_VAL_740_TR "%740"
#define OPTION_VAL_750_TR "%750"
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_TR "GTE Hız Aşırtma"
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_TR NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_TR "BIOS'u Atla"
#define BEETLE_OPT_SKIP_BIOS_INFO_0_TR NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_TR NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_TR NULL
#define OPTION_VAL_PSXONPSP_TR NULL
#define OPTION_VAL_PS1_ROM_TR NULL
#define BEETLE_OPT_RENDERER_LABEL_TR NULL
#define BEETLE_OPT_RENDERER_INFO_0_TR NULL
#define OPTION_VAL_HARDWARE_TR "Donanım (Otomatik)"
#define OPTION_VAL_HARDWARE_GL_TR "Donanım (OpenGL)"
#define OPTION_VAL_HARDWARE_VK_TR "Donanım (Vulkan)"
#define OPTION_VAL_SOFTWARE_TR "Yazılım"
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_TR NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_TR NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_TR NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_TR NULL
#define OPTION_VAL_DISABLED_TR NULL
#define OPTION_VAL_EXECUTE_TR "Azami Performans"
#define OPTION_VAL_EXECUTE_ONE_TR NULL
#define OPTION_VAL_RUN_INTERPRETER_TR NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_TR NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_TR NULL
#define OPTION_VAL_FULL_TR "Tam"
#define OPTION_VAL_DMA_TR NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_TR NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_TR NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_TR NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_TR NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_TR NULL
#define OPTION_VAL_FORCE_INTERLACED_TR NULL
#define OPTION_VAL_AUTO_TOGGLE_TR NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_TR NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_TR NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_TR "Aşırı Taramayı Kırp"
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_TR NULL
#define OPTION_VAL_DISABLED_O53_TR "Yok"
#define OPTION_VAL_STATIC_TR "Statik"
#define OPTION_VAL_SMART_TR "Dinamik (Varsayılan)"
#define BEETLE_OPT_IMAGE_CROP_LABEL_TR NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_TR NULL
#define OPTION_VAL_9PX_TR NULL
#define OPTION_VAL_10PX_TR NULL
#define OPTION_VAL_11PX_TR NULL
#define OPTION_VAL_12PX_TR NULL
#define OPTION_VAL_13PX_TR NULL
#define OPTION_VAL_14PX_TR NULL
#define OPTION_VAL_15PX_TR NULL
#define OPTION_VAL_16PX_TR NULL
#define OPTION_VAL_17PX_TR NULL
#define OPTION_VAL_18PX_TR NULL
#define OPTION_VAL_19PX_TR NULL
#define OPTION_VAL_20PX_TR NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_TR "Merkeze Kırpılmış Görüntü"
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_TR "'Yatay Aşırı Tarama Kırp' etkinleştirildiğinde, bu elde edilen kırpılan görüntünün belirtilen piksel sayısı kadar yatay olarak sağa (pozitif) veya sola (negatif) kaydırılmasına izin verir. Hizalama sorunlarını düzeltmek için kullanılabilir. Yalnızca yazılım işleyici tarafından desteklenir."
#define OPTION_VAL_12PX_O55_TR NULL
#define OPTION_VAL_11PX_O55_TR NULL
#define OPTION_VAL_10PX_O55_TR NULL
#define OPTION_VAL_9PX_O55_TR NULL
#define OPTION_VAL_8PX_O55_TR NULL
#define OPTION_VAL_7PX_O55_TR NULL
#define OPTION_VAL_6PX_O55_TR NULL
#define OPTION_VAL_5PX_O55_TR NULL
#define OPTION_VAL_4PX_O55_TR NULL
#define OPTION_VAL_3PX_O55_TR NULL
#define OPTION_VAL_2PX_O55_TR NULL
#define OPTION_VAL_1PX_O55_TR NULL
#define OPTION_VAL_DISABLED_O55_TR "0 (Varsayılan)"
#define OPTION_VAL_1PX_O55_0_TR NULL
#define OPTION_VAL_2PX_O55_0_TR NULL
#define OPTION_VAL_3PX_O55_0_TR NULL
#define OPTION_VAL_4PX_O55_0_TR NULL
#define OPTION_VAL_5PX_O55_0_TR NULL
#define OPTION_VAL_6PX_O55_0_TR NULL
#define OPTION_VAL_7PX_O55_0_TR NULL
#define OPTION_VAL_8PX_O55_0_TR NULL
#define OPTION_VAL_9PX_O55_0_TR NULL
#define OPTION_VAL_10PX_O55_0_TR NULL
#define OPTION_VAL_11PX_O55_0_TR NULL
#define OPTION_VAL_12PX_O55_0_TR NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_TR NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_TR NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_TR NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_TR NULL
#define OPTION_VAL_32X_TR NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_TR "Çekirdek En Boy Oranı"
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_TR "Çekirdek tarafından sağlanan en boy oranını seçin. Geniş Ekran Kipi Geliştirmesi veya Tam VRAM Görüntüle seçenekleri etkinleştirildiğinde bu ayar yok sayılır."
#define OPTION_VAL_CORRECTED_TR "Düzeltilmiş"
#define OPTION_VAL_UNCORRECTED_TR "Düzeltilmemiş"
#define OPTION_VAL_4_3_TR "4:3 İçin Zorla"
#define OPTION_VAL_NTSC_TR "NTSC İçin Zorla"
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_TR NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_TR NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_TR NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_TR NULL
#define OPTION_VAL_239_TR "239 (Varsayılan)"
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_TR NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_TR NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_TR NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_TR NULL
#define OPTION_VAL_287_TR "287 (Varsayılan)"
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_TR NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_TR NULL
#define OPTION_VAL_SYNC_TR "Senkron"
#define OPTION_VAL_ASYNC_TR "Asenkron"
#define OPTION_VAL_PRECACHE_TR NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_TR NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_TR NULL
#define OPTION_VAL_2X_NATIVE_TR "2x (Doğal)"
#define OPTION_VAL_6X_TR NULL
#define OPTION_VAL_10X_TR NULL
#define OPTION_VAL_12X_TR NULL
#define OPTION_VAL_14X_TR NULL

struct retro_core_option_v2_category option_cats_tr[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_TR,
      CATEGORY_VIDEO_INFO_0_TR
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_TR,
      CATEGORY_OSD_INFO_0_TR
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_TR,
      CATEGORY_INPUT_INFO_0_TR
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_TR,
      CATEGORY_MEMCARDS_INFO_0_TR
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_TR,
      CATEGORY_PGXP_INFO_0_TR
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_TR,
      CATEGORY_HACKS_INFO_0_TR
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_tr[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_TR,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_TR,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_TR },
         { "2x",         OPTION_VAL_2X_TR },
         { "4x",         OPTION_VAL_4X_TR },
         { "8x",         OPTION_VAL_8X_TR },
         { "16x",        OPTION_VAL_16X_TR },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_TR,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_TR,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_TR },
         { "32bpp",         OPTION_VAL_32BPP_TR },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_TR,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_TR,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_TR },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_TR },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_TR,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_TR,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_TR,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_TR,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_TR },
         { "SABR",     OPTION_VAL_SABR_TR },
         { "xBR",      OPTION_VAL_XBR_TR },
         { "bilinear", OPTION_VAL_BILINEAR_TR },
         { "3-point",  OPTION_VAL_3_POINT_TR },
         { "JINC2",    OPTION_VAL_JINC2_TR },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_TR,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_TR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_TR },
         { "all", OPTION_VAL_ALL_TR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_TR,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_TR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_TR },
         { "all", OPTION_VAL_ALL_TR },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_TR,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_TR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_TR,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_TR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_TR,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_TR,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_TR },
         { "2x",  OPTION_VAL_2X_TR },
         { "4x",  OPTION_VAL_4X_TR },
         { "8x",  OPTION_VAL_8X_TR },
         { "16x", OPTION_VAL_16X_TR },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_TR,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_TR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_TR,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_TR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_TR,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_TR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_TR,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_TR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_TR,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_TR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_TR,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_TR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_TR,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_TR,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_TR,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_TR,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_TR,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_TR,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_TR,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_TR,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_TR,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_TR,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_TR,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_TR,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_TR,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_TR,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_TR },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_TR },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_TR,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_TR,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_TR },
         { "dot",   OPTION_VAL_DOT_TR },
         { "off",   OPTION_VAL_OFF_TR },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_TR,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_TR,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_TR },
         { "blue", OPTION_VAL_BLUE_TR },
         { "green", OPTION_VAL_GREEN_TR },
         { "orange", OPTION_VAL_ORANGE_TR },
         { "yellow", OPTION_VAL_YELLOW_TR },
         { "cyan", OPTION_VAL_CYAN_TR },
         { "pink", OPTION_VAL_PINK_TR },
         { "purple", OPTION_VAL_PURPLE_TR },
         { "black", OPTION_VAL_BLACK_TR },
         { "white", OPTION_VAL_WHITE_TR },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_TR,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_TR,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_TR },
         { "red", OPTION_VAL_RED_TR },
         { "green", OPTION_VAL_GREEN_TR },
         { "orange", OPTION_VAL_ORANGE_TR },
         { "yellow", OPTION_VAL_YELLOW_TR },
         { "cyan", OPTION_VAL_CYAN_TR },
         { "pink", OPTION_VAL_PINK_TR },
         { "purple", OPTION_VAL_PURPLE_TR },
         { "black", OPTION_VAL_BLACK_TR },
         { "white", OPTION_VAL_WHITE_TR },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_TR,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_TR,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_TR },
         { "10%",  OPTION_VAL_10_TR },
         { "15%",  OPTION_VAL_15_TR },
         { "20%",  OPTION_VAL_20_TR },
         { "25%",  OPTION_VAL_25_TR },
         { "30%",  OPTION_VAL_30_TR },
         { "35%",  OPTION_VAL_35_TR },
         { "40%",  OPTION_VAL_40_TR },
         { "45%",  OPTION_VAL_45_TR },
         { "50%",  OPTION_VAL_50_TR },
         { "55%",  OPTION_VAL_55_TR },
         { "60%",  OPTION_VAL_60_TR },
         { "65%",  OPTION_VAL_65_TR },
         { "70%",  OPTION_VAL_70_TR },
         { "75%",  OPTION_VAL_75_TR },
         { "80%",  OPTION_VAL_80_TR },
         { "85%",  OPTION_VAL_85_TR },
         { "90%",  OPTION_VAL_90_TR },
         { "95%",  OPTION_VAL_95_TR },
         { "100%", OPTION_VAL_100_TR },
         { "105%", OPTION_VAL_105_TR },
         { "110%", OPTION_VAL_110_TR },
         { "115%", OPTION_VAL_115_TR },
         { "120%", OPTION_VAL_120_TR },
         { "125%", OPTION_VAL_125_TR },
         { "130%", OPTION_VAL_130_TR },
         { "135%", OPTION_VAL_135_TR },
         { "140%", OPTION_VAL_140_TR },
         { "145%", OPTION_VAL_145_TR },
         { "150%", OPTION_VAL_150_TR },
         { "155%", OPTION_VAL_155_TR },
         { "160%", OPTION_VAL_160_TR },
         { "165%", OPTION_VAL_165_TR },
         { "170%", OPTION_VAL_170_TR },
         { "175%", OPTION_VAL_175_TR },
         { "180%", OPTION_VAL_180_TR },
         { "185%", OPTION_VAL_185_TR },
         { "190%", OPTION_VAL_190_TR },
         { "195%", OPTION_VAL_195_TR },
         { "200%", OPTION_VAL_200_TR },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_TR,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_TR,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_TR },
         { "quadratic", OPTION_VAL_QUADRATIC_TR },
         { "cubic",     OPTION_VAL_CUBIC_TR },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_TR,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_TR,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_TR },
         { "5%",  OPTION_VAL_5_TR },
         { "10%", OPTION_VAL_10_TR },
         { "15%", OPTION_VAL_15_TR },
         { "20%", OPTION_VAL_20_TR },
         { "25%", OPTION_VAL_25_TR },
         { "30%", OPTION_VAL_30_TR },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_TR,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_TR,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_TR },
         { "mednafen", OPTION_VAL_MEDNAFEN_TR },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_TR,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_TR,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_TR,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_TR,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_TR,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_TR,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_TR,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_TR,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_TR },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_TR,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_TR,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_TR },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_TR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_TR,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_TR,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_TR },
         { "1px", OPTION_VAL_1PX_TR },
         { "2px", OPTION_VAL_2PX_TR },
         { "3px", OPTION_VAL_3PX_TR },
         { "4px", OPTION_VAL_4PX_TR },
         { "5px", OPTION_VAL_5PX_TR },
         { "6px", OPTION_VAL_6PX_TR },
         { "7px", OPTION_VAL_7PX_TR },
         { "8px", OPTION_VAL_8PX_TR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_TR,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_TR,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_TR,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_TR,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_TR,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_TR,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_TR,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_TR,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_TR },
         { "aggressive", OPTION_VAL_AGGRESSIVE_TR },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_TR,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_TR,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_TR,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_TR,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_TR },
         { "16:10", OPTION_VAL_16_10_TR },
         { "18:9",  OPTION_VAL_18_9_TR },
         { "19:9",  OPTION_VAL_19_9_TR },
         { "20:9",  OPTION_VAL_20_9_TR },
         { "21:9",  OPTION_VAL_21_9_TR }, // 64:27
         { "32:9",  OPTION_VAL_32_9_TR },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_TR,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_TR,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_TR },
         { "60%",           OPTION_VAL_60_TR },
         { "70%",           OPTION_VAL_70_TR },
         { "80%",           OPTION_VAL_80_TR },
         { "90%",           OPTION_VAL_90_TR },
         { "100%(native)", OPTION_VAL_100_NATIVE_TR },
         { "110%",          OPTION_VAL_110_TR },
         { "120%",          OPTION_VAL_120_TR },
         { "130%",          OPTION_VAL_130_TR },
         { "140%",          OPTION_VAL_140_TR },
         { "150%",          OPTION_VAL_150_TR },
         { "160%",          OPTION_VAL_160_TR },
         { "170%",          OPTION_VAL_170_TR },
         { "180%",          OPTION_VAL_180_TR },
         { "190%",          OPTION_VAL_190_TR },
         { "200%",          OPTION_VAL_200_TR },
         { "210%",          OPTION_VAL_210_TR },
         { "220%",          OPTION_VAL_220_TR },
         { "230%",          OPTION_VAL_230_TR },
         { "240%",          OPTION_VAL_240_TR },
         { "250%",          OPTION_VAL_250_TR },
         { "260%",          OPTION_VAL_260_TR },
         { "270%",          OPTION_VAL_270_TR },
         { "280%",          OPTION_VAL_280_TR },
         { "290%",          OPTION_VAL_290_TR },
         { "300%",          OPTION_VAL_300_TR },
         { "310%",          OPTION_VAL_310_TR },
         { "320%",          OPTION_VAL_320_TR },
         { "330%",          OPTION_VAL_330_TR },
         { "340%",          OPTION_VAL_340_TR },
         { "350%",          OPTION_VAL_350_TR },
         { "360%",          OPTION_VAL_360_TR },
         { "370%",          OPTION_VAL_370_TR },
         { "380%",          OPTION_VAL_380_TR },
         { "390%",          OPTION_VAL_390_TR },
         { "400%",          OPTION_VAL_400_TR },
         { "410%",          OPTION_VAL_410_TR },
         { "420%",          OPTION_VAL_420_TR },
         { "430%",          OPTION_VAL_430_TR },
         { "440%",          OPTION_VAL_440_TR },
         { "450%",          OPTION_VAL_450_TR },
         { "460%",          OPTION_VAL_460_TR },
         { "470%",          OPTION_VAL_470_TR },
         { "480%",          OPTION_VAL_480_TR },
         { "490%",          OPTION_VAL_490_TR },
         { "500%",          OPTION_VAL_500_TR },
         { "510%",          OPTION_VAL_510_TR },
         { "520%",          OPTION_VAL_520_TR },
         { "530%",          OPTION_VAL_530_TR },
         { "540%",          OPTION_VAL_540_TR },
         { "550%",          OPTION_VAL_550_TR },
         { "560%",          OPTION_VAL_560_TR },
         { "570%",          OPTION_VAL_570_TR },
         { "580%",          OPTION_VAL_580_TR },
         { "590%",          OPTION_VAL_590_TR },
         { "600%",          OPTION_VAL_600_TR },
         { "610%",          OPTION_VAL_610_TR },
         { "620%",          OPTION_VAL_620_TR },
         { "630%",          OPTION_VAL_630_TR },
         { "640%",          OPTION_VAL_640_TR },
         { "650%",          OPTION_VAL_650_TR },
         { "660%",          OPTION_VAL_660_TR },
         { "670%",          OPTION_VAL_670_TR },
         { "680%",          OPTION_VAL_680_TR },
         { "690%",          OPTION_VAL_690_TR },
         { "700%",          OPTION_VAL_700_TR },
         { "710%",          OPTION_VAL_710_TR },
         { "720%",          OPTION_VAL_720_TR },
         { "730%",          OPTION_VAL_730_TR },
         { "740%",          OPTION_VAL_740_TR },
         { "750%",          OPTION_VAL_750_TR },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_TR,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_TR,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_TR,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_TR,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_TR,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_TR,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_TR },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_TR },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_TR,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_TR,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_TR },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_TR },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_TR },
#endif
         { "software",    OPTION_VAL_SOFTWARE_TR },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_TR,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_TR,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_TR,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_TR,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_TR },
         { "execute",  OPTION_VAL_EXECUTE_TR },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_TR },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_TR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_TR,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_TR,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_TR },
         { "dma",  OPTION_VAL_DMA_TR },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_TR,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_TR,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_TR,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_TR,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_TR },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_TR },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_TR },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_TR,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_TR,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_TR,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_TR,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_TR },
         { "static",  OPTION_VAL_STATIC_TR },
         { "smart", OPTION_VAL_SMART_TR },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_TR,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_TR,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_TR },
         { "2px",      OPTION_VAL_2PX_TR },
         { "3px",      OPTION_VAL_3PX_TR },
         { "4px",      OPTION_VAL_4PX_TR },
         { "5px",      OPTION_VAL_5PX_TR },
         { "6px",      OPTION_VAL_6PX_TR },
         { "7px",      OPTION_VAL_7PX_TR },
         { "8px",      OPTION_VAL_8PX_TR },
         { "9px",      OPTION_VAL_9PX_TR },
         { "10px",     OPTION_VAL_10PX_TR },
         { "11px",     OPTION_VAL_11PX_TR },
         { "12px",     OPTION_VAL_12PX_TR },
         { "13px",     OPTION_VAL_13PX_TR },
         { "14px",     OPTION_VAL_14PX_TR },
         { "15px",     OPTION_VAL_15PX_TR },
         { "16px",     OPTION_VAL_16PX_TR },
         { "17px",     OPTION_VAL_17PX_TR },
         { "18px",     OPTION_VAL_18PX_TR },
         { "19px",     OPTION_VAL_19PX_TR },
         { "20px",     OPTION_VAL_20PX_TR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_TR,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_TR,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_TR },
         { "-11px",    OPTION_VAL_11PX_O55_TR },
         { "-10px",    OPTION_VAL_10PX_O55_TR },
         { "-9px",     OPTION_VAL_9PX_O55_TR },
         { "-8px",     OPTION_VAL_8PX_O55_TR },
         { "-7px",     OPTION_VAL_7PX_O55_TR },
         { "-6px",     OPTION_VAL_6PX_O55_TR },
         { "-5px",     OPTION_VAL_5PX_O55_TR },
         { "-4px",     OPTION_VAL_4PX_O55_TR },
         { "-3px",     OPTION_VAL_3PX_O55_TR },
         { "-2px",     OPTION_VAL_2PX_O55_TR },
         { "-1px",     OPTION_VAL_1PX_O55_TR },
         { "disabled", OPTION_VAL_DISABLED_O55_TR },
         { "+1px",     OPTION_VAL_1PX_O55_0_TR },
         { "+2px",     OPTION_VAL_2PX_O55_0_TR },
         { "+3px",     OPTION_VAL_3PX_O55_0_TR },
         { "+4px",     OPTION_VAL_4PX_O55_0_TR },
         { "+5px",     OPTION_VAL_5PX_O55_0_TR },
         { "+6px",     OPTION_VAL_6PX_O55_0_TR },
         { "+7px",     OPTION_VAL_7PX_O55_0_TR },
         { "+8px",     OPTION_VAL_8PX_O55_0_TR },
         { "+9px",     OPTION_VAL_9PX_O55_0_TR },
         { "+10px",    OPTION_VAL_10PX_O55_0_TR },
         { "+11px",    OPTION_VAL_11PX_O55_0_TR },
         { "+12px",    OPTION_VAL_12PX_O55_0_TR },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_TR,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_TR,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_TR },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_TR,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_TR,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_TR },
         { "2x",         OPTION_VAL_2X_TR },
         { "4x",         OPTION_VAL_4X_TR },
         { "8x",         OPTION_VAL_8X_TR },
         { "16x",        OPTION_VAL_16X_TR },
         { "32x",        OPTION_VAL_32X_TR },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_TR,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_TR,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_TR },
         { "uncorrected", OPTION_VAL_UNCORRECTED_TR },
         { "4:3",  OPTION_VAL_4_3_TR },
         { "ntsc", OPTION_VAL_NTSC_TR },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_TR,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_TR,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_TR,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_TR,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_TR },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_TR,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_TR,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_TR,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_TR,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_TR },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_TR,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_TR,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_TR },
         { "async",    OPTION_VAL_ASYNC_TR },
         { "precache", OPTION_VAL_PRECACHE_TR },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_TR,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_TR,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_TR },
         { "4x",          OPTION_VAL_4X_TR },
         { "6x",          OPTION_VAL_6X_TR },
         { "8x",          OPTION_VAL_8X_TR },
         { "10x",         OPTION_VAL_10X_TR },
         { "12x",         OPTION_VAL_12X_TR },
         { "14x",         OPTION_VAL_14X_TR },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_tr = {
   option_cats_tr,
   option_defs_tr
};

/* RETRO_LANGUAGE_UK */

#define CATEGORY_VIDEO_LABEL_UK "Відео"
#define CATEGORY_VIDEO_INFO_0_UK "Налаштування співвідношення сторін / кадрування / відеофільтрів / пропуску кадрів."
#define CATEGORY_OSD_LABEL_UK "Сповіщення на екрані"
#define CATEGORY_OSD_INFO_0_UK "Змінити сповіщення, що показуються на екрані."
#define CATEGORY_INPUT_LABEL_UK "Ввід"
#define CATEGORY_INPUT_INFO_0_UK NULL
#define CATEGORY_MEMCARDS_LABEL_UK "Карта пам'яті"
#define CATEGORY_MEMCARDS_INFO_0_UK NULL
#define CATEGORY_PGXP_LABEL_UK NULL
#define CATEGORY_PGXP_INFO_0_UK "Цей параметр може покращувати графіку в порівнянні з оригінальною консолею. PGXP може виправити викривлення текстур і проблем з Z-fighting."
#define CATEGORY_HACKS_LABEL_UK "Гаки емуляції"
#define CATEGORY_HACKS_INFO_0_UK "Налаштування розгону процесора та точності емуляції, що впливають на низькорівневу продуктивність та сумісність."
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_UK "Роздільна здатність GPU"
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_UK NULL
#define OPTION_VAL_1X_NATIVE_UK "1x (рідна)"
#define OPTION_VAL_2X_UK NULL
#define OPTION_VAL_4X_UK NULL
#define OPTION_VAL_8X_UK NULL
#define OPTION_VAL_16X_UK NULL
#define BEETLE_OPT_DEPTH_LABEL_UK "Внутрішня глибина кольору"
#define BEETLE_OPT_DEPTH_INFO_0_UK NULL
#define OPTION_VAL_16BPP_NATIVE_UK "16 bpp (Рідне)"
#define OPTION_VAL_32BPP_UK NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_UK "Шаблон дизерингу"
#define BEETLE_OPT_DITHER_MODE_INFO_0_UK NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_UK NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_UK NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_UK NULL
#define BEETLE_OPT_FILTER_LABEL_UK NULL
#define BEETLE_OPT_FILTER_INFO_0_UK NULL
#define OPTION_VAL_NEAREST_UK "Найближчі"
#define OPTION_VAL_SABR_UK NULL
#define OPTION_VAL_XBR_UK NULL
#define OPTION_VAL_BILINEAR_UK "Білінійна"
#define OPTION_VAL_3_POINT_UK NULL
#define OPTION_VAL_JINC2_UK NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_UK NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_UK NULL
#define OPTION_VAL_OPAQUE_UK NULL
#define OPTION_VAL_ALL_UK NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_UK NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_UK NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_UK NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_UK NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_UK NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_UK NULL
#define BEETLE_OPT_MSAA_LABEL_UK NULL
#define BEETLE_OPT_MSAA_INFO_0_UK NULL
#define OPTION_VAL_1X_UK NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_UK NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_UK NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_UK NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_UK NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_UK NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_UK NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_UK NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_UK NULL
#define BEETLE_OPT_WIREFRAME_LABEL_UK NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_UK NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_UK NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_UK NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_UK NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_UK NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_UK NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_UK NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_UK NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_UK NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_UK NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_UK NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_UK NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_UK NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_UK NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_UK NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_UK NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_UK NULL
#define OPTION_VAL_LIGHTGUN_UK NULL
#define OPTION_VAL_TOUCHSCREEN_UK NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_UK NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_UK NULL
#define OPTION_VAL_CROSS_UK NULL
#define OPTION_VAL_DOT_UK NULL
#define OPTION_VAL_OFF_UK NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_UK NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_UK NULL
#define OPTION_VAL_RED_UK "Червоний"
#define OPTION_VAL_BLUE_UK "Синій"
#define OPTION_VAL_GREEN_UK "Зелений"
#define OPTION_VAL_ORANGE_UK NULL
#define OPTION_VAL_YELLOW_UK "Жовтий"
#define OPTION_VAL_CYAN_UK NULL
#define OPTION_VAL_PINK_UK NULL
#define OPTION_VAL_PURPLE_UK NULL
#define OPTION_VAL_BLACK_UK NULL
#define OPTION_VAL_WHITE_UK NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_UK NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_UK NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_UK NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_UK NULL
#define OPTION_VAL_5_UK NULL
#define OPTION_VAL_10_UK NULL
#define OPTION_VAL_15_UK NULL
#define OPTION_VAL_20_UK NULL
#define OPTION_VAL_25_UK NULL
#define OPTION_VAL_30_UK NULL
#define OPTION_VAL_35_UK NULL
#define OPTION_VAL_40_UK NULL
#define OPTION_VAL_45_UK NULL
#define OPTION_VAL_50_UK NULL
#define OPTION_VAL_55_UK NULL
#define OPTION_VAL_60_UK NULL
#define OPTION_VAL_65_UK NULL
#define OPTION_VAL_70_UK NULL
#define OPTION_VAL_75_UK NULL
#define OPTION_VAL_80_UK NULL
#define OPTION_VAL_85_UK NULL
#define OPTION_VAL_90_UK NULL
#define OPTION_VAL_95_UK NULL
#define OPTION_VAL_100_UK NULL
#define OPTION_VAL_105_UK NULL
#define OPTION_VAL_110_UK NULL
#define OPTION_VAL_115_UK NULL
#define OPTION_VAL_120_UK NULL
#define OPTION_VAL_125_UK NULL
#define OPTION_VAL_130_UK NULL
#define OPTION_VAL_135_UK NULL
#define OPTION_VAL_140_UK NULL
#define OPTION_VAL_145_UK NULL
#define OPTION_VAL_150_UK NULL
#define OPTION_VAL_155_UK NULL
#define OPTION_VAL_160_UK NULL
#define OPTION_VAL_165_UK NULL
#define OPTION_VAL_170_UK NULL
#define OPTION_VAL_175_UK NULL
#define OPTION_VAL_180_UK NULL
#define OPTION_VAL_185_UK NULL
#define OPTION_VAL_190_UK NULL
#define OPTION_VAL_195_UK NULL
#define OPTION_VAL_200_UK NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_UK NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_UK NULL
#define OPTION_VAL_LINEAR_UK "Лінійна"
#define OPTION_VAL_QUADRATIC_UK NULL
#define OPTION_VAL_CUBIC_UK NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_UK NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_UK NULL
#define OPTION_VAL_0_UK NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_UK NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_UK NULL
#define OPTION_VAL_LIBRETRO_UK NULL
#define OPTION_VAL_MEDNAFEN_UK NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_UK NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_UK NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_UK NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_UK NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_UK NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_UK NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_UK NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_UK NULL
#define OPTION_VAL_1_UK NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_UK NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_UK NULL
#define OPTION_VAL_MEMORY_ONLY_UK NULL
#define OPTION_VAL_MEMORY_CPU_UK NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_UK NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_UK NULL
#define OPTION_VAL_0PX_UK NULL
#define OPTION_VAL_1PX_UK NULL
#define OPTION_VAL_2PX_UK NULL
#define OPTION_VAL_3PX_UK NULL
#define OPTION_VAL_4PX_UK NULL
#define OPTION_VAL_5PX_UK NULL
#define OPTION_VAL_6PX_UK NULL
#define OPTION_VAL_7PX_UK NULL
#define OPTION_VAL_8PX_UK NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_UK NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_UK NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_UK NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_UK NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_UK NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_UK NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_UK NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_UK NULL
#define OPTION_VAL_DEFAULT_UK NULL
#define OPTION_VAL_AGGRESSIVE_UK NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_UK NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_UK NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_UK NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_UK NULL
#define OPTION_VAL_16_9_UK NULL
#define OPTION_VAL_16_10_UK NULL
#define OPTION_VAL_18_9_UK NULL
#define OPTION_VAL_19_9_UK NULL
#define OPTION_VAL_20_9_UK NULL
#define OPTION_VAL_21_9_UK NULL
#define OPTION_VAL_32_9_UK NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_UK NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_UK NULL
#define OPTION_VAL_100_NATIVE_UK NULL
#define OPTION_VAL_210_UK NULL
#define OPTION_VAL_220_UK NULL
#define OPTION_VAL_230_UK NULL
#define OPTION_VAL_240_UK NULL
#define OPTION_VAL_250_UK NULL
#define OPTION_VAL_260_UK NULL
#define OPTION_VAL_270_UK NULL
#define OPTION_VAL_280_UK NULL
#define OPTION_VAL_290_UK NULL
#define OPTION_VAL_300_UK NULL
#define OPTION_VAL_310_UK NULL
#define OPTION_VAL_320_UK NULL
#define OPTION_VAL_330_UK NULL
#define OPTION_VAL_340_UK NULL
#define OPTION_VAL_350_UK NULL
#define OPTION_VAL_360_UK NULL
#define OPTION_VAL_370_UK NULL
#define OPTION_VAL_380_UK NULL
#define OPTION_VAL_390_UK NULL
#define OPTION_VAL_400_UK NULL
#define OPTION_VAL_410_UK NULL
#define OPTION_VAL_420_UK NULL
#define OPTION_VAL_430_UK NULL
#define OPTION_VAL_440_UK NULL
#define OPTION_VAL_450_UK NULL
#define OPTION_VAL_460_UK NULL
#define OPTION_VAL_470_UK NULL
#define OPTION_VAL_480_UK NULL
#define OPTION_VAL_490_UK NULL
#define OPTION_VAL_500_UK NULL
#define OPTION_VAL_510_UK NULL
#define OPTION_VAL_520_UK NULL
#define OPTION_VAL_530_UK NULL
#define OPTION_VAL_540_UK NULL
#define OPTION_VAL_550_UK NULL
#define OPTION_VAL_560_UK NULL
#define OPTION_VAL_570_UK NULL
#define OPTION_VAL_580_UK NULL
#define OPTION_VAL_590_UK NULL
#define OPTION_VAL_600_UK NULL
#define OPTION_VAL_610_UK NULL
#define OPTION_VAL_620_UK NULL
#define OPTION_VAL_630_UK NULL
#define OPTION_VAL_640_UK NULL
#define OPTION_VAL_650_UK NULL
#define OPTION_VAL_660_UK NULL
#define OPTION_VAL_670_UK NULL
#define OPTION_VAL_680_UK NULL
#define OPTION_VAL_690_UK NULL
#define OPTION_VAL_700_UK NULL
#define OPTION_VAL_710_UK NULL
#define OPTION_VAL_720_UK NULL
#define OPTION_VAL_730_UK NULL
#define OPTION_VAL_740_UK NULL
#define OPTION_VAL_750_UK NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_UK NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_UK NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_UK NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_UK NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_UK NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_UK NULL
#define OPTION_VAL_PSXONPSP_UK NULL
#define OPTION_VAL_PS1_ROM_UK NULL
#define BEETLE_OPT_RENDERER_LABEL_UK NULL
#define BEETLE_OPT_RENDERER_INFO_0_UK NULL
#define OPTION_VAL_HARDWARE_UK NULL
#define OPTION_VAL_HARDWARE_GL_UK NULL
#define OPTION_VAL_HARDWARE_VK_UK NULL
#define OPTION_VAL_SOFTWARE_UK NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_UK NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_UK NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_UK NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_UK NULL
#define OPTION_VAL_DISABLED_UK NULL
#define OPTION_VAL_EXECUTE_UK NULL
#define OPTION_VAL_EXECUTE_ONE_UK NULL
#define OPTION_VAL_RUN_INTERPRETER_UK NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_UK NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_UK NULL
#define OPTION_VAL_FULL_UK NULL
#define OPTION_VAL_DMA_UK NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_UK NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_UK NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_UK NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_UK NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_UK NULL
#define OPTION_VAL_FORCE_INTERLACED_UK NULL
#define OPTION_VAL_AUTO_TOGGLE_UK NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_UK NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_UK NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_UK NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_UK NULL
#define OPTION_VAL_DISABLED_O53_UK "Немає"
#define OPTION_VAL_STATIC_UK NULL
#define OPTION_VAL_SMART_UK NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_UK NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_UK NULL
#define OPTION_VAL_9PX_UK NULL
#define OPTION_VAL_10PX_UK NULL
#define OPTION_VAL_11PX_UK NULL
#define OPTION_VAL_12PX_UK NULL
#define OPTION_VAL_13PX_UK NULL
#define OPTION_VAL_14PX_UK NULL
#define OPTION_VAL_15PX_UK NULL
#define OPTION_VAL_16PX_UK NULL
#define OPTION_VAL_17PX_UK NULL
#define OPTION_VAL_18PX_UK NULL
#define OPTION_VAL_19PX_UK NULL
#define OPTION_VAL_20PX_UK NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_UK NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_UK NULL
#define OPTION_VAL_12PX_O55_UK NULL
#define OPTION_VAL_11PX_O55_UK NULL
#define OPTION_VAL_10PX_O55_UK NULL
#define OPTION_VAL_9PX_O55_UK NULL
#define OPTION_VAL_8PX_O55_UK NULL
#define OPTION_VAL_7PX_O55_UK NULL
#define OPTION_VAL_6PX_O55_UK NULL
#define OPTION_VAL_5PX_O55_UK NULL
#define OPTION_VAL_4PX_O55_UK NULL
#define OPTION_VAL_3PX_O55_UK NULL
#define OPTION_VAL_2PX_O55_UK NULL
#define OPTION_VAL_1PX_O55_UK NULL
#define OPTION_VAL_DISABLED_O55_UK NULL
#define OPTION_VAL_1PX_O55_0_UK NULL
#define OPTION_VAL_2PX_O55_0_UK NULL
#define OPTION_VAL_3PX_O55_0_UK NULL
#define OPTION_VAL_4PX_O55_0_UK NULL
#define OPTION_VAL_5PX_O55_0_UK NULL
#define OPTION_VAL_6PX_O55_0_UK NULL
#define OPTION_VAL_7PX_O55_0_UK NULL
#define OPTION_VAL_8PX_O55_0_UK NULL
#define OPTION_VAL_9PX_O55_0_UK NULL
#define OPTION_VAL_10PX_O55_0_UK NULL
#define OPTION_VAL_11PX_O55_0_UK NULL
#define OPTION_VAL_12PX_O55_0_UK NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_UK NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_UK NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_UK NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_UK NULL
#define OPTION_VAL_32X_UK NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_UK NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_UK NULL
#define OPTION_VAL_CORRECTED_UK NULL
#define OPTION_VAL_UNCORRECTED_UK NULL
#define OPTION_VAL_4_3_UK NULL
#define OPTION_VAL_NTSC_UK NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_UK NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_UK NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_UK NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_UK NULL
#define OPTION_VAL_239_UK NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_UK NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_UK NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_UK NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_UK NULL
#define OPTION_VAL_287_UK NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_UK NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_UK NULL
#define OPTION_VAL_SYNC_UK NULL
#define OPTION_VAL_ASYNC_UK NULL
#define OPTION_VAL_PRECACHE_UK NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_UK NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_UK NULL
#define OPTION_VAL_2X_NATIVE_UK NULL
#define OPTION_VAL_6X_UK NULL
#define OPTION_VAL_10X_UK NULL
#define OPTION_VAL_12X_UK NULL
#define OPTION_VAL_14X_UK NULL

struct retro_core_option_v2_category option_cats_uk[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_UK,
      CATEGORY_VIDEO_INFO_0_UK
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_UK,
      CATEGORY_OSD_INFO_0_UK
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_UK,
      CATEGORY_INPUT_INFO_0_UK
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_UK,
      CATEGORY_MEMCARDS_INFO_0_UK
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_UK,
      CATEGORY_PGXP_INFO_0_UK
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_UK,
      CATEGORY_HACKS_INFO_0_UK
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_uk[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_UK,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_UK,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_UK },
         { "2x",         OPTION_VAL_2X_UK },
         { "4x",         OPTION_VAL_4X_UK },
         { "8x",         OPTION_VAL_8X_UK },
         { "16x",        OPTION_VAL_16X_UK },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_UK,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_UK,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_UK },
         { "32bpp",         OPTION_VAL_32BPP_UK },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_UK,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_UK,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_UK },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_UK },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_UK,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_UK,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_UK,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_UK,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_UK },
         { "SABR",     OPTION_VAL_SABR_UK },
         { "xBR",      OPTION_VAL_XBR_UK },
         { "bilinear", OPTION_VAL_BILINEAR_UK },
         { "3-point",  OPTION_VAL_3_POINT_UK },
         { "JINC2",    OPTION_VAL_JINC2_UK },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_UK,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_UK,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_UK },
         { "all", OPTION_VAL_ALL_UK },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_UK,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_UK,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_UK },
         { "all", OPTION_VAL_ALL_UK },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_UK,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_UK,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_UK,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_UK,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_UK,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_UK,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_UK },
         { "2x",  OPTION_VAL_2X_UK },
         { "4x",  OPTION_VAL_4X_UK },
         { "8x",  OPTION_VAL_8X_UK },
         { "16x", OPTION_VAL_16X_UK },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_UK,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_UK,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_UK,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_UK,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_UK,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_UK,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_UK,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_UK,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_UK,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_UK,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_UK,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_UK,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_UK,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_UK,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_UK,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_UK,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_UK,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_UK,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_UK,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_UK,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_UK,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_UK,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_UK,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_UK,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_UK,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_UK,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_UK },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_UK },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_UK,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_UK,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_UK },
         { "dot",   OPTION_VAL_DOT_UK },
         { "off",   OPTION_VAL_OFF_UK },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_UK,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_UK,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_UK },
         { "blue", OPTION_VAL_BLUE_UK },
         { "green", OPTION_VAL_GREEN_UK },
         { "orange", OPTION_VAL_ORANGE_UK },
         { "yellow", OPTION_VAL_YELLOW_UK },
         { "cyan", OPTION_VAL_CYAN_UK },
         { "pink", OPTION_VAL_PINK_UK },
         { "purple", OPTION_VAL_PURPLE_UK },
         { "black", OPTION_VAL_BLACK_UK },
         { "white", OPTION_VAL_WHITE_UK },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_UK,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_UK,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_UK },
         { "red", OPTION_VAL_RED_UK },
         { "green", OPTION_VAL_GREEN_UK },
         { "orange", OPTION_VAL_ORANGE_UK },
         { "yellow", OPTION_VAL_YELLOW_UK },
         { "cyan", OPTION_VAL_CYAN_UK },
         { "pink", OPTION_VAL_PINK_UK },
         { "purple", OPTION_VAL_PURPLE_UK },
         { "black", OPTION_VAL_BLACK_UK },
         { "white", OPTION_VAL_WHITE_UK },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_UK,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_UK,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_UK },
         { "10%",  OPTION_VAL_10_UK },
         { "15%",  OPTION_VAL_15_UK },
         { "20%",  OPTION_VAL_20_UK },
         { "25%",  OPTION_VAL_25_UK },
         { "30%",  OPTION_VAL_30_UK },
         { "35%",  OPTION_VAL_35_UK },
         { "40%",  OPTION_VAL_40_UK },
         { "45%",  OPTION_VAL_45_UK },
         { "50%",  OPTION_VAL_50_UK },
         { "55%",  OPTION_VAL_55_UK },
         { "60%",  OPTION_VAL_60_UK },
         { "65%",  OPTION_VAL_65_UK },
         { "70%",  OPTION_VAL_70_UK },
         { "75%",  OPTION_VAL_75_UK },
         { "80%",  OPTION_VAL_80_UK },
         { "85%",  OPTION_VAL_85_UK },
         { "90%",  OPTION_VAL_90_UK },
         { "95%",  OPTION_VAL_95_UK },
         { "100%", OPTION_VAL_100_UK },
         { "105%", OPTION_VAL_105_UK },
         { "110%", OPTION_VAL_110_UK },
         { "115%", OPTION_VAL_115_UK },
         { "120%", OPTION_VAL_120_UK },
         { "125%", OPTION_VAL_125_UK },
         { "130%", OPTION_VAL_130_UK },
         { "135%", OPTION_VAL_135_UK },
         { "140%", OPTION_VAL_140_UK },
         { "145%", OPTION_VAL_145_UK },
         { "150%", OPTION_VAL_150_UK },
         { "155%", OPTION_VAL_155_UK },
         { "160%", OPTION_VAL_160_UK },
         { "165%", OPTION_VAL_165_UK },
         { "170%", OPTION_VAL_170_UK },
         { "175%", OPTION_VAL_175_UK },
         { "180%", OPTION_VAL_180_UK },
         { "185%", OPTION_VAL_185_UK },
         { "190%", OPTION_VAL_190_UK },
         { "195%", OPTION_VAL_195_UK },
         { "200%", OPTION_VAL_200_UK },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_UK,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_UK,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_UK },
         { "quadratic", OPTION_VAL_QUADRATIC_UK },
         { "cubic",     OPTION_VAL_CUBIC_UK },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_UK,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_UK,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_UK },
         { "5%",  OPTION_VAL_5_UK },
         { "10%", OPTION_VAL_10_UK },
         { "15%", OPTION_VAL_15_UK },
         { "20%", OPTION_VAL_20_UK },
         { "25%", OPTION_VAL_25_UK },
         { "30%", OPTION_VAL_30_UK },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_UK,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_UK,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_UK },
         { "mednafen", OPTION_VAL_MEDNAFEN_UK },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_UK,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_UK,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_UK,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_UK,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_UK,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_UK,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_UK,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_UK,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_UK },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_UK,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_UK,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_UK },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_UK },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_UK,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_UK,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_UK },
         { "1px", OPTION_VAL_1PX_UK },
         { "2px", OPTION_VAL_2PX_UK },
         { "3px", OPTION_VAL_3PX_UK },
         { "4px", OPTION_VAL_4PX_UK },
         { "5px", OPTION_VAL_5PX_UK },
         { "6px", OPTION_VAL_6PX_UK },
         { "7px", OPTION_VAL_7PX_UK },
         { "8px", OPTION_VAL_8PX_UK },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_UK,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_UK,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_UK,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_UK,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_UK,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_UK,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_UK,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_UK,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_UK },
         { "aggressive", OPTION_VAL_AGGRESSIVE_UK },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_UK,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_UK,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_UK,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_UK,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_UK },
         { "16:10", OPTION_VAL_16_10_UK },
         { "18:9",  OPTION_VAL_18_9_UK },
         { "19:9",  OPTION_VAL_19_9_UK },
         { "20:9",  OPTION_VAL_20_9_UK },
         { "21:9",  OPTION_VAL_21_9_UK }, // 64:27
         { "32:9",  OPTION_VAL_32_9_UK },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_UK,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_UK,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_UK },
         { "60%",           OPTION_VAL_60_UK },
         { "70%",           OPTION_VAL_70_UK },
         { "80%",           OPTION_VAL_80_UK },
         { "90%",           OPTION_VAL_90_UK },
         { "100%(native)", OPTION_VAL_100_NATIVE_UK },
         { "110%",          OPTION_VAL_110_UK },
         { "120%",          OPTION_VAL_120_UK },
         { "130%",          OPTION_VAL_130_UK },
         { "140%",          OPTION_VAL_140_UK },
         { "150%",          OPTION_VAL_150_UK },
         { "160%",          OPTION_VAL_160_UK },
         { "170%",          OPTION_VAL_170_UK },
         { "180%",          OPTION_VAL_180_UK },
         { "190%",          OPTION_VAL_190_UK },
         { "200%",          OPTION_VAL_200_UK },
         { "210%",          OPTION_VAL_210_UK },
         { "220%",          OPTION_VAL_220_UK },
         { "230%",          OPTION_VAL_230_UK },
         { "240%",          OPTION_VAL_240_UK },
         { "250%",          OPTION_VAL_250_UK },
         { "260%",          OPTION_VAL_260_UK },
         { "270%",          OPTION_VAL_270_UK },
         { "280%",          OPTION_VAL_280_UK },
         { "290%",          OPTION_VAL_290_UK },
         { "300%",          OPTION_VAL_300_UK },
         { "310%",          OPTION_VAL_310_UK },
         { "320%",          OPTION_VAL_320_UK },
         { "330%",          OPTION_VAL_330_UK },
         { "340%",          OPTION_VAL_340_UK },
         { "350%",          OPTION_VAL_350_UK },
         { "360%",          OPTION_VAL_360_UK },
         { "370%",          OPTION_VAL_370_UK },
         { "380%",          OPTION_VAL_380_UK },
         { "390%",          OPTION_VAL_390_UK },
         { "400%",          OPTION_VAL_400_UK },
         { "410%",          OPTION_VAL_410_UK },
         { "420%",          OPTION_VAL_420_UK },
         { "430%",          OPTION_VAL_430_UK },
         { "440%",          OPTION_VAL_440_UK },
         { "450%",          OPTION_VAL_450_UK },
         { "460%",          OPTION_VAL_460_UK },
         { "470%",          OPTION_VAL_470_UK },
         { "480%",          OPTION_VAL_480_UK },
         { "490%",          OPTION_VAL_490_UK },
         { "500%",          OPTION_VAL_500_UK },
         { "510%",          OPTION_VAL_510_UK },
         { "520%",          OPTION_VAL_520_UK },
         { "530%",          OPTION_VAL_530_UK },
         { "540%",          OPTION_VAL_540_UK },
         { "550%",          OPTION_VAL_550_UK },
         { "560%",          OPTION_VAL_560_UK },
         { "570%",          OPTION_VAL_570_UK },
         { "580%",          OPTION_VAL_580_UK },
         { "590%",          OPTION_VAL_590_UK },
         { "600%",          OPTION_VAL_600_UK },
         { "610%",          OPTION_VAL_610_UK },
         { "620%",          OPTION_VAL_620_UK },
         { "630%",          OPTION_VAL_630_UK },
         { "640%",          OPTION_VAL_640_UK },
         { "650%",          OPTION_VAL_650_UK },
         { "660%",          OPTION_VAL_660_UK },
         { "670%",          OPTION_VAL_670_UK },
         { "680%",          OPTION_VAL_680_UK },
         { "690%",          OPTION_VAL_690_UK },
         { "700%",          OPTION_VAL_700_UK },
         { "710%",          OPTION_VAL_710_UK },
         { "720%",          OPTION_VAL_720_UK },
         { "730%",          OPTION_VAL_730_UK },
         { "740%",          OPTION_VAL_740_UK },
         { "750%",          OPTION_VAL_750_UK },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_UK,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_UK,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_UK,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_UK,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_UK,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_UK,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_UK },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_UK },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_UK,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_UK,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_UK },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_UK },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_UK },
#endif
         { "software",    OPTION_VAL_SOFTWARE_UK },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_UK,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_UK,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_UK,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_UK,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_UK },
         { "execute",  OPTION_VAL_EXECUTE_UK },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_UK },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_UK },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_UK,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_UK,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_UK },
         { "dma",  OPTION_VAL_DMA_UK },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_UK,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_UK,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_UK,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_UK,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_UK },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_UK },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_UK },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_UK,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_UK,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_UK,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_UK,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_UK },
         { "static",  OPTION_VAL_STATIC_UK },
         { "smart", OPTION_VAL_SMART_UK },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_UK,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_UK,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_UK },
         { "2px",      OPTION_VAL_2PX_UK },
         { "3px",      OPTION_VAL_3PX_UK },
         { "4px",      OPTION_VAL_4PX_UK },
         { "5px",      OPTION_VAL_5PX_UK },
         { "6px",      OPTION_VAL_6PX_UK },
         { "7px",      OPTION_VAL_7PX_UK },
         { "8px",      OPTION_VAL_8PX_UK },
         { "9px",      OPTION_VAL_9PX_UK },
         { "10px",     OPTION_VAL_10PX_UK },
         { "11px",     OPTION_VAL_11PX_UK },
         { "12px",     OPTION_VAL_12PX_UK },
         { "13px",     OPTION_VAL_13PX_UK },
         { "14px",     OPTION_VAL_14PX_UK },
         { "15px",     OPTION_VAL_15PX_UK },
         { "16px",     OPTION_VAL_16PX_UK },
         { "17px",     OPTION_VAL_17PX_UK },
         { "18px",     OPTION_VAL_18PX_UK },
         { "19px",     OPTION_VAL_19PX_UK },
         { "20px",     OPTION_VAL_20PX_UK },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_UK,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_UK,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_UK },
         { "-11px",    OPTION_VAL_11PX_O55_UK },
         { "-10px",    OPTION_VAL_10PX_O55_UK },
         { "-9px",     OPTION_VAL_9PX_O55_UK },
         { "-8px",     OPTION_VAL_8PX_O55_UK },
         { "-7px",     OPTION_VAL_7PX_O55_UK },
         { "-6px",     OPTION_VAL_6PX_O55_UK },
         { "-5px",     OPTION_VAL_5PX_O55_UK },
         { "-4px",     OPTION_VAL_4PX_O55_UK },
         { "-3px",     OPTION_VAL_3PX_O55_UK },
         { "-2px",     OPTION_VAL_2PX_O55_UK },
         { "-1px",     OPTION_VAL_1PX_O55_UK },
         { "disabled", OPTION_VAL_DISABLED_O55_UK },
         { "+1px",     OPTION_VAL_1PX_O55_0_UK },
         { "+2px",     OPTION_VAL_2PX_O55_0_UK },
         { "+3px",     OPTION_VAL_3PX_O55_0_UK },
         { "+4px",     OPTION_VAL_4PX_O55_0_UK },
         { "+5px",     OPTION_VAL_5PX_O55_0_UK },
         { "+6px",     OPTION_VAL_6PX_O55_0_UK },
         { "+7px",     OPTION_VAL_7PX_O55_0_UK },
         { "+8px",     OPTION_VAL_8PX_O55_0_UK },
         { "+9px",     OPTION_VAL_9PX_O55_0_UK },
         { "+10px",    OPTION_VAL_10PX_O55_0_UK },
         { "+11px",    OPTION_VAL_11PX_O55_0_UK },
         { "+12px",    OPTION_VAL_12PX_O55_0_UK },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_UK,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_UK,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_UK },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_UK,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_UK,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_UK },
         { "2x",         OPTION_VAL_2X_UK },
         { "4x",         OPTION_VAL_4X_UK },
         { "8x",         OPTION_VAL_8X_UK },
         { "16x",        OPTION_VAL_16X_UK },
         { "32x",        OPTION_VAL_32X_UK },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_UK,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_UK,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_UK },
         { "uncorrected", OPTION_VAL_UNCORRECTED_UK },
         { "4:3",  OPTION_VAL_4_3_UK },
         { "ntsc", OPTION_VAL_NTSC_UK },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_UK,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_UK,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_UK,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_UK,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_UK },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_UK,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_UK,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_UK,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_UK,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_UK },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_UK,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_UK,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_UK },
         { "async",    OPTION_VAL_ASYNC_UK },
         { "precache", OPTION_VAL_PRECACHE_UK },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_UK,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_UK,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_UK },
         { "4x",          OPTION_VAL_4X_UK },
         { "6x",          OPTION_VAL_6X_UK },
         { "8x",          OPTION_VAL_8X_UK },
         { "10x",         OPTION_VAL_10X_UK },
         { "12x",         OPTION_VAL_12X_UK },
         { "14x",         OPTION_VAL_14X_UK },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_uk = {
   option_cats_uk,
   option_defs_uk
};

/* RETRO_LANGUAGE_VAL */

#define CATEGORY_VIDEO_LABEL_VAL "Vídeo"
#define CATEGORY_VIDEO_INFO_0_VAL NULL
#define CATEGORY_OSD_LABEL_VAL NULL
#define CATEGORY_OSD_INFO_0_VAL NULL
#define CATEGORY_INPUT_LABEL_VAL "Entrada"
#define CATEGORY_INPUT_INFO_0_VAL NULL
#define CATEGORY_MEMCARDS_LABEL_VAL NULL
#define CATEGORY_MEMCARDS_INFO_0_VAL NULL
#define CATEGORY_PGXP_LABEL_VAL NULL
#define CATEGORY_PGXP_INFO_0_VAL NULL
#define CATEGORY_HACKS_LABEL_VAL NULL
#define CATEGORY_HACKS_INFO_0_VAL NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_VAL NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_VAL NULL
#define OPTION_VAL_1X_NATIVE_VAL NULL
#define OPTION_VAL_2X_VAL NULL
#define OPTION_VAL_4X_VAL NULL
#define OPTION_VAL_8X_VAL NULL
#define OPTION_VAL_16X_VAL NULL
#define BEETLE_OPT_DEPTH_LABEL_VAL NULL
#define BEETLE_OPT_DEPTH_INFO_0_VAL NULL
#define OPTION_VAL_16BPP_NATIVE_VAL NULL
#define OPTION_VAL_32BPP_VAL NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_VAL NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_VAL NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_VAL NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_VAL NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_VAL NULL
#define BEETLE_OPT_FILTER_LABEL_VAL NULL
#define BEETLE_OPT_FILTER_INFO_0_VAL NULL
#define OPTION_VAL_NEAREST_VAL NULL
#define OPTION_VAL_SABR_VAL NULL
#define OPTION_VAL_XBR_VAL NULL
#define OPTION_VAL_BILINEAR_VAL NULL
#define OPTION_VAL_3_POINT_VAL NULL
#define OPTION_VAL_JINC2_VAL NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_VAL NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_VAL NULL
#define OPTION_VAL_OPAQUE_VAL NULL
#define OPTION_VAL_ALL_VAL NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_VAL NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_VAL NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_VAL NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_VAL NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_VAL NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_VAL NULL
#define BEETLE_OPT_MSAA_LABEL_VAL NULL
#define BEETLE_OPT_MSAA_INFO_0_VAL NULL
#define OPTION_VAL_1X_VAL NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_VAL NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_VAL NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_VAL NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_VAL NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_VAL NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_VAL NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_VAL NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_VAL NULL
#define BEETLE_OPT_WIREFRAME_LABEL_VAL NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_VAL NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_VAL NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_VAL NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_VAL NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_VAL NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_VAL NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_VAL NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_VAL NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_VAL NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_VAL NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_VAL NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_VAL NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_VAL NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_VAL NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_VAL NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_VAL NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_VAL NULL
#define OPTION_VAL_LIGHTGUN_VAL NULL
#define OPTION_VAL_TOUCHSCREEN_VAL NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_VAL NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_VAL NULL
#define OPTION_VAL_CROSS_VAL NULL
#define OPTION_VAL_DOT_VAL NULL
#define OPTION_VAL_OFF_VAL NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_VAL NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_VAL NULL
#define OPTION_VAL_RED_VAL NULL
#define OPTION_VAL_BLUE_VAL NULL
#define OPTION_VAL_GREEN_VAL NULL
#define OPTION_VAL_ORANGE_VAL NULL
#define OPTION_VAL_YELLOW_VAL NULL
#define OPTION_VAL_CYAN_VAL NULL
#define OPTION_VAL_PINK_VAL NULL
#define OPTION_VAL_PURPLE_VAL NULL
#define OPTION_VAL_BLACK_VAL NULL
#define OPTION_VAL_WHITE_VAL NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_VAL NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_VAL NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_VAL NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_VAL NULL
#define OPTION_VAL_5_VAL NULL
#define OPTION_VAL_10_VAL NULL
#define OPTION_VAL_15_VAL NULL
#define OPTION_VAL_20_VAL NULL
#define OPTION_VAL_25_VAL NULL
#define OPTION_VAL_30_VAL NULL
#define OPTION_VAL_35_VAL NULL
#define OPTION_VAL_40_VAL NULL
#define OPTION_VAL_45_VAL NULL
#define OPTION_VAL_50_VAL NULL
#define OPTION_VAL_55_VAL NULL
#define OPTION_VAL_60_VAL NULL
#define OPTION_VAL_65_VAL NULL
#define OPTION_VAL_70_VAL NULL
#define OPTION_VAL_75_VAL NULL
#define OPTION_VAL_80_VAL NULL
#define OPTION_VAL_85_VAL NULL
#define OPTION_VAL_90_VAL NULL
#define OPTION_VAL_95_VAL NULL
#define OPTION_VAL_100_VAL NULL
#define OPTION_VAL_105_VAL NULL
#define OPTION_VAL_110_VAL NULL
#define OPTION_VAL_115_VAL NULL
#define OPTION_VAL_120_VAL NULL
#define OPTION_VAL_125_VAL NULL
#define OPTION_VAL_130_VAL NULL
#define OPTION_VAL_135_VAL NULL
#define OPTION_VAL_140_VAL NULL
#define OPTION_VAL_145_VAL NULL
#define OPTION_VAL_150_VAL NULL
#define OPTION_VAL_155_VAL NULL
#define OPTION_VAL_160_VAL NULL
#define OPTION_VAL_165_VAL NULL
#define OPTION_VAL_170_VAL NULL
#define OPTION_VAL_175_VAL NULL
#define OPTION_VAL_180_VAL NULL
#define OPTION_VAL_185_VAL NULL
#define OPTION_VAL_190_VAL NULL
#define OPTION_VAL_195_VAL NULL
#define OPTION_VAL_200_VAL NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_VAL NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_VAL NULL
#define OPTION_VAL_LINEAR_VAL NULL
#define OPTION_VAL_QUADRATIC_VAL NULL
#define OPTION_VAL_CUBIC_VAL NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_VAL NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_VAL NULL
#define OPTION_VAL_0_VAL NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_VAL NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_VAL NULL
#define OPTION_VAL_LIBRETRO_VAL NULL
#define OPTION_VAL_MEDNAFEN_VAL NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_VAL NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_VAL NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_VAL NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_VAL NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_VAL NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_VAL NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_VAL NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_VAL NULL
#define OPTION_VAL_1_VAL NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_VAL NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_VAL NULL
#define OPTION_VAL_MEMORY_ONLY_VAL NULL
#define OPTION_VAL_MEMORY_CPU_VAL NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_VAL NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_VAL NULL
#define OPTION_VAL_0PX_VAL NULL
#define OPTION_VAL_1PX_VAL NULL
#define OPTION_VAL_2PX_VAL NULL
#define OPTION_VAL_3PX_VAL NULL
#define OPTION_VAL_4PX_VAL NULL
#define OPTION_VAL_5PX_VAL NULL
#define OPTION_VAL_6PX_VAL NULL
#define OPTION_VAL_7PX_VAL NULL
#define OPTION_VAL_8PX_VAL NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_VAL NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_VAL NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_VAL NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_VAL NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_VAL NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_VAL NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_VAL NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_VAL NULL
#define OPTION_VAL_DEFAULT_VAL NULL
#define OPTION_VAL_AGGRESSIVE_VAL NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_VAL NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_VAL NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_VAL NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_VAL NULL
#define OPTION_VAL_16_9_VAL NULL
#define OPTION_VAL_16_10_VAL NULL
#define OPTION_VAL_18_9_VAL NULL
#define OPTION_VAL_19_9_VAL NULL
#define OPTION_VAL_20_9_VAL NULL
#define OPTION_VAL_21_9_VAL NULL
#define OPTION_VAL_32_9_VAL NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_VAL NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_VAL NULL
#define OPTION_VAL_100_NATIVE_VAL NULL
#define OPTION_VAL_210_VAL NULL
#define OPTION_VAL_220_VAL NULL
#define OPTION_VAL_230_VAL NULL
#define OPTION_VAL_240_VAL NULL
#define OPTION_VAL_250_VAL NULL
#define OPTION_VAL_260_VAL NULL
#define OPTION_VAL_270_VAL NULL
#define OPTION_VAL_280_VAL NULL
#define OPTION_VAL_290_VAL NULL
#define OPTION_VAL_300_VAL NULL
#define OPTION_VAL_310_VAL NULL
#define OPTION_VAL_320_VAL NULL
#define OPTION_VAL_330_VAL NULL
#define OPTION_VAL_340_VAL NULL
#define OPTION_VAL_350_VAL NULL
#define OPTION_VAL_360_VAL NULL
#define OPTION_VAL_370_VAL NULL
#define OPTION_VAL_380_VAL NULL
#define OPTION_VAL_390_VAL NULL
#define OPTION_VAL_400_VAL NULL
#define OPTION_VAL_410_VAL NULL
#define OPTION_VAL_420_VAL NULL
#define OPTION_VAL_430_VAL NULL
#define OPTION_VAL_440_VAL NULL
#define OPTION_VAL_450_VAL NULL
#define OPTION_VAL_460_VAL NULL
#define OPTION_VAL_470_VAL NULL
#define OPTION_VAL_480_VAL NULL
#define OPTION_VAL_490_VAL NULL
#define OPTION_VAL_500_VAL NULL
#define OPTION_VAL_510_VAL NULL
#define OPTION_VAL_520_VAL NULL
#define OPTION_VAL_530_VAL NULL
#define OPTION_VAL_540_VAL NULL
#define OPTION_VAL_550_VAL NULL
#define OPTION_VAL_560_VAL NULL
#define OPTION_VAL_570_VAL NULL
#define OPTION_VAL_580_VAL NULL
#define OPTION_VAL_590_VAL NULL
#define OPTION_VAL_600_VAL NULL
#define OPTION_VAL_610_VAL NULL
#define OPTION_VAL_620_VAL NULL
#define OPTION_VAL_630_VAL NULL
#define OPTION_VAL_640_VAL NULL
#define OPTION_VAL_650_VAL NULL
#define OPTION_VAL_660_VAL NULL
#define OPTION_VAL_670_VAL NULL
#define OPTION_VAL_680_VAL NULL
#define OPTION_VAL_690_VAL NULL
#define OPTION_VAL_700_VAL NULL
#define OPTION_VAL_710_VAL NULL
#define OPTION_VAL_720_VAL NULL
#define OPTION_VAL_730_VAL NULL
#define OPTION_VAL_740_VAL NULL
#define OPTION_VAL_750_VAL NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_VAL NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_VAL NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_VAL NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_VAL NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_VAL NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_VAL NULL
#define OPTION_VAL_PSXONPSP_VAL NULL
#define OPTION_VAL_PS1_ROM_VAL NULL
#define BEETLE_OPT_RENDERER_LABEL_VAL NULL
#define BEETLE_OPT_RENDERER_INFO_0_VAL NULL
#define OPTION_VAL_HARDWARE_VAL NULL
#define OPTION_VAL_HARDWARE_GL_VAL NULL
#define OPTION_VAL_HARDWARE_VK_VAL NULL
#define OPTION_VAL_SOFTWARE_VAL NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_VAL NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_VAL NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_VAL NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_VAL NULL
#define OPTION_VAL_DISABLED_VAL NULL
#define OPTION_VAL_EXECUTE_VAL NULL
#define OPTION_VAL_EXECUTE_ONE_VAL NULL
#define OPTION_VAL_RUN_INTERPRETER_VAL NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_VAL NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_VAL NULL
#define OPTION_VAL_FULL_VAL NULL
#define OPTION_VAL_DMA_VAL NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_VAL NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_VAL NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_VAL NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_VAL NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_VAL NULL
#define OPTION_VAL_FORCE_INTERLACED_VAL NULL
#define OPTION_VAL_AUTO_TOGGLE_VAL NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_VAL NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_VAL NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_VAL NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_VAL NULL
#define OPTION_VAL_DISABLED_O53_VAL "Cap"
#define OPTION_VAL_STATIC_VAL NULL
#define OPTION_VAL_SMART_VAL NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_VAL NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_VAL NULL
#define OPTION_VAL_9PX_VAL NULL
#define OPTION_VAL_10PX_VAL NULL
#define OPTION_VAL_11PX_VAL NULL
#define OPTION_VAL_12PX_VAL NULL
#define OPTION_VAL_13PX_VAL NULL
#define OPTION_VAL_14PX_VAL NULL
#define OPTION_VAL_15PX_VAL NULL
#define OPTION_VAL_16PX_VAL NULL
#define OPTION_VAL_17PX_VAL NULL
#define OPTION_VAL_18PX_VAL NULL
#define OPTION_VAL_19PX_VAL NULL
#define OPTION_VAL_20PX_VAL NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_VAL NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_VAL NULL
#define OPTION_VAL_12PX_O55_VAL NULL
#define OPTION_VAL_11PX_O55_VAL NULL
#define OPTION_VAL_10PX_O55_VAL NULL
#define OPTION_VAL_9PX_O55_VAL NULL
#define OPTION_VAL_8PX_O55_VAL NULL
#define OPTION_VAL_7PX_O55_VAL NULL
#define OPTION_VAL_6PX_O55_VAL NULL
#define OPTION_VAL_5PX_O55_VAL NULL
#define OPTION_VAL_4PX_O55_VAL NULL
#define OPTION_VAL_3PX_O55_VAL NULL
#define OPTION_VAL_2PX_O55_VAL NULL
#define OPTION_VAL_1PX_O55_VAL NULL
#define OPTION_VAL_DISABLED_O55_VAL NULL
#define OPTION_VAL_1PX_O55_0_VAL NULL
#define OPTION_VAL_2PX_O55_0_VAL NULL
#define OPTION_VAL_3PX_O55_0_VAL NULL
#define OPTION_VAL_4PX_O55_0_VAL NULL
#define OPTION_VAL_5PX_O55_0_VAL NULL
#define OPTION_VAL_6PX_O55_0_VAL NULL
#define OPTION_VAL_7PX_O55_0_VAL NULL
#define OPTION_VAL_8PX_O55_0_VAL NULL
#define OPTION_VAL_9PX_O55_0_VAL NULL
#define OPTION_VAL_10PX_O55_0_VAL NULL
#define OPTION_VAL_11PX_O55_0_VAL NULL
#define OPTION_VAL_12PX_O55_0_VAL NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_VAL NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_VAL NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_VAL NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_VAL NULL
#define OPTION_VAL_32X_VAL NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_VAL NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_VAL NULL
#define OPTION_VAL_CORRECTED_VAL NULL
#define OPTION_VAL_UNCORRECTED_VAL NULL
#define OPTION_VAL_4_3_VAL NULL
#define OPTION_VAL_NTSC_VAL NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_VAL NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_VAL NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_VAL NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_VAL NULL
#define OPTION_VAL_239_VAL NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_VAL NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_VAL NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_VAL NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_VAL NULL
#define OPTION_VAL_287_VAL NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_VAL NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_VAL NULL
#define OPTION_VAL_SYNC_VAL NULL
#define OPTION_VAL_ASYNC_VAL NULL
#define OPTION_VAL_PRECACHE_VAL NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_VAL NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_VAL NULL
#define OPTION_VAL_2X_NATIVE_VAL NULL
#define OPTION_VAL_6X_VAL NULL
#define OPTION_VAL_10X_VAL NULL
#define OPTION_VAL_12X_VAL NULL
#define OPTION_VAL_14X_VAL NULL

struct retro_core_option_v2_category option_cats_val[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_VAL,
      CATEGORY_VIDEO_INFO_0_VAL
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_VAL,
      CATEGORY_OSD_INFO_0_VAL
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_VAL,
      CATEGORY_INPUT_INFO_0_VAL
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_VAL,
      CATEGORY_MEMCARDS_INFO_0_VAL
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_VAL,
      CATEGORY_PGXP_INFO_0_VAL
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_VAL,
      CATEGORY_HACKS_INFO_0_VAL
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_val[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_VAL,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_VAL,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_VAL },
         { "2x",         OPTION_VAL_2X_VAL },
         { "4x",         OPTION_VAL_4X_VAL },
         { "8x",         OPTION_VAL_8X_VAL },
         { "16x",        OPTION_VAL_16X_VAL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_VAL,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_VAL,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_VAL },
         { "32bpp",         OPTION_VAL_32BPP_VAL },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_VAL,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_VAL,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_VAL },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_VAL },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_VAL,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_VAL,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_VAL,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_VAL,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_VAL },
         { "SABR",     OPTION_VAL_SABR_VAL },
         { "xBR",      OPTION_VAL_XBR_VAL },
         { "bilinear", OPTION_VAL_BILINEAR_VAL },
         { "3-point",  OPTION_VAL_3_POINT_VAL },
         { "JINC2",    OPTION_VAL_JINC2_VAL },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_VAL,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_VAL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_VAL },
         { "all", OPTION_VAL_ALL_VAL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_VAL,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_VAL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_VAL },
         { "all", OPTION_VAL_ALL_VAL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_VAL,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_VAL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_VAL,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_VAL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_VAL,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_VAL,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_VAL },
         { "2x",  OPTION_VAL_2X_VAL },
         { "4x",  OPTION_VAL_4X_VAL },
         { "8x",  OPTION_VAL_8X_VAL },
         { "16x", OPTION_VAL_16X_VAL },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_VAL,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_VAL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_VAL,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_VAL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_VAL,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_VAL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_VAL,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_VAL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_VAL,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_VAL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_VAL,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_VAL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_VAL,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_VAL,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_VAL,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_VAL,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_VAL,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_VAL,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_VAL,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_VAL,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_VAL,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_VAL,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_VAL,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_VAL,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_VAL,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_VAL,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_VAL },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_VAL },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_VAL,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_VAL,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_VAL },
         { "dot",   OPTION_VAL_DOT_VAL },
         { "off",   OPTION_VAL_OFF_VAL },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_VAL,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_VAL,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_VAL },
         { "blue", OPTION_VAL_BLUE_VAL },
         { "green", OPTION_VAL_GREEN_VAL },
         { "orange", OPTION_VAL_ORANGE_VAL },
         { "yellow", OPTION_VAL_YELLOW_VAL },
         { "cyan", OPTION_VAL_CYAN_VAL },
         { "pink", OPTION_VAL_PINK_VAL },
         { "purple", OPTION_VAL_PURPLE_VAL },
         { "black", OPTION_VAL_BLACK_VAL },
         { "white", OPTION_VAL_WHITE_VAL },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_VAL,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_VAL,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_VAL },
         { "red", OPTION_VAL_RED_VAL },
         { "green", OPTION_VAL_GREEN_VAL },
         { "orange", OPTION_VAL_ORANGE_VAL },
         { "yellow", OPTION_VAL_YELLOW_VAL },
         { "cyan", OPTION_VAL_CYAN_VAL },
         { "pink", OPTION_VAL_PINK_VAL },
         { "purple", OPTION_VAL_PURPLE_VAL },
         { "black", OPTION_VAL_BLACK_VAL },
         { "white", OPTION_VAL_WHITE_VAL },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_VAL,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_VAL,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_VAL },
         { "10%",  OPTION_VAL_10_VAL },
         { "15%",  OPTION_VAL_15_VAL },
         { "20%",  OPTION_VAL_20_VAL },
         { "25%",  OPTION_VAL_25_VAL },
         { "30%",  OPTION_VAL_30_VAL },
         { "35%",  OPTION_VAL_35_VAL },
         { "40%",  OPTION_VAL_40_VAL },
         { "45%",  OPTION_VAL_45_VAL },
         { "50%",  OPTION_VAL_50_VAL },
         { "55%",  OPTION_VAL_55_VAL },
         { "60%",  OPTION_VAL_60_VAL },
         { "65%",  OPTION_VAL_65_VAL },
         { "70%",  OPTION_VAL_70_VAL },
         { "75%",  OPTION_VAL_75_VAL },
         { "80%",  OPTION_VAL_80_VAL },
         { "85%",  OPTION_VAL_85_VAL },
         { "90%",  OPTION_VAL_90_VAL },
         { "95%",  OPTION_VAL_95_VAL },
         { "100%", OPTION_VAL_100_VAL },
         { "105%", OPTION_VAL_105_VAL },
         { "110%", OPTION_VAL_110_VAL },
         { "115%", OPTION_VAL_115_VAL },
         { "120%", OPTION_VAL_120_VAL },
         { "125%", OPTION_VAL_125_VAL },
         { "130%", OPTION_VAL_130_VAL },
         { "135%", OPTION_VAL_135_VAL },
         { "140%", OPTION_VAL_140_VAL },
         { "145%", OPTION_VAL_145_VAL },
         { "150%", OPTION_VAL_150_VAL },
         { "155%", OPTION_VAL_155_VAL },
         { "160%", OPTION_VAL_160_VAL },
         { "165%", OPTION_VAL_165_VAL },
         { "170%", OPTION_VAL_170_VAL },
         { "175%", OPTION_VAL_175_VAL },
         { "180%", OPTION_VAL_180_VAL },
         { "185%", OPTION_VAL_185_VAL },
         { "190%", OPTION_VAL_190_VAL },
         { "195%", OPTION_VAL_195_VAL },
         { "200%", OPTION_VAL_200_VAL },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_VAL,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_VAL,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_VAL },
         { "quadratic", OPTION_VAL_QUADRATIC_VAL },
         { "cubic",     OPTION_VAL_CUBIC_VAL },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_VAL,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_VAL,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_VAL },
         { "5%",  OPTION_VAL_5_VAL },
         { "10%", OPTION_VAL_10_VAL },
         { "15%", OPTION_VAL_15_VAL },
         { "20%", OPTION_VAL_20_VAL },
         { "25%", OPTION_VAL_25_VAL },
         { "30%", OPTION_VAL_30_VAL },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_VAL,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_VAL,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_VAL },
         { "mednafen", OPTION_VAL_MEDNAFEN_VAL },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_VAL,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_VAL,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_VAL,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_VAL,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_VAL,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_VAL,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_VAL,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_VAL,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_VAL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_VAL,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_VAL,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_VAL },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_VAL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_VAL,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_VAL,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_VAL },
         { "1px", OPTION_VAL_1PX_VAL },
         { "2px", OPTION_VAL_2PX_VAL },
         { "3px", OPTION_VAL_3PX_VAL },
         { "4px", OPTION_VAL_4PX_VAL },
         { "5px", OPTION_VAL_5PX_VAL },
         { "6px", OPTION_VAL_6PX_VAL },
         { "7px", OPTION_VAL_7PX_VAL },
         { "8px", OPTION_VAL_8PX_VAL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_VAL,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_VAL,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_VAL,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_VAL,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_VAL,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_VAL,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_VAL,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_VAL,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_VAL },
         { "aggressive", OPTION_VAL_AGGRESSIVE_VAL },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_VAL,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_VAL,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_VAL,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_VAL,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_VAL },
         { "16:10", OPTION_VAL_16_10_VAL },
         { "18:9",  OPTION_VAL_18_9_VAL },
         { "19:9",  OPTION_VAL_19_9_VAL },
         { "20:9",  OPTION_VAL_20_9_VAL },
         { "21:9",  OPTION_VAL_21_9_VAL }, // 64:27
         { "32:9",  OPTION_VAL_32_9_VAL },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_VAL,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_VAL,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_VAL },
         { "60%",           OPTION_VAL_60_VAL },
         { "70%",           OPTION_VAL_70_VAL },
         { "80%",           OPTION_VAL_80_VAL },
         { "90%",           OPTION_VAL_90_VAL },
         { "100%(native)", OPTION_VAL_100_NATIVE_VAL },
         { "110%",          OPTION_VAL_110_VAL },
         { "120%",          OPTION_VAL_120_VAL },
         { "130%",          OPTION_VAL_130_VAL },
         { "140%",          OPTION_VAL_140_VAL },
         { "150%",          OPTION_VAL_150_VAL },
         { "160%",          OPTION_VAL_160_VAL },
         { "170%",          OPTION_VAL_170_VAL },
         { "180%",          OPTION_VAL_180_VAL },
         { "190%",          OPTION_VAL_190_VAL },
         { "200%",          OPTION_VAL_200_VAL },
         { "210%",          OPTION_VAL_210_VAL },
         { "220%",          OPTION_VAL_220_VAL },
         { "230%",          OPTION_VAL_230_VAL },
         { "240%",          OPTION_VAL_240_VAL },
         { "250%",          OPTION_VAL_250_VAL },
         { "260%",          OPTION_VAL_260_VAL },
         { "270%",          OPTION_VAL_270_VAL },
         { "280%",          OPTION_VAL_280_VAL },
         { "290%",          OPTION_VAL_290_VAL },
         { "300%",          OPTION_VAL_300_VAL },
         { "310%",          OPTION_VAL_310_VAL },
         { "320%",          OPTION_VAL_320_VAL },
         { "330%",          OPTION_VAL_330_VAL },
         { "340%",          OPTION_VAL_340_VAL },
         { "350%",          OPTION_VAL_350_VAL },
         { "360%",          OPTION_VAL_360_VAL },
         { "370%",          OPTION_VAL_370_VAL },
         { "380%",          OPTION_VAL_380_VAL },
         { "390%",          OPTION_VAL_390_VAL },
         { "400%",          OPTION_VAL_400_VAL },
         { "410%",          OPTION_VAL_410_VAL },
         { "420%",          OPTION_VAL_420_VAL },
         { "430%",          OPTION_VAL_430_VAL },
         { "440%",          OPTION_VAL_440_VAL },
         { "450%",          OPTION_VAL_450_VAL },
         { "460%",          OPTION_VAL_460_VAL },
         { "470%",          OPTION_VAL_470_VAL },
         { "480%",          OPTION_VAL_480_VAL },
         { "490%",          OPTION_VAL_490_VAL },
         { "500%",          OPTION_VAL_500_VAL },
         { "510%",          OPTION_VAL_510_VAL },
         { "520%",          OPTION_VAL_520_VAL },
         { "530%",          OPTION_VAL_530_VAL },
         { "540%",          OPTION_VAL_540_VAL },
         { "550%",          OPTION_VAL_550_VAL },
         { "560%",          OPTION_VAL_560_VAL },
         { "570%",          OPTION_VAL_570_VAL },
         { "580%",          OPTION_VAL_580_VAL },
         { "590%",          OPTION_VAL_590_VAL },
         { "600%",          OPTION_VAL_600_VAL },
         { "610%",          OPTION_VAL_610_VAL },
         { "620%",          OPTION_VAL_620_VAL },
         { "630%",          OPTION_VAL_630_VAL },
         { "640%",          OPTION_VAL_640_VAL },
         { "650%",          OPTION_VAL_650_VAL },
         { "660%",          OPTION_VAL_660_VAL },
         { "670%",          OPTION_VAL_670_VAL },
         { "680%",          OPTION_VAL_680_VAL },
         { "690%",          OPTION_VAL_690_VAL },
         { "700%",          OPTION_VAL_700_VAL },
         { "710%",          OPTION_VAL_710_VAL },
         { "720%",          OPTION_VAL_720_VAL },
         { "730%",          OPTION_VAL_730_VAL },
         { "740%",          OPTION_VAL_740_VAL },
         { "750%",          OPTION_VAL_750_VAL },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_VAL,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_VAL,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_VAL,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_VAL,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_VAL,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_VAL,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_VAL },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_VAL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_VAL,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_VAL },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_VAL },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_VAL },
#endif
         { "software",    OPTION_VAL_SOFTWARE_VAL },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_VAL,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_VAL,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_VAL,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_VAL },
         { "execute",  OPTION_VAL_EXECUTE_VAL },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_VAL },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_VAL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_VAL,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_VAL },
         { "dma",  OPTION_VAL_DMA_VAL },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_VAL,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_VAL,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_VAL },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_VAL },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_VAL },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_VAL,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_VAL,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_VAL,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_VAL,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_VAL },
         { "static",  OPTION_VAL_STATIC_VAL },
         { "smart", OPTION_VAL_SMART_VAL },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_VAL,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_VAL,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_VAL },
         { "2px",      OPTION_VAL_2PX_VAL },
         { "3px",      OPTION_VAL_3PX_VAL },
         { "4px",      OPTION_VAL_4PX_VAL },
         { "5px",      OPTION_VAL_5PX_VAL },
         { "6px",      OPTION_VAL_6PX_VAL },
         { "7px",      OPTION_VAL_7PX_VAL },
         { "8px",      OPTION_VAL_8PX_VAL },
         { "9px",      OPTION_VAL_9PX_VAL },
         { "10px",     OPTION_VAL_10PX_VAL },
         { "11px",     OPTION_VAL_11PX_VAL },
         { "12px",     OPTION_VAL_12PX_VAL },
         { "13px",     OPTION_VAL_13PX_VAL },
         { "14px",     OPTION_VAL_14PX_VAL },
         { "15px",     OPTION_VAL_15PX_VAL },
         { "16px",     OPTION_VAL_16PX_VAL },
         { "17px",     OPTION_VAL_17PX_VAL },
         { "18px",     OPTION_VAL_18PX_VAL },
         { "19px",     OPTION_VAL_19PX_VAL },
         { "20px",     OPTION_VAL_20PX_VAL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_VAL,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_VAL,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_VAL },
         { "-11px",    OPTION_VAL_11PX_O55_VAL },
         { "-10px",    OPTION_VAL_10PX_O55_VAL },
         { "-9px",     OPTION_VAL_9PX_O55_VAL },
         { "-8px",     OPTION_VAL_8PX_O55_VAL },
         { "-7px",     OPTION_VAL_7PX_O55_VAL },
         { "-6px",     OPTION_VAL_6PX_O55_VAL },
         { "-5px",     OPTION_VAL_5PX_O55_VAL },
         { "-4px",     OPTION_VAL_4PX_O55_VAL },
         { "-3px",     OPTION_VAL_3PX_O55_VAL },
         { "-2px",     OPTION_VAL_2PX_O55_VAL },
         { "-1px",     OPTION_VAL_1PX_O55_VAL },
         { "disabled", OPTION_VAL_DISABLED_O55_VAL },
         { "+1px",     OPTION_VAL_1PX_O55_0_VAL },
         { "+2px",     OPTION_VAL_2PX_O55_0_VAL },
         { "+3px",     OPTION_VAL_3PX_O55_0_VAL },
         { "+4px",     OPTION_VAL_4PX_O55_0_VAL },
         { "+5px",     OPTION_VAL_5PX_O55_0_VAL },
         { "+6px",     OPTION_VAL_6PX_O55_0_VAL },
         { "+7px",     OPTION_VAL_7PX_O55_0_VAL },
         { "+8px",     OPTION_VAL_8PX_O55_0_VAL },
         { "+9px",     OPTION_VAL_9PX_O55_0_VAL },
         { "+10px",    OPTION_VAL_10PX_O55_0_VAL },
         { "+11px",    OPTION_VAL_11PX_O55_0_VAL },
         { "+12px",    OPTION_VAL_12PX_O55_0_VAL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_VAL,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_VAL,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_VAL },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_VAL,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_VAL,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_VAL },
         { "2x",         OPTION_VAL_2X_VAL },
         { "4x",         OPTION_VAL_4X_VAL },
         { "8x",         OPTION_VAL_8X_VAL },
         { "16x",        OPTION_VAL_16X_VAL },
         { "32x",        OPTION_VAL_32X_VAL },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_VAL,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_VAL,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_VAL },
         { "uncorrected", OPTION_VAL_UNCORRECTED_VAL },
         { "4:3",  OPTION_VAL_4_3_VAL },
         { "ntsc", OPTION_VAL_NTSC_VAL },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_VAL,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_VAL,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_VAL,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_VAL,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_VAL },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_VAL,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_VAL,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_VAL,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_VAL,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_VAL },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_VAL,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_VAL },
         { "async",    OPTION_VAL_ASYNC_VAL },
         { "precache", OPTION_VAL_PRECACHE_VAL },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_VAL,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_VAL },
         { "4x",          OPTION_VAL_4X_VAL },
         { "6x",          OPTION_VAL_6X_VAL },
         { "8x",          OPTION_VAL_8X_VAL },
         { "10x",         OPTION_VAL_10X_VAL },
         { "12x",         OPTION_VAL_12X_VAL },
         { "14x",         OPTION_VAL_14X_VAL },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_val = {
   option_cats_val,
   option_defs_val
};

/* RETRO_LANGUAGE_VN */

#define CATEGORY_VIDEO_LABEL_VN "Hình ảnh"
#define CATEGORY_VIDEO_INFO_0_VN NULL
#define CATEGORY_OSD_LABEL_VN "Enable Onscreen Notifications"
#define CATEGORY_OSD_INFO_0_VN NULL
#define CATEGORY_INPUT_LABEL_VN "Input Driver"
#define CATEGORY_INPUT_INFO_0_VN NULL
#define CATEGORY_MEMCARDS_LABEL_VN NULL
#define CATEGORY_MEMCARDS_INFO_0_VN NULL
#define CATEGORY_PGXP_LABEL_VN NULL
#define CATEGORY_PGXP_INFO_0_VN NULL
#define CATEGORY_HACKS_LABEL_VN NULL
#define CATEGORY_HACKS_INFO_0_VN NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_VN NULL
#define BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_VN NULL
#define OPTION_VAL_1X_NATIVE_VN NULL
#define OPTION_VAL_2X_VN NULL
#define OPTION_VAL_4X_VN NULL
#define OPTION_VAL_8X_VN NULL
#define OPTION_VAL_16X_VN NULL
#define BEETLE_OPT_DEPTH_LABEL_VN NULL
#define BEETLE_OPT_DEPTH_INFO_0_VN NULL
#define OPTION_VAL_16BPP_NATIVE_VN NULL
#define OPTION_VAL_32BPP_VN NULL
#define BEETLE_OPT_DITHER_MODE_LABEL_VN NULL
#define BEETLE_OPT_DITHER_MODE_INFO_0_VN NULL
#define OPTION_VAL_INTERNAL_RESOLUTION_VN NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_LABEL_VN NULL
#define BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_VN NULL
#define BEETLE_OPT_FILTER_LABEL_VN NULL
#define BEETLE_OPT_FILTER_INFO_0_VN NULL
#define OPTION_VAL_NEAREST_VN NULL
#define OPTION_VAL_SABR_VN NULL
#define OPTION_VAL_XBR_VN NULL
#define OPTION_VAL_BILINEAR_VN NULL
#define OPTION_VAL_3_POINT_VN NULL
#define OPTION_VAL_JINC2_VN NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_VN NULL
#define BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_VN NULL
#define OPTION_VAL_OPAQUE_VN NULL
#define OPTION_VAL_ALL_VN NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_VN NULL
#define BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_VN NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_VN NULL
#define BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_VN NULL
#define BEETLE_OPT_SUPER_SAMPLING_LABEL_VN NULL
#define BEETLE_OPT_SUPER_SAMPLING_INFO_0_VN NULL
#define BEETLE_OPT_MSAA_LABEL_VN NULL
#define BEETLE_OPT_MSAA_INFO_0_VN NULL
#define OPTION_VAL_1X_VN NULL
#define BEETLE_OPT_MDEC_YUV_LABEL_VN NULL
#define BEETLE_OPT_MDEC_YUV_INFO_0_VN NULL
#define BEETLE_OPT_TRACK_TEXTURES_LABEL_VN NULL
#define BEETLE_OPT_TRACK_TEXTURES_INFO_0_VN NULL
#define BEETLE_OPT_DUMP_TEXTURES_LABEL_VN NULL
#define BEETLE_OPT_DUMP_TEXTURES_INFO_0_VN NULL
#define BEETLE_OPT_REPLACE_TEXTURES_LABEL_VN NULL
#define BEETLE_OPT_REPLACE_TEXTURES_INFO_0_VN NULL
#define BEETLE_OPT_WIREFRAME_LABEL_VN NULL
#define BEETLE_OPT_WIREFRAME_INFO_0_VN NULL
#define BEETLE_OPT_FRAME_DUPING_LABEL_VN NULL
#define BEETLE_OPT_FRAME_DUPING_INFO_0_VN NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_VN NULL
#define BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_VN NULL
#define BEETLE_OPT_DISPLAY_VRAM_LABEL_VN NULL
#define BEETLE_OPT_DISPLAY_VRAM_INFO_0_VN NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_LABEL_VN NULL
#define BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_VN NULL
#define BEETLE_OPT_ANALOG_TOGGLE_LABEL_VN NULL
#define BEETLE_OPT_ANALOG_TOGGLE_INFO_0_VN NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_VN NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_VN NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_VN NULL
#define BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_VN NULL
#define BEETLE_OPT_GUN_INPUT_MODE_LABEL_VN NULL
#define BEETLE_OPT_GUN_INPUT_MODE_INFO_0_VN NULL
#define OPTION_VAL_LIGHTGUN_VN NULL
#define OPTION_VAL_TOUCHSCREEN_VN NULL
#define BEETLE_OPT_GUN_CURSOR_LABEL_VN NULL
#define BEETLE_OPT_GUN_CURSOR_INFO_0_VN NULL
#define OPTION_VAL_CROSS_VN NULL
#define OPTION_VAL_DOT_VN NULL
#define OPTION_VAL_OFF_VN NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_VN NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_VN NULL
#define OPTION_VAL_RED_VN NULL
#define OPTION_VAL_BLUE_VN NULL
#define OPTION_VAL_GREEN_VN NULL
#define OPTION_VAL_ORANGE_VN NULL
#define OPTION_VAL_YELLOW_VN NULL
#define OPTION_VAL_CYAN_VN NULL
#define OPTION_VAL_PINK_VN NULL
#define OPTION_VAL_PURPLE_VN NULL
#define OPTION_VAL_BLACK_VN NULL
#define OPTION_VAL_WHITE_VN NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_VN NULL
#define BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_VN NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_VN NULL
#define BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_VN NULL
#define OPTION_VAL_5_VN NULL
#define OPTION_VAL_10_VN NULL
#define OPTION_VAL_15_VN NULL
#define OPTION_VAL_20_VN NULL
#define OPTION_VAL_25_VN NULL
#define OPTION_VAL_30_VN NULL
#define OPTION_VAL_35_VN NULL
#define OPTION_VAL_40_VN NULL
#define OPTION_VAL_45_VN NULL
#define OPTION_VAL_50_VN NULL
#define OPTION_VAL_55_VN NULL
#define OPTION_VAL_60_VN NULL
#define OPTION_VAL_65_VN NULL
#define OPTION_VAL_70_VN NULL
#define OPTION_VAL_75_VN NULL
#define OPTION_VAL_80_VN NULL
#define OPTION_VAL_85_VN NULL
#define OPTION_VAL_90_VN NULL
#define OPTION_VAL_95_VN NULL
#define OPTION_VAL_100_VN NULL
#define OPTION_VAL_105_VN NULL
#define OPTION_VAL_110_VN NULL
#define OPTION_VAL_115_VN NULL
#define OPTION_VAL_120_VN NULL
#define OPTION_VAL_125_VN NULL
#define OPTION_VAL_130_VN NULL
#define OPTION_VAL_135_VN NULL
#define OPTION_VAL_140_VN NULL
#define OPTION_VAL_145_VN NULL
#define OPTION_VAL_150_VN NULL
#define OPTION_VAL_155_VN NULL
#define OPTION_VAL_160_VN NULL
#define OPTION_VAL_165_VN NULL
#define OPTION_VAL_170_VN NULL
#define OPTION_VAL_175_VN NULL
#define OPTION_VAL_180_VN NULL
#define OPTION_VAL_185_VN NULL
#define OPTION_VAL_190_VN NULL
#define OPTION_VAL_195_VN NULL
#define OPTION_VAL_200_VN NULL
#define BEETLE_OPT_NEGCON_RESPONSE_LABEL_VN NULL
#define BEETLE_OPT_NEGCON_RESPONSE_INFO_0_VN NULL
#define OPTION_VAL_LINEAR_VN NULL
#define OPTION_VAL_QUADRATIC_VN NULL
#define OPTION_VAL_CUBIC_VN NULL
#define BEETLE_OPT_NEGCON_DEADZONE_LABEL_VN NULL
#define BEETLE_OPT_NEGCON_DEADZONE_INFO_0_VN NULL
#define OPTION_VAL_0_VN NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_VN NULL
#define BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_VN NULL
#define OPTION_VAL_LIBRETRO_VN NULL
#define OPTION_VAL_MEDNAFEN_VN NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_LABEL_VN NULL
#define BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_VN NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_VN NULL
#define BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_VN NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_VN NULL
#define BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_VN NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_VN NULL
#define BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_VN NULL
#define OPTION_VAL_1_VN NULL
#define BEETLE_OPT_PGXP_MODE_LABEL_VN NULL
#define BEETLE_OPT_PGXP_MODE_INFO_0_VN NULL
#define OPTION_VAL_MEMORY_ONLY_VN NULL
#define OPTION_VAL_MEMORY_CPU_VN NULL
#define BEETLE_OPT_PGXP_2D_TOL_LABEL_VN NULL
#define BEETLE_OPT_PGXP_2D_TOL_INFO_0_VN NULL
#define OPTION_VAL_0PX_VN NULL
#define OPTION_VAL_1PX_VN NULL
#define OPTION_VAL_2PX_VN NULL
#define OPTION_VAL_3PX_VN NULL
#define OPTION_VAL_4PX_VN NULL
#define OPTION_VAL_5PX_VN NULL
#define OPTION_VAL_6PX_VN NULL
#define OPTION_VAL_7PX_VN NULL
#define OPTION_VAL_8PX_VN NULL
#define BEETLE_OPT_PGXP_NCLIP_LABEL_VN NULL
#define BEETLE_OPT_PGXP_NCLIP_INFO_0_VN NULL
#define BEETLE_OPT_PGXP_VERTEX_LABEL_VN NULL
#define BEETLE_OPT_PGXP_VERTEX_INFO_0_VN NULL
#define BEETLE_OPT_PGXP_TEXTURE_LABEL_VN NULL
#define BEETLE_OPT_PGXP_TEXTURE_INFO_0_VN NULL
#define BEETLE_OPT_LINE_RENDER_LABEL_VN NULL
#define BEETLE_OPT_LINE_RENDER_INFO_0_VN NULL
#define OPTION_VAL_DEFAULT_VN NULL
#define OPTION_VAL_AGGRESSIVE_VN NULL
#define BEETLE_OPT_WIDESCREEN_HACK_LABEL_VN NULL
#define BEETLE_OPT_WIDESCREEN_HACK_INFO_0_VN NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_VN NULL
#define BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_VN NULL
#define OPTION_VAL_16_9_VN NULL
#define OPTION_VAL_16_10_VN NULL
#define OPTION_VAL_18_9_VN NULL
#define OPTION_VAL_19_9_VN NULL
#define OPTION_VAL_20_9_VN NULL
#define OPTION_VAL_21_9_VN NULL
#define OPTION_VAL_32_9_VN NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_LABEL_VN NULL
#define BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_VN NULL
#define OPTION_VAL_100_NATIVE_VN NULL
#define OPTION_VAL_210_VN NULL
#define OPTION_VAL_220_VN NULL
#define OPTION_VAL_230_VN NULL
#define OPTION_VAL_240_VN NULL
#define OPTION_VAL_250_VN NULL
#define OPTION_VAL_260_VN NULL
#define OPTION_VAL_270_VN NULL
#define OPTION_VAL_280_VN NULL
#define OPTION_VAL_290_VN NULL
#define OPTION_VAL_300_VN NULL
#define OPTION_VAL_310_VN NULL
#define OPTION_VAL_320_VN NULL
#define OPTION_VAL_330_VN NULL
#define OPTION_VAL_340_VN NULL
#define OPTION_VAL_350_VN NULL
#define OPTION_VAL_360_VN NULL
#define OPTION_VAL_370_VN NULL
#define OPTION_VAL_380_VN NULL
#define OPTION_VAL_390_VN NULL
#define OPTION_VAL_400_VN NULL
#define OPTION_VAL_410_VN NULL
#define OPTION_VAL_420_VN NULL
#define OPTION_VAL_430_VN NULL
#define OPTION_VAL_440_VN NULL
#define OPTION_VAL_450_VN NULL
#define OPTION_VAL_460_VN NULL
#define OPTION_VAL_470_VN NULL
#define OPTION_VAL_480_VN NULL
#define OPTION_VAL_490_VN NULL
#define OPTION_VAL_500_VN NULL
#define OPTION_VAL_510_VN NULL
#define OPTION_VAL_520_VN NULL
#define OPTION_VAL_530_VN NULL
#define OPTION_VAL_540_VN NULL
#define OPTION_VAL_550_VN NULL
#define OPTION_VAL_560_VN NULL
#define OPTION_VAL_570_VN NULL
#define OPTION_VAL_580_VN NULL
#define OPTION_VAL_590_VN NULL
#define OPTION_VAL_600_VN NULL
#define OPTION_VAL_610_VN NULL
#define OPTION_VAL_620_VN NULL
#define OPTION_VAL_630_VN NULL
#define OPTION_VAL_640_VN NULL
#define OPTION_VAL_650_VN NULL
#define OPTION_VAL_660_VN NULL
#define OPTION_VAL_670_VN NULL
#define OPTION_VAL_680_VN NULL
#define OPTION_VAL_690_VN NULL
#define OPTION_VAL_700_VN NULL
#define OPTION_VAL_710_VN NULL
#define OPTION_VAL_720_VN NULL
#define OPTION_VAL_730_VN NULL
#define OPTION_VAL_740_VN NULL
#define OPTION_VAL_750_VN NULL
#define BEETLE_OPT_GTE_OVERCLOCK_LABEL_VN NULL
#define BEETLE_OPT_GTE_OVERCLOCK_INFO_0_VN NULL
#define BEETLE_OPT_SKIP_BIOS_LABEL_VN NULL
#define BEETLE_OPT_SKIP_BIOS_INFO_0_VN NULL
#define BEETLE_OPT_OVERRIDE_BIOS_LABEL_VN NULL
#define BEETLE_OPT_OVERRIDE_BIOS_INFO_0_VN NULL
#define OPTION_VAL_PSXONPSP_VN NULL
#define OPTION_VAL_PS1_ROM_VN NULL
#define BEETLE_OPT_RENDERER_LABEL_VN NULL
#define BEETLE_OPT_RENDERER_INFO_0_VN NULL
#define OPTION_VAL_HARDWARE_VN NULL
#define OPTION_VAL_HARDWARE_GL_VN NULL
#define OPTION_VAL_HARDWARE_VK_VN NULL
#define OPTION_VAL_SOFTWARE_VN NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_VN NULL
#define BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_VN NULL
#define BEETLE_OPT_CPU_DYNAREC_LABEL_VN NULL
#define BEETLE_OPT_CPU_DYNAREC_INFO_0_VN NULL
#define OPTION_VAL_DISABLED_VN NULL
#define OPTION_VAL_EXECUTE_VN NULL
#define OPTION_VAL_EXECUTE_ONE_VN NULL
#define OPTION_VAL_RUN_INTERPRETER_VN NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_VN NULL
#define BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_VN NULL
#define OPTION_VAL_FULL_VN NULL
#define OPTION_VAL_DMA_VN NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_VN NULL
#define BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_VN NULL
#define BEETLE_OPT_CORE_TIMING_FPS_LABEL_VN NULL
#define BEETLE_OPT_CORE_TIMING_FPS_INFO_0_VN NULL
#define OPTION_VAL_FORCE_PROGRESSIVE_VN NULL
#define OPTION_VAL_FORCE_INTERLACED_VN NULL
#define OPTION_VAL_AUTO_TOGGLE_VN NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_VN NULL
#define BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_VN NULL
#define BEETLE_OPT_CROP_OVERSCAN_LABEL_VN NULL
#define BEETLE_OPT_CROP_OVERSCAN_INFO_0_VN NULL
#define OPTION_VAL_DISABLED_O53_VN NULL
#define OPTION_VAL_STATIC_VN NULL
#define OPTION_VAL_SMART_VN NULL
#define BEETLE_OPT_IMAGE_CROP_LABEL_VN NULL
#define BEETLE_OPT_IMAGE_CROP_INFO_0_VN NULL
#define OPTION_VAL_9PX_VN NULL
#define OPTION_VAL_10PX_VN NULL
#define OPTION_VAL_11PX_VN NULL
#define OPTION_VAL_12PX_VN NULL
#define OPTION_VAL_13PX_VN NULL
#define OPTION_VAL_14PX_VN NULL
#define OPTION_VAL_15PX_VN NULL
#define OPTION_VAL_16PX_VN NULL
#define OPTION_VAL_17PX_VN NULL
#define OPTION_VAL_18PX_VN NULL
#define OPTION_VAL_19PX_VN NULL
#define OPTION_VAL_20PX_VN NULL
#define BEETLE_OPT_IMAGE_OFFSET_LABEL_VN NULL
#define BEETLE_OPT_IMAGE_OFFSET_INFO_0_VN NULL
#define OPTION_VAL_12PX_O55_VN NULL
#define OPTION_VAL_11PX_O55_VN NULL
#define OPTION_VAL_10PX_O55_VN NULL
#define OPTION_VAL_9PX_O55_VN NULL
#define OPTION_VAL_8PX_O55_VN NULL
#define OPTION_VAL_7PX_O55_VN NULL
#define OPTION_VAL_6PX_O55_VN NULL
#define OPTION_VAL_5PX_O55_VN NULL
#define OPTION_VAL_4PX_O55_VN NULL
#define OPTION_VAL_3PX_O55_VN NULL
#define OPTION_VAL_2PX_O55_VN NULL
#define OPTION_VAL_1PX_O55_VN NULL
#define OPTION_VAL_DISABLED_O55_VN NULL
#define OPTION_VAL_1PX_O55_0_VN NULL
#define OPTION_VAL_2PX_O55_0_VN NULL
#define OPTION_VAL_3PX_O55_0_VN NULL
#define OPTION_VAL_4PX_O55_0_VN NULL
#define OPTION_VAL_5PX_O55_0_VN NULL
#define OPTION_VAL_6PX_O55_0_VN NULL
#define OPTION_VAL_7PX_O55_0_VN NULL
#define OPTION_VAL_8PX_O55_0_VN NULL
#define OPTION_VAL_9PX_O55_0_VN NULL
#define OPTION_VAL_10PX_O55_0_VN NULL
#define OPTION_VAL_11PX_O55_0_VN NULL
#define OPTION_VAL_12PX_O55_0_VN NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_VN NULL
#define BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_VN NULL
#define BEETLE_OPT_GPU_OVERCLOCK_LABEL_VN NULL
#define BEETLE_OPT_GPU_OVERCLOCK_INFO_0_VN NULL
#define OPTION_VAL_32X_VN NULL
#define BEETLE_OPT_ASPECT_RATIO_LABEL_VN NULL
#define BEETLE_OPT_ASPECT_RATIO_INFO_0_VN NULL
#define OPTION_VAL_CORRECTED_VN NULL
#define OPTION_VAL_UNCORRECTED_VN NULL
#define OPTION_VAL_4_3_VN NULL
#define OPTION_VAL_NTSC_VN NULL
#define BEETLE_OPT_INITIAL_SCANLINE_LABEL_VN NULL
#define BEETLE_OPT_INITIAL_SCANLINE_INFO_0_VN NULL
#define BEETLE_OPT_LAST_SCANLINE_LABEL_VN NULL
#define BEETLE_OPT_LAST_SCANLINE_INFO_0_VN NULL
#define OPTION_VAL_239_VN NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_VN NULL
#define BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_VN NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_VN NULL
#define BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_VN NULL
#define OPTION_VAL_287_VN NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_LABEL_VN NULL
#define BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_VN NULL
#define OPTION_VAL_SYNC_VN NULL
#define OPTION_VAL_ASYNC_VN NULL
#define OPTION_VAL_PRECACHE_VN NULL
#define BEETLE_OPT_CD_FASTLOAD_LABEL_VN NULL
#define BEETLE_OPT_CD_FASTLOAD_INFO_0_VN NULL
#define OPTION_VAL_2X_NATIVE_VN NULL
#define OPTION_VAL_6X_VN NULL
#define OPTION_VAL_10X_VN NULL
#define OPTION_VAL_12X_VN NULL
#define OPTION_VAL_14X_VN NULL

struct retro_core_option_v2_category option_cats_vn[] = {
   {
      "video",
      CATEGORY_VIDEO_LABEL_VN,
      CATEGORY_VIDEO_INFO_0_VN
   },
   {
      "osd",
      CATEGORY_OSD_LABEL_VN,
      CATEGORY_OSD_INFO_0_VN
   },
   {
      "input",
      CATEGORY_INPUT_LABEL_VN,
      CATEGORY_INPUT_INFO_0_VN
   },
   {
      "memcards",
      CATEGORY_MEMCARDS_LABEL_VN,
      CATEGORY_MEMCARDS_INFO_0_VN
   },
   {
      "pgxp",
      CATEGORY_PGXP_LABEL_VN,
      CATEGORY_PGXP_INFO_0_VN
   },
   {
      "hacks",
      CATEGORY_HACKS_LABEL_VN,
      CATEGORY_HACKS_INFO_0_VN
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_vn[] = {
   {
      BEETLE_OPT(internal_resolution),
      BEETLE_OPT_INTERNAL_RESOLUTION_LABEL_VN,
      NULL,
      BEETLE_OPT_INTERNAL_RESOLUTION_INFO_0_VN,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_VN },
         { "2x",         OPTION_VAL_2X_VN },
         { "4x",         OPTION_VAL_4X_VN },
         { "8x",         OPTION_VAL_8X_VN },
         { "16x",        OPTION_VAL_16X_VN },
         { NULL, NULL },
      },
      "1x(native)"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(depth),
      BEETLE_OPT_DEPTH_LABEL_VN,
      NULL,
      BEETLE_OPT_DEPTH_INFO_0_VN,
      NULL,
      "video",
      {
         { "16bpp(native)", OPTION_VAL_16BPP_NATIVE_VN },
         { "32bpp",         OPTION_VAL_32BPP_VN },
         { NULL, NULL },
      },
      "16bpp(native)"
   },
   // Sort of, it's more like 15-bit high color and 24-bit true color for visible output. The alpha channel is used for mask bit. Vulkan renderer uses ABGR1555_555 for 31 bits internal? FMVs are always 24-bit on all renderers like original hardware (BGR888, no alpha)
#endif
   {
      BEETLE_OPT(dither_mode),
      BEETLE_OPT_DITHER_MODE_LABEL_VN,
      NULL,
      BEETLE_OPT_DITHER_MODE_INFO_0_VN,
      NULL,
      "video",
      {
         { "1x(native)",          OPTION_VAL_1X_NATIVE_VN },
         { "internal resolution", OPTION_VAL_INTERNAL_RESOLUTION_VN },
         { "disabled",            NULL },
         { NULL, NULL },
      },
      "1x(native)"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(scaled_uv_offset),
      BEETLE_OPT_SCALED_UV_OFFSET_LABEL_VN,
      NULL,
      BEETLE_OPT_SCALED_UV_OFFSET_INFO_0_VN,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(filter),
      BEETLE_OPT_FILTER_LABEL_VN,
      NULL,
      BEETLE_OPT_FILTER_INFO_0_VN,
      NULL,
      "video",
      {
         { "nearest",  OPTION_VAL_NEAREST_VN },
         { "SABR",     OPTION_VAL_SABR_VN },
         { "xBR",      OPTION_VAL_XBR_VN },
         { "bilinear", OPTION_VAL_BILINEAR_VN },
         { "3-point",  OPTION_VAL_3_POINT_VN },
         { "JINC2",    OPTION_VAL_JINC2_VN },
         { NULL, NULL },
      },
      "nearest"
   },
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(filter_exclude_sprite),
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_LABEL_VN,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_SPRITE_INFO_0_VN,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_VN },
         { "all", OPTION_VAL_ALL_VN },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(filter_exclude_2d_polygon),
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_LABEL_VN,
      NULL,
      BEETLE_OPT_FILTER_EXCLUDE_2D_POLYGON_INFO_0_VN,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "opaque", OPTION_VAL_OPAQUE_VN },
         { "all", OPTION_VAL_ALL_VN },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#endif
#ifdef HAVE_VULKAN
   {
      BEETLE_OPT(adaptive_smoothing),
      BEETLE_OPT_ADAPTIVE_SMOOTHING_LABEL_VN,
      NULL,
      BEETLE_OPT_ADAPTIVE_SMOOTHING_INFO_0_VN,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(super_sampling),
      BEETLE_OPT_SUPER_SAMPLING_LABEL_VN,
      NULL,
      BEETLE_OPT_SUPER_SAMPLING_INFO_0_VN,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(msaa),
      BEETLE_OPT_MSAA_LABEL_VN,
      NULL,
      BEETLE_OPT_MSAA_INFO_0_VN,
      NULL,
      "video",
      {
         { "1x",  OPTION_VAL_1X_VN },
         { "2x",  OPTION_VAL_2X_VN },
         { "4x",  OPTION_VAL_4X_VN },
         { "8x",  OPTION_VAL_8X_VN },
         { "16x", OPTION_VAL_16X_VN },
         { NULL, NULL },
      },
      "1x"
   },
   {
      BEETLE_OPT(mdec_yuv),
      BEETLE_OPT_MDEC_YUV_LABEL_VN,
      NULL,
      BEETLE_OPT_MDEC_YUV_INFO_0_VN,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(track_textures),
      BEETLE_OPT_TRACK_TEXTURES_LABEL_VN,
      NULL,
      BEETLE_OPT_TRACK_TEXTURES_INFO_0_VN,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#ifdef TEXTURE_DUMPING_ENABLED
   {
      BEETLE_OPT(dump_textures),
      BEETLE_OPT_DUMP_TEXTURES_LABEL_VN,
      NULL,
      BEETLE_OPT_DUMP_TEXTURES_INFO_0_VN,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(replace_textures),
      BEETLE_OPT_REPLACE_TEXTURES_LABEL_VN,
      NULL,
      BEETLE_OPT_REPLACE_TEXTURES_INFO_0_VN,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
   {
      BEETLE_OPT(wireframe),
      BEETLE_OPT_WIREFRAME_LABEL_VN,
      NULL,
      BEETLE_OPT_WIREFRAME_INFO_0_VN,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(frame_duping),
      BEETLE_OPT_FRAME_DUPING_LABEL_VN,
      NULL,
      BEETLE_OPT_FRAME_DUPING_INFO_0_VN,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(display_internal_fps),
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_LABEL_VN,
      NULL,
      BEETLE_OPT_DISPLAY_INTERNAL_FPS_INFO_0_VN,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(display_vram),
      BEETLE_OPT_DISPLAY_VRAM_LABEL_VN,
      NULL,
      BEETLE_OPT_DISPLAY_VRAM_INFO_0_VN,
      NULL,
      "osd",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(analog_calibration),
      BEETLE_OPT_ANALOG_CALIBRATION_LABEL_VN,
      NULL,
      BEETLE_OPT_ANALOG_CALIBRATION_INFO_0_VN,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(analog_toggle),
      BEETLE_OPT_ANALOG_TOGGLE_LABEL_VN,
      NULL,
      BEETLE_OPT_ANALOG_TOGGLE_INFO_0_VN,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port1),
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_LABEL_VN,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT1_INFO_0_VN,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(enable_multitap_port2),
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_LABEL_VN,
      NULL,
      BEETLE_OPT_ENABLE_MULTITAP_PORT2_INFO_0_VN,
      NULL,
      "input",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(gun_input_mode),
      BEETLE_OPT_GUN_INPUT_MODE_LABEL_VN,
      NULL,
      BEETLE_OPT_GUN_INPUT_MODE_INFO_0_VN,
      NULL,
      "input",
      {
         { "lightgun",    OPTION_VAL_LIGHTGUN_VN },
         { "touchscreen", OPTION_VAL_TOUCHSCREEN_VN },
         { NULL, NULL },
      },
      "lightgun"
   },
   // Shouldn't the gun_input_mode just be Mouse vs. Touchscreen?
   {
      BEETLE_OPT(gun_cursor),
      BEETLE_OPT_GUN_CURSOR_LABEL_VN,
      NULL,
      BEETLE_OPT_GUN_CURSOR_INFO_0_VN,
      NULL,
      "input",
      {
         { "cross", OPTION_VAL_CROSS_VN },
         { "dot",   OPTION_VAL_DOT_VN },
         { "off",   OPTION_VAL_OFF_VN },
         { NULL, NULL },
      },
      "cross"
   },
   {
      BEETLE_OPT(crosshair_color_p1),
      BEETLE_OPT_CROSSHAIR_COLOR_P1_LABEL_VN,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P1_INFO_0_VN,
      NULL,
      "input",
      {
         { "red", OPTION_VAL_RED_VN },
         { "blue", OPTION_VAL_BLUE_VN },
         { "green", OPTION_VAL_GREEN_VN },
         { "orange", OPTION_VAL_ORANGE_VN },
         { "yellow", OPTION_VAL_YELLOW_VN },
         { "cyan", OPTION_VAL_CYAN_VN },
         { "pink", OPTION_VAL_PINK_VN },
         { "purple", OPTION_VAL_PURPLE_VN },
         { "black", OPTION_VAL_BLACK_VN },
         { "white", OPTION_VAL_WHITE_VN },
         { NULL, NULL },
      },
      "red"
   },
   {
      BEETLE_OPT(crosshair_color_p2),
      BEETLE_OPT_CROSSHAIR_COLOR_P2_LABEL_VN,
      NULL,
      BEETLE_OPT_CROSSHAIR_COLOR_P2_INFO_0_VN,
      NULL,
      "input",
      {
         { "blue", OPTION_VAL_BLUE_VN },
         { "red", OPTION_VAL_RED_VN },
         { "green", OPTION_VAL_GREEN_VN },
         { "orange", OPTION_VAL_ORANGE_VN },
         { "yellow", OPTION_VAL_YELLOW_VN },
         { "cyan", OPTION_VAL_CYAN_VN },
         { "pink", OPTION_VAL_PINK_VN },
         { "purple", OPTION_VAL_PURPLE_VN },
         { "black", OPTION_VAL_BLACK_VN },
         { "white", OPTION_VAL_WHITE_VN },
         { NULL, NULL },
      },
      "blue"
   },
   {
      BEETLE_OPT(mouse_sensitivity),
      BEETLE_OPT_MOUSE_SENSITIVITY_LABEL_VN,
      NULL,
      BEETLE_OPT_MOUSE_SENSITIVITY_INFO_0_VN,
      NULL,
      "input",
      {
         { "5%",   OPTION_VAL_5_VN },
         { "10%",  OPTION_VAL_10_VN },
         { "15%",  OPTION_VAL_15_VN },
         { "20%",  OPTION_VAL_20_VN },
         { "25%",  OPTION_VAL_25_VN },
         { "30%",  OPTION_VAL_30_VN },
         { "35%",  OPTION_VAL_35_VN },
         { "40%",  OPTION_VAL_40_VN },
         { "45%",  OPTION_VAL_45_VN },
         { "50%",  OPTION_VAL_50_VN },
         { "55%",  OPTION_VAL_55_VN },
         { "60%",  OPTION_VAL_60_VN },
         { "65%",  OPTION_VAL_65_VN },
         { "70%",  OPTION_VAL_70_VN },
         { "75%",  OPTION_VAL_75_VN },
         { "80%",  OPTION_VAL_80_VN },
         { "85%",  OPTION_VAL_85_VN },
         { "90%",  OPTION_VAL_90_VN },
         { "95%",  OPTION_VAL_95_VN },
         { "100%", OPTION_VAL_100_VN },
         { "105%", OPTION_VAL_105_VN },
         { "110%", OPTION_VAL_110_VN },
         { "115%", OPTION_VAL_115_VN },
         { "120%", OPTION_VAL_120_VN },
         { "125%", OPTION_VAL_125_VN },
         { "130%", OPTION_VAL_130_VN },
         { "135%", OPTION_VAL_135_VN },
         { "140%", OPTION_VAL_140_VN },
         { "145%", OPTION_VAL_145_VN },
         { "150%", OPTION_VAL_150_VN },
         { "155%", OPTION_VAL_155_VN },
         { "160%", OPTION_VAL_160_VN },
         { "165%", OPTION_VAL_165_VN },
         { "170%", OPTION_VAL_170_VN },
         { "175%", OPTION_VAL_175_VN },
         { "180%", OPTION_VAL_180_VN },
         { "185%", OPTION_VAL_185_VN },
         { "190%", OPTION_VAL_190_VN },
         { "195%", OPTION_VAL_195_VN },
         { "200%", OPTION_VAL_200_VN },
         { NULL, NULL },
      },
      "100%"
   },
   {
      BEETLE_OPT(negcon_response),
      BEETLE_OPT_NEGCON_RESPONSE_LABEL_VN,
      NULL,
      BEETLE_OPT_NEGCON_RESPONSE_INFO_0_VN,
      NULL,
      "input",
      {
         { "linear",    OPTION_VAL_LINEAR_VN },
         { "quadratic", OPTION_VAL_QUADRATIC_VN },
         { "cubic",     OPTION_VAL_CUBIC_VN },
         { NULL, NULL },
      },
      "linear"
   },
   {
      BEETLE_OPT(negcon_deadzone),
      BEETLE_OPT_NEGCON_DEADZONE_LABEL_VN,
      NULL,
      BEETLE_OPT_NEGCON_DEADZONE_INFO_0_VN,
      NULL,
      "input",
      {
         { "0%",  OPTION_VAL_0_VN },
         { "5%",  OPTION_VAL_5_VN },
         { "10%", OPTION_VAL_10_VN },
         { "15%", OPTION_VAL_15_VN },
         { "20%", OPTION_VAL_20_VN },
         { "25%", OPTION_VAL_25_VN },
         { "30%", OPTION_VAL_30_VN },
         { NULL, NULL },
      },
      "0%"
   },
   {
      BEETLE_OPT(use_mednafen_memcard0_method),
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_LABEL_VN,
      NULL,
      BEETLE_OPT_USE_MEDNAFEN_MEMCARD0_METHOD_INFO_0_VN,
      NULL,
      "memcards",
      {
         { "libretro", OPTION_VAL_LIBRETRO_VN },
         { "mednafen", OPTION_VAL_MEDNAFEN_VN },
         { NULL, NULL },
      },
      "libretro"
   },
   {
      BEETLE_OPT(enable_memcard1),
      BEETLE_OPT_ENABLE_MEMCARD1_LABEL_VN,
      NULL,
      BEETLE_OPT_ENABLE_MEMCARD1_INFO_0_VN,
      NULL,
      "memcards",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      BEETLE_OPT(shared_memory_cards),
      BEETLE_OPT_SHARED_MEMORY_CARDS_LABEL_VN,
      NULL,
      BEETLE_OPT_SHARED_MEMORY_CARDS_INFO_0_VN,
      NULL,
      "memcards",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(memcard_left_index),
      BEETLE_OPT_MEMCARD_LEFT_INDEX_LABEL_VN,
      NULL,
      BEETLE_OPT_MEMCARD_LEFT_INDEX_INFO_0_VN,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(memcard_right_index),
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_LABEL_VN,
      NULL,
      BEETLE_OPT_MEMCARD_RIGHT_INDEX_INFO_0_VN,
      NULL,
      "memcards",
      {
         { "0",  NULL },
         { "1",  OPTION_VAL_1_VN },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { NULL, NULL },
      },
      "1"
   },
   {
      BEETLE_OPT(pgxp_mode),
      BEETLE_OPT_PGXP_MODE_LABEL_VN,
      NULL,
      BEETLE_OPT_PGXP_MODE_INFO_0_VN,
      NULL,
      "pgxp",
      {
         { "disabled",     NULL },
         { "memory only",  OPTION_VAL_MEMORY_ONLY_VN },
         { "memory + CPU", OPTION_VAL_MEMORY_CPU_VN },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_2d_tol),
      BEETLE_OPT_PGXP_2D_TOL_LABEL_VN,
      NULL,
      BEETLE_OPT_PGXP_2D_TOL_INFO_0_VN,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "0px", OPTION_VAL_0PX_VN },
         { "1px", OPTION_VAL_1PX_VN },
         { "2px", OPTION_VAL_2PX_VN },
         { "3px", OPTION_VAL_3PX_VN },
         { "4px", OPTION_VAL_4PX_VN },
         { "5px", OPTION_VAL_5PX_VN },
         { "6px", OPTION_VAL_6PX_VN },
         { "7px", OPTION_VAL_7PX_VN },
         { "8px", OPTION_VAL_8PX_VN },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_nclip),
      BEETLE_OPT_PGXP_NCLIP_LABEL_VN,
      NULL,
      BEETLE_OPT_PGXP_NCLIP_INFO_0_VN,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(pgxp_vertex),
      BEETLE_OPT_PGXP_VERTEX_LABEL_VN,
      NULL,
      BEETLE_OPT_PGXP_VERTEX_INFO_0_VN,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(pgxp_texture),
      BEETLE_OPT_PGXP_TEXTURE_LABEL_VN,
      NULL,
      BEETLE_OPT_PGXP_TEXTURE_INFO_0_VN,
      NULL,
      "pgxp",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
#endif
   {
      BEETLE_OPT(line_render),
      BEETLE_OPT_LINE_RENDER_LABEL_VN,
      NULL,
      BEETLE_OPT_LINE_RENDER_INFO_0_VN,
      NULL,
      "hacks",
      {
         { "default",    OPTION_VAL_DEFAULT_VN },
         { "aggressive", OPTION_VAL_AGGRESSIVE_VN },
         { "disabled",   NULL },
         { NULL, NULL },
      },
      "default"
   },
   {
      BEETLE_OPT(widescreen_hack),
      BEETLE_OPT_WIDESCREEN_HACK_LABEL_VN,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_INFO_0_VN,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(widescreen_hack_aspect_ratio),
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_LABEL_VN,
      NULL,
      BEETLE_OPT_WIDESCREEN_HACK_ASPECT_RATIO_INFO_0_VN,
      NULL,
      "hacks",
      {
         { "16:9",  OPTION_VAL_16_9_VN },
         { "16:10", OPTION_VAL_16_10_VN },
         { "18:9",  OPTION_VAL_18_9_VN },
         { "19:9",  OPTION_VAL_19_9_VN },
         { "20:9",  OPTION_VAL_20_9_VN },
         { "21:9",  OPTION_VAL_21_9_VN }, // 64:27
         { "32:9",  OPTION_VAL_32_9_VN },
         { NULL,    NULL },
      },
      "16:9"
   },
   {
      BEETLE_OPT(cpu_freq_scale),
      BEETLE_OPT_CPU_FREQ_SCALE_LABEL_VN,
      NULL,
      BEETLE_OPT_CPU_FREQ_SCALE_INFO_0_VN,
      NULL,
      "hacks",
      {
         { "50%",           OPTION_VAL_50_VN },
         { "60%",           OPTION_VAL_60_VN },
         { "70%",           OPTION_VAL_70_VN },
         { "80%",           OPTION_VAL_80_VN },
         { "90%",           OPTION_VAL_90_VN },
         { "100%(native)", OPTION_VAL_100_NATIVE_VN },
         { "110%",          OPTION_VAL_110_VN },
         { "120%",          OPTION_VAL_120_VN },
         { "130%",          OPTION_VAL_130_VN },
         { "140%",          OPTION_VAL_140_VN },
         { "150%",          OPTION_VAL_150_VN },
         { "160%",          OPTION_VAL_160_VN },
         { "170%",          OPTION_VAL_170_VN },
         { "180%",          OPTION_VAL_180_VN },
         { "190%",          OPTION_VAL_190_VN },
         { "200%",          OPTION_VAL_200_VN },
         { "210%",          OPTION_VAL_210_VN },
         { "220%",          OPTION_VAL_220_VN },
         { "230%",          OPTION_VAL_230_VN },
         { "240%",          OPTION_VAL_240_VN },
         { "250%",          OPTION_VAL_250_VN },
         { "260%",          OPTION_VAL_260_VN },
         { "270%",          OPTION_VAL_270_VN },
         { "280%",          OPTION_VAL_280_VN },
         { "290%",          OPTION_VAL_290_VN },
         { "300%",          OPTION_VAL_300_VN },
         { "310%",          OPTION_VAL_310_VN },
         { "320%",          OPTION_VAL_320_VN },
         { "330%",          OPTION_VAL_330_VN },
         { "340%",          OPTION_VAL_340_VN },
         { "350%",          OPTION_VAL_350_VN },
         { "360%",          OPTION_VAL_360_VN },
         { "370%",          OPTION_VAL_370_VN },
         { "380%",          OPTION_VAL_380_VN },
         { "390%",          OPTION_VAL_390_VN },
         { "400%",          OPTION_VAL_400_VN },
         { "410%",          OPTION_VAL_410_VN },
         { "420%",          OPTION_VAL_420_VN },
         { "430%",          OPTION_VAL_430_VN },
         { "440%",          OPTION_VAL_440_VN },
         { "450%",          OPTION_VAL_450_VN },
         { "460%",          OPTION_VAL_460_VN },
         { "470%",          OPTION_VAL_470_VN },
         { "480%",          OPTION_VAL_480_VN },
         { "490%",          OPTION_VAL_490_VN },
         { "500%",          OPTION_VAL_500_VN },
         { "510%",          OPTION_VAL_510_VN },
         { "520%",          OPTION_VAL_520_VN },
         { "530%",          OPTION_VAL_530_VN },
         { "540%",          OPTION_VAL_540_VN },
         { "550%",          OPTION_VAL_550_VN },
         { "560%",          OPTION_VAL_560_VN },
         { "570%",          OPTION_VAL_570_VN },
         { "580%",          OPTION_VAL_580_VN },
         { "590%",          OPTION_VAL_590_VN },
         { "600%",          OPTION_VAL_600_VN },
         { "610%",          OPTION_VAL_610_VN },
         { "620%",          OPTION_VAL_620_VN },
         { "630%",          OPTION_VAL_630_VN },
         { "640%",          OPTION_VAL_640_VN },
         { "650%",          OPTION_VAL_650_VN },
         { "660%",          OPTION_VAL_660_VN },
         { "670%",          OPTION_VAL_670_VN },
         { "680%",          OPTION_VAL_680_VN },
         { "690%",          OPTION_VAL_690_VN },
         { "700%",          OPTION_VAL_700_VN },
         { "710%",          OPTION_VAL_710_VN },
         { "720%",          OPTION_VAL_720_VN },
         { "730%",          OPTION_VAL_730_VN },
         { "740%",          OPTION_VAL_740_VN },
         { "750%",          OPTION_VAL_750_VN },
         { NULL, NULL },
      },
      "100%(native)"
   },
   {
      BEETLE_OPT(gte_overclock),
      BEETLE_OPT_GTE_OVERCLOCK_LABEL_VN,
      NULL,
      BEETLE_OPT_GTE_OVERCLOCK_INFO_0_VN,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(skip_bios),
      BEETLE_OPT_SKIP_BIOS_LABEL_VN,
      NULL,
      BEETLE_OPT_SKIP_BIOS_INFO_0_VN,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(override_bios),
      BEETLE_OPT_OVERRIDE_BIOS_LABEL_VN,
      NULL,
      BEETLE_OPT_OVERRIDE_BIOS_INFO_0_VN,
      NULL,
      "hacks",
      {
         { "disabled", NULL },
         { "psxonpsp",  OPTION_VAL_PSXONPSP_VN },
         { "ps1_rom",  OPTION_VAL_PS1_ROM_VN },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(renderer),
      BEETLE_OPT_RENDERER_LABEL_VN,
      NULL,
      BEETLE_OPT_RENDERER_INFO_0_VN,
      NULL,
      NULL,
      {
         { "hardware",    OPTION_VAL_HARDWARE_VN },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES)
         { "hardware_gl", OPTION_VAL_HARDWARE_GL_VN },
#endif
#if defined(HAVE_VULKAN)
         { "hardware_vk", OPTION_VAL_HARDWARE_VK_VN },
#endif
         { "software",    OPTION_VAL_SOFTWARE_VN },
         { NULL, NULL },
      },
      "hardware"
   },
   {
      BEETLE_OPT(renderer_software_fb),
      BEETLE_OPT_RENDERER_SOFTWARE_FB_LABEL_VN,
      NULL,
      BEETLE_OPT_RENDERER_SOFTWARE_FB_INFO_0_VN,
      NULL,
      "video",
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
#endif
#if defined(HAVE_LIGHTREC)
   {
      BEETLE_OPT(cpu_dynarec),
      BEETLE_OPT_CPU_DYNAREC_LABEL_VN,
      NULL,
      BEETLE_OPT_CPU_DYNAREC_INFO_0_VN,
      NULL,
      NULL,
      {
         { "disabled", OPTION_VAL_DISABLED_VN },
         { "execute",  OPTION_VAL_EXECUTE_VN },
         { "execute_one",  OPTION_VAL_EXECUTE_ONE_VN },
         { "run_interpreter", OPTION_VAL_RUN_INTERPRETER_VN },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(dynarec_invalidate),
      BEETLE_OPT_DYNAREC_INVALIDATE_LABEL_VN,
      NULL,
      BEETLE_OPT_DYNAREC_INVALIDATE_INFO_0_VN,
      NULL,
      NULL,
      {
         { "full", OPTION_VAL_FULL_VN },
         { "dma",  OPTION_VAL_DMA_VN },
         { NULL, NULL },
      },
      "full"
   },
   {
      BEETLE_OPT(dynarec_eventcycles),
      BEETLE_OPT_DYNAREC_EVENTCYCLES_LABEL_VN,
      NULL,
      BEETLE_OPT_DYNAREC_EVENTCYCLES_INFO_0_VN,
      NULL,
      NULL,
      {
         { "128",  NULL },
         { "256",  NULL },
         { "384",  NULL },
         { "512",  NULL },
         { "640",  NULL },
         { "768",  NULL },
         { "896",  NULL },
         { "1024",  NULL },
         { NULL, NULL },
      },
      "128"
   },
#endif
   {
      BEETLE_OPT(core_timing_fps),
      BEETLE_OPT_CORE_TIMING_FPS_LABEL_VN,
      NULL,
      BEETLE_OPT_CORE_TIMING_FPS_INFO_0_VN,
      NULL,
      NULL,
      {
         { "force_progressive", OPTION_VAL_FORCE_PROGRESSIVE_VN },
         { "force_interlaced",  OPTION_VAL_FORCE_INTERLACED_VN },
         { "auto_toggle", OPTION_VAL_AUTO_TOGGLE_VN },
      },
      "force_progressive"
   },
   {
      BEETLE_OPT(pal_video_timing_override),
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_LABEL_VN,
      NULL,
      BEETLE_OPT_PAL_VIDEO_TIMING_OVERRIDE_INFO_0_VN,
      NULL,
      "video",
      {
         { "disabled", NULL },
         { "enabled",  NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(crop_overscan),
      BEETLE_OPT_CROP_OVERSCAN_LABEL_VN,
      NULL,
      BEETLE_OPT_CROP_OVERSCAN_INFO_0_VN,
      NULL,
      "video",
      {
         { "disabled",  OPTION_VAL_DISABLED_O53_VN },
         { "static",  OPTION_VAL_STATIC_VN },
         { "smart", OPTION_VAL_SMART_VN },
         { NULL, NULL },
      },
      "smart"
   },
   {
      BEETLE_OPT(image_crop),
      BEETLE_OPT_IMAGE_CROP_LABEL_VN,
      NULL,
      BEETLE_OPT_IMAGE_CROP_INFO_0_VN,
      NULL,
      "video",
      {
         { "disabled", "0" },
         { "1px",      OPTION_VAL_1PX_VN },
         { "2px",      OPTION_VAL_2PX_VN },
         { "3px",      OPTION_VAL_3PX_VN },
         { "4px",      OPTION_VAL_4PX_VN },
         { "5px",      OPTION_VAL_5PX_VN },
         { "6px",      OPTION_VAL_6PX_VN },
         { "7px",      OPTION_VAL_7PX_VN },
         { "8px",      OPTION_VAL_8PX_VN },
         { "9px",      OPTION_VAL_9PX_VN },
         { "10px",     OPTION_VAL_10PX_VN },
         { "11px",     OPTION_VAL_11PX_VN },
         { "12px",     OPTION_VAL_12PX_VN },
         { "13px",     OPTION_VAL_13PX_VN },
         { "14px",     OPTION_VAL_14PX_VN },
         { "15px",     OPTION_VAL_15PX_VN },
         { "16px",     OPTION_VAL_16PX_VN },
         { "17px",     OPTION_VAL_17PX_VN },
         { "18px",     OPTION_VAL_18PX_VN },
         { "19px",     OPTION_VAL_19PX_VN },
         { "20px",     OPTION_VAL_20PX_VN },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      BEETLE_OPT(image_offset),
      BEETLE_OPT_IMAGE_OFFSET_LABEL_VN,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_INFO_0_VN,
      NULL,
      "video",
      {
         { "-12px",    OPTION_VAL_12PX_O55_VN },
         { "-11px",    OPTION_VAL_11PX_O55_VN },
         { "-10px",    OPTION_VAL_10PX_O55_VN },
         { "-9px",     OPTION_VAL_9PX_O55_VN },
         { "-8px",     OPTION_VAL_8PX_O55_VN },
         { "-7px",     OPTION_VAL_7PX_O55_VN },
         { "-6px",     OPTION_VAL_6PX_O55_VN },
         { "-5px",     OPTION_VAL_5PX_O55_VN },
         { "-4px",     OPTION_VAL_4PX_O55_VN },
         { "-3px",     OPTION_VAL_3PX_O55_VN },
         { "-2px",     OPTION_VAL_2PX_O55_VN },
         { "-1px",     OPTION_VAL_1PX_O55_VN },
         { "disabled", OPTION_VAL_DISABLED_O55_VN },
         { "+1px",     OPTION_VAL_1PX_O55_0_VN },
         { "+2px",     OPTION_VAL_2PX_O55_0_VN },
         { "+3px",     OPTION_VAL_3PX_O55_0_VN },
         { "+4px",     OPTION_VAL_4PX_O55_0_VN },
         { "+5px",     OPTION_VAL_5PX_O55_0_VN },
         { "+6px",     OPTION_VAL_6PX_O55_0_VN },
         { "+7px",     OPTION_VAL_7PX_O55_0_VN },
         { "+8px",     OPTION_VAL_8PX_O55_0_VN },
         { "+9px",     OPTION_VAL_9PX_O55_0_VN },
         { "+10px",    OPTION_VAL_10PX_O55_0_VN },
         { "+11px",    OPTION_VAL_11PX_O55_0_VN },
         { "+12px",    OPTION_VAL_12PX_O55_0_VN },
         { NULL, NULL },
      },
      "disabled"
   },
#if defined(HAVE_OPENGL) || defined(HAVE_OPENGLES) || defined(HAVE_VULKAN)
   {
      BEETLE_OPT(image_offset_cycles),
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_LABEL_VN,
      NULL,
      BEETLE_OPT_IMAGE_OFFSET_CYCLES_INFO_0_VN,
      NULL,
      "video",
      {
         { "-40",      NULL },
         { "-39",      NULL },
         { "-38",      NULL },
         { "-37",      NULL },
         { "-36",      NULL },
         { "-35",      NULL },
         { "-34",      NULL },
         { "-33",      NULL },
         { "-32",      NULL },
         { "-31",      NULL },
         { "-30",      NULL },
         { "-29",      NULL },
         { "-28",      NULL },
         { "-27",      NULL },
         { "-26",      NULL },
         { "-25",      NULL },
         { "-24",      NULL },
         { "-23",      NULL },
         { "-22",      NULL },
         { "-21",      NULL },
         { "-20",      NULL },
         { "-19",      NULL },
         { "-18",      NULL },
         { "-17",      NULL },
         { "-16",      NULL },
         { "-15",      NULL },
         { "-14",      NULL },
         { "-13",      NULL },
         { "-12",      NULL },
         { "-11",      NULL },
         { "-10",      NULL },
         { "-9",       NULL },
         { "-8",       NULL },
         { "-7",       NULL },
         { "-6",       NULL },
         { "-5",       NULL },
         { "-4",       NULL },
         { "-3",       NULL },
         { "-2",       NULL },
         { "-1",       NULL },
         { "0",        OPTION_VAL_DISABLED_O55_VN },
         { "+1",       NULL },
         { "+2",       NULL },
         { "+3",       NULL },
         { "+4",       NULL },
         { "+5",       NULL },
         { "+6",       NULL },
         { "+7",       NULL },
         { "+8",       NULL },
         { "+9",       NULL },
         { "+10",      NULL },
         { "+11",      NULL },
         { "+12",      NULL },
         { "+13",      NULL },
         { "+14",      NULL },
         { "+15",      NULL },
         { "+16",      NULL },
         { "+17",      NULL },
         { "+18",      NULL },
         { "+19",      NULL },
         { "+20",      NULL },
         { "+21",      NULL },
         { "+22",      NULL },
         { "+23",      NULL },
         { "+24",      NULL },
         { "+25",      NULL },
         { "+26",      NULL },
         { "+27",      NULL },
         { "+28",      NULL },
         { "+29",      NULL },
         { "+30",      NULL },
         { "+31",      NULL },
         { "+32",      NULL },
         { "+33",      NULL },
         { "+34",      NULL },
         { "+35",      NULL },
         { "+36",      NULL },
         { "+37",      NULL },
         { "+38",      NULL },
         { "+39",      NULL },
         { "+40",      NULL },
         { NULL, NULL},
      },
      "0"
   },
#endif
   {
      BEETLE_OPT(gpu_overclock),
      BEETLE_OPT_GPU_OVERCLOCK_LABEL_VN,
      NULL,
      BEETLE_OPT_GPU_OVERCLOCK_INFO_0_VN,
      NULL,
      "video",
      {
         { "1x(native)", OPTION_VAL_1X_NATIVE_VN },
         { "2x",         OPTION_VAL_2X_VN },
         { "4x",         OPTION_VAL_4X_VN },
         { "8x",         OPTION_VAL_8X_VN },
         { "16x",        OPTION_VAL_16X_VN },
         { "32x",        OPTION_VAL_32X_VN },
         { NULL, NULL },
      },
      "1x(native)"
   },
   {
      BEETLE_OPT(aspect_ratio),
      BEETLE_OPT_ASPECT_RATIO_LABEL_VN,
      NULL,
      BEETLE_OPT_ASPECT_RATIO_INFO_0_VN,
      NULL,
      "video",
      {
         { "corrected", OPTION_VAL_CORRECTED_VN },
         { "uncorrected", OPTION_VAL_UNCORRECTED_VN },
         { "4:3",  OPTION_VAL_4_3_VN },
         { "ntsc", OPTION_VAL_NTSC_VN },
      },
      "corrected"
   },
   {
      BEETLE_OPT(initial_scanline),
      BEETLE_OPT_INITIAL_SCANLINE_LABEL_VN,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_INFO_0_VN,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline),
      BEETLE_OPT_LAST_SCANLINE_LABEL_VN,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_INFO_0_VN,
      NULL,
      "video",
      {
         { "210", NULL },
         { "211", NULL },
         { "212", NULL },
         { "213", NULL },
         { "214", NULL },
         { "215", NULL },
         { "216", NULL },
         { "217", NULL },
         { "218", NULL },
         { "219", NULL },
         { "220", NULL },
         { "221", NULL },
         { "222", NULL },
         { "223", NULL },
         { "224", NULL },
         { "225", NULL },
         { "226", NULL },
         { "227", NULL },
         { "228", NULL },
         { "229", NULL },
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", OPTION_VAL_239_VN },
         { NULL, NULL },
      },
      "239"
   },
   {
      BEETLE_OPT(initial_scanline_pal),
      BEETLE_OPT_INITIAL_SCANLINE_PAL_LABEL_VN,
      NULL,
      BEETLE_OPT_INITIAL_SCANLINE_PAL_INFO_0_VN,
      NULL,
      "video",
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { "11", NULL },
         { "12", NULL },
         { "13", NULL },
         { "14", NULL },
         { "15", NULL },
         { "16", NULL },
         { "17", NULL },
         { "18", NULL },
         { "19", NULL },
         { "20", NULL },
         { "21", NULL },
         { "22", NULL },
         { "23", NULL },
         { "24", NULL },
         { "25", NULL },
         { "26", NULL },
         { "27", NULL },
         { "28", NULL },
         { "29", NULL },
         { "30", NULL },
         { "31", NULL },
         { "32", NULL },
         { "33", NULL },
         { "34", NULL },
         { "35", NULL },
         { "36", NULL },
         { "37", NULL },
         { "38", NULL },
         { "39", NULL },
         { "40", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      BEETLE_OPT(last_scanline_pal),
      BEETLE_OPT_LAST_SCANLINE_PAL_LABEL_VN,
      NULL,
      BEETLE_OPT_LAST_SCANLINE_PAL_INFO_0_VN,
      NULL,
      "video",
      {
         { "230", NULL },
         { "231", NULL },
         { "232", NULL },
         { "233", NULL },
         { "234", NULL },
         { "235", NULL },
         { "236", NULL },
         { "237", NULL },
         { "238", NULL },
         { "239", NULL },
         { "240", NULL },
         { "241", NULL },
         { "242", NULL },
         { "243", NULL },
         { "244", NULL },
         { "245", NULL },
         { "246", NULL },
         { "247", NULL },
         { "248", NULL },
         { "249", NULL },
         { "250", NULL },
         { "251", NULL },
         { "252", NULL },
         { "253", NULL },
         { "254", NULL },
         { "255", NULL },
         { "256", NULL },
         { "257", NULL },
         { "258", NULL },
         { "259", NULL },
         { "260", NULL },
         { "261", NULL },
         { "262", NULL },
         { "263", NULL },
         { "264", NULL },
         { "265", NULL },
         { "266", NULL },
         { "267", NULL },
         { "268", NULL },
         { "269", NULL },
         { "270", NULL },
         { "271", NULL },
         { "272", NULL },
         { "273", NULL },
         { "274", NULL },
         { "275", NULL },
         { "276", NULL },
         { "277", NULL },
         { "278", NULL },
         { "279", NULL },
         { "280", NULL },
         { "281", NULL },
         { "282", NULL },
         { "283", NULL },
         { "284", NULL },
         { "285", NULL },
         { "286", NULL },
         { "287", OPTION_VAL_287_VN },
         { NULL, NULL },
      },
      "287"
   },
#ifndef EMSCRIPTEN
   {
      BEETLE_OPT(cd_access_method),
      BEETLE_OPT_CD_ACCESS_METHOD_LABEL_VN,
      NULL,
      BEETLE_OPT_CD_ACCESS_METHOD_INFO_0_VN,
      NULL,
      NULL,
      {
         { "sync",     OPTION_VAL_SYNC_VN },
         { "async",    OPTION_VAL_ASYNC_VN },
         { "precache", OPTION_VAL_PRECACHE_VN },
         { NULL, NULL },
      },
      "sync"
   },
#endif
   {
      BEETLE_OPT(cd_fastload),
      BEETLE_OPT_CD_FASTLOAD_LABEL_VN,
      NULL,
      BEETLE_OPT_CD_FASTLOAD_INFO_0_VN,
      NULL,
      NULL,
      {
         { "2x(native)", OPTION_VAL_2X_NATIVE_VN },
         { "4x",          OPTION_VAL_4X_VN },
         { "6x",          OPTION_VAL_6X_VN },
         { "8x",          OPTION_VAL_8X_VN },
         { "10x",         OPTION_VAL_10X_VN },
         { "12x",         OPTION_VAL_12X_VN },
         { "14x",         OPTION_VAL_14X_VN },
         { NULL, NULL },
      },
      "2x(native)"
   },
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_vn = {
   option_cats_vn,
   option_defs_vn
};


#ifdef __cplusplus
}
#endif

#endif